﻿// Generated by Construct 2, the HTML5 game and app creator :: http://www.scirra.com
//////////////////////////////////////
// COCOONJS.JS                      //
//////////////////////////////////////

(function()
{
	// There should not be a CocoonJS object when this code is executed.
	// if (typeof window.CocoonJS !== 'undefined') throw("This is strange, a CocoonJS object already exists when trying to create it.");

    /**
    * The basic object for all the CocoonJS related specific APIs === extensions.
    * @namespace
    */
    CocoonJS = window.CocoonJS ? window.CocoonJS : {};

	CocoonJS.nativeExtensionObjectAvailable = typeof window.ext !== 'undefined';

	/**
	* This type represents a 2D size structure with horizontal and vertical values.
	* @namespace
	*/
	CocoonJS.Size = {
		/**
		* The horizontal size value.
		*/
		width : 0,

		/**
		* The vertical size value.
		*/
		height : 0
	};

	/**
	* This utility function allows to create an object oriented like hierarchy between two functions using their prototypes.
	* This function adds a "superclass" and a "__super" attributes to the subclass and it's functions to reference the super class.
	* @param {function} subc The subclass function.
	* @param {function} superc The superclass function.
	*/
	CocoonJS.extend = function(subc, superc) {
	    var subcp = subc.prototype;

	    // Class pattern.
	    var CocoonJSExtendHierarchyChainClass = function() {};
	    CocoonJSExtendHierarchyChainClass.prototype = superc.prototype;

	    subc.prototype = new CocoonJSExtendHierarchyChainClass();       // chain prototypes.
	    subc.superclass = superc.prototype;
	    subc.prototype.constructor = subc;

	    // Reset constructor. See Object Oriented Javascript for an in-depth explanation of this.
	    if (superc.prototype.constructor === Object.prototype.constructor) {
	        superc.prototype.constructor = superc;
	    }

	    // Check all the elements in the subclass prototype and add them to the chain object's prototype.
	    for (var method in subcp) {
	        if (subcp.hasOwnProperty(method)) {
	            subc.prototype[method] = subcp[method];

	            // // tenemos en super un metodo con igual nombre.
	            // if ( superc.prototype[method]) 
	            // {
	            //     subc.prototype[method]= (function(fn, fnsuper) 
	            //     {
	            //         return function() 
	            //         {
	            //             var prevMethod= this.__super;

	            //             this.__super= fnsuper;

	            //             var retValue= fn.apply(
	            //                     this,
	            //                     Array.prototype.slice.call(arguments) );

	            //             this.__super= prevMethod;

	            //             return retValue;
	            //         };
	            //     })(subc.prototype[method], superc.prototype[method]);
	            // }
	        }
	    }
	}

	/**
	* IMPORTANT: This function should only be used by Ludei.
	* This function allows a call to the native extension object function reusing the same arguments object.
	* Why is interesting to use this function instead of calling the native object's function directly?
	* As the CocoonJS object functions expicitly receive parameters, if they are not present and the native call is direcly mapped,
	* undefined arguments are passed to the native side. Some native functions do not check the parameters validation
	* correctly (just check the number of parameters passed).
	* Another solution instead of using this function call is to correctly check if the parameters are valid (not undefined) to make the
	* call, but it takes more work than using this approach.
	* @static
	* @param {string} nativeExtensionObjectName The name of the native extension object name. The object that is a member of the 'ext' object.
	* @param {string} nativeFunctionName The name of the function to be called inside the native extension object.
	* @param {object} arguments The arguments object of the CocoonJS extension object function. It contains all the arguments passed to the CocoonJS extension object function and these are the ones that will be passed to the native call too.
	* @param {boolean} [async] A flag to indicate if the makeCall (false or undefined) or the makeCallAsync function should be used to perform the native call.
	* @returns Whatever the native function call returns.
	*/
	CocoonJS.makeNativeExtensionObjectFunctionCall = function(nativeExtensionObjectName, nativeFunctionName, args, async) {
		if (CocoonJS.nativeExtensionObjectAvailable) {
			var argumentsArray = Array.prototype.slice.call(args);
			argumentsArray.unshift(nativeFunctionName);
			var nativeExtensionObject = ext[nativeExtensionObjectName];
			var makeCallFunction = async ? nativeExtensionObject.makeCallAsync : nativeExtensionObject.makeCall;
			var ret = makeCallFunction.apply(nativeExtensionObject, argumentsArray);
			var finalRet = ret;
			if (typeof ret === "string") {
				try	{
					finalRet = JSON.parse(ret);
				}
				catch(error) {
				}
			}
			return finalRet;
		}
	};

	/**
	* Returns an object retrieved from a path specified by a dot specified text path starting from a given base object.
	* It could be useful to find the reference of an object from a defined base object. For example the base object could be window and the
	* path could be "CocoonJS.App" or "document.body".
	* @param {Object} baseObject The object to start from to find the object using the given text path.
	* @param {string} objectPath The path in the form of a text using the dot notation. i.e. "document.body"
	* For example:
	* var body = getObjectFromPath(window, "document.body");
	*/
	CocoonJS.getObjectFromPath = function(baseObject, objectPath) {
    	var parts = objectPath.split('.');
    	var obj = baseObject;
        for (var i = 0, len = parts.length; i < len; ++i) 
        {
            obj[parts[i]] = obj[parts[i]] || undefined;
    		obj = obj[parts[i]];
    	}
    	return obj;
 	};

 	/**
 	* Returns the key for a value in a dictionary. It looks for an specific value inside a dictionary and returns the corresponding key.
 	* @param {Object} dictionary The dictionary to look for the value in and get the corresponding key.
 	* @param {Object} value The value to look for inside the dictionary and return it's corresponding key.
 	* @return The key that corresponds to the given value it is has been found or null.
 	*/
 	CocoonJS.getKeyForValueInDictionary = function(dictionary, value) {
        var finalKey = null;
        for (var key in dictionary) {
            if (dictionary[key] === value)            {
                finalKey = key;
                break;
            }
        }
        return finalKey;
 	}

 	/**
 	* Finds a string inside a given array of strings by looking for a given substring. It can also
 	* specify if the search must be performed taking care or not of the case sensitivity.
 	* @param {Array} stringArray The array of strings in which to to look for the string.
 	* @param {string} subString The substring to look for inside all the strings of the array.
 	* @param {boolean} caseSensitive A flag to indicate if the search must be performed taking case of the 
 	* case sensitiveness (true) or not (false).
 	* @return {string} The string that has been found or null if the substring is not inside any of the string of the array.
 	*/
 	CocoonJS.findStringInStringArrayThatIsIndexOf = function(stringArray, subString, caseSensitive) {
 		var foundString = null;
 		subString = caseSensitive ? subString : subString.toUpperCase();
 		for (var i = 0; foundString == null && i < stringArray.length; i++)	{
 			foundString = caseSensitive ? stringArray[i] : stringArray[i].toUpperCase();
 			foundString = foundString.indexOf(subString) >= 0 ? stringArray[i] : null; 
 		}
 		return foundString;
 	};

	/**
	* A class that represents objects to handle events. Event handlers have always the same structure:
	* Mainly they provide the addEventListener and removeEventListener functions.
	* Both functions receive a callback function that will be added or removed. All the added callback
	* functions will be called when the event takes place.
	* Additionally they also allow the addEventListenerOnce and notifyEventListeners functions.
	* @constructor
	* @param {string} nativeExtensionObjectName The name of the native extension object (inside the ext object) to be used.
	* @param {string} cocoonJSExtensionObjectName The name of the sugarized extension object.
	* @param {string} nativeEventName The name of the native event inside the ext object.
	* @param {number} [chainFunction] An optional function used to preprocess the listener callbacks. This function, if provided,
	* will be called before any of the other listeners.
	*/
	CocoonJS.EventHandler = function(nativeExtensionObjectName, cocoonJSExtensionObjectName, nativeEventName, chainFunction) {
		this.listeners = [];
		this.listenersOnce = [];
		this.chainFunction = chainFunction;

		/**
		* Adds a callback function so it can be called when the event takes place.
		* @param {function} listener The callback function to be added to the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
		*/
		this.addEventListener = function(listener) {
			if (chainFunction) {
				var f = function() {
					chainFunction.call(this, arguments.callee.sourceListener, Array.prototype.slice.call(arguments)); 
				};
				listener.CocoonJSEventHandlerChainFunction = f;
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0) {
                	this.listeners.push(listener);
                }
            }
		};

        this.addEventListenerOnce = function(listener)
		{
			if (chainFunction) {
				var f = function() { chainFunction(arguments.callee.sourceListener,Array.prototype.slice.call(arguments)); };
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListenerOnce(nativeEventName, listener);
            }
            else
            {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0)
                {
                	this.listenersOnce.push(listener);
                }
            }
		};

        /**
         * Removes a callback function that was added to the event handler so it won't be called when the event takes place.
         * @param {function} listener The callback function to be removed from the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.removeEventListener = function (listener) {

        	if (chainFunction) {
        		listener = listener.CocoonJSEventHandlerChainFunction;
        		delete listener.CocoonJSEventHandlerChainFunction;
        	}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].removeEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener >= 0) {
                    this.listeners.splice(indexOfListener, 1);
                }
            }
        };

		this.notifyEventListeners = function() {
			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].notifyEventListeners(nativeEventName);
            } else {

                var argumentsArray= Array.prototype.slice.call(arguments);
                var listeners =     Array.prototype.slice.call(this.listeners);
                var listenersOnce = Array.prototype.slice.call(this.listenersOnce);
                var _this = this;
                // Notify listeners after a while ;) === do not block this thread.
                setTimeout(function() {
                    for (var i = 0; i < listeners.length; i++) {
                        listeners[i].apply(_this, argumentsArray);
                    }
                    for (var i = 0; i < listenersOnce.length; i++) {
                        listenersOnce[i].apply(_this, argumentsArray);
                    }
                }, 0);

                _this.listenersOnce= [];
            }
		};
		return this;
	};

	/**
	* A simple timer class. Update it every loop iteration and get values from accumulated time to elapsed time in seconds or milliseconds.
	*/
	CocoonJS.Timer = function() {
		this.reset();
		return this;
	};

	CocoonJS.Timer.prototype = {
		currentTimeInMillis : 0,
		lastTimeInMillis : 0,
		elapsedTimeInMillis : 0,
		elapsedTimeInSeconds : 0,
		accumTimeInMillis : 0,

		/**
		Resets the timer to 0.
		*/
		reset : function() {
			this.currentTimeInMillis = this.lastTimeInMillis = new Date().getTime();
			this.accumTimeInMillis = this.elapsedTimeInMillis = this.elapsedTimeInSeconds = 0;
		},

		/**
		Updates the timer calculating the elapsed time between update calls.
		*/
		update : function() {
			this.currentTimeInMillis = new Date().getTime();
			this.elapsedTimeInMillis = this.currentTimeInMillis - this.lastTimeInMillis;
			this.elapsedTimeInSeconds = this.elapsedTimeInMillis / 1000.0;
			this.lastTimeInMillis = this.currentTimeInMillis;
			this.accumTimeInMillis += this.elapsedTimeInMillis;
		}
	};

	// CocoonJS.FindAllNativeBindingsInCocoonJSExtensionObject = function(cocoonJSExtensionObject, nativeFunctionBindingCallback, nativeEventBindingCallback)
	// {
	// 	for (var cocoonJSExtensionObjectAttributeName in cocoonJSExtensionObject)
	// 	{
	// 		var cocoonJSExtensionObjectAttribute = cocoonJSExtensionObject[cocoonJSExtensionObjectAttributeName];

	// 		// Function
	// 		if (typeof cocoonJSExtensionObjectAttribute === 'function' && typeof cocoonJSExtensionObjectAttribute.nativeFunctionName !== 'undefined')
	// 		{
	// 			var nativeFunctionName = cocoonJSExtensionObjectAttribute.nativeFunctionName;
	// 			nativeFunctionBindingCallback(cocoonJSExtensionObjectAttributeName, nativeFunctionName);
	// 		}
	// 		// Event object
	// 		else if (typeof cocoonJSExtensionObjectAttribute === 'object' && cocoonJSExtensionObjectAttribute !== null && typeof cocoonJSExtensionObjectAttribute.nativeEventName !== 'undefined')
	// 		{
	// 			var nativeEventName = cocoonJSExtensionObjectAttribute.nativeEventName;
	// 			nativeEventBindingCallback(cocoonJSExtensionObjectAttributeName, nativeEventName);
	// 		}
	// 	}
	// }

	/**
	This function looks for a CocoonJS extension object that is bound to the given native ext object name.
	@returns The CocoonJS extension object that corresponds to the give native extension object name or null if it cannot be found.
	*/
	// CocoonJS.GetCocoonJSExtensionObjectForNativeExtensionObjectName = function(nativeExtensionObjectName)
	// {
	// 	var cocoonJSExtensionObject = null;
	// 	// Look in the CocoonJS object and for every object that is a CocoonJS.Extension check if it's nativeExtensionObjectName matches to the one passed as argument. If so, create an object that will represent it's documentation for the native ext object.
	// 	for (var cocoonJSAttributeName in CocoonJS)
	// 	{
	// 		var cocoonJSAttribute = CocoonJS[cocoonJSAttributeName];
	// 		if (typeof cocoonJSAttribute === 'object' && cocoonJSAttribute instanceof CocoonJS.Extension && cocoonJSAttribute.nativeExtensionObjectName === nativeExtensionObjectName)
	// 		{
	// 			// We have found the CocoonJS object that represents the native ext extension object name. 
	// 			cocoonJSExtensionObject = cocoonJSAttribute;
	// 			break;
	// 		}
	// 	}
	// 	return cocoonJSExtensionObject;
	// };

	/**
	This function adds functions to a CocoonJS extension object in order to bind them to the native makeCall function calls of the ext object.

	@param extensionObject The reference to the CocoonJS extension object where to add the new functions bound to the ext object makeCall functions calls.

	@param nativeFunctionsConfiguration An array of objects with the following structure:

		{ nativeFunctionName : "" [, functionName : "", isAsync : true/false] }

		- nativeFunctionName: Specifies the name of the function inside the ext object makeCall function call that will be bound.
		- functionName: An optional attribute that allows to specify the name of the function to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeFunctionName.
		- isAsync: An optional attribute that allows to specify if the call should be performed using makeCall (false or missing) or makeCallAsync (true).
		- alternativeFunction: An optional attribute that allows to specify an alternative function that will be called internally when this function is called. This attribute
		allows for adding new functionalities like for example adding methods 

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeFunctionBindingsToExtensionObject = function(extensionObject, nativeFunctionsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeFunctionsConfiguration === 'undefined' || nativeFunctionsConfiguration === null) throw("The passed native functions configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeFunctionsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeFunctionsConfiguration[i].nativeFunctionName === 'undefined') throw("The 'nativeFunctionName' attribute in the native function configuration object at index '" + i + "' in the native function configuration array cannot be undefined.");
	// 		var nativeFunctionName = nativeFunctionsConfiguration[i].nativeFunctionName;
	// 		var functionName = typeof nativeFunctionsConfiguration[i].functionName !== 'undefined' ? nativeFunctionsConfiguration[i].functionName : nativeFunctionName;
	// 		var makeCallFunction = null;
	// 		makeCallFunction = typeof nativeFunctionsConfiguration[i].isAsync !== 'undefined' && nativeFunctionsConfiguration[i].isAsync ? extensionObject.nativeExtensionObject.makeCallAsync : extensionObject.nativeExtensionObject.makeCall;
	// 		// Add the new function to the CocoonJS extension object
	// 		extensionObject[functionName] = function()
	// 		{
	// 			// Convert the arguments object to an array
	// 			var arguments = Array.prototype.slice.call(arguments);
	// 			// Add the native function name as the first parameter
	// 			arguments.unshift(nativeFunctionName);
	// 			// Make the native ext object call
	// 			var result = makeCallFunction.apply(extensionObject.nativeExtensionObject, arguments);
	// 			return result;
	// 		}
	// 		// Add a property to the newly added function to store the name of the original function.
	// 		extensionObject[functionName].nativeFunctionName = nativeFunctionName;
	// 	}
	// 	return extensionObject;
	// };

	/**
	This function adds objects to a CocoonJS extension object to allow event listener handling (add and remove) bound to the native ext object event listener handling.

	@param extensionObject The reference to the CocoonJS extension object where to add the new objects bound to the ext object event listener handling.

	@param nativeEventsConfiguration An array of objects with the following structure:

		{ nativeEventName : "" [, eventObjectName : ""] }

		- nativeEventName: Specifies the event in the native ext object to be bound.
		- eventObjectName: An optional attribute that allows to specify the name of the object to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeEventName.
		- alternativeAddEventListenerFunction:
		- alternativeRemoveEventListenerFunction:

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeEventBindingsToExtensionObject = function(extensionObject, nativeEventsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeEventsConfiguration === 'undefined' || nativeEventsConfiguration === null) throw("The passed native events configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeEventsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeEventsConfiguration[i].nativeEventName === 'undefined') throw("The 'nativeEventName' attribute in the native event configuration object at index '" + i + "' in the native event configuration array cannot be undefined.");
	// 		var nativeEventName = nativeEventsConfiguration[i].nativeEventName;
	// 		var eventObjectName = typeof nativeEventsConfiguration[i].eventObjectName !== 'undefined' ? nativeEventsConfiguration[i].eventObjectName : nativeEventName;
	// 		// Anonymous function call so each variable in the loop is used in the event listener handling function bindings.
	// 		(function(nativeEventName, eventObjectName)
	// 		{
	//     		extensionObject[eventObjectName] =
	//     		{
	//     			// Store the native event name
	//     			nativeEventName : nativeEventName,
	//     			// Create the event listener management functions bound to the native counterparts
	//     			addEventListener : function(callback)
	// 	    		{
	// 	    			extensionObject.nativeExtensionObject.addEventListener(nativeEventName, callback);
	//     			},
	//     			removeEventListener : function(callback)
	//     			{
	// 	    			extensionObject.nativeExtensionObject.removeEventListener(nativeEventName, callback);
	//     			}
	//     			// ,
	//     			// removeAllEventListeners : function()
	//     			// {

	//     			// }
	//     		};
	// 		})(nativeEventName, eventObjectName);
	// 	}
	// 	return extensionObject;
	// };

	/**
	The function object constructor function all the CocoonJS extensions can use to instantiate the CocoonJS extension object and add all the functionality needed bound to the native ext object.

	@param nativeExtensionObject The reference to the ext object extension object.

	@param nativeFunctionsConfiguration See CocoonJS.AddNativeFunctionBindingsToExtensionObject function's documentation for more details.

	@param nativeEventsConfiguration See CocoonJS.AddNativeEventBindingsToExtensionObject function's documentation for more details.

	@returns The new CocoonJS extension object.
	*/
	// CocoonJS.Extension = function(nativeExtensionObjectName, nativeFunctionsConfiguration, nativeEventsConfiguration)
	// {
	// 	if (typeof nativeExtensionObjectName === 'undefined' || nativeExtensionObjectName === null) throw("The native extension object name cannot be null");

	// 	if (window.ext[nativeExtensionObjectName] === 'undefined') throw("The given native extension object name '" + nativeExtensionObjectName + "' is incorrect or the native extension object is undefined.");

	// 	var nativeExtensionObject = window.ext[nativeExtensionObjectName];

	// 	// Store a reference to the native extension object and to it's name
	// 	this.nativeExtensionObject = nativeExtensionObject;
	// 	this.nativeExtensionObjectName = nativeExtensionObjectName;

	// 	// If native function configuration is passed, use it to add some functions to the new extension object.
	// 	if (typeof nativeFunctionsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeFunctionBindingsToExtensionObject(this, nativeFunctionsConfiguration);
	// 	}

	// 	// If native event configuration is passed, use it to add some event objects to the new extension object.
	// 	if (typeof nativeEventsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeEventBindingsToExtensionObject(this, nativeEventsConfiguration);
	// 	}

	// 	return this;
	// };   

})();

//////////////////////////////////////
// COCOONJS_APP.JS                  //
//////////////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents all the basic functionalities available in the CocoonJS extension API.
     * @namespace
     */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_APP !== 'undefined';

    /**
     * The predefined possible layouts for the FPS overlay.
     * @namespace
     */
    CocoonJS.App.FPSLayout = {
        TOP_LEFT:'top-left',
        TOP_RIGHT:'top-right',
        BOTTOM_LEFT:'bottom-left',
        BOTTOM_RIGHT:'bottom-right'
    };

    /**
     * Contains all the possible values to specify the input keyboard type to be used when introducing text.
     * @namespace
     */
    CocoonJS.App.KeyboardType = {
        /**
         * Represents a generic text input keyboard.
         */
        TEXT:"text",

        /**
         * Represents a number like input keyboard.
         */
        NUMBER:"num",

        /**
         * Represents a phone like input keyboard.
         */
        PHONE:"phone",

        /**
         * Represents an email like input keyboard.
         */
        EMAIL:"email",

        /**
         * Represents an URL like input keyboard.
         */
        URL:"url"
    };

    /**
     * The storage types to be used with file system related operations.
     * @namespace
     */
    CocoonJS.App.StorageType = {
        /**
         * Represents the application storage. The application storage is the place where all the resources that come with the application are stored.
         */
        APP_STORAGE:"APP_STORAGE",

        /**
         * Represents the internal storage. The internal storage is a different storage space that the application storage and only the data that the application has stored
         * in it will be in this storage. It is internal to the platform/device.
         */
        INTERNAL_STORAGE:"INTERNAL_STORAGE",

        /**
         * Represents an external storage. The external storage is similar to the internal storage in the sense that it only contains information that the application has written
         * in it but it represents an external storage device like a SD-CARD. If there is no exrernal storage, it will represent the same as the internal storage.
         */
        EXTERNAL_STORAGE:"EXTERNAL_STORAGE",

        /**
         * Represents the temporal storage. Same as the internal and external storage spaces in the sense that it only contains information that the application has written
         * in it but the main difference is that the information in this storage may dissapear without notice.
         */
        TEMPORARY_STORAGE:"TEMPORARY_STORAGE"
    };

    /**
     * The capture types to capture screenshots using CocoonJS native capabilities.
     * @namespace
     */
    CocoonJS.App.CaptureType = {
        /**
         Captures everything, both the CocoonJS GL hardware accelerated surface and the system views (like the WebView).
         */
        EVERYTHING:0,

        /**
         * Captures just the CocoonJS GL hardware accelerated surface.
         */
        JUST_COCOONJS_GL_SURFACE:1,

        /**
         * Captures just the sustem views (like the webview)
         */
        JUST_SYSTEM_VIEWS:2
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It waits until the code is executed and the result of it is returned === synchronous.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @return {string} The result of the execution of the passed JavaScript code in the different JavaScript environment.
     */
    CocoonJS.App.forward = function (javaScriptCode) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forward", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                //return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                return window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It is asyncrhonous so it does not wait until the code is executed and the result of it is returned. Instead, it calls a callback function when the execution has finished to pass the result.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @param {function} [returnCallback] A function callback that will be called when the passed JavaScript code is executed in a different thread to pass the result of the execution in the different JavaScript environment.
     */
    CocoonJS.App.forwardAsync = function (javaScriptCode, returnCallback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            if (typeof returnCallback !== 'undefined') {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode, returnCallback);
            }
            else {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode);
            }
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                // window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Pops up a text dialog so the user can introduce some text and the application can get it back. It is the first approach CocoonJS has taken to be able to introduce
     * text input in a easy way. The dialog execution events are passed to the application through the {@link CocoonJS.App.onTextDialogFinished} and the {@link CocoonJS.App.onTextDialogCancelled} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [text] Default value is "". The initial text to be introduced in the text input field.
     * @param {CocoonJS.App.KeyboardType} [keyboardType] Default value is {@link CocoonJS.App.KeyboardType.TEXT}. The keyboard type to be used when the text has to be introduced.
     * @param {string} [cancelButtonText] Default value is "". The text to be displayed in the cancel button of the dialog.
     * @param {string} [okButtonText] Default value is "". The text to be displayed in the ok button of the dialog.
     * @see CocoonJS.App.onTextDialogFinished
     * @see CocoonJS.App.onTextDialogCancelled
     */
    CocoonJS.App.showTextDialog = function (title, message, text, keyboardType, cancelButtonText, okButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTextDialog", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            if (!text) {
                text = "";
            }
            var result = prompt(message, text);
            var eventObject = result ? CocoonJS.App.onTextDialogFinished : CocoonJS.App.onTextDialogCancelled;
            eventObject.notifyEventListeners(result);
        }
    };

    /**
     * Pops up a message dialog so the user can decide between a yes or no like confirmation. The message box execution events are passed to the application through the {@link CocoonJS.App.onMessageBoxConfirmed} and the {@link CocoonJS.App.onMessageBoxDenied} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [confirmButtonText] Default value is "Yes". The text to be displayed for the confirm button.
     * @param {string} [denyButtonText] Default value is "No". The text to be displayed for the deny button.
     * @see CocoonJS.App.onMessageBoxConfirmed
     * @see CocoonJS.App.onMessageBoxDenied
     */
    CocoonJS.App.showMessageBox = function (title, message, confirmButtonText, denyButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showMessageBox", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            var result = confirm(message);
            var eventObject = result ? CocoonJS.App.onMessageBoxConfirmed : CocoonJS.App.onMessageBoxDenied;
            eventObject.notifyEventListeners();
        }
    };

    /**
     * It allows to load a new JavaScript/HTML5 resource that can be loaded either locally (inside the platform/device storage) or using a remote URL.
     * @function
     * @param {string} path A path to a resource stored in the platform or in a URL to a remote resource.
     * @param {CocoonJS.App.StorageType} [storageType] If the path argument represents a locally stored resource, the developer can specify the storage where it is stored. If no value is passes, the {@link CocoonJS.App.StorageType.APP_STORAGE} value is used by default.
     */
    CocoonJS.App.load = function (path, storageType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadPath", arguments);
        }
        else if (!navigator.isCocoonJS) {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function (event) {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        // TODO: As window load event is not being called (WHY???), I have decided to call the listeners directly
                        // var callback= function(event){
                        //     window.removeEventListener("load", callback);
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInCocoonJSSucceed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                        // };
                        // window.addEventListener("load", callback);
                        window.location.href = path;
                    }
                    else if (xhr.status === 404) {
                        this.onreadystatechange = null;
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInCocoonJSFailed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the current context.
     * @function
     */
    CocoonJS.App.reload = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reload", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.location.reload();
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.location.reload();
            }
        }
    };

    /**
     * Opens a given URL using a system service that is able to open it. For example, open a HTTP URL using the system WebBrowser.+
     * @function
     * @param {string} url The URL to be opened by a system service.
     */
    CocoonJS.App.openURL = function (url) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "openURL", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            window.open(url, '_blank');
        }
    }

    /**
     * Forces the app to be finished.
     * @function
     */
    CocoonJS.App.forceToFinish = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forceToFinish", arguments);
        }
        else if (!navigator.isCocoonJS) {
            window.close();
        }
    }

    /**
     * Enables or disables the auto lock to control if the screen keeps on after an inactivity period.
     * When the auto lock is enabled and the application has no user input for a short period, the system puts the device into a "sleepâ€ state where the screen dims or turns off.
     * When the auto lock is disabled the screen keeps on even when there is no user input for long times.
     * @param enabled A boolean value that controls whether to enable or disable the auto lock.
     */
    CocoonJS.App.setAutoLockEnabled = function (enabled) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setAutoLockEnabled", arguments);
        }
    }

    /**
     * Creates a canvas element that is automatically resized to the screen size. When the app is being executed
     * inside CocoonJS. This canvas is optimized for rendering so it is higly recommended to use it if it fits
     * your app needs. If your app uses one canvas as the main canvas where all other canvases and images are displayed, Ludei recommends to
     * call this function in order to create this main canvas. A usual 2x performance gain is achieved by doing so
     * depending on the device and the graphics card driver.
     * @function
     * @return {object} The canvas object that should be used as the main canvas and that is resized to the screen resolution.
     */
    CocoonJS.App.createScreenCanvas = function () {
        var screenCanvas;
        if (navigator.isCocoonJS) {
            screenCanvas = document.createElement("screencanvas");
        }
        else if (!navigator.isCocoonJS) {
            screenCanvas = document.createElement("canvas");
            screenCanvas.width = window.innerWidth;
            screenCanvas.height = window.innerHeight;
        }
        return screenCanvas;
    };

    /**
     * Disables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.disableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Enables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.enableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Disables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.disableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "WebView");
        }
    };

    /**
     * Enables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.enableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "WebView");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the accelerometer updates.
     * It defines the rate at which the devicemotion events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setAccelerometerUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setAccelerometerUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for accelerometer related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for accelerometer related events.
     */
    CocoonJS.App.getAccelerometerUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getAccelerometerUpdateIntervalInSeconds");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the gyroscope updates.
     * It defines the rate at which the devicemotion and deviceorientation events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setGyroscopeUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setGyroscopeUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for gyroscope related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for gyroscope related events.
     */
    CocoonJS.App.getGyroscopeUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("getGyroscopeUpdateIntervalInSeconds");
        }
    };


    /**
     * Setups a origin proxy for a given typeName. What this means is that after calling this function the environment that makes this call will suddenly
     * have a way of creating instances of the given typeName and those instances will act as a transparent proxy to counterpart instances in the destination environment.
     * Manipulating attributes, calling funcitions or handling events will all be performed in the destination environment but the developer will think they will be
     * happening in the origin environment.
     * IMPORTANT NOTE: These proxies only work with types that use attributes and function parameters and return types that are primitive like numbers, strings or arrays.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} [attributeNames] A list of the names of the attributes to be proxified.
     * @param {array} [functionNames] A list of the names of the functions to be proxified.
     * @param {array} [eventHandlerNames] A list of the names of the event handlers to be proxified (onXXXX like attributes that represent callbacks).
     * A valid typeName and at least one valid array for attribute, function or event handler names is mandatory.
     */
    CocoonJS.App.setupOriginProxyType = function (typeName, attributeNames, functionNames, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            // Control the parameters.
            if (!typeName) throw "The given typeName must be valid.";
            if (!attributeNames && !functionNames && !eventHandlerNames) throw "There is no point on setting up a proxy for no attributes, functions nor eventHandlers.";
            attributeNames = attributeNames ? attributeNames : [];
            functionNames = functionNames ? functionNames : [];
            eventHandlerNames = eventHandlerNames ? eventHandlerNames : [];

            // The parent object will be the window. It could be another object but careful, the destination side should know about this.
            // TODO: Specify the parentObject as a parameter, obtain it's path from the window object and pass it to the destination environment so it knows about it.
            var parentObject = window;

            // Setup the destination side too.
            var jsCode = "CocoonJS.App.setupDestinationProxyType(" + JSON.stringify(typeName) + ", " + JSON.stringify(eventHandlerNames) + ");";
            CocoonJS.App.forward(jsCode);

            var originalType = parentObject[typeName];

            // Constructor. This will be the new proxified type in the origin environment. Instances of this type will be created by the developer without knowing that they are
            // internally calling to their counterparts in the destination environment.
            parentObject[typeName] = function () {
                var _this = this;

                // Each proxy object will have a origin object inside with all the necessary information to be a proxy to the destination.
                this._cocoonjs_proxy_object_data = {};
                // The id is obtained calling to the destination side to create an instance of the type.
                var jsCode = "CocoonJS.App.newDestinationProxyObject(" + JSON.stringify(typeName) + ");";
                this._cocoonjs_proxy_object_data.id = CocoonJS.App.forward(jsCode);
                // The eventHandlers dictionary contains objects of the type { eventHandlerName : string, eventHandler : function } to be able to make the callbacks when the 
                // webview makes the corresponding calls.
                this._cocoonjs_proxy_object_data.eventHandlers = {};
                // Also store the typename inside each instance.
                this._cocoonjs_proxy_object_data.typeName = typeName;
                // A dictionary to store the event handlers
                this._cocoonjs_proxy_object_data.eventListeners = {};

                // TODO: eventHandlers and eventListeners should be in the same list ;)

                // Store all the proxy instances in a list that belongs to the type itself.
                parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[this._cocoonjs_proxy_object_data.id] = this;

                // Create a setter and a getter for all the attribute names that have been specified. When the attributes are accessed (set or get) a call to the destination counterpart will be performed.
                for (var i = 0; i < attributeNames.length; i++) {
                    (function (attributeName) {
                        _this.__defineSetter__(attributeName, function (value) {
                            var jsCode = "CocoonJS.App.setDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ", " + JSON.stringify(value) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                        _this.__defineGetter__(attributeName, function () {
                            var jsCode = "CocoonJS.App.getDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                    })(attributeNames[i]);
                }

                // Create a function that performs a call to the destination environment counterpart for all the function names that have been specified.
                for (var i = 0; i < functionNames.length; i++) {
                    (function (functionName) {
                        _this[functionName] = function () {
                            // Get the arguments as an array and add the typeName, the proxy id and the functionName before all the other arguments before making the call to the destination counterpart.
                            var argumentsArray = Array.prototype.slice.call(arguments);
                            argumentsArray.unshift(functionName);
                            argumentsArray.unshift(this._cocoonjs_proxy_object_data.id);
                            argumentsArray.unshift(typeName);
                            // Use the array to create the correct function call.
                            var jsCode = "CocoonJS.App.callDestinationProxyObjectFunction(";
                            for (var i = 0; i < argumentsArray.length; i++) {
                                // The second argument (the id) should not be stringified
                                jsCode += (i !== 1 ? JSON.stringify(argumentsArray[i]) : argumentsArray[i]) + (i < argumentsArray.length - 1 ? ", " : "");
                            }
                            jsCode += ");";
                            // TODO: This next call should be synchronous but it seems that some customers are experiencing some crash issues. Making it async solves these crashes.
                            // Another possible solution could be to be able to specify which calls could be async and which sync in the proxification array.
                            var ret = CocoonJS.App.forwardAsync(jsCode);
                            return ret;
                        };
                    })(functionNames[i]);
                }

                // Create a setter and getter for all the event handler names that have been specified. When the event handlers are accessed, store them inside the corresponding position on the eventHandlers
                // array so they can be called when the destination environment makes the corresponding callback call.
                for (var i = 0; i < eventHandlerNames.length; i++) {
                    (function (eventHandlerName) {
                        _this.__defineSetter__(eventHandlerName, function (value) {
                            _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName] = value;
                        });
                        _this.__defineGetter__(eventHandlerName, function () {
                            return _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                        });
                    })(eventHandlerNames[i]);
                }

                // Setup the add and remove event listeners in the proxy object
                _this.addEventListener = function (eventTypeName, eventCallback) {
                    var addEventCallback = true;
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        // As the eventListeners were already added, check that the same callback has not been added.
                        addEventCallback = eventListeners.indexOf(eventCallback) < 0;
                    }
                    else {
                        // There are no event listeners, so add the one and add the listeners array for the specific event type name
                        eventListeners = [];
                        _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = eventListeners;

                        // Forward the call so the other end registers a event listener (only one is needed).
                        var jsCode = "CocoonJS.App.addDestinationProxyObjectEventListener(" + JSON.stringify(_this._cocoonjs_proxy_object_data.typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                    // Only if the alforithm above specify so, add the eventcallback and notify the destination environment to do the same
                    if (addEventCallback) {
                        eventListeners.push(eventCallback);
                    }
                };

                _this.removeEventListener = function (eventTypeName, eventCallback) {
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        var eventCallbackIndex = eventListeners.indexOf(eventCallback);
                        if (eventCallbackIndex >= 0) {
                            eventListeners.splice(eventCallbackIndex, 1);
                        }
                    }
                };

                // Return the proxy instance.
                return this;
            };

            // The type will contain a proxy data structure to store all the instances that are created so they are available when the destination environment calls back. 
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                originalType:originalType,
                proxyObjects:[]
            };

            /**
             * Deletes a proxy instance from both the CocoonJS environment structures and also deleting it's webview environment counterpart.
             * This function should be manually called whenever a proxy instance won't be accessed anymore.
             * @param {object} object The proxy object to be deleted.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.deleteProxyObject = function (object) {
                var proxyObjectKey = CocoonJS.getKeyForValueInDictionary(this.proxyObjects, object);
                if (proxyObjectKey) {
                    var jsCode = "CocoonJS.App.deleteDestinationProxyObject(" + JSON.stringify(typeName) + ", " + object._cocoonjs_proxy_object_data.id + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                    object._cocoonjs_proxy_object_data = null;
                    delete this.proxyObjects[proxyObjectKey];
                }
            };

            /**
             * Calls a event handler for the given proxy object id and eventHandlerName.
             * @param {number} id The id to be used to look for the proxy object for which to make the call to it's event handler.
             * @param {string} eventHandlerName The name of the handler to be called.
             * NOTE: Events are a complex thing in the HTML specification. This function just performs a call but at least provides a
             * structure to the event passing the target (the proxy object).
             * TODO: The destination should serialize the event object as far as it can so many parameters can be passed to the origin
             * side. Using JSON.stringify in the destination side and parse in origin side maybe? Still must add the target to the event structure though.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler = function (id, eventHandlerName) {
                var object = this.proxyObjects[id];
                var eventHandler = object._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                if (eventHandler) {
                    eventHandler({ target:object });
                }
            };

            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners = function (id, eventTypeName) {
                var object = this.proxyObjects[id];
                var eventListeners = object._cocoonjs_proxy_object_data.eventListeners[eventTypeName].slice();
                for (var i = 0; i < eventListeners.length; i++) {
                    eventListeners[i]({ target:object });
                }
            };
        }
    };

    /**
     * Takes down the proxification of a type and restores it to it's original type. Do not worry if you pass a type name that is not proxified yet. The
     * function will handle it correctly for compativility reasons.
     * @param {string} typeName The name of the type to be deproxified (take down the proxification and restore the type to it's original state)
     */
    CocoonJS.App.takedownOriginProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parentObject[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                parentObject[typeName] = parentObject[typeName]._cocoonjs_proxy_type_data.originalType;
            }
        }
    };

    /**
     * Deletes everything related to a proxy object in both environments. Do not worry of you do not pass a proxified object to the
     * function. For compatibility reasons, you can still have calls to this function even when no poxification of a type has been done.
     * @param {object} object The proxified object to be deleted.
     */
    CocoonJS.App.deleteOriginProxyObject = function (object) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (object && object._cocoonjs_proxy_object_data) {
                parentObject[object._cocoonjs_proxy_object_data.typeName]._cocoonjs_proxy_type_data.deleteProxyObject(object);
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when an event handler need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventHandlerName The name of the event handler to be called.
     */
    CocoonJS.App.callOriginProxyObjectEventHandler = function (typeName, id, eventHandlerName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler(id, eventHandlerName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when all the event listeners related to a specific event need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventTypeName The name of the event type to call the listeners related to it.
     */
    CocoonJS.App.callOriginProxyObjectEventListeners = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners(id, eventTypeName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Setups all the structures that are needed to proxify a destination type to an origin type.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} eventHandlerNames An array with al the event handlers to be proxified. Needed in order to be able to create callbacks for all the event handlers
     * and call to the CocoonJS counterparts accordingly.
     */
    CocoonJS.App.setupDestinationProxyType = function (typeName, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            // Add a cocoonjs structure to the destination proxified type to store some useful information like all the proxy instances that are created, plus the id counter 
            // and the names of all the event handlers and some utility functions.
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                nextId:0,
                proxyObjects:{},
                eventHandlerNames:eventHandlerNames
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Takes down the proxy type at the destination environment. Just removes the data structure related to proxies that was added to the type when proxification tool place.
     * @param {string} typeName The name of the type to take the proxification down.
     */
    CocoonJS.App.takedownDestinationProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parent[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                delete parentObject[typeName]._cocoonjs_proxy_type_data;
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Creates a new destination object instance and generates a id to reference it from the original environment.
     * @param {string} typeName The name of the type to be proxified and to generate an instance.
     * @return The id to be used from the original environment to identify the corresponding destination object instance.
     */
    CocoonJS.App.newDestinationProxyObject = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            var proxyObject = new parentObject[typeName]();
            // Also store some additional information in the proxy object
            proxyObject._cocoonjs_proxy_object_data = {};
            // Like the type name, that could be useful late ;)
            proxyObject._cocoonjs_proxy_object_data.typeName = typeName;
            // Caculate the id for the object. It will be returned to the origin environment so this object can be referenced later
            var proxyObjectId = parentObject[typeName]._cocoonjs_proxy_type_data.nextId;
            // Store the created object in the structure defined in the setup of proxification with an id associated to it
            parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[proxyObjectId] = proxyObject;
            // Also store the id inside the proxy object itself
            proxyObject._cocoonjs_proxy_object_data.id = proxyObjectId;
            // Calculate a new id for the next object.
            parentObject[typeName]._cocoonjs_proxy_type_data.nextId++;

            // Setup all the event handlers.
            for (var i = 0; i < parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames.length; i++) {
                (function (eventHandlerName) {
                    proxyObject[eventHandlerName] = function (event) {
                        var proxyObject = this; // event.target;
                        // var eventHandlerName = CocoonJS.getKeyForValueInDictionary(proxyObject, this); // Avoid closures ;)
                        var jsCode = "CocoonJS.App.callOriginProxyObjectEventHandler(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventHandlerName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    };
                })(parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames[i]);
            }

            // Add the dictionary where the event listeners (callbacks) will be added.
            proxyObject._cocoonjs_proxy_object_data.eventListeners = {};

            return proxyObjectId;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environement whenever it is needed to work with proxy objects.
     * Calls a function of a destination object idetified by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} functionName The name of the function to be called.
     * @return Whatever the function call returns.
     */
    CocoonJS.App.callDestinationProxyObjectFunction = function (typeName, id, functionName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var argumentsArray = Array.prototype.slice.call(arguments);
            argumentsArray.splice(0, 3);
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            var result = proxyObject[functionName].apply(proxyObject, argumentsArray);
            return result;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Sets a value to the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be set.
     * @param {unknown} attributeValue The value to be set to the attribute.
     */
    CocoonJS.App.setDestinationProxyObjectAttribute = function (typeName, id, attributeName, attributeValue) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            proxyObject[attributeName] = attributeValue;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Retrieves the value of the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be retrieved.
     */
    CocoonJS.App.getDestinationProxyObjectAttribute = function (typeName, id, attributeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            return proxyObject[attributeName];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Deletes a proxy object identifying it using it's typeName and id. Deleting a proxy object mainly means to remove the instance from the global structure
     * that hold all the instances.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     */
    CocoonJS.App.deleteDestinationProxyObject = function (typeName, id) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            delete parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     */
    CocoonJS.App.addDestinationProxyObjectEventListener = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            // Look for the proxy object
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];

            var callback = function (event) {
                var proxyObject = this; // event.target;
                // var eventTypeName = CocoonJS.getKeyForValueInDictionary(proxyObject._cocoonjs_proxy_object_data.eventListeners, this); // Avoid closures ;)
                // TODO: Is there a way to retrieve the callbackId without a closure?
                var jsCode = "CocoonJS.App.callOriginProxyObjectEventListeners(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                CocoonJS.App.forwardAsync(jsCode);
            };

            proxyObject._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = callback;

            // Finally add the event listener callback to the proxy object
            proxyObject.addEventListener(eventTypeName, callback);
        }
    };

    // TODO: We could add a removeDestinationProxyObjectEventListener although it seems that is not completely necessary.

    /**
     * Proxifies the XMLHttpRequest type for the environment where this call is made. After calling this function, all the new objects
     * of XMLHttpRequest that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyXHR = function () {
        var ATTRIBUTE_NAMES =
            [
                "timeout",
                "withCredentials",
                "upload",
                "status",
                "statusText",
                "responseType",
                "response",
                "responseText",
                "responseXML",
                "readyState"
            ];
        var FUNCTION_NAMES =
            [
                "open",
                "setRequestHeader",
                "send",
                "abort",
                "getResponseHeader",
                "getAllResponseHeaders",
                "overrideMimeType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onloadstart",
                "onprogress",
                "onabort",
                "onerror",
                "onload",
                "ontimeout",
                "onloadend",
                "onreadystatechange"
            ];
        CocoonJS.App.setupOriginProxyType("XMLHttpRequest", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Proxifies the Audio type for the environment where this call is made. After calling this function, all the new objects
     * of Audio that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyAudio = function () {
        var ATTRIBUTE_NAMES =
            [
                "src",
                "loop",
                "volume",
                "preload"
            ];
        var FUNCTION_NAMES =
            [
                "play",
                "pause",
                "load",
                "canPlayType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onended",
                "oncanplay",
                "oncanplaythrough",
                "onerror"
            ];
        CocoonJS.App.setupOriginProxyType("Audio", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Captures a image of the screen synchronously and saves it to a file. Sync mode allows to capture the screen in the middle of a frame rendering.
     * @param {string} fileName Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} storageType The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @return The URL of the saved file.
     * @throws exception if the image fails to be stored or there is another error.
     * @see CocoonJS.App.onCaptureScreenSucceeded
     * @see CocoonJS.App.onCaptureScreenFailed
     */
    CocoonJS.App.captureScreen = function (fileName, storageType, captureType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("captureScreen", fileName, storageType, captureType);
        }
    };

    /**
     * Captures a image of the screen asynchronously and saves it to a file.
     * Async mode captures a final frame as soon as possible.
     * @param {string} Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} [storageType] The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface, 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @param {function} callback. Response callback, check the error property to monitor errors. Check the 'url' property to get the URL of the saved Image
     */
    CocoonJS.App.captureScreenAsync = function (fileName, storageType, captureType, callback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCallAsync("captureScreen", fileName, storageType, captureType, callback);
        }
    };

    /**
     * Returns the device UUID
     * @return {string} The device UUID
     */
    CocoonJS.App.getDeviceId = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceId");
        }
    };

    /**
     * Structure that defines the getDeviceInfo returned information
     */
    CocoonJS.App.DeviceInfo = {

        /**
        * The operating system name (ios, android,...)
        * @type string
        */
        os: null,

        /**
        * The operating system version (4.2.2, 5.0,...)
        * @type string
        */
        version: null,

        /**
        * The operating system screen density in dpi
        * @type string
        */
        dpi: null,

        /**
        * The device manufacturer (apple, samsung, lg,...)
        * @type string
        */
        brand: null,

        /**
        * The device model (iPhone 4S, SAMSUNG-SGH-I997, SAMSUNG-SGH-I997R, etc)
        * @type string
        */
        model: null,

        /**
        * The phone IMEI
        * Android: The phone IMEI is returned or null if the device has not telepohny
        * iOS: null is returned as we cannot get the IMEI in iOS, no public API available for that yet.
        * @type string
        */
        imei: null,

        /**
        * The platform Id
        * Android: The ANDROID_ID is used.
        * iOS: The OpenUDID is used as there is no Android ANDROID_ID equivalent in iOS
        * @type string
        */
        platformId: null,

        /**
        * The Odin generated id https://code.google.com/p/odinmobile/
        * @type string
        */
        odin: null,

        /**
        * The OpenUDID generated Id https://github.com/ylechelle/OpenUDID
        * @type string
        */
        openudid: null
    };

    /**
     * Returns the device Info
     * @return {CocoonJS.App.DeviceInfo} The device Info
     */
    CocoonJS.App.getDeviceInfo = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceInfo");
        }
    };    

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onTextDialogFinished} event calls.
     * @name OnTextDialogFinishedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} text The text that was introduced in the text dialog when it was finished.
     */
    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function's documentation is represented by {@link CocoonJS.App.OnTextDialogFinishedListener}
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogFinished = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogfinish");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogCancelled = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogcancel");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxConfirmed = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxconfirmed");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxDenied = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxdenied");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is suspended.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onSuspended = new CocoonJS.EventHandler("IDTK_APP", "App", "onsuspended");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is activated.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onActivated = new CocoonJS.EventHandler("IDTK_APP", "App", "onactivated");

})();

//////////////////////////////////////
// COCOONJS_APP_FORCOCOONJS.JS		//
//////////////////////////////////////

(function()
{
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    if (!CocoonJS.App.nativeExtensionObjectAvailable)
    {
        (function createWebView() { 
            CocoonJS.App.EmulatedWebView = document.createElement('div'); 
            CocoonJS.App.EmulatedWebView.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewDiv'); 
            CocoonJS.App.EmulatedWebView.style.width = 0; 
            CocoonJS.App.EmulatedWebView.style.height = 0; 
            CocoonJS.App.EmulatedWebView.style.position = "absolute"; 
            CocoonJS.App.EmulatedWebView.style.left = 0; 
            CocoonJS.App.EmulatedWebView.style.top = 0;
            CocoonJS.App.EmulatedWebView.style.backgroundColor = 'transparent';
            CocoonJS.App.EmulatedWebView.style.border = "0px solid #000"; 
            CocoonJS.App.EmulatedWebViewIFrame = document.createElement("IFRAME"); 
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('name', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.style.width = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.style.height = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.frameBorder = 0;
            CocoonJS.App.EmulatedWebViewIFrame.allowtransparency = true;
            CocoonJS.App.EmulatedWebView.appendChild(CocoonJS.App.EmulatedWebViewIFrame);
            if(!document.body)
            document.body = document.createElement("body");
            document.body.appendChild(CocoonJS.App.EmulatedWebView);
        })(); 
    }

    /**
    * Pauses the CocoonJS JavaScript execution loop.
    * @function
    * @augments CocoonJS.App
    */
    CocoonJS.App.pause = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "pause", arguments);
        }
    };

    /**
    * Resumes the CocoonJS JavaScript execution loop.
    * @static
    * @function
    */
    CocoonJS.App.resume = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "resume", arguments);
        }
    };

    /**
    * Loads a resource in the WebView environment from the CocoonJS environment.
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    * @see CocoonJS.App.onLoadInTheWebViewSucceed
    * @see CocoonJS.App.onLoadInTheWebViewFailed
    */
    CocoonJS.App.loadInTheWebView = function(path, storageType)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            // TODO: All this code should be changed to a simple call makeNativeExtensionObjectFunctionCall when the native argument control is improved.
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('loadPath'";
            if (typeof path !== 'undefined')
            {
                javaScriptCodeToForward += ", '" + path + "'";
                if (typeof storageType !== 'undefined')
                {
                    javaScriptCodeToForward += ", '" + storageType + "'";
                }
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function(event) {
                if (xhr.readyState === 4)
                {
                    if (xhr.status === 200)
                    {
                        var callback= function(event){
                            CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners(path);
                            CocoonJS.App.EmulatedWebViewIFrame.removeEventListener("load", callback);
                        };

                        CocoonJS.App.EmulatedWebViewIFrame.addEventListener(
                            "load", 
                            callback
                        );
                        CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.href= path;
                    }
                    else if (xhr.status === 404)
                    {
                        this.onreadystatechange = null;
                        CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners(path);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the WebView context.
     * @function
     */
    CocoonJS.App.reloadWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.App.forwardAsync("ext.IDTK_APP.makeCall('reload');");
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.reload();
        }
    };

    /**
    * Shows the webview.
    * @function
    * @param {int} x The top lef x coordinate of the rectangle where the webview will be shown.
    * @param {int} y The top lef y coordinate of the rectangle where the webview will be shown.
    * @param {width} y The width of the rectangle where the webview will be shown.
    * @param {height} y The height of the rectangle where the webview will be shown.
    */
    CocoonJS.App.showTheWebView = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('show'";
            if (typeof x !== 'undefined' && typeof y !== 'undefined' && typeof width !== 'undefined' && typeof height !== 'undefined')
            {
                javaScriptCodeToForward += ", " + x + ", " + y + ", " + width + ", " + height;
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebViewIFrame.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.left = (x ? x : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.top = (y ? y : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebView.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.display = "block";
        }
    };

    /**
    * Hides the webview.
    * @function
    */
    CocoonJS.App.hideTheWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('hide');";
            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebView.style.display = "none";
        }
    };

    /**
    * Marks a audio file to be used as music by the system. CocoonJS, internally, differentiates among music files and sound files.
    * Music files are usually bigger in size and longer in duration that sound files. There can only be just one music file 
    * playing at a specific given time. The developer can mark as many files as he/she wants to be treated as music. When the corresponding
    * HTML5 audio object is used, the system will automatically know how to treat the audio resource as music or as sound.
    * Note that it is not mandatory to use this function. The system automatically tries to identify if a file is suitable to be treated as music
    * or as sound by checking file size and duration thresholds. It is recommended, though, that the developer specifies him/herself what he/she considers
    * to be music.
    * @function
    * @param {string} audioFilePath The same audio file path that will be used to create HTML5 audio objects.
    */
    CocoonJS.App.markAsMusic = function(audioFilePath)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "addForceMusic", arguments);
        }
    };

    /**
    * Activates or deactivates the antialas functionality from the CocoonJS rendering.
    * @function
    * @param {boolean} enable A flag that indicates if the antialas should be activated (true) or deactivated (false).
    */
    CocoonJS.App.setAntialias = function(enable)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultAntialias", arguments);
        }
    };

    /**
    * Sets a callback function that will be called whenever the system tries to finish the app.
    * The developer can specify how the system will react to the finish of the app by returning a
    * boolean value in the callback function: true means, close the app, false means that the developer
    * will handle the app close.
    * A common example of this is the back button in Android devices. When the back button is pressed, this
    * callback will be called and the system will react depending on the developers choice finishing, or not,
    * the application.
    * @function
    * @param {function} appShouldFinishCallback A function object that will be called when the system
    * determines that the app should be finished. This function must return a true or a false value
    * depending on what the developer wants: true === finish the app, false === do not close the app.
    */
    CocoonJS.App.setAppShouldFinishCallback = function(appShouldFinishCallback)
    {
        if (navigator.isCocoonJS)
        {
            window.onidtkappfinish = appShouldFinishCallback;
        }
    }

    /**
    * Sets the texture reduction options. The texture reduction is a process that allows big images to be reduced/scaled down when they are loaded.
    * Although the quality of the images may decrease, it can be very useful in low end devices or those with limited amount of memory.
    * The function sets the threshold on image size (width or height) that will be used in order to know if an image should be reduced or not.
    * It also allows to specify a list of strings to identify in which images file paths should be applied (when they meet the size threshold requirement) 
    * The developer will still think that the image is of the original size. CocoonJS handles all of the internals to be able to show the image correctly.
    * IMPORTANT NOTE: This function should be called when the application is initialized before any image is set to be loaded for obvious reasons ;).
    * and in which sould be forbid (even if they meet the threshold requirement).
    * @function
    * @param {number} sizeThreshold This parameter specifies the minimun size (either width or height) that an image should have in order to be reduced.
    * @param {string or array} [applyTo] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it will be reduced. This parameter can also be null.
    * @param {string or array} [forbidFor] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it won't be reduced. This parameter should be used in order to mantain the 
    * quality of some images even they meet the size threshold requirement.
    */
    CocoonJS.App.setTextureReduction = function(sizeThreshold, applyTo, forbidFor)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultTextureReducerThreshold", arguments);
        }
    };


    /**
    * Prints to the console the memory usage of the currently alive textures
    * @function
    */
    CocoonJS.App.logMemoryInfo = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "logMemoryInfo", arguments);
        }
    };

    /**
    * Enable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.enableFPSInTheWebView = function(fpsLayout, textColor)
    {
        if (!CocoonJS.App.fpsInTheWebViewEnabled)
        {
            fpsLayout = fpsLayout ? fpsLayout : CocoonJS.App.FPSLayout.TOP_RIGHT;
            textColor = textColor ? textColor : "white";
            var jsCode = "" +
                "(function()" +
                "{" +
                    "var COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES = ['js/CocoonJSExtensions/CocoonJS.js', 'js/CocoonJSExtensions/CocoonJS_App.js', 'js/CocoonJSExtensions/CocoonJS_App_ForWebView.js'];" +
                    "var loadedScriptCounter = 0;" + 
                    "var loadedScriptFunction = function() " +
                    "{ " +
                        "loadedScriptCounter++;"+
                        "if (loadedScriptCounter >= COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length)"+
                        "{"+
                            "CocoonJS.App.enableFPS(" + JSON.stringify(fpsLayout) + ", " + JSON.stringify(textColor) + ");"+
                        "}"+
                    "};"+
                    "for (var i = 0; i < COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length; i++)"+
                    "{"+
                        "var s = document.createElement('script');"+
                        "s.onload = loadedScriptFunction;"+
                        "s.src = COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES[i];"+
                        "document.body.appendChild(s);"+
                    "}" +
                "})();";
            setTimeout(function()
            {
                CocoonJS.App.forward(jsCode);
            }, 3000);
            CocoonJS.App.fpsInTheWebViewEnabled = true;
        }
    };

    /**
    * Disable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.disableFPSInTheWebView = function()
    {
        // TODO: Implement this function.
    };

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewSucceed} event calls.
     * @name OnLoadInTheWebViewSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInTheWebViewSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewFailed} event calls.
     * @name OnLoadInTheWebViewFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInTheWebViewFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");
    
})();

//////////////////////////////////////
// COCOONJS_AD.JS                   //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Advertisement extension API.
    * @namespace
    */
    CocoonJS.Ad = {};

    CocoonJS.Ad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_AD !== 'undefined';

    /**
    * The predefined possible layouts for a banner ad.
    * @namespace 
    */
	CocoonJS.Ad.BannerLayout = 
	{
		/**
		* Specifies that the banner must be shown in the top of the screen and vertically centered.
		*/
	    TOP_CENTER      : "TOP_CENTER",

		/**
		* Specifies that the banner must be shown in the bottom of the screen and vertically centered.
		*/
	    BOTTOM_CENTER   : "BOTTOM_CENTER"
	};

	/**
    * A rectangle object that contains the banner dimensions
    * @namespace 
    * @constructor
    * @param {int} x The top lef x coordinate of the rectangle.
    * @param {int} y The top lef y coordinate of the rectangle.
    * @param {width} y The rectangle width.
    * @param {height} y The rectangle height.
    */
	CocoonJS.Ad.Rectangle = function(x, y, width, height) 
	{
		/**
		* The top lef x coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.x = x;

		/**
		* The top lef y coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.y = y;

	    /**
		* The rectangle width
		* @field 
		* @type {int}
		*/
	    this.width = width;

	    /**
		* The rectangle height
		* @field 
		* @type {int}
		*/
	    this.height = height;
	};

	CocoonJS.Ad.Banner = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
    	* The callback function does not receive any parameter.
    	* @param {number} width The banner width
    	* @param {number} height The banner height
    	* @static
    	* @event
    	*/
		this.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener(args[1], args[2]);
    		}
    	});
	};

	CocoonJS.Ad.Banner.prototype = {

		/**
		* Shows a banner ad if available.
		* @function
		*/
		showBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", [this.id], true);
			}
		},

		/**
		* Hides the banner ad if it was being shown.
		* @function
		*/
		hideBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", [this.id], true);
			}
		},

		/**
		* Refreshes the banner.
		* @function
		*/
		refreshBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", [this.id], true);
			}
		},

		/**
		* Gets the rectangle representing the banner screen position.
		* @function
		* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
		*/
		getRectangle : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", [this.id]);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* @function
		* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
		*/
		setRectangle : function(rect)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", [this.id, rect],true);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* You can use this method if you want to have better control of the banner screen positioning.
		* @function
		* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
		*/
		setBannerLayout : function(bannerLayout)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", [this.id, bannerLayout],true);
			}
		}
	};

	CocoonJS.Ad.Fullscreen = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
		this.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

    	/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});
	};

	CocoonJS.Ad.Fullscreen.prototype = {

		/**
		* Shows a full screen ad if available.
		* @function
		* @see CocoonJS.Ad.onFullScreenShown
		* @see CocoonJS.Ad.onFullScreenHidden
		*/
		showFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", [this.id], true);
			}
		},

		/**
		* Refreshes the fullscreen.
		* @function
		*/
		refreshFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", [this.id], true);
			}
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Ad.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "requestInitialization", arguments, true);
		}
	};

	/**
	* Creates a new banner ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createBanner = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createBanner", [parameters]);
			var banner = new CocoonJS.Ad.Banner(adId);

			return banner;
		}
	};

	/**
	* Releases a banner.
	* @function
	* @param {object} The banner ad object to be released.
	*/
	CocoonJS.Ad.releaseBanner = function(banner)
	{
		if (typeof banner === "undefined") {
            throw "The banner ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseBanner", [banner.id]);
		}
	};

	/**
	* Creates a new fullscreen ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createFullscreen = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createFullscreen", [parameters]);
			var fullscreen = new CocoonJS.Ad.Fullscreen(adId);

			return fullscreen;
		}
	};

	/**
	* Releases a fullscreen ad.
	* @function
	* @param {object} The fullscreen ad object to be released.
	*/
	CocoonJS.Ad.releaseFullscreen = function(fullscreen)
	{
		if (typeof fullscreen === "undefined") {
            throw "The fullscreen ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseFullscreen", [fullscreen.id]);
		}
	};

	/**
	* Shows a banner ad if available.
	* @function
	* @see CocoonJS.Ad.setBannerLayout
	* @see CocoonJS.Ad.onBannerShown
	*/
	CocoonJS.Ad.showBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", arguments, true);
		}
	};

	/**
	* Hides the banner ad if it was being shown.
	* @function
	*/
	CocoonJS.Ad.hideBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", arguments, true);
		}
	};

	/**
	* Refreshes the banner.
	* @function
	*/
	CocoonJS.Ad.refreshBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", arguments, true);
		}
	};

	/**
	* Shows a full screen ad if available.
	* @function
	* @see CocoonJS.Ad.onFullScreenShown
	* @see CocoonJS.Ad.onFullScreenHidden
	*/
	CocoonJS.Ad.showFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", arguments, true);
		}
	};

	/**
	* Refreshes the fullscreen.
	* @function
	*/
	CocoonJS.Ad.refreshFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", arguments, true);
		}
	};

	/**
	* Makes a request to preload a banner ad.
	* @function
	*/
	CocoonJS.Ad.preloadBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadBanner", arguments, true);
		}
	};

	/**
	* Makes a request to preload a full screen ad.
	* @function
	*/
	CocoonJS.Ad.preloadFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadFullScreen", arguments, true);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* @function
	* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.setRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", arguments, true);
		}
	};

	/**
	* Gets the rectangle representing the banner screen position.
	* @function
	* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.getRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", arguments);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* You can use this method if you want to have better control of the banner screen positioning.
	* @function
	* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
	*/
	CocoonJS.Ad.setBannerLayout = function(bannerLayout)
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", arguments, true);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide"); 

	/**
	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
	* The callback function does not receive any parameter.
	* @param {number} width The banner width
	* @param {number} height The banner height
	* @static
	* @event
	*/
	CocoonJS.Ad.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready"); 

})();

//////////////////////////////////////
// COCOONJS_STORE.JS                //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS In-App Purchase extension.
    * @namespace
    */
    CocoonJS.Store = {};

    CocoonJS.Store.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_STORE !== 'undefined';

	/**
	* The data structure that represents the information of a product in the store.
	* @namespace
	* @constructor
	* @param {string} The id of the product.
	* @param {string} The alias of the product.
	* @param {CocoonJS.Store.ProductType} The product type @see CocoonJS.Store.ProductType.
	* @param {string} The title of the product.
	* @param {string} The description of the product.
	* @param {string} The localized price of the product.
	* @param {string} The URL of the asset to be downloaded for this purchase.
	*/
	CocoonJS.Store.ProductInfo = function(productAlias, productId, productType, title, description, price, localizedPrice, downloadURL)
	{
		/**
		* The id of the product.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The alias of the product.
		* @field
		* @type string
		*/
		this.productAlias = productAlias;

		/**
		* The product type @see CocoonJS.Store.ProductType
		* @field
		* @type CocoonJS.Store.ProductType
		*/
		this.productType = productType;

		/**
		* The title of the product.
		* @field
		* @type string
		*/
		this.title = title;

		/**
		* The description of the product.
		* @field
		* @type string
		*/
		this.description = description;

		/**
		* The price of the product.
		* @field
		* @type string
		*/
		this.price = price;

		/**
		* The localized price of the product.
		* @field
		* @type string
		*/
		this.localizedPrice = localizedPrice;

		/**
		* The URL of the asset to be downloaded for this purchase.
		* @field
		* @type string
		*/
		this.downloadURL = downloadURL;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.ProductType = 
	{
		/**
		* A consumable product. See platform documentation for further information.
		*/
	    CONSUMABLE : 0,

		/**
		* A non-cunsumable product. . See platform documentation for further information.
		*/
	    NON_CONSUMABLE : 1,

	    /**
		* An auto-renewable subscription. See platform documentation for further information.
		*/
	    AUTO_RENEWABLE_SUBSCRIPTION : 2,

	    /**
		* A free subscription. See platform documentation for further information.
		*/
	    FREE_SUBSCRIPTION : 3,

	    /**
		* A non-renewable subscription. See platform documentation for further information.
		*/
	    NON_RENEWABLE_SUBSCRIPTION : 4
	};

	/**
    * The predefined possible store types.
    * @namespace 
    */
	CocoonJS.Store.StoreType = 
	{
		/**
		* Apple AppStore
		*/
	    APP_STORE : 0,

	    /**
	    * Android Play Store
	    */
	    PLAY_STORE : 1,

		/**
		* Mock Store
		*/
		MOCK_STORE : 2,

		/**
	    * Amazon AppStore
	    */
	    CHROME_STORE : 3,

	    /**
	    * Amazon AppStore
	    */
	    AMAZON_STORE : 4,

	    /**
	    * Nook Store
	    */
	    NOOK_STORE : 5
	};

	/**
	* The data structure that represents the information of a purchase.
	* @namespace
	* @constructor
	* @param {string} The transaction id of a purchase.
	* @param {string} The time when the purchase was done in seconds since 1970.
	* @param {CocoonJS.Store.PurchaseState} The state of the purchase. @see CocoonJS.Store.PurchaseState
	* @param {string} The product id related to this purchase.
	* @param {number} The number of products of the productId kind purchased in this transaction.
	*/
	CocoonJS.Store.PurchaseInfo = function(transactionId, purchaseTime, purchaseState, productId, quantity)
	{
		/**
		* The transaction id of a purchase.
		* @field
		* @type string
		*/
		this.transactionId = transactionId;

		/**
		* The time when the purchase was done in seconds since 1970.
		* @field
		* @type string
		*/
		this.purchaseTime = purchaseTime;

		/**
		* The state of the purchase. @see CocoonJS.Store.PurchaseState
		* @field
		* @type CocoonJS.Store.PurchaseState
		*/
		this.purchaseState = purchaseState;

		/**
		* The product id related to this purchase.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The number of products of the productId kind purchased in this transaction.
		* @field
		* @type number
		*/
		this.quantity = quantity;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.PurchaseState = 
	{
		/**
		* The product has been successfully purchased. The transaction has ended successfully.
		*/
	    PURCHASED : 0,

		/**
		* The purchase has been canceled.
		*/
	    CANCELED : 1,

	    /**
		* The purchase has been refunded.
		*/
	    REFUNDED : 2,

	    /**
		* The purchase (subscriptions only) has expired and is no longer valid.
		*/
	    EXPIRED : 3
	};

	/**
	* Gets the name of the native store implementation. 
	* @return {CocoonJS.Store.StoreType} The store type
	* @function
	*/ 
	CocoonJS.Store.getStoreType = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getStoreType", arguments);
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Store.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") 
        {
            parameters = {};
        }
        else
        {
        	if (parameters['managed'] !== undefined) parameters['remote'] = parameters['managed'];
        	if (parameters['sandbox'] !== undefined) parameters['debug'] = parameters['sandbox'];
        }

		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "requestInitialization", arguments, true);
		}
	};

	/**
	* Starts the Store Service. 
	* This will make the system to initialize the Store Service and probably Store callbacks will start to be received after calling this method so you should have set your event handler before calling this method so don't lose any callback.
	* @function
	*/ 
	CocoonJS.Store.start = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "start", arguments);
		}
	};

	/**
	* This method allows you to check is the  Store service is available in this platform. 
	* Not all iOS and Android devices will have the Store service available so you should check if it is before calling any other method.
	* @function
	* @return {boolean} True if the service is available and false otherwise.
	*/ 
	CocoonJS.Store.canPurchase = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "canPurchase", arguments);
		}
	};

	/**
	* Fetches the products from the CocoonJS Cloud Compiling service store configuration. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @deprecated You should now use fetchProductsFromStore. We don't support cloud products now.
	* @function
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromServer = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromServer", arguments, true);
		}
	};

	/**
	* Fetches the products information from the Store. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @function
	* @param {array} productIds An array with the ids of the products to retrieve information from.
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromStore = function(productIds)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromStore", arguments, true);
		}
	};

	/**
	* Finish a purchase transaction and removes the transaction from the transaction queue. 
	* This method must be called after a purchase finishes successfully and the  {@link CocoonJS.Store.onProductPurchaseCompleted} callback has been received. 
	* If the purchase includes some asset to download from an external server this method must be called after the asset has been successfully downloaded. 
	* If you do not finish the transaction because the asset has not been correctly downloaded the {@link CocoonJS.Store.onProductPurchaseStarted} method will be called again later on.
	* @function
	* @param {string} transactionId The transactionId of the purchase to finish.
	*/ 
	CocoonJS.Store.finishPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "finishPurchase", arguments, true);
		}
	};

	/**
	* Consumes a purchase. This makes that product to be purchasable again. 
	* @function
	* @param {string} transactionId The transaction Id of the purchase to consume.
	* @param {string} productId The product Id of the product to be consumed.
	*/ 
	CocoonJS.Store.consumePurchase = function(transactionId, productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "consumePurchase", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeature", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id showing a modal progress dialog. 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.puchaseProductModal = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModal", arguments, true);
		}
	};

	/**
	* Request the purchase of a product given it's product id showing a dialog with a preview of the product (title and description). 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProductModalWithPreview = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModalWithPreview", arguments, true);
		}
	};

	/**
	* Returns if a product has been already purchased or not. 
	* @function
	* @param {string} productId The product id or alias of the product to be checked.
	* @returns {boolean} A flag that indicates whether the product has been already purchased (true) or not (false).
	*/
	CocoonJS.Store.isProductPurchased = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "isFeaturePurchased", arguments);
		}
	};

	/**
	* Restores all the purchases from the platform's market. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchases", arguments, true);
		}
	};

	/**
	* Restores all the purchases from the platform's market showing a modal progress dialog. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchasesModal = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchasesModal", arguments, true);
		}
	};

	/**
	* Returns all the products available to be purchased.
	* @function
	* @returns {array} An array with  all the {@link CocoonJS.Store.ProductInfo} objects available for purchase.
	*/
	CocoonJS.Store.getProducts = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getProducts", arguments);
		}
	};

	/**
	* Adds a product to the products local DB. 
	* @function
	* @param {CocoonJS.Store.ProductInfo} product The product to be added to the local products DB.
	*/
	CocoonJS.Store.addProduct = function(product)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addProduct", arguments);
		}
	};

	/**
	* Removes a product from the products local DB given its productId. 
	* @function
	* @param {string} productId The product or alias of the product to be removed from the local products DB.
	*/
	CocoonJS.Store.removeProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removeProduct", arguments);
		}
	};

	/**
	* Returns all the locally stored purchases.
	* @function
	* @returns {array} An array with all the {@link CocoonJS.Store.PurchaseInfo} completed purchases.
	*/
	CocoonJS.Store.getPurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getPurchases", arguments);
		}
	};

	/**
	* Adds a purchase to the local purchases DB. 
	* @function
	* @param {CocoonJS.Store.StorePurchase} purchase The purchase to be added.
	*/ 
	CocoonJS.Store.addPurchase = function(purchase)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addPurchase", arguments);
		}
	};

	/**
	* Removes a purchase from the local purchases DB given it's transaction id. 
	* @function
	* @param {string} transactionId The id of the transaction to be removed.
	*/ 
	CocoonJS.Store.removePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removePurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase cancel. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be canceled.
	*/
	CocoonJS.Store.cancelPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "cancelPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase refundment. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be refunded.
	*/
	CocoonJS.Store.refundPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "refundPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase expiration. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be expired.
	*/
	CocoonJS.Store.expirePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "expirePurchase", arguments);
		}
	};

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onProductsFetchStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchStarted");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has completed.
    * The callback function receives a parameter with an the valid products array.
    * @static
    * @event
    * @param {array} validProducts An array of {@link CocoonJS.Store.ProductInfo} objects representing all the valid fetched products.
    */
	CocoonJS.Store.onProductsFetchCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onProductsFetchFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product starts.
    * The callback function receives a parameters with the information of the purchased product @see CocoonJS.Store.ProductInfo.
    * @static
	* @event
    * @param {string} productId The product id of the product being purchased.
    */
	CocoonJS.Store.onProductPurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseStarted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a request for purchase verification has been received from the Store.
    * The callback function receives two parameters, one with the productId of the purchased product and another one with a JSON object containing the data to be verified.
    * In Andorid this JSON object will containt two keys: signedData and signature. You will need that information to verify the purchase against the backend server.
    * @static
    * @event
    * @param {string} productId The product id of the product to be verified.
    * @param {string} data The string with the data to be verified.
    */
	CocoonJS.Store.onProductPurchaseVerificationRequestReceived = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseVerificationRequestReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product succeeds.
    * The callback function receives as parameter the information of the purchase {@see CocoonJS.Store.PurchaseInfo}.
    * @static
    * @event
    * @param {CocoonJS.Store.PurchaseInfo} purchaseInfo The purchase info.
    */
	CocoonJS.Store.onProductPurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product fails.
    * The callback function receives a parameters with the product id and an error message.
    * @static
    * @event
    * @param {string} productId The product id.
    * @param {string} msg The error message.
    */
	CocoonJS.Store.onProductPurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has completed.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onRestorePurchasesFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesFailed");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has started.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase being consumed.
    */
	CocoonJS.Store.onConsumePurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has completed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the consumed purchase.
    */
	CocoonJS.Store.onConsumePurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has failed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase that couldn't be consumed.
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onConsumePurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseFailed");

})();

//////////////////////////////////////
// COCOONJS_SOCIAL.JS               //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.Social = function(nativeExtensionName, extensionName)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + extensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationSucceed} event calls.
	     * @name OnRequestInitializationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when requestInitialization was called.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationFailed} event calls.
	     * @name OnRequestInitializationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when the requestInitialization function was called.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginSucceed} event calls.
	     * @name OnRequestLoginSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the user that logged in.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginFailed} event calls.
	     * @name OnRequestLoginFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user logs out.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onLogout = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLogout");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoSucceed} event calls.
	     * @name OnRequestUserInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the request user id.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoFailed} event calls.
	     * @name OnRequestUserInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLSucceed} event calls.
	     * @name OnRequestUserImageURLSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} imageURL The URL of the image of the requested user. 
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLFailed} event calls.
	     * @name OnRequestUserImageURLFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user the request was placed for.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosSucceed} event calls.
	     * @name OnRequestUserFriendsUserInfosSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user for whom the friend user infos where requested.
	     * @param {array} friendsInfo An array of {@link CocoonJS.Social.UserInfo} objects representing the information of the friends of the user.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info is successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosFailed} event calls.
	     * @name OnRequestUserFriendsUserInfosFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param 
	     * @param {string} userID The id of the user fro whom the friends infos were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationSucceed} event calls.
	     * @name OnRequestMessagePublicationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
 	     * @param {CocoonJS.Social.Message} message The message that has been published.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    * @param {CocoonJS.Social.Message} message The message that has been published.
	    */
		this.onRequestMessagePublicationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationFailed} event calls.
	     * @name OnRequestMessagePublicationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.Message} message The message that was supposed to be published.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestMessagePublicationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationFailed");

		/**
        * @ignore
        */
        this.on= function(event, callback) {
            event= "on"+event[0].toUpperCase()+event.substr(1);
            var signal= this[event];
            if (signal) {
                signal.addEventListener(callback);
            } else {
                console.error("SocialGaming service: '"+this.extensionName+"' does not understand '"+event+' signal.');
            }

            return this;
        };

	    return this;
	};

	CocoonJS.Social.prototype = {
        userInfo : null,
        userInfoCocoonJS : null,

        /**
        * @ignore
        */
        getUserInfo : function() {
            return this.userInfo;
        },

        /**
        * Returns the information of the currently logged in user.
        * @return {@link CocoonJS.Social.UserInfo}
        */
        getLoggedInUserInfo : function() {
            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLoggedInUserInfo", arguments);
            }
            else {
                return this.userInfoCocoonJS;
            }
        },

        /**
        * @ignore
        */
        setUserInfo : function( userInfo) {
            this.userInfo= userInfo;
        },

        /**
        * @ignore
        */
        setUserInfoCocoonJS : function( userInfoCocoonJS ) {
            this.userInfoCocoonJS = userInfoCocoonJS;
        },

		/**
        * Request initialization of the underlying social service.
        * @param {object} paramsObject A data structure to initialize the service. It will be dependable of the underlying service.
        * @see CocoonJS.Social.onRequestInitializationSucceed
        * @see CocoonJS.Social.onRequestInitializationFailed
        */
		requestInitialization : function(paramsObject) 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestInitialization", arguments, true);
			}
		},

		/**
        * Returns a flag to indicate if the underlying service has been initialized or not.
        * @return {boolean} If the underlying service had been initialized using the requestInitialization function call.
        */
		isInitialized : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isInitialized", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to log in the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Socual.onRequestLoginFailed
		*/
		requestLogin : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogin", arguments, true);
			}
		},

		/**
		* Request to log out of the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Social.onRequestLoginFailed
		* @see CocoonJS.Social.onLogout
		*/
		requestLogout : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogout", arguments, true);
			}
		},

		/**
		* Check if the user is logged in.
		* @return {boolean} true if the user is still logged in, false otherwise.
		*/
		isLoggedIn : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isLoggedIn", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Returns all the granted permissions for the current session.
		* @return {Array} An array containin the user granted permissions.
		*/
		getPermissions : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getPermissions", arguments);
			}
			else
			{
				return new Array();
			}
		},

		/**
		* Check if the user has granted the publish permission for the current session.
		* @return {boolean} true if the user has granted the publish permission for the current session, false otherwise.
		*/
		hasPublishPermission : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "hasPublishPermission", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to retrieve the current or a specific user's id. The request can be monitored using the {@link CocoonJS.Social.onUserInfoRequestSucceed} and {@link CocoonJS.Social.onUserInfoRequestFailed} event handlers.
		* @param {string} [userId] The id of the user to retireve the information from. If no userID is specified, the currently logged in user is assumed.
		* @see CocoonJS.Social.onRequestUserInfoSucceed
		* @see CocoonJS.Social.onRequestUserInfoFailed
		*/
		requestUserInfo : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserInfo", arguments, true);
			}
		},

		/**
		* Request to retrieve the Image of a user
		* @param {string} [userID] The id of the user to get the image for. If no userID is specified, the currently logged user is used.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}. If no value is specified, SMALL is used.
		* @see CocoonJS.Social.onRequestUserImageURLSucceed;
		* @see CocoonJS.Social.onRequestUserImageURLFailed;
		*/
		requestUserImageURL : function( imageSizeType, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserImageURL", arguments, true);
			}
		},

		/**
		* Request for the information of all the friends of the currently logged user.
		* @param {string} [userID] The id of the user to get the friends infos for. If no userID is specified, the currently logged user is used.
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosSucceed;
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosFailed;
		*/
		requestUserFriendsUserInfos : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserFriendsUserInfos", arguments, true);
			}
		},

		/**
		* Request the publication of a message using a dialog.
		* @param {CocoonJS.Social.Message} message A object representing the information to be published.
		* @see CocoonJS.Social.onRequestMessagePublicationSucceed
		* @see CocoonJS.Social.onRequestMessagePublicationFailed
		*/
		requestMessagePublicationWithDialog : function(message)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestMessagePublicationWithDialog", arguments, true);
			}
		}
	};

	/**
	* This structure represents the possible images to be obtained for a user in the social gaming extension.
	* @namespace
	*/
	CocoonJS.Social.ImageSizeType = 
	{
		/**
		* Represent a thumbnail like image size.
		*/
	    THUMB : "thumb",

		/**
		* Represents the small image size.
		*/
	    SMALL : "small",

		/**
		* Represents the medium image size.
		*/
	    MEDIUM : "medium",

		/**
		* Represents the large image size.
		*/
	    LARGE : "large"
	};

	/**
	* The data structure that represents the information of a user inside the social gaming extension.
	* @namespace
	* @constructor
	* @param {string} userID The id of the user.
	* @param {string} userName The user name of the user.
	*/
	CocoonJS.Social.UserInfo = function(userID, userName)
	{
		/**
		* The id of the user.
		* @field
		* @type string
		*/
		this.userID = userID;

		/**
		* The user name of the user.
		* @field
		* @type string
		*/
		this.userName = userName;
	};

	/**
	* This type represents a message to be published.
	* @namespace
	* @constructor
	* @param {string} message The message to be published.
	* @param {string} mediaURL An URL to a media (image, video, ...)
	* @param {string} linkURL An URL to add to the message so the user can click on that link to get more information.
	* @param {string} linkText The text that will appear in the message link.
	* @param {string} linkCaption The text caption that will appear in the message link.
	*/
	CocoonJS.Social.Message = function(message, mediaURL, linkURL, linkText, linkCaption)
	{
		/**
		* The message to be published.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* An URL to a media (image, video, ...)
		* @field
		* @type string
		*/
		this.mediaURL = mediaURL;

		/**
		* An URL to add to the message so the user can click on that link to get more information.
		* @field
		* @type string
		*/
		this.linkURL = linkURL;

		/**
		* The text that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkText = linkText;

		/**
		* The text caption that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkCaption = linkCaption;

		return this;
	};

})();

//////////////////////////////////////
// COCOONJS_SOCIALGAMING.JS         //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    if (!CocoonJS.Social)
		throw("The CocoonJS.Social object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social Gamming extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.SocialGaming = function(nativeExtensionName, extensionName)
	{
		CocoonJS.SocialGaming.superclass.constructor.call(this, nativeExtensionName, extensionName);

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed} event calls.
	     * @name OnRequestUserAndFriendsScoresSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} userAndFriendsScoreInfos An array of {@link CocoonJS.SocialGaming.UserScoreInfo} objects representing the information of the user's and friends' scores.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and friends scores request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed} event calls.
	     * @name OnRequestUserAndFriendsScoresFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score and friends scores were requested.
	     * @param {string} leadeboardID The id of the leaderboard for whom the score and friends scores were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and his/her friends scores request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreSucceed} event calls.
	     * @name OnRequestUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.UserScoreInfo} userScoreInfo The info of the user's score.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreFailed} event calls.
	     * @name OnRequestUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score was requested.
	     * @param {string} leaderboardID The id of the leaderboard for whom the score was requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreSucceed} event calls.
	     * @name OnSubmitUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score has been submitted.
	     * @param {string} leaderboardID The id of the leaderboard for which the score has been submitted.
	     * @param {number} score The score that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreFailed} event calls.
	     * @name OnSubmitUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score submition was requested.
	     * @param {string} leaderboadID The id of the leaderboard for which the score submition was requested.
	     * @param {number} score The score that was submitted and failed.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} event calls.
	     * @name OnRequestUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where requested.
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of the user's achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsFailed} event calls.
	     * @name OnRequestUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were requested.
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} event calls.
	     * @name OnRequestAllAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of all the achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsFailed} event calls.
	     * @name OnRequestAllAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoSucceed} event calls.
	     * @name OnRequestAchievementInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.AchievementInfo} achievementInfo A {@link CocoonJS.SocialGaming.AchievementInfo} object representing the information of the achievement.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoFailed} event calls.
	     * @name OnRequestAchievementInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} achievementID The id of the achievement for which the information retrieval was requested.
	     * @param {string} errorMessage The error message.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementSucceed} event calls.
	     * @name OnSubmitUserAchievementSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievement has been submitted.
	     * @param {string} achievementID The id of the achievement that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementFailed} event calls.
	     * @name OnSubmitUserAchievementFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievment was submitted.
	     * @param {string} achievementID The id of the achievement that was submitted.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsSucceed} event calls.
	     * @name OnResetUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were reset.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsFailed} event calls.
	     * @name OnResetUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where tried to be reset.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the users closes the achievements view.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onAchievementsViewFailed} event calls.
	     * @name OnAchievementsViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} errorMessage The message that describes why the call failed.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the achievements view failed to show.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnAchievementsViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewFailed");

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when achievements view shows successfully.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewClosed} event calls.
	     * @name OnLeaderboardViewClosedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewClosedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewFailed} event calls.
	     * @name OnLeaderboardViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewSucceed} event calls.
	     * @name OnLeaderboardViewSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewSucceed");

		return this;
	};

	CocoonJS.SocialGaming.prototype = 
	{
        abstractToSocialGamingAchievementMap : null,
        abstractToSocialGamingAchievementMapInverse : null,

        /**
        * @ignore
        */
        setAbstractToSocialGamingAchievementMap : function( map ) {
            this.abstractToSocialGamingAchievementMap= map;

            // build a reciprocal map.
            this.abstractToSocialGamingAchievementMapInverse= {};
            for( var id in map ) {
                if ( map.hasOwnProperty(id) ) {
                    this.abstractToSocialGamingAchievementMapInverse[ map[id] ]= id;
                }
            }
            return this;
        },

        /**
        * @ignore
        */
        getAbstractToSocialGamingAchievementTranslation : function( achievementID ) {
            /**
             * If a translation map for abstract in-game achievements has been set, translate achievementID from
             * abstract to SocialGamingService.
             */
            if (this.abstractToSocialGamingAchievementMap) {
                var socialGamingAchievementID = this.abstractToSocialGamingAchievementMap[achievementID];
                if (socialGamingAchievementID) {
                    console.log("Abstract achieventID='" + achievementID + "' turned to '" + socialGamingAchievementID + "'");
                    achievementID = socialGamingAchievementID;
                } else {
                    console.log("Something may be wrong: abstract achievementID: '" + achievementID + "' w/o translation.")
                }
            }

            return achievementID;
        },

		/**
		* Request to retrieve the scores of all friends of a given user.
		* @param {string} [leaderboardID] The id of the leaderboard to request the scores for.
		* @param {string} [userID] The id of the user. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed
		*/
		requestUserAndFriendsScores : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAndFriendsScores", arguments, true);
			}
		},

		/**
		* Request to retrieve the score of a user.
		* @param {string} [leaderboardID] The id of the scores leaderboard to retireve the score from. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to retireve the score from. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserScoreSucceed
		* @see CocoonJS.SocualGaming.onRequestUserScoreFailed
		*/
		requestUserScore : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserScore", arguments, true);
			}
		},

		/**
		* Request to the server the score of a user.
		* @param {number} [score] the score to submit
		* @param {string} [leaderboardID] The id of the scores leaderboard to submit the score to. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to submit the score for. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onSubmitUserScoreSucceed
		* @see CocoonJS.SocualGaming.onSubmitUserScoreFailed
		*/
		submitUserScore : function(score, leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserScore", arguments, true);
			}
		},
		/**
		* Shows the leaderboard using a platform dependant view.
		* @param {string} [leaderboardID] The id of the scores leaderboard to show the view for. If null or underfined is passed, the "leadeboard" id will be used.
		* @see CocoonJS.SocialGaming.onLeaderboardViewClosed
		*/
		showLeaderboardView : function(leaderboardID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showLeaderboardView", arguments, true);
			}
		},

		/**
		* Request to retrieve the user achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} and {@link CocoonJS.Social.onRequestUserAchievementsFailed} event handlers.
		* @param {string} [userID] The id of the user to retireve the achievements from. if null/undefined/"" is specified, the currently logged in user is assumed.
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsFailed
		*/
		requestUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve all the achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} and {@link CocoonJS.Social.onRequestAllAchievementsFailed} event handlers.
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsFailed
		*/
		requestAllAchievements : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAllAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve the information about an achievement. 
		* @param {string} achievementID The id of the achievement to get the information for.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}
		*/
		requestAchievementInfo : function(achievementID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAchievementInfo", arguments, true);
			}
		},

		/**
		* Submits an achievement to the server. If the process fails, the achievement is stored to submit it later.
		* @param {string} [achievementID] the achievement identifier
		* @param {number} [percentComplete] an optional number between 0 and 100 that indicates a completion percentage.
		* @see CocoonJS.SocialGaming.onSubmitAchievementSucceed
		* @see CocoonJS.SocualGaming.onSubmitAchievementFailed
		*/
        submitUserAchievement:function (achievementID, userID) {
            achievementID = this.getAbstractToSocialGamingAchievementTranslation(achievementID);

            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserAchievement", arguments, true);
            }
        },

		/**
		* Shows the achievements using a platform dependant view.
		* @see CocoonJS.SocialGaming.onAchievementsViewClosed
		*/
		showUserAchievementsView : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showUserAchievementsView", arguments, true);
			}
		},

		/**
		* Resets all the achievements of the current user
		* @param {string} [userID] The id of the user to reset the achievements for. If null/undefined/"", the logged in user is assumed.
		* @see CocoonJS.SocialGaming.onResetAchievementsSucceed
		* @see CocoonJS.SocualGaming.onResetAchievementsFailed
		*/
		resetUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "resetUserAchievements", arguments, true);
			}
		}
	};

	/**
    * @ignore
    */
	CocoonJS.extend(CocoonJS.SocialGaming, CocoonJS.Social);

	/**
	* The data structure that represents the information of the user score in the application.
	* @namespace
	* @constructor
	* @param {string} userID The user id.
	* @param {number} score The score of the user.
	* @param {string} userName The name of the user.
	* @param {string} imageURL The url of the user image.
	* @param {number} leaderboardID The id of the leaderboard the score belongs to.
	*/
	CocoonJS.SocialGaming.UserScoreInfo = function(userID, score, userName, imageURL, leaderboardID)
	{
		/**
		* The user id. 
		* @type string
		*/
		this.userID = userID;

		/**
		* The score of the user.
		* @type number
		*/
		this.score = score ? score : 0;

		/**
		* The name of the user.
		* @type string
		*/
        this.userName = userName;

		/**
		* The url of the user image.
		* @type string
		*/
        this.imageURL = imageURL;

        /**
		* The id of the leaderboard the score belongs to.
		* @type number
		*/
        this.leaderboardID = leaderboardID;
	};

	/**
	* The data structure that represents the information of an achievement in the application.
	* @namespace
	* @constructor
	* @param {string} achievementID The id of the achievement info.
	* @param {string} title The title of the achievement.
	* @param {string} description The description of the achievement.
	* @param {string} imageURL The url to the image representing the achievement.
	* @param {number} points The points value of the achievement
	*/
	CocoonJS.SocialGaming.AchievementInfo = function(achievementID, title, description, imageURL, points)
	{
		/**
		* The id of the achievement info.
		* @type string
		*/
		this.achievementID = achievementID;

		/**
		* The title of the achievement.
		* @type string
		*/
		this.title = title;

		/**
		* The description of the achievement.
		* @type string
		*/
		this.description = description;

		/**
		* The url to the image representing the achievement.
		* @type string
		*/
		this.imageURL = imageURL;

		/**
		* The points value of the achievement
		* @type number
		*/
		this.points = points ? points : 0;
	};

})();

/////////////////////////////////////////
// COCOONJS_SOCIALGAMING_GAMECENTER.JS //
/////////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.SocialGaming === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.SocialGaming object must exist and be valid before creating a Game Center extension object.");

	/**
	* This instance represents the extension object to access GameCenter related native functionalities.
	* The data structure for initialization: None.
	* @see CocoonJS.Social
	*/
	CocoonJS.SocialGaming.GameCenter = new CocoonJS.SocialGaming("IDTK_SRV_SOCIAL_GAMECENTER", "SocialGaming.GameCenter");
})();

//////////////////////////////
// COCOONJS_GAMEPAD.JS 		//
//////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the functionalities related to OUYA android gaming control.
     * @namespace
     */
    CocoonJS.Gamepad = {};

    CocoonJS.Gamepad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.Gamepad !== 'undefined';

    CocoonJS.Gamepad.Indices = {
        BUTTON_0                : 0, 
        BUTTON_1                : 1,
        BUTTON_2                : 2,
        BUTTON_3                : 3,
        BUTTON_LEFT_BUMPER      : 4,
        BUTTON_RIGHT_BUMPER     : 5,
        
        BUTTON_LEFT_TRIGGER     : 6,
        BUTTON_RIGHT_TRIGGER    : 7,
        
        BUTTON_LEFT_JOYSTICK    : 10,
        BUTTON_RIGHT_JOYSTICK   : 11,
        BUTTON_DPAD_UP          : 12,
        BUTTON_DPAD_DOWN        : 13,
        BUTTON_DPAD_LEFT        : 14,
        BUTTON_DPAD_RIGHT       : 15,
        BUTTON_MENU             : 16,
        
        AXE_LEFT_JOYSTICK_X     : 0,
        AXE_LEFT_JOYSTICK_Y     : 1,
        AXE_RIGHT_JOYSTICK_X    : 2,
        AXE_RIGHT_JOYSTICK_Y    : 3
    };

    // If the extension is present and the navigator does not provide the gamepad API:
    // 1.- Add the getGamepads function to the navigator object.
    // 2.- Replace the window add and remove event listener functions to call to the extension for the gamepad related events.
    var systemSupportsGamepads = navigator["getGamepads"] || navigator["webkitGetGamepads"];
    if (CocoonJS.Gamepad.nativeExtensionObjectAvailable && !systemSupportsGamepads)
    {
        navigator.getGamepads = function()
        {
            return window.ext.Gamepad.makeCall("getGamepads");
        };

        CocoonJS.Gamepad.originalWindowAddEventListener = window.addEventListener;
        CocoonJS.Gamepad.originalWindowRemoveEventListener = window.removeEventListener;

        window.addEventListener = function(eventName, callback)
        {
            console.log("The new window.addEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.addEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowAddEventListener.apply(window, argumentsArray);
            }
        };
        window.removeEventListener = function(eventName, callback)
        {
            console.log("The new window.removeEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.removeEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowRemoveEventListener.apply(window, argumentsArray);
            }
        };
    } 
    else if (systemSupportsGamepads) 
    {
        if (!navigator.getGamepads)
        {
            console.log("navigator.getGamepads does not exist.");
            if (navigator.webkitGetGamepads)
            {
                console.log("navigator.webkitGamepads exists, adding navigator.getGamepads to point to it.");
                navigator.getGamepads = navigator.webkitGetGamepads;
            }
            else
            {
                console.log("navigator.webkitGetGamepads does not exist either.");
            }
        }
    }
})();

//////////////////////////////
// COCOONJS_NOTIFICATION.JS //
//////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Notification extension.
    * @namespace
    */
    CocoonJS.Notification = {};

    CocoonJS.Notification.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_NOTIFICATION !== 'undefined';

	/**
	* The data structure that represents the information of a local notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {string} contentBody The body content to be showed in the expanded notification information.
	* @param {string} contentTitle The title to be showed in the expanded notification information.
	* @param {number} date Time in millisecs from 1970 when the notification will be fired.
	*/
	CocoonJS.Notification.LocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* (iOS only) The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData;

		/**
		* (Android only) The body content to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentBody !== undefined)
			this.contentBody = contentBody;
		else
			this.contentBody = "";

		/**
		* (Android only) The title to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentTitle !== undefined)
			this.contentTitle = contentTitle;
		else
			this.contentTitle = "";

		/**
		* Time in millisecs from 1970 when the local notification will be fired
		* @field
		* @type number
		*/
		var currentTime = new Date().getTime();
		if (scheduleTime !== undefined){
			this.scheduleTime = scheduleTime;
		}else{
			this.scheduleTime = currentTime;
		}
	};

	/**
	* The data structure that represents the information of a push notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {array} channels An array containing the channels names this notification will be delivered to.
	* @param {number} expirationTime A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	* @param {number} expirationTimeInterval An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	*/
	CocoonJS.Notification.PushNotification = function(message, soundEnabled, badgeNumber, userData, channels, expirationTime, expirationTimeInterval)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData

		/**
		* An array containing the channels names this notification will be delivered to.
		* @field
		* @type array
		*/
		this.channels = channels;

		/**
		* A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTime !== undefined)
			this.expirationTime = expirationTime;
		else
			this.expirationTime = 0;

		/**
		* An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTimeInterval !== undefined)
			this.expirationTimeInterval = expirationTimeInterval;
		else
			this.expirationTimeInterval = 0;
	};

	/**
	* Start processing received notifications. The user must call this method when the game is ready to process notifications. Notifications received before being prepared are stored and processed later.
	*/
	CocoonJS.Notification.start = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "start", arguments, true);
		}
	};


	/**
	* Register to be able to receive push notifications.
	* The registration process is controlled using the {@link CocoonJS.Notification.onRegisterForPushNotificationsSucceed} and {@link CocoonJS.Notification.onRegisterForPushNotificationsFailed} event handlers.
	* @function
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsSucceed}
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsFailed}
	*/
	CocoonJS.Notification.registerForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "registerForPushNotifications", arguments, true);
		}
	};

	/**
	* Unregister from receiving push notifications.
	* The unregistration process is controlled using the {@link CocoonJS.Notification.onUnregisterForPushNotificationsSucceed} event handler.
	* @function
	* @see CocoonJS.Notification.onUnregisterForPushNotificationsSucceed
	*/
	CocoonJS.Notification.unregisterForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unregisterForPushNotifications", arguments, true);
		}
	};

	/**
	* Cancel the last sent local notification.
	* The last sent local notification will be remove from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelLastSentLocalNotificiation = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments, true);
		}
	};

	/**
	* Cancel all sent local notifications.
	* All the notifications will ve removed from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelAllLocalNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelAllLocalNotifications", arguments, true);
		}
	};

	/**
	* Send a local notification.
	* @function
	* @param {CocoonJS.Notification.LocalNotification} localNotification The local notification to be sent.
	*/
	CocoonJS.Notification.sendLocalNotification = function(localNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendLocalNotification", arguments, true);
		}
	};

	/**
	* Subscribe to a channel in order to receive notifications targeted to that channel.
	* @function
	* @param {string} channel The channel id to subscribe to.
	*/
	CocoonJS.Notification.subscribeToChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "subscribe", arguments, true);
		}
	};

	/**
	* Unsubscribe from a channel in order to stop receiving notifications targeted to it.
	* @function
	* @param {string} channel The channel id to unsubscribe from.
	*/
	CocoonJS.Notification.unsubscribeFromChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unsubscribe", arguments, true);
		}
	};

	/**
	* Send a push notification.
	* @function
	* @param {CocoonJS.Notification.PushNotification} pushNotification The push notification object to be sent.
	* @see CocoonJS.Notification.onPushNotificationDeliverySucceed
	* @see CocoonJS.Notification.onPushNotificationDeliveryFailed
	*/
	CocoonJS.Notification.sendPushNotification = function(pushNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendPushNotification", arguments, true);
		}
	};

	/**
	* (iOS only) Set the badge number for this application.
	* This is useful if you want to modify the badge number set by a notification.
	* @function
	* @param {number} badgeNumber The number of the badge.
	*/
	CocoonJS.Notification.setBadgeNumber = function(badgeNumber)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "setBadgeNumber", arguments);
		}
	};

	/**
	* (iOS only) Returns the current badge number.
	* @function
	* @returns {number} The badge number.
	*/
	CocoonJS.Notification.getBadgeNumber = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getBadgeNumber", arguments);
		}
	};

	/**
	* Returns the last received user data from a Local notification.
	* @function
	* @returns {object} The last received user data from a Local notification.
	*/
	CocoonJS.Notification.getLastReceivedLocalNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedLocalNotificationData", arguments);
		}
	};

	/**
	* Returns the last received user data from a Push notification.
	* @function
	* @returns {object} The last received user data from a Push notification.
	*/
	CocoonJS.Notification.getLastReceivedPushNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedPushNotificationData", arguments);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notification succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @param {string} token The token (apid or device token) received at registration time.
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onRegisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceRegistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the unregistration for push notifications succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onUnregisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceUnregistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notifications fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onRegisterForPushNotificationsFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceFailedToRegister");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a push notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a local notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onLocalNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "localNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a notification is successfully delivered.
    * The callback function receives a parameter with the notificationId of the delivered notification.
    * @static
    * @event
    * @param {string} userData A string with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationDeliverySucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationSuccessfullyDelivered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the delivery of push a notification fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onPushNotificationDeliveryFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationDeliveryError");

})();

/////////////////
// PATHFIND.JS //
/////////////////

// Pathfind.js
// Written by Ashley Gullen
// Copyright (c) 2013 Scirra Ltd.

// A* pathfinding javascript implementation

(function() {
	
	var PF_CLEAR = 0;
	var PF_OBSTACLE = 32767;
	
	function node()
	{
		this.parent = null;
		
		this.x = 0;
		this.y = 0;

		this.f = 0;
		this.g = 0;
		this.h = 0;
	};
	
	var nodeCache = [];			// for recycling nodes
	
	function allocNode()
	{
		var ret;
		
		if (nodeCache.length)
			ret = nodeCache.pop();
		else
			ret = new node();
			
		ret.parent = null;
		ret.x = 0;
		ret.y = 0;
		ret.f = 0;
		ret.g = 0;
		ret.h = 0;
		return ret;
	};
	
	function freeNode(n)
	{
		if (nodeCache.length < 64000)
			nodeCache.push(n);
	};
	
	function resultNode(x_, y_)
	{
		this.x = x_ || 0;
		this.y = y_ || 0;
	};
	
	var resultNodeCache = [];			// for recycling resultNodes
	
	function allocResultNode()
	{
		if (resultNodeCache.length)
			return resultNodeCache.pop();
		else
			return new resultNode(0, 0);
	};
	
	function freeResultNode(n)
	{
		if (resultNodeCache.length < 10000)
			resultNodeCache.push(n);
	};
	
	var workersSupported = (typeof Worker !== "undefined");
	var isInWebWorker = (typeof document === "undefined");		// no DOM in a worker
	var myInstance = null;										// single pathfinder instance for worker
	
	if (isInWebWorker)
	{
		self.addEventListener("message", function (e)
		{
			var d = e.data;
			
			if (!d)
				return;		// could be empty postMessage() to start worker
			
			if (d.cmd === "init")
			{
				if (!myInstance)
					myInstance = new pathfinder();
					
				myInstance.init(d.hcells, d.vcells, d.data, d.diagonals);
			}
			else if (d.cmd === "find")
			{
				// receive a pathfind job, process it them dispatch result
				myInstance.pathEnd.parent = null;
				myInstance.targetX = d.endX;
				myInstance.targetY = d.endY;
				
				if (myInstance.doLongFindPath(d.startX, d.startY))
				{
					self.postMessage({ cmd: "result", pathList: myInstance.pathList });
				}
				else
				{
					self.postMessage({ cmd: "result", pathList: null });
				}
			}
			else if (d.cmd === "setdiag")
			{
				// update diagonalsEnabled flag
				myInstance.diagonalsEnabled = d.diagonals;
			}
			
		}, false);
	}
	
	function pathfinder()
	{
		this.hcells = 0;
		this.vcells = 0;
		
		this.pathEnd = allocNode();
		
		this.cells = null;
		this.openList = [];
		this.closedList = [];
		this.closedCache = {};
		this.pathList = [];
		
		this.currentNode = null;
		this.targetX = 0;
		this.targetY = 0;
		this.diagonalsEnabled = true;
		
		this.worker = null;
		this.workerQueue = [];		// jobs awaiting completion from worker in order of requests made
		this.workerRecycle = [];
		
		var self = this;
		var i, len;
		
		if (workersSupported && !isInWebWorker)
		{
			// Create worker and receive results of pathfind jobs from it
			this.worker = new Worker("pathfind.js");
			
			this.worker.addEventListener("message", function (e) {
			
				if (!e || !e.data)
					return;
				
				if (e.data.cmd === "result")
				{
					if (e.data.pathList)
					{
						for (i = 0, len = self.pathList.length; i < len; i++)
							freeResultNode(self.pathList[i]);
						
						self.pathList = e.data.pathList;
						self.workerQueue[0].success();
					}
					else
						self.workerQueue[0].fail();
						
					self.workerRecycle.push(self.workerQueue.shift());
				}
			}, false);
			
			this.worker.addEventListener("error", function (e) {
				console.error(e);
			}, false);
			
			this.worker.postMessage(null);
		}
	};
	
	pathfinder.prototype.init = function (hcells_, vcells_, data_, diagonals_)
	{
		this.hcells = hcells_;
		this.vcells = vcells_;
		this.cells = data_;
		this.diagonalsEnabled = diagonals_;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "init",
				hcells: hcells_,
				vcells: vcells_,
				diagonals: diagonals_,
				data: data_
			});
		}
	};
	
	pathfinder.prototype.isReady = function ()
	{
		return !!this.cells;
	};
	
	pathfinder.prototype.setDiagonals = function (d)
	{
		if (this.diagonalsEnabled === d)
			return;
		
		this.diagonalsEnabled = d;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "setdiag",
				diagonals: d,
			});
		}
	};
	
	pathfinder.prototype.at = function (x_, y_)
	{
		if (x_ < 0 || y_ < 0 || x_ >= this.hcells || y_ >= this.vcells)
			return PF_OBSTACLE;
			
		return this.cells[x_][y_];
	};
	
	pathfinder.prototype.findPath = function (startX, startY, endX, endY, successCallback, failCallback)
	{
		if (!this.cells)
		{
			// not yet initialised
			failCallback();
			return;
		}
		
		startX = Math.floor(startX);
		startY = Math.floor(startY);
		endX = Math.floor(endX);
		endY = Math.floor(endY);
		
		this.targetX = endX;
		this.targetY = endY;
		this.pathEnd.parent = null;
		
		// Check the box made by the start and dest cells.
		// If the complete box is empty, allow a direct move to target.
		var minX = Math.min(startX, endX);
		var maxX = Math.max(startX, endX);
		var minY = Math.min(startY, endY);
		var maxY = Math.max(startY, endY);
		
		// Path goes out of bounds: no calculable path
		if (minX < 0 || minY < 0 || maxX >= this.hcells || maxY >= this.vcells)
		{
			failCallback();
			return;
		}
		
		var x, y, i, len, c, h, n;

		if (this.diagonalsEnabled)
		{
			var canMoveDirect = true;
			
			for (x = minX; x <= maxX; x++)
			{
				for (y = minY; y <= maxY; y++)
				{
					if (this.cells[x][y] !== 0)
					{
						canMoveDirect = false;
						
						// Break both loops
						x = maxX + 1;
						break;
					}
				}
			}

			// A "direct" path is available (box is empty)
			if (canMoveDirect)
			{
				for (i = 0, len = this.pathList.length; i < len; i++)
					freeResultNode(this.pathList[i]);
				this.pathList.length = 0;
			
				this.pathEnd.x = endX;
				this.pathEnd.y = endY;
				this.pathEnd.parent = null;
				n = allocResultNode();
				n.x = endX;
				n.y = endY;
				this.pathList.push(n);
				successCallback();
				return;
			}
		}
		
		if (workersSupported)
		{
			// recycle objects in the worker queue
			if (this.workerRecycle.length)
				h = this.workerRecycle.pop();
			else
				h = {};
			
			h.success = successCallback;
			h.fail = failCallback;
			
			// dispatch the heavy lifting to the worker thread
			this.workerQueue.push(h);

			this.worker.postMessage({
				cmd: "find",
				startX: startX,
				startY: startY,
				endX: endX,
				endY: endY
			});
		}
		else
		{
			// no web worker support, just run on main thread
			if (this.doLongFindPath(startX, startY))
				successCallback();
			else
				failCallback();
		}
	};
		
	pathfinder.prototype.doLongFindPath = function (startX, startY)
	{
		var i, len, c, n, p, lastDir = 8, curDir = -1, addNode;
		for (i = 0, len = this.openList.length; i < len; i++)
			freeNode(this.openList[i]);
		for (i = 0, len = this.closedList.length; i < len; i++)
			freeNode(this.closedList[i]);
		for (i = 0, len = this.pathList.length; i < len; i++)
			freeResultNode(this.pathList[i]);
		this.openList.length = 0;
		this.closedList.length = 0;
		this.closedCache = {};
		this.pathList.length = 0;

		// Add the start node to the open list
		var startNode = allocNode();
		startNode.x = startX;
		startNode.y = startY;

		this.openList.push(startNode);
		var obsLeft = false, obsTop = false, obsRight = false, obsBottom = false;
		var diagonals = this.diagonalsEnabled;
		
		// While there are nodes on the open list
		while (this.openList.length)
		{
			// Move the best F value to closed list
			c = this.openList.shift();
			this.closedList.unshift(c);
			this.closedCache[((c.x << 16) + c.y).toString()] = true;

			// Are we there yet?
			if (c.x === this.targetX && c.y === this.targetY)
			{
				this.pathEnd.parent = c.parent;
				this.pathEnd.x = c.x;
				this.pathEnd.y = c.y;
				
				// Link up the whole path to an indexable array
				p = this.pathEnd;
				
				while (p)
				{
					// filter redundant nodes in straight lines
					if (this.pathList.length === 0)
					{
						addNode = true;
						
						if (p.parent)
						{
							lastDir = this.nodeDirection(p, p.parent);
							curDir = lastDir;
						}
					}
					else if (!p.parent)
						addNode = false;
					else 
					{
						curDir = this.nodeDirection(p, p.parent);
						addNode = (curDir !== lastDir);
					}
					
					if (addNode)
					{
						n = allocResultNode();
						n.x = p.x;
						n.y = p.y;
						this.pathList.unshift(n);
						lastDir = curDir;
					}
					
					p = p.parent;
				}
				
				return true;
			}

			// Get current node
			this.currentNode = c;
			var x = c.x;
			var y = c.y;
			
			var obsLeft = (this.at(x - 1, y) === PF_OBSTACLE);
			var obsTop = (this.at(x, y - 1) === PF_OBSTACLE);
			var obsRight = (this.at(x + 1, y) === PF_OBSTACLE);
			var obsBottom = (this.at(x, y + 1) === PF_OBSTACLE);

			// Check adjacent 8 nodes.  No diagonals allowed if either cell being crossed is obstacle.
			if (!obsLeft)
				this.addCellToOpenList(x - 1, y, 10);

			if (diagonals && !obsLeft && !obsTop)
				this.addCellToOpenList(x - 1, y - 1, 14);

			if (!obsTop)
				this.addCellToOpenList(x, y - 1, 10);

			if (diagonals && !obsTop && !obsRight)
				this.addCellToOpenList(x + 1, y - 1, 14);

			if (!obsRight)
				this.addCellToOpenList(x + 1, y, 10);

			if (diagonals && !obsRight && !obsBottom)
				this.addCellToOpenList(x + 1, y + 1, 14);

			if (!obsBottom)
				this.addCellToOpenList(x, y + 1, 10);

			if (diagonals && !obsBottom && !obsLeft)
				this.addCellToOpenList(x - 1, y + 1, 14);
		}
		
		return false;
	};
	
	pathfinder.prototype.insertToOpenList = function (c)
	{
		var i, len;
		
		// Needs to go at end
		if (c.f >= this.openList[this.openList.length - 1].f)
		{
			this.openList.push(c);
		}
		else
		{
			for (i = 0, len = this.openList.length; i < len; i++)
			{
				if (c.f < this.openList[i].f)
				{
					this.openList.splice(i, 0, c);
					break;
				}
			}
		}
	};
	
	pathfinder.prototype.addCellToOpenList = function (x_, y_, g_)
	{
		// Ignore if cell on closed list
		if (this.closedCache.hasOwnProperty(((x_ << 16) + y_).toString()))
			return;
		
		var i, len, c;
		
		// Cell costs can be increased by changing the number in the map
		var curCellCost = this.at(x_, y_);

		// Is this cell already on the open list?
		for (i = 0, len = this.openList.length; i < len; i++)
		{
			c = this.openList[i];
			
			if (x_ === c.x && y_ === c.y)
			{
				// Is this a better path?
				if (this.currentNode.g + g_ + curCellCost < c.g)
				{
					// Update F, G and H and update parent
					c.parent = this.currentNode;
					c.g = this.currentNode.g + g_ + curCellCost;
					c.h = this.estimateH(c.x, c.y);
					c.f = c.g + c.h;

					// This node's F has changed:  Delete it then re-insert it in the right place

					if (this.openList.length === 1)
					{
						// no need to remove then re-insert same node, just leave it there
						return;
					}
					
					this.openList.splice(i, 1);
					this.insertToOpenList(c);
				}

				return;
			}
		}

		// Not on the open list; add it in the right place
		c = allocNode();
		c.x = x_;
		c.y = y_;
		c.h = this.estimateH(x_, y_);
		c.g = this.currentNode.g + g_ + curCellCost;
		c.f = c.h + c.g;
		c.parent = this.currentNode;

		// Insert this node sorted in the open list
		// The loop below won't add new largest F values
		if (!this.openList.length)
		{
			this.openList.push(c);
			return;
		}
		
		this.insertToOpenList(c);
	};
	
	function quickAbs(x)
	{
		return x < 0 ? -x : x;
	};
	
	pathfinder.prototype.estimateH = function (x_, y_)
	{
		var dx = quickAbs(x_ - this.targetX);
		var dy = quickAbs(y_ - this.targetY);

		return dx * 10 + dy * 10;
	};
	
	pathfinder.prototype.nodeDirection = function (a, b)
	{
		var ax = a.x;
		var ay = a.y;
		var bx = b.x;
		var by = b.y;

		if (ax === bx)
		{
			if (by > ay) return 6;
			if (by < ay) return 2;
			if (ay == by) return 8;
		}
		else if (ay === by)
		{
			if (bx > ax) return 4;
			if (by < ax) return 0;
		}
		else
		{
			if (bx < ax && by < ay) return 1;
			if (bx > ax && by < ay) return 3;
			if (bx < ax && by > ay) return 7;
			if (bx > ax && by > ay) return 5;
		}
		return 8;
	};
	
	if (!isInWebWorker)
	{
		window.PF_CLEAR = PF_CLEAR;
		window.PF_OBSTACLE = PF_OBSTACLE;
		window.Pathfinder = pathfinder;
		
		window.ResultNode = resultNode;
		window.allocResultNode = allocResultNode;
		window.freeResultNode = freeResultNode;
	}

})();
(function() {
'use strict';var cr={plugins_:{},behaviors:{}};"function"!==typeof Object.getPrototypeOf&&(Object.getPrototypeOf="object"===typeof"test".__proto__?function(a){return a.__proto__}:function(a){return a.constructor.prototype});
(function(){function a(a,b){this.x=a;this.y=b;cr.seal(this)}function b(a,b,c,d){this.set(a,b,c,d);cr.seal(this)}function c(){this.bly=this.blx=this.bry=this.brx=this.try_=this.trx=this.tly=this.tlx=0;cr.seal(this)}function d(a,b,c,d){a<b?c<d?(n=a<c?a:c,p=b>d?b:d):(n=a<d?a:d,p=b>c?b:c):c<d?(n=b<c?b:c,p=a>d?a:d):(n=b<d?b:d,p=a>c?a:c)}function e(){this.items=this.s=null;this.item_count=0;s&&(this.s=new Set);this.values_cache=[];this.cache_valid=!0;cr.seal(this)}function h(a){q[t++]=a}function f(){this.sum=
this.t=this.y=this.c=0;cr.seal(this)}function l(a){this.pts_cache=[];this.bboxBottom=this.bboxRight=this.bboxTop=this.bboxLeft=0;this.convexpolys=null;this.set_pts(a);cr.seal(this)}function k(a,b){this.cellwidth=a;this.cellheight=b;this.cells={}}function g(a,b,c){var d;k.prototype.totalCellCount++;return u.length?(d=u.pop(),d.grid=a,d.x=b,d.y=c,d):new cr.GridCell(a,b,c)}function m(a,b,c){this.grid=a;this.x=b;this.y=c;this.objects=new cr.ObjectSet}cr.logexport=function(a){window.console&&window.console.log&&
window.console.log(a)};cr.seal=function(a){return a};cr.freeze=function(a){return a};cr.is_undefined=function(a){return"undefined"===typeof a};cr.is_number=function(a){return"number"===typeof a};cr.is_string=function(a){return"string"===typeof a};cr.isPOT=function(a){return 0<a&&0===(a-1&a)};cr.nextHighestPowerOfTwo=function(a){--a;for(var b=1;32>b;b<<=1)a|=a>>b;return a+1};cr.abs=function(a){return 0>a?-a:a};cr.max=function(a,b){return a>b?a:b};cr.min=function(a,b){return a<b?a:b};cr.PI=Math.PI;
cr.round=function(a){return a+0.5|0};cr.floor=function(a){return 0<=a?a|0:(a|0)-1};cr.ceil=function(a){var b=a|0;return b===a?b:b+1};a.prototype.offset=function(a,b){this.x+=a;this.y+=b;return this};a.prototype.mul=function(a,b){this.x*=a;this.y*=b;return this};cr.vector2=a;cr.segments_intersect=function(a,b,c,d,e,t,h,g){var f,k,l,m;a<c?(k=a,f=c):(k=c,f=a);e<h?(m=e,l=h):(m=h,l=e);if(f<m||k>l)return!1;b<d?(k=b,f=d):(k=d,f=b);t<g?(m=t,l=g):(m=g,l=t);if(f<m||k>l)return!1;f=e-a+h-c;k=t-b+g-d;a=c-a;b=
d-b;e=h-e;t=g-t;g=cr.abs(b*e-t*a);return cr.abs(e*k-t*f)>g?!1:cr.abs(a*k-b*f)<=g};b.prototype.set=function(a,b,c,d){this.left=a;this.top=b;this.right=c;this.bottom=d};b.prototype.copy=function(a){this.left=a.left;this.top=a.top;this.right=a.right;this.bottom=a.bottom};b.prototype.width=function(){return this.right-this.left};b.prototype.height=function(){return this.bottom-this.top};b.prototype.offset=function(a,b){this.left+=a;this.top+=b;this.right+=a;this.bottom+=b;return this};b.prototype.normalize=
function(){var a=0;this.left>this.right&&(a=this.left,this.left=this.right,this.right=a);this.top>this.bottom&&(a=this.top,this.top=this.bottom,this.bottom=a)};b.prototype.intersects_rect=function(a){return!(a.right<this.left||a.bottom<this.top||a.left>this.right||a.top>this.bottom)};b.prototype.intersects_rect_off=function(a,b,c){return!(a.right+b<this.left||a.bottom+c<this.top||a.left+b>this.right||a.top+c>this.bottom)};b.prototype.contains_pt=function(a,b){return a>=this.left&&a<=this.right&&b>=
this.top&&b<=this.bottom};b.prototype.equals=function(a){return this.left===a.left&&this.top===a.top&&this.right===a.right&&this.bottom===a.bottom};cr.rect=b;c.prototype.set_from_rect=function(a){this.tlx=a.left;this.tly=a.top;this.trx=a.right;this.try_=a.top;this.brx=a.right;this.bry=a.bottom;this.blx=a.left;this.bly=a.bottom};c.prototype.set_from_rotated_rect=function(a,b){if(0===b)this.set_from_rect(a);else{var c=Math.sin(b),d=Math.cos(b),e=a.left*c,t=a.top*c,h=a.right*c,c=a.bottom*c,g=a.left*
d,f=a.top*d,k=a.right*d,d=a.bottom*d;this.tlx=g-t;this.tly=f+e;this.trx=k-t;this.try_=f+h;this.brx=k-c;this.bry=d+h;this.blx=g-c;this.bly=d+e}};c.prototype.offset=function(a,b){this.tlx+=a;this.tly+=b;this.trx+=a;this.try_+=b;this.brx+=a;this.bry+=b;this.blx+=a;this.bly+=b;return this};var n=0,p=0;c.prototype.bounding_box=function(a){d(this.tlx,this.trx,this.brx,this.blx);a.left=n;a.right=p;d(this.tly,this.try_,this.bry,this.bly);a.top=n;a.bottom=p};c.prototype.contains_pt=function(a,b){var c=this.trx-
this.tlx,d=this.try_-this.tly,e=this.brx-this.tlx,t=this.bry-this.tly,h=a-this.tlx,g=b-this.tly,f=c*c+d*d,k=c*e+d*t,d=c*h+d*g,l=e*e+t*t,m=e*h+t*g,u=1/(f*l-k*k),c=(l*d-k*m)*u,f=(f*m-k*d)*u;if(0<=c&&0<f&&1>c+f)return!0;c=this.blx-this.tlx;d=this.bly-this.tly;f=c*c+d*d;k=c*e+d*t;d=c*h+d*g;u=1/(f*l-k*k);c=(l*d-k*m)*u;f=(f*m-k*d)*u;return 0<=c&&0<f&&1>c+f};c.prototype.at=function(a,b){if(b)switch(a){case 0:return this.tlx;case 1:return this.trx;case 2:return this.brx;case 3:return this.blx;case 4:return this.tlx;
default:return this.tlx}else switch(a){case 0:return this.tly;case 1:return this.try_;case 2:return this.bry;case 3:return this.bly;case 4:return this.tly;default:return this.tly}};c.prototype.midX=function(){return(this.tlx+this.trx+this.brx+this.blx)/4};c.prototype.midY=function(){return(this.tly+this.try_+this.bry+this.bly)/4};c.prototype.intersects_segment=function(a,b,c,d){if(this.contains_pt(a,b)||this.contains_pt(c,d))return!0;var e,t,h,g,f;for(f=0;4>f;f++)if(e=this.at(f,!0),t=this.at(f,!1),
h=this.at(f+1,!0),g=this.at(f+1,!1),cr.segments_intersect(a,b,c,d,e,t,h,g))return!0;return!1};c.prototype.intersects_quad=function(a){var b=a.midX(),c=a.midY();if(this.contains_pt(b,c))return!0;b=this.midX();c=this.midY();if(a.contains_pt(b,c))return!0;var d,e,t,f,h,g,k,l;for(k=0;4>k;k++)for(l=0;4>l;l++)if(b=this.at(k,!0),c=this.at(k,!1),d=this.at(k+1,!0),e=this.at(k+1,!1),t=a.at(l,!0),f=a.at(l,!1),h=a.at(l+1,!0),g=a.at(l+1,!1),cr.segments_intersect(b,c,d,e,t,f,h,g))return!0;return!1};cr.quad=c;cr.RGB=
function(a,b,c){return Math.max(Math.min(a,255),0)|Math.max(Math.min(b,255),0)<<8|Math.max(Math.min(c,255),0)<<16};cr.GetRValue=function(a){return a&255};cr.GetGValue=function(a){return(a&65280)>>8};cr.GetBValue=function(a){return(a&16711680)>>16};cr.shallowCopy=function(a,b,c){for(var d in b)b.hasOwnProperty(d)&&(a[d]=b[d]);return a};cr.arrayRemove=function(a,b){var c,d;b=cr.floor(b);if(!(0>b||b>=a.length))if(0===b)a.shift();else if(b===a.length-1)a.pop();else{c=b;for(d=a.length-1;c<d;c++)a[c]=a[c+
1];a.length=d}};cr.shallowAssignArray=function(a,b){a.length=b.length;var c,d;c=0;for(d=b.length;c<d;c++)a[c]=b[c]};cr.appendArray=function(a,b){a.push.apply(a,b)};cr.arrayFindRemove=function(a,b){var c=a.indexOf(b);-1!==c&&cr.arrayRemove(a,c)};cr.clamp=function(a,b,c){return a<b?b:a>c?c:a};cr.to_radians=function(a){return a/(180/cr.PI)};cr.to_degrees=function(a){return 180/cr.PI*a};cr.clamp_angle_degrees=function(a){a%=360;0>a&&(a+=360);return a};cr.clamp_angle=function(a){a%=2*cr.PI;0>a&&(a+=2*
cr.PI);return a};cr.to_clamped_degrees=function(a){return cr.clamp_angle_degrees(cr.to_degrees(a))};cr.to_clamped_radians=function(a){return cr.clamp_angle(cr.to_radians(a))};cr.angleTo=function(a,b,c,d){return Math.atan2(d-b,c-a)};cr.angleDiff=function(a,b){if(a===b)return 0;var c=Math.sin(a),d=Math.cos(a),e=Math.sin(b),t=Math.cos(b),c=c*e+d*t;return 1<=c?0:-1>=c?cr.PI:Math.acos(c)};cr.angleRotate=function(a,b,c){var d=Math.sin(a),e=Math.cos(a),t=Math.sin(b),f=Math.cos(b);return Math.acos(d*t+e*
f)>c?0<e*t-d*f?cr.clamp_angle(a+c):cr.clamp_angle(a-c):cr.clamp_angle(b)};cr.angleClockwise=function(a,b){var c=Math.sin(a),d=Math.cos(a),e=Math.sin(b),t=Math.cos(b);return 0>=d*e-c*t};cr.rotatePtAround=function(a,b,c,d,e,t){if(0===c)return t?a:b;var f=Math.sin(c);c=Math.cos(c);a-=d;b-=e;var h=a*f;a=a*c-b*f;b=b*c+h;return t?a+d:b+e};cr.distanceTo=function(a,b,c,d){a=c-a;b=d-b;return Math.sqrt(a*a+b*b)};cr.xor=function(a,b){return!a!==!b};cr.lerp=function(a,b,c){return a+(b-a)*c};cr.unlerp=function(a,
b,c){return a===b?0:(c-a)/(b-a)};cr.anglelerp=function(a,b,c){var d=cr.angleDiff(a,b);return cr.angleClockwise(b,a)?a+d*c:a-d*c};cr.hasAnyOwnProperty=function(a){for(var b in a)if(a.hasOwnProperty(b))return!0;return!1};cr.wipe=function(a){for(var b in a)a.hasOwnProperty(b)&&delete a[b]};var r=+new Date;cr.performance_now=function(){if("undefined"!==typeof window.performance){var a=window.performance;if("undefined"!==typeof a.now)return a.now();if("undefined"!==typeof a.webkitNow)return a.webkitNow();
if("undefined"!==typeof a.mozNow)return a.mozNow();if("undefined"!==typeof a.msNow)return a.msNow()}return Date.now()-r};var s=("undefined"===typeof window||!window.c2ejecta)&&"undefined"!==typeof Set&&"undefined"!==typeof Set.prototype.forEach;e.prototype.contains=function(a){return this.isEmpty()?!1:s?this.s.has(a):this.items&&this.items.hasOwnProperty(a)};e.prototype.add=function(a){if(s)this.s.has(a)||(this.s.add(a),this.cache_valid=!1);else{var b=a.toString(),c=this.items;c?c.hasOwnProperty(b)||
(c[b]=a,this.item_count++,this.cache_valid=!1):(this.items={},this.items[b]=a,this.item_count=1,this.cache_valid=!1)}};e.prototype.remove=function(a){if(!this.isEmpty())if(s)this.s.has(a)&&(this.s["delete"](a),this.cache_valid=!1);else if(this.items){a=a.toString();var b=this.items;b.hasOwnProperty(a)&&(delete b[a],this.item_count--,this.cache_valid=!1)}};e.prototype.clear=function(){this.isEmpty()||(s?this.s.clear():(this.items=null,this.item_count=0),this.values_cache.length=0,this.cache_valid=
!0)};e.prototype.isEmpty=function(){return 0===this.count()};e.prototype.count=function(){return s?this.s.size:this.item_count};var q=null,t=0;e.prototype.update_cache=function(){if(!this.cache_valid){if(s)this.values_cache.length=this.s.size,q=this.values_cache,t=0,this.s.forEach(h),q=null,t=0;else{var a=this.values_cache;a.length=this.item_count;var b,c=0,d=this.items;if(d)for(b in d)d.hasOwnProperty(b)&&(a[c++]=d[b])}this.cache_valid=!0}};e.prototype.valuesRef=function(){this.update_cache();return this.values_cache};
cr.ObjectSet=e;f.prototype.add=function(a){this.y=a-this.c;this.t=this.sum+this.y;this.c=this.t-this.sum-this.y;this.sum=this.t};f.prototype.reset=function(){this.sum=this.t=this.y=this.c=0};cr.KahanAdder=f;cr.regexp_escape=function(a){return a.replace(/[-[\]{}()*+?.,\\^$|#\s]/g,"\\$&")};l.prototype.set_pts=function(a){this.pts_array=a;this.pts_count=a.length/2;this.pts_cache.length=a.length;this.cache_height=this.cache_width=-1;this.cache_angle=0};l.prototype.is_empty=function(){return!this.pts_array.length};
l.prototype.update_bbox=function(){for(var a=this.pts_cache,b=a[0],c=b,d=a[1],e=d,t,f,h=1,g=this.pts_count;h<g;++h)f=2*h,t=a[f],f=a[f+1],t<b&&(b=t),t>c&&(c=t),f<d&&(d=f),f>e&&(e=f);this.bboxLeft=b;this.bboxRight=c;this.bboxTop=d;this.bboxBottom=e};l.prototype.set_from_rect=function(a,b,c){this.pts_cache.length=8;this.pts_count=4;var d=this.pts_cache;d[0]=a.left-b;d[1]=a.top-c;d[2]=a.right-b;d[3]=a.top-c;d[4]=a.right-b;d[5]=a.bottom-c;d[6]=a.left-b;d[7]=a.bottom-c;this.cache_width=a.right-a.left;this.cache_height=
a.bottom-a.top;this.update_bbox()};l.prototype.set_from_quad=function(a,b,c,d,e){this.pts_cache.length=8;this.pts_count=4;var t=this.pts_cache;t[0]=a.tlx-b;t[1]=a.tly-c;t[2]=a.trx-b;t[3]=a.try_-c;t[4]=a.brx-b;t[5]=a.bry-c;t[6]=a.blx-b;t[7]=a.bly-c;this.cache_width=d;this.cache_height=e;this.update_bbox()};l.prototype.set_from_poly=function(a){this.pts_count=a.pts_count;cr.shallowAssignArray(this.pts_cache,a.pts_cache);this.bboxLeft=a.bboxLeft;this.bboxTop-a.bboxTop;this.bboxRight=a.bboxRight;this.bboxBottom=
a.bboxBottom};l.prototype.cache_poly=function(a,b,c){if(this.cache_width!==a||this.cache_height!==b||this.cache_angle!==c){this.cache_width=a;this.cache_height=b;this.cache_angle=c;var d,e,t,f,h,g=0,k=1,l=this.pts_array,m=this.pts_cache;0!==c&&(g=Math.sin(c),k=Math.cos(c));c=0;for(t=this.pts_count;c<t;c++)d=2*c,e=d+1,f=l[d]*a,h=l[e]*b,m[d]=f*k-h*g,m[e]=h*k+f*g;this.update_bbox()}};l.prototype.contains_pt=function(a,b){var c=this.pts_cache;if(a===c[0]&&b===c[1])return!0;var d,e,t,f=this.pts_count,
h=this.bboxLeft-110,g=this.bboxTop-101,k=this.bboxRight+131,l=this.bboxBottom+120,m,u,n=0,C=0;for(d=0;d<f;d++)e=2*d,t=(d+1)%f*2,m=c[e],e=c[e+1],u=c[t],t=c[t+1],cr.segments_intersect(h,g,a,b,m,e,u,t)&&n++,cr.segments_intersect(k,l,a,b,m,e,u,t)&&C++;return 1===n%2||1===C%2};l.prototype.intersects_poly=function(a,b,c){var d=a.pts_cache,e=this.pts_cache;if(this.contains_pt(d[0]+b,d[1]+c)||a.contains_pt(e[0]-b,e[1]-c))return!0;var t,f,h,g,k,l,m,u,n,C,s,r;t=0;for(g=this.pts_count;t<g;t++)for(f=2*t,h=(t+
1)%g*2,u=e[f],f=e[f+1],n=e[h],C=e[h+1],h=0,m=a.pts_count;h<m;h++)if(k=2*h,l=(h+1)%m*2,s=d[k]+b,k=d[k+1]+c,r=d[l]+b,l=d[l+1]+c,cr.segments_intersect(u,f,n,C,s,k,r,l))return!0;return!1};l.prototype.intersects_segment=function(a,b,c,d,e,t){var f=this.pts_cache;if(this.contains_pt(c-a,d-b))return!0;var h,g,k,l,m,u;h=0;for(g=this.pts_count;h<g;h++)if(k=2*h,l=(h+1)%g*2,m=f[k]+a,k=f[k+1]+b,u=f[l]+a,l=f[l+1]+b,cr.segments_intersect(c,d,e,t,m,k,u,l))return!0;return!1};l.prototype.mirror=function(a){var b,
c,d;b=0;for(c=this.pts_count;b<c;++b)d=2*b,this.pts_cache[d]=2*a-this.pts_cache[d]};l.prototype.flip=function(a){var b,c,d;b=0;for(c=this.pts_count;b<c;++b)d=2*b+1,this.pts_cache[d]=2*a-this.pts_cache[d]};l.prototype.diag=function(){var a,b,c,d,e;a=0;for(b=this.pts_count;a<b;++a)c=2*a,d=c+1,e=this.pts_cache[c],this.pts_cache[c]=this.pts_cache[d],this.pts_cache[d]=e};cr.CollisionPoly=l;k.prototype.totalCellCount=0;k.prototype.getCell=function(a,b,c){var d;d=this.cells[a];return d?(d=d[b])?d:c?(d=g(this,
a,b),this.cells[a][b]=d):null:c?(d=g(this,a,b),this.cells[a]={},this.cells[a][b]=d):null};k.prototype.XToCell=function(a){return cr.floor(a/this.cellwidth)};k.prototype.YToCell=function(a){return cr.floor(a/this.cellheight)};k.prototype.update=function(a,b,c){var d,e,t,f,h;if(b)for(d=b.left,e=b.right;d<=e;++d)for(t=b.top,f=b.bottom;t<=f;++t)if(!c||!c.contains_pt(d,t))if(h=this.getCell(d,t,!1))h.remove(a),h.isEmpty()&&(k.prototype.totalCellCount--,h.objects.clear(),1E3>u.length&&u.push(h),this.cells[d][t]=
null);if(c)for(d=c.left,e=c.right;d<=e;++d)for(t=c.top,f=c.bottom;t<=f;++t)b&&b.contains_pt(d,t)||this.getCell(d,t,!0).insert(a)};k.prototype.queryRange=function(a,b){var c,d,e,t,f,h;c=this.XToCell(a.left);e=this.YToCell(a.top);d=this.XToCell(a.right);for(f=this.YToCell(a.bottom);c<=d;++c)for(t=e;t<=f;++t)(h=this.getCell(c,t,!1))&&h.dump(b)};cr.SparseGrid=k;var u=[];m.prototype.isEmpty=function(){return this.objects.isEmpty()};m.prototype.insert=function(a){this.objects.add(a)};m.prototype.remove=
function(a){this.objects.remove(a)};m.prototype.dump=function(a){cr.appendArray(a,this.objects.valuesRef())};cr.GridCell=m;var C="lighter xor copy destination-over source-in destination-in source-out destination-out source-atop destination-atop".split(" ");cr.effectToCompositeOp=function(a){return 0>=a||11<=a?"source-over":C[a-1]};cr.setGLBlend=function(a,b,c){if(c)switch(a.srcBlend=c.ONE,a.destBlend=c.ONE_MINUS_SRC_ALPHA,b){case 1:a.srcBlend=c.ONE;a.destBlend=c.ONE;break;case 3:a.srcBlend=c.ONE;
a.destBlend=c.ZERO;break;case 4:a.srcBlend=c.ONE_MINUS_DST_ALPHA;a.destBlend=c.ONE;break;case 5:a.srcBlend=c.DST_ALPHA;a.destBlend=c.ZERO;break;case 6:a.srcBlend=c.ZERO;a.destBlend=c.SRC_ALPHA;break;case 7:a.srcBlend=c.ONE_MINUS_DST_ALPHA;a.destBlend=c.ZERO;break;case 8:a.srcBlend=c.ZERO;a.destBlend=c.ONE_MINUS_SRC_ALPHA;break;case 9:a.srcBlend=c.DST_ALPHA;a.destBlend=c.ONE_MINUS_SRC_ALPHA;break;case 10:a.srcBlend=c.ONE_MINUS_DST_ALPHA,a.destBlend=c.SRC_ALPHA}};cr.round6dp=function(a){return cr.round(1E6*
a)/1E6};cr.equals_nocase=function(a,b){return"string"!==typeof a||"string"!==typeof b||a.length!==b.length?!1:a===b?!0:a.toLowerCase()===b.toLowerCase()}})();
(function(){function a(a){if(a&&(a.getContext||a.dc)&&!a.c2runtime){a.c2runtime=this;var b=this;this.isCrosswalk=/crosswalk/i.test(navigator.userAgent)||/xwalk/i.test(navigator.userAgent)||!("undefined"===typeof window.c2isCrosswalk||!window.c2isCrosswalk);this.isPhoneGap=!this.isCrosswalk&&"undefined"!==typeof window.device&&("undefined"!==typeof window.device.cordova||"undefined"!==typeof window.device.phonegap);this.isDirectCanvas=!!a.dc;this.isAppMobi="undefined"!==typeof window.AppMobi||this.isDirectCanvas;
this.isCocoonJs=!!window.c2cocoonjs;this.isEjecta=!!window.c2ejecta;this.isCocoonJs&&(CocoonJS.App.onSuspended.addEventListener(function(){b.setSuspended(!0)}),CocoonJS.App.onActivated.addEventListener(function(){b.setSuspended(!1)}));this.isEjecta&&(document.addEventListener("pagehide",function(){b.setSuspended(!0)}),document.addEventListener("pageshow",function(){b.setSuspended(!1)}),document.addEventListener("resize",function(){b.setSize(window.innerWidth,window.innerHeight)}));this.isDomFree=
this.isDirectCanvas||this.isCocoonJs||this.isEjecta;this.isTizen=/tizen/i.test(navigator.userAgent);this.isAndroid=/android/i.test(navigator.userAgent)&&!this.isTizen;this.isIE=/msie/i.test(navigator.userAgent)||/trident/i.test(navigator.userAgent);this.isiPhone=/iphone/i.test(navigator.userAgent)||/ipod/i.test(navigator.userAgent);this.isiPad=/ipad/i.test(navigator.userAgent);this.isiOS=this.isiPhone||this.isiPad||this.isEjecta;this.isiPhoneiOS6=this.isiPhone&&/os\s6/i.test(navigator.userAgent);
this.isChrome=/chrome/i.test(navigator.userAgent)||/chromium/i.test(navigator.userAgent);this.isAmazonWebApp=/amazonwebappplatform/i.test(navigator.userAgent);this.isFirefox=/firefox/i.test(navigator.userAgent);this.isSafari=!this.isChrome&&/safari/i.test(navigator.userAgent);this.isWindows=/windows/i.test(navigator.userAgent);this.isNodeWebkit="undefined"!==typeof window.c2nodewebkit||/nodewebkit/i.test(navigator.userAgent);this.isArcade="undefined"!==typeof window.is_scirra_arcade;this.isWindows8App=
!("undefined"===typeof window.c2isWindows8||!window.c2isWindows8);this.isWindows8Capable=!("undefined"===typeof window.c2isWindows8Capable||!window.c2isWindows8Capable);this.isWindowsPhone8=!("undefined"===typeof window.c2isWindowsPhone8||!window.c2isWindowsPhone8);this.isWindowsPhone81=!("undefined"===typeof window.c2isWindowsPhone81||!window.c2isWindowsPhone81);this.isWinJS=this.isWindows8App||this.isWindows8Capable||this.isWindowsPhone81;this.isBlackberry10=!("undefined"===typeof window.c2isBlackberry10||
!window.c2isBlackberry10);this.isAndroidStockBrowser=this.isAndroid&&!this.isChrome&&!this.isFirefox&&!this.isAmazonWebApp&&!this.isDomFree;this.devicePixelRatio=1;this.isMobile=this.isPhoneGap||this.isCrosswalk||this.isAppMobi||this.isCocoonJs||this.isAndroid||this.isiOS||this.isWindowsPhone8||this.isWindowsPhone81||this.isBlackberry10||this.isTizen||this.isEjecta;this.isMobile||(this.isMobile=/(blackberry|bb10|playbook|palm|symbian|nokia|windows\s+ce|phone|mobile|tablet|kindle|silk)/i.test(navigator.userAgent));
"undefined"===typeof cr_is_preview||this.isNodeWebkit||"?nw"!==window.location.search&&!/nodewebkit/i.test(navigator.userAgent)||(this.isNodeWebkit=!0);this.isDebug="undefined"!==typeof cr_is_preview&&-1<window.location.search.indexOf("debug");this.canvas=a;this.canvasdiv=document.getElementById("c2canvasdiv");this.ctx=this.glwrap=this.gl=null;this.fullscreenOldMarginCss="";this.firstInFullscreen=!1;this.oldHeight=this.oldWidth=0;this.canvas.oncontextmenu=function(a){a.preventDefault&&a.preventDefault();
return!1};this.canvas.onselectstart=function(a){a.preventDefault&&a.preventDefault();return!1};this.isDirectCanvas&&(window.c2runtime=this);this.isNodeWebkit&&(window.ondragover=function(a){a.preventDefault();return!1},window.ondrop=function(a){a.preventDefault();return!1},require("nw.gui").App.clearCache());this.width=a.width;this.height=a.height;this.draw_width=this.width;this.draw_height=this.height;this.cssWidth=this.width;this.cssHeight=this.height;this.lastWindowWidth=window.innerWidth;this.lastWindowHeight=
window.innerHeight;this.redraw=!0;this.isSuspended=!1;Date.now||(Date.now=function(){return+new Date});this.plugins=[];this.types={};this.types_by_index=[];this.behaviors=[];this.layouts={};this.layouts_by_index=[];this.eventsheets={};this.eventsheets_by_index=[];this.wait_for_textures=[];this.triggers_to_postinit=[];this.all_global_vars=[];this.all_local_vars=[];this.jumpthruBehavior=this.solidBehavior=null;this.deathRow=new cr.ObjectSet;this.isInClearDeathRow=!1;this.isInOnDestroy=0;this.isRunningEvents=
!1;this.createRow=[];this.isLoadingState=!1;this.lastSaveJson=this.loadFromJson=this.loadFromSlot=this.saveToSlot="";this.suspendDrawing=this.signalledContinuousPreview=!1;this.zeroDtCount=this.cpuutilisation=this.logictime=this.dt1=this.dt=0;this.timescale=1;this.kahanTime=new cr.KahanAdder;this.last_tick_time=0;this.measuring_dt=!0;this.objectcount=this.framecount=this.execcount=this.tickcount=this.last_fps_time=this.fps=0;this.changelayout=null;this.destroycallbacks=[];this.event_stack=[];this.event_stack_index=
-1;this.localvar_stack=[[]];this.trigger_depth=this.localvar_stack_index=0;this.pushEventStack(null);this.loop_stack=[];this.loop_stack_index=-1;this.next_puid=this.next_uid=0;this.layout_first_tick=!0;this.family_count=0;this.suspend_events=[];this.timeout_id=this.raf_id=-1;this.isloading=!0;this.loadingprogress=0;this.isNodeFullscreen=!1;this.stackLocalCount=0;this.halfFramerateMode=!1;this.lastRafTime=0;this.isInUserInputEvent=this.had_a_click=this.ranLastRaf=!1;this.objects_to_tick=new cr.ObjectSet;
this.objects_to_tick2=new cr.ObjectSet;this.registered_collisions=[];this.temp_poly=new cr.CollisionPoly([]);this.temp_poly2=new cr.CollisionPoly([]);this.allGroups=[];this.groups_by_name={};this.cndsBySid={};this.actsBySid={};this.varsBySid={};this.blocksBySid={};this.layout_ctx=this.layout_canvas=this.layout_tex=this.layer_tex=this.layer_ctx=this.layer_canvas=this.running_layout=null;this.uses_background_blending=this.is_WebGL_context_lost=!1;this.fx_tex=[null,null];this.fullscreen_scaling=0;this.files_subfolder=
"";this.objectsByUid={};this.snapshotCanvas=this.loaderlogo=null;this.snapshotData="";this.load();this.devicePixelRatio=(this.isRetina=(!this.isDomFree||this.isEjecta)&&this.useHighDpi&&!this.isAndroidStockBrowser)?window.devicePixelRatio||window.webkitDevicePixelRatio||window.mozDevicePixelRatio||window.msDevicePixelRatio||1:1;this.ClearDeathRow();var c,d=this.alphaBackground&&!(this.isNodeWebkit||this.isWinJS||this.isWindowsPhone8||this.isCrosswalk);0<this.fullscreen_mode&&this.setSize(window.innerWidth,
window.innerHeight,!0);try{this.enableWebGL&&(this.isCocoonJs||this.isEjecta||!this.isDomFree)&&(c={alpha:d,depth:!1,antialias:!1,failIfMajorPerformanceCaveat:!0},this.gl=a.getContext("webgl",c)||a.getContext("experimental-webgl",c))}catch(e){}if(this.gl){this.isDomFree||(this.overlay_canvas=document.createElement("canvas"),jQuery(this.overlay_canvas).appendTo(this.canvas.parentNode),this.overlay_canvas.oncontextmenu=function(a){return!1},this.overlay_canvas.onselectstart=function(a){return!1},this.overlay_canvas.width=
this.cssWidth,this.overlay_canvas.height=this.cssHeight,jQuery(this.overlay_canvas).css({width:this.cssWidth+"px",height:this.cssHeight+"px"}),this.positionOverlayCanvas(),this.overlay_ctx=this.overlay_canvas.getContext("2d"));this.glwrap=new cr.GLWrap(this.gl,this.isMobile);this.glwrap.setSize(a.width,a.height);this.glwrap.enable_mipmaps=0!==this.downscalingQuality;this.ctx=null;this.canvas.addEventListener("webglcontextlost",function(a){a.preventDefault();b.onContextLost();console.log("[Construct 2] WebGL context lost");
window.cr_setSuspended(!0)},!1);this.canvas.addEventListener("webglcontextrestored",function(a){b.glwrap.initState();b.glwrap.setSize(b.glwrap.width,b.glwrap.height,!0);b.layer_tex=null;b.layout_tex=null;b.fx_tex[0]=null;b.fx_tex[1]=null;b.onContextRestored();b.redraw=!0;console.log("[Construct 2] WebGL context restored");window.cr_setSuspended(!1)},!1);var f,h,g,k,l,m;a=0;for(c=this.types_by_index.length;a<c;a++)for(h=this.types_by_index[a],d=0,f=h.effect_types.length;d<f;d++)k=h.effect_types[d],
k.shaderindex=this.glwrap.getShaderIndex(k.id),this.uses_background_blending=this.uses_background_blending||this.glwrap.programUsesDest(k.shaderindex);a=0;for(c=this.layouts_by_index.length;a<c;a++){l=this.layouts_by_index[a];d=0;for(f=l.effect_types.length;d<f;d++)k=l.effect_types[d],k.shaderindex=this.glwrap.getShaderIndex(k.id);d=0;for(f=l.layers.length;d<f;d++)for(m=l.layers[d],h=0,g=m.effect_types.length;h<g;h++)k=m.effect_types[h],k.shaderindex=this.glwrap.getShaderIndex(k.id),this.uses_background_blending=
this.uses_background_blending||this.glwrap.programUsesDest(k.shaderindex)}}else{if(0<this.fullscreen_mode&&this.isDirectCanvas){this.canvas=null;document.oncontextmenu=function(a){return!1};document.onselectstart=function(a){return!1};this.ctx=AppMobi.canvas.getContext("2d");try{this.ctx.samplingMode=this.linearSampling?"smooth":"sharp",this.ctx.globalScale=1,this.ctx.HTML5CompatibilityMode=!0,this.ctx.imageSmoothingEnabled=this.linearSampling}catch(n){}0!==this.width&&0!==this.height&&(this.ctx.width=
this.width,this.ctx.height=this.height)}this.ctx||(c=this.isCocoonJs?{antialias:!!this.linearSampling,alpha:d}:{alpha:d},this.ctx=a.getContext("2d",c),this.ctx.webkitImageSmoothingEnabled=this.linearSampling,this.ctx.mozImageSmoothingEnabled=this.linearSampling,this.ctx.msImageSmoothingEnabled=this.linearSampling,this.ctx.imageSmoothingEnabled=this.linearSampling);this.overlay_ctx=this.overlay_canvas=null}this.tickFunc=function(){b.tick(!1)};window==window.top||this.isDomFree||this.isWinJS||this.isWindowsPhone8||
(document.addEventListener("mousedown",function(){window.focus()},!0),document.addEventListener("touchstart",function(){window.focus()},!0));"undefined"!==typeof cr_is_preview&&(this.isCocoonJs&&console.log("[Construct 2] In preview-over-wifi via CocoonJS mode"),-1<window.location.search.indexOf("continuous")&&(cr.logexport("Reloading for continuous preview"),this.loadFromSlot="__c2_continuouspreview",this.suspendDrawing=!0),this.pauseOnBlur&&!this.isMobile&&(jQuery(window).focus(function(){b.setSuspended(!1)}),
jQuery(window).blur(function(){b.setSuspended(!0)})));0===this.fullscreen_mode&&this.isRetina&&1<this.devicePixelRatio&&this.setSize(this.original_width,this.original_height,!0);this.tryLockOrientation();this.go();this.extra={};cr.seal(this)}}function b(a){a.target.result.createObjectStore("saves",{keyPath:"slot"})}function c(a,c,d,e){var f=indexedDB.open("_C2SaveStates");f.onupgradeneeded=b;f.onerror=e;f.onsuccess=function(b){b=b.target.result;b.onerror=e;b.transaction(["saves"],"readwrite").objectStore("saves").put({slot:a,
data:c}).onsuccess=d}}function d(a,c,d){var e=indexedDB.open("_C2SaveStates");e.onupgradeneeded=b;e.onerror=d;e.onsuccess=function(b){b=b.target.result;b.onerror=d;var e=b.transaction(["saves"]).objectStore("saves").get(a);e.onsuccess=function(a){e.result?c(e.result.data):c(null)}}}function e(){cr.logexport("Reloading for continuous preview");window.c2cocoonjs?CocoonJS.App.reload():-1<window.location.search.indexOf("continuous")?window.location.reload(!0):window.location+="?continuous"}function h(a){var b,
c={};for(b in a)!a.hasOwnProperty(b)||a[b]instanceof cr.ObjectSet||a[b]&&"undefined"!==typeof a[b].c2userdata||(c[b]=a[b]);return c}a.prototype.setSize=function(a,b,c){var d=0,e=0,f=0,h=0,h=0,g=this.isiPhoneiOS6&&this.isSafari&&!navigator.standalone&&!this.isDomFree&&!this.isPhoneGap;g&&(b+=60);if(this.lastWindowWidth!==a||this.lastWindowHeight!==b||c){this.lastWindowWidth=a;this.lastWindowHeight=b;var k=this.fullscreen_mode,l=document.mozFullScreen||document.webkitIsFullScreen||!!document.msFullscreenElement||
document.fullScreen||this.isNodeFullscreen;if(l||0!==this.fullscreen_mode||c)l&&0<this.fullscreen_scaling&&(k=this.fullscreen_scaling),4<=k?(c=this.original_width/this.original_height,a/b>c?(f=b*c,5===k?(h=f/this.original_width,1<h?h=Math.floor(h):1>h&&(h=1/Math.ceil(1/h)),f=this.original_width*h,h*=this.original_height,d=(a-f)/2,e=(b-h)/2,a=f,b=h):(d=(a-f)/2,a=f)):(h=a/c,5===k?(h/=this.original_height,1<h?h=Math.floor(h):1>h&&(h=1/Math.ceil(1/h)),f=this.original_width*h,h*=this.original_height,d=
(a-f)/2,e=(b-h)/2,a=f):e=(b-h)/2,b=h),l&&!this.isNodeWebkit&&(e=d=0),d=Math.floor(d),e=Math.floor(e),a=Math.floor(a),b=Math.floor(b)):this.isNodeWebkit&&this.isNodeFullscreen&&0===this.fullscreen_mode_set&&(d=Math.floor((a-this.original_width)/2),e=Math.floor((b-this.original_height)/2),a=this.original_width,b=this.original_height),2>k&&(this.aspect_scale=this.devicePixelRatio),this.isRetina&&this.isiPad&&1<this.devicePixelRatio&&(1024<=a&&(a=1023),1024<=b&&(b=1023)),l=this.devicePixelRatio,this.cssWidth=
a,this.cssHeight=b,this.width=Math.round(a*l),this.height=Math.round(b*l),this.redraw=!0,this.wantFullscreenScalingQuality?(this.draw_width=this.width,this.draw_height=this.height,this.fullscreenScalingQuality=!0):this.width<this.original_width&&this.height<this.original_height||1===k?(this.draw_width=this.width,this.draw_height=this.height,this.fullscreenScalingQuality=!0):(this.draw_width=this.original_width,this.draw_height=this.original_height,this.fullscreenScalingQuality=!1,2===k?(c=this.original_width/
this.original_height,k=this.lastWindowWidth/this.lastWindowHeight,k<c?this.draw_width=this.draw_height*k:k>c&&(this.draw_height=this.draw_width/k)):3===k&&(c=this.original_width/this.original_height,k=this.lastWindowWidth/this.lastWindowHeight,k>c?this.draw_width=this.draw_height*k:k<c&&(this.draw_height=this.draw_width/k))),this.canvasdiv&&!this.isDomFree&&(jQuery(this.canvasdiv).css({width:a+"px",height:b+"px","margin-left":d,"margin-top":e}),"undefined"!==typeof cr_is_preview&&jQuery("#borderwrap").css({width:a+
"px",height:b+"px"})),this.canvas&&(this.canvas.width=Math.round(a*l),this.canvas.height=Math.round(b*l),this.isEjecta?(this.canvas.style.left=d+"px",this.canvas.style.top=e+"px",this.canvas.style.width=a+"px",this.canvas.style.height=b+"px"):this.isRetina&&!this.isDomFree&&jQuery(this.canvas).css({width:a+"px",height:b+"px"})),this.overlay_canvas&&(this.overlay_canvas.width=a,this.overlay_canvas.height=b,jQuery(this.overlay_canvas).css({width:a+"px",height:b+"px"})),this.glwrap&&this.glwrap.setSize(Math.round(a*
l),Math.round(b*l)),this.isDirectCanvas&&this.ctx&&(this.ctx.width=a,this.ctx.height=b),this.ctx&&(this.ctx.webkitImageSmoothingEnabled=this.linearSampling,this.ctx.mozImageSmoothingEnabled=this.linearSampling,this.ctx.msImageSmoothingEnabled=this.linearSampling,this.ctx.imageSmoothingEnabled=this.linearSampling),this.tryLockOrientation(),this.isDomFree||!g&&!this.isiPhone||window.setTimeout(function(){window.scrollTo(0,1)},100)}};a.prototype.tryLockOrientation=function(){if(this.autoLockOrientation&&
0!==this.orientations){var a="portrait";2===this.orientations&&(a="landscape");screen.lockOrientation?screen.lockOrientation(a):screen.webkitLockOrientation?screen.webkitLockOrientation(a):screen.mozLockOrientation?screen.mozLockOrientation(a):screen.msLockOrientation&&screen.msLockOrientation(a)}};a.prototype.onContextLost=function(){this.is_WebGL_context_lost=!0;var a,b,c;a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onLostWebGLContext)c.onLostWebGLContext()};a.prototype.onContextRestored=
function(){this.is_WebGL_context_lost=!1;var a,b,c;a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onRestoreWebGLContext)c.onRestoreWebGLContext()};a.prototype.positionOverlayCanvas=function(){if(!this.isDomFree){var a=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||document.msFullscreenElement||this.isNodeFullscreen?jQuery(this.canvas).offset():jQuery(this.canvas).position();a.position="absolute";jQuery(this.overlay_canvas).css(a)}};var f=window.cancelAnimationFrame||
window.mozCancelAnimationFrame||window.webkitCancelAnimationFrame||window.msCancelAnimationFrame||window.oCancelAnimationFrame;a.prototype.setSuspended=function(a){var b;if(a&&!this.isSuspended)for(cr.logexport("[Construct 2] Suspending"),this.isSuspended=!0,-1!==this.raf_id&&f&&f(this.raf_id),-1!==this.timeout_id&&clearTimeout(this.timeout_id),a=0,b=this.suspend_events.length;a<b;a++)this.suspend_events[a](!0);else if(!a&&this.isSuspended){cr.logexport("[Construct 2] Resuming");this.isSuspended=
!1;this.last_tick_time=cr.performance_now();this.last_fps_time=cr.performance_now();a=this.logictime=this.framecount=0;for(b=this.suspend_events.length;a<b;a++)this.suspend_events[a](!1);this.tick(!1)}};a.prototype.addSuspendCallback=function(a){this.suspend_events.push(a)};a.prototype.load=function(){var a=cr.getProjectModel();this.name=a[0];this.first_layout=a[1];this.fullscreen_mode=a[11];this.fullscreen_mode_set=a[11];this.original_width=a[9];this.original_height=a[10];this.parallax_x_origin=
this.original_width/2;this.parallax_y_origin=this.original_height/2;this.isDomFree&&!this.isEjecta&&(4<=a[11]||0===a[11])&&(cr.logexport("[Construct 2] Letterbox scale fullscreen modes are not supported on this platform - falling back to 'Scale outer'"),this.fullscreen_mode_set=this.fullscreen_mode=3);this.uses_loader_layout=a[17];this.loaderstyle=a[18];0===this.loaderstyle&&(this.loaderlogo=new Image,this.loaderlogo.src="loading-logo.png");this.next_uid=a[20];this.system=new cr.system_object(this);
var b,c,d,e,h,f,g,k,l;b=0;for(c=a[2].length;b<c;b++){g=a[2][b];cr.add_common_aces(g);l=new g[0](this);l.singleglobal=g[1];l.is_world=g[2];l.must_predraw=g[9];if(l.onCreate)l.onCreate();cr.seal(l);this.plugins.push(l)}a=cr.getProjectModel();b=0;for(c=a[3].length;b<c;b++){g=a[3][b];h=g[1];l=null;d=0;for(e=this.plugins.length;d<e;d++)if(this.plugins[d]instanceof h){l=this.plugins[d];break}var m=new l.Type(l);m.name=g[0];m.is_family=g[2];m.instvar_sids=g[3].slice(0);m.vars_count=g[3].length;m.behs_count=
g[4];m.fx_count=g[5];m.sid=g[11];m.is_family?(m.members=[],m.family_index=this.family_count++,m.families=null):(m.members=null,m.family_index=-1,m.families=[]);m.family_var_map=null;m.family_beh_map=null;m.family_fx_map=null;m.is_contained=!1;m.container=null;g[6]?(m.texture_file=g[6][0],m.texture_filesize=g[6][1],m.texture_pixelformat=g[6][2]):(m.texture_file=null,m.texture_filesize=0,m.texture_pixelformat=0);m.animations=g[7]?g[7]:null;m.index=b;m.instances=[];m.deadCache=[];m.solstack=[new cr.selection(m)];
m.cur_sol=0;m.default_instance=null;m.default_layerindex=0;m.stale_iids=!0;m.updateIIDs=cr.type_updateIIDs;m.getFirstPicked=cr.type_getFirstPicked;m.getPairedInstance=cr.type_getPairedInstance;m.getCurrentSol=cr.type_getCurrentSol;m.pushCleanSol=cr.type_pushCleanSol;m.pushCopySol=cr.type_pushCopySol;m.popSol=cr.type_popSol;m.getBehaviorByName=cr.type_getBehaviorByName;m.getBehaviorIndexByName=cr.type_getBehaviorIndexByName;m.getEffectIndexByName=cr.type_getEffectIndexByName;m.applySolToContainer=
cr.type_applySolToContainer;m.getInstanceByIID=cr.type_getInstanceByIID;m.collision_grid=new cr.SparseGrid(this.original_width,this.original_height);m.any_cell_changed=!0;m.any_instance_parallaxed=!1;m.extra={};m.toString=cr.type_toString;m.behaviors=[];d=0;for(e=g[8].length;d<e;d++){k=g[8][d];var n=k[1],s=null;h=0;for(f=this.behaviors.length;h<f;h++)if(this.behaviors[h]instanceof n){s=this.behaviors[h];break}if(!s){s=new n(this);s.my_types=[];s.my_instances=new cr.ObjectSet;if(s.onCreate)s.onCreate();
cr.seal(s);this.behaviors.push(s);cr.behaviors.solid&&s instanceof cr.behaviors.solid&&(this.solidBehavior=s);cr.behaviors.jumpthru&&s instanceof cr.behaviors.jumpthru&&(this.jumpthruBehavior=s)}-1===s.my_types.indexOf(m)&&s.my_types.push(m);h=new s.Type(s,m);h.name=k[0];h.sid=k[2];h.onCreate();cr.seal(h);m.behaviors.push(h)}m.global=g[9];m.isOnLoaderLayout=g[10];m.effect_types=[];d=0;for(e=g[12].length;d<e;d++)m.effect_types.push({id:g[12][d][0],name:g[12][d][1],shaderindex:-1,active:!0,index:d});
m.tile_poly_data=g[13];if(!this.uses_loader_layout||m.is_family||m.isOnLoaderLayout||!l.is_world)m.onCreate(),cr.seal(m);m.name&&(this.types[m.name]=m);this.types_by_index.push(m);l.singleglobal&&(d=new l.Instance(m),d.uid=this.next_uid++,d.puid=this.next_puid++,d.iid=0,d.get_iid=cr.inst_get_iid,d.toString=cr.inst_toString,d.properties=g[14],d.onCreate(),cr.seal(d),m.instances.push(d),this.objectsByUid[d.uid.toString()]=d)}b=0;for(c=a[4].length;b<c;b++)for(h=a[4][b],f=this.types_by_index[h[0]],d=
1,e=h.length;d<e;d++)g=this.types_by_index[h[d]],g.families.push(f),f.members.push(g);b=0;for(c=a[24].length;b<c;b++){h=a[24][b];f=[];d=0;for(e=h.length;d<e;d++)f.push(this.types_by_index[h[d]]);d=0;for(e=f.length;d<e;d++)f[d].is_contained=!0,f[d].container=f}if(0<this.family_count)for(b=0,c=this.types_by_index.length;b<c;b++)if(g=this.types_by_index[b],!g.is_family&&g.families.length){g.family_var_map=Array(this.family_count);g.family_beh_map=Array(this.family_count);g.family_fx_map=Array(this.family_count);
m=[];d=s=n=k=0;for(e=g.families.length;d<e;d++)for(l=g.families[d],g.family_var_map[l.family_index]=k,k+=l.vars_count,g.family_beh_map[l.family_index]=n,n+=l.behs_count,g.family_fx_map[l.family_index]=s,s+=l.fx_count,h=0,f=l.effect_types.length;h<f;h++)m.push(cr.shallowCopy({},l.effect_types[h]));g.effect_types=m.concat(g.effect_types);d=0;for(e=g.effect_types.length;d<e;d++)g.effect_types[d].index=d}b=0;for(c=a[5].length;b<c;b++)g=a[5][b],d=new cr.layout(this,g),cr.seal(d),this.layouts[d.name]=d,
this.layouts_by_index.push(d);b=0;for(c=a[6].length;b<c;b++)g=a[6][b],d=new cr.eventsheet(this,g),cr.seal(d),this.eventsheets[d.name]=d,this.eventsheets_by_index.push(d);b=0;for(c=this.eventsheets_by_index.length;b<c;b++)this.eventsheets_by_index[b].postInit();b=0;for(c=this.eventsheets_by_index.length;b<c;b++)this.eventsheets_by_index[b].updateDeepIncludes();b=0;for(c=this.triggers_to_postinit.length;b<c;b++)this.triggers_to_postinit[b].postInit();this.triggers_to_postinit.length=0;this.files_subfolder=
a[7];this.pixel_rounding=a[8];this.aspect_scale=1;this.enableWebGL=a[12];this.linearSampling=a[13];this.alphaBackground=a[14];this.versionstr=a[15];this.useHighDpi=a[16];this.orientations=a[19];this.autoLockOrientation=0<this.orientations;this.pauseOnBlur=a[21];this.fullscreenScalingQuality=this.wantFullscreenScalingQuality=a[22];this.downscalingQuality=a[23];this.start_time=Date.now()};var l=!1;a.prototype.waitForImageLoad=function(a){a.onerror=function(b){l=a.c2error=!0;console&&console.error&&
console.error("Error loading image '"+a.src+"': ",b)};this.wait_for_textures.push(a)};a.prototype.findWaitingTexture=function(a){var b,c;b=0;for(c=this.wait_for_textures.length;b<c;b++)if(this.wait_for_textures[b].cr_src===a)return this.wait_for_textures[b];return null};a.prototype.areAllTexturesLoaded=function(){var a=0,b=0,c=!0,d,e,h;d=0;for(e=this.wait_for_textures.length;d<e;d++){h=this.wait_for_textures[d];var f=h.cr_filesize;if(!f||0>=f)f=5E4;a+=f;!h.complete&&!h.loaded||h.c2error?c=!1:b+=f}this.progress=
0==a?0:b/a;return c};a.prototype.go=function(){if(this.ctx||this.glwrap){var a=this.ctx||this.overlay_ctx;this.overlay_canvas&&this.positionOverlayCanvas();this.progress=0;this.last_progress=-1;if(this.areAllTexturesLoaded())this.go_textures_done();else{var b=Date.now()-this.start_time;if(a){var c=this.width,d=this.height,e=this.devicePixelRatio;this.overlay_canvas&&(c=this.cssWidth,d=this.cssHeight,e=1);if(3!==this.loaderstyle&&(this.isCocoonJs||500<=b&&this.last_progress!=this.progress)){a.clearRect(0,
0,c,d);var b=c/2,d=d/2,c=0===this.loaderstyle&&this.loaderlogo.complete,h=40*e,f=0,g=80*e,k;c&&(g=this.loaderlogo.width*e,k=this.loaderlogo.height*e,h=g/2,f=k/2,a.drawImage(this.loaderlogo,cr.floor(b-h),cr.floor(d-f),g,k));1>=this.loaderstyle?(d+=f+(c?12*e:0),b=cr.floor(b-h)+0.5,d=cr.floor(d)+0.5,a.fillStyle=l?"red":"DodgerBlue",a.fillRect(b,d,Math.floor(g*this.progress),6*e),a.strokeStyle="black",a.strokeRect(b,d,g,6*e),a.strokeStyle="white",a.strokeRect(b-1*e,d-1*e,g+2*e,8*e)):2===this.loaderstyle&&
(a.font=this.isEjecta?"12pt ArialMT":"12pt Arial",a.fillStyle=l?"#f00":"#999",a.textBaseLine="middle",e=Math.round(100*this.progress)+"%",c=a.measureText?a.measureText(e):null,a.fillText(e,b-(c?c.width:0)/2,d))}this.last_progress=this.progress}setTimeout(function(a){return function(){a.go()}}(this),this.isCocoonJs?10:100)}}};a.prototype.go_textures_done=function(){this.overlay_canvas&&(this.canvas.parentNode.removeChild(this.overlay_canvas),this.overlay_canvas=this.overlay_ctx=null);this.start_time=
Date.now();this.last_fps_time=cr.performance_now();var a,b,c;if(this.uses_loader_layout)for(a=0,b=this.types_by_index.length;a<b;a++)c=this.types_by_index[a],c.is_family||c.isOnLoaderLayout||!c.plugin.is_world||(c.onCreate(),cr.seal(c));else this.isloading=!1;a=0;for(b=this.layouts_by_index.length;a<b;a++)this.layouts_by_index[a].createGlobalNonWorlds();2<=this.fullscreen_mode&&(a=this.original_width/this.original_height,b=this.width/this.height,this.aspect_scale=2!==this.fullscreen_mode&&b>a||2===
this.fullscreen_mode&&b<a?this.height/this.original_height:this.width/this.original_width);this.first_layout?this.layouts[this.first_layout].startRunning():this.layouts_by_index[0].startRunning();this.uses_loader_layout||(this.loadingprogress=1,this.trigger(cr.system_object.prototype.cnds.OnLoadFinished,null));navigator.splashscreen&&navigator.splashscreen.hide&&navigator.splashscreen.hide();a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],c.onAppBegin)c.onAppBegin();this.tick(!1);
this.isDirectCanvas&&AppMobi.webview.execute("onGameReady();")};var k=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame||window.oRequestAnimationFrame;a.prototype.tick=function(a){if(this.running_layout){var b=cr.performance_now();if(this.halfFramerateMode&&this.ranLastRaf&&29>b-this.lastRafTime)this.ranLastRaf=!1,this.lastRafTime=b,k?this.raf_id=k(this.tickFunc,this.canvas):this.timeout_id=setTimeout(this.tickFunc,this.isMobile?
1:16);else{this.ranLastRaf=!0;this.lastRafTime=b;var c=this.fullscreen_mode,d=document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||!!document.msFullscreenElement;(d||this.isNodeFullscreen)&&0<this.fullscreen_scaling&&(c=this.fullscreen_scaling);if(0<c&&(!this.isiOS||window.self!==window.top)){var c=window.innerWidth,e=window.innerHeight;this.lastWindowWidth===c&&this.lastWindowHeight===e||this.setSize(c,e)}this.isDomFree||(d?(this.firstInFullscreen||(this.fullscreenOldMarginCss=
jQuery(this.canvas).css("margin")||"0",this.firstInFullscreen=!0),this.isChrome||this.isNodeWebkit||jQuery(this.canvas).css({"margin-left":""+Math.floor((screen.width-this.width/this.devicePixelRatio)/2)+"px","margin-top":""+Math.floor((screen.height-this.height/this.devicePixelRatio)/2)+"px"})):this.firstInFullscreen?(this.isChrome||this.isNodeWebkit||jQuery(this.canvas).css("margin",this.fullscreenOldMarginCss),this.fullscreenOldMarginCss="",this.firstInFullscreen=!1,0===this.fullscreen_mode&&this.setSize(Math.round(this.oldWidth/
this.devicePixelRatio),Math.round(this.oldHeight/this.devicePixelRatio),!0)):(this.oldWidth=this.width,this.oldHeight=this.height));this.isloading&&(d=this.areAllTexturesLoaded(),this.loadingprogress=this.progress,d&&(this.isloading=!1,this.progress=1,this.trigger(cr.system_object.prototype.cnds.OnLoadFinished,null)));this.logic();!this.redraw&&!this.isCocoonJs||this.is_WebGL_context_lost||this.suspendDrawing||a||(this.redraw=!1,this.glwrap?this.drawGL():this.draw(),this.snapshotCanvas&&(this.canvas&&
this.canvas.toDataURL&&(this.snapshotData=this.canvas.toDataURL(this.snapshotCanvas[0],this.snapshotCanvas[1]),this.trigger(cr.system_object.prototype.cnds.OnCanvasSnapshot,null)),this.snapshotCanvas=null));this.hit_breakpoint||(this.tickcount++,this.execcount++,this.framecount++);this.logictime+=cr.performance_now()-b;this.isSuspended||a||(k?this.raf_id=k(this.tickFunc,this.canvas):this.timeout_id=setTimeout(this.tickFunc,this.isMobile?1:16))}}};a.prototype.logic=function(){var a,b,c,d,e,h,f,g,k;
a=cr.performance_now();1E3<=a-this.last_fps_time&&(this.last_fps_time+=1E3,this.fps=this.framecount,this.framecount=0,this.cpuutilisation=this.logictime,this.logictime=0);this.measuring_dt&&(0!==this.last_tick_time&&(b=a-this.last_tick_time,0!==b||this.isDebug?(this.dt1=b/1E3,0.5<this.dt1?this.dt1=0:0.1<this.dt1&&(this.dt1=0.1)):(this.zeroDtCount++,10<=this.zeroDtCout&&(this.measuring_dt=!1),this.dt1=1/60)),this.last_tick_time=a);this.dt=this.dt1*this.timescale;this.kahanTime.add(this.dt);a=document.mozFullScreen||
document.webkitIsFullScreen||document.fullScreen||!!document.msFullscreenElement||this.isNodeFullscreen;2<=this.fullscreen_mode||a&&0<this.fullscreen_scaling?(b=this.original_width/this.original_height,c=this.width/this.height,d=this.fullscreen_mode,a&&0<this.fullscreen_scaling&&(d=this.fullscreen_scaling),this.aspect_scale=2!==d&&c>b||2===d&&c<b?this.height/this.original_height:this.width/this.original_width,this.running_layout&&(this.running_layout.scrollToX(this.running_layout.scrollX),this.running_layout.scrollToY(this.running_layout.scrollY))):
this.aspect_scale=this.isRetina?this.devicePixelRatio:1;this.ClearDeathRow();this.isInOnDestroy++;this.system.runWaits();this.isInOnDestroy--;this.ClearDeathRow();this.isInOnDestroy++;a=0;for(b=this.types_by_index.length;a<b;a++)if(f=this.types_by_index[a],!f.is_family&&(f.behaviors.length||f.families.length))for(c=0,d=f.instances.length;c<d;c++)for(g=f.instances[c],e=0,h=g.behavior_insts.length;e<h;e++)g.behavior_insts[e].tick();a=0;for(b=this.types_by_index.length;a<b;a++)if(f=this.types_by_index[a],
!f.is_family&&(f.behaviors.length||f.families.length))for(c=0,d=f.instances.length;c<d;c++)for(g=f.instances[c],e=0,h=g.behavior_insts.length;e<h;e++)k=g.behavior_insts[e],k.posttick&&k.posttick();c=this.objects_to_tick.valuesRef();a=0;for(b=c.length;a<b;a++)c[a].tick();this.isInOnDestroy--;this.handleSaveLoad();for(a=0;this.changelayout&&10>a++;)this.doChangeLayout(this.changelayout);a=0;for(b=this.eventsheets_by_index.length;a<b;a++)this.eventsheets_by_index[a].hasRun=!1;this.running_layout.event_sheet&&
this.running_layout.event_sheet.run();this.registered_collisions.length=0;this.layout_first_tick=!1;this.isInOnDestroy++;a=0;for(b=this.types_by_index.length;a<b;a++)if(f=this.types_by_index[a],!f.is_family&&(f.behaviors.length||f.families.length))for(c=0,d=f.instances.length;c<d;c++)for(g=f.instances[c],e=0,h=g.behavior_insts.length;e<h;e++)k=g.behavior_insts[e],k.tick2&&k.tick2();c=this.objects_to_tick2.valuesRef();a=0;for(b=c.length;a<b;a++)c[a].tick2();this.isInOnDestroy--};a.prototype.doChangeLayout=
function(a){var b=this.running_layout;this.running_layout.stopRunning();var c,d,e,h,f,g,k;if(this.glwrap)for(c=0,d=this.types_by_index.length;c<d;c++)f=this.types_by_index[c],f.is_family||!f.unloadTextures||f.global&&0!==f.instances.length||-1!==a.initial_types.indexOf(f)||f.unloadTextures();b==a&&(this.system.waits.length=0);a.startRunning();c=0;for(d=this.types_by_index.length;c<d;c++)if(f=this.types_by_index[c],f.global||f.plugin.singleglobal)for(a=0,b=f.instances.length;a<b;a++){g=f.instances[a];
if(g.onLayoutChange)g.onLayoutChange();if(g.behavior_insts)for(e=0,h=g.behavior_insts.length;e<h;e++)if(k=g.behavior_insts[e],k.onLayoutChange)k.onLayoutChange()}this.layout_first_tick=this.redraw=!0;this.ClearDeathRow()};a.prototype.tickMe=function(a){this.objects_to_tick.add(a)};a.prototype.untickMe=function(a){this.objects_to_tick.remove(a)};a.prototype.tick2Me=function(a){this.objects_to_tick2.add(a)};a.prototype.untick2Me=function(a){this.objects_to_tick2.remove(a)};a.prototype.getDt=function(a){return a&&
-1!==a.my_timescale?this.dt1*a.my_timescale:this.dt};a.prototype.draw=function(){this.running_layout.draw(this.ctx);this.isDirectCanvas&&this.ctx.present()};a.prototype.drawGL=function(){this.running_layout.drawGL(this.glwrap);this.glwrap.present()};a.prototype.addDestroyCallback=function(a){a&&this.destroycallbacks.push(a)};a.prototype.removeDestroyCallback=function(a){cr.arrayFindRemove(this.destroycallbacks,a)};a.prototype.getObjectByUID=function(a){a=a.toString();return this.objectsByUid.hasOwnProperty(a)?
this.objectsByUid[a]:null};a.prototype.DestroyInstance=function(a){var b,c;if(!this.deathRow.contains(a)){this.deathRow.add(a);if(a.is_contained)for(b=0,c=a.siblings.length;b<c;b++)this.DestroyInstance(a.siblings[b]);this.isInClearDeathRow&&this.deathRow.values_cache.push(a);this.isInOnDestroy++;this.trigger(Object.getPrototypeOf(a.type.plugin).cnds.OnDestroyed,a);this.isInOnDestroy--}};a.prototype.ClearDeathRow=function(){var a,b,c,d,e,f,h,g,k,l;this.isInClearDeathRow=!0;d=0;for(f=this.createRow.length;d<
f;d++)for(a=this.createRow[d],b=a.type,b.instances.push(a),e=0,h=b.families.length;e<h;e++)b.families[e].instances.push(a),b.families[e].stale_iids=!0;this.createRow.length=0;f=this.deathRow.valuesRef();for(d=0;d<f.length;d++){a=f[d];b=a.type;c=b.instances;e=0;for(h=this.destroycallbacks.length;e<h;e++)this.destroycallbacks[e](a);cr.arrayFindRemove(c,a);0===c.length&&(b.any_instance_parallaxed=!1);a.collcells&&b.collision_grid.update(a,a.collcells,null);a.layer&&(cr.arrayRemove(a.layer.instances,
a.get_zindex()),a.layer.zindices_stale=!0);e=0;for(h=b.families.length;e<h;e++)cr.arrayFindRemove(b.families[e].instances,a),b.families[e].stale_iids=!0;if(a.behavior_insts)for(e=0,h=a.behavior_insts.length;e<h;e++){c=a.behavior_insts[e];if(c.onDestroy)c.onDestroy();c.behavior.my_instances.remove(a)}this.objects_to_tick.remove(a);this.objects_to_tick2.remove(a);e=0;for(h=this.system.waits.length;e<h;e++)if(k=this.system.waits[e],k.sols.hasOwnProperty(b.index)&&cr.arrayFindRemove(k.sols[b.index].insts,
a),!b.is_family)for(c=0,g=b.families.length;c<g;c++)l=b.families[c],k.sols.hasOwnProperty(l.index)&&cr.arrayFindRemove(k.sols[l.index].insts,a);if(a.onDestroy)a.onDestroy();this.objectsByUid.hasOwnProperty(a.uid.toString())&&delete this.objectsByUid[a.uid.toString()];this.objectcount--;64>b.deadCache.length&&b.deadCache.push(a);b.stale_iids=!0}this.deathRow.isEmpty()||(this.redraw=!0);this.deathRow.clear();this.isInClearDeathRow=!1};a.prototype.createInstance=function(a,b,c,d){if(a.is_family){var e=
cr.floor(Math.random()*a.members.length);return this.createInstance(a.members[e],b,c,d)}return a.default_instance?this.createInstanceFromInit(a.default_instance,b,!1,c,d,!1):null};var g=[];a.prototype.createInstanceFromInit=function(a,b,c,d,e,h){var f,k,l,m;if(!a)return null;var n=this.types_by_index[a[1]],s=n.plugin.is_world;if(this.isloading&&s&&!n.isOnLoaderLayout||s&&!this.glwrap&&11===a[0][11])return null;var r=b;s||(b=null);var q;n.deadCache.length?(q=n.deadCache.pop(),q.recycled=!0,n.plugin.Instance.call(q,
n)):(q=new n.plugin.Instance(n),q.recycled=!1);q.uid=c&&!h?a[2]:this.next_uid++;this.objectsByUid[q.uid.toString()]=q;q.puid=this.next_puid++;q.iid=n.instances.length;f=0;for(k=this.createRow.length;f<k;++f)this.createRow[f].type===n&&q.iid++;q.get_iid=cr.inst_get_iid;l=a[3];if(q.recycled)cr.wipe(q.extra);else{q.extra={};if("undefined"!==typeof cr_is_preview)for(q.instance_var_names=[],q.instance_var_names.length=l.length,f=0,k=l.length;f<k;f++)q.instance_var_names[f]=l[f][1];q.instance_vars=[];q.instance_vars.length=
l.length}f=0;for(k=l.length;f<k;f++)q.instance_vars[f]=l[f][0];if(s){var p=a[0];q.x=cr.is_undefined(d)?p[0]:d;q.y=cr.is_undefined(e)?p[1]:e;q.z=p[2];q.width=p[3];q.height=p[4];q.depth=p[5];q.angle=p[6];q.opacity=p[7];q.hotspotX=p[8];q.hotspotY=p[9];q.blend_mode=p[10];f=p[11];!this.glwrap&&n.effect_types.length&&(q.blend_mode=f);q.compositeOp=cr.effectToCompositeOp(q.blend_mode);this.gl&&cr.setGLBlend(q,q.blend_mode,this.gl);if(q.recycled){f=0;for(k=p[12].length;f<k;f++)for(l=0,m=p[12][f].length;l<
m;l++)q.effect_params[f][l]=p[12][f][l];q.bbox.set(0,0,0,0);q.collcells.set(0,0,-1,-1);q.bquad.set_from_rect(q.bbox);q.bbox_changed_callbacks.length=0}else{q.effect_params=p[12].slice(0);f=0;for(k=q.effect_params.length;f<k;f++)q.effect_params[f]=p[12][f].slice(0);q.active_effect_types=[];q.active_effect_flags=[];q.active_effect_flags.length=n.effect_types.length;q.bbox=new cr.rect(0,0,0,0);q.collcells=new cr.rect(0,0,-1,-1);q.bquad=new cr.quad;q.bbox_changed_callbacks=[];q.set_bbox_changed=cr.set_bbox_changed;
q.add_bbox_changed_callback=cr.add_bbox_changed_callback;q.contains_pt=cr.inst_contains_pt;q.update_bbox=cr.update_bbox;q.update_collision_cell=cr.update_collision_cell;q.get_zindex=cr.inst_get_zindex}q.tilemap_exists=!1;q.tilemap_width=0;q.tilemap_height=0;q.tilemap_data=null;14===p.length&&(q.tilemap_exists=!0,q.tilemap_width=p[13][0],q.tilemap_height=p[13][1],q.tilemap_data=p[13][2]);f=0;for(k=n.effect_types.length;f<k;f++)q.active_effect_flags[f]=!0;q.updateActiveEffects=cr.inst_updateActiveEffects;
q.updateActiveEffects();q.uses_shaders=!!q.active_effect_types.length;q.bbox_changed=!0;q.cell_changed=!0;n.any_cell_changed=!0;q.visible=!0;q.my_timescale=-1;q.layer=b;q.zindex=b.instances.length;"undefined"===typeof q.collision_poly&&(q.collision_poly=null);this.redraw=q.collisionsEnabled=!0}q.toString=cr.inst_toString;var E;f=g.length=0;for(k=n.families.length;f<k;f++)g.push.apply(g,n.families[f].behaviors);g.push.apply(g,n.behaviors);if(q.recycled)for(f=0,k=g.length;f<k;f++){var T=g[f];E=q.behavior_insts[f];
E.recycled=!0;T.behavior.Instance.call(E,T,q);p=a[4][f];l=0;for(m=p.length;l<m;l++)E.properties[l]=p[l];E.onCreate();T.behavior.my_instances.add(q)}else for(q.behavior_insts=[],f=0,k=g.length;f<k;f++)T=g[f],E=new T.behavior.Instance(T,q),E.recycled=!1,E.properties=a[4][f].slice(0),E.onCreate(),cr.seal(E),q.behavior_insts.push(E),T.behavior.my_instances.add(q);p=a[5];if(q.recycled)for(f=0,k=p.length;f<k;f++)q.properties[f]=p[f];else q.properties=p.slice(0);this.createRow.push(q);b&&(b.instances.push(q),
1!==b.parallaxX||1!==b.parallaxY)&&(n.any_instance_parallaxed=!0);this.objectcount++;if(n.is_contained){if(q.is_contained=!0,q.recycled?q.siblings.length=0:q.siblings=[],!c&&!h){f=0;for(k=n.container.length;f<k;f++)if(n.container[f]!==n){if(!n.container[f].default_instance)return null;q.siblings.push(this.createInstanceFromInit(n.container[f].default_instance,r,!1,s?q.x:d,s?q.y:e,!0))}f=0;for(k=q.siblings.length;f<k;f++)for(q.siblings[f].siblings.push(q),l=0;l<k;l++)f!==l&&q.siblings[f].siblings.push(q.siblings[l])}}else q.is_contained=
!1,q.siblings=null;q.onCreate();q.recycled||cr.seal(q);f=0;for(k=q.behavior_insts.length;f<k;f++)q.behavior_insts[f].postCreate&&q.behavior_insts[f].postCreate();return q};a.prototype.getLayerByName=function(a){var b,c;b=0;for(c=this.running_layout.layers.length;b<c;b++){var d=this.running_layout.layers[b];if(cr.equals_nocase(d.name,a))return d}return null};a.prototype.getLayerByNumber=function(a){a=cr.floor(a);0>a&&(a=0);a>=this.running_layout.layers.length&&(a=this.running_layout.layers.length-
1);return this.running_layout.layers[a]};a.prototype.getLayer=function(a){return cr.is_number(a)?this.getLayerByNumber(a):this.getLayerByName(a.toString())};a.prototype.clearSol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].getCurrentSol().select_all=!0};a.prototype.pushCleanSol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].pushCleanSol()};a.prototype.pushCopySol=function(a){var b,c;b=0;for(c=a.length;b<c;b++)a[b].pushCopySol()};a.prototype.popSol=function(a){var b,c;b=0;for(c=a.length;b<
c;b++)a[b].popSol()};a.prototype.updateAllCells=function(a){if(a.any_cell_changed){var b,c,d=a.instances;b=0;for(c=d.length;b<c;++b)d[b].update_collision_cell();d=this.createRow;b=0;for(c=d.length;b<c;++b)d[b].type===a&&d[b].update_collision_cell();a.any_cell_changed=!1}};a.prototype.getCollisionCandidates=function(a,b,c,d){var e,f,h=a?1!==a.parallaxX||1!==a.parallaxY:!1;if(b.is_family)for(a=0,e=b.members.length;a<e;++a)f=b.members[a],h||f.any_instance_parallaxed?cr.appendArray(d,f.instances):(this.updateAllCells(f),
f.collision_grid.queryRange(c,d));else h||b.any_instance_parallaxed?cr.appendArray(d,b.instances):(this.updateAllCells(b),b.collision_grid.queryRange(c,d))};a.prototype.getTypesCollisionCandidates=function(a,b,c,d){var e,f;e=0;for(f=b.length;e<f;++e)this.getCollisionCandidates(a,b[e],c,d)};a.prototype.getSolidCollisionCandidates=function(a,b,c){var d=this.getSolidBehavior();if(!d)return null;this.getTypesCollisionCandidates(a,d.my_types,b,c)};a.prototype.getJumpthruCollisionCandidates=function(a,
b,c){var d=this.getJumpthruBehavior();if(!d)return null;this.getTypesCollisionCandidates(a,d.my_types,b,c)};a.prototype.testAndSelectCanvasPointOverlap=function(a,b,c,d){var e=a.getCurrentSol(),f,h,g,k,l,m;if(e.select_all)for(d||(e.select_all=!1,e.instances.length=0),f=0,k=a.instances.length;f<k;f++){if(g=a.instances[f],g.update_bbox(),l=g.layer.canvasToLayer(b,c,!0),m=g.layer.canvasToLayer(b,c,!1),g.contains_pt(l,m)){if(d)return!1;e.instances.push(g)}}else{f=h=0;for(k=e.instances.length;f<k;f++)if(g=
e.instances[f],g.update_bbox(),l=g.layer.canvasToLayer(b,c,!0),m=g.layer.canvasToLayer(b,c,!1),g.contains_pt(l,m)){if(d)return!1;e.instances[h]=e.instances[f];h++}d||(e.instances.length=h)}a.applySolToContainer();return d?!0:e.hasObjects()};a.prototype.testOverlap=function(a,b){if(!(a&&b&&a!==b&&a.collisionsEnabled&&b.collisionsEnabled))return!1;a.update_bbox();b.update_bbox();var c=a.layer,d=b.layer,e,f,h,g,k,l,m,n;if(c===d||c.parallaxX===d.parallaxX&&d.parallaxY===d.parallaxY&&c.scale===d.scale&&
c.angle===d.angle&&c.zoomRate===d.zoomRate){if(!a.bbox.intersects_rect(b.bbox)||!a.bquad.intersects_quad(b.bquad)||a.tilemap_exists&&b.tilemap_exists)return!1;if(a.tilemap_exists)return this.testTilemapOverlap(a,b);if(b.tilemap_exists)return this.testTilemapOverlap(b,a);m=a.collision_poly&&!a.collision_poly.is_empty();e=b.collision_poly&&!b.collision_poly.is_empty();if(!m&&!e)return!0;m?(a.collision_poly.cache_poly(a.width,a.height,a.angle),m=a.collision_poly):(this.temp_poly.set_from_quad(a.bquad,
a.x,a.y,a.width,a.height),m=this.temp_poly);e?(b.collision_poly.cache_poly(b.width,b.height,b.angle),n=b.collision_poly):(this.temp_poly.set_from_quad(b.bquad,b.x,b.y,b.width,b.height),n=this.temp_poly);return m.intersects_poly(n,b.x-a.x,b.y-a.y)}m=a.collision_poly&&!a.collision_poly.is_empty();e=b.collision_poly&&!b.collision_poly.is_empty();m?(a.collision_poly.cache_poly(a.width,a.height,a.angle),this.temp_poly.set_from_poly(a.collision_poly)):this.temp_poly.set_from_quad(a.bquad,a.x,a.y,a.width,
a.height);m=this.temp_poly;e?(b.collision_poly.cache_poly(b.width,b.height,b.angle),this.temp_poly2.set_from_poly(b.collision_poly)):this.temp_poly2.set_from_quad(b.bquad,b.x,b.y,b.width,b.height);n=this.temp_poly2;e=0;for(f=m.pts_count;e<f;e++)h=2*e,g=h+1,k=m.pts_cache[h],l=m.pts_cache[g],m.pts_cache[h]=c.layerToCanvas(k+a.x,l+a.y,!0),m.pts_cache[g]=c.layerToCanvas(k+a.x,l+a.y,!1);m.update_bbox();e=0;for(f=n.pts_count;e<f;e++)h=2*e,g=h+1,k=n.pts_cache[h],l=n.pts_cache[g],n.pts_cache[h]=d.layerToCanvas(k+
b.x,l+b.y,!0),n.pts_cache[g]=d.layerToCanvas(k+b.x,l+b.y,!1);n.update_bbox();return m.intersects_poly(n,0,0)};var m=new cr.quad,n=new cr.rect(0,0,0,0),p=[];a.prototype.testTilemapOverlap=function(a,b){var c,d,e,f,h=b.bbox,g=a.x,k=a.y;a.getCollisionRectCandidates(h,p);var l=b.collision_poly&&!b.collision_poly.is_empty();c=0;for(d=p.length;c<d;++c)if(e=p[c],f=e.rc,h.intersects_rect_off(f,g,k)&&(m.set_from_rect(f),m.offset(g,k),m.intersects_quad(b.bquad)))if(l)if(b.collision_poly.cache_poly(b.width,
b.height,b.angle),e.poly){if(e.poly.intersects_poly(b.collision_poly,b.x-(g+f.left),b.y-(k+f.top)))return p.length=0,!0}else{if(this.temp_poly.set_from_quad(m,0,0,f.right-f.left,f.bottom-f.top),this.temp_poly.intersects_poly(b.collision_poly,b.x,b.y))return p.length=0,!0}else if(e.poly){if(this.temp_poly.set_from_quad(b.bquad,0,0,b.width,b.height),e.poly.intersects_poly(this.temp_poly,-(g+f.left),-(k+f.top)))return p.length=0,!0}else return p.length=0,!0;p.length=0;return!1};a.prototype.testRectOverlap=
function(a,b){if(!b||!b.collisionsEnabled)return!1;b.update_bbox();if(!b.bbox.intersects_rect(a))return!1;if(b.tilemap_exists){b.getCollisionRectCandidates(a,p);var c,d,e,f,h=b.x,g=b.y;c=0;for(d=p.length;c<d;++c)if(e=p[c],f=e.rc,a.intersects_rect_off(f,h,g))if(e.poly){if(this.temp_poly.set_from_rect(a,0,0),e.poly.intersects_poly(this.temp_poly,-(h+f.left),-(g+f.top)))return p.length=0,!0}else return p.length=0,!0;p.length=0;return!1}m.set_from_rect(a);if(!b.bquad.intersects_quad(m))return!1;if(!b.collision_poly||
b.collision_poly.is_empty())return!0;b.collision_poly.cache_poly(b.width,b.height,b.angle);m.offset(-a.left,-a.top);this.temp_poly.set_from_quad(m,0,0,1,1);return b.collision_poly.intersects_poly(this.temp_poly,a.left-b.x,a.top-b.y)};a.prototype.testSegmentOverlap=function(a,b,c,d,e){if(!e||!e.collisionsEnabled)return!1;e.update_bbox();n.set(cr.min(a,c),cr.min(b,d),cr.max(a,c),cr.max(b,d));if(!e.bbox.intersects_rect(n))return!1;if(e.tilemap_exists){e.getCollisionRectCandidates(n,p);var f,h,g,k=e.x,
l=e.y;e=0;for(f=p.length;e<f;++e)if(h=p[e],g=h.rc,n.intersects_rect_off(g,k,l)&&(m.set_from_rect(g),m.offset(k,l),m.intersects_segment(a,b,c,d)))if(h.poly){if(h.poly.intersects_segment(k+g.left,l+g.top,a,b,c,d))return p.length=0,!0}else return p.length=0,!0;p.length=0;return!1}if(!e.bquad.intersects_segment(a,b,c,d))return!1;if(!e.collision_poly||e.collision_poly.is_empty())return!0;e.collision_poly.cache_poly(e.width,e.height,e.angle);return e.collision_poly.intersects_segment(e.x,e.y,a,b,c,d)};
a.prototype.typeHasBehavior=function(a,b){if(!b)return!1;var c,d,e,f,h;c=0;for(d=a.behaviors.length;c<d;c++)if(a.behaviors[c].behavior instanceof b)return!0;if(!a.is_family)for(c=0,d=a.families.length;c<d;c++)for(h=a.families[c],e=0,f=h.behaviors.length;e<f;e++)if(h.behaviors[e].behavior instanceof b)return!0;return!1};a.prototype.typeHasNoSaveBehavior=function(a){return this.typeHasBehavior(a,cr.behaviors.NoSave)};a.prototype.typeHasPersistBehavior=function(a){return this.typeHasBehavior(a,cr.behaviors.Persist)};
a.prototype.getSolidBehavior=function(){return this.solidBehavior};a.prototype.getJumpthruBehavior=function(){return this.jumpthruBehavior};var r=[];a.prototype.testOverlapSolid=function(a){var b,c,d;a.update_bbox();this.getSolidCollisionCandidates(a.layer,a.bbox,r);b=0;for(c=r.length;b<c;++b)if(d=r[b],d.extra.solidEnabled&&this.testOverlap(a,d))return r.length=0,d;r.length=0;return null};a.prototype.testRectOverlapSolid=function(a){var b,c,d;this.getSolidCollisionCandidates(null,a,r);b=0;for(c=r.length;b<
c;++b)if(d=r[b],d.extra.solidEnabled&&this.testRectOverlap(a,d))return r.length=0,d;r.length=0;return null};var s=[];a.prototype.testOverlapJumpThru=function(a,b){var c=null;b&&(c=s,c.length=0);a.update_bbox();this.getJumpthruCollisionCandidates(a.layer,a.bbox,r);var d,e,f;d=0;for(e=r.length;d<e;++d)if(f=r[d],f.extra.jumpthruEnabled&&this.testOverlap(a,f))if(b)c.push(f);else return r.length=0,f;r.length=0;return c};a.prototype.pushOutSolid=function(a,b,c,d,e,f){d=d||50;var h=a.x,g=a.y,k,l=null,m=
null;for(k=0;k<d;k++)if(a.x=h+b*k,a.y=g+c*k,a.set_bbox_changed(),!this.testOverlap(a,l)&&((l=this.testOverlapSolid(a))&&(m=l),!l&&(e&&(l=f?this.testOverlap(a,f)?f:null:this.testOverlapJumpThru(a))&&(m=l),!l)))return m&&this.pushInFractional(a,b,c,m,16),!0;a.x=h;a.y=g;a.set_bbox_changed();return!1};a.prototype.pushOut=function(a,b,c,d,e){d=d||50;var f=a.x,h=a.y,g;for(g=0;g<d;g++)if(a.x=f+b*g,a.y=h+c*g,a.set_bbox_changed(),!this.testOverlap(a,e))return!0;a.x=f;a.y=h;a.set_bbox_changed();return!1};a.prototype.pushInFractional=
function(a,b,c,d,e){var f=2,h,g=!1;h=!1;for(var k=a.x,l=a.y;f<=e;)h=1/f,f*=2,a.x+=b*h*(g?1:-1),a.y+=c*h*(g?1:-1),a.set_bbox_changed(),this.testOverlap(a,d)?h=g=!0:(h=g=!1,k=a.x,l=a.y);h&&(a.x=k,a.y=l,a.set_bbox_changed())};a.prototype.pushOutSolidNearest=function(a,b){var c=cr.is_undefined(b)?100:b,d=0,e=a.x,f=a.y,h=0,g=0,k=0,l=this.testOverlapSolid(a);if(!l)return!0;for(;d<=c;){switch(h){case 0:g=0;k=-1;d++;break;case 1:g=1;k=-1;break;case 2:g=1;k=0;break;case 3:k=g=1;break;case 4:g=0;k=1;break;
case 5:g=-1;k=1;break;case 6:g=-1;k=0;break;case 7:k=g=-1}h=(h+1)%8;a.x=cr.floor(e+g*d);a.y=cr.floor(f+k*d);a.set_bbox_changed();if(!this.testOverlap(a,l)&&(l=this.testOverlapSolid(a),!l))return!0}a.x=e;a.y=f;a.set_bbox_changed();return!1};a.prototype.registerCollision=function(a,b){a.collisionsEnabled&&b.collisionsEnabled&&this.registered_collisions.push([a,b])};a.prototype.checkRegisteredCollision=function(a,b){var c,d,e;c=0;for(d=this.registered_collisions.length;c<d;c++)if(e=this.registered_collisions[c],
e[0]==a&&e[1]==b||e[0]==b&&e[1]==a)return!0;return!1};a.prototype.calculateSolidBounceAngle=function(a,b,c,d){var e=a.x,f=a.y,h=cr.max(10,cr.distanceTo(b,c,e,f)),g=cr.angleTo(b,c,e,f),k=d||this.testOverlapSolid(a);if(!k)return cr.clamp_angle(g+cr.PI);var l=k,m,n,s,q,r=cr.to_radians(5);for(m=1;36>m;m++)if(n=g-m*r,a.x=b+Math.cos(n)*h,a.y=c+Math.sin(n)*h,a.set_bbox_changed(),!this.testOverlap(a,l)&&(l=d?null:this.testOverlapSolid(a),!l)){s=n;break}36===m&&(s=cr.clamp_angle(g+cr.PI));l=k;for(m=1;36>m;m++)if(n=
g+m*r,a.x=b+Math.cos(n)*h,a.y=c+Math.sin(n)*h,a.set_bbox_changed(),!this.testOverlap(a,l)&&(l=d?null:this.testOverlapSolid(a),!l)){q=n;break}36===m&&(q=cr.clamp_angle(g+cr.PI));a.x=e;a.y=f;a.set_bbox_changed();if(q===s)return q;a=cr.angleDiff(q,s)/2;a=cr.angleClockwise(q,s)?cr.clamp_angle(s+a+cr.PI):cr.clamp_angle(q+a);s=Math.cos(g);g=Math.sin(g);q=Math.cos(a);a=Math.sin(a);b=s*q+g*a;return cr.angleTo(0,0,s-2*b*q,g-2*b*a)};var q=-1;a.prototype.trigger=function(a,b,c){if(!this.running_layout)return!1;
var d=this.running_layout.event_sheet;if(!d)return!1;var e=!1,f,h,g;q++;var k=d.deep_includes;h=0;for(g=k.length;h<g;++h)f=this.triggerOnSheet(a,b,k[h],c),e=e||f;f=this.triggerOnSheet(a,b,d,c);q--;return e||f};a.prototype.triggerOnSheet=function(a,b,c,d){var e=!1,f,h,g,k;if(b)for(g=this.triggerOnSheetForTypeName(a,b,b.type.name,c,d),e=e||g,k=b.type.families,f=0,h=k.length;f<h;++f)g=this.triggerOnSheetForTypeName(a,b,k[f].name,c,d),e=e||g;else g=this.triggerOnSheetForTypeName(a,b,"system",c,d),e=e||
g;return e};a.prototype.triggerOnSheetForTypeName=function(a,b,c,d,e){var f,h=!1,g=!1,g="undefined"!==typeof e,k=(g?d.fasttriggers:d.triggers)[c];if(!k)return h;var l=null;d=0;for(f=k.length;d<f;++d)if(k[d].method==a){l=k[d].evs;break}if(!l)return h;a=g?l[e]:l;if(!a)return null;d=0;for(f=a.length;d<f;d++)e=a[d][0],g=a[d][1],g=this.executeSingleTrigger(b,c,e,g),h=h||g;return h};a.prototype.executeSingleTrigger=function(a,b,c,d){var e,f,h=!1;this.trigger_depth++;var g=this.getCurrentEventStack().current_event;
g&&this.pushCleanSol(g.solModifiersIncludingParents);var k=1<this.trigger_depth;this.pushCleanSol(c.solModifiersIncludingParents);k&&this.pushLocalVarStack();var l=this.pushEventStack(c);l.current_event=c;a&&(e=this.types[b].getCurrentSol(),e.select_all=!1,e.instances.length=1,e.instances[0]=a,this.types[b].applySolToContainer());a=!0;if(c.parent){b=l.temp_parents_arr;for(e=c.parent;e;)b.push(e),e=e.parent;b.reverse();e=0;for(f=b.length;e<f;e++)if(!b[e].run_pretrigger()){a=!1;break}}a&&(this.execcount++,
c.orblock?c.run_orblocktrigger(d):c.run(),h=h||l.last_event_true);this.popEventStack();k&&this.popLocalVarStack();this.popSol(c.solModifiersIncludingParents);g&&this.popSol(g.solModifiersIncludingParents);0!==this.isInOnDestroy||0!==q||this.isRunningEvents||this.deathRow.isEmpty()&&!this.createRow.length||this.ClearDeathRow();this.trigger_depth--;return h};a.prototype.getCurrentCondition=function(){var a=this.getCurrentEventStack();return a.current_event.conditions[a.cndindex]};a.prototype.getCurrentAction=
function(){var a=this.getCurrentEventStack();return a.current_event.actions[a.actindex]};a.prototype.pushLocalVarStack=function(){this.localvar_stack_index++;this.localvar_stack_index>=this.localvar_stack.length&&this.localvar_stack.push([])};a.prototype.popLocalVarStack=function(){this.localvar_stack_index--};a.prototype.getCurrentLocalVarStack=function(){return this.localvar_stack[this.localvar_stack_index]};a.prototype.pushEventStack=function(a){this.event_stack_index++;this.event_stack_index>=
this.event_stack.length&&this.event_stack.push(new cr.eventStackFrame);var b=this.getCurrentEventStack();b.reset(a);return b};a.prototype.popEventStack=function(){this.event_stack_index--};a.prototype.getCurrentEventStack=function(){return this.event_stack[this.event_stack_index]};a.prototype.pushLoopStack=function(a){this.loop_stack_index++;this.loop_stack_index>=this.loop_stack.length&&this.loop_stack.push(cr.seal({name:a,index:0,stopped:!1}));var b=this.getCurrentLoop();b.name=a;b.index=0;b.stopped=
!1;return b};a.prototype.popLoopStack=function(){this.loop_stack_index--};a.prototype.getCurrentLoop=function(){return this.loop_stack[this.loop_stack_index]};a.prototype.getEventVariableByName=function(a,b){for(var c,d,e,f,h,g;b;){c=0;for(d=b.subevents.length;c<d;c++)if(g=b.subevents[c],g instanceof cr.eventvariable&&cr.equals_nocase(a,g.name))return g;b=b.parent}c=0;for(d=this.eventsheets_by_index.length;c<d;c++)for(h=this.eventsheets_by_index[c],e=0,f=h.events.length;e<f;e++)if(g=h.events[e],g instanceof
cr.eventvariable&&cr.equals_nocase(a,g.name))return g;return null};a.prototype.getLayoutBySid=function(a){var b,c;b=0;for(c=this.layouts_by_index.length;b<c;b++)if(this.layouts_by_index[b].sid===a)return this.layouts_by_index[b];return null};a.prototype.getObjectTypeBySid=function(a){var b,c;b=0;for(c=this.types_by_index.length;b<c;b++)if(this.types_by_index[b].sid===a)return this.types_by_index[b];return null};a.prototype.getGroupBySid=function(a){var b,c;b=0;for(c=this.allGroups.length;b<c;b++)if(this.allGroups[b].sid===
a)return this.allGroups[b];return null};a.prototype.signalContinuousPreview=function(){this.signalledContinuousPreview=!0};a.prototype.handleSaveLoad=function(){var a=this,b=this.saveToSlot,f=this.lastSaveJson,h=this.loadFromSlot,g=!1;this.signalledContinuousPreview&&(g=!0,b="__c2_continuouspreview",this.signalledContinuousPreview=!1);if(b.length){this.ClearDeathRow();f=this.saveToJSONString();if(window.indexedDB&&!this.isCocoonJs)c(b,f,function(){cr.logexport("Saved state to IndexedDB storage ("+
f.length+" bytes)");a.lastSaveJson=f;a.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null);a.lastSaveJson="";g&&e()},function(c){try{localStorage.setItem("__c2save_"+b,f),cr.logexport("Saved state to WebStorage ("+f.length+" bytes)"),a.lastSaveJson=f,a.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null),a.lastSaveJson="",g&&e()}catch(d){cr.logexport("Failed to save game state: "+c+"; "+d)}});else try{localStorage.setItem("__c2save_"+b,f),cr.logexport("Saved state to WebStorage ("+
f.length+" bytes)"),a.lastSaveJson=f,this.trigger(cr.system_object.prototype.cnds.OnSaveComplete,null),a.lastSaveJson="",g&&e()}catch(k){cr.logexport("Error saving to WebStorage: "+k)}this.loadFromJson=this.loadFromSlot=this.saveToSlot=""}h.length&&(window.indexedDB&&!this.isCocoonJs?d(h,function(b){b?(a.loadFromJson=b,cr.logexport("Loaded state from IndexedDB storage ("+a.loadFromJson.length+" bytes)")):(a.loadFromJson=localStorage.getItem("__c2save_"+h)||"",cr.logexport("Loaded state from WebStorage ("+
a.loadFromJson.length+" bytes)"));a.suspendDrawing=!1;a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)},function(b){a.loadFromJson=localStorage.getItem("__c2save_"+h)||"";cr.logexport("Loaded state from WebStorage ("+a.loadFromJson.length+" bytes)");a.suspendDrawing=!1;a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)}):(this.loadFromJson=localStorage.getItem("__c2save_"+h)||"",cr.logexport("Loaded state from WebStorage ("+this.loadFromJson.length+
" bytes)"),this.suspendDrawing=!1,a.loadFromJson.length||a.trigger(cr.system_object.prototype.cnds.OnLoadFailed,null)),this.saveToSlot=this.loadFromSlot="");this.loadFromJson.length&&(this.ClearDeathRow(),this.loadFromJSONString(this.loadFromJson),this.lastSaveJson=this.loadFromJson,this.trigger(cr.system_object.prototype.cnds.OnLoadComplete,null),this.loadFromJson=this.lastSaveJson="")};a.prototype.saveToJSONString=function(){var a,b,c,d,e,f,g,k={c2save:!0,version:1,rt:{time:this.kahanTime.sum,timescale:this.timescale,
tickcount:this.tickcount,execcount:this.execcount,next_uid:this.next_uid,running_layout:this.running_layout.sid,start_time_offset:Date.now()-this.start_time},types:{},layouts:{},events:{groups:{},cnds:{},acts:{},vars:{}}};a=0;for(b=this.types_by_index.length;a<b;a++)if(e=this.types_by_index[a],!e.is_family&&!this.typeHasNoSaveBehavior(e)){f={instances:[]};cr.hasAnyOwnProperty(e.extra)&&(f.ex=h(e.extra));c=0;for(d=e.instances.length;c<d;c++)f.instances.push(this.saveInstanceToJSON(e.instances[c]));
k.types[e.sid.toString()]=f}a=0;for(b=this.layouts_by_index.length;a<b;a++)c=this.layouts_by_index[a],k.layouts[c.sid.toString()]=c.saveToJSON();d=k.events.groups;a=0;for(b=this.allGroups.length;a<b;a++)c=this.allGroups[a],d[c.sid.toString()]=this.groups_by_name[c.group_name].group_active;b=k.events.cnds;for(g in this.cndsBySid)this.cndsBySid.hasOwnProperty(g)&&(a=this.cndsBySid[g],cr.hasAnyOwnProperty(a.extra)&&(b[g]={ex:h(a.extra)}));b=k.events.acts;for(g in this.actsBySid)this.actsBySid.hasOwnProperty(g)&&
(a=this.actsBySid[g],cr.hasAnyOwnProperty(a.extra)&&(b[g]={ex:a.extra}));b=k.events.vars;for(g in this.varsBySid)this.varsBySid.hasOwnProperty(g)&&(a=this.varsBySid[g],a.is_constant||a.parent&&!a.is_static||(b[g]=a.data));k.system=this.system.saveToJSON();return JSON.stringify(k)};a.prototype.refreshUidMap=function(){var a,b,c,d,e,f;this.objectsByUid={};a=0;for(b=this.types_by_index.length;a<b;a++)if(c=this.types_by_index[a],!c.is_family)for(d=0,e=c.instances.length;d<e;d++)f=c.instances[d],this.objectsByUid[f.uid.toString()]=
f};a.prototype.loadFromJSONString=function(a){a=JSON.parse(a);if(a.c2save&&!(1<a.version)){var b=a.rt;this.kahanTime.reset();this.kahanTime.sum=b.time;this.timescale=b.timescale;this.tickcount=b.tickcount;this.start_time=Date.now()-b.start_time_offset;var c=b.running_layout;if(c!==this.running_layout.sid)if(c=this.getLayoutBySid(c))this.doChangeLayout(c);else return;this.isLoadingState=!0;var d,e,f,g,h,k,l;k=a.types;for(e in k)if(k.hasOwnProperty(e)&&(g=this.getObjectTypeBySid(parseInt(e,10)))&&!g.is_family&&
!this.typeHasNoSaveBehavior(g)){k[e].ex?g.extra=k[e].ex:cr.wipe(g.extra);h=g.instances;f=k[e].instances;c=0;for(d=cr.min(h.length,f.length);c<d;c++)this.loadInstanceFromJSON(h[c],f[c]);c=f.length;for(d=h.length;c<d;c++)this.DestroyInstance(h[c]);c=h.length;for(d=f.length;c<d;c++){h=null;if(g.plugin.is_world&&(h=this.running_layout.getLayerBySid(f[c].w.l),!h))continue;h=this.createInstanceFromInit(g.default_instance,h,!1,0,0,!0);this.loadInstanceFromJSON(h,f[c])}g.stale_iids=!0}this.ClearDeathRow();
this.refreshUidMap();d=a.layouts;for(e in d)d.hasOwnProperty(e)&&(c=this.getLayoutBySid(parseInt(e,10)))&&c.loadFromJSON(d[e]);d=a.events.groups;for(e in d)d.hasOwnProperty(e)&&(c=this.getGroupBySid(parseInt(e,10)))&&this.groups_by_name[c.group_name]&&(this.groups_by_name[c.group_name].group_active=d[e]);c=a.events.cnds;for(e in c)c.hasOwnProperty(e)&&this.cndsBySid.hasOwnProperty(e)&&(this.cndsBySid[e].extra=c[e].ex);c=a.events.acts;for(e in c)c.hasOwnProperty(e)&&this.actsBySid.hasOwnProperty(e)&&
(this.actsBySid[e].extra=c[e].ex);c=a.events.vars;for(e in c)c.hasOwnProperty(e)&&this.varsBySid.hasOwnProperty(e)&&(this.varsBySid[e].data=c[e]);this.next_uid=b.next_uid;this.isLoadingState=!1;this.system.loadFromJSON(a.system);c=0;for(d=this.types_by_index.length;c<d;c++)if(g=this.types_by_index[c],!g.is_family)for(e=0,a=g.instances.length;e<a;e++){h=g.instances[e];if(g.is_contained)for(k=h.get_iid(),b=h.siblings.length=0,f=g.container.length;b<f;b++)l=g.container[b],g!==l&&h.siblings.push(l.instances[k]);
h.afterLoad&&h.afterLoad();if(h.behavior_insts)for(b=0,f=h.behavior_insts.length;b<f;b++)k=h.behavior_insts[b],k.afterLoad&&k.afterLoad()}this.redraw=!0}};a.prototype.saveInstanceToJSON=function(a,b){var c,d,e,f,g;f=a.type;e=f.plugin;var k={};b?k.c2=!0:k.uid=a.uid;cr.hasAnyOwnProperty(a.extra)&&(k.ex=h(a.extra));if(a.instance_vars&&a.instance_vars.length)for(k.ivs={},c=0,d=a.instance_vars.length;c<d;c++)k.ivs[a.type.instvar_sids[c].toString()]=a.instance_vars[c];if(e.is_world){e={x:a.x,y:a.y,w:a.width,
h:a.height,l:a.layer.sid,zi:a.get_zindex()};0!==a.angle&&(e.a=a.angle);1!==a.opacity&&(e.o=a.opacity);0.5!==a.hotspotX&&(e.hX=a.hotspotX);0.5!==a.hotspotY&&(e.hY=a.hotspotY);0!==a.blend_mode&&(e.bm=a.blend_mode);a.visible||(e.v=a.visible);a.collisionsEnabled||(e.ce=a.collisionsEnabled);-1!==a.my_timescale&&(e.mts=a.my_timescale);if(f.effect_types.length)for(e.fx=[],c=0,d=f.effect_types.length;c<d;c++)g=f.effect_types[c],e.fx.push({name:g.name,active:a.active_effect_flags[g.index],params:a.effect_params[g.index]});
k.w=e}if(a.behavior_insts&&a.behavior_insts.length)for(k.behs={},c=0,d=a.behavior_insts.length;c<d;c++)f=a.behavior_insts[c],f.saveToJSON&&(k.behs[f.type.sid.toString()]=f.saveToJSON());a.saveToJSON&&(k.data=a.saveToJSON());return k};a.prototype.getInstanceVarIndexBySid=function(a,b){var c,d;c=0;for(d=a.instvar_sids.length;c<d;c++)if(a.instvar_sids[c]===b)return c;return-1};a.prototype.getBehaviorIndexBySid=function(a,b){var c,d;c=0;for(d=a.behavior_insts.length;c<d;c++)if(a.behavior_insts[c].type.sid===
b)return c;return-1};a.prototype.loadInstanceFromJSON=function(a,b,c){var d,e,f,g,h;h=a.type;f=h.plugin;if(c){if(!b.c2)return}else a.uid=b.uid;b.ex?a.extra=b.ex:cr.wipe(a.extra);if(e=b.ivs)for(d in e)e.hasOwnProperty(d)&&(c=this.getInstanceVarIndexBySid(h,parseInt(d,10)),0>c||c>=a.instance_vars.length||(a.instance_vars[c]=e[d]));if(f.is_world){f=b.w;a.layer.sid!==f.l&&(c=a.layer,a.layer=this.running_layout.getLayerBySid(f.l),a.layer?(a.layer.instances.push(a),a.layer.zindices_stale=!0,cr.arrayFindRemove(c.instances,
a),c.zindices_stale=!0):(a.layer=c,this.DestroyInstance(a)));a.x=f.x;a.y=f.y;a.width=f.w;a.height=f.h;a.zindex=f.zi;a.angle=f.hasOwnProperty("a")?f.a:0;a.opacity=f.hasOwnProperty("o")?f.o:1;a.hotspotX=f.hasOwnProperty("hX")?f.hX:0.5;a.hotspotY=f.hasOwnProperty("hY")?f.hY:0.5;a.visible=f.hasOwnProperty("v")?f.v:!0;a.collisionsEnabled=f.hasOwnProperty("ce")?f.ce:!0;a.my_timescale=f.hasOwnProperty("mts")?f.mts:-1;a.blend_mode=f.hasOwnProperty("bm")?f.bm:0;a.compositeOp=cr.effectToCompositeOp(a.blend_mode);
this.gl&&cr.setGLBlend(a,a.blend_mode,this.gl);a.set_bbox_changed();if(f.hasOwnProperty("fx"))for(c=0,e=f.fx.length;c<e;c++)g=h.getEffectIndexByName(f.fx[c].name),0>g||(a.active_effect_flags[g]=f.fx[c].active,a.effect_params[g]=f.fx[c].params);a.updateActiveEffects()}if(h=b.behs)for(d in h)h.hasOwnProperty(d)&&(f=this.getBehaviorIndexBySid(a,parseInt(d,10)),0>f||a.behavior_insts[f].loadFromJSON(h[d]));b.data&&a.loadFromJSON(b.data)};cr.runtime=a;cr.createRuntime=function(b){return new a(document.getElementById(b))};
cr.createDCRuntime=function(b,c){return new a({dc:!0,width:b,height:c})};window.cr_createRuntime=cr.createRuntime;window.cr_createDCRuntime=cr.createDCRuntime;window.createCocoonJSRuntime=function(){window.c2cocoonjs=!0;var b=document.createElement("screencanvas")||document.createElement("canvas");b.screencanvas=!0;document.body.appendChild(b);b=new a(b);window.c2runtime=b;window.addEventListener("orientationchange",function(){window.c2runtime.setSize(window.innerWidth,window.innerHeight)});window.c2runtime.setSize(window.innerWidth,
window.innerHeight);return b};window.createEjectaRuntime=function(){var b=document.getElementById("canvas"),b=new a(b);window.c2runtime=b;window.c2runtime.setSize(window.innerWidth,window.innerHeight);return b}})();window.cr_getC2Runtime=function(){var a=document.getElementById("c2canvas");return a?a.c2runtime:window.c2runtime?window.c2runtime:null};window.cr_sizeCanvas=function(a,b){if(0!==a&&0!==b){var c=window.cr_getC2Runtime();c&&c.setSize(a,b)}};
window.cr_setSuspended=function(a){var b=window.cr_getC2Runtime();b&&b.setSuspended(a)};
(function(){function a(a,b){this.runtime=a;this.event_sheet=null;this.scrollX=this.runtime.original_width/2;this.scrollY=this.runtime.original_height/2;this.scale=1;this.angle=0;this.first_visit=!0;this.name=b[0];this.width=b[1];this.height=b[2];this.unbounded_scrolling=b[3];this.sheetname=b[4];this.sid=b[5];var c=b[6],d,k;this.layers=[];this.initial_types=[];d=0;for(k=c.length;d<k;d++){var g=new cr.layer(this,c[d]);g.number=d;cr.seal(g);this.layers.push(g)}c=b[7];this.initial_nonworld=[];d=0;for(k=
c.length;d<k;d++){var g=c[d],m=this.runtime.types_by_index[g[1]];m.default_instance||(m.default_instance=g);this.initial_nonworld.push(g);-1===this.initial_types.indexOf(m)&&this.initial_types.push(m)}this.effect_types=[];this.active_effect_types=[];this.effect_params=[];d=0;for(k=b[8].length;d<k;d++)this.effect_types.push({id:b[8][d][0],name:b[8][d][1],shaderindex:-1,active:!0,index:d}),this.effect_params.push(b[8][d][2].slice(0));this.updateActiveEffects();this.rcTex=new cr.rect(0,0,1,1);this.rcTex2=
new cr.rect(0,0,1,1);this.persist_data={}}function b(a,b){this.layout=a;this.runtime=a.runtime;this.instances=[];this.scale=1;this.angle=0;this.disableAngle=!1;this.tmprect=new cr.rect(0,0,0,0);this.tmpquad=new cr.quad;this.viewBottom=this.viewTop=this.viewRight=this.viewLeft=0;this.zindices_stale=!1;this.name=b[0];this.index=b[1];this.sid=b[2];this.visible=b[3];this.background_color=b[4];this.transparent=b[5];this.parallaxX=b[6];this.parallaxY=b[7];this.opacity=b[8];this.forceOwnTexture=b[9];this.zoomRate=
b[10];this.blend_mode=b[11];this.effect_fallback=b[12];this.compositeOp="source-over";this.destBlend=this.srcBlend=0;this.render_offscreen=!1;var c=b[13],d,k;this.initial_instances=[];d=0;for(k=c.length;d<k;d++){var g=c[d],m=this.runtime.types_by_index[g[1]];m.default_instance||(m.default_instance=g,m.default_layerindex=this.index);this.initial_instances.push(g);-1===this.layout.initial_types.indexOf(m)&&this.layout.initial_types.push(m)}this.effect_types=[];this.active_effect_types=[];this.effect_params=
[];d=0;for(k=b[14].length;d<k;d++)this.effect_types.push({id:b[14][d][0],name:b[14][d][1],shaderindex:-1,active:!0,index:d}),this.effect_params.push(b[14][d][2].slice(0));this.updateActiveEffects();this.rcTex=new cr.rect(0,0,1,1);this.rcTex2=new cr.rect(0,0,1,1)}function c(a,b){return a.zindex-b.zindex}a.prototype.saveObjectToPersist=function(a){var b=a.type.sid.toString();this.persist_data.hasOwnProperty(b)||(this.persist_data[b]=[]);this.persist_data[b].push(this.runtime.saveInstanceToJSON(a))};
a.prototype.hasOpaqueBottomLayer=function(){var a=this.layers[0];return!a.transparent&&1===a.opacity&&!a.forceOwnTexture&&a.visible};a.prototype.updateActiveEffects=function(){this.active_effect_types.length=0;var a,b,c;a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],c.active&&this.active_effect_types.push(c)};a.prototype.getEffectByName=function(a){var b,c,d;b=0;for(c=this.effect_types.length;b<c;b++)if(d=this.effect_types[b],d.name===a)return d;return null};var d=[];a.prototype.startRunning=
function(){this.sheetname&&(this.event_sheet=this.runtime.eventsheets[this.sheetname],this.event_sheet.updateDeepIncludes());this.runtime.running_layout=this;this.scrollX=this.runtime.original_width/2;this.scrollY=this.runtime.original_height/2;var a,b,f,l,k,g,m;a=0;for(f=this.runtime.types_by_index.length;a<f;a++)if(b=this.runtime.types_by_index[a],!b.is_family)for(k=b.instances,b=0,l=k.length;b<l;b++)if(g=k[b],g.layer){var n=g.layer.number;n>=this.layers.length&&(n=this.layers.length-1);g.layer=
this.layers[n];g.layer.instances.push(g);g.layer.zindices_stale=!0}d.length=0;this.boundScrolling();a=0;for(f=this.layers.length;a<f;a++)g=this.layers[a],g.createInitialInstances(),g.disableAngle=!0,b=g.canvasToLayer(0,0,!0,!0),l=g.canvasToLayer(0,0,!1,!0),g.disableAngle=!1,this.runtime.pixel_rounding&&(b=b+0.5|0,l=l+0.5|0),g.rotateViewport(b,l,null);k=!1;if(!this.first_visit){for(m in this.persist_data)if(this.persist_data.hasOwnProperty(m)&&(b=this.runtime.getObjectTypeBySid(parseInt(m,10)))&&!b.is_family&&
this.runtime.typeHasPersistBehavior(b)){l=this.persist_data[m];a=0;for(f=l.length;a<f;a++){g=null;if(b.plugin.is_world&&(g=this.getLayerBySid(l[a].w.l),!g))continue;g=this.runtime.createInstanceFromInit(b.default_instance,g,!1,0,0,!0);this.runtime.loadInstanceFromJSON(g,l[a]);k=!0;d.push(g)}l.length=0}a=0;for(f=this.layers.length;a<f;a++)this.layers[a].instances.sort(c),this.layers[a].zindices_stale=!0}k&&(this.runtime.ClearDeathRow(),this.runtime.refreshUidMap());for(a=0;a<d.length;a++)if(g=d[a],
g.type.is_contained)for(f=g.get_iid(),b=0,l=g.type.container.length;b<l;b++)m=g.type.container[b],g.type!==m&&(m.instances.length>f?g.siblings.push(m.instances[f]):m.default_instance&&(k=this.runtime.createInstanceFromInit(m.default_instance,g.layer,!0,g.x,g.y,!0),this.runtime.ClearDeathRow(),m.updateIIDs(),g.siblings.push(k),d.push(k)));a=0;for(f=this.initial_nonworld.length;a<f;a++)this.runtime.createInstanceFromInit(this.initial_nonworld[a],null,!0);this.runtime.changelayout=null;this.runtime.ClearDeathRow();
if(this.runtime.ctx&&!this.runtime.isDomFree)for(a=0,f=this.runtime.types_by_index.length;a<f;a++)m=this.runtime.types_by_index[a],!m.is_family&&m.instances.length&&m.preloadCanvas2D&&m.preloadCanvas2D(this.runtime.ctx);a=0;for(f=d.length;a<f;a++)g=d[a],this.runtime.trigger(Object.getPrototypeOf(g.type.plugin).cnds.OnCreated,g);d.length=0;this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutStart,null);this.first_visit=!1};a.prototype.createGlobalNonWorlds=function(){var a,b,c,d,k;b=a=0;for(c=
this.initial_nonworld.length;a<c;a++)d=this.initial_nonworld[a],k=this.runtime.types_by_index[d[1]],k.global?this.runtime.createInstanceFromInit(d,null,!0):(this.initial_nonworld[b]=d,b++);this.initial_nonworld.length=b};a.prototype.stopRunning=function(){this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutEnd,null);this.runtime.system.waits.length=0;var a,b,c,d,k,g;a=0;for(b=this.layers.length;a<b;a++){k=this.layers[a].instances;c=0;for(d=k.length;c<d;c++)g=k[c],g.type.global||(this.runtime.typeHasPersistBehavior(g.type)&&
this.saveObjectToPersist(g),this.runtime.DestroyInstance(g));this.runtime.ClearDeathRow();k.length=0;this.layers[a].zindices_stale=!0}a=0;for(b=this.runtime.types_by_index.length;a<b;a++)if(k=this.runtime.types_by_index[a],!(k.global||k.plugin.is_world||k.plugin.singleglobal||k.is_family)){c=0;for(d=k.instances.length;c<d;c++)this.runtime.DestroyInstance(k.instances[c]);this.runtime.ClearDeathRow()}};a.prototype.draw=function(a){var b,c=a,d=!1,k=!this.runtime.fullscreenScalingQuality;k&&(this.runtime.layout_canvas||
(this.runtime.layout_canvas=document.createElement("canvas"),b=this.runtime.layout_canvas,b.width=this.runtime.draw_width,b.height=this.runtime.draw_height,this.runtime.layout_ctx=b.getContext("2d"),d=!0),b=this.runtime.layout_canvas,c=this.runtime.layout_ctx,b.width!==this.runtime.draw_width&&(b.width=this.runtime.draw_width,d=!0),b.height!==this.runtime.draw_height&&(b.height=this.runtime.draw_height,d=!0),d&&(c.webkitImageSmoothingEnabled=this.runtime.linearSampling,c.mozImageSmoothingEnabled=
this.runtime.linearSampling,c.msImageSmoothingEnabled=this.runtime.linearSampling,c.imageSmoothingEnabled=this.runtime.linearSampling));c.globalAlpha=1;c.globalCompositeOperation="source-over";this.runtime.alphaBackground&&!this.hasOpaqueBottomLayer()&&c.clearRect(0,0,this.runtime.draw_width,this.runtime.draw_height);var g,m,d=0;for(g=this.layers.length;d<g;d++)m=this.layers[d],m.visible&&0<m.opacity&&11!==m.blend_mode&&m.draw(c);k&&a.drawImage(b,0,0,this.runtime.width,this.runtime.height)};a.prototype.drawGL=
function(a){var b=0<this.active_effect_types.length||this.runtime.uses_background_blending||!this.runtime.fullscreenScalingQuality;if(b){this.runtime.layout_tex||(this.runtime.layout_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling));if(this.runtime.layout_tex.c2width!==this.runtime.draw_width||this.runtime.layout_tex.c2height!==this.runtime.draw_height)a.deleteTexture(this.runtime.layout_tex),this.runtime.layout_tex=a.createEmptyTexture(this.runtime.draw_width,
this.runtime.draw_height,this.runtime.linearSampling);a.setRenderingToTexture(this.runtime.layout_tex);this.runtime.fullscreenScalingQuality||a.setSize(this.runtime.draw_width,this.runtime.draw_height)}else this.runtime.layout_tex&&(a.setRenderingToTexture(null),a.deleteTexture(this.runtime.layout_tex),this.runtime.layout_tex=null);this.runtime.alphaBackground&&!this.hasOpaqueBottomLayer()&&a.clear(0,0,0,0);var c,d;c=0;for(d=this.layers.length;c<d;c++)this.layers[c].visible&&0<this.layers[c].opacity&&
this.layers[c].drawGL(a);b&&(0===this.active_effect_types.length||1===this.active_effect_types.length&&this.runtime.fullscreenScalingQuality?(1===this.active_effect_types.length?(b=this.active_effect_types[0].index,a.switchProgram(this.active_effect_types[0].shaderindex),a.setProgramParameters(null,1/this.runtime.draw_width,1/this.runtime.draw_height,0,0,1,1,this.scale,this.angle,0,0,this.effect_params[b]),a.programIsAnimated(this.active_effect_types[0].shaderindex)&&(this.runtime.redraw=!0)):a.switchProgram(0),
this.runtime.fullscreenScalingQuality||a.setSize(this.runtime.width,this.runtime.height),a.setRenderingToTexture(null),a.setOpacity(1),a.setTexture(this.runtime.layout_tex),a.setAlphaBlend(),a.resetModelView(),a.updateModelView(),b=this.runtime.width/2,c=this.runtime.height/2,a.quad(-b,c,b,c,b,-c,-b,-c),a.setTexture(null)):this.renderEffectChain(a,null,null,null))};a.prototype.getRenderTarget=function(){return 0<this.active_effect_types.length||this.runtime.uses_background_blending||!this.runtime.fullscreenScalingQuality?
this.runtime.layout_tex:null};a.prototype.getMinLayerScale=function(){var a=this.layers[0].getScale(),b,c,d;b=1;for(c=this.layers.length;b<c;b++)d=this.layers[b],(0!==d.parallaxX||0!==d.parallaxY)&&d.getScale()<a&&(a=d.getScale());return a};a.prototype.scrollToX=function(a){if(!this.unbounded_scrolling){var b=this.runtime.draw_width*(1/this.getMinLayerScale())/2;a>this.width-b&&(a=this.width-b);a<b&&(a=b)}this.scrollX!==a&&(this.scrollX=a,this.runtime.redraw=!0)};a.prototype.scrollToY=function(a){if(!this.unbounded_scrolling){var b=
this.runtime.draw_height*(1/this.getMinLayerScale())/2;a>this.height-b&&(a=this.height-b);a<b&&(a=b)}this.scrollY!==a&&(this.scrollY=a,this.runtime.redraw=!0)};a.prototype.boundScrolling=function(){this.scrollToX(this.scrollX);this.scrollToY(this.scrollY)};a.prototype.renderEffectChain=function(a,b,c,d){var k=c?c.active_effect_types:b?b.active_effect_types:this.active_effect_types,g=1,m=0,n=0,p=0;c?(g=c.layer.getScale(),m=c.layer.getAngle(),n=c.layer.viewLeft,p=c.layer.viewTop):b&&(g=b.getScale(),
m=b.getAngle(),n=b.viewLeft,p=b.viewTop);var r=this.runtime.fx_tex,s,q,t,u,C=0,J=1,G,A=this.runtime.draw_width,v=this.runtime.draw_height,w=A/2,x=v/2,y=b?b.rcTex:this.rcTex,D=b?b.rcTex2:this.rcTex2,z=0,H=0,I=0,S=0,E=A,T=A,K=v,R=v,L=t=0,B=c?c.layer.getAngle():0;if(c){s=0;for(q=k.length;s<q;s++)t+=a.getProgramBoxExtendHorizontal(k[s].shaderindex),L+=a.getProgramBoxExtendVertical(k[s].shaderindex);u=c.bbox;z=b.layerToCanvas(u.left,u.top,!0,!0);I=b.layerToCanvas(u.left,u.top,!1,!0);E=b.layerToCanvas(u.right,
u.bottom,!0,!0);K=b.layerToCanvas(u.right,u.bottom,!1,!0);0!==B&&(s=b.layerToCanvas(u.right,u.top,!0,!0),q=b.layerToCanvas(u.right,u.top,!1,!0),H=b.layerToCanvas(u.left,u.bottom,!0,!0),S=b.layerToCanvas(u.left,u.bottom,!1,!0),u=Math.min(z,E,s,H),E=Math.max(z,E,s,H),z=u,u=Math.min(I,K,q,S),K=Math.max(I,K,q,S),I=u);z-=t;I-=L;E+=t;K+=L;D.left=z/A;D.top=1-I/v;D.right=E/A;D.bottom=1-K/v;H=z=cr.floor(z);S=I=cr.floor(I);T=E=cr.ceil(E);R=K=cr.ceil(K);H-=t;S-=L;T+=t;R+=L;0>z&&(z=0);0>I&&(I=0);E>A&&(E=A);K>
v&&(K=v);0>H&&(H=0);0>S&&(S=0);T>A&&(T=A);R>v&&(R=v);y.left=z/A;y.top=1-I/v;y.right=E/A;y.bottom=1-K/v}else y.left=D.left=0,y.top=D.top=0,y.right=D.right=1,y.bottom=D.bottom=1;L=c&&((c.angle||B)&&a.programUsesDest(k[0].shaderindex)||0!==t||0!==L||1!==c.opacity||c.type.plugin.must_predraw)||b&&!c&&1!==b.opacity;a.setAlphaBlend();if(L){r[C]||(r[C]=a.createEmptyTexture(A,v,this.runtime.linearSampling));if(r[C].c2width!==A||r[C].c2height!==v)a.deleteTexture(r[C]),r[C]=a.createEmptyTexture(A,v,this.runtime.linearSampling);
a.switchProgram(0);a.setRenderingToTexture(r[C]);G=R-S;a.clearRect(H,v-S-G,T-H,G);c?c.drawGL(a):(a.setTexture(this.runtime.layer_tex),a.setOpacity(b.opacity),a.resetModelView(),a.translate(-w,-x),a.updateModelView(),a.quadTex(z,K,E,K,E,I,z,I,y));D.left=D.top=0;D.right=D.bottom=1;c&&(u=y.top,y.top=y.bottom,y.bottom=u);C=1;J=0}a.setOpacity(1);t=k.length-1;var B=a.programUsesCrossSampling(k[t].shaderindex)||!b&&!c&&!this.runtime.fullscreenScalingQuality,N=0;s=0;for(q=k.length;s<q;s++){r[C]||(r[C]=a.createEmptyTexture(A,
v,this.runtime.linearSampling));if(r[C].c2width!==A||r[C].c2height!==v)a.deleteTexture(r[C]),r[C]=a.createEmptyTexture(A,v,this.runtime.linearSampling);a.switchProgram(k[s].shaderindex);N=k[s].index;a.programIsAnimated(k[s].shaderindex)&&(this.runtime.redraw=!0);0!=s||L?(a.setProgramParameters(d,1/A,1/v,D.left,D.top,D.right,D.bottom,g,m,n,p,c?c.effect_params[N]:b?b.effect_params[N]:this.effect_params[N]),a.setTexture(null),s!==t||B?(a.setRenderingToTexture(r[C]),G=R-S,u=v-S-G,a.clearRect(H,u,T-H,
G)):(c?a.setBlend(c.srcBlend,c.destBlend):b&&a.setBlend(b.srcBlend,b.destBlend),a.setRenderingToTexture(d)),a.setTexture(r[J]),a.resetModelView(),a.translate(-w,-x),a.updateModelView(),a.quadTex(z,K,E,K,E,I,z,I,y),s!==t||B||a.setTexture(null)):(a.setRenderingToTexture(r[C]),G=R-S,u=v-S-G,a.clearRect(H,u,T-H,G),c?(a.setProgramParameters(d,1/c.width,1/c.height,D.left,D.top,D.right,D.bottom,g,m,n,p,c.effect_params[N]),c.drawGL(a)):(a.setProgramParameters(d,1/A,1/v,0,0,1,1,g,m,n,p,b?b.effect_params[N]:
this.effect_params[N]),a.setTexture(b?this.runtime.layer_tex:this.runtime.layout_tex),a.resetModelView(),a.translate(-w,-x),a.updateModelView(),a.quadTex(z,K,E,K,E,I,z,I,y)),D.left=D.top=0,D.right=D.bottom=1,c&&!B&&(u=K,K=I,I=u));C=0===C?1:0;J=0===C?1:0}B&&(a.switchProgram(0),c?a.setBlend(c.srcBlend,c.destBlend):b?a.setBlend(b.srcBlend,b.destBlend):this.runtime.fullscreenScalingQuality||(a.setSize(this.runtime.width,this.runtime.height),w=this.runtime.width/2,x=this.runtime.height/2,I=z=0,E=this.runtime.width,
K=this.runtime.height),a.setRenderingToTexture(d),a.setTexture(r[J]),a.resetModelView(),a.translate(-w,-x),a.updateModelView(),c&&1===k.length&&!L?a.quadTex(z,I,E,I,E,K,z,K,y):a.quadTex(z,K,E,K,E,I,z,I,y),a.setTexture(null))};a.prototype.getLayerBySid=function(a){var b,c;b=0;for(c=this.layers.length;b<c;b++)if(this.layers[b].sid===a)return this.layers[b];return null};a.prototype.saveToJSON=function(){var a,b,c,d={sx:this.scrollX,sy:this.scrollY,s:this.scale,a:this.angle,w:this.width,h:this.height,
fv:this.first_visit,persist:this.persist_data,fx:[],layers:{}};a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],d.fx.push({name:c.name,active:c.active,params:this.effect_params[c.index]});a=0;for(b=this.layers.length;a<b;a++)c=this.layers[a],d.layers[c.sid.toString()]=c.saveToJSON();return d};a.prototype.loadFromJSON=function(a){var b,c,d,k;this.scrollX=a.sx;this.scrollY=a.sy;this.scale=a.s;this.angle=a.a;this.width=a.w;this.height=a.h;this.persist_data=a.persist;"undefined"!==typeof a.fv&&
(this.first_visit=a.fv);var g=a.fx;b=0;for(c=g.length;b<c;b++)if(d=this.getEffectByName(g[b].name))d.active=g[b].active,this.effect_params[d.index]=g[b].params;this.updateActiveEffects();b=a.layers;for(k in b)b.hasOwnProperty(k)&&(a=this.getLayerBySid(parseInt(k,10)))&&a.loadFromJSON(b[k])};cr.layout=a;b.prototype.updateActiveEffects=function(){this.active_effect_types.length=0;var a,b,c;a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],c.active&&this.active_effect_types.push(c)};
b.prototype.getEffectByName=function(a){var b,c,d;b=0;for(c=this.effect_types.length;b<c;b++)if(d=this.effect_types[b],d.name===a)return d;return null};b.prototype.createInitialInstances=function(){var a,b,c,l,k,g;b=a=0;for(c=this.initial_instances.length;a<c;a++){l=this.initial_instances[a];k=this.runtime.types_by_index[l[1]];g=this.runtime.typeHasPersistBehavior(k);k=!0;if(!g||this.layout.first_visit)l=this.runtime.createInstanceFromInit(l,this,!0),d.push(l),l.type.global&&(k=!1);k&&(this.initial_instances[b]=
this.initial_instances[a],b++)}this.initial_instances.length=b;this.runtime.ClearDeathRow();!this.runtime.glwrap&&this.effect_types.length&&(this.blend_mode=this.effect_fallback);this.compositeOp=cr.effectToCompositeOp(this.blend_mode);this.runtime.gl&&cr.setGLBlend(this,this.blend_mode,this.runtime.gl)};b.prototype.updateZIndices=function(){if(this.zindices_stale){var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].zindex=a;this.zindices_stale=!1}};b.prototype.getScale=function(a){return this.getNormalScale()*
(this.runtime.fullscreenScalingQuality||a?this.runtime.aspect_scale:1)};b.prototype.getNormalScale=function(){return(this.scale*this.layout.scale-1)*this.zoomRate+1};b.prototype.getAngle=function(){return this.disableAngle?0:cr.clamp_angle(this.layout.angle+this.angle)};b.prototype.draw=function(a){this.render_offscreen=this.forceOwnTexture||1!==this.opacity||0!==this.blend_mode;var b=this.runtime.canvas,c=a,d=!1;this.render_offscreen&&(this.runtime.layer_canvas||(this.runtime.layer_canvas=document.createElement("canvas"),
b=this.runtime.layer_canvas,b.width=this.runtime.draw_width,b.height=this.runtime.draw_height,this.runtime.layer_ctx=b.getContext("2d"),d=!0),b=this.runtime.layer_canvas,c=this.runtime.layer_ctx,b.width!==this.runtime.draw_width&&(b.width=this.runtime.draw_width,d=!0),b.height!==this.runtime.draw_height&&(b.height=this.runtime.draw_height,d=!0),d&&(c.webkitImageSmoothingEnabled=this.runtime.linearSampling,c.mozImageSmoothingEnabled=this.runtime.linearSampling,c.msImageSmoothingEnabled=this.runtime.linearSampling,
c.imageSmoothingEnabled=this.runtime.linearSampling),this.transparent&&c.clearRect(0,0,this.runtime.draw_width,this.runtime.draw_height));c.globalAlpha=1;c.globalCompositeOperation="source-over";this.transparent||(c.fillStyle="rgb("+this.background_color[0]+","+this.background_color[1]+","+this.background_color[2]+")",c.fillRect(0,0,this.runtime.draw_width,this.runtime.draw_height));c.save();this.disableAngle=!0;var d=this.canvasToLayer(0,0,!0,!0),k=this.canvasToLayer(0,0,!1,!0);this.disableAngle=
!1;this.runtime.pixel_rounding&&(d=d+0.5|0,k=k+0.5|0);this.rotateViewport(d,k,c);var g=this.getScale();c.scale(g,g);c.translate(-d,-k);for(var m,d=0,k=this.instances.length;d<k;d++)g=this.instances[d],g.visible&&0!==g.width&&0!==g.height&&(g.update_bbox(),m=g.bbox,m.right<this.viewLeft||m.bottom<this.viewTop||m.left>this.viewRight||m.top>this.viewBottom||(c.globalCompositeOperation=g.compositeOp,g.draw(c)));c.restore();this.render_offscreen&&(a.globalCompositeOperation=this.compositeOp,a.globalAlpha=
this.opacity,a.drawImage(b,0,0))};b.prototype.rotateViewport=function(a,b,c){var d=this.getScale();this.viewLeft=a;this.viewTop=b;this.viewRight=a+1/d*this.runtime.draw_width;this.viewBottom=b+1/d*this.runtime.draw_height;a=this.getAngle();0!==a&&(c&&(c.translate(this.runtime.draw_width/2,this.runtime.draw_height/2),c.rotate(-a),c.translate(this.runtime.draw_width/-2,this.runtime.draw_height/-2)),this.tmprect.set(this.viewLeft,this.viewTop,this.viewRight,this.viewBottom),this.tmprect.offset((this.viewLeft+
this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2),this.tmpquad.set_from_rotated_rect(this.tmprect,a),this.tmpquad.bounding_box(this.tmprect),this.tmprect.offset((this.viewLeft+this.viewRight)/2,(this.viewTop+this.viewBottom)/2),this.viewLeft=this.tmprect.left,this.viewTop=this.tmprect.top,this.viewRight=this.tmprect.right,this.viewBottom=this.tmprect.bottom)};b.prototype.drawGL=function(a){var b=this.runtime.draw_width,c=this.runtime.draw_height,d=0,k=0;if(this.render_offscreen=this.forceOwnTexture||
1!==this.opacity||0<this.active_effect_types.length||0!==this.blend_mode){this.runtime.layer_tex||(this.runtime.layer_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling));if(this.runtime.layer_tex.c2width!==this.runtime.draw_width||this.runtime.layer_tex.c2height!==this.runtime.draw_height)a.deleteTexture(this.runtime.layer_tex),this.runtime.layer_tex=a.createEmptyTexture(this.runtime.draw_width,this.runtime.draw_height,this.runtime.linearSampling);
a.setRenderingToTexture(this.runtime.layer_tex);this.transparent&&a.clear(0,0,0,0)}this.transparent||a.clear(this.background_color[0]/255,this.background_color[1]/255,this.background_color[2]/255,1);this.disableAngle=!0;var k=this.canvasToLayer(0,0,!0,!0),g=this.canvasToLayer(0,0,!1,!0);this.disableAngle=!1;this.runtime.pixel_rounding&&(k=k+0.5|0,g=g+0.5|0);this.rotateViewport(k,g,null);g=this.getScale();a.resetModelView();a.scale(g,g);a.rotateZ(-this.getAngle());a.translate((this.viewLeft+this.viewRight)/
-2,(this.viewTop+this.viewBottom)/-2);a.updateModelView();var m,n,p;m=0;for(n=this.instances.length;m<n;m++)if(p=this.instances[m],p.visible&&0!==p.width&&0!==p.height&&(p.update_bbox(),d=p.bbox,!(d.right<this.viewLeft||d.bottom<this.viewTop||d.left>this.viewRight||d.top>this.viewBottom)))if(p.uses_shaders)if(d=p.active_effect_types[0].shaderindex,k=p.active_effect_types[0].index,1!==p.active_effect_types.length||a.programUsesCrossSampling(d)||a.programExtendsBox(d)||(p.angle||p.layer.getAngle())&&
a.programUsesDest(d)||1!==p.opacity||p.type.plugin.must_predraw)this.layout.renderEffectChain(a,this,p,this.render_offscreen?this.runtime.layer_tex:this.layout.getRenderTarget()),a.resetModelView(),a.scale(g,g),a.rotateZ(-this.getAngle()),a.translate((this.viewLeft+this.viewRight)/-2,(this.viewTop+this.viewBottom)/-2),a.updateModelView();else{a.switchProgram(d);a.setBlend(p.srcBlend,p.destBlend);a.programIsAnimated(d)&&(this.runtime.redraw=!0);var r=0,s=0,q=0,t=0;a.programUsesDest(d)&&(d=p.bbox,r=
this.layerToCanvas(d.left,d.top,!0,!0),s=this.layerToCanvas(d.left,d.top,!1,!0),q=this.layerToCanvas(d.right,d.bottom,!0,!0),d=this.layerToCanvas(d.right,d.bottom,!1,!0),r/=b,s=1-s/c,q/=b,t=1-d/c);a.setProgramParameters(this.render_offscreen?this.runtime.layer_tex:this.layout.getRenderTarget(),1/p.width,1/p.height,r,s,q,t,this.getScale(),this.getAngle(),this.viewLeft,this.viewTop,p.effect_params[k]);p.drawGL(a)}else a.switchProgram(0),a.setBlend(p.srcBlend,p.destBlend),p.drawGL(a);this.render_offscreen&&
(d=this.active_effect_types.length?this.active_effect_types[0].shaderindex:0,k=this.active_effect_types.length?this.active_effect_types[0].index:0,0===this.active_effect_types.length||1===this.active_effect_types.length&&!a.programUsesCrossSampling(d)&&1===this.opacity?(1===this.active_effect_types.length?(a.switchProgram(d),a.setProgramParameters(this.layout.getRenderTarget(),1/this.runtime.draw_width,1/this.runtime.draw_height,0,0,1,1,this.getScale(),this.getAngle(),this.viewLeft,this.viewTop,this.effect_params[k]),
a.programIsAnimated(d)&&(this.runtime.redraw=!0)):a.switchProgram(0),a.setRenderingToTexture(this.layout.getRenderTarget()),a.setOpacity(this.opacity),a.setTexture(this.runtime.layer_tex),a.setBlend(this.srcBlend,this.destBlend),a.resetModelView(),a.updateModelView(),b=this.runtime.draw_width/2,c=this.runtime.draw_height/2,a.quad(-b,c,b,c,b,-c,-b,-c),a.setTexture(null)):this.layout.renderEffectChain(a,this,null,this.layout.getRenderTarget()))};b.prototype.canvasToLayer=function(a,b,c,d){var k=this.runtime.devicePixelRatio;
this.runtime.isRetina&&(a*=k,b*=k);var k=this.runtime.parallax_x_origin,g=this.runtime.parallax_y_origin,k=(this.layout.scrollX-k)*this.parallaxX+k,g=(this.layout.scrollY-g)*this.parallaxY+g,m=1/this.getScale(!d);d?(k-=this.runtime.draw_width*m/2,g-=this.runtime.draw_height*m/2):(k-=this.runtime.width*m/2,g-=this.runtime.height*m/2);k+=a*m;g+=b*m;b=this.getAngle();0!==b&&(k-=this.layout.scrollX,g-=this.layout.scrollY,a=Math.cos(b),b=Math.sin(b),d=k*a-g*b,g=g*a+k*b,k=d+this.layout.scrollX,g+=this.layout.scrollY);
return c?k:g};b.prototype.layerToCanvas=function(a,b,c,d){var k=this.getAngle();if(0!==k){a-=this.layout.scrollX;b-=this.layout.scrollY;var g=Math.cos(-k),k=Math.sin(-k),m=a*g-b*k;b=b*g+a*k;a=m+this.layout.scrollX;b+=this.layout.scrollY}g=this.runtime.parallax_x_origin;k=this.runtime.parallax_y_origin;g=(this.layout.scrollX-g)*this.parallaxX+g;k=(this.layout.scrollY-k)*this.parallaxY+k;m=1/this.getScale(!d);d?(g-=this.runtime.draw_width*m/2,k-=this.runtime.draw_height*m/2):(g-=this.runtime.width*
m/2,k-=this.runtime.height*m/2);g=(a-g)/m;k=(b-k)/m;a=this.runtime.devicePixelRatio;this.runtime.isRetina&&(g/=a,k/=a);return c?g:k};b.prototype.rotatePt=function(a,b,c){if(0===this.getAngle())return c?a:b;var d=this.layerToCanvas(a,b,!0);b=this.layerToCanvas(a,b,!1);this.disableAngle=!0;a=this.canvasToLayer(d,b,!0);d=this.canvasToLayer(d,b,!0);this.disableAngle=!1;return c?a:d};b.prototype.saveToJSON=function(){var a,b,c,d={s:this.scale,a:this.angle,vl:this.viewLeft,vt:this.viewTop,vr:this.viewRight,
vb:this.viewBottom,v:this.visible,bc:this.background_color,t:this.transparent,px:this.parallaxX,py:this.parallaxY,o:this.opacity,zr:this.zoomRate,fx:[],instances:[]};a=0;for(b=this.effect_types.length;a<b;a++)c=this.effect_types[a],d.fx.push({name:c.name,active:c.active,params:this.effect_params[c.index]});return d};b.prototype.loadFromJSON=function(a){var b,d;this.scale=a.s;this.angle=a.a;this.viewLeft=a.vl;this.viewTop=a.vt;this.viewRight=a.vr;this.viewBottom=a.vb;this.visible=a.v;this.background_color=
a.bc;this.transparent=a.t;this.parallaxX=a.px;this.parallaxY=a.py;this.opacity=a.o;this.zoomRate=a.zr;var l=a.fx;a=0;for(b=l.length;a<b;a++)if(d=this.getEffectByName(l[a].name))d.active=l[a].active,this.effect_params[d.index]=l[a].params;this.updateActiveEffects();this.instances.sort(c);this.zindices_stale=!0};cr.layer=b})();
(function(){function a(a,b){var c,d=a.length;switch(d){case 0:return!0;case 1:return a[0]===b[0];case 2:return a[0]===b[0]&&a[1]===b[1];default:for(c=0;c<d;c++)if(a[c]!==b[c])return!1;return!0}}function b(a,b){return a.index-b.index}function c(c){var d,e,g,f;2===c.length?c[0].index>c[1].index&&(d=c[0],c[0]=c[1],c[1]=d):2<c.length&&c.sort(b);c.length>=r.length&&(r.length=c.length+1);r[c.length]||(r[c.length]=[]);f=r[c.length];d=0;for(e=f.length;d<e;d++)if(g=f[d],a(c,g))return g;f.push(c);return c}
function d(a,b){this.runtime=a;this.triggers={};this.fasttriggers={};this.hasRun=!1;this.includes=new cr.ObjectSet;this.deep_includes=[];this.already_included_sheets=[];this.name=b[0];var c=b[1];this.events=[];var d,e;d=0;for(e=c.length;d<e;d++)this.init_event(c[d],null,this.events)}function e(a){this.type=a;this.instances=[];this.else_instances=[];this.select_all=!0}function h(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.solModifiersIncludingParents=[];this.has_else_block=
this.toplevelgroup=this.toplevelevent=this.initially_activated=this.group=this.solWriterAfterCnds=!1;this.conditions=[];this.actions=[];this.subevents=[];this.group_name="";this.group_active=this.initially_activated=this.group=!1;this.contained_includes=null;c[1]&&(this.group_name=c[1][1].toLowerCase(),this.group=!0,this.initially_activated=!!c[1][0],this.contained_includes=[],this.group_active=this.initially_activated,this.runtime.allGroups.push(this),this.runtime.groups_by_name[this.group_name]=
this);this.orblock=c[2];this.sid=c[4];this.group||(this.runtime.blocksBySid[this.sid.toString()]=this);var d=c[5];a=0;for(b=d.length;a<b;a++){var e=new cr.condition(this,d[a]);e.index=a;cr.seal(e);this.conditions.push(e);this.addSolModifier(e.type)}d=c[6];a=0;for(b=d.length;a<b;a++)e=new cr.action(this,d[a]),e.index=a,cr.seal(e),this.actions.push(e);if(8===c.length)for(c=c[7],a=0,b=c.length;a<b;a++)this.sheet.init_event(c[a],this,this.subevents);this.is_else_block=!1;this.conditions.length&&(this.is_else_block=
null==this.conditions[0].type&&this.conditions[0].func==cr.system_object.prototype.cnds.Else)}function f(a,b){var c,d,e;if(a&&(-1===b.indexOf(a)&&b.push(a),a.is_contained))for(c=0,d=a.container.length;c<d;c++)e=a.container[c],a!==e&&-1===b.indexOf(e)&&b.push(e)}function l(a,b){this.block=a;this.sheet=a.sheet;this.runtime=a.runtime;this.parameters=[];this.results=[];this.extra={};this.index=-1;this.anyParamVariesPerInstance=!1;this.func=b[1];this.trigger=0<b[3];this.fasttrigger=2===b[3];this.looping=
b[4];this.inverted=b[5];this.isstatic=b[6];this.sid=b[7];this.runtime.cndsBySid[this.sid.toString()]=this;-1===b[0]?(this.type=null,this.run=this.run_system,this.behaviortype=null,this.beh_index=-1):(this.type=this.runtime.types_by_index[b[0]],this.run=this.isstatic?this.run_static:this.run_object,b[2]?(this.behaviortype=this.type.getBehaviorByName(b[2]),this.beh_index=this.type.getBehaviorIndexByName(b[2])):(this.behaviortype=null,this.beh_index=-1),this.block.parent&&this.block.parent.setSolWriterAfterCnds());
this.fasttrigger&&(this.run=this.run_true);if(10===b.length){var c,d,e=b[9];c=0;for(d=e.length;c<d;c++){var g=new cr.parameter(this,e[c]);cr.seal(g);this.parameters.push(g)}this.results.length=e.length}}function k(a,b){this.block=a;this.sheet=a.sheet;this.runtime=a.runtime;this.parameters=[];this.results=[];this.extra={};this.index=-1;this.anyParamVariesPerInstance=!1;this.func=b[1];-1===b[0]?(this.type=null,this.run=this.run_system,this.behaviortype=null,this.beh_index=-1):(this.type=this.runtime.types_by_index[b[0]],
this.run=this.run_object,b[2]?(this.behaviortype=this.type.getBehaviorByName(b[2]),this.beh_index=this.type.getBehaviorIndexByName(b[2])):(this.behaviortype=null,this.beh_index=-1));this.sid=b[3];this.runtime.actsBySid[this.sid.toString()]=this;if(6===b.length){var c,d,e=b[5];c=0;for(d=e.length;c<d;c++){var g=new cr.parameter(this,e[c]);cr.seal(g);this.parameters.push(g)}this.results.length=e.length}}function g(a,b){this.owner=a;this.block=a.block;this.sheet=a.sheet;this.runtime=a.runtime;this.type=
b[0];this.expression=null;this.solindex=0;this.get=null;this.combosel=0;this.layout=null;this.key=0;this.object=null;this.index=0;this.variadicret=this.subparams=this.variadicret=this.subparams=this.fileinfo=this.eventvar=this.varname=null;this.variesPerInstance=!1;var c,d,e;switch(b[0]){case 0:case 7:this.expression=new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_exp;break;case 1:this.expression=new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_exp_str;break;case 5:this.expression=
new cr.expNode(this,b[1]);this.solindex=0;this.get=this.get_layer;break;case 3:case 8:this.combosel=b[1];this.get=this.get_combosel;break;case 6:this.layout=this.runtime.layouts[b[1]];this.get=this.get_layout;break;case 9:this.key=b[1];this.get=this.get_key;break;case 4:this.object=this.runtime.types_by_index[b[1]];this.get=this.get_object;this.block.addSolModifier(this.object);this.owner instanceof cr.action?this.block.setSolWriterAfterCnds():this.block.parent&&this.block.parent.setSolWriterAfterCnds();
break;case 10:this.index=b[1];a.type.is_family?(this.get=this.get_familyvar,this.variesPerInstance=!0):this.get=this.get_instvar;break;case 11:this.varname=b[1];this.eventvar=null;this.get=this.get_eventvar;break;case 2:case 12:this.fileinfo=b[1];this.get=this.get_audiofile;break;case 13:for(this.get=this.get_variadic,this.subparams=[],this.variadicret=[],c=1,d=b.length;c<d;c++)e=new cr.parameter(this.owner,b[c]),cr.seal(e),this.subparams.push(e),this.variadicret.push(0)}}function m(a,b,c){this.sheet=
a;this.parent=b;this.runtime=a.runtime;this.solModifiers=[];this.name=c[1];this.vartype=c[2];this.initial=c[3];this.is_static=!!c[4];this.is_constant=!!c[5];this.sid=c[6];this.runtime.varsBySid[this.sid.toString()]=this;this.data=this.initial;this.parent?(this.localIndex=this.is_static||this.is_constant?-1:this.runtime.stackLocalCount++,this.runtime.all_local_vars.push(this)):(this.localIndex=-1,this.runtime.all_global_vars.push(this))}function n(a,b,c){this.sheet=a;this.parent=b;this.runtime=a.runtime;
this.solModifiers=[];this.include_sheet=null;this.include_sheet_name=c[1];this.active=!0}function p(){this.temp_parents_arr=[];this.reset(null);cr.seal(this)}var r=[];d.prototype.toString=function(){return this.name};d.prototype.init_event=function(a,b,c){switch(a[0]){case 0:a=new cr.eventblock(this,b,a);cr.seal(a);if(a.orblock)for(c.push(a),c=0,b=a.conditions.length;c<b;c++)a.conditions[c].trigger&&this.init_trigger(a,c);else a.is_trigger()?this.init_trigger(a,0):c.push(a);break;case 1:a=new cr.eventvariable(this,
b,a);cr.seal(a);c.push(a);break;case 2:a=new cr.eventinclude(this,b,a),cr.seal(a),c.push(a)}};d.prototype.postInit=function(){var a,b;a=0;for(b=this.events.length;a<b;a++)this.events[a].postInit(a<b-1&&this.events[a+1].is_else_block)};d.prototype.updateDeepIncludes=function(){this.deep_includes.length=0;this.already_included_sheets.length=0;this.addDeepIncludes(this);this.already_included_sheets.length=0};d.prototype.addDeepIncludes=function(a){var b,c,d,e,g=a.deep_includes,f=a.already_included_sheets,
k=this.includes.valuesRef();b=0;for(c=k.length;b<c;++b)d=k[b],e=d.include_sheet,!d.isActive()||a===e||-1<f.indexOf(e)||(f.push(e),e.addDeepIncludes(a),g.push(e))};d.prototype.run=function(a){this.runtime.resuming_breakpoint||(this.hasRun=!0,a||(this.runtime.isRunningEvents=!0));var b,c;b=0;for(c=this.events.length;b<c;b++){var d=this.events[b];d.run();this.runtime.clearSol(d.solModifiers);this.runtime.deathRow.isEmpty()&&!this.runtime.createRow.length||this.runtime.ClearDeathRow()}a||(this.runtime.isRunningEvents=
!1)};d.prototype.init_trigger=function(a,b){a.orblock||this.runtime.triggers_to_postinit.push(a);var c,d,e=a.conditions[b],g;g=e.type?e.type.name:"system";var f=(c=e.fasttrigger)?this.fasttriggers:this.triggers;f[g]||(f[g]=[]);g=f[g];f=e.func;if(c){if(e.parameters.length&&(e=e.parameters[0],1===e.type&&2===e.expression.type)){e=e.expression.value.toLowerCase();c=0;for(d=g.length;c<d;c++)if(g[c].method==f){c=g[c].evs;c[e]?c[e].push([a,b]):c[e]=[[a,b]];return}c={};c[e]=[[a,b]];g.push({method:f,evs:c})}}else{c=
0;for(d=g.length;c<d;c++)if(g[c].method==f){g[c].evs.push([a,b]);return}e=cr.plugins_.Sprite&&f===cr.plugins_.Sprite.prototype.cnds.OnFrameChanged?!0:!1;e?g.unshift({method:f,evs:[[a,b]]}):g.push({method:f,evs:[[a,b]]})}};cr.eventsheet=d;e.prototype.hasObjects=function(){return this.select_all?this.type.instances.length:this.instances.length};e.prototype.getObjects=function(){return this.select_all?this.type.instances:this.instances};e.prototype.pick_one=function(a){a&&(a.runtime.getCurrentEventStack().current_event.orblock?
(this.select_all&&(this.instances.length=0,cr.shallowAssignArray(this.else_instances,a.type.instances),this.select_all=!1),a=this.else_instances.indexOf(a),-1!==a&&(this.instances.push(this.else_instances[a]),this.else_instances.splice(a,1))):(this.select_all=!1,this.instances.length=1,this.instances[0]=a))};cr.selection=e;window._c2hh_="184F0CCD1F1226856D58E8300A281DFF380CB0A3";h.prototype.postInit=function(a){var b,d=this.parent;if(this.group)for(this.toplevelgroup=!0;d;){if(!d.group){this.toplevelgroup=
!1;break}d=d.parent}this.toplevelevent=!this.is_trigger()&&(!this.parent||this.parent.group&&this.parent.toplevelgroup);this.has_else_block=!!a;this.solModifiersIncludingParents=this.solModifiers.slice(0);for(d=this.parent;d;){a=0;for(b=d.solModifiers.length;a<b;a++)this.addParentSolModifier(d.solModifiers[a]);d=d.parent}this.solModifiers=c(this.solModifiers);this.solModifiersIncludingParents=c(this.solModifiersIncludingParents);a=0;for(b=this.conditions.length;a<b;a++)this.conditions[a].postInit();
a=0;for(b=this.actions.length;a<b;a++)this.actions[a].postInit();a=0;for(b=this.subevents.length;a<b;a++)this.subevents[a].postInit(a<b-1&&this.subevents[a+1].is_else_block)};h.prototype.setGroupActive=function(a){if(this.group_active!==!!a){this.group_active=!!a;var b;a=0;for(b=this.contained_includes.length;a<b;++a)this.contained_includes[a].updateActive();0<b&&this.runtime.running_layout.event_sheet&&this.runtime.running_layout.event_sheet.updateDeepIncludes()}};h.prototype.addSolModifier=function(a){f(a,
this.solModifiers)};h.prototype.addParentSolModifier=function(a){f(a,this.solModifiersIncludingParents)};h.prototype.setSolWriterAfterCnds=function(){this.solWriterAfterCnds=!0;this.parent&&this.parent.setSolWriterAfterCnds()};h.prototype.is_trigger=function(){return this.conditions.length?this.conditions[0].trigger:!1};h.prototype.run=function(){var a,b=!1,c,d=this.runtime,e=this.runtime.getCurrentEventStack();e.current_event=this;var g=this.conditions;this.is_else_block||(e.else_branch_ran=!1);
if(this.orblock){0===g.length&&(b=!0);e.cndindex=0;for(a=g.length;e.cndindex<a;e.cndindex++)g[e.cndindex].trigger||(c=g[e.cndindex].run())&&(b=!0);(e.last_event_true=b)&&this.run_actions_and_subevents()}else{e.cndindex=0;for(a=g.length;e.cndindex<a;e.cndindex++)if(c=g[e.cndindex].run(),!c){e.last_event_true=!1;!this.toplevelevent||d.deathRow.isEmpty()&&!d.createRow.length||d.ClearDeathRow();return}e.last_event_true=!0;this.run_actions_and_subevents()}this.end_run(e)};h.prototype.end_run=function(a){a.last_event_true&&
this.has_else_block&&(a.else_branch_ran=!0);!this.toplevelevent||this.runtime.deathRow.isEmpty()&&!this.runtime.createRow.length||this.runtime.ClearDeathRow()};h.prototype.run_orblocktrigger=function(a){this.runtime.getCurrentEventStack().current_event=this;this.conditions[a].run()&&(this.run_actions_and_subevents(),this.runtime.getCurrentEventStack().last_event_true=!0)};h.prototype.run_actions_and_subevents=function(){var a=this.runtime.getCurrentEventStack(),b;a.actindex=0;for(b=this.actions.length;a.actindex<
b;a.actindex++)if(this.actions[a.actindex].run())return;this.run_subevents()};h.prototype.resume_actions_and_subevents=function(){var a=this.runtime.getCurrentEventStack(),b;for(b=this.actions.length;a.actindex<b;a.actindex++)if(this.actions[a.actindex].run())return;this.run_subevents()};h.prototype.run_subevents=function(){if(this.subevents.length){var a,b,c,d,e=this.subevents.length-1;this.runtime.pushEventStack(this);if(this.solWriterAfterCnds)for(a=0,b=this.subevents.length;a<b;a++)c=this.subevents[a],
(d=!this.toplevelgroup||!this.group&&a<e)&&this.runtime.pushCopySol(c.solModifiers),c.run(),d?this.runtime.popSol(c.solModifiers):this.runtime.clearSol(c.solModifiers);else for(a=0,b=this.subevents.length;a<b;a++)this.subevents[a].run();this.runtime.popEventStack()}};h.prototype.run_pretrigger=function(){var a=this.runtime.getCurrentEventStack();a.current_event=this;var b=!1,c;a.cndindex=0;for(c=this.conditions.length;a.cndindex<c;a.cndindex++)if(this.conditions[a.cndindex].run())b=!0;else if(!this.orblock)return!1;
return this.orblock?b:!0};h.prototype.retrigger=function(){this.runtime.execcount++;var a=this.runtime.getCurrentEventStack().cndindex,b=this.runtime.pushEventStack(this);if(!this.orblock)for(b.cndindex=a+1,a=this.conditions.length;b.cndindex<a;b.cndindex++)if(!this.conditions[b.cndindex].run())return this.runtime.popEventStack(),!1;this.run_actions_and_subevents();this.runtime.popEventStack();return!0};h.prototype.isFirstConditionOfType=function(a){var b=a.index;if(0===b)return!0;for(--b;0<=b;--b)if(this.conditions[b].type===
a.type)return!1;return!0};cr.eventblock=h;l.prototype.postInit=function(){var a,b,c;a=0;for(b=this.parameters.length;a<b;a++)c=this.parameters[a],c.postInit(),c.variesPerInstance&&(this.anyParamVariesPerInstance=!0)};l.prototype.run_true=function(){return!0};l.prototype.run_system=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get();return cr.xor(this.func.apply(this.runtime.system,this.results),this.inverted)};l.prototype.run_static=function(){var a,
b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=this.parameters[a].get();a=this.func.apply(this.behaviortype?this.behaviortype:this.type,this.results);this.type.applySolToContainer();return a};l.prototype.run_object=function(){var a,b,c,d,e,g,f,k,h=this.type,l=h.getCurrentSol(),m=this.block.orblock&&!this.trigger;b=0;var n=h.is_contained,s=h.is_family,q=h.family_index,r=this.beh_index,p=-1<r,T=this.anyParamVariesPerInstance,K=this.parameters,R=this.results,L=this.inverted,B=this.func,N;
if(T)for(b=0,e=K.length;b<e;++b)g=K[b],g.variesPerInstance||(R[b]=g.get(0));else for(b=0,e=K.length;b<e;++b)R[b]=K[b].get(0);if(l.select_all){l.instances.length=0;l.else_instances.length=0;N=h.instances;a=0;for(d=N.length;a<d;++a){k=N[a];if(T)for(b=0,e=K.length;b<e;++b)g=K[b],g.variesPerInstance&&(R[b]=g.get(a));p?(b=0,s&&(b=k.type.family_beh_map[q]),b=B.apply(k.behavior_insts[r+b],R)):b=B.apply(k,R);(f=cr.xor(b,L))?l.instances.push(k):m&&l.else_instances.push(k)}h.finish&&h.finish(!0);l.select_all=
!1;h.applySolToContainer();return l.hasObjects()}c=0;N=(f=m&&!this.block.isFirstConditionOfType(this))?l.else_instances:l.instances;var V=!1;a=0;for(d=N.length;a<d;++a){k=N[a];if(T)for(b=0,e=K.length;b<e;++b)g=K[b],g.variesPerInstance&&(R[b]=g.get(a));p?(b=0,s&&(b=k.type.family_beh_map[q]),b=B.apply(k.behavior_insts[r+b],R)):b=B.apply(k,R);if(cr.xor(b,L))if(V=!0,f){if(l.instances.push(k),n)for(b=0,e=k.siblings.length;b<e;b++)g=k.siblings[b],g.type.getCurrentSol().instances.push(g)}else{N[c]=k;if(n)for(b=
0,e=k.siblings.length;b<e;b++)g=k.siblings[b],g.type.getCurrentSol().instances[c]=g;c++}else if(f){N[c]=k;if(n)for(b=0,e=k.siblings.length;b<e;b++)g=k.siblings[b],g.type.getCurrentSol().else_instances[c]=g;c++}else if(m&&(l.else_instances.push(k),n))for(b=0,e=k.siblings.length;b<e;b++)g=k.siblings[b],g.type.getCurrentSol().else_instances.push(g)}N.length=c;if(n)for(s=h.container,a=0,d=s.length;a<d;a++)k=s[a].getCurrentSol(),f?k.else_instances.length=c:k.instances.length=c;c=V;if(f&&!V)for(a=0,d=l.instances.length;a<
d;a++){k=l.instances[a];if(T)for(b=0,e=K.length;b<e;b++)g=K[b],g.variesPerInstance&&(R[b]=g.get(a));b=p?B.apply(k.behavior_insts[r],R):B.apply(k,R);if(cr.xor(b,L)){V=!0;break}}h.finish&&h.finish(c||m);return m?V:l.hasObjects()};cr.condition=l;k.prototype.postInit=function(){var a,b,c;a=0;for(b=this.parameters.length;a<b;a++)c=this.parameters[a],c.postInit(),c.variesPerInstance&&(this.anyParamVariesPerInstance=!0)};k.prototype.run_system=function(){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.results[a]=
this.parameters[a].get();return this.func.apply(this.runtime.system,this.results)};k.prototype.run_object=function(){var a=this.type.getCurrentSol().getObjects(),b=this.type.is_family,c=this.type.family_index,d=this.beh_index,e=-1<d,g=this.anyParamVariesPerInstance,f=this.parameters,k=this.results,h=this.func,l,m,n,s,q,r;if(g)for(m=0,s=f.length;m<s;++m)q=f[m],q.variesPerInstance||(k[m]=q.get(0));else for(m=0,s=f.length;m<s;++m)k[m]=f[m].get(0);l=0;for(n=a.length;l<n;++l){r=a[l];if(g)for(m=0,s=f.length;m<
s;++m)q=f[m],q.variesPerInstance&&(k[m]=q.get(l));e?(m=0,b&&(m=r.type.family_beh_map[c]),h.apply(r.behavior_insts[d+m],k)):h.apply(r,k)}return!1};cr.action=k;var s=[],q=-1;g.prototype.postInit=function(){var a,b;if(11===this.type)this.eventvar=this.runtime.getEventVariableByName(this.varname,this.block.parent);else if(13===this.type)for(a=0,b=this.subparams.length;a<b;a++)this.subparams[a].postInit();this.expression&&this.expression.postInit()};g.prototype.maybeVaryForType=function(a){this.variesPerInstance||
!a||a.plugin.singleglobal||(this.variesPerInstance=!0)};g.prototype.setVaries=function(){this.variesPerInstance=!0};g.prototype.pushTempValue=function(){q++;s.length===q&&s.push(new cr.expvalue);return s[q]};g.prototype.popTempValue=function(){q--};g.prototype.get_exp=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();return a.data};g.prototype.get_exp_str=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();
return cr.is_string(a.data)?a.data:""};g.prototype.get_object=function(){return this.object};g.prototype.get_combosel=function(){return this.combosel};g.prototype.get_layer=function(a){this.solindex=a||0;a=this.pushTempValue();this.expression.get(a);this.popTempValue();return a.is_number()?this.runtime.getLayerByNumber(a.data):this.runtime.getLayerByName(a.data)};g.prototype.get_layout=function(){return this.layout};g.prototype.get_key=function(){return this.key};g.prototype.get_instvar=function(){return this.index};
g.prototype.get_familyvar=function(a){a=a||0;var b=this.owner.type,c=null,c=b.getCurrentSol(),d=c.getObjects();if(d.length)c=d[a%d.length].type;else if(c.else_instances.length)c=c.else_instances[a%c.else_instances.length].type;else if(b.instances.length)c=b.instances[a%b.instances.length].type;else return 0;return this.index+c.family_var_map[b.family_index]};g.prototype.get_eventvar=function(){return this.eventvar};g.prototype.get_audiofile=function(){return this.fileinfo};g.prototype.get_variadic=
function(){var a,b;a=0;for(b=this.subparams.length;a<b;a++)this.variadicret[a]=this.subparams[a].get();return this.variadicret};cr.parameter=g;m.prototype.postInit=function(){this.solModifiers=c(this.solModifiers)};m.prototype.setValue=function(a){var b=this.runtime.getCurrentLocalVarStack();this.parent&&!this.is_static&&b?(this.localIndex>=b.length&&(b.length=this.localIndex+1),b[this.localIndex]=a):this.data=a};m.prototype.getValue=function(){var a=this.runtime.getCurrentLocalVarStack();return!this.parent||
this.is_static||!a||this.is_constant?this.data:this.localIndex>=a.length||"undefined"===typeof a[this.localIndex]?this.initial:a[this.localIndex]};m.prototype.run=function(){!this.parent||this.is_static||this.is_constant||this.setValue(this.initial)};cr.eventvariable=m;n.prototype.toString=function(){return"include:"+this.include_sheet.toString()};n.prototype.postInit=function(){this.include_sheet=this.runtime.eventsheets[this.include_sheet_name];this.sheet.includes.add(this);this.solModifiers=c(this.solModifiers);
for(var a=this.parent;a;)a.group&&a.contained_includes.push(this),a=a.parent;this.updateActive()};n.prototype.run=function(){this.parent&&this.runtime.pushCleanSol(this.runtime.types_by_index);this.include_sheet.hasRun||this.include_sheet.run(!0);this.parent&&this.runtime.popSol(this.runtime.types_by_index)};n.prototype.updateActive=function(){for(var a=this.parent;a;){if(a.group&&!a.group_active){this.active=!1;return}a=a.parent}this.active=!0};n.prototype.isActive=function(){return this.active};
cr.eventinclude=n;p.prototype.reset=function(a){this.current_event=a;this.actindex=this.cndindex=0;this.temp_parents_arr.length=0;this.any_true_state=this.else_branch_ran=this.last_event_true=!1};p.prototype.isModifierAfterCnds=function(){return this.current_event.solWriterAfterCnds?!0:this.cndindex<this.current_event.conditions.length-1?!!this.current_event.solModifiers.length:!1};cr.eventStackFrame=p})();
(function(){function a(a,b){this.owner=a;this.runtime=a.runtime;this.type=b[0];this.get=[this.eval_int,this.eval_float,this.eval_string,this.eval_unaryminus,this.eval_add,this.eval_subtract,this.eval_multiply,this.eval_divide,this.eval_mod,this.eval_power,this.eval_and,this.eval_or,this.eval_equal,this.eval_notequal,this.eval_less,this.eval_lessequal,this.eval_greater,this.eval_greaterequal,this.eval_conditional,this.eval_system_exp,this.eval_object_behavior_exp,this.eval_instvar_exp,this.eval_object_behavior_exp,
this.eval_eventvar_exp][this.type];var e=null;this.object_type=this.parameters=this.results=this.func=this.third=this.second=this.first=this.value=null;this.beh_index=-1;this.instance_expr=null;this.varindex=-1;this.eventvar=this.varname=this.behavior_type=null;this.return_string=!1;switch(this.type){case 0:case 1:case 2:this.value=b[1];break;case 3:this.first=new cr.expNode(a,b[1]);break;case 18:this.first=new cr.expNode(a,b[1]);this.second=new cr.expNode(a,b[2]);this.third=new cr.expNode(a,b[3]);
break;case 19:this.func=b[1];this.func!==cr.system_object.prototype.exps.random&&this.func!==cr.system_object.prototype.exps.choose||this.owner.setVaries();this.results=[];this.parameters=[];3===b.length?(e=b[2],this.results.length=e.length+1):this.results.length=1;break;case 20:this.object_type=this.runtime.types_by_index[b[1]];this.beh_index=-1;this.func=b[2];this.return_string=b[3];cr.plugins_.Function&&this.func===cr.plugins_.Function.prototype.exps.Call&&this.owner.setVaries();this.instance_expr=
b[4]?new cr.expNode(a,b[4]):null;this.results=[];this.parameters=[];6===b.length?(e=b[5],this.results.length=e.length+1):this.results.length=1;break;case 21:this.object_type=this.runtime.types_by_index[b[1]];this.return_string=b[2];this.instance_expr=b[3]?new cr.expNode(a,b[3]):null;this.varindex=b[4];break;case 22:this.object_type=this.runtime.types_by_index[b[1]];this.behavior_type=this.object_type.getBehaviorByName(b[2]);this.beh_index=this.object_type.getBehaviorIndexByName(b[2]);this.func=b[3];
this.return_string=b[4];this.instance_expr=b[5]?new cr.expNode(a,b[5]):null;this.results=[];this.parameters=[];7===b.length?(e=b[6],this.results.length=e.length+1):this.results.length=1;break;case 23:this.varname=b[1],this.eventvar=null}this.owner.maybeVaryForType(this.object_type);4<=this.type&&17>=this.type&&(this.first=new cr.expNode(a,b[1]),this.second=new cr.expNode(a,b[2]));if(e){var h,f;h=0;for(f=e.length;h<f;h++)this.parameters.push(new cr.expNode(a,e[h]))}cr.seal(this)}function b(a,b){this.type=
a||cr.exptype.Integer;this.data=b||0;this.object_class=null;this.type==cr.exptype.Integer&&(this.data=Math.floor(this.data));cr.seal(this)}a.prototype.postInit=function(){23===this.type&&(this.eventvar=this.owner.runtime.getEventVariableByName(this.varname,this.owner.block.parent));this.first&&this.first.postInit();this.second&&this.second.postInit();this.third&&this.third.postInit();this.instance_expr&&this.instance_expr.postInit();if(this.parameters){var a,b;a=0;for(b=this.parameters.length;a<b;a++)this.parameters[a].postInit()}};
a.prototype.eval_system_exp=function(a){this.results[0]=a;a=this.owner.pushTempValue();var b,e;b=0;for(e=this.parameters.length;b<e;b++)this.parameters[b].get(a),this.results[b+1]=a.data;this.owner.popTempValue();this.func.apply(this.runtime.system,this.results)};a.prototype.eval_object_behavior_exp=function(a){var b=this.object_type.getCurrentSol(),e=b.getObjects();if(!e.length)if(b.else_instances.length)e=b.else_instances;else{this.return_string?a.set_string(""):a.set_int(0);return}this.results[0]=
a;a.object_class=this.object_type;a=this.owner.pushTempValue();var h,b=0;for(h=this.parameters.length;b<h;b++)this.parameters[b].get(a),this.results[b+1]=a.data;b=this.owner.solindex;this.instance_expr&&(this.instance_expr.get(a),a.is_number()&&(b=a.data,e=this.object_type.instances));this.owner.popTempValue();b%=e.length;0>b&&(b+=e.length);e=e[b];-1<this.beh_index?(a=0,this.object_type.is_family&&(a=e.type.family_beh_map[this.object_type.family_index]),this.func.apply(e.behavior_insts[this.beh_index+
a],this.results)):this.func.apply(e,this.results)};a.prototype.eval_instvar_exp=function(a){var b=this.object_type.getCurrentSol(),e=b.getObjects();if(!e.length)if(b.else_instances.length)e=b.else_instances;else{this.return_string?a.set_string(""):a.set_int(0);return}b=this.owner.solindex;if(this.instance_expr){var h=this.owner.pushTempValue();this.instance_expr.get(h);if(h.is_number()){b=h.data;e=this.object_type.instances;b%=e.length;0>b&&(b+=e.length);e=e[b].instance_vars[this.varindex];cr.is_string(e)?
a.set_string(e):a.set_float(e);this.owner.popTempValue();return}this.owner.popTempValue()}b%=e.length;0>b&&(b+=e.length);e=e[b];b=0;this.object_type.is_family&&(b=e.type.family_var_map[this.object_type.family_index]);e=e.instance_vars[this.varindex+b];cr.is_string(e)?a.set_string(e):a.set_float(e)};a.prototype.eval_int=function(a){a.type=cr.exptype.Integer;a.data=this.value};a.prototype.eval_float=function(a){a.type=cr.exptype.Float;a.data=this.value};a.prototype.eval_string=function(a){a.type=cr.exptype.String;
a.data=this.value};a.prototype.eval_unaryminus=function(a){this.first.get(a);a.is_number()&&(a.data=-a.data)};a.prototype.eval_add=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data+=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_subtract=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data-=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};
a.prototype.eval_multiply=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data*=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_divide=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data/=b.data,a.make_float());this.owner.popTempValue()};a.prototype.eval_mod=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);
a.is_number()&&b.is_number()&&(a.data%=b.data,b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_power=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data=Math.pow(a.data,b.data),b.is_float()&&a.make_float());this.owner.popTempValue()};a.prototype.eval_and=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()?b.is_string()?a.set_string(a.data.toString()+b.data):a.data&&
b.data?a.set_int(1):a.set_int(0):a.is_string()&&(b.is_string()?a.data+=b.data:a.data+=(Math.round(1E10*b.data)/1E10).toString());this.owner.popTempValue()};a.prototype.eval_or=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.is_number()&&b.is_number()&&(a.data||b.data?a.set_int(1):a.set_int(0));this.owner.popTempValue()};a.prototype.eval_conditional=function(a){this.first.get(a);a.data?this.second.get(a):this.third.get(a)};a.prototype.eval_equal=function(a){this.first.get(a);
var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data===b.data?1:0);this.owner.popTempValue()};a.prototype.eval_notequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data!==b.data?1:0);this.owner.popTempValue()};a.prototype.eval_less=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data<b.data?1:0);this.owner.popTempValue()};a.prototype.eval_lessequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();
this.second.get(b);a.set_int(a.data<=b.data?1:0);this.owner.popTempValue()};a.prototype.eval_greater=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data>b.data?1:0);this.owner.popTempValue()};a.prototype.eval_greaterequal=function(a){this.first.get(a);var b=this.owner.pushTempValue();this.second.get(b);a.set_int(a.data>=b.data?1:0);this.owner.popTempValue()};a.prototype.eval_eventvar_exp=function(a){var b=this.eventvar.getValue();cr.is_number(b)?a.set_float(b):
a.set_string(b)};cr.expNode=a;b.prototype.is_int=function(){return this.type===cr.exptype.Integer};b.prototype.is_float=function(){return this.type===cr.exptype.Float};b.prototype.is_number=function(){return this.type===cr.exptype.Integer||this.type===cr.exptype.Float};b.prototype.is_string=function(){return this.type===cr.exptype.String};b.prototype.make_int=function(){this.is_int()||(this.is_float()?this.data=Math.floor(this.data):this.is_string()&&(this.data=parseInt(this.data,10)),this.type=cr.exptype.Integer)};
b.prototype.make_float=function(){this.is_float()||(this.is_string()&&(this.data=parseFloat(this.data)),this.type=cr.exptype.Float)};b.prototype.make_string=function(){this.is_string()||(this.data=this.data.toString(),this.type=cr.exptype.String)};b.prototype.set_int=function(a){this.type=cr.exptype.Integer;this.data=Math.floor(a)};b.prototype.set_float=function(a){this.type=cr.exptype.Float;this.data=a};b.prototype.set_string=function(a){this.type=cr.exptype.String;this.data=a};b.prototype.set_any=
function(a){cr.is_number(a)?(this.type=cr.exptype.Float,this.data=a):cr.is_string(a)?(this.type=cr.exptype.String,this.data=a.toString()):(this.type=cr.exptype.Integer,this.data=0)};cr.expvalue=b;cr.exptype={Integer:0,Float:1,String:2}})();cr.system_object=function(a){this.runtime=a;this.waits=[]};
cr.system_object.prototype.saveToJSON=function(){var a={},b,c,d,e,h,f,l,k;a.waits=[];var g=a.waits,m;b=0;for(c=this.waits.length;b<c;b++){f=this.waits[b];m={t:f.time,ev:f.ev.sid,sm:[],sols:{}};f.ev.actions[f.actindex]&&(m.act=f.ev.actions[f.actindex].sid);d=0;for(e=f.solModifiers.length;d<e;d++)m.sm.push(f.solModifiers[d].sid);for(h in f.sols)if(f.sols.hasOwnProperty(h)){l=this.runtime.types_by_index[parseInt(h,10)];k={sa:f.sols[h].sa,insts:[]};d=0;for(e=f.sols[h].insts.length;d<e;d++)k.insts.push(f.sols[h].insts[d].uid);
m.sols[l.sid.toString()]=k}g.push(m)}return a};
cr.system_object.prototype.loadFromJSON=function(a){a=a.waits;var b,c,d,e,h,f,l,k,g,m,n;b=this.waits.length=0;for(c=a.length;b<c;b++)if(f=a[b],k=this.runtime.blocksBySid[f.ev.toString()]){g=-1;d=0;for(e=k.actions.length;d<e;d++)if(k.actions[d].sid===f.act){g=d;break}if(-1!==g){l={sols:{},solModifiers:[],deleteme:!1};l.time=f.t;l.ev=k;l.actindex=g;d=0;for(e=f.sm.length;d<e;d++)(k=this.runtime.getObjectTypeBySid(f.sm[d]))&&l.solModifiers.push(k);for(h in f.sols)if(f.sols.hasOwnProperty(h)&&(k=this.runtime.getObjectTypeBySid(parseInt(h,
10)))){g=f.sols[h];m={sa:g.sa,insts:[]};d=0;for(e=g.insts.length;d<e;d++)(n=this.runtime.getObjectByUID(g.insts[d]))&&m.insts.push(n);l.sols[k.index.toString()]=m}this.waits.push(l)}}};
(function(){function a(){}function b(a,b){var c=a.extra.c2_foreachordered_val,d=b.extra.c2_foreachordered_val;if(cr.is_number(c)&&cr.is_number(d))return c-d;c=""+c;d=""+d;return c<d?-1:c>d?1:0}function c(a,b){g&&a===m&&b===n||(g=new RegExp(a,b),m=a,n=b);g.lastIndex=0;return g}function d(){}function e(){}function h(a,b,d){if(a!==t||b!==u||d!==C){var e=c(b,d);q=a.match(e);t=a;u=b;C=d}}var f=cr.system_object.prototype;a.prototype.EveryTick=function(){return!0};a.prototype.OnLayoutStart=function(){return!0};
a.prototype.OnLayoutEnd=function(){return!0};a.prototype.Compare=function(a,b,c){return cr.do_cmp(a,b,c)};a.prototype.CompareTime=function(a,b){var c=this.runtime.kahanTime.sum;if(0===a){var d=this.runtime.getCurrentCondition();return!d.extra.CompareTime_executed&&c>=b?d.extra.CompareTime_executed=!0:!1}return cr.do_cmp(c,a,b)};a.prototype.LayerVisible=function(a){return a?a.visible:!1};a.prototype.LayerCmpOpacity=function(a,b,c){return a?cr.do_cmp(100*a.opacity,b,c):!1};a.prototype.Repeat=function(a){var b=
this.runtime.getCurrentEventStack(),c=b.current_event,d=b.isModifierAfterCnds(),b=this.runtime.pushLoopStack();if(d)for(d=0;d<a&&!b.stopped;d++)this.runtime.pushCopySol(c.solModifiers),b.index=d,c.retrigger(),this.runtime.popSol(c.solModifiers);else for(d=0;d<a&&!b.stopped;d++)b.index=d,c.retrigger();this.runtime.popLoopStack();return!1};a.prototype.While=function(a){var b=this.runtime.getCurrentEventStack();a=b.current_event;var c=b.isModifierAfterCnds(),b=this.runtime.pushLoopStack();if(c)for(c=
0;!b.stopped;c++)this.runtime.pushCopySol(a.solModifiers),b.index=c,a.retrigger()||(b.stopped=!0),this.runtime.popSol(a.solModifiers);else for(c=0;!b.stopped;c++)b.index=c,a.retrigger()||(b.stopped=!0);this.runtime.popLoopStack();return!1};a.prototype.For=function(a,b,c){var d=this.runtime.getCurrentEventStack(),e=d.current_event,d=d.isModifierAfterCnds();a=this.runtime.pushLoopStack(a);if(c<b)if(d)for(;b>=c&&!a.stopped;--b)this.runtime.pushCopySol(e.solModifiers),a.index=b,e.retrigger(),this.runtime.popSol(e.solModifiers);
else for(;b>=c&&!a.stopped;--b)a.index=b,e.retrigger();else if(d)for(;b<=c&&!a.stopped;++b)this.runtime.pushCopySol(e.solModifiers),a.index=b,e.retrigger(),this.runtime.popSol(e.solModifiers);else for(;b<=c&&!a.stopped;++b)a.index=b,e.retrigger();this.runtime.popLoopStack();return!1};var l=[],k=-1;a.prototype.ForEach=function(a){var b=a.getCurrentSol();k++;l.length===k&&l.push([]);var c=l[k];cr.shallowAssignArray(c,b.getObjects());var d=this.runtime.getCurrentEventStack(),e=d.current_event,g=d.isModifierAfterCnds(),
d=this.runtime.pushLoopStack(),f,h,m,n,s,q,r=a.is_contained;if(g)for(g=0,f=c.length;g<f&&!d.stopped;g++){this.runtime.pushCopySol(e.solModifiers);n=c[g];b=a.getCurrentSol();b.select_all=!1;b.instances.length=1;b.instances[0]=n;if(r)for(h=0,m=n.siblings.length;h<m;h++)s=n.siblings[h],q=s.type.getCurrentSol(),q.select_all=!1,q.instances.length=1,q.instances[0]=s;d.index=g;e.retrigger();this.runtime.popSol(e.solModifiers)}else for(b.select_all=!1,b.instances.length=1,g=0,f=c.length;g<f&&!d.stopped;g++){n=
c[g];b.instances[0]=n;if(r)for(h=0,m=n.siblings.length;h<m;h++)s=n.siblings[h],q=s.type.getCurrentSol(),q.select_all=!1,q.instances.length=1,q.instances[0]=s;d.index=g;e.retrigger()}c.length=0;this.runtime.popLoopStack();k--;return!1};a.prototype.ForEachOrdered=function(a,c,d){c=a.getCurrentSol();k++;l.length===k&&l.push([]);var e=l[k];cr.shallowAssignArray(e,c.getObjects());var g=this.runtime.getCurrentEventStack(),f=g.current_event,h=this.runtime.getCurrentCondition(),m=g.isModifierAfterCnds(),
g=this.runtime.pushLoopStack(),n,s,q,r,p;n=0;for(s=e.length;n<s;n++)e[n].extra.c2_foreachordered_val=h.parameters[1].get(n);e.sort(b);1===d&&e.reverse();d=a.is_contained;if(m)for(n=0,s=e.length;n<s&&!g.stopped;n++){this.runtime.pushCopySol(f.solModifiers);q=e[n];c=a.getCurrentSol();c.select_all=!1;c.instances.length=1;c.instances[0]=q;if(d)for(h=0,m=q.siblings.length;h<m;h++)r=q.siblings[h],p=r.type.getCurrentSol(),p.select_all=!1,p.instances.length=1,p.instances[0]=r;g.index=n;f.retrigger();this.runtime.popSol(f.solModifiers)}else for(c.select_all=
!1,c.instances.length=1,n=0,s=e.length;n<s&&!g.stopped;n++){q=e[n];c.instances[0]=q;if(d)for(h=0,m=q.siblings.length;h<m;h++)r=q.siblings[h],p=r.type.getCurrentSol(),p.select_all=!1,p.instances.length=1,p.instances[0]=r;g.index=n;f.retrigger()}e.length=0;this.runtime.popLoopStack();k--;return!1};a.prototype.PickByComparison=function(a,b,c,d){var e,g,f,h;if(a){k++;l.length===k&&l.push([]);var m=l[k],n=a.getCurrentSol();cr.shallowAssignArray(m,n.getObjects());n.select_all&&(n.else_instances.length=
0);var s=this.runtime.getCurrentCondition();f=e=0;for(g=m.length;e<g;e++)h=m[e],m[f]=h,b=s.parameters[1].get(e),d=s.parameters[3].get(e),cr.do_cmp(b,c,d)?f++:n.else_instances.push(h);m.length=f;n.select_all=!1;cr.shallowAssignArray(n.instances,m);m.length=0;k--;a.applySolToContainer();return!!n.instances.length}};a.prototype.PickByEvaluate=function(a,b){var c,d,e,g;if(a){k++;l.length===k&&l.push([]);var f=l[k],h=a.getCurrentSol();cr.shallowAssignArray(f,h.getObjects());h.select_all&&(h.else_instances.length=
0);var m=this.runtime.getCurrentCondition();e=c=0;for(d=f.length;c<d;c++)g=f[c],f[e]=g,(b=m.parameters[1].get(c))?e++:h.else_instances.push(g);f.length=e;h.select_all=!1;cr.shallowAssignArray(h.instances,f);f.length=0;k--;a.applySolToContainer();return!!h.instances.length}};a.prototype.TriggerOnce=function(){var a=this.runtime.getCurrentCondition().extra;"undefined"===typeof a.TriggerOnce_lastTick&&(a.TriggerOnce_lastTick=-1);var b=a.TriggerOnce_lastTick,c=this.runtime.tickcount;a.TriggerOnce_lastTick=
c;return this.runtime.layout_first_tick||b!==c-1};a.prototype.Every=function(a){var b=this.runtime.getCurrentCondition(),c=b.extra.Every_lastTime||0,d=this.runtime.kahanTime.sum;"undefined"===typeof b.extra.Every_seconds&&(b.extra.Every_seconds=a);var e=b.extra.Every_seconds;if(d>=c+e)return b.extra.Every_lastTime=c+e,d>=b.extra.Every_lastTime+0.04&&(b.extra.Every_lastTime=d),b.extra.Every_seconds=a,!0;d<c-0.1&&(b.extra.Every_lastTime=d);return!1};a.prototype.PickNth=function(a,b){if(!a)return!1;
var c=a.getCurrentSol(),d=c.getObjects();b=cr.floor(b);if(0>b||b>=d.length)return!1;c.pick_one(d[b]);a.applySolToContainer();return!0};a.prototype.PickRandom=function(a){if(!a)return!1;var b=a.getCurrentSol(),c=b.getObjects(),d=cr.floor(Math.random()*c.length);if(d>=c.length)return!1;b.pick_one(c[d]);a.applySolToContainer();return!0};a.prototype.CompareVar=function(a,b,c){return cr.do_cmp(a.getValue(),b,c)};a.prototype.IsGroupActive=function(a){return(a=this.runtime.groups_by_name[a.toLowerCase()])&&
a.group_active};a.prototype.IsPreview=function(){return"undefined"!==typeof cr_is_preview};a.prototype.PickAll=function(a){if(!a||!a.instances.length)return!1;a.getCurrentSol().select_all=!0;a.applySolToContainer();return!0};a.prototype.IsMobile=function(){return this.runtime.isMobile};a.prototype.CompareBetween=function(a,b,c){return a>=b&&a<=c};a.prototype.Else=function(){var a=this.runtime.getCurrentEventStack();return a.else_branch_ran?!1:!a.last_event_true};a.prototype.OnLoadFinished=function(){return!0};
a.prototype.OnCanvasSnapshot=function(){return!0};a.prototype.EffectsSupported=function(){return!!this.runtime.glwrap};a.prototype.OnSaveComplete=function(){return!0};a.prototype.OnLoadComplete=function(){return!0};a.prototype.OnLoadFailed=function(){return!0};a.prototype.ObjectUIDExists=function(a){return!!this.runtime.getObjectByUID(a)};a.prototype.IsOnPlatform=function(a){var b=this.runtime;switch(a){case 0:return!b.isDomFree&&!b.isNodeWebkit&&!b.isPhoneGap&&!b.isCrosswalk&&!b.isWinJS&&!b.isWindowsPhone8&&
!b.isBlackberry10&&!b.isAmazonWebApp;case 1:return b.isiOS;case 2:return b.isAndroid;case 3:return b.isWindows8App;case 4:return b.isWindowsPhone8;case 5:return b.isBlackberry10;case 6:return b.isTizen;case 7:return b.isCocoonJs;case 8:return b.isPhoneGap;case 9:return b.isArcade;case 10:return b.isNodeWebkit;case 11:return b.isCrosswalk;case 12:return b.isAmazonWebApp;default:return!1}};var g=null,m="",n="";a.prototype.RegexTest=function(a,b,d){return c(b,d).test(a)};var p=[];a.prototype.PickOverlappingPoint=
function(a,b,c){if(!a)return!1;var d=a.getCurrentSol(),e=d.getObjects(),g=this.runtime.getCurrentEventStack().current_event.orblock,f=this.runtime.getCurrentCondition(),k,h;d.select_all?(cr.shallowAssignArray(p,e),d.else_instances.length=0,d.select_all=!1,d.instances.length=0):g?(cr.shallowAssignArray(p,d.else_instances),d.else_instances.length=0):(cr.shallowAssignArray(p,e),d.instances.length=0);e=0;for(g=p.length;e<g;++e)k=p[e],k.update_bbox(),(h=cr.xor(k.contains_pt(b,c),f.inverted))?d.instances.push(k):
d.else_instances.push(k);a.applySolToContainer();return cr.xor(!!d.instances.length,f.inverted)};f.cnds=new a;d.prototype.GoToLayout=function(a){this.runtime.isloading||this.runtime.changelayout||(this.runtime.changelayout=a)};d.prototype.CreateObject=function(a,b,c,d){if(b&&a&&(b=this.runtime.createInstance(a,b,c,d))){this.runtime.isInOnDestroy++;var e;this.runtime.trigger(Object.getPrototypeOf(a.plugin).cnds.OnCreated,b);if(b.is_contained)for(c=0,d=b.siblings.length;c<d;c++)e=b.siblings[c],this.runtime.trigger(Object.getPrototypeOf(e.type.plugin).cnds.OnCreated,
e);this.runtime.isInOnDestroy--;a=a.getCurrentSol();a.select_all=!1;a.instances.length=1;a.instances[0]=b;if(b.is_contained)for(c=0,d=b.siblings.length;c<d;c++)e=b.siblings[c],a=e.type.getCurrentSol(),a.select_all=!1,a.instances.length=1,a.instances[0]=e}};d.prototype.SetLayerVisible=function(a,b){a&&a.visible!==b&&(a.visible=b,this.runtime.redraw=!0)};d.prototype.SetLayerOpacity=function(a,b){a&&(b=cr.clamp(b/100,0,1),a.opacity!==b&&(a.opacity=b,this.runtime.redraw=!0))};d.prototype.SetLayerScaleRate=
function(a,b){a&&a.zoomRate!==b&&(a.zoomRate=b,this.runtime.redraw=!0)};d.prototype.SetLayoutScale=function(a){this.runtime.running_layout&&this.runtime.running_layout.scale!==a&&(this.runtime.running_layout.scale=a,this.runtime.running_layout.boundScrolling(),this.runtime.redraw=!0)};d.prototype.ScrollX=function(a){this.runtime.running_layout.scrollToX(a)};d.prototype.ScrollY=function(a){this.runtime.running_layout.scrollToY(a)};d.prototype.Scroll=function(a,b){this.runtime.running_layout.scrollToX(a);
this.runtime.running_layout.scrollToY(b)};d.prototype.ScrollToObject=function(a){if(a=a.getFirstPicked())this.runtime.running_layout.scrollToX(a.x),this.runtime.running_layout.scrollToY(a.y)};d.prototype.SetVar=function(a,b){0===a.vartype?cr.is_number(b)?a.setValue(b):a.setValue(parseFloat(b)):1===a.vartype&&a.setValue(b.toString())};d.prototype.AddVar=function(a,b){0===a.vartype?cr.is_number(b)?a.setValue(a.getValue()+b):a.setValue(a.getValue()+parseFloat(b)):1===a.vartype&&a.setValue(a.getValue()+
b.toString())};d.prototype.SubVar=function(a,b){0===a.vartype&&(cr.is_number(b)?a.setValue(a.getValue()-b):a.setValue(a.getValue()-parseFloat(b)))};d.prototype.SetGroupActive=function(a,b){var c=this.runtime.groups_by_name[a.toLowerCase()];if(c)switch(b){case 0:c.setGroupActive(!1);break;case 1:c.setGroupActive(!0);break;case 2:c.setGroupActive(!c.group_active)}};d.prototype.SetTimescale=function(a){0>a&&(a=0);this.runtime.timescale=a};d.prototype.SetObjectTimescale=function(a,b){var c=b;0>c&&(c=
0);if(a){var d=a.getCurrentSol().getObjects(),e,g;e=0;for(g=d.length;e<g;e++)d[e].my_timescale=c}};d.prototype.RestoreObjectTimescale=function(a){if(!a)return!1;a=a.getCurrentSol().getObjects();var b,c;b=0;for(c=a.length;b<c;b++)a[b].my_timescale=-1};var r=[],s=[];d.prototype.Wait=function(a){if(!(0>a)){var b,c,d,e=this.runtime.getCurrentEventStack(),g;g=r.length?r.pop():{sols:{},solModifiers:[]};g.deleteme=!1;g.time=this.runtime.kahanTime.sum+a;g.ev=e.current_event;g.actindex=e.actindex+1;a=0;for(b=
this.runtime.types_by_index.length;a<b;a++)d=this.runtime.types_by_index[a],c=d.getCurrentSol(),c.select_all&&-1===e.current_event.solModifiers.indexOf(d)||(g.solModifiers.push(d),d=void 0,d=s.length?s.pop():{insts:[]},d.sa=!1,d.sa=c.select_all,cr.shallowAssignArray(d.insts,c.instances),g.sols[a.toString()]=d);this.waits.push(g);return!0}};d.prototype.SetLayerScale=function(a,b){a&&a.scale!==b&&(a.scale=b,this.runtime.redraw=!0)};d.prototype.ResetGlobals=function(){var a,b,c;a=0;for(b=this.runtime.all_global_vars.length;a<
b;a++)c=this.runtime.all_global_vars[a],c.data=c.initial};d.prototype.SetLayoutAngle=function(a){a=cr.to_radians(a);a=cr.clamp_angle(a);this.runtime.running_layout&&this.runtime.running_layout.angle!==a&&(this.runtime.running_layout.angle=a,this.runtime.redraw=!0)};d.prototype.SetLayerAngle=function(a,b){a&&(b=cr.to_radians(b),b=cr.clamp_angle(b),a.angle!==b&&(a.angle=b,this.runtime.redraw=!0))};d.prototype.SetLayerParallax=function(a,b,c){if(a&&(a.parallaxX!==b/100||a.parallaxY!==c/100)){a.parallaxX=
b/100;a.parallaxY=c/100;if(1!==a.parallaxX||1!==a.parallaxY)for(c=a.instances,a=0,b=c.length;a<b;++a)c[a].type.any_instance_parallaxed=!0;this.runtime.redraw=!0}};d.prototype.SetLayerBackground=function(a,b){if(a){var c=cr.GetRValue(b),d=cr.GetGValue(b),e=cr.GetBValue(b);if(a.background_color[0]!==c||a.background_color[1]!==d||a.background_color[2]!==e)a.background_color[0]=c,a.background_color[1]=d,a.background_color[2]=e,this.runtime.redraw=!0}};d.prototype.SetLayerTransparent=function(a,b){a&&
!!b!==!!a.transparent&&(a.transparent=!!b,this.runtime.redraw=!0)};d.prototype.StopLoop=function(){0>this.runtime.loop_stack_index||(this.runtime.getCurrentLoop().stopped=!0)};d.prototype.GoToLayoutByName=function(a){if(!this.runtime.isloading&&!this.runtime.changelayout)for(var b in this.runtime.layouts)if(this.runtime.layouts.hasOwnProperty(b)&&cr.equals_nocase(b,a)){this.runtime.changelayout=this.runtime.layouts[b];break}};d.prototype.RestartLayout=function(a){if(!this.runtime.isloading&&!this.runtime.changelayout&&
this.runtime.running_layout){this.runtime.changelayout=this.runtime.running_layout;var b,c;a=0;for(b=this.runtime.allGroups.length;a<b;a++)c=this.runtime.allGroups[a],c.setGroupActive(c.initially_activated)}};d.prototype.SnapshotCanvas=function(a,b){this.runtime.snapshotCanvas=[0===a?"image/png":"image/jpeg",b/100];this.runtime.redraw=!0};d.prototype.SetCanvasSize=function(a,b){if(!(0>=a||0>=b)){var c=this.runtime.fullscreen_mode;(document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||
document.fullScreen||this.runtime.isNodeFullscreen)&&0<this.runtime.fullscreen_scaling&&(c=this.runtime.fullscreen_scaling);0===c?this.runtime.setSize(a,b,!0):(this.runtime.original_width=a,this.runtime.original_height=b,this.runtime.setSize(this.runtime.lastWindowWidth,this.runtime.lastWindowHeight,!0))}};d.prototype.SetLayoutEffectEnabled=function(a,b){if(this.runtime.running_layout&&this.runtime.glwrap){var c=this.runtime.running_layout.getEffectByName(b);if(c){var d=1===a;c.active!=d&&(c.active=
d,this.runtime.running_layout.updateActiveEffects(),this.runtime.redraw=!0)}}};d.prototype.SetLayerEffectEnabled=function(a,b,c){a&&this.runtime.glwrap&&(c=a.getEffectByName(c))&&(b=1===b,c.active!=b&&(c.active=b,a.updateActiveEffects(),this.runtime.redraw=!0))};d.prototype.SetLayoutEffectParam=function(a,b,c){if(this.runtime.running_layout&&this.runtime.glwrap&&(a=this.runtime.running_layout.getEffectByName(a))){var d=this.runtime.running_layout.effect_params[a.index];b=Math.floor(b);0>b||b>=d.length||
(1===this.runtime.glwrap.getProgramParameterType(a.shaderindex,b)&&(c/=100),d[b]!==c&&(d[b]=c,a.active&&(this.runtime.redraw=!0)))}};d.prototype.SetLayerEffectParam=function(a,b,c,d){a&&this.runtime.glwrap&&(b=a.getEffectByName(b))&&(a=a.effect_params[b.index],c=Math.floor(c),0>c||c>=a.length||(1===this.runtime.glwrap.getProgramParameterType(b.shaderindex,c)&&(d/=100),a[c]!==d&&(a[c]=d,b.active&&(this.runtime.redraw=!0))))};d.prototype.SaveState=function(a){this.runtime.saveToSlot=a};d.prototype.LoadState=
function(a){this.runtime.loadFromSlot=a};d.prototype.LoadStateJSON=function(a){this.runtime.loadFromJson=a};d.prototype.SetHalfFramerateMode=function(a){this.runtime.halfFramerateMode=0!==a};d.prototype.SetFullscreenQuality=function(a){if(document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||document.fullScreen||this.isNodeFullscreen||0!==this.runtime.fullscreen_mode)this.runtime.wantFullscreenScalingQuality=0!==a,this.runtime.setSize(this.runtime.lastWindowWidth,this.runtime.lastWindowHeight,
!0)};f.acts=new d;e.prototype["int"]=function(a,b){cr.is_string(b)?(a.set_int(parseInt(b,10)),isNaN(a.data)&&(a.data=0)):a.set_int(b)};e.prototype["float"]=function(a,b){cr.is_string(b)?(a.set_float(parseFloat(b)),isNaN(a.data)&&(a.data=0)):a.set_float(b)};e.prototype.str=function(a,b){cr.is_string(b)?a.set_string(b):a.set_string(b.toString())};e.prototype.len=function(a,b){a.set_int(b.length||0)};e.prototype.random=function(a,b,c){void 0===c?a.set_float(Math.random()*b):a.set_float(Math.random()*
(c-b)+b)};e.prototype.sqrt=function(a,b){a.set_float(Math.sqrt(b))};e.prototype.abs=function(a,b){a.set_float(Math.abs(b))};e.prototype.round=function(a,b){a.set_int(Math.round(b))};e.prototype.floor=function(a,b){a.set_int(Math.floor(b))};e.prototype.ceil=function(a,b){a.set_int(Math.ceil(b))};e.prototype.sin=function(a,b){a.set_float(Math.sin(cr.to_radians(b)))};e.prototype.cos=function(a,b){a.set_float(Math.cos(cr.to_radians(b)))};e.prototype.tan=function(a,b){a.set_float(Math.tan(cr.to_radians(b)))};
e.prototype.asin=function(a,b){a.set_float(cr.to_degrees(Math.asin(b)))};e.prototype.acos=function(a,b){a.set_float(cr.to_degrees(Math.acos(b)))};e.prototype.atan=function(a,b){a.set_float(cr.to_degrees(Math.atan(b)))};e.prototype.exp=function(a,b){a.set_float(Math.exp(b))};e.prototype.ln=function(a,b){a.set_float(Math.log(b))};e.prototype.log10=function(a,b){a.set_float(Math.log(b)/Math.LN10)};e.prototype.max=function(a){var b=arguments[1],c,d;c=2;for(d=arguments.length;c<d;c++)b<arguments[c]&&(b=
arguments[c]);a.set_float(b)};e.prototype.min=function(a){var b=arguments[1],c,d;c=2;for(d=arguments.length;c<d;c++)b>arguments[c]&&(b=arguments[c]);a.set_float(b)};e.prototype.dt=function(a){a.set_float(this.runtime.dt)};e.prototype.timescale=function(a){a.set_float(this.runtime.timescale)};e.prototype.wallclocktime=function(a){a.set_float((Date.now()-this.runtime.start_time)/1E3)};e.prototype.time=function(a){a.set_float(this.runtime.kahanTime.sum)};e.prototype.tickcount=function(a){a.set_int(this.runtime.tickcount)};
e.prototype.objectcount=function(a){a.set_int(this.runtime.objectcount)};e.prototype.fps=function(a){a.set_int(this.runtime.fps)};e.prototype.loopindex=function(a,b){var c,d,e;if(this.runtime.loop_stack.length)if(b){d=0;for(e=this.runtime.loop_stack.length;d<e;d++)if(c=this.runtime.loop_stack[d],c.name===b){a.set_int(c.index);return}a.set_int(0)}else c=this.runtime.getCurrentLoop(),a.set_int(c?c.index:-1);else a.set_int(0)};e.prototype.distance=function(a,b,c,d,e){a.set_float(cr.distanceTo(b,c,d,
e))};e.prototype.angle=function(a,b,c,d,e){a.set_float(cr.to_degrees(cr.angleTo(b,c,d,e)))};e.prototype.scrollx=function(a){a.set_float(this.runtime.running_layout.scrollX)};e.prototype.scrolly=function(a){a.set_float(this.runtime.running_layout.scrollY)};e.prototype.newline=function(a){a.set_string("\n")};e.prototype.lerp=function(a,b,c,d){a.set_float(cr.lerp(b,c,d))};e.prototype.windowwidth=function(a){a.set_int(this.runtime.width)};e.prototype.windowheight=function(a){a.set_int(this.runtime.height)};
e.prototype.uppercase=function(a,b){a.set_string(cr.is_string(b)?b.toUpperCase():"")};e.prototype.lowercase=function(a,b){a.set_string(cr.is_string(b)?b.toLowerCase():"")};e.prototype.clamp=function(a,b,c,d){b<c?a.set_float(c):b>d?a.set_float(d):a.set_float(b)};e.prototype.layerscale=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(c.scale):a.set_float(0)};e.prototype.layeropacity=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.opacity):a.set_float(0)};e.prototype.layerscalerate=
function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(c.zoomRate):a.set_float(0)};e.prototype.layerparallaxx=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.parallaxX):a.set_float(0)};e.prototype.layerparallaxy=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(100*c.parallaxY):a.set_float(0)};e.prototype.layoutscale=function(a){this.runtime.running_layout?a.set_float(this.runtime.running_layout.scale):a.set_float(0)};e.prototype.layoutangle=function(a){a.set_float(cr.to_degrees(this.runtime.running_layout.angle))};
e.prototype.layerangle=function(a,b){var c=this.runtime.getLayer(b);c?a.set_float(cr.to_degrees(c.angle)):a.set_float(0)};e.prototype.layoutwidth=function(a){a.set_int(this.runtime.running_layout.width)};e.prototype.layoutheight=function(a){a.set_int(this.runtime.running_layout.height)};e.prototype.find=function(a,b,c){cr.is_string(b)&&cr.is_string(c)?a.set_int(b.search(new RegExp(cr.regexp_escape(c),"i"))):a.set_int(-1)};e.prototype.left=function(a,b,c){a.set_string(cr.is_string(b)?b.substr(0,c):
"")};e.prototype.right=function(a,b,c){a.set_string(cr.is_string(b)?b.substr(b.length-c):"")};e.prototype.mid=function(a,b,c,d){a.set_string(cr.is_string(b)?b.substr(c,d):"")};e.prototype.tokenat=function(a,b,c,d){cr.is_string(b)&&cr.is_string(d)?(b=b.split(d),c=cr.floor(c),0>c||c>=b.length?a.set_string(""):a.set_string(b[c])):a.set_string("")};e.prototype.tokencount=function(a,b,c){cr.is_string(b)&&b.length?a.set_int(b.split(c).length):a.set_int(0)};e.prototype.replace=function(a,b,c,d){cr.is_string(b)&&
cr.is_string(c)&&cr.is_string(d)?a.set_string(b.replace(new RegExp(cr.regexp_escape(c),"gi"),d)):a.set_string(cr.is_string(b)?b:"")};e.prototype.trim=function(a,b){a.set_string(cr.is_string(b)?b.trim():"")};e.prototype.pi=function(a){a.set_float(cr.PI)};e.prototype.layoutname=function(a){this.runtime.running_layout?a.set_string(this.runtime.running_layout.name):a.set_string("")};e.prototype.renderer=function(a){a.set_string(this.runtime.gl?"webgl":"canvas2d")};e.prototype.anglediff=function(a,b,c){a.set_float(cr.to_degrees(cr.angleDiff(cr.to_radians(b),
cr.to_radians(c))))};e.prototype.choose=function(a){var b=cr.floor(Math.random()*(arguments.length-1));a.set_any(arguments[b+1])};e.prototype.rgb=function(a,b,c,d){a.set_int(cr.RGB(b,c,d))};e.prototype.projectversion=function(a){a.set_string(this.runtime.versionstr)};e.prototype.anglelerp=function(a,b,c,d){b=cr.to_radians(b);c=cr.to_radians(c);var e=cr.angleDiff(b,c);cr.angleClockwise(c,b)?a.set_float(cr.to_clamped_degrees(b+e*d)):a.set_float(cr.to_clamped_degrees(b-e*d))};e.prototype.anglerotate=
function(a,b,c,d){b=cr.to_radians(b);c=cr.to_radians(c);d=cr.to_radians(d);a.set_float(cr.to_clamped_degrees(cr.angleRotate(b,c,d)))};e.prototype.zeropad=function(a,b,c){var d=0>b?"-":"";0>b&&(b=-b);c-=b.toString().length;for(var e=0;e<c;e++)d+="0";a.set_string(d+b.toString())};e.prototype.cpuutilisation=function(a){a.set_float(this.runtime.cpuutilisation/1E3)};e.prototype.viewportleft=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewLeft:0)};e.prototype.viewporttop=function(a,b){var c=
this.runtime.getLayer(b);a.set_float(c?c.viewTop:0)};e.prototype.viewportright=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewRight:0)};e.prototype.viewportbottom=function(a,b){var c=this.runtime.getLayer(b);a.set_float(c?c.viewBottom:0)};e.prototype.loadingprogress=function(a){a.set_float(this.runtime.loadingprogress)};e.prototype.unlerp=function(a,b,c,d){a.set_float(cr.unlerp(b,c,d))};e.prototype.canvassnapshot=function(a){a.set_string(this.runtime.snapshotData)};e.prototype.urlencode=
function(a,b){a.set_string(encodeURIComponent(b))};e.prototype.urldecode=function(a,b){a.set_string(decodeURIComponent(b))};e.prototype.canvastolayerx=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.canvasToLayer(c,d,!0):0)};e.prototype.canvastolayery=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.canvasToLayer(c,d,!1):0)};e.prototype.layertocanvasx=function(a,b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.layerToCanvas(c,d,!0):0)};e.prototype.layertocanvasy=function(a,
b,c,d){b=this.runtime.getLayer(b);a.set_float(b?b.layerToCanvas(c,d,!1):0)};e.prototype.savestatejson=function(a){a.set_string(this.runtime.lastSaveJson)};e.prototype.imagememoryusage=function(a){this.runtime.glwrap?a.set_float(Math.round(100*this.runtime.glwrap.estimateVRAM()/1048576)/100):a.set_float(0)};e.prototype.regexsearch=function(a,b,d,e){d=c(d,e);a.set_int(b?b.search(d):-1)};e.prototype.regexreplace=function(a,b,d,e,g){d=c(d,e);a.set_string(b?b.replace(d,g):"")};var q=[],t="",u="",C="";
e.prototype.regexmatchcount=function(a,b,d,e){c(d,e);h(b,d,e);a.set_int(q?q.length:0)};e.prototype.regexmatchat=function(a,b,d,e,g){g=Math.floor(g);c(d,e);h(b,d,e);!q||0>g||g>=q.length?a.set_string(""):a.set_string(q[g])};e.prototype.infinity=function(a){a.set_float(Infinity)};e.prototype.setbit=function(a,b,c,d){c|=0;a.set_int((b|0)&~(1<<c)|(0!==d?1:0)<<c)};e.prototype.togglebit=function(a,b,c){a.set_int((b|0)^1<<(c|0))};e.prototype.getbit=function(a,b,c){a.set_int((b|0)&1<<(c|0)?1:0)};f.exps=new e;
f.runWaits=function(){var a,b,c,d,e,g,f=this.runtime.getCurrentEventStack();a=0;for(c=this.waits.length;a<c;a++)if(d=this.waits[a],!(d.time>this.runtime.kahanTime.sum)){f.current_event=d.ev;f.actindex=d.actindex;f.cndindex=0;for(b in d.sols)d.sols.hasOwnProperty(b)&&(e=this.runtime.types_by_index[parseInt(b,10)].getCurrentSol(),g=d.sols[b],e.select_all=g.sa,cr.shallowAssignArray(e.instances,g.insts),e=g,e.insts.length=0,s.push(e));d.ev.resume_actions_and_subevents();this.runtime.clearSol(d.solModifiers);
d.deleteme=!0}b=a=0;for(c=this.waits.length;a<c;a++)d=this.waits[a],this.waits[b]=d,d.deleteme?(cr.wipe(d.sols),d.solModifiers.length=0,r.push(d)):b++;this.waits.length=b}})();
(function(){cr.add_common_aces=function(a){var c=a[0].prototype,d=a[1],e=a[3],h=a[4],f=a[5],l=a[6],k=a[7];a=a[8];c.cnds||(c.cnds={});c.acts||(c.acts={});c.exps||(c.exps={});var g=c.cnds,m=c.acts,c=c.exps;e&&(g.CompareX=function(a,b){return cr.do_cmp(this.x,a,b)},g.CompareY=function(a,b){return cr.do_cmp(this.y,a,b)},g.IsOnScreen=function(){var a=this.layer;this.update_bbox();var b=this.bbox;return!(b.right<a.viewLeft||b.bottom<a.viewTop||b.left>a.viewRight||b.top>a.viewBottom)},g.IsOutsideLayout=
function(){this.update_bbox();var a=this.bbox,b=this.runtime.running_layout;return 0>a.right||0>a.bottom||a.left>b.width||a.top>b.height},g.PickDistance=function(a,b,c){var d=this.getCurrentSol(),e=d.getObjects();if(!e.length)return!1;var g=e[0],f=g,k=cr.distanceTo(g.x,g.y,b,c),h,l,m;h=1;for(l=e.length;h<l;h++)if(g=e[h],m=cr.distanceTo(g.x,g.y,b,c),0===a&&m<k||1===a&&m>k)k=m,f=g;d.pick_one(f);return!0},m.SetX=function(a){this.x!==a&&(this.x=a,this.set_bbox_changed())},m.SetY=function(a){this.y!==
a&&(this.y=a,this.set_bbox_changed())},m.SetPos=function(a,b){if(this.x!==a||this.y!==b)this.x=a,this.y=b,this.set_bbox_changed()},m.SetPosToObject=function(a,b){var c=a.getPairedInstance(this);if(c){var d;c.getImagePoint?(d=c.getImagePoint(b,!0),c=c.getImagePoint(b,!1)):(d=c.x,c=c.y);if(this.x!==d||this.y!==c)this.x=d,this.y=c,this.set_bbox_changed()}},m.MoveForward=function(a){0!==a&&(this.x+=Math.cos(this.angle)*a,this.y+=Math.sin(this.angle)*a,this.set_bbox_changed())},m.MoveAtAngle=function(a,
b){0!==b&&(this.x+=Math.cos(cr.to_radians(a))*b,this.y+=Math.sin(cr.to_radians(a))*b,this.set_bbox_changed())},c.X=function(a){a.set_float(this.x)},c.Y=function(a){a.set_float(this.y)},c.dt=function(a){a.set_float(this.runtime.getDt(this))});h&&(g.CompareWidth=function(a,b){return cr.do_cmp(this.width,a,b)},g.CompareHeight=function(a,b){return cr.do_cmp(this.height,a,b)},m.SetWidth=function(a){this.width!==a&&(this.width=a,this.set_bbox_changed())},m.SetHeight=function(a){this.height!==a&&(this.height=
a,this.set_bbox_changed())},m.SetSize=function(a,b){if(this.width!==a||this.height!==b)this.width=a,this.height=b,this.set_bbox_changed()},c.Width=function(a){a.set_float(this.width)},c.Height=function(a){a.set_float(this.height)},c.BBoxLeft=function(a){this.update_bbox();a.set_float(this.bbox.left)},c.BBoxTop=function(a){this.update_bbox();a.set_float(this.bbox.top)},c.BBoxRight=function(a){this.update_bbox();a.set_float(this.bbox.right)},c.BBoxBottom=function(a){this.update_bbox();a.set_float(this.bbox.bottom)});
f&&(g.AngleWithin=function(a,b){return cr.angleDiff(this.angle,cr.to_radians(b))<=cr.to_radians(a)},g.IsClockwiseFrom=function(a){return cr.angleClockwise(this.angle,cr.to_radians(a))},g.IsBetweenAngles=function(a,b){var c=cr.to_clamped_radians(a),d=cr.to_clamped_radians(b),e=cr.clamp_angle(this.angle);return cr.angleClockwise(d,c)?cr.angleClockwise(e,c)&&!cr.angleClockwise(e,d):!(!cr.angleClockwise(e,c)&&cr.angleClockwise(e,d))},m.SetAngle=function(a){a=cr.to_radians(cr.clamp_angle_degrees(a));isNaN(a)||
this.angle===a||(this.angle=a,this.set_bbox_changed())},m.RotateClockwise=function(a){0===a||isNaN(a)||(this.angle+=cr.to_radians(a),this.angle=cr.clamp_angle(this.angle),this.set_bbox_changed())},m.RotateCounterclockwise=function(a){0===a||isNaN(a)||(this.angle-=cr.to_radians(a),this.angle=cr.clamp_angle(this.angle),this.set_bbox_changed())},m.RotateTowardAngle=function(a,b){var c=cr.angleRotate(this.angle,cr.to_radians(b),cr.to_radians(a));isNaN(c)||this.angle===c||(this.angle=c,this.set_bbox_changed())},
m.RotateTowardPosition=function(a,b,c){b=Math.atan2(c-this.y,b-this.x);a=cr.angleRotate(this.angle,b,cr.to_radians(a));isNaN(a)||this.angle===a||(this.angle=a,this.set_bbox_changed())},m.SetTowardPosition=function(a,b){var c=Math.atan2(b-this.y,a-this.x);isNaN(c)||this.angle===c||(this.angle=c,this.set_bbox_changed())},c.Angle=function(a){a.set_float(cr.to_clamped_degrees(this.angle))});d||(g.CompareInstanceVar=function(a,b,c){return cr.do_cmp(this.instance_vars[a],b,c)},g.IsBoolInstanceVarSet=function(a){return this.instance_vars[a]},
g.PickInstVarHiLow=function(a,b){var c=this.getCurrentSol(),d=c.getObjects();if(!d.length)return!1;var e=d[0],g=e,f=e.instance_vars[b],k,h,l;k=1;for(h=d.length;k<h;k++)if(e=d[k],l=e.instance_vars[b],0===a&&l<f||1===a&&l>f)f=l,g=e;c.pick_one(g);return!0},g.PickByUID=function(a){var b,c,d,e,g;if(this.runtime.getCurrentCondition().inverted){g=this.getCurrentSol();if(g.select_all)for(g.select_all=!1,g.instances.length=0,g.else_instances.length=0,d=this.instances,b=0,c=d.length;b<c;b++)e=d[b],e.uid===
a?g.else_instances.push(e):g.instances.push(e);else{d=b=0;for(c=g.instances.length;b<c;b++)e=g.instances[b],g.instances[d]=e,e.uid===a?g.else_instances.push(e):d++;g.instances.length=d}this.applySolToContainer();return!!g.instances.length}e=this.runtime.getObjectByUID(a);if(!e)return!1;g=this.getCurrentSol();if(!g.select_all&&-1===g.instances.indexOf(e))return!1;if(this.is_family)for(a=e.type.families,b=0,c=a.length;b<c;b++){if(a[b]===this)return g.pick_one(e),this.applySolToContainer(),!0}else if(e.type===
this)return g.pick_one(e),this.applySolToContainer(),!0;return!1},g.OnCreated=function(){return!0},g.OnDestroyed=function(){return!0},m.SetInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])?cr.is_number(b)?c[a]=b:c[a]=parseFloat(b):cr.is_string(c[a])&&(cr.is_string(b)?c[a]=b:c[a]=b.toString())},m.AddInstanceVar=function(a,b){var c=this.instance_vars;cr.is_number(c[a])?cr.is_number(b)?c[a]+=b:c[a]+=parseFloat(b):cr.is_string(c[a])&&(cr.is_string(b)?c[a]+=b:c[a]+=b.toString())},m.SubInstanceVar=
function(a,b){var c=this.instance_vars;cr.is_number(c[a])&&(cr.is_number(b)?c[a]-=b:c[a]-=parseFloat(b))},m.SetBoolInstanceVar=function(a,b){this.instance_vars[a]=b?1:0},m.ToggleBoolInstanceVar=function(a){this.instance_vars[a]=1-this.instance_vars[a]},m.Destroy=function(){this.runtime.DestroyInstance(this)},m.LoadFromJsonString||(m.LoadFromJsonString=function(a){var b,c;try{b=JSON.parse(a)}catch(d){return}this.runtime.loadInstanceFromJSON(this,b,!0);this.afterLoad&&this.afterLoad();if(this.behavior_insts)for(a=
0,b=this.behavior_insts.length;a<b;++a)c=this.behavior_insts[a],c.afterLoad&&c.afterLoad()}),c.Count=function(a){var b=a.object_class.instances.length,c,d,e;c=0;for(d=this.runtime.createRow.length;c<d;c++)e=this.runtime.createRow[c],a.object_class.is_family?0<=e.type.families.indexOf(a.object_class)&&b++:e.type===a.object_class&&b++;a.set_int(b)},c.PickedCount=function(a){a.set_int(a.object_class.getCurrentSol().getObjects().length)},c.UID=function(a){a.set_int(this.uid)},c.IID=function(a){a.set_int(this.get_iid())},
c.AsJSON||(c.AsJSON=function(a){a.set_string(JSON.stringify(this.runtime.saveInstanceToJSON(this,!0)))}));l&&(g.IsVisible=function(){return this.visible},m.SetVisible=function(a){!a!==!this.visible&&(this.visible=a,this.runtime.redraw=!0)},g.CompareOpacity=function(a,b){return cr.do_cmp(cr.round6dp(100*this.opacity),a,b)},m.SetOpacity=function(a){a/=100;0>a?a=0:1<a&&(a=1);a!==this.opacity&&(this.opacity=a,this.runtime.redraw=!0)},c.Opacity=function(a){a.set_float(cr.round6dp(100*this.opacity))});
k&&(g.IsOnLayer=function(a){return a?this.layer===a:!1},g.PickTopBottom=function(a){var b=this.getCurrentSol(),c=b.getObjects();if(!c.length)return!1;var d=c[0],e=d,g,f;g=1;for(f=c.length;g<f;g++)if(d=c[g],0===a){if(d.layer.index>e.layer.index||d.layer.index===e.layer.index&&d.get_zindex()>e.get_zindex())e=d}else if(d.layer.index<e.layer.index||d.layer.index===e.layer.index&&d.get_zindex()<e.get_zindex())e=d;b.pick_one(e);return!0},m.MoveToTop=function(){var a=this.get_zindex();a!==this.layer.instances.length-
1&&(cr.arrayRemove(this.layer.instances,a),this.layer.instances.push(this),this.runtime.redraw=!0,this.layer.zindices_stale=!0)},m.MoveToBottom=function(){var a=this.get_zindex();0!==a&&(cr.arrayRemove(this.layer.instances,a),this.layer.instances.unshift(this),this.runtime.redraw=!0,this.layer.zindices_stale=!0)},m.MoveToLayer=function(a){a&&a!=this.layer&&(cr.arrayRemove(this.layer.instances,this.get_zindex()),this.layer.zindices_stale=!0,this.layer=a,this.zindex=a.instances.length,a.instances.push(this),
this.runtime.redraw=!0)},m.ZMoveToObject=function(a,b){var c=0===a;if(b){var d=b.getFirstPicked(this);if(d&&d.uid!==this.uid){this.layer.index!==d.layer.index&&(cr.arrayRemove(this.layer.instances,this.get_zindex()),this.layer.zindices_stale=!0,this.layer=d.layer,this.zindex=d.layer.instances.length,d.layer.instances.push(this));var e=this.get_zindex(),d=d.get_zindex();cr.arrayRemove(this.layer.instances,e);e<d&&d--;c&&d++;d===this.layer.instances.length?this.layer.instances.push(this):this.layer.instances.splice(d,
0,this);this.layer.zindices_stale=!0;this.runtime.redraw=!0}}},c.LayerNumber=function(a){a.set_int(this.layer.number)},c.LayerName=function(a){a.set_string(this.layer.name)},c.ZIndex=function(a){a.set_int(this.get_zindex())});a&&(m.SetEffectEnabled=function(a,b){if(this.runtime.glwrap){var c=this.type.getEffectIndexByName(b);if(!(0>c)){var d=1===a;this.active_effect_flags[c]!==d&&(this.active_effect_flags[c]=d,this.updateActiveEffects(),this.runtime.redraw=!0)}}},m.SetEffectParam=function(a,b,c){if(this.runtime.glwrap){var d=
this.type.getEffectIndexByName(a);0>d||(a=this.type.effect_types[d],d=this.effect_params[d],b=Math.floor(b),0>b||b>=d.length||(1===this.runtime.glwrap.getProgramParameterType(a.shaderindex,b)&&(c/=100),d[b]!==c&&(d[b]=c,a.active&&(this.runtime.redraw=!0))))}})};cr.set_bbox_changed=function(){this.cell_changed=this.bbox_changed=!0;this.type.any_cell_changed=!0;this.runtime.redraw=!0;var a,c,d=this.bbox_changed_callbacks;a=0;for(c=d.length;a<c;++a)d[a](this)};cr.add_bbox_changed_callback=function(a){a&&
this.bbox_changed_callbacks.push(a)};cr.update_bbox=function(){if(this.bbox_changed){var a=this.bbox,c=this.bquad;a.set(this.x,this.y,this.x+this.width,this.y+this.height);a.offset(-this.hotspotX*this.width,-this.hotspotY*this.height);this.angle?(a.offset(-this.x,-this.y),c.set_from_rotated_rect(a,this.angle),c.offset(this.x,this.y),c.bounding_box(a)):c.set_from_rect(a);a.normalize();this.bbox_changed=!1}};var a=new cr.rect(0,0,0,0);cr.update_collision_cell=function(){if(this.cell_changed&&this.collisionsEnabled){this.update_bbox();
var b=this.type.collision_grid,c=this.collcells,d=this.bbox;a.set(b.XToCell(d.left),b.YToCell(d.top),b.XToCell(d.right),b.YToCell(d.bottom));c.equals(a)||(c.right<c.left?b.update(this,null,a):b.update(this,c,a),c.copy(a),this.cell_changed=!1)}};cr.inst_contains_pt=function(a,c){return this.bbox.contains_pt(a,c)&&this.bquad.contains_pt(a,c)?this.collision_poly&&!this.collision_poly.is_empty()?(this.collision_poly.cache_poly(this.width,this.height,this.angle),this.collision_poly.contains_pt(a-this.x,
c-this.y)):!0:!1};cr.inst_get_iid=function(){this.type.updateIIDs();return this.iid};cr.inst_get_zindex=function(){this.layer.updateZIndices();return this.zindex};cr.inst_updateActiveEffects=function(){this.active_effect_types.length=0;var a,c;a=0;for(c=this.active_effect_flags.length;a<c;a++)this.active_effect_flags[a]&&this.active_effect_types.push(this.type.effect_types[a]);this.uses_shaders=!!this.active_effect_types.length};cr.inst_toString=function(){return"Inst"+this.puid};cr.type_getFirstPicked=
function(a){if(a&&a.is_contained&&a.type!=this){var c,d,e;c=0;for(d=a.siblings.length;c<d;c++)if(e=a.siblings[c],e.type==this)return e}a=this.getCurrentSol().getObjects();return a.length?a[0]:null};cr.type_getPairedInstance=function(a){var c=this.getCurrentSol().getObjects();return c.length?c[a.get_iid()%c.length]:null};cr.type_updateIIDs=function(){if(this.stale_iids&&!this.is_family){var a,c;a=0;for(c=this.instances.length;a<c;a++)this.instances[a].iid=a;var d=a,e=this.runtime.createRow;a=0;for(c=
e.length;a<c;++a)e[a].type===this&&(e[a].iid=d++);this.stale_iids=!1}};cr.type_getInstanceByIID=function(a){if(a<this.instances.length)return this.instances[a];a-=this.instances.length;var c=this.runtime.createRow,d,e;d=0;for(e=c.length;d<e;++d)if(c[d].type===this){if(0===a)return c[d];--a}return null};cr.type_getCurrentSol=function(){return this.solstack[this.cur_sol]};cr.type_pushCleanSol=function(){this.cur_sol++;this.cur_sol===this.solstack.length?this.solstack.push(new cr.selection(this)):this.solstack[this.cur_sol].select_all=
!0};cr.type_pushCopySol=function(){this.cur_sol++;this.cur_sol===this.solstack.length&&this.solstack.push(new cr.selection(this));var a=this.solstack[this.cur_sol],c=this.solstack[this.cur_sol-1];c.select_all?a.select_all=!0:(a.select_all=!1,cr.shallowAssignArray(a.instances,c.instances),cr.shallowAssignArray(a.else_instances,c.else_instances))};cr.type_popSol=function(){this.cur_sol--};cr.type_getBehaviorByName=function(a){var c,d,e,h,f,l=0;if(!this.is_family)for(c=0,d=this.families.length;c<d;c++)for(f=
this.families[c],e=0,h=f.behaviors.length;e<h;e++){if(a===f.behaviors[e].name)return this.extra.lastBehIndex=l,f.behaviors[e];l++}c=0;for(d=this.behaviors.length;c<d;c++){if(a===this.behaviors[c].name)return this.extra.lastBehIndex=l,this.behaviors[c];l++}return null};cr.type_getBehaviorIndexByName=function(a){return this.getBehaviorByName(a)?this.extra.lastBehIndex:-1};cr.type_getEffectIndexByName=function(a){var c,d;c=0;for(d=this.effect_types.length;c<d;c++)if(this.effect_types[c].name===a)return c;
return-1};cr.type_applySolToContainer=function(){if(this.is_contained&&!this.is_family){var a,c,d,e,h,f,l;this.updateIIDs();f=this.getCurrentSol();var k=f.select_all,g=(a=this.runtime.getCurrentEventStack())&&a.current_event&&a.current_event.orblock;a=0;for(c=this.container.length;a<c;a++)if(h=this.container[a],h!==this&&(h.updateIIDs(),l=h.getCurrentSol(),l.select_all=k,!k)){l.instances.length=f.instances.length;d=0;for(e=f.instances.length;d<e;d++)l.instances[d]=h.getInstanceByIID(f.instances[d].iid);
if(g)for(l.else_instances.length=f.else_instances.length,d=0,e=f.else_instances.length;d<e;d++)l.else_instances[d]=h.getInstanceByIID(f.else_instances[d].iid)}}};cr.type_toString=function(){return"Type"+this.sid};cr.do_cmp=function(a,c,d){if("undefined"===typeof a||"undefined"===typeof d)return!1;switch(c){case 0:return a===d;case 1:return a!==d;case 2:return a<d;case 3:return a<=d;case 4:return a>d;case 5:return a>=d;default:return!1}}})();cr.shaders={};
cr.shaders.crystalball={src:"#ifdef GL_FRAGMENT_PRECISION_HIGH\n#define highmedp highp\n#else\n#define highmedp mediump\n#endif\nvarying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump float pixelWidth;\nuniform mediump float pixelHeight;\nconst highmedp vec3 lightPosition = vec3(-0.5, 0.5, 1.0);\nconst highmedp vec3 ambientLightPosition = vec3(0.0, 0.0, 1.0);\nuniform highmedp float radius;\nuniform highmedp float refractiveIndex;\nvoid main(void)\n{\nhighmedp vec2 center = vec2(0.5, 0.5);\nhighmedp float aspectRatio = pixelWidth/pixelHeight;\nhighmedp vec2 otherTex = vec2(vTex.x, (vTex.y * aspectRatio + 0.5 - 0.5 * aspectRatio));\nhighmedp float distanceFromCenter = distance(center, otherTex);\nlowp float checkForPresenceWithinSphere = step(distanceFromCenter, radius);\ndistanceFromCenter = distanceFromCenter / radius;\nhighmedp float normalizedDepth = radius * sqrt(1.0 - distanceFromCenter * distanceFromCenter);\nhighmedp vec3 sphereNormal = normalize(vec3(otherTex - center, normalizedDepth));\nhighmedp vec3 refractedVector = 2.0 * refract(vec3(0.0, 0.0, -1.0), sphereNormal, refractiveIndex);\nrefractedVector.xy = -refractedVector.xy;\nhighmedp vec4 front = texture2D(samplerFront, (refractedVector.xy + 1.0) * 0.5);\nhighmedp vec3 finalSphereColor = front.rgb;\nhighmedp float lightingIntensity = 2.5 * (1.0 - pow(clamp(dot(ambientLightPosition, sphereNormal), 0.0, 1.0), 0.25));\nfinalSphereColor += lightingIntensity;\nlightingIntensity  = clamp(dot(normalize(lightPosition), sphereNormal), 0.0, 1.0);\nlightingIntensity  = pow(lightingIntensity, 15.0);\nfinalSphereColor += vec3(0.8, 0.8, 0.8) * lightingIntensity;\ngl_FragColor = vec4(finalSphereColor, front.a) * checkForPresenceWithinSphere;\n}",extendBoxHorizontal:0,
extendBoxVertical:0,crossSampling:!1,animated:!1,parameters:[["radius",0,1],["refractiveIndex",0,1]]};
cr.shaders.warpripple={src:"varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nuniform mediump float seconds;\nuniform mediump float pixelWidth;\nuniform mediump float layerScale;\nuniform mediump float freq;\nuniform mediump float amp;\nuniform mediump float speed;\nconst mediump float PI = 3.1415926;\nvoid main(void)\n{\nmediump vec2 p = vTex;\nmediump vec2 tex = vTex * 2.0 - 1.0;\nmediump float d = length(tex);\nmediump float a = atan(tex.y, tex.x);\nd += sin((d * 2.0 * PI) * freq / layerScale / (pixelWidth * 750.0) + (seconds * speed)) * amp * (pixelWidth * 750.0) * layerScale;\ntex.x = cos(a) * d;\ntex.y = sin(a) * d;\ntex = (tex + 1.0) / 2.0;\ngl_FragColor = texture2D(samplerFront, tex);\n}",extendBoxHorizontal:50,
extendBoxVertical:50,crossSampling:!1,animated:!0,parameters:[["freq",0,0],["amp",0,1],["speed",0,0]]};
cr.shaders.water={src:"varying mediump vec2 vTex;\nuniform lowp sampler2D samplerFront;\nprecision mediump float;\nuniform float seconds;\nuniform float pixelWidth;\nuniform float pixelHeight;\nconst float PI = 3.1415926535897932;\nuniform float speed;\nuniform float speed_x;\nuniform float speed_y;\nuniform float intensity;\nconst int steps = 8;\nuniform float frequency;\nuniform float angle; // better when a prime\nuniform float delta;\nuniform float intence;\nuniform float emboss;\nfloat col(vec2 coord)\n{\nfloat delta_theta = 2.0 * PI / angle;\nfloat col = 0.0;\nfloat theta = 0.0;\nfor (int i = 0; i < steps; i++)\n{\nvec2 adjc = coord;\ntheta = delta_theta*float(i);\nadjc.x += cos(theta)*seconds*speed + seconds * speed_x;\nadjc.y -= sin(theta)*seconds*speed - seconds * speed_y;\ncol = col + cos( (adjc.x*cos(theta) - adjc.y*sin(theta))*frequency)*intensity;\n}\nreturn cos(col);\n}\nvoid main(void)\n{\nvec2 p = vTex, c1 = p, c2 = p;\nfloat cc1 = col(c1);\nc2.x += (1.0 / pixelWidth) / delta;\nfloat dx = emboss*(cc1-col(c2))/delta;\nc2.x = p.x;\nc2.y += (1.0 / pixelHeight) / delta;\nfloat dy = emboss*(cc1-col(c2))/delta;\nc1.x += dx;\nc1.y = -(c1.y+dy);\nfloat alpha = 1.+dot(dx,dy)*intence;\nc1.y = -c1.y;\ngl_FragColor = texture2D(samplerFront,c1)*(alpha);\n}",extendBoxHorizontal:25,
extendBoxVertical:25,crossSampling:!1,animated:!0,parameters:[["speed",0,1],["speed_x",0,1],["speed_y",0,1],["intensity",0,0],["frequency",0,0],["angle",0,0],["delta",0,0],["intence",0,0],["emboss",0,1]]};window.cr_cjs_accelerated_physics=!0;cr.plugins_.Audio=function(a){this.runtime=a};
(function(){function a(a){a=Math.pow(10,a/20);0>a&&(a=0);1<a&&(a=1);return a}function b(a){0>a&&(a=0);1<a&&(a=1);return Math.log(a)/Math.log(10)*20}function c(a){a=a.toLowerCase();return P.hasOwnProperty(a)&&P[a].length?P[a][0].getInputNode():F.destination}function d(){return F.createGain?F.createGain():F.createGainNode()}function e(a){return F.createDelay?F.createDelay(a):F.createDelayNode(a)}function h(a){a.start?a.start(0):a.noteOn(0)}function f(a,b,c){a.start?a.start(0,b):a.noteGrainOn(0,b,c-
b)}function l(a){try{a.stop?a.stop(0):a.noteOff(0)}catch(b){}}function k(a,b,c,d){if(a)if(a.cancelScheduledValues(0),0===d)a.value=b;else{var e=F.currentTime;d+=e;switch(c){case 0:a.setValueAtTime(b,d);break;case 1:a.setValueAtTime(a.value,e);a.linearRampToValueAtTime(b,d);break;case 2:a.setValueAtTime(a.value,e),a.exponentialRampToValueAtTime(b,d)}}}function g(a,b,c,e,g,f){this.type="filter";this.params=[a,b,c,e,g,f];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=f;this.dryNode=d();
this.dryNode.gain.value=1-f;this.filterNode=F.createBiquadFilter();this.filterNode.type="number"===typeof this.filterNode.type?a:la[a];this.filterNode.frequency.value=b;this.filterNode.detune&&(this.filterNode.detune.value=c);this.filterNode.Q.value=e;this.filterNode.gain.value=g;this.inputNode.connect(this.filterNode);this.inputNode.connect(this.dryNode);this.filterNode.connect(this.wetNode)}function m(a,b,c){this.type="delay";this.params=[a,b,c];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=
c;this.dryNode=d();this.dryNode.gain.value=1-c;this.mainNode=d();this.delayNode=e(a);this.delayNode.delayTime.value=a;this.delayGainNode=d();this.delayGainNode.gain.value=b;this.inputNode.connect(this.mainNode);this.inputNode.connect(this.dryNode);this.mainNode.connect(this.wetNode);this.mainNode.connect(this.delayNode);this.delayNode.connect(this.delayGainNode);this.delayGainNode.connect(this.mainNode)}function n(a,b,c,e){this.type="convolve";this.params=[b,c,e];this.inputNode=d();this.wetNode=d();
this.wetNode.gain.value=c;this.dryNode=d();this.dryNode.gain.value=1-c;this.convolveNode=F.createConvolver();a&&(this.convolveNode.normalize=b,this.convolveNode.buffer=a);this.inputNode.connect(this.convolveNode);this.inputNode.connect(this.dryNode);this.convolveNode.connect(this.wetNode)}function p(a,b,c,g,f){this.type="flanger";this.params=[a,b,c,g,f];this.inputNode=d();this.dryNode=d();this.dryNode.gain.value=1-f/2;this.wetNode=d();this.wetNode.gain.value=f/2;this.feedbackNode=d();this.feedbackNode.gain.value=
g;this.delayNode=e(a+b);this.delayNode.delayTime.value=a;this.oscNode=F.createOscillator();this.oscNode.frequency.value=c;this.oscGainNode=d();this.oscGainNode.gain.value=b;this.inputNode.connect(this.delayNode);this.inputNode.connect(this.dryNode);this.delayNode.connect(this.wetNode);this.delayNode.connect(this.feedbackNode);this.feedbackNode.connect(this.delayNode);this.oscNode.connect(this.oscGainNode);this.oscGainNode.connect(this.delayNode.delayTime);h(this.oscNode)}function r(a,b,c,e,g,f){this.type=
"phaser";this.params=[a,b,c,e,g,f];this.inputNode=d();this.dryNode=d();this.dryNode.gain.value=1-f/2;this.wetNode=d();this.wetNode.gain.value=f/2;this.filterNode=F.createBiquadFilter();this.filterNode.type="number"===typeof this.filterNode.type?7:"allpass";this.filterNode.frequency.value=a;this.filterNode.detune&&(this.filterNode.detune.value=b);this.filterNode.Q.value=c;this.oscNode=F.createOscillator();this.oscNode.frequency.value=g;this.oscGainNode=d();this.oscGainNode.gain.value=e;this.inputNode.connect(this.filterNode);
this.inputNode.connect(this.dryNode);this.filterNode.connect(this.wetNode);this.oscNode.connect(this.oscGainNode);this.oscGainNode.connect(this.filterNode.frequency);h(this.oscNode)}function s(a){this.type="gain";this.params=[a];this.node=d();this.node.gain.value=a}function q(a,b){this.type="tremolo";this.params=[a,b];this.node=d();this.node.gain.value=1-b/2;this.oscNode=F.createOscillator();this.oscNode.frequency.value=a;this.oscGainNode=d();this.oscGainNode.gain.value=b/2;this.oscNode.connect(this.oscGainNode);
this.oscGainNode.connect(this.node.gain);h(this.oscNode)}function t(a,b){this.type="ringmod";this.params=[a,b];this.inputNode=d();this.wetNode=d();this.wetNode.gain.value=b;this.dryNode=d();this.dryNode.gain.value=1-b;this.ringNode=d();this.ringNode.gain.value=0;this.oscNode=F.createOscillator();this.oscNode.frequency.value=a;this.oscNode.connect(this.ringNode.gain);h(this.oscNode);this.inputNode.connect(this.ringNode);this.inputNode.connect(this.dryNode);this.ringNode.connect(this.wetNode)}function u(a,
b,c,e,g){this.type="distortion";this.params=[a,b,c,e,g];this.inputNode=d();this.preGain=d();this.postGain=d();this.setDrive(c,Math.pow(10,e/20));this.wetNode=d();this.wetNode.gain.value=g;this.dryNode=d();this.dryNode.gain.value=1-g;this.waveShaper=F.createWaveShaper();this.curve=new Float32Array(65536);this.generateColortouchCurve(a,b);this.waveShaper.curve=this.curve;this.inputNode.connect(this.preGain);this.inputNode.connect(this.dryNode);this.preGain.connect(this.waveShaper);this.waveShaper.connect(this.postGain);
this.postGain.connect(this.wetNode)}function C(a,b,c,d,e){this.type="compressor";this.params=[a,b,c,d,e];this.node=F.createDynamicsCompressor();try{this.node.threshold.value=a,this.node.knee.value=b,this.node.ratio.value=c,this.node.attack.value=d,this.node.release.value=e}catch(g){}}function J(a,b){this.type="analyser";this.params=[a,b];this.node=F.createAnalyser();this.node.fftSize=a;this.node.smoothingTimeConstant=b;this.freqBins=new Float32Array(this.node.frequencyBinCount);this.signal=new Uint8Array(a);
this.rms=this.peak=0}function G(){this.obj=null;this.loadUid=0;this.speeds=[];this.moveAngle=this.lastY=this.lastX=0}function A(a,b){this.src=a;this.myapi=M;this.is_music=b;this.added_end_listener=!1;var c=this;this.mediaSourceNode=this.outNode=null;this.panWhenReady=[];this.seekWhenReady=0;this.supportWebAudioAPI=this.pauseWhenReady=!1;M===B&&b&&(this.myapi=L,this.outNode=d());this.audioData=this.bufferObject=null;var e;switch(this.myapi){case L:this.bufferObject=new Audio;M!==B||!F.createMediaElementSource||
E.isFirefox||/wiiu/i.test(navigator.userAgent)||(this.supportWebAudioAPI=!0,this.bufferObject.addEventListener("canplay",function(){c.mediaSourceNode||(c.mediaSourceNode=F.createMediaElementSource(c.bufferObject),c.mediaSourceNode.connect(c.outNode))}));this.bufferObject.autoplay=!1;this.bufferObject.preload="auto";this.bufferObject.src=a;break;case B:e=new XMLHttpRequest;e.open("GET",a,!0);e.responseType="arraybuffer";e.onload=function(){c.audioData=e.response;c.decodeAudioBuffer()};e.send();break;
case N:this.bufferObject=!0;break;case V:this.bufferObject=!0}}function v(a,b){var e=this;this.tag=b;this.stopped=this.fresh=!0;this.src=a.src;this.buffer=a;this.myapi=M;this.is_music=a.is_music;this.playbackRate=1;this.pgended=!0;this.is_paused=this.resume_me=!1;this.resume_position=0;this.is_silent=this.is_muted=this.looping=!1;this.mutevol=this.volume=1;this.startTime=E.kahanTime.sum;this.pannerNode=this.gainNode=null;this.pannerEnabled=!1;this.objectTracker=null;this.panConeOuterGain=this.panConeOuter=
this.panConeInner=this.panAngle=this.panY=this.panX=0;this.instanceObject=null;var g=!1;this.myapi!==B||this.buffer.myapi!==L||this.buffer.supportWebAudioAPI||(this.myapi=L);switch(this.myapi){case L:this.is_music?(this.instanceObject=a.bufferObject,g=!a.added_end_listener,a.added_end_listener=!0):(this.instanceObject=new Audio,this.instanceObject.autoplay=!1,this.instanceObject.src=a.bufferObject.src,g=!0);g&&this.instanceObject.addEventListener("ended",function(){K=e.tag;e.stopped=!0;E.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,
T)});break;case B:this.gainNode=d();this.gainNode.connect(c(b));this.buffer.myapi===B?a.bufferObject&&(this.instanceObject=F.createBufferSource(),this.instanceObject.buffer=a.bufferObject,this.instanceObject.connect(this.gainNode)):(this.instanceObject=this.buffer.bufferObject,this.buffer.outNode.connect(this.gainNode));break;case N:this.instanceObject=new window.Media(R+this.src,null,null,function(a){a===window.Media.MEDIA_STOPPED&&(e.pgended=!0,e.stopped=!0,K=e.tag,E.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,
T))});break;case V:this.instanceObject=!0}}function w(a){Q.length=0;if(a.length){var b,c,d;b=0;for(c=O.length;b<c;b++)d=O[b],cr.equals_nocase(a,d.tag)&&Q.push(d)}else U&&!U.hasEnded()&&(Q.length=1,Q[0]=U)}function x(a){var b,c,d,e,g=F.destination;if(P.hasOwnProperty(a)&&(d=P[a],d.length))for(g=d[0].getInputNode(),b=0,c=d.length;b<c;b++)e=d[b],b+1===c?e.connectTo(F.destination):e.connectTo(d[b+1].getInputNode());w(a);b=0;for(c=Q.length;b<c;b++)Q[b].reconnect(g);ca&&ia===a&&(ca.disconnect(),ca.connect(g))}
function y(a,b){P.hasOwnProperty(a)?P[a].push(b):P[a]=[b];x(a)}function D(){}function z(){}function H(){}function I(a,b){var c=null;P.hasOwnProperty(a)&&(c=P[a]);return c&&0<=b&&b<c.length&&c[b].freqBins?c[b]:null}var S=cr.plugins_.Audio.prototype;S.Type=function(a){this.plugin=a;this.runtime=a.runtime};S.Type.prototype.onCreate=function(){};var E=null,T=null,K="",R="",L=0,B=1,N=2,V=3,M=L,F=null,da=[],O=[],U=null,X=!1,ha=0,W=!1,Y=1,Z=0,aa=0,ja=1,ka=1,ma=10,na=1E4,oa=1,ca=null,ia="",ea=!1,fa=[],P=
{},la="lowpass highpass bandpass lowshelf highshelf peaking notch allpass".split(" ");g.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};g.prototype.remove=function(){this.inputNode.disconnect();this.filterNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};g.prototype.getInputNode=function(){return this.inputNode};g.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=
1);this.params[5]=b;k(this.wetNode.gain,b,c,d);k(this.dryNode.gain,1-b,c,d);break;case 1:this.params[1]=b;k(this.filterNode.frequency,b,c,d);break;case 2:this.params[2]=b;k(this.filterNode.detune,b,c,d);break;case 3:this.params[3]=b;k(this.filterNode.Q,b,c,d);break;case 4:this.params[4]=b,k(this.filterNode.gain,b,c,d)}};m.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};m.prototype.remove=function(){this.inputNode.disconnect();
this.mainNode.disconnect();this.delayNode.disconnect();this.delayGainNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};m.prototype.getInputNode=function(){return this.inputNode};m.prototype.setParam=function(b,c,d,e){switch(b){case 0:c/=100;0>c&&(c=0);1<c&&(c=1);this.params[2]=c;k(this.wetNode.gain,c,d,e);k(this.dryNode.gain,1-c,d,e);break;case 4:this.params[1]=a(c);k(this.delayGainNode.gain,a(c),d,e);break;case 5:this.params[0]=c,k(this.delayNode.delayTime,c,d,e)}};n.prototype.connectTo=
function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};n.prototype.remove=function(){this.inputNode.disconnect();this.convolveNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};n.prototype.getInputNode=function(){return this.inputNode};n.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100,0>b&&(b=0),1<b&&(b=1),this.params[1]=b,k(this.wetNode.gain,b,c,d),k(this.dryNode.gain,1-b,c,d)}};p.prototype.connectTo=function(a){this.dryNode.disconnect();
this.dryNode.connect(a);this.wetNode.disconnect();this.wetNode.connect(a)};p.prototype.remove=function(){this.inputNode.disconnect();this.delayNode.disconnect();this.oscNode.disconnect();this.oscGainNode.disconnect();this.dryNode.disconnect();this.wetNode.disconnect();this.feedbackNode.disconnect()};p.prototype.getInputNode=function(){return this.inputNode};p.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[4]=b;k(this.wetNode.gain,b/2,c,d);k(this.dryNode.gain,
1-b/2,c,d);break;case 6:this.params[1]=b/1E3;k(this.oscGainNode.gain,b/1E3,c,d);break;case 7:this.params[2]=b;k(this.oscNode.frequency,b,c,d);break;case 8:this.params[3]=b/100,k(this.feedbackNode.gain,b/100,c,d)}};r.prototype.connectTo=function(a){this.dryNode.disconnect();this.dryNode.connect(a);this.wetNode.disconnect();this.wetNode.connect(a)};r.prototype.remove=function(){this.inputNode.disconnect();this.filterNode.disconnect();this.oscNode.disconnect();this.oscGainNode.disconnect();this.dryNode.disconnect();
this.wetNode.disconnect()};r.prototype.getInputNode=function(){return this.inputNode};r.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[5]=b;k(this.wetNode.gain,b/2,c,d);k(this.dryNode.gain,1-b/2,c,d);break;case 1:this.params[0]=b;k(this.filterNode.frequency,b,c,d);break;case 2:this.params[1]=b;k(this.filterNode.detune,b,c,d);break;case 3:this.params[2]=b;k(this.filterNode.Q,b,c,d);break;case 6:this.params[3]=b;k(this.oscGainNode.gain,b,c,d);break;case 7:this.params[4]=
b,k(this.oscNode.frequency,b,c,d)}};s.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};s.prototype.remove=function(){this.node.disconnect()};s.prototype.getInputNode=function(){return this.node};s.prototype.setParam=function(b,c,d,e){switch(b){case 4:this.params[0]=a(c),k(this.node.gain,a(c),d,e)}};q.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};q.prototype.remove=function(){this.oscNode.disconnect();this.oscGainNode.disconnect();this.node.disconnect()};
q.prototype.getInputNode=function(){return this.node};q.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[1]=b;k(this.node.gain.value,1-b/2,c,d);k(this.oscGainNode.gain.value,b/2,c,d);break;case 7:this.params[0]=b,k(this.oscNode.frequency,b,c,d)}};t.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};t.prototype.remove=function(){this.oscNode.disconnect();this.ringNode.disconnect();
this.inputNode.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};t.prototype.getInputNode=function(){return this.inputNode};t.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100;0>b&&(b=0);1<b&&(b=1);this.params[1]=b;k(this.wetNode.gain,b,c,d);k(this.dryNode.gain,1-b,c,d);break;case 7:this.params[0]=b,k(this.oscNode.frequency,b,c,d)}};u.prototype.setDrive=function(a,b){0.01>a&&(a=0.01);this.preGain.gain.value=a;this.postGain.gain.value=Math.pow(1/a,0.6)*b};u.prototype.shape=
function(a,b,c){var d=1.05*c*b-b;c=0>a?-1:1;a=0>a?-a:a;b=a<b?a:b+d*(1-Math.exp(-(1/d)*(a-b)));return b*c};u.prototype.generateColortouchCurve=function(a,b){for(var c=Math.pow(10,a/20),d=Math.pow(10,b/20),e=0,g=0;32768>g;++g)e=g/32768,e=this.shape(e,c,d),this.curve[32768+g]=e,this.curve[32768-g-1]=-e};u.prototype.connectTo=function(a){this.wetNode.disconnect();this.wetNode.connect(a);this.dryNode.disconnect();this.dryNode.connect(a)};u.prototype.remove=function(){this.inputNode.disconnect();this.preGain.disconnect();
this.waveShaper.disconnect();this.postGain.disconnect();this.wetNode.disconnect();this.dryNode.disconnect()};u.prototype.getInputNode=function(){return this.inputNode};u.prototype.setParam=function(a,b,c,d){switch(a){case 0:b/=100,0>b&&(b=0),1<b&&(b=1),this.params[4]=b,k(this.wetNode.gain,b,c,d),k(this.dryNode.gain,1-b,c,d)}};C.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};C.prototype.remove=function(){this.node.disconnect()};C.prototype.getInputNode=function(){return this.node};
C.prototype.setParam=function(a,b,c,d){};J.prototype.tick=function(){this.node.getFloatFrequencyData(this.freqBins);this.node.getByteTimeDomainData(this.signal);for(var a=this.node.fftSize,c=0,d=this.peak=0,e=0;c<a;c++)e=(this.signal[c]-128)/128,0>e&&(e=-e),this.peak<e&&(this.peak=e),d+=e*e;this.peak=b(this.peak);this.rms=b(Math.sqrt(d/a))};J.prototype.connectTo=function(a){this.node.disconnect();this.node.connect(a)};J.prototype.remove=function(){this.node.disconnect()};J.prototype.getInputNode=
function(){return this.node};J.prototype.setParam=function(a,b,c,d){};G.prototype.setObject=function(a){if(this.obj=a)this.lastX=this.obj.x,this.lastY=this.obj.y;this.speeds.length=0};G.prototype.hasObject=function(){return!!this.obj};G.prototype.tick=function(a){this.obj&&0!==a&&(this.moveAngle=cr.angleTo(this.lastX,this.lastY,this.obj.x,this.obj.y),a=cr.distanceTo(this.lastX,this.lastY,this.obj.x,this.obj.y)/a,4>this.speeds.length||this.speeds.shift(),this.speeds.push(a),this.lastX=this.obj.x,this.lastY=
this.obj.y)};G.prototype.getSpeed=function(){if(!this.speeds.length)return 0;var a,b,c=0;a=0;for(b=this.speeds.length;a<b;a++)c+=this.speeds[a];return c/this.speeds.length};G.prototype.getVelocityX=function(){return Math.cos(this.moveAngle)*this.getSpeed()};G.prototype.getVelocityY=function(){return Math.sin(this.moveAngle)*this.getSpeed()};var pa=!1;A.prototype.decodeAudioBuffer=function(){if(!this.bufferObject&&this.audioData){var a=this;if(F.decodeAudioData)F.decodeAudioData(this.audioData,function(b){a.bufferObject=
b;var c,d,e;if(cr.is_undefined(a.playTagWhenReady)||W)cr.is_undefined(a.convolveWhenReady)||(c=a.convolveWhenReady.convolveNode,c.normalize=a.normalizeWhenReady,c.buffer=b);else if(a.panWhenReady.length){c=0;for(d=a.panWhenReady.length;c<d;c++){b=a.panWhenReady[c];e=new v(a,b.thistag);e.setPannerEnabled(!0);if("undefined"!==typeof b.objUid&&(b.obj=E.getObjectByUID(b.objUid),!b.obj))continue;if(b.obj){var g=cr.rotatePtAround(b.obj.x,b.obj.y,-b.obj.layer.getAngle(),Z,aa,!0),f=cr.rotatePtAround(b.obj.x,
b.obj.y,-b.obj.layer.getAngle(),Z,aa,!1);e.setPan(g,f,cr.to_degrees(b.obj.angle-b.obj.layer.getAngle()),b.ia,b.oa,b.og);e.setObject(b.obj)}else e.setPan(b.x,b.y,b.a,b.ia,b.oa,b.og);e.play(a.loopWhenReady,a.volumeWhenReady,a.seekWhenReady);a.pauseWhenReady&&e.pause();O.push(e)}a.panWhenReady.length=0}else e=new v(a,a.playTagWhenReady),e.play(a.loopWhenReady,a.volumeWhenReady,a.seekWhenReady),a.pauseWhenReady&&e.pause(),O.push(e)});else if(this.bufferObject=F.createBuffer(this.audioData,!1),cr.is_undefined(this.playTagWhenReady)||
W)cr.is_undefined(this.convolveWhenReady)||(b=this.convolveWhenReady.convolveNode,b.normalize=this.normalizeWhenReady,b.buffer=this.bufferObject);else{var b=new v(this,this.playTagWhenReady);b.play(this.loopWhenReady,this.volumeWhenReady,this.seekWhenReady);this.pauseWhenReady&&b.pause();O.push(b)}}};A.prototype.isLoaded=function(){switch(this.myapi){case L:return 4===this.bufferObject.readyState;case B:return!!this.audioData;case N:return!0;case V:return!0}return!1};v.prototype.hasEnded=function(){switch(this.myapi){case L:return this.instanceObject.ended;
case B:return this.buffer.myapi===B?!this.fresh&&!this.stopped&&this.instanceObject.loop||this.is_paused?!1:E.kahanTime.sum-this.startTime>this.buffer.bufferObject.duration:this.instanceObject.ended;case N:return this.pgended;case V:!0}return!0};v.prototype.canBeRecycled=function(){return this.fresh||this.stopped?!0:this.hasEnded()};v.prototype.setPannerEnabled=function(a){M===B&&(!this.pannerEnabled&&a?this.gainNode&&(this.pannerNode||(this.pannerNode=F.createPanner(),this.pannerNode.panningModel=
"number"===typeof this.pannerNode.panningModel?ja:["equalpower","HRTF","soundfield"][ja],this.pannerNode.distanceModel="number"===typeof this.pannerNode.distanceModel?ka:["linear","inverse","exponential"][ka],this.pannerNode.refDistance=ma,this.pannerNode.maxDistance=na,this.pannerNode.rolloffFactor=oa),this.gainNode.disconnect(),this.gainNode.connect(this.pannerNode),this.pannerNode.connect(c(this.tag)),this.pannerEnabled=!0):this.pannerEnabled&&!a&&this.gainNode&&(this.pannerNode.disconnect(),this.gainNode.disconnect(),
this.gainNode.connect(c(this.tag)),this.pannerEnabled=!1))};v.prototype.setPan=function(a,b,c,d,e,g){this.pannerEnabled&&M===B&&(this.pannerNode.setPosition(a,b,0),this.pannerNode.setOrientation(Math.cos(cr.to_radians(c)),Math.sin(cr.to_radians(c)),0),this.pannerNode.coneInnerAngle=d,this.pannerNode.coneOuterAngle=e,this.pannerNode.coneOuterGain=g,this.panX=a,this.panY=b,this.panAngle=c,this.panConeInner=d,this.panConeOuter=e,this.panConeOuterGain=g)};v.prototype.setObject=function(a){this.pannerEnabled&&
M===B&&(this.objectTracker||(this.objectTracker=new G),this.objectTracker.setObject(a))};v.prototype.tick=function(a){if(this.pannerEnabled&&M===B&&this.objectTracker&&this.objectTracker.hasObject()&&this.isPlaying()){this.objectTracker.tick(a);a=this.objectTracker.obj;var b=cr.rotatePtAround(a.x,a.y,-a.layer.getAngle(),Z,aa,!0),c=cr.rotatePtAround(a.x,a.y,-a.layer.getAngle(),Z,aa,!1);this.pannerNode.setPosition(b,c,0);b=0;"undefined"!==typeof this.objectTracker.obj.angle&&(b=a.angle-a.layer.getAngle(),
this.pannerNode.setOrientation(Math.cos(b),Math.sin(b),0));b=cr.rotatePtAround(this.objectTracker.getVelocityX(),this.objectTracker.getVelocityY(),-a.layer.getAngle(),0,0,!0);c=cr.rotatePtAround(this.objectTracker.getVelocityX(),this.objectTracker.getVelocityY(),-a.layer.getAngle(),0,0,!1);this.pannerNode.setVelocity(b,c,0)}};v.prototype.play=function(a,b,c){var d=this.instanceObject;this.looping=a;this.volume=b;c=c||0;switch(this.myapi){case L:1!==d.playbackRate&&(d.playbackRate=1);d.volume!==b*
Y&&(d.volume=b*Y);d.loop!==a&&(d.loop=a);d.muted&&(d.muted=!1);if(d.currentTime!==c)try{d.currentTime=c}catch(e){}if(this.is_music&&ea&&!E.isInUserInputEvent)fa.push(this);else try{this.instanceObject.play()}catch(g){}break;case B:this.muted=!1;this.mutevol=1;if(this.buffer.myapi===B)this.fresh||(this.instanceObject=F.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode)),this.instanceObject.loop=a,this.gainNode.gain.value=b*Y,0===c?h(this.instanceObject):
f(this.instanceObject,c,this.getDuration());else{1!==d.playbackRate&&(d.playbackRate=1);d.loop!==a&&(d.loop=a);this.gainNode.gain.value=b*Y;if(d.currentTime!==c)try{d.currentTime=c}catch(k){}this.is_music&&ea&&!E.isInUserInputEvent?fa.push(this):d.play()}break;case N:(!this.fresh&&this.stopped||0!==c)&&d.seekTo(c);d.play();this.pgended=!1;break;case V:E.isDirectCanvas?AppMobi.context.playSound(this.src,a):AppMobi.player.playSound(this.src,a)}this.playbackRate=1;this.startTime=E.kahanTime.sum-c;this.is_paused=
this.stopped=this.fresh=!1};v.prototype.stop=function(){switch(this.myapi){case L:this.instanceObject.paused||this.instanceObject.pause();break;case B:this.buffer.myapi===B?l(this.instanceObject):this.instanceObject.paused||this.instanceObject.pause();break;case N:this.instanceObject.stop();break;case V:E.isDirectCanvas&&AppMobi.context.stopSound(this.src)}this.stopped=!0;this.is_paused=!1};v.prototype.pause=function(){if(!(this.fresh||this.stopped||this.hasEnded()||this.is_paused)){switch(this.myapi){case L:this.instanceObject.paused||
this.instanceObject.pause();break;case B:this.buffer.myapi===B?(this.resume_position=this.getPlaybackTime(),this.looping&&(this.resume_position%=this.getDuration()),l(this.instanceObject)):this.instanceObject.paused||this.instanceObject.pause();break;case N:this.instanceObject.pause();break;case V:E.isDirectCanvas&&AppMobi.context.stopSound(this.src)}this.is_paused=!0}};v.prototype.resume=function(){if(!this.fresh&&!this.stopped&&!this.hasEnded()&&this.is_paused){switch(this.myapi){case L:this.instanceObject.play();
break;case B:this.buffer.myapi===B?(this.instanceObject=F.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode),this.instanceObject.loop=this.looping,this.gainNode.gain.value=Y*this.volume*this.mutevol,this.startTime=E.kahanTime.sum-this.resume_position,f(this.instanceObject,this.resume_position,this.getDuration())):this.instanceObject.play();break;case N:this.instanceObject.play();break;case V:E.isDirectCanvas&&AppMobi.context.resumeSound(this.src)}this.is_paused=
!1}};v.prototype.seek=function(a){if(!(this.fresh||this.stopped||this.hasEnded()))switch(this.myapi){case L:try{this.instanceObject.currentTime=a}catch(b){}break;case B:if(this.buffer.myapi===B)this.is_paused?this.resume_position=a:(this.pause(),this.resume_position=a,this.resume());else try{this.instanceObject.currentTime=a}catch(c){}break;case V:E.isDirectCanvas&&AppMobi.context.seekSound(this.src,a)}};v.prototype.reconnect=function(a){this.myapi===B&&(this.pannerEnabled?(this.pannerNode.disconnect(),
this.pannerNode.connect(a)):(this.gainNode.disconnect(),this.gainNode.connect(a)))};v.prototype.getDuration=function(){switch(this.myapi){case L:if("undefined"!==typeof this.instanceObject.duration)return this.instanceObject.duration;break;case B:return this.buffer.bufferObject.duration;case N:return this.instanceObject.getDuration();case V:if(E.isDirectCanvas)return AppMobi.context.getDurationSound(this.src)}return 0};v.prototype.getPlaybackTime=function(){var a=this.getDuration(),b=0;switch(this.myapi){case L:"undefined"!==
typeof this.instanceObject.currentTime&&(b=this.instanceObject.currentTime);break;case B:if(this.buffer.myapi===B){if(this.is_paused)return this.resume_position;b=E.kahanTime.sum-this.startTime}else"undefined"!==typeof this.instanceObject.currentTime&&(b=this.instanceObject.currentTime);break;case V:E.isDirectCanvas&&(b=AppMobi.context.getPlaybackTimeSound(this.src))}!this.looping&&b>a&&(b=a);return b};v.prototype.isPlaying=function(){return!this.is_paused&&!this.fresh&&!this.stopped&&!this.hasEnded()};
v.prototype.setVolume=function(a){this.volume=a;this.updateVolume()};v.prototype.updateVolume=function(){var a=this.volume*Y;switch(this.myapi){case L:this.instanceObject.volume&&this.instanceObject.volume!==a&&(this.instanceObject.volume=a);break;case B:this.gainNode.gain.value=a*this.mutevol}};v.prototype.getVolume=function(){return this.volume};v.prototype.doSetMuted=function(a){switch(this.myapi){case L:this.instanceObject.muted!==!!a&&(this.instanceObject.muted=!!a);break;case B:this.mutevol=
a?0:1,this.gainNode.gain.value=Y*this.volume*this.mutevol}};v.prototype.setMuted=function(a){this.is_muted=!!a;this.doSetMuted(this.is_muted||this.is_silent)};v.prototype.setSilent=function(a){this.is_silent=!!a;this.doSetMuted(this.is_muted||this.is_silent)};v.prototype.setLooping=function(a){this.looping=a;switch(this.myapi){case L:this.instanceObject.loop!==!!a&&(this.instanceObject.loop=!!a);break;case B:this.instanceObject.loop!==!!a&&(this.instanceObject.loop=!!a);break;case V:E.isDirectCanvas&&
AppMobi.context.setLoopingSound(this.src,a)}};v.prototype.setPlaybackRate=function(a){this.playbackRate=a;this.updatePlaybackRate()};v.prototype.updatePlaybackRate=function(){var a=this.playbackRate;if(1===ha&&!this.is_music||2===ha)a*=E.timescale;switch(this.myapi){case L:this.instanceObject.playbackRate!==a&&(this.instanceObject.playbackRate=a);break;case B:this.buffer.myapi===B?this.instanceObject.playbackRate.value!==a&&(this.instanceObject.playbackRate.value=a):this.instanceObject.playbackRate!==
a&&(this.instanceObject.playbackRate=a)}};v.prototype.setSuspended=function(a){switch(this.myapi){case L:a?this.isPlaying()?(this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&this.instanceObject.play();break;case B:a?this.isPlaying()?(this.buffer.myapi===B?(this.resume_position=this.getPlaybackTime(),this.looping&&(this.resume_position%=this.getDuration()),l(this.instanceObject)):this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&(this.buffer.myapi===
B?(this.instanceObject=F.createBufferSource(),this.instanceObject.buffer=this.buffer.bufferObject,this.instanceObject.connect(this.gainNode),this.instanceObject.loop=this.looping,this.gainNode.gain.value=Y*this.volume*this.mutevol,this.startTime=E.kahanTime.sum-this.resume_position,f(this.instanceObject,this.resume_position,this.getDuration())):this.instanceObject.play());break;case N:a?this.isPlaying()?(this.instanceObject.pause(),this.resume_me=!0):this.resume_me=!1:this.resume_me&&this.instanceObject.play()}};
S.Instance=function(a){this.type=a;E=this.runtime=a.runtime;T=this;this.listenerTracker=null;this.listenerZ=-600;!(this.runtime.isiOS||this.runtime.isAndroid&&(this.runtime.isChrome||this.runtime.isAndroidStockBrowser))||this.runtime.isCrosswalk||this.runtime.isDomFree||(ea=!0);F=null;"undefined"!==typeof AudioContext?(M=B,F=new AudioContext):"undefined"!==typeof webkitAudioContext&&(M=B,F=new webkitAudioContext);(this.runtime.isiOS&&M===B||ea)&&document.addEventListener("touchstart",function(){var a,
b,c;!pa&&F&&(a=F.createBuffer(1,1,22050),b=F.createBufferSource(),b.buffer=a,b.connect(F.destination),h(b),pa=!0);if(ea){if(!W)for(a=0,b=fa.length;a<b;++a)c=fa[a],c.stopped||c.is_paused||c.instanceObject.play();fa.length=0}},!0);M!==B&&(this.runtime.isPhoneGap?M=N:this.runtime.isAppMobi&&(M=V));M===N&&(R=location.href,a=R.lastIndexOf("/"),-1<a&&(R=R.substr(0,a+1)),R=R.replace("file://",""));if(this.runtime.isSafari&&this.runtime.isWindows&&"undefined"===typeof Audio)alert("It looks like you're using Safari for Windows without Quicktime.  Audio cannot be played until Quicktime is installed."),
this.runtime.DestroyInstance(this);else{if(this.runtime.isDirectCanvas)X=this.runtime.isAndroid;else try{X=!!(new Audio).canPlayType('audio/ogg; codecs="vorbis"')}catch(b){X=!1}this.runtime.tickMe(this)}};var ba=S.Instance.prototype;ba.onCreate=function(){ha=this.properties[0];this.saveload=this.properties[1];ja=this.properties[2];ka=this.properties[3];this.listenerZ=-this.properties[4];ma=this.properties[5];na=this.properties[6];oa=this.properties[7];this.listenerTracker=new G;M===B&&(F.listener.speedOfSound=
this.properties[8],F.listener.dopplerFactor=this.properties[9],F.listener.setPosition(this.runtime.draw_width/2,this.runtime.draw_height/2,this.listenerZ),F.listener.setOrientation(0,0,1,0,-1,0),window.c2OnAudioMicStream=function(a,b){ca&&ca.disconnect();ia=b.toLowerCase();ca=F.createMediaStreamSource(a);ca.connect(c(ia))});this.runtime.addSuspendCallback(function(a){T.onSuspend(a)});var a=this;this.runtime.addDestroyCallback(function(b){a.onInstanceDestroyed(b)})};ba.onInstanceDestroyed=function(a){var b,
c,d;b=0;for(c=O.length;b<c;b++)d=O[b],d.objectTracker&&d.objectTracker.obj===a&&(d.objectTracker.obj=null,d.pannerEnabled&&d.isPlaying()&&d.looping&&d.stop());this.listenerTracker.obj===a&&(this.listenerTracker.obj=null)};ba.saveToJSON=function(){var a={silent:W,masterVolume:Y,listenerZ:this.listenerZ,listenerUid:this.listenerTracker.hasObject()?this.listenerTracker.obj.uid:-1,playing:[],effects:{}},b=a.playing,c,d,e,g,f,k;c=0;for(d=O.length;c<d;c++)e=O[c],!e.isPlaying()||3===this.saveload||e.is_music&&
1===this.saveload||!e.is_music&&2===this.saveload||(g=e.getPlaybackTime(),e.looping&&(g%=e.getDuration()),g={tag:e.tag,buffersrc:e.buffer.src,is_music:e.is_music,playbackTime:g,volume:e.volume,looping:e.looping,muted:e.is_muted,playbackRate:e.playbackRate,paused:e.is_paused,resume_position:e.resume_position},e.pannerEnabled&&(g.pan={},k=g.pan,e.objectTracker&&e.objectTracker.hasObject()?k.objUid=e.objectTracker.obj.uid:(k.x=e.panX,k.y=e.panY,k.a=e.panAngle),k.ia=e.panConeInner,k.oa=e.panConeOuter,
k.og=e.panConeOuterGain),b.push(g));b=a.effects;for(f in P)if(P.hasOwnProperty(f)){e=[];c=0;for(d=P[f].length;c<d;c++)e.push({type:P[f][c].type,params:P[f][c].params});b[f]=e}return a};var ga=[];ba.loadFromJSON=function(a){var b=a.silent;Y=a.masterVolume;this.listenerZ=a.listenerZ;this.listenerTracker.setObject(null);var c=a.listenerUid;-1!==c&&(this.listenerTracker.loadUid=c,ga.push(this.listenerTracker));var c=a.playing,d,e,f,k,h,l,D,A,v,w,x;if(3!==this.saveload)for(d=0,e=O.length;d<e;d++)v=O[d],
v.is_music&&1===this.saveload||(v.is_music||2!==this.saveload)&&v.stop();for(h in P)if(P.hasOwnProperty(h))for(d=0,e=P[h].length;d<e;d++)P[h][d].remove();cr.wipe(P);for(h in a.effects)if(a.effects.hasOwnProperty(h))for(l=a.effects[h],d=0,e=l.length;d<e;d++)switch(f=l[d].type,w=l[d].params,f){case "filter":y(h,new g(w[0],w[1],w[2],w[3],w[4],w[5]));break;case "delay":y(h,new m(w[0],w[1],w[2]));break;case "convolve":f=w[2];v=this.getAudioBuffer(f,!1);v.bufferObject?f=new n(v.bufferObject,w[0],w[1],f):
(f=new n(null,w[0],w[1],f),v.normalizeWhenReady=w[0],v.convolveWhenReady=f);y(h,f);break;case "flanger":y(h,new p(w[0],w[1],w[2],w[3],w[4]));break;case "phaser":y(h,new r(w[0],w[1],w[2],w[3],w[4],w[5]));break;case "gain":y(h,new s(w[0]));break;case "tremolo":y(h,new q(w[0],w[1]));break;case "ringmod":y(h,new t(w[0],w[1]));break;case "distortion":y(h,new u(w[0],w[1],w[2],w[3],w[4]));break;case "compressor":y(h,new C(w[0],w[1],w[2],w[3],w[4]));break;case "analyser":y(h,new J(w[0],w[1]))}d=0;for(e=c.length;d<
e;d++)3===this.saveload||(a=c[d],f=a.buffersrc,k=a.is_music,h=a.tag,l=a.playbackTime,D=a.looping,A=a.volume,x=(w=a.pan)&&w.hasOwnProperty("objUid")?w.objUid:-1,k&&1===this.saveload)||!k&&2===this.saveload||((v=this.getAudioInstance(f,h,k,D,A))?(v.resume_position=a.resume_position,v.setPannerEnabled(!!w),v.play(D,A,l),v.updatePlaybackRate(),v.updateVolume(),v.doSetMuted(v.is_muted||v.is_silent),a.paused&&v.pause(),a.muted&&v.setMuted(!0),v.doSetMuted(v.is_muted||v.is_silent),w&&(-1!==x?(v.objectTracker=
v.objectTracker||new G,v.objectTracker.loadUid=x,ga.push(v.objectTracker)):v.setPan(w.x,w.y,w.a,w.ia,w.oa,w.og))):(v=this.getAudioBuffer(f,k),v.seekWhenReady=l,v.pauseWhenReady=a.paused,w&&(-1!==x?v.panWhenReady.push({objUid:x,ia:w.ia,oa:w.oa,og:w.og,thistag:h}):v.panWhenReady.push({x:w.x,y:w.y,a:w.a,ia:w.ia,oa:w.oa,og:w.og,thistag:h}))));if(b&&!W){d=0;for(e=O.length;d<e;d++)O[d].setSilent(!0);W=!0}else if(!b&&W){d=0;for(e=O.length;d<e;d++)O[d].setSilent(!1);W=!1}};ba.afterLoad=function(){var a,b,
c,d;a=0;for(b=ga.length;a<b;a++)c=ga[a],d=this.runtime.getObjectByUID(c.loadUid),c.setObject(d),c.loadUid=-1,d&&(Z=d.x,aa=d.y);ga.length=0};ba.onSuspend=function(a){var b,c;b=0;for(c=O.length;b<c;b++)O[b].setSuspended(a)};ba.tick=function(){var a=this.runtime.dt,b,c,d;b=0;for(c=O.length;b<c;b++)d=O[b],d.tick(a),d.myapi===L||d.myapi===V||d.fresh||d.stopped||!d.hasEnded()||(d.stopped=!0,K=d.tag,E.trigger(cr.plugins_.Audio.prototype.cnds.OnEnded,T)),0!==ha&&d.updatePlaybackRate();var e,g;for(e in P)if(P.hasOwnProperty(e))for(d=
P[e],b=0,c=d.length;b<c;b++)g=d[b],g.tick&&g.tick();M===B&&this.listenerTracker.hasObject()&&(this.listenerTracker.tick(a),Z=this.listenerTracker.obj.x,aa=this.listenerTracker.obj.y,F.listener.setPosition(this.listenerTracker.obj.x,this.listenerTracker.obj.y,this.listenerZ),F.listener.setVelocity(this.listenerTracker.getVelocityX(),this.listenerTracker.getVelocityY(),0))};ba.getAudioBuffer=function(a,b){var c,d,e,g=null;c=0;for(d=da.length;c<d;c++)if(e=da[c],e.src===a){g=e;break}g||(g=new A(a,b),
da.push(g));return g};ba.getAudioInstance=function(a,b,c,d,e){var g,f,k;g=0;for(f=O.length;g<f;g++)if(k=O[g],k.src===a&&(k.canBeRecycled()||c))return k.tag=b,k;a=this.getAudioBuffer(a,c);if(!a.bufferObject)return"<preload>"!==b&&(a.playTagWhenReady=b,a.loopWhenReady=d,a.volumeWhenReady=e),null;k=new v(a,b);O.push(k);return k};var Q=[];D.prototype.OnEnded=function(a){return cr.equals_nocase(K,a)};D.prototype.PreloadsComplete=function(){var a,b;a=0;for(b=da.length;a<b;a++)if(!da[a].isLoaded())return!1;
return!0};D.prototype.AdvancedAudioSupported=function(){return M===B};D.prototype.IsSilent=function(){return W};D.prototype.IsAnyPlaying=function(){var a,b;a=0;for(b=O.length;a<b;a++)if(O[a].isPlaying())return!0;return!1};D.prototype.IsTagPlaying=function(a){w(a);var b;a=0;for(b=Q.length;a<b;a++)if(Q[a].isPlaying())return!0;return!1};S.cnds=new D;z.prototype.Play=function(b,c,d,e){!W&&(d=a(d),U=this.getAudioInstance(this.runtime.files_subfolder+b[0]+(X?".ogg":".m4a"),e,b[1],0!==c,d))&&(U.setPannerEnabled(!1),
U.play(0!==c,d))};z.prototype.PlayAtPosition=function(b,c,d,e,g,f,k,h,l,m){if(!W){d=a(d);var n=b[1];b=this.runtime.files_subfolder+b[0]+(X?".ogg":".m4a");(U=this.getAudioInstance(b,m,n,0!==c,d))?(U.setPannerEnabled(!0),U.setPan(e,g,f,k,h,a(l)),U.play(0!==c,d)):this.getAudioBuffer(b,n).panWhenReady.push({x:e,y:g,a:f,ia:k,oa:h,og:a(l),thistag:m})}};z.prototype.PlayAtObject=function(b,c,d,e,g,f,k,h){if(!W&&e&&(e=e.getFirstPicked())){d=a(d);var l=b[1];b=this.runtime.files_subfolder+b[0]+(X?".ogg":".m4a");
(U=this.getAudioInstance(b,h,l,0!==c,d))?(U.setPannerEnabled(!0),h=cr.rotatePtAround(e.x,e.y,-e.layer.getAngle(),Z,aa,!0),b=cr.rotatePtAround(e.x,e.y,-e.layer.getAngle(),Z,aa,!1),U.setPan(h,b,cr.to_degrees(e.angle-e.layer.getAngle()),g,f,a(k)),U.setObject(e),U.play(0!==c,d)):this.getAudioBuffer(b,l).panWhenReady.push({obj:e,ia:g,oa:f,og:a(k),thistag:h})}};z.prototype.PlayByName=function(b,c,d,e,g){!W&&(e=a(e),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(X?".ogg":".m4a"),U=this.getAudioInstance(c,
g,b,0!==d,e))&&(U.setPannerEnabled(!1),U.play(0!==d,e))};z.prototype.PlayAtPositionByName=function(b,c,d,e,g,f,k,h,l,m,n){W||(e=a(e),b=1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(X?".ogg":".m4a"),(U=this.getAudioInstance(c,n,b,0!==d,e))?(U.setPannerEnabled(!0),U.setPan(g,f,k,h,l,a(m)),U.play(0!==d,e)):this.getAudioBuffer(c,b).panWhenReady.push({x:g,y:f,a:k,ia:h,oa:l,og:a(m),thistag:n}))};z.prototype.PlayAtObjectByName=function(b,c,d,e,g,f,k,h,l){!W&&g&&(g=g.getFirstPicked())&&(e=a(e),b=
1===b,c=this.runtime.files_subfolder+c.toLowerCase()+(X?".ogg":".m4a"),(U=this.getAudioInstance(c,l,b,0!==d,e))?(U.setPannerEnabled(!0),l=cr.rotatePtAround(g.x,g.y,-g.layer.getAngle(),Z,aa,!0),c=cr.rotatePtAround(g.x,g.y,-g.layer.getAngle(),Z,aa,!1),U.setPan(l,c,cr.to_degrees(g.angle-g.layer.getAngle()),f,k,a(h)),U.setObject(g),U.play(0!==d,e)):this.getAudioBuffer(c,b).panWhenReady.push({obj:g,ia:f,oa:k,og:a(h),thistag:l}))};z.prototype.SetLooping=function(a,b){w(a);var c,d;c=0;for(d=Q.length;c<d;c++)Q[c].setLooping(0===
b)};z.prototype.SetMuted=function(a,b){w(a);var c,d;c=0;for(d=Q.length;c<d;c++)Q[c].setMuted(0===b)};z.prototype.SetVolume=function(b,c){w(b);var d=a(c),e,g;e=0;for(g=Q.length;e<g;e++)Q[e].setVolume(d)};z.prototype.Preload=function(a){if(!W){var b=a[1];a=this.runtime.files_subfolder+a[0]+(X?".ogg":".m4a");M===V?this.runtime.isDirectCanvas?AppMobi.context.loadSound(a):AppMobi.player.loadSound(a):M!==N&&this.getAudioInstance(a,"<preload>",b,!1)}};z.prototype.PreloadByName=function(a,b){if(!W){var c=
1===a,d=this.runtime.files_subfolder+b.toLowerCase()+(X?".ogg":".m4a");M===V?this.runtime.isDirectCanvas?AppMobi.context.loadSound(d):AppMobi.player.loadSound(d):M!==N&&this.getAudioInstance(d,"<preload>",c,!1)}};z.prototype.SetPlaybackRate=function(a,b){w(a);0>b&&(b=0);var c,d;c=0;for(d=Q.length;c<d;c++)Q[c].setPlaybackRate(b)};z.prototype.Stop=function(a){w(a);var b;a=0;for(b=Q.length;a<b;a++)Q[a].stop()};z.prototype.StopAll=function(){var a,b;a=0;for(b=O.length;a<b;a++)O[a].stop()};z.prototype.SetPaused=
function(a,b){w(a);var c,d;c=0;for(d=Q.length;c<d;c++)0===b?Q[c].pause():Q[c].resume()};z.prototype.Seek=function(a,b){w(a);var c,d;c=0;for(d=Q.length;c<d;c++)Q[c].seek(b)};z.prototype.SetSilent=function(a){var b;2===a&&(a=W?1:0);if(0===a&&!W){a=0;for(b=O.length;a<b;a++)O[a].setSilent(!0);W=!0}else if(1===a&&W){a=0;for(b=O.length;a<b;a++)O[a].setSilent(!1);W=!1}};z.prototype.SetMasterVolume=function(b){Y=a(b);var c;b=0;for(c=O.length;b<c;b++)O[b].updateVolume()};z.prototype.AddFilterEffect=function(a,
b,c,d,e,f,k){M!==B||0>b||b>=la.length||!F.createBiquadFilter||(a=a.toLowerCase(),k/=100,0>k&&(k=0),1<k&&(k=1),y(a,new g(b,c,d,e,f,k)))};z.prototype.AddDelayEffect=function(b,c,d,e){M===B&&(b=b.toLowerCase(),e/=100,0>e&&(e=0),1<e&&(e=1),y(b,new m(c,a(d),e)))};z.prototype.AddFlangerEffect=function(a,b,c,d,e,g){M===B&&F.createOscillator&&(a=a.toLowerCase(),g/=100,0>g&&(g=0),1<g&&(g=1),y(a,new p(b/1E3,c/1E3,d,e/100,g)))};z.prototype.AddPhaserEffect=function(a,b,c,d,e,g,f){M===B&&F.createOscillator&&(a=
a.toLowerCase(),f/=100,0>f&&(f=0),1<f&&(f=1),y(a,new r(b,c,d,e,g,f)))};z.prototype.AddConvolutionEffect=function(a,b,c,d){if(M===B&&F.createConvolver){c=0===c;var e=this.runtime.files_subfolder+b[0]+(X?".ogg":".m4a");b=this.getAudioBuffer(e,!1);a=a.toLowerCase();d/=100;0>d&&(d=0);1<d&&(d=1);b.bufferObject?d=new n(b.bufferObject,c,d,e):(d=new n(null,c,d,e),b.normalizeWhenReady=c,b.convolveWhenReady=d);y(a,d)}};z.prototype.AddGainEffect=function(b,c){M===B&&(b=b.toLowerCase(),y(b,new s(a(c))))};z.prototype.AddMuteEffect=
function(a){M===B&&(a=a.toLowerCase(),y(a,new s(0)))};z.prototype.AddTremoloEffect=function(a,b,c){M===B&&F.createOscillator&&(a=a.toLowerCase(),c/=100,0>c&&(c=0),1<c&&(c=1),y(a,new q(b,c)))};z.prototype.AddRingModEffect=function(a,b,c){M===B&&F.createOscillator&&(a=a.toLowerCase(),c/=100,0>c&&(c=0),1<c&&(c=1),y(a,new t(b,c)))};z.prototype.AddDistortionEffect=function(a,b,c,d,e,g){M===B&&F.createWaveShaper&&(a=a.toLowerCase(),g/=100,0>g&&(g=0),1<g&&(g=1),y(a,new u(b,c,d,e,g)))};z.prototype.AddCompressorEffect=
function(a,b,c,d,e,g){M===B&&F.createDynamicsCompressor&&(a=a.toLowerCase(),y(a,new C(b,c,d,e/1E3,g/1E3)))};z.prototype.AddAnalyserEffect=function(a,b,c){M===B&&(a=a.toLowerCase(),y(a,new J(b,c)))};z.prototype.RemoveEffects=function(a){if(M===B){a=a.toLowerCase();var b,c,d;if(P.hasOwnProperty(a)&&(d=P[a],d.length)){b=0;for(c=d.length;b<c;b++)d[b].remove();d.length=0;x(a)}}};z.prototype.SetEffectParameter=function(a,b,c,d,e,g){M===B&&(a=a.toLowerCase(),b=Math.floor(b),P.hasOwnProperty(a)&&(a=P[a],
0>b||b>=a.length||a[b].setParam(c,d,e,g)))};z.prototype.SetListenerObject=function(a){a&&M===B&&(a=a.getFirstPicked())&&(this.listenerTracker.setObject(a),Z=a.x,aa=a.y)};z.prototype.SetListenerZ=function(a){this.listenerZ=a};S.acts=new z;H.prototype.Duration=function(a,b){w(b);Q.length?a.set_float(Q[0].getDuration()):a.set_float(0)};H.prototype.PlaybackTime=function(a,b){w(b);Q.length?a.set_float(Q[0].getPlaybackTime()):a.set_float(0)};H.prototype.Volume=function(a,c){w(c);if(Q.length){var d=Q[0].getVolume();
a.set_float(b(d))}else a.set_float(0)};H.prototype.MasterVolume=function(a){a.set_float(Y)};H.prototype.EffectCount=function(a,b){b=b.toLowerCase();var c=null;P.hasOwnProperty(b)&&(c=P[b]);a.set_int(c?c.length:0)};H.prototype.AnalyserFreqBinCount=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);b=I(b,c);a.set_int(b?b.node.frequencyBinCount:0)};H.prototype.AnalyserFreqBinAt=function(a,b,c,d){b=b.toLowerCase();c=Math.floor(c);d=Math.floor(d);(b=I(b,c))?0>d||d>=b.node.frequencyBinCount?a.set_float(0):
a.set_float(b.freqBins[d]):a.set_float(0)};H.prototype.AnalyserPeakLevel=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);(b=I(b,c))?a.set_float(b.peak):a.set_float(0)};H.prototype.AnalyserRMSLevel=function(a,b,c){b=b.toLowerCase();c=Math.floor(c);(b=I(b,c))?a.set_float(b.rms):a.set_float(0)};S.exps=new H})();cr.plugins_.Browser=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){"undefined"!==typeof jQuery&&f.setSize(jQuery(window).width(),jQuery(window).height())}function d(){}var e=cr.plugins_.Browser.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a){this.type=a;this.runtime=a.runtime};e.Instance.prototype.onCreate=function(){var a=this;window.addEventListener("resize",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnResize,
a)});"undefined"!==typeof navigator.onLine&&(window.addEventListener("online",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOnline,a)}),window.addEventListener("offline",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOffline,a)}));"undefined"!==typeof window.applicationCache&&(window.applicationCache.addEventListener("updateready",function(){a.runtime.loadingprogress=1;a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady,a)}),window.applicationCache.addEventListener("progress",
function(b){a.runtime.loadingprogress=b.loaded/b.total}));this.runtime.isDirectCanvas||(document.addEventListener("appMobi.device.update.available",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady,a)}),document.addEventListener("backbutton",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,a)}),document.addEventListener("menubutton",function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton,a)}),document.addEventListener("searchbutton",
function(){a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnSearchButton,a)}),document.addEventListener("tizenhwkey",function(b){var c;switch(b.keyName){case "back":c=a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,a);!c&&window.tizen&&window.tizen.application.getCurrentApplication().exit();break;case "menu":(c=a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton,a))||b.preventDefault()}}));this.runtime.isWindowsPhone81&&(WinJS.Application.onbackclick=function(b){return!!a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton,
a)});this.runtime.addSuspendCallback(function(b){b?a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageHidden,a):a.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageVisible,a)});this.is_arcade="undefined"!==typeof window.is_scirra_arcade};a.prototype.CookiesEnabled=function(){return navigator?navigator.cookieEnabled:!1};a.prototype.IsOnline=function(){return navigator?navigator.onLine:!1};a.prototype.HasJava=function(){return navigator?navigator.javaEnabled():!1};a.prototype.OnOnline=
function(){return!0};a.prototype.OnOffline=function(){return!0};a.prototype.IsDownloadingUpdate=function(){return"undefined"===typeof window.applicationCache?!1:window.applicationCache.status===window.applicationCache.DOWNLOADING};a.prototype.OnUpdateReady=function(){return!0};a.prototype.PageVisible=function(){return!this.runtime.isSuspended};a.prototype.OnPageVisible=function(){return!0};a.prototype.OnPageHidden=function(){return!0};a.prototype.OnResize=function(){return!0};a.prototype.IsFullscreen=
function(){return!!(document.mozFullScreen||document.webkitIsFullScreen||document.fullScreen||this.runtime.isNodeFullscreen)};a.prototype.OnBackButton=function(){return!0};a.prototype.OnMenuButton=function(){return!0};a.prototype.OnSearchButton=function(){return!0};a.prototype.IsMetered=function(){var a=navigator.connection||navigator.mozConnection||navigator.webkitConnection;return a?a.metered:!1};a.prototype.IsCharging=function(){var a=navigator.battery||navigator.mozBattery||navigator.webkitBattery;
return a?a.charging:!0};a.prototype.IsPortraitLandscape=function(a){return(window.innerWidth<=window.innerHeight?0:1)===a};e.cnds=new a;b.prototype.Alert=function(a){this.runtime.isDomFree||alert(a.toString())};b.prototype.Close=function(){this.runtime.isCocoonJs?CocoonJS.App.forceToFinish():window.tizen?window.tizen.application.getCurrentApplication().exit():navigator.app&&navigator.app.exitApp?navigator.app.exitApp():navigator.device&&navigator.device.exitApp?navigator.device.exitApp():this.is_arcade||
this.runtime.isDomFree||window.close()};b.prototype.Focus=function(){this.runtime.isNodeWebkit?window.nwgui.Window.get().focus():this.is_arcade||this.runtime.isDomFree||window.focus()};b.prototype.Blur=function(){this.runtime.isNodeWebkit?window.nwgui.Window.get().blur():this.is_arcade||this.runtime.isDomFree||window.blur()};b.prototype.GoBack=function(){navigator.app&&navigator.app.backHistory?navigator.app.backHistory():this.is_arcade||this.runtime.isDomFree||!window.back||window.back()};b.prototype.GoForward=
function(){this.is_arcade||this.runtime.isDomFree||!window.forward||window.forward()};b.prototype.GoHome=function(){this.is_arcade||this.runtime.isDomFree||!window.home||window.home()};b.prototype.GoToURL=function(a){this.runtime.isCocoonJs?CocoonJS.App.openURL(a):this.runtime.isEjecta?ejecta.openURL(a):this.runtime.isWinJS?Windows.System.Launcher.launchUriAsync(new Windows.Foundation.Uri(a)):navigator.app&&navigator.app.loadUrl?navigator.app.loadUrl(a,{openExternal:!0}):this.is_arcade||this.runtime.isDomFree||
(window.location=a)};b.prototype.GoToURLWindow=function(a,b){this.runtime.isCocoonJs?CocoonJS.App.openURL(a):this.runtime.isEjecta?ejecta.openURL(a):this.runtime.isWinJS?Windows.System.Launcher.launchUriAsync(new Windows.Foundation.Uri(a)):navigator.app&&navigator.app.loadUrl?navigator.app.loadUrl(a,{openExternal:!0}):this.is_arcade||this.runtime.isDomFree||window.open(a,b)};b.prototype.Reload=function(){this.is_arcade||this.runtime.isDomFree||window.location.reload()};var h=!0,f=null;b.prototype.RequestFullScreen=
function(a){this.runtime.isDomFree?cr.logexport("[Construct 2] Requesting fullscreen is not supported on this platform - the request has been ignored"):(2<=a&&(a+=1),6===a&&(a=2),this.runtime.isNodeWebkit?this.runtime.isNodeFullscreen||(window.nwgui.Window.get().enterFullscreen(),this.runtime.isNodeFullscreen=!0,this.runtime.fullscreen_scaling=2<=a?a:0):document.mozFullScreen||document.webkitIsFullScreen||document.msFullscreenElement||document.fullScreen||(this.runtime.fullscreen_scaling=2<=a?a:0,
a=this.runtime.canvasdiv||this.runtime.canvas,h&&(h=!1,f=this.runtime,a.addEventListener("mozfullscreenerror",c),a.addEventListener("webkitfullscreenerror",c),a.addEventListener("msfullscreenerror",c),a.addEventListener("fullscreenerror",c)),cr.is_undefined(a.requestFullscreen)?cr.is_undefined(a.webkitRequestFullScreen)?cr.is_undefined(a.mozRequestFullScreen)?cr.is_undefined(a.msRequestFullscreen)||a.msRequestFullscreen():a.mozRequestFullScreen():"undefined"!==typeof Element&&"undefined"!==typeof Element.ALLOW_KEYBOARD_INPUT?
a.webkitRequestFullScreen(Element.ALLOW_KEYBOARD_INPUT):a.webkitRequestFullScreen():a.requestFullscreen()))};b.prototype.CancelFullScreen=function(){this.runtime.isDomFree?cr.logexport("[Construct 2] Exiting fullscreen is not supported on this platform - the request has been ignored"):this.runtime.isNodeWebkit?this.runtime.isNodeFullscreen&&(window.nwgui.Window.get().leaveFullscreen(),this.runtime.isNodeFullscreen=!1):cr.is_undefined(document.exitFullscreen)?cr.is_undefined(document.webkitCancelFullScreen)?
cr.is_undefined(document.mozCancelFullScreen)?cr.is_undefined(document.msExitFullscreen)||document.msExitFullscreen():document.mozCancelFullScreen():document.webkitCancelFullScreen():document.exitFullscreen()};b.prototype.Vibrate=function(a){try{var b=a.split(","),c,d;c=0;for(d=b.length;c<d;c++)b[c]=parseInt(b[c],10);navigator.vibrate?navigator.vibrate(b):navigator.mozVibrate?navigator.mozVibrate(b):navigator.webkitVibrate?navigator.webkitVibrate(b):navigator.msVibrate&&navigator.msVibrate(b)}catch(e){}};
b.prototype.InvokeDownload=function(a,b){var c=document.createElement("a");if("undefined"===typeof c.download)window.open(a);else{var d=document.getElementsByTagName("body")[0];c.textContent=b;c.href=a;c.download=b;d.appendChild(c);var e=document.createEvent("MouseEvent");e.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null);c.dispatchEvent(e);d.removeChild(c)}};b.prototype.InvokeDownloadString=function(a,b,c){var d="data:"+b+","+encodeURIComponent(a);a=document.createElement("a");"undefined"===
typeof a.download?window.open(d):(b=document.getElementsByTagName("body")[0],a.textContent=c,a.href=d,a.download=c,b.appendChild(a),c=document.createEvent("MouseEvent"),c.initMouseEvent("click",!0,!0,window,0,0,0,0,0,!1,!1,!1,!1,0,null),a.dispatchEvent(c),b.removeChild(a))};b.prototype.ConsoleLog=function(a,b){"undefined"!==typeof console&&(0===a&&console.log&&console.log(b.toString()),1===a&&console.warn&&console.warn(b.toString()),2===a&&console.error&&console.error(b.toString()))};b.prototype.ConsoleGroup=
function(a){console&&console.group&&console.group(a)};b.prototype.ConsoleGroupEnd=function(){console&&console.groupEnd&&console.groupEnd()};b.prototype.ExecJs=function(a){eval&&eval(a)};var l="portrait landscape portrait-primary portrait-secondary landscape-primary landscape-secondary".split(" ");b.prototype.LockOrientation=function(a){a=Math.floor(a);0>a||a>=l.length||(this.runtime.autoLockOrientation=!1,a=l[a],screen.lockOrientation?screen.lockOrientation(a):screen.webkitLockOrientation?screen.webkitLockOrientation(a):
screen.mozLockOrientation?screen.mozLockOrientation(a):screen.msLockOrientation&&screen.msLockOrientation(a))};b.prototype.UnlockOrientation=function(){this.runtime.autoLockOrientation=!1;screen.unlockOrientation?screen.unlockOrientation():screen.webkitUnlockOrientation?screen.webkitUnlockOrientation():screen.mozUnlockOrientation?screen.mozUnlockOrientation():screen.msUnlockOrientation&&screen.msUnlockOrientation()};e.acts=new b;d.prototype.URL=function(a){a.set_string(this.runtime.isDomFree?"":window.location.toString())};
d.prototype.Protocol=function(a){a.set_string(this.runtime.isDomFree?"":window.location.protocol)};d.prototype.Domain=function(a){a.set_string(this.runtime.isDomFree?"":window.location.hostname)};d.prototype.PathName=function(a){a.set_string(this.runtime.isDomFree?"":window.location.pathname)};d.prototype.Hash=function(a){a.set_string(this.runtime.isDomFree?"":window.location.hash)};d.prototype.Referrer=function(a){a.set_string(this.runtime.isDomFree?"":document.referrer)};d.prototype.Title=function(a){a.set_string(this.runtime.isDomFree?
"":document.title)};d.prototype.Name=function(a){a.set_string(this.runtime.isDomFree?"":navigator.appName)};d.prototype.Version=function(a){a.set_string(this.runtime.isDomFree?"":navigator.appVersion)};d.prototype.Language=function(a){navigator&&navigator.language?a.set_string(navigator.language):a.set_string("")};d.prototype.Platform=function(a){a.set_string(this.runtime.isDomFree?"":navigator.platform)};d.prototype.Product=function(a){navigator&&navigator.product?a.set_string(navigator.product):
a.set_string("")};d.prototype.Vendor=function(a){navigator&&navigator.vendor?a.set_string(navigator.vendor):a.set_string("")};d.prototype.UserAgent=function(a){a.set_string(this.runtime.isDomFree?"":navigator.userAgent)};d.prototype.QueryString=function(a){a.set_string(this.runtime.isDomFree?"":window.location.search)};d.prototype.QueryParam=function(a,b){if(this.runtime.isDomFree)a.set_string("");else{var c=RegExp("[?&]"+b+"=([^&]*)").exec(window.location.search);c?a.set_string(decodeURIComponent(c[1].replace(/\+/g,
" "))):a.set_string("")}};d.prototype.Bandwidth=function(a){var b=navigator.connection||navigator.mozConnection||navigator.webkitConnection;b?a.set_float(b.bandwidth):a.set_float(Number.POSITIVE_INFINITY)};d.prototype.BatteryLevel=function(a){var b=navigator.battery||navigator.mozBattery||navigator.webkitBattery;b?a.set_float(b.level):a.set_float(1)};d.prototype.BatteryTimeLeft=function(a){var b=navigator.battery||navigator.mozBattery||navigator.webkitBattery;b?a.set_float(b.dischargingTime):a.set_float(Number.POSITIVE_INFINITY)};
d.prototype.ExecJS=function(a,b){if(eval){var c=eval(b);"number"===typeof c?a.set_any(c):"string"===typeof c?a.set_any(c):"boolean"===typeof c?a.set_any(c?1:0):a.set_any(0)}else a.set_any(0)};d.prototype.ScreenWidth=function(a){a.set_int(screen.width)};d.prototype.ScreenHeight=function(a){a.set_int(screen.height)};d.prototype.DevicePixelRatio=function(a){a.set_float(this.runtime.devicePixelRatio)};e.exps=new d})();cr.plugins_.CJSAds=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d="",e=[],h=0,f=0,l=!1,k=!1,g=!1,m=cr.plugins_.CJSAds.prototype;m.Type=function(a){this.plugin=a;this.runtime=a.runtime};m.Type.prototype.onCreate=function(){};m.Instance=function(a){this.type=a;this.runtime=a.runtime};m.Instance.prototype.onCreate=function(){this.isShowingFullscreen=this.isShowingBanner=!1;this.triggerProduct="";this.socialService=null;this.socialServiceAvailable=!1;this.storeServiceAvailable=this.runtime.isCocoonJs&&"undefined"!==
typeof CocoonJS.Store.nativeExtensionObjectAvailable;this.storeManaged=1!==this.properties[0];this.storeSandboxed=0!==this.properties[1];this.onConsumePurchaseCompleted=this.onConsumePurchaseFailedTransactionId="";var a=this;this.runtime.isCocoonJs&&(CocoonJS.App.onTextDialogFinished.addEventListener(function(b){d=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardOK,a)}),CocoonJS.App.onTextDialogCancelled.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardCancelled,
a)}),CocoonJS.Ad.onBannerShown.addEventListener(function(){a.isShowingBanner=!0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnBannerShown,a)}),CocoonJS.Ad.onBannerReady.addEventListener(function(){k=!0;l||(CocoonJS.Ad.setBannerLayout(f),CocoonJS.Ad.showBanner())}),CocoonJS.Ad.onFullScreenShown.addEventListener(function(){a.isShowingFullscreen=!0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenShown,a)}),CocoonJS.Ad.onFullScreenHidden.addEventListener(function(){a.isShowingFullscreen=
!1;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenHidden,a)}),CocoonJS.Ad.onFullScreenReady.addEventListener(function(){g=!0;preloadFullScreen||CocoonJS.Ad.showFullScreen()}),this.storeServiceAvailable&&(CocoonJS.Store.onProductPurchaseCompleted.addEventListener(function(b){a.triggerProduct=b.productId;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,a);CocoonJS.Store.addPurchase(b);CocoonJS.Store.consumePurchase(b.transactionId,b.productId);CocoonJS.Store.finishPurchase(b.transactionId)}),
CocoonJS.Store.onConsumePurchaseFailed.addEventListener(function(b,c){this.onConsumePurchaseFailedTransactionId=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseFailed,a)}),CocoonJS.Store.onConsumePurchaseCompleted.addEventListener(function(b){this.onConsumePurchaseCompleted=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseCompleted,a)}),CocoonJS.Store.onProductPurchaseFailed.addEventListener(function(b,c){a.triggerProduct=b;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,
a)}),CocoonJS.Store.onProductPurchaseStarted.addEventListener(function(b){a.triggerProduct=b.productId;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseStart,a)}),CocoonJS.Store.onProductsFetchStarted.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchStarted,a)}),CocoonJS.Store.onProductsFetchFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchFailed,a)}),CocoonJS.Store.onProductsFetchCompleted.addEventListener(function(b){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchCompleted,
a)}),CocoonJS.Store.requestInitialization({managed:this.storeManaged,sandbox:this.storeSandboxed}),CocoonJS.Store.start()),this.socialService=CocoonJS.SocialGaming.GameCenter,this.socialServiceAvailable=!!this.socialService.nativeExtensionObjectAvailable,this.socialService.onRequestLoginSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginSuccess,a)}),this.socialService.onRequestLoginFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginFail,
a)}),this.socialService.onLogout.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLogout,a)}),this.socialService.onRequestUserScoreSucceed.addEventListener(function(b){h=b.score||0;a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreReceived,a)}),this.socialService.onRequestUserScoreFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreUnavailable,a)}),this.socialService.onSubmitUserScoreSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitSuccess,
a)}),this.socialService.onSubmitUserScoreFailed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitFail,a)}),this.socialService.onLeaderboardViewSucceed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardOpen,a)}),this.socialService.onLeaderboardViewClosed.addEventListener(function(){a.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardClose,a)}))};a.prototype.IsShowingBanner=function(){return this.isShowingBanner};
a.prototype.IsCocoonJS=function(){return this.runtime.isCocoonJs};a.prototype.OnBannerShown=function(){return!0};a.prototype.OnFullscreenShown=function(){return!0};a.prototype.OnFullscreenHidden=function(){return!0};a.prototype.IsShowingFullscreen=function(){return this.isShowingFullscreen};a.prototype.IsStoreAvailable=function(){return this.runtime.isCocoonJs?this.storeServiceAvailable&&CocoonJS.Store.canPurchase():!1};a.prototype.OnPurchaseStart=function(a){return this.triggerProduct===a};a.prototype.OnPurchaseComplete=
function(a){return this.triggerProduct===a};a.prototype.OnPurchaseFail=function(a){return this.triggerProduct===a};a.prototype.onProductsFetchStarted=function(){return!0};a.prototype.onConsumePurchaseFailed=function(){return!0};a.prototype.onProductsFetchCompleted=function(){return!0};a.prototype.onProductsFetchFailed=function(){return!0};a.prototype.IsProductPurchased=function(a){return this.runtime.isCocoonJs?CocoonJS.Store.isProductPurchased(a):!1};a.prototype.OnKeyboardCancelled=function(){return!0};
a.prototype.OnKeyboardOK=function(){return!0};a.prototype.IsGCAvailable=function(){return this.socialServiceAvailable};a.prototype.IsGCLoggedIn=function(){return this.socialServiceAvailable?this.socialService.isLoggedIn():!1};a.prototype.OnGCLoginSuccess=function(){return!0};a.prototype.OnGCLoginFail=function(){return!0};a.prototype.OnGCLogout=function(){return!0};a.prototype.OnGCScoreReceived=function(){return!0};a.prototype.OnGCScoreUnavailable=function(){return!0};a.prototype.OnGCScoreSubmitSuccess=
function(){return!0};a.prototype.OnGCScoreSubmitFail=function(){return!0};a.prototype.OnGCLeaderboardOpen=function(){return!0};a.prototype.OnGCLeaderboardClose=function(){return!0};m.cnds=new a;b.prototype.ShowBanner=function(a){this.runtime.isCocoonJs&&(f=0===a?CocoonJS.Ad.BannerLayout.TOP_CENTER:CocoonJS.Ad.BannerLayout.BOTTOM_CENTER,l=!1,k?(CocoonJS.Ad.setBannerLayout(f),CocoonJS.Ad.showBanner()):CocoonJS.Ad.preloadBanner())};b.prototype.ShowFullscreen=function(){this.runtime.isCocoonJs&&(g?CocoonJS.Ad.showFullScreen():
CocoonJS.Ad.preloadFullScreen())};b.prototype.HideBanner=function(){this.runtime.isCocoonJs&&(CocoonJS.Ad.hideBanner(),this.isShowingBanner=!1)};b.prototype.PreloadBanner=function(){this.runtime.isCocoonJs&&(l=!0,CocoonJS.Ad.preloadBanner())};b.prototype.PreloadFullscreen=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.preloadFullScreen()};b.prototype.RefreshBanner=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.refreshBanner()};b.prototype.RefreshFullscreen=function(){this.runtime.isCocoonJs&&CocoonJS.Ad.refreshFullScreen()};
b.prototype.Purchase=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.purchaseProduct(a)};b.prototype.fetchProductsFromStore=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.fetchProductsFromStore(a.split(","))};b.prototype.restorePurchases=function(){if(this.runtime.isCocoonJs)return CocoonJS.Store.restorePurchases()};b.prototype.PurchasePreview=function(a){this.runtime.isCocoonJs&&CocoonJS.Store.purchaseProductModalWithPreview(a)};b.prototype.RestorePurchases=function(){this.runtime.isCocoonJs&&
CocoonJS.Store.restorePurchases()};b.prototype.PromptKeyboard=function(a,b,c,d,e,g){this.runtime.isCocoonJs&&CocoonJS.App.showTextDialog(a,b,c,["text","num","phone","email","url"][d],e,g)};b.prototype.UpdateProductsList=function(){this.runtime.isCocoonJs&&CocoonJS.Store.canPurchase()&&(e=CocoonJS.Store.getProducts())};b.prototype.GCLogin=function(){this.socialServiceAvailable&&!this.socialService.isLoggedIn()&&this.socialService.requestLogin()};b.prototype.GCLogout=function(){this.socialServiceAvailable&&
this.socialService.isLoggedIn()&&this.socialService.requestLogout()};b.prototype.GCSubmitScore=function(a,b){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.submitUserScore(a,b)};b.prototype.GCRequestScore=function(a){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.requestUserScore(a)};b.prototype.GCOpenLeaderboard=function(a){this.socialServiceAvailable&&this.socialService.isLoggedIn()&&this.socialService.showLeaderboardView(a)};m.acts=
new b;c.prototype.InputText=function(a){a.set_string(d)};c.prototype.ProductCount=function(a){a.set_int(e.length)};c.prototype.ProductDescription=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].description)};c.prototype.ProductLocalizedPrice=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].localizedPrice)};c.prototype.ProductPrice=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].price)};c.prototype.ProductAlias=
function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].productAlias)};c.prototype.ProductID=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].productId)};c.prototype.ProductTitle=function(a,b){b=Math.floor(b);0>b||b>=e.length?a.set_string(""):a.set_string(e[b].title)};c.prototype.GameCenterScore=function(a){a.set_float(h)};m.exps=new c})();cr.plugins_.Clay=function(a){this.runtime=a};
(function(){var a=cr.plugins_.Clay.prototype;a.Type=function(a){this.plugin=a;this.runtime=a.runtime};var b=null,c=null,d,e,h,f=!1,l=!1,k={},g,m="",n,p=0,r=0,s=0,q="",t=0,u=0,C=0,J,G="",A,v,w=0;a.Type.prototype.onCreate=function(){};a.Instance=function(a){this.type=a;this.runtime=a.runtime};var x=a.Instance.prototype,y=function(){if(cr_getC2Runtime().uses_loader_layout)return!1;var a=cr_getC2Runtime(),b=a&&a.progress?a.progress:0,c,d,e,g,f,h,k,l,m,s,n=document.getElementById("c2canvas");c=document.createElement("canvas");
c.style.background="#000";d=c.getContext("2d");document.getElementById("c2canvasdiv").appendChild(c);var q=new Image;q.src="http://clay.io/images/full-logo-free-games.svg";var r=new Image;r.src="http://clay.io/images/docs/c2.svg";var p=a.loaderlogo,t=function(){p.onload=q.onload=r.onload=function(){};c.width=a.width;c.height=a.height;c.style.position="absolute";c.style.zIndex="5";c.style.left=n.offsetLeft+"px";c.style.top=n.offsetTop+"px";c.setAttribute("style",c.getAttribute("style")+" -ms-touch-action: none;");
m=c.width/1E3;s=c.height/1E3;k=0;var b=200*s,t=k+=50*s,w=function(){var a=p.width/p.height*b;d.drawImage(p,500*m-a/2,t,a,b)};p&&p.complete?w():p&&(p.onload=function(){w()});k+=b;e=750*m;g=100*s;f=125*m;h=30*s;l=k+=h;var A=d.createLinearGradient(0,l,0,l+g);A.addColorStop(0,"#fff");A.addColorStop(1,"#ccc");d.fillStyle=A;d.strokeStyle="#777";d.lineWidth=4*m;k+=30*s;A=30*s;d.font=A+"px sans-serif, Verdana, Arial";var v=d.measureText("Powered By"),v=500*m-v.width/2;k+=g+A;d.fillText("Powered By",v,k);
k+=10*s;var x=function(){var a=100*s,b=q.width/q.height*a,e=450*m-b,g=k;d.drawImage(q,e,g,b,a);var f=!1;c.onmousemove=function(d){var h=d.pageX||d.clientX;d=d.pageY||d.clientY;h-=c.offsetLeft;d-=c.offsetTop;h>=e&&h<=e+b&&d>=g&&d<=g+a?(f=!0,c.style.cursor="pointer"):f&&(f=!1,c.style.cursor="default")};c.onclick=function(){f&&window.open("http://clay.io/play")}};q&&q.complete?x():q&&(q.onload=function(){x()});var u=function(){var a=100*s;d.drawImage(r,650*m,k,r.width/r.height*a,a)};r&&r.complete?u():
r&&(r.onload=function(){u()})},w=n.width,A=n.height,v=function(){if(w!=n.width||A!=n.height)t(),w=n.width,A=n.height;var h=a&&a.progress?a.progress:0;b<h&&(b+=0.01);1<=h&&(b=1);d.fillRect(f,l,b*e,g);d.strokeRect(f,l,e,g);1>h?setTimeout(v,32):c.parentNode.removeChild(c)};v()};x.onCreate=function(){0==this.properties[3]&&y();b=this.runtime;c=this;var a=0==this.properties[1],g=0==this.properties[2]?!1:"c2canvasdiv";if(window.c2cocoonjs){var h=this,k=!1;"undefined"===typeof window.Clay&&(window.Clay=
{});d=window.Clay;d.UI={modalsOpen:function(){return w}};CocoonJS.App.onLoadInTheWebViewSucceed.addEventListener(function(){k||(k=!0,CocoonJS.App.forwardAsync("CocoonJS['App']['hide']();"),CocoonJS.App.forwardAsync("load_clay( '"+h.properties[0]+"', "+a+" );"))});CocoonJS.App.loadInTheWebView("webview/webview.html")}else"undefined"===typeof window.Clay&&(window.Clay={}),d=window.Clay,d.options=d.options||{},d.options.debug=a,d.options.DOMid=g,d.options.fail=function(){l=!0},d.gameKey=this.properties[0],
d.readyFunctions=d.readyFunctions||[],d.ready=function(a){d.readyFunctions.push(a)},d.documentReadyFunctions=d.documentReadyFunctions||[],d.documentReady=function(a){d.documentReadyFunctions.push(a)},d.Stats=d.Stats||{},d.Stats.level=d.Stats.level||function(){},d.PROTOCOL="chrome-extension:"==document.location.protocol||"file:"==document.location.protocol?"https://":"ms-appx:"==document.location.protocol?"http://":document.location.protocol+"//",d.source||function(){var a=document.createElement("script");
a.src=window.Clay.PROTOCOL+"clay.io/api/api.js";var b=document.getElementsByTagName("script")[0];b.parentNode.insertBefore(a,b)}(),d.ready(function(){f=!0;e=new d.Payment})};x.draw=function(a){};x.drawGL=function(a){};a.cnds={};x=a.cnds;x.clayready=function(){var a=f;a&&(f=!1);return a};x.cdns_failed_to_load=function(){var a=l;a&&(l=!1);return a};x.cdns_leaderboard_post=function(){return!0};x.cdns_leaderboard_fetch=function(){return!0};x.cdns_achievement_award=function(){return!0};x.cdns_achievement_fetch=
function(){return!0};x.cdns_screenshot_take=function(){return!0};x.cdns_facebook_post=function(){return!0};x.cdns_facebook_invite=function(){return!0};x.cdns_twitter_post=function(){return!0};x.cdns_clay_post=function(){return!0};x.cdns_social_share=function(){return!0};x.cdns_clay_add_payment_item=function(){return!0};x.cdns_clay_checkout=function(){return!0};x.cdns_clay_checkout_fail=function(){return!0};x.cdns_clay_rooms_show=function(){return!0};x.cdns_clay_rooms_full=function(){return!0};x.cdns_clay_fetch_data=
function(){return!0};x.cdns_clay_save_data=function(){return!0};x.cdns_clay_prompt_login=function(){return!0};x.cdns_clay_prompt_logout=function(){return!0};x.cdns_clay_fetch_items=function(){return!0};x.cdns_clay_set_game_key=function(){return!0};a.acts={};x=a.acts;window.clay_from_cocoon_ready=function(a,b,c,e,g){d.isReady=!0;d.Player={identifier:a,data:{username:b},loggedIn:c,clearance:e,hasInstalled:function(){return g}};f=!0};window.clay_from_cocoon_user_ready=function(a,b,c,e,g){d.Player={identifier:a,
data:{username:b},loggedIn:c,clearance:e,hasInstalled:function(){return g}}};window.clay_from_cocoon_fail=function(){l=!0};window.clay_modal_count=function(a){w=parseInt(a)};x.log_play=function(){d.Stats.logStat({name:"Plays"})};x.log_stat=function(a,b){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['Stats']['logStat']( { name: '"+a+"', quantity: "+b+" } );"):d.Stats.logStat({name:a,quantity:b})};x.level_start=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['Stats']['level']( { action: 'start', level: level } );"):
d.Stats.level({action:"start",level:a})};x.level_success=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['Stats']['level']( { action: 'pass', level: level } );"):d.Stats.level({action:"pass",level:a})};x.level_fail=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['Stats']['level']( { action: 'fail', level: level } );"):d.Stats.level({action:"fail",level:a})};x.leaderboards_post=function(a,e,g,f){if(window.c2cocoonjs){var h="";"string"==typeof g&&(h+="'");h+=g;"string"==
typeof g&&(h+="'");CocoonJS.App.forwardAsync("leaderboards_post( '"+a+"', '"+e+"', "+h+", '"+f+"' );")}else a={name:a},a.score=e?e:0,0!=f&&(a.hideUI=!0),(new d.Leaderboard({id:g})).post(a,function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_leaderboard_post,c)})};window.clay_from_cocoon_leaderboards_post=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_leaderboard_post,c)};x.leaderboards_post_encrypted=function(a,e){if(window.c2cocoonjs){var g="";"string"==typeof a&&(g+="'");g+=a;"string"==
typeof a&&(g+="'");CocoonJS.App.forwardAsync("leaderboards_post_encrypted( "+g+", '"+e+"' );")}else(new d.Leaderboard({id:a})).post(e,function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_leaderboard_post,c)})};x.leaderboards_show=function(a,b,c,e,g,f){if(window.c2cocoonjs){var h="";"string"==typeof a&&(h+="'");h+=a;"string"==typeof a&&(h+="'");CocoonJS.App.forwardAsync("leaderboards_show( "+h+", "+b+", "+c+", "+e+", "+g+", "+f+" );")}else{h=0;f||(f=10);switch(b){case 0:h=0;break;case 1:h=2592E3;
break;case 2:h=604800;break;case 3:h=86400;break;default:h=0}b={cumulative:1===c,best:2===c,self:1===g?!0:!1,friends:2===g?!0:!1,recent:h,sort:1===e?"asc":"desc",limit:f};(new d.Leaderboard({id:a})).show(b)}};x.leaderboards_fetch=function(a,e,g,f,h,k){if(window.c2cocoonjs){var l="";"string"==typeof a&&(l+="'");l+=a;"string"==typeof a&&(l+="'");CocoonJS.App.forwardAsync("leaderboards_fetch( "+l+", "+e+", "+g+", "+f+", "+h+", "+k+" );")}else{l=0;k||(k=10);switch(e){case 0:l=0;break;case 1:l=2592E3;
break;case 2:l=604800;break;case 3:l=86400;break;default:l=0}e={cumulative:1===g,best:2===g,self:1===h?!0:!1,friends:2===h?!0:!1,recent:l,sort:1===f?"asc":"desc",limit:k,getRank:!0};(new d.Leaderboard({id:a})).fetch(e,function(d){n=d.data||[];d.rank.rank&&(r=d.rank.rank,s=d.rank.row.score,q=d.rank.row.name);p=d&&d.data?d.data.length-1:-1;0>p&&(p=0);A=a;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_leaderboard_fetch,c)})}};window.clay_from_cocoon_leaderboards_fetch=function(a,d,e,g,f,h){n=JSON.parse(d);
p=e;r=g;s=f;q=h;A=a;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_leaderboard_fetch,c)};x.leaderboards_hide=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['UI']['closeModal']( 'clay-leaderboard-wrapper' );"):d.UI.closeModal("clay-leaderboard-wrapper")};x.close_modal=function(a){window.c2cocoonjs?a?CocoonJS.App.forwardAsync("Clay['UI']['closeModal']( 'clay-"+a+"-wrapper' );"):CocoonJS.App.forwardAsync("Clay['UI']['closeModal']();"):a?d.UI.closeModal("clay-"+a+"-wrapper"):d.UI.closeModal()};
x.achievements_award=function(a,e){if(window.c2cocoonjs){var g="";"string"==typeof a&&(g+="'");g+=a;"string"==typeof a&&(g+="'");CocoonJS.App.forwardAsync("achievements_award( "+g+", "+e+" );")}else g={id:a},0!=e&&(g.hideUI=!0),(new d.Achievement(g)).award(function(d){d.success&&(k[a]=d,b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_achievement_award,c))})};window.clay_from_cocoon_achievements_award=function(a,d){k[a]=JSON.parse(d);b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_achievement_award,
c)};x.achievements_fetch=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("achievements_fetch_all();"):d.Achievement.fetchAll({},function(a){g=a.data;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_achievement_fetch,c)})};window.clay_from_cocoon_achievements_fetch=function(a){g=JSON.parse(a);b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_achievement_fetch,c)};x.achievements_award_encrypted=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("achievements_award_encrypted( '"+a+"' );"):(new d.Achievement({jwt:a})).award(function(a){a.success&&
b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_achievement_award,c)})};x.achievements_show_all=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("achievements_show_all();"):d.Achievement.showAll()};x.screenshot_show=function(a,e){if(window.c2cocoonjs)CocoonJS.App.forwardAsync("screenshot_show( '"+a+"', "+e+" );");else{var g=new d.Screenshot({prompt:!1});g.data=a;var f={};0!=e&&(f.hideUI=!0);g.save(f,function(a){a.success&&(m=a.imageSrc,b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_screenshot_take,
c))})}};window.clay_from_cocoon_screenshot_show=function(a){m=a;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_screenshot_take,c)};x.suggestions_show=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("new Clay['Suggestions']();"):new d.Suggestions};x.suggestions_hide=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['UI']['closeModal']( 'clay-suggestions-wrapper' );"):d.UI.closeModal("clay-suggestions-wrapper")};x.ratings_show=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("new Clay['Ratings']();"):
new d.Ratings};x.ratings_hide=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("Clay['UI']['closeModal']( 'clay-ratings-wrapper' );"):d.UI.closeModal("clay-ratings-wrapper")};x.facebook_post=function(a,e,g,f){window.c2cocoonjs?CocoonJS.App.forwardAsync("facebook_post( '"+a+"', '"+e+"', '"+g+"', "+f+" );"):(a={message:a},""!=e&&(a.link=e),""!=g&&(a.picture=g),0!=f&&(a.hideUI=!0),d.Facebook.post(a,function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_facebook_post,c)}))};window.clay_from_cocoon_facebook_post=
function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_facebook_post,c)};x.facebook_invite=function(a){if(window.c2cocoonjs)CocoonJS.App.forwardAsync("facebook_invite( '"+a+"' );");else{var e={};""!==a&&(e.caption=a);d.Facebook.invite(e,function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_facebook_invite,c)})}};window.clay_from_cocoon_facebook_invite=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_facebook_invite,c)};x.twitter_post=function(a,e){if(window.c2cocoonjs)CocoonJS.App.forwardAsync("twitter_post( '"+
a.replace("'","'")+"', "+e+" );");else{var g={message:a};0!=e&&(g.hideUI=!0);d.Twitter.post(g,function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_twitter_post,c)})}};window.clay_from_cocoon_twitter_post=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_twitter_post,c)};x.clay_post=function(a,e){if(window.c2cocoonjs)CocoonJS.App.forwardAsync("clay_post( '"+a.replace("'","'")+"', "+e+" );");else{var g={message:a};0!=e&&(g.hideUI=!0);d.Stream.post(g,function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_post,
c)})}};window.clay_from_cocoon_clay_post=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_post,c)};x.social_share=function(a){d.Social.share({message:a},function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_social_share,c)})};x.clay_add_payment_item=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("add_payment_item( "+a+" );"):e.addItem({id:a},function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_add_payment_item,c)})};window.clay_from_cocoon_add_payment_item=
function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_add_payment_item,c)};x.clay_remove_payment_item=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("ClayPay['removeItem']( { id: "+a+" } );"):e.removeItem({id:a})};x.clay_checkout=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_checkout();"):e.checkout(function(a){a.success?(t=a.itemIds,b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout,c)):a.jwt?(t=a.jwt,b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout,
c)):b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout_fail,c)})};window.clay_from_cocoon_clay_checkout=function(a){t=a;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout,c)};window.clay_from_cocoon_clay_checkout_fail=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout_fail,c)};x.clay_fetch_items=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_fetch_items();"):d.Player.fetchItems(function(a){v=a;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_fetch_items,
c)})};window.clay_from_cocoon_clay_fetch_items=function(a){v=JSON.parse(a);b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_fetch_items,c)};x.clay_purchase_game=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_purchase_game();"):d.Player.purchaseGame(function(a){a.success?(t=a.itemIds,b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout,c)):a.jwt?(t=a.jwt,b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout,c)):b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_checkout_fail,
c)})};x.clay_remove_player_item=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_remove_player_item( "+a+" );"):d.Player.removeItem({id:a},function(a){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_remove_player_item,c)})};window.clay_from_cocoon_remove_player_item=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_remove_player_item,c)};x.clay_rooms=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_rooms();"):(h||(h=new d.Rooms(function(a){u=a.count;C=a.id;
b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_rooms_full,c)})),h.show(function(a){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_rooms_show,c)}))};window.clay_from_cocoon_clay_rooms_show=function(){v=JSON.parse(items);b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_rooms_show,c)};window.clay_from_cocoon_clay_rooms_full=function(){v=JSON.parse(items);b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_rooms_full,c)};x.clay_rooms_force_leave=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("ClayRooms['leaveRoom']();"):
h.leaveRoom()};x.clay_fetch_data=function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_fetch_data( '"+a.replace("'","'")+"' );"):d.Player.fetchUserData(a,function(d){J=d.data;G=a;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_fetch_data,c)})};window.clay_from_cocoon_clay_fetch_data=function(a,d){J=JSON.parse(a);G=d;b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_fetch_data,c)};x.clay_save_data=function(a,e){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_save_data( '"+a.replace("'",
"'")+"', '"+e.replace("'","'")+"' );"):d.Player.saveUserData(a,e,function(a){a.success?b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_save_data,c):d.log(a.error)})};window.clay_from_cocoon_clay_save_data=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_save_data,c)};x.clay_prompt_login=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_prompt_login();"):d.Player.signup(function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_prompt_login,c)})};window.clay_from_cocoon_clay_prompt_login=
function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_prompt_login,c)};x.clay_prompt_logout=function(){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_prompt_logout();"):d.Player.logout({},function(a){a.success&&b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_prompt_logout,c)})};window.clay_from_cocoon_clay_prompt_logout=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_prompt_logout,c);d.Player.clearance="site";d.Player.data={};d.Player.identifier=0};x.clay_set_game_key=
function(a){window.c2cocoonjs?CocoonJS.App.forwardAsync("clay_set_game_key( '"+a+"' );"):d.Game.set({key:a,options:{debug:0==this.properties[1]}},function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_set_game_key,c)})};window.clay_from_cocoon_clay_set_game_key=function(){b.trigger(cr.plugins_.Clay.prototype.cnds.cdns_clay_set_game_key,c)};x.cocoon_go_to_link=function(a){window.c2cocoonjs?CocoonJS.App.openURL(a):window.open(a)};a.exps={};a=a.exps;a.Ready=function(a){a.set_int(d&&d.isReady?
1:0)};a.ScreenshotSrc=function(a){a.set_string(m)};a.AwardedAchievementTitle=function(a,b){k[b]&&k[b].title?a.set_string(k[b].title):a.set_string("")};a.AwardedAchievementDescription=function(a,b){k[b]&&k[b].description?a.set_string(k[b].description):a.set_string("")};a.AwardedAchievementIcon=function(a,b){k[b]&&k[b].icon?a.set_string(k[b].icon):a.set_string("")};a.FetchedAchievementTitle=function(a,b){g[b]&&g[b].title?a.set_string(g[b].title):a.set_string("")};a.FetchedAchievementDescription=function(a,
b){g[b]&&g[b].description?a.set_string(g[b].description):a.set_string("")};a.FetchedAchievementIcon=function(a,b){g[b]&&g[b].icon?a.set_string(g[b].icon):a.set_string("")};a.FetchedAchievementEarned=function(a,b){g[b]?a.set_int(g[b].earned?1:0):a.set_int(0)};a.FetchedAchievementCount=function(a){a.set_int(0<g.length?g.length-1:-1)};a.LeaderboardScoreCount=function(a){a.set_int(p)};a.LeaderboardName=function(a,b){"object"!==typeof n||"undefined"===typeof n[b]?a.set_string(""):a.set_string(n[b].name)};
a.LeaderboardScore=function(a,b){"object"!==typeof n||"undefined"===typeof n[b]?a.set_int(0):a.set_int(n[b].score)};a.LeaderboardScoreMe=function(a,b){"object"!==typeof n||"undefined"===typeof n[b]?a.set_int(0):a.set_int(n[b].me?1:0)};a.LeaderboardRank=function(a){a.set_int(r)};a.LeaderboardRankName=function(a){a.set_string(q)};a.LeaderboardRankScore=function(a){a.set_int(s)};a.FetchedLeaderboardID=function(a){a.set_string(A)};a.PaymentItemCount=function(a){a.set_int(t.length-1)};a.PaymentItemId=
function(a,b){"undefined"===typeof t[b]?a.set_int(0):a.set_int(t[b])};a.EncryptedPaymentResponse=function(a){a.set_string(t)};a.RoomCount=function(a){a.set_int(u)};a.RoomId=function(a){a.set_int(C)};a.Data=function(a,b){var c;c="undefined"!==typeof b&&null!==b?J[b]:J;"undefined"===typeof c||null==c?a.set_string(""):"number"===typeof c&&parseInt(c)==c?a.set_int(c):"number"===typeof c?a.set_float(c):"string"===typeof c&&a.set_string(c)};a.FetchedKey=function(a){a.set_string(G)};a.PlayerIdentifier=function(a){a.set_string(d.Player&&
d.Player.identifier?d.Player.identifier:"")};a.PlayerUsername=function(a){a.set_string(d.Player&&d.Player.data&&d.Player.data.username?d.Player.data.username:"Anonymous")};a.LoggedIn=function(a){a.set_int(d.Player?d.Player.loggedIn?1:0:0)};a.Clearance=function(a){a.set_string(d.Player?d.Player.clearance:"none")};a.FetchedItemCount=function(a){a.set_int(v?v.length-1:-1)};a.FetchedItemId=function(a,b){"undefined"===typeof v[b]?a.set_int(0):a.set_int(v[b].id)};a.FetchedItemQuantity=function(a,b){"undefined"===
typeof v[b]?a.set_int(0):a.set_int(v[b].quantity)};a.EncryptedFetchedItems=function(a){a.set_string(v)};a.HasInstalled=function(a){a.set_int(d.Player?d.Player.hasInstalled()?1:0:0)};a.ModalsOpen=function(a){a.set_int(d.UI&&d.UI.modalsOpen?parseInt(d.UI.modalsOpen()):0)}})();cr.plugins_.Facebook=function(a){this.runtime=a};
(function(){function a(){k||(k=!0,r.trigger(cr.plugins_.Facebook.prototype.cnds.OnLogIn,s),FB.api("/me",function(a){m=a.name;n=a.first_name;p=a.last_name;r.trigger(cr.plugins_.Facebook.prototype.cnds.OnNameAvailable,s)}))}function b(){}function c(){}function d(){}var e=cr.plugins_.Facebook.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};var h="",f="",l=!1,k=!1,g="",m="",n="",p="",r=null,s=null,q=0,t="",u=0,C=0,J=!1,G=!1,A="";e.Type.prototype.onCreate=function(){};e.Instance=function(a){this.type=
a;this.runtime=a.runtime};var v=e.Instance.prototype;v.onCreate=function(){this.runtime.isDomFree?cr.logexport("[Construct 2] Facebook plugin not supported on this platform - the object will not be created"):(h=this.properties[0],f=this.properties[1],r=this.runtime,s=this,window.fbAsyncInit=function(){var b=location.pathname;"/"!==b.substr(b.length-1)&&(b=b.substr(0,b.lastIndexOf("/")+1));FB.init({appId:h,channelURL:"//"+location.hostname+b+"channel.html",status:!0,cookie:!0,oauth:!0,xfbml:!1});l=
!0;FB.Event.subscribe("auth.login",function(b){g=b.authResponse.userID;a()});FB.Event.subscribe("auth.logout",function(a){k&&(k=!1,p=n=m="",r.trigger(cr.plugins_.Facebook.prototype.cnds.OnLogOut,s))});FB.getLoginStatus(function(b){b.authResponse&&(g=b.authResponse.userID,a())});r.trigger(cr.plugins_.Facebook.prototype.cnds.OnReady,s)},h.length&&function(a){var b;a.getElementById("facebook-jssdk")||(b=a.createElement("script"),b.id="facebook-jssdk",b.async=!0,b.src="//connect.facebook.net/en_US/all.js",
a.getElementsByTagName("head")[0].appendChild(b))}(document))};v.onLayoutChange=function(){this.runtime.isDomFree||(k&&r.trigger(cr.plugins_.Facebook.prototype.cnds.OnLogIn,s),m.length&&r.trigger(cr.plugins_.Facebook.prototype.cnds.OnNameAvailable,s))};b.prototype.IsReady=function(){return l};b.prototype.OnReady=function(){return!0};b.prototype.IsLoggedIn=function(){return k};b.prototype.OnLogIn=function(){return!0};b.prototype.OnLogOut=function(){return!0};b.prototype.OnNameAvailable=function(){return!0};
b.prototype.OnUserTopScoreAvailable=function(){return!0};b.prototype.OnHiscore=function(){return!0};b.prototype.OnScoreSubmitted=function(){return!0};e.cnds=new b;c.prototype.LogIn=function(b,c){if(!this.runtime.isDomFree&&l){J=1===b;G=1===c;var d=[];J&&d.push("publish_stream");G&&d.push("publish_actions");A=d.join();FB.login(function(b){b.authResponse&&a()},{scope:A})}};c.prototype.LogOut=function(){this.runtime.isDomFree||k&&FB.logout(function(a){})};c.prototype.PromptWallPost=function(){!this.runtime.isDomFree&&
k&&FB.ui({method:"feed"},function(a){a&&!a.error||console.error(a)})};c.prototype.PromptToShareApp=function(a,b,c,d){!this.runtime.isDomFree&&k&&FB.ui({method:"feed",link:"http://apps.facebook.com/"+h+"/",picture:d,name:a,caption:b,description:c},function(a){a&&!a.error||console.error(a)})};c.prototype.PromptToShareLink=function(a,b,c,d,e){!this.runtime.isDomFree&&k&&FB.ui({method:"feed",link:a,picture:e,name:b,caption:c,description:d},function(a){a&&!a.error||console.error(a)})};c.prototype.PublishToWall=
function(a){!this.runtime.isDomFree&&k&&FB.api("/me/feed","POST",{method:"stream.publish",message:a},function(a){a&&!a.error||console.error(a)})};c.prototype.PublishLink=function(a,b,c,d,e,g){!this.runtime.isDomFree&&k&&(a={method:"stream.publish",message:a,link:b,name:c,caption:d,description:e},g.length&&(a.picture=g),FB.api("/me/feed","POST",a,function(a){a&&!a.error||console.error(a)}))};c.prototype.PublishScore=function(a){!this.runtime.isDomFree&&k&&FB.api("/"+g+"/scores","POST",{score:Math.floor(a),
access_token:h+"|"+f},function(a){r.trigger(cr.plugins_.Facebook.prototype.cnds.OnScoreSubmitted,s);a&&!a.error||console.error(a)})};c.prototype.RequestUserHiscore=function(){!this.runtime.isDomFree&&k&&FB.api("/me/scores","GET",{},function(a){q=0;var b=a.data;if(b){var c,d;c=0;for(d=b.length;c<d;c++)b[c].score>q&&(q=b[c].score);r.trigger(cr.plugins_.Facebook.prototype.cnds.OnUserTopScoreAvailable,s);a&&!a.error||console.error(a)}else console.error("Request for user hi-score failed: "+a)})};c.prototype.RequestHiscores=
function(a){!this.runtime.isDomFree&&k&&FB.api("/"+h+"/scores","GET",{},function(b){var c=b.data;if(c){c.sort(function(a,b){return b.score-a.score});for(var d=0,e=Math.min(c.length,a);d<e;d++)q=c[d].score,t=c[d].user.name,u=c[d].user.id,C=d+1,r.trigger(cr.plugins_.Facebook.prototype.cnds.OnHiscore,s);b&&!b.error||console.error(b)}else console.error("Hi-scores request failed: "+b)})};e.acts=new c;d.prototype.FullName=function(a){a.set_string(m)};d.prototype.FirstName=function(a){a.set_string(n)};d.prototype.LastName=
function(a){a.set_string(p)};d.prototype.Score=function(a){a.set_int(q)};d.prototype.HiscoreName=function(a){a.set_string(t)};d.prototype.HiscoreUserID=function(a){a.set_int(u)};d.prototype.HiscoreRank=function(a){a.set_int(C)};d.prototype.UserID=function(a){a.set_float(parseFloat(g))};e.exps=new d})();cr.plugins_.Function=function(a){this.runtime=a};
(function(){function a(){this.name="";this.retVal=0;this.params=[]}function b(){k++;k===l.length&&l.push(new a);return l[k]}function c(){return 0>k?null:l[k]}function d(){}function e(){}function h(){}var f=cr.plugins_.Function.prototype;f.Type=function(a){this.plugin=a;this.runtime=a.runtime};f.Type.prototype.onCreate=function(){};f.Instance=function(a){this.type=a;this.runtime=a.runtime};var l=[],k=-1;f.Instance.prototype.onCreate=function(){};d.prototype.OnFunction=function(a){var b=c();return b?
cr.equals_nocase(a,b.name):!1};d.prototype.CompareParam=function(a,b,d){var e=c();if(!e)return!1;a=cr.floor(a);return 0>a||a>=e.params.length?!1:cr.do_cmp(e.params[a],b,d)};f.cnds=new d;e.prototype.CallFunction=function(a,c){var d=b();d.name=a.toLowerCase();d.retVal=0;cr.shallowAssignArray(d.params,c);this.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction,this,d.name);k--};e.prototype.SetReturnValue=function(a){var b=c();b&&(b.retVal=a)};f.acts=new e;h.prototype.ReturnValue=function(a){var b;
l.length?(b=k+1,b>=l.length&&(b=l.length-1),b=l[b]):b=null;b?a.set_any(b.retVal):a.set_int(0)};h.prototype.ParamCount=function(a){var b=c();b?a.set_int(b.params.length):a.set_int(0)};h.prototype.Param=function(a,b){b=cr.floor(b);var d=c();d?0<=b&&b<d.params.length?a.set_any(d.params[b]):a.set_int(0):a.set_int(0)};h.prototype.Call=function(a,c){var d=b();d.name=c.toLowerCase();d.retVal=0;d.params.length=0;var e,f;e=2;for(f=arguments.length;e<f;e++)d.params.push(arguments[e]);this.runtime.trigger(cr.plugins_.Function.prototype.cnds.OnFunction,
this,d.name);k--;a.set_any(d.retVal)};f.exps=new h})();cr.plugins_.Keyboard=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(a){a=Math.floor(a);switch(a){case 8:return"backspace";case 9:return"tab";case 13:return"enter";case 16:return"shift";case 17:return"control";case 18:return"alt";case 19:return"pause";case 20:return"capslock";case 27:return"esc";case 33:return"pageup";case 34:return"pagedown";case 35:return"end";case 36:return"home";case 37:return"\u2190";case 38:return"\u2191";case 39:return"\u2192";case 40:return"\u2193";case 45:return"insert";case 46:return"del";
case 91:return"left window key";case 92:return"right window key";case 93:return"select";case 96:return"numpad 0";case 97:return"numpad 1";case 98:return"numpad 2";case 99:return"numpad 3";case 100:return"numpad 4";case 101:return"numpad 5";case 102:return"numpad 6";case 103:return"numpad 7";case 104:return"numpad 8";case 105:return"numpad 9";case 106:return"numpad *";case 107:return"numpad +";case 109:return"numpad -";case 110:return"numpad .";case 111:return"numpad /";case 112:return"F1";case 113:return"F2";
case 114:return"F3";case 115:return"F4";case 116:return"F5";case 117:return"F6";case 118:return"F7";case 119:return"F8";case 120:return"F9";case 121:return"F10";case 122:return"F11";case 123:return"F12";case 144:return"numlock";case 145:return"scroll lock";case 186:return";";case 187:return"=";case 188:return",";case 189:return"-";case 190:return".";case 191:return"/";case 192:return"'";case 219:return"[";case 220:return"\\";case 221:return"]";case 222:return"#";case 223:return"`";default:return String.fromCharCode(a)}}
var d=cr.plugins_.Keyboard.prototype;d.Type=function(a){this.plugin=a;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a){this.type=a;this.runtime=a.runtime;this.keyMap=Array(256);this.usedKeys=Array(256);this.triggerKey=0};var e=d.Instance.prototype;e.onCreate=function(){var a=this;this.runtime.isDomFree||(jQuery(document).keydown(function(b){a.onKeyDown(b)}),jQuery(document).keyup(function(b){a.onKeyUp(b)}))};var h=[32,33,34,35,36,37,38,39,40,44];e.onKeyDown=function(a){var b=
!1;window!=window.top&&-1<h.indexOf(a.which)&&(a.preventDefault(),b=!0,a.stopPropagation());if(this.keyMap[a.which])this.usedKeys[a.which]&&!b&&a.preventDefault();else{this.keyMap[a.which]=!0;this.triggerKey=a.which;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnAnyKey,this);var c=this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKey,this),d=this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKeyCode,this);this.runtime.isInUserInputEvent=
!1;if(c||d)this.usedKeys[a.which]=!0,b||a.preventDefault()}};e.onKeyUp=function(a){this.keyMap[a.which]=!1;this.triggerKey=a.which;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnAnyKeyReleased,this);var b=this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKeyReleased,this),c=this.runtime.trigger(cr.plugins_.Keyboard.prototype.cnds.OnKeyCodeReleased,this);this.runtime.isInUserInputEvent=!1;if(b||c||this.usedKeys[a.which])this.usedKeys[a.which]=
!0,a.preventDefault()};e.saveToJSON=function(){return{triggerKey:this.triggerKey}};e.loadFromJSON=function(a){this.triggerKey=a.triggerKey};a.prototype.IsKeyDown=function(a){return this.keyMap[a]};a.prototype.OnKey=function(a){return a===this.triggerKey};a.prototype.OnAnyKey=function(a){return!0};a.prototype.OnAnyKeyReleased=function(a){return!0};a.prototype.OnKeyReleased=function(a){return a===this.triggerKey};a.prototype.IsKeyCodeDown=function(a){a=Math.floor(a);return 0>a||a>=this.keyMap.length?
!1:this.keyMap[a]};a.prototype.OnKeyCode=function(a){return a===this.triggerKey};a.prototype.OnKeyCodeReleased=function(a){return a===this.triggerKey};d.cnds=new a;d.acts=new function(){};b.prototype.LastKeyCode=function(a){a.set_int(this.triggerKey)};b.prototype.StringFromKeyCode=function(a,b){a.set_string(c(b))};d.exps=new b})();cr.plugins_.Particles=function(a){this.runtime=a};
(function(){function a(a){this.owner=a;this.active=!1;this.angle=this.speed=this.y=this.x=0;this.opacity=1;this.age=this.gs=this.size=this.grow=0;cr.seal(this)}function b(){}function c(){}function d(){}var e=cr.plugins_.Particles.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};var h=e.Type.prototype;h.onCreate=function(){this.is_family||(this.texture_img=new Image,this.texture_img.idtkLoadDisposed=!0,this.texture_img.src=this.texture_file,this.texture_img.cr_filesize=this.texture_filesize,
this.webGL_texture=null,this.runtime.waitForImageLoad(this.texture_img))};h.onLostWebGLContext=function(){this.is_family||(this.webGL_texture=null)};h.onRestoreWebGLContext=function(){this.is_family||!this.instances.length||this.webGL_texture||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,this.texture_pixelformat))};h.loadTextures=function(){this.is_family||this.webGL_texture||!this.runtime.glwrap||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,
!0,this.runtime.linearSampling,this.texture_pixelformat))};h.unloadTextures=function(){this.is_family||this.instances.length||!this.webGL_texture||(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};h.preloadCanvas2D=function(a){a.drawImage(this.texture_img,0,0)};a.prototype.init=function(){var a=this.owner;this.x=a.x-a.xrandom/2+Math.random()*a.xrandom;this.y=a.y-a.yrandom/2+Math.random()*a.yrandom;this.speed=a.initspeed-a.speedrandom/2+Math.random()*a.speedrandom;this.angle=
a.angle-a.spraycone/2+Math.random()*a.spraycone;this.opacity=a.initopacity;this.size=a.initsize-a.sizerandom/2+Math.random()*a.sizerandom;this.grow=a.growrate-a.growrandom/2+Math.random()*a.growrandom;this.age=this.gs=0};a.prototype.tick=function(a){var b=this.owner;this.x+=Math.cos(this.angle)*this.speed*a;this.y+=Math.sin(this.angle)*this.speed*a;this.y+=this.gs*a;this.speed+=b.acc*a;this.size+=this.grow*a;this.gs+=b.g*a;this.age+=a;1>this.size?this.active=!1:(0!==b.lifeanglerandom&&(this.angle+=
Math.random()*b.lifeanglerandom*a-b.lifeanglerandom*a/2),0!==b.lifespeedrandom&&(this.speed+=Math.random()*b.lifespeedrandom*a-b.lifespeedrandom*a/2),0!==b.lifeopacityrandom&&(this.opacity+=Math.random()*b.lifeopacityrandom*a-b.lifeopacityrandom*a/2,0>this.opacity?this.opacity=0:1<this.opacity&&(this.opacity=1)),1>=b.destroymode&&this.age>=b.timeout&&(this.active=!1),2===b.destroymode&&0>=this.speed&&(this.active=!1))};a.prototype.draw=function(a){var b=this.owner.opacity*this.opacity;if(0!==b){0===
this.owner.destroymode&&(b*=1-this.age/this.owner.timeout);a.globalAlpha=b;var b=this.x-this.size/2,c=this.y-this.size/2;this.owner.runtime.pixel_rounding&&(b=b+0.5|0,c=c+0.5|0);a.drawImage(this.owner.type.texture_img,b,c,this.size,this.size)}};a.prototype.drawGL=function(a){var b=this.owner.opacity*this.opacity;0===this.owner.destroymode&&(b*=1-this.age/this.owner.timeout);var c=this.size,d=c*this.owner.particlescale,e=this.x-c/2,f=this.y-c/2;this.owner.runtime.pixel_rounding&&(e=e+0.5|0,f=f+0.5|
0);1>d||0===b||(d<a.minPointSize||d>a.maxPointSize?(a.setOpacity(b),a.quad(e,f,e+c,f,e+c,f+c,e,f+c)):a.point(this.x,this.y,d,b))};a.prototype.left=function(){return this.x-this.size/2};a.prototype.right=function(){return this.x+this.size/2};a.prototype.top=function(){return this.y-this.size/2};a.prototype.bottom=function(){return this.y+this.size/2};e.Instance=function(a){this.type=a;this.runtime=a.runtime};var h=e.Instance.prototype,f=[];h.onCreate=function(){var a=this.properties;this.rate=a[0];
this.spraycone=cr.to_radians(a[1]);this.spraytype=a[2];this.spraying=!0;this.initspeed=a[3];this.initsize=a[4];this.initopacity=a[5]/100;this.growrate=a[6];this.xrandom=a[7];this.yrandom=a[8];this.speedrandom=a[9];this.sizerandom=a[10];this.growrandom=a[11];this.acc=a[12];this.g=a[13];this.lifeanglerandom=a[14];this.lifespeedrandom=a[15];this.lifeopacityrandom=a[16];this.destroymode=a[17];this.timeout=a[18];this.particleCreateCounter=0;this.particlescale=1;this.particleBoxLeft=this.x;this.particleBoxTop=
this.y;this.particleBoxRight=this.x;this.particleBoxBottom=this.y;this.add_bbox_changed_callback(function(a){a.bbox.set(a.particleBoxLeft,a.particleBoxTop,a.particleBoxRight,a.particleBoxBottom);a.bquad.set_from_rect(a.bbox);a.bbox_changed=!1;a.update_collision_cell()});this.recycled||(this.particles=[]);this.runtime.tickMe(this);this.type.loadTextures();if(1===this.spraytype)for(a=0;a<this.rate;a++)this.allocateParticle().opacity=0;this.first_tick=!0};h.saveToJSON=function(){var a={r:this.rate,sc:this.spraycone,
st:this.spraytype,s:this.spraying,isp:this.initspeed,isz:this.initsize,io:this.initopacity,gr:this.growrate,xr:this.xrandom,yr:this.yrandom,spr:this.speedrandom,szr:this.sizerandom,grnd:this.growrandom,acc:this.acc,g:this.g,lar:this.lifeanglerandom,lsr:this.lifespeedrandom,lor:this.lifeopacityrandom,dm:this.destroymode,to:this.timeout,pcc:this.particleCreateCounter,ft:this.first_tick,p:[]},b,c,d,e=a.p;b=0;for(c=this.particles.length;b<c;b++)d=this.particles[b],e.push([d.x,d.y,d.speed,d.angle,d.opacity,
d.grow,d.size,d.gs,d.age]);return a};h.loadFromJSON=function(a){this.rate=a.r;this.spraycone=a.sc;this.spraytype=a.st;this.spraying=a.s;this.initspeed=a.isp;this.initsize=a.isz;this.initopacity=a.io;this.growrate=a.gr;this.xrandom=a.xr;this.yrandom=a.yr;this.speedrandom=a.spr;this.sizerandom=a.szr;this.growrandom=a.grnd;this.acc=a.acc;this.g=a.g;this.lifeanglerandom=a.lar;this.lifespeedrandom=a.lsr;this.lifeopacityrandom=a.lor;this.destroymode=a.dm;this.timeout=a.to;this.particleCreateCounter=a.pcc;
this.first_tick=a.ft;f.push.apply(f,this.particles);this.particles.length=0;var b,c,d,e=a.p;a=0;for(b=e.length;a<b;a++)c=this.allocateParticle(),d=e[a],c.x=d[0],c.y=d[1],c.speed=d[2],c.angle=d[3],c.opacity=d[4],c.grow=d[5],c.size=d[6],c.gs=d[7],c.age=d[8]};h.onDestroy=function(){f.push.apply(f,this.particles);this.particles.length=0};h.allocateParticle=function(){var b;f.length?(b=f.pop(),b.owner=this):b=new a(this);this.particles.push(b);b.active=!0;return b};h.tick=function(){var a=this.runtime.getDt(this),
b,c,d,e;if(0===this.spraytype&&this.spraying)for(this.particleCreateCounter+=a*this.rate,c=cr.floor(this.particleCreateCounter),this.particleCreateCounter-=c,b=0;b<c;b++)d=this.allocateParticle(),d.init();this.particleBoxLeft=this.x;this.particleBoxTop=this.y;this.particleBoxRight=this.x;this.particleBoxBottom=this.y;e=b=0;for(c=this.particles.length;b<c;b++)d=this.particles[b],this.particles[e]=d,this.runtime.redraw=!0,1===this.spraytype&&this.first_tick&&d.init(),d.tick(a),d.active?(d.left()<this.particleBoxLeft&&
(this.particleBoxLeft=d.left()),d.right()>this.particleBoxRight&&(this.particleBoxRight=d.right()),d.top()<this.particleBoxTop&&(this.particleBoxTop=d.top()),d.bottom()>this.particleBoxBottom&&(this.particleBoxBottom=d.bottom()),e++):f.push(d);this.particles.length=e;this.set_bbox_changed();this.first_tick=!1;1===this.spraytype&&0===this.particles.length&&this.runtime.DestroyInstance(this)};h.draw=function(a){var b,c,d,e=this.layer;b=0;for(c=this.particles.length;b<c;b++)d=this.particles[b],d.right()>=
e.viewLeft&&d.bottom()>=e.viewTop&&d.left()<=e.viewRight&&d.top()<=e.viewBottom&&d.draw(a)};h.drawGL=function(a){this.particlescale=this.layer.getScale();a.setTexture(this.type.webGL_texture);var b,c,d,e=this.layer;b=0;for(c=this.particles.length;b<c;b++)d=this.particles[b],d.right()>=e.viewLeft&&d.bottom()>=e.viewTop&&d.left()<=e.viewRight&&d.top()<=e.viewBottom&&d.drawGL(a)};b.prototype.IsSpraying=function(){return this.spraying};e.cnds=new b;c.prototype.SetSpraying=function(a){this.spraying=0!==
a};c.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};c.prototype.SetRate=function(a){this.rate=a;var b;if(1===this.spraytype&&this.first_tick)if(a<this.particles.length)for(a=this.particles.length-a,b=0;b<a;b++)f.push(this.particles.pop());else if(a>this.particles.length)for(a-=this.particles.length,b=0;b<a;b++)this.allocateParticle().opacity=0};c.prototype.SetSprayCone=function(a){this.spraycone=cr.to_radians(a)};
c.prototype.SetInitSpeed=function(a){this.initspeed=a};c.prototype.SetInitSize=function(a){this.initsize=a};c.prototype.SetInitOpacity=function(a){this.initopacity=a/100};c.prototype.SetGrowRate=function(a){this.growrate=a};c.prototype.SetXRandomiser=function(a){this.xrandom=a};c.prototype.SetYRandomiser=function(a){this.yrandom=a};c.prototype.SetSpeedRandomiser=function(a){this.speedrandom=a};c.prototype.SetSizeRandomiser=function(a){this.sizerandom=a};c.prototype.SetGrowRateRandomiser=function(a){this.growrandom=
a};c.prototype.SetParticleAcc=function(a){this.acc=a};c.prototype.SetGravity=function(a){this.g=a};c.prototype.SetAngleRandomiser=function(a){this.lifeanglerandom=a};c.prototype.SetSpeedRandomiser=function(a){this.lifespeedrandom=a};c.prototype.SetOpacityRandomiser=function(a){this.lifeopacityrandom=a};c.prototype.SetTimeout=function(a){this.timeout=a};e.acts=new c;d.prototype.ParticleCount=function(a){a.set_int(this.particles.length)};d.prototype.Rate=function(a){a.set_float(this.rate)};d.prototype.SprayCone=
function(a){a.set_float(cr.to_degrees(this.spraycone))};d.prototype.InitSpeed=function(a){a.set_float(this.initspeed)};d.prototype.InitSize=function(a){a.set_float(this.initsize)};d.prototype.InitOpacity=function(a){a.set_float(100*this.initopacity)};d.prototype.InitGrowRate=function(a){a.set_float(this.growrate)};d.prototype.XRandom=function(a){a.set_float(this.xrandom)};d.prototype.YRandom=function(a){a.set_float(this.yrandom)};d.prototype.InitSpeedRandom=function(a){a.set_float(this.speedrandom)};
d.prototype.InitSizeRandom=function(a){a.set_float(this.sizerandom)};d.prototype.InitGrowRandom=function(a){a.set_float(this.growrandom)};d.prototype.ParticleAcceleration=function(a){a.set_float(this.acc)};d.prototype.Gravity=function(a){a.set_float(this.g)};d.prototype.ParticleAngleRandom=function(a){a.set_float(this.lifeanglerandom)};d.prototype.ParticleSpeedRandom=function(a){a.set_float(this.lifespeedrandom)};d.prototype.ParticleOpacityRandom=function(a){a.set_float(this.lifeopacityrandom)};d.prototype.Timeout=
function(a){a.set_float(this.timeout)};e.exps=new d})();cr.plugins_.Sprite=function(a){this.runtime=a};
(function(){function a(){if(0===this.datauri.length){var a=document.createElement("canvas");a.width=this.width;a.height=this.height;var b=a.getContext("2d");this.spritesheeted?b.drawImage(this.texture_img,this.offx,this.offy,this.width,this.height,0,0,this.width,this.height):b.drawImage(this.texture_img,0,0,this.width,this.height);this.datauri=a.toDataURL("image/png")}return this.datauri}function b(){}function c(a){a[0]=0;a[1]=0;a[2]=0;s.push(a)}function d(a,b){return a<b?""+a+","+b:""+b+","+a}function e(a,
b,c,e){b=b.uid;c=c.uid;var g=d(b,c);if(a.hasOwnProperty(g))a[g][2]=e;else{var f;f=s.length?s.pop():[0,0,0];f[0]=b;f[1]=c;f[2]=e;a[g]=f}}function h(a,b,e){b=d(b.uid,e.uid);a.hasOwnProperty(b)&&(c(a[b]),delete a[b])}function f(a,b,c){b=d(b.uid,c.uid);if(a.hasOwnProperty(b))return q=a[b][2],!0;q=-2;return!1}function l(a,b,c){if(!a)return!1;var d=0!==b||0!==c,e,g,f=!1,h,k=this.runtime.getCurrentCondition(),m=k.type,k=k.inverted,l=a.getCurrentSol();h=this.runtime.getCurrentEventStack().current_event.orblock;
l.select_all?(this.update_bbox(),this.runtime.getCollisionCandidates(this.layer,a,this.bbox,G),l=G):l=h?l.else_instances:l.instances;u=a;J=m!==a&&!k;d&&(e=this.x,g=this.y,this.x+=b,this.y+=c,this.set_bbox_changed());b=0;for(c=l.length;b<c;b++)if(h=l[b],this.runtime.testOverlap(this,h)){f=!0;if(k)break;m!==a&&C.add(h)}d&&(this.x=e,this.y=g,this.set_bbox_changed());G.length=0;return f}function k(){}function g(){}var m=cr.plugins_.Sprite.prototype;m.Type=function(a){this.plugin=a;this.runtime=a.runtime};
var n=m.Type.prototype;n.onCreate=function(){if(!this.is_family){var b,c,d,e,g,f,h,k,m;this.all_frames=[];this.has_loaded_textures=!1;b=0;for(c=this.animations.length;b<c;b++){g=this.animations[b];h={};h.name=g[0];h.speed=g[1];h.loop=g[2];h.repeatcount=g[3];h.repeatto=g[4];h.pingpong=g[5];h.sid=g[6];h.frames=[];d=0;for(e=g[7].length;d<e;d++)f=g[7][d],k={},k.texture_file=f[0],k.texture_filesize=f[1],k.offx=f[2],k.offy=f[3],k.width=f[4],k.height=f[5],k.duration=f[6],k.hotspotX=f[7],k.hotspotY=f[8],
k.image_points=f[9],k.poly_pts=f[10],k.pixelformat=f[11],k.spritesheeted=0!==k.width,k.datauri="",k.getDataUri=a,m={left:0,top:0,right:1,bottom:1},k.sheetTex=m,k.webGL_texture=null,(m=this.runtime.findWaitingTexture(f[0]))?k.texture_img=m:(k.texture_img=new Image,k.texture_img.idtkLoadDisposed=!0,k.texture_img.src=f[0],k.texture_img.cr_src=f[0],k.texture_img.cr_filesize=f[1],k.texture_img.c2webGL_texture=null,this.runtime.waitForImageLoad(k.texture_img)),cr.seal(k),h.frames.push(k),this.all_frames.push(k);
cr.seal(h);this.animations[b]=h}}};n.updateAllCurrentTexture=function(){var a,b,c;a=0;for(b=this.instances.length;a<b;a++)c=this.instances[a],c.curWebGLTexture=c.curFrame.webGL_texture};n.onLostWebGLContext=function(){if(!this.is_family){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.texture_img.c2webGL_texture=null,c.webGL_texture=null}};n.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],
c.webGL_texture=this.runtime.glwrap.loadTexture(c.texture_img,!1,this.runtime.linearSampling,c.pixelformat);this.updateAllCurrentTexture()}};n.loadTextures=function(){if(!this.is_family&&!this.has_loaded_textures&&this.runtime.glwrap){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],c.webGL_texture=this.runtime.glwrap.loadTexture(c.texture_img,!1,this.runtime.linearSampling,c.pixelformat);this.has_loaded_textures=!0}};n.unloadTextures=function(){if(!this.is_family&&!this.instances.length&&
this.has_loaded_textures){var a,b,c;a=0;for(b=this.all_frames.length;a<b;++a)c=this.all_frames[a],this.runtime.glwrap.deleteTexture(c.webGL_texture),c.webGL_texture=null;this.has_loaded_textures=!1}};var p=[];n.preloadCanvas2D=function(a){var b,c,d;b=p.length=0;for(c=this.all_frames.length;b<c;++b)d=this.all_frames[b].texture_img,-1===p.indexOf(d)&&(a.drawImage(d,0,0),p.push(d))};m.Instance=function(a){this.type=a;this.runtime=a.runtime;a=this.type.animations[0].frames[0].poly_pts;this.recycled?this.collision_poly.set_pts(a):
this.collision_poly=new cr.CollisionPoly(a)};var r=m.Instance.prototype;r.onCreate=function(){this.visible=0===this.properties[0];this.inAnimTrigger=this.isTicking=!1;this.collisionsEnabled=0!==this.properties[3];1===this.type.animations.length&&1===this.type.animations[0].frames.length||0===this.type.animations[0].speed||(this.runtime.tickMe(this),this.isTicking=!0);this.cur_animation=this.getAnimationByName(this.properties[1])||this.type.animations[0];this.cur_frame=this.properties[2];0>this.cur_frame&&
(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);var a=this.cur_animation.frames[this.cur_frame];this.collision_poly.set_pts(a.poly_pts);this.hotspotX=a.hotspotX;this.hotspotY=a.hotspotY;this.cur_anim_speed=this.cur_animation.speed;this.recycled?this.animTimer.reset():this.animTimer=new cr.KahanAdder;this.frameStart=this.getNowTime();this.animPlaying=!0;this.animRepeats=0;this.animForwards=!0;this.changeAnimName=this.animTriggerName=
"";this.changeAnimFrom=0;this.changeAnimFrame=-1;this.type.loadTextures();var b,c,d,e,g,f,h,a=0;for(b=this.type.animations.length;a<b;a++)for(e=this.type.animations[a],c=0,d=e.frames.length;c<d;c++)g=e.frames[c],0===g.width&&(g.width=g.texture_img.width,g.height=g.texture_img.height),g.spritesheeted&&(h=g.texture_img,f=g.sheetTex,f.left=g.offx/h.width,f.top=g.offy/h.height,f.right=(g.offx+g.width)/h.width,f.bottom=(g.offy+g.height)/h.height,0===g.offx&&0===g.offy&&g.width===h.width&&g.height===h.height&&
(g.spritesheeted=!1));this.curFrame=this.cur_animation.frames[this.cur_frame];this.curWebGLTexture=this.curFrame.webGL_texture};r.saveToJSON=function(){var a={a:this.cur_animation.sid,f:this.cur_frame,cas:this.cur_anim_speed,fs:this.frameStart,ar:this.animRepeats,at:this.animTimer.sum};this.animPlaying||(a.ap=this.animPlaying);this.animForwards||(a.af=this.animForwards);return a};r.loadFromJSON=function(a){var b=this.getAnimationBySid(a.a);b&&(this.cur_animation=b);this.cur_frame=a.f;0>this.cur_frame&&
(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);this.cur_anim_speed=a.cas;this.frameStart=a.fs;this.animRepeats=a.ar;this.animTimer.reset();this.animTimer.sum=a.at;this.animPlaying=a.hasOwnProperty("ap")?a.ap:!0;this.animForwards=a.hasOwnProperty("af")?a.af:!0;this.curFrame=this.cur_animation.frames[this.cur_frame];this.curWebGLTexture=this.curFrame.webGL_texture;this.collision_poly.set_pts(this.curFrame.poly_pts);this.hotspotX=
this.curFrame.hotspotX;this.hotspotY=this.curFrame.hotspotY};r.animationFinish=function(a){this.cur_frame=a?0:this.cur_animation.frames.length-1;this.animPlaying=!1;this.animTriggerName=this.cur_animation.name;this.inAnimTrigger=!0;this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished,this);this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnimFinished,this);this.inAnimTrigger=!1;this.animRepeats=0};r.getNowTime=function(){return this.animTimer.sum};r.tick=function(){this.animTimer.add(this.runtime.getDt(this));
this.changeAnimName.length&&this.doChangeAnim();0<=this.changeAnimFrame&&this.doChangeAnimFrame();var a=this.getNowTime(),b=this.cur_animation,c=b.frames[this.cur_frame],d=c.duration/this.cur_anim_speed;this.animPlaying&&a>=this.frameStart+d&&(this.animForwards?this.cur_frame++:this.cur_frame--,this.frameStart+=d,this.cur_frame>=b.frames.length&&(b.pingpong?(this.animForwards=!1,this.cur_frame=b.frames.length-2):b.loop?this.cur_frame=b.repeatto:(this.animRepeats++,this.animRepeats>=b.repeatcount?
this.animationFinish(!1):this.cur_frame=b.repeatto)),0>this.cur_frame&&(b.pingpong?(this.cur_frame=1,this.animForwards=!0,b.loop||(this.animRepeats++,this.animRepeats>=b.repeatcount&&this.animationFinish(!0))):b.loop?this.cur_frame=b.repeatto:(this.animRepeats++,this.animRepeats>=b.repeatcount?this.animationFinish(!0):this.cur_frame=b.repeatto)),0>this.cur_frame?this.cur_frame=0:this.cur_frame>=b.frames.length&&(this.cur_frame=b.frames.length-1),a>this.frameStart+b.frames[this.cur_frame].duration/
this.cur_anim_speed&&(this.frameStart=a),a=b.frames[this.cur_frame],this.OnFrameChanged(c,a),this.runtime.redraw=!0)};r.getAnimationByName=function(a){var b,c,d;b=0;for(c=this.type.animations.length;b<c;b++)if(d=this.type.animations[b],cr.equals_nocase(d.name,a))return d;return null};r.getAnimationBySid=function(a){var b,c,d;b=0;for(c=this.type.animations.length;b<c;b++)if(d=this.type.animations[b],d.sid===a)return d;return null};r.doChangeAnim=function(){var a=this.cur_animation.frames[this.cur_frame],
b=this.getAnimationByName(this.changeAnimName);this.changeAnimName="";!b||cr.equals_nocase(b.name,this.cur_animation.name)&&this.animPlaying||(this.cur_animation=b,this.cur_anim_speed=b.speed,0>this.cur_frame&&(this.cur_frame=0),this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1),1===this.changeAnimFrom&&(this.cur_frame=0),this.animPlaying=!0,this.frameStart=this.getNowTime(),this.animForwards=!0,this.OnFrameChanged(a,this.cur_animation.frames[this.cur_frame]),
this.runtime.redraw=!0)};r.doChangeAnimFrame=function(){var a=this.cur_animation.frames[this.cur_frame],b=this.cur_frame;this.cur_frame=cr.floor(this.changeAnimFrame);0>this.cur_frame&&(this.cur_frame=0);this.cur_frame>=this.cur_animation.frames.length&&(this.cur_frame=this.cur_animation.frames.length-1);b!==this.cur_frame&&(this.OnFrameChanged(a,this.cur_animation.frames[this.cur_frame]),this.frameStart=this.getNowTime(),this.runtime.redraw=!0);this.changeAnimFrame=-1};r.OnFrameChanged=function(a,
b){var c=a.width,d=a.height,e=b.width,g=b.height;c!=e&&(this.width*=e/c);d!=g&&(this.height*=g/d);this.hotspotX=b.hotspotX;this.hotspotY=b.hotspotY;this.collision_poly.set_pts(b.poly_pts);this.set_bbox_changed();this.curFrame=b;this.curWebGLTexture=b.webGL_texture;c=0;for(d=this.behavior_insts.length;c<d;c++)if(e=this.behavior_insts[c],e.onSpriteFrameChanged)e.onSpriteFrameChanged(a,b);this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnFrameChanged,this)};r.draw=function(a){a.globalAlpha=this.opacity;
var b=this.curFrame,c=b.spritesheeted,d=b.texture_img,e=this.x,g=this.y,f=this.width,h=this.height;if(0===this.angle&&0<=f&&0<=h)e-=this.hotspotX*f,g-=this.hotspotY*h,this.runtime.pixel_rounding&&(e=e+0.5|0,g=g+0.5|0),c?a.drawImage(d,b.offx,b.offy,b.width,b.height,e,g,f,h):a.drawImage(d,e,g,f,h);else{this.runtime.pixel_rounding&&(e=e+0.5|0,g=g+0.5|0);a.save();var k=0<f?1:-1,m=0<h?1:-1;a.translate(e,g);1===k&&1===m||a.scale(k,m);a.rotate(this.angle*k*m);e=0-this.hotspotX*cr.abs(f);g=0-this.hotspotY*
cr.abs(h);c?a.drawImage(d,b.offx,b.offy,b.width,b.height,e,g,cr.abs(f),cr.abs(h)):a.drawImage(d,e,g,cr.abs(f),cr.abs(h));a.restore()}};r.drawGL=function(a){a.setTexture(this.curWebGLTexture);a.setOpacity(this.opacity);var b=this.curFrame,c=this.bquad;if(this.runtime.pixel_rounding){var d=(this.x+0.5|0)-this.x,e=(this.y+0.5|0)-this.y;b.spritesheeted?a.quadTex(c.tlx+d,c.tly+e,c.trx+d,c.try_+e,c.brx+d,c.bry+e,c.blx+d,c.bly+e,b.sheetTex):a.quad(c.tlx+d,c.tly+e,c.trx+d,c.try_+e,c.brx+d,c.bry+e,c.blx+d,
c.bly+e)}else b.spritesheeted?a.quadTex(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly,b.sheetTex):a.quad(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly)};r.getImagePointIndexByName=function(a){var b=this.curFrame,c,d;c=0;for(d=b.image_points.length;c<d;c++)if(cr.equals_nocase(a,b.image_points[c][0]))return c;return-1};r.getImagePoint=function(a,b){var c=this.curFrame,d=c.image_points,e;e=cr.is_string(a)?this.getImagePointIndexByName(a):a-1;e=cr.floor(e);if(0>e||e>=d.length)return b?this.x:this.y;
var g=(d[e][1]-c.hotspotX)*this.width,d=d[e][2],d=(d-c.hotspotY)*this.height,c=Math.cos(this.angle);e=Math.sin(this.angle);var f=g*c-d*e,d=d*c+g*e,g=f+this.x,d=d+this.y;return b?g:d};var s=[],q=-2,t=[];b.prototype.OnCollision=function(a){if(!a)return!1;var b=this.runtime,d=b.getCurrentCondition(),g=d.type;d.extra.collmemory||(d.extra.collmemory={},b.addDestroyCallback(function(a){return function(b){b=b.uid;var d,e;for(d in a)a.hasOwnProperty(d)&&(e=a[d],e[0]===b||e[1]===b)&&(c(a[d]),delete a[d])}}(d.extra.collmemory)));
var d=d.extra.collmemory,k=g.getCurrentSol(),m=a.getCurrentSol(),k=k.getObjects(),l,s,n,r,p,u,C,G=this.runtime.tickcount,J=G-1,B=b.getCurrentEventStack().current_event;for(s=0;s<k.length;s++){n=k[s];m.select_all?(n.update_bbox(),this.runtime.getCollisionCandidates(n.layer,a,n.bbox,t),l=t):l=m.getObjects();for(r=0;r<l.length;r++)p=l[r],b.testOverlap(n,p)||b.checkRegisteredCollision(n,p)?(u=f(d,n,p),u=!u||q<J,e(d,n,p,G),u&&(b.pushCopySol(B.solModifiers),u=g.getCurrentSol(),C=a.getCurrentSol(),u.select_all=
!1,C.select_all=!1,g===a?(u.instances.length=2,u.instances[0]=n,u.instances[1]=p,g.applySolToContainer()):(u.instances.length=1,C.instances.length=1,u.instances[0]=n,C.instances[0]=p,g.applySolToContainer(),a.applySolToContainer()),B.retrigger(),b.popSol(B.solModifiers))):h(d,n,p);t.length=0}return!1};var u=null,C=new cr.ObjectSet,J=!1,G=[];n.finish=function(a){if(J){if(a){var b=this.runtime.getCurrentEventStack().current_event.orblock;a=u.getCurrentSol();var c=C.valuesRef(),d,e;if(a.select_all){a.select_all=
!1;a.instances.length=c.length;d=0;for(e=c.length;d<e;d++)a.instances[d]=c[d];if(b)for(d=a.else_instances.length=0,e=u.instances.length;d<e;d++)c=u.instances[d],C.contains(c)||a.else_instances.push(c)}else if(b)for(b=a.instances.length,a.instances.length=b+c.length,d=0,e=c.length;d<e;d++)a.instances[b+d]=c[d],cr.arrayFindRemove(a.else_instances,c[d]);else cr.shallowAssignArray(a.instances,c);u.applySolToContainer()}C.clear();J=!1}};b.prototype.IsOverlapping=function(a){return l.call(this,a,0,0)};
b.prototype.IsOverlappingOffset=function(a,b,c){return l.call(this,a,b,c)};b.prototype.IsAnimPlaying=function(a){return this.changeAnimName.length?cr.equals_nocase(this.changeAnimName,a):cr.equals_nocase(this.cur_animation.name,a)};b.prototype.CompareFrame=function(a,b){return cr.do_cmp(this.cur_frame,a,b)};b.prototype.CompareAnimSpeed=function(a,b){return cr.do_cmp(this.animForwards?this.cur_anim_speed:-this.cur_anim_speed,a,b)};b.prototype.OnAnimFinished=function(a){return cr.equals_nocase(this.animTriggerName,
a)};b.prototype.OnAnyAnimFinished=function(){return!0};b.prototype.OnFrameChanged=function(){return!0};b.prototype.IsMirrored=function(){return 0>this.width};b.prototype.IsFlipped=function(){return 0>this.height};b.prototype.OnURLLoaded=function(){return!0};b.prototype.IsCollisionEnabled=function(){return this.collisionsEnabled};m.cnds=new b;k.prototype.Spawn=function(a,b,c){if(a&&b&&(b=this.runtime.createInstance(a,b,this.getImagePoint(c,!0),this.getImagePoint(c,!1)))){"undefined"!==typeof b.angle&&
(b.angle=this.angle,b.set_bbox_changed());this.runtime.isInOnDestroy++;var d,e,g;this.runtime.trigger(Object.getPrototypeOf(a.plugin).cnds.OnCreated,b);if(b.is_contained)for(d=0,e=b.siblings.length;d<e;d++)g=b.siblings[d],this.runtime.trigger(Object.getPrototypeOf(g.type.plugin).cnds.OnCreated,g);this.runtime.isInOnDestroy--;d=this.runtime.getCurrentAction();c=!1;if(cr.is_undefined(d.extra.Spawn_LastExec)||d.extra.Spawn_LastExec<this.runtime.execcount)c=!0,d.extra.Spawn_LastExec=this.runtime.execcount;
if(a!=this.type&&(a=a.getCurrentSol(),a.select_all=!1,c?(a.instances.length=1,a.instances[0]=b):a.instances.push(b),b.is_contained))for(d=0,e=b.siblings.length;d<e;d++)g=b.siblings[d],a=g.type.getCurrentSol(),a.select_all=!1,c?(a.instances.length=1,a.instances[0]=g):a.instances.push(g)}};k.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};k.prototype.StopAnim=function(){this.animPlaying=!1};k.prototype.StartAnim=
function(a){this.animPlaying=!0;this.frameStart=this.getNowTime();1===a&&0!==this.cur_frame&&(this.changeAnimFrame=0,this.inAnimTrigger||this.doChangeAnimFrame());this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0)};k.prototype.SetAnim=function(a,b){this.changeAnimName=a;this.changeAnimFrom=b;this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0);this.inAnimTrigger||this.doChangeAnim()};k.prototype.SetAnimFrame=function(a){this.changeAnimFrame=a;this.isTicking||(this.runtime.tickMe(this),
this.isTicking=!0);this.inAnimTrigger||this.doChangeAnimFrame()};k.prototype.SetAnimSpeed=function(a){this.cur_anim_speed=cr.abs(a);this.animForwards=0<=a;this.isTicking||(this.runtime.tickMe(this),this.isTicking=!0)};k.prototype.SetMirrored=function(a){a=cr.abs(this.width)*(0===a?-1:1);this.width!==a&&(this.width=a,this.set_bbox_changed())};k.prototype.SetFlipped=function(a){a=cr.abs(this.height)*(0===a?-1:1);this.height!==a&&(this.height=a,this.set_bbox_changed())};k.prototype.SetScale=function(a){var b=
this.curFrame,c=b.width*a*(0>this.width?-1:1);a=b.height*a*(0>this.height?-1:1);if(this.width!==c||this.height!==a)this.width=c,this.height=a,this.set_bbox_changed()};k.prototype.LoadURL=function(a,b){var c=new Image,d=this,e=this.curFrame;c.onload=function(){e.texture_img.src===c.src?d.runtime.glwrap&&d.curFrame===e&&(d.curWebGLTexture=e.webGL_texture):(e.texture_img=c,e.offx=0,e.offy=0,e.width=c.width,e.height=c.height,e.spritesheeted=!1,e.datauri="",d.runtime.glwrap&&(e.webGL_texture&&d.runtime.glwrap.deleteTexture(e.webGL_texture),
e.webGL_texture=d.runtime.glwrap.loadTexture(c,!1,d.runtime.linearSampling),d.curFrame===e&&(d.curWebGLTexture=e.webGL_texture),d.type.updateAllCurrentTexture()),0===b&&(d.width=c.width,d.height=c.height,d.set_bbox_changed()));d.runtime.redraw=!0;d.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded,d)};"data:"!==a.substr(0,5)&&(c.crossOrigin="anonymous");c.src=a};k.prototype.SetCollisions=function(a){this.collisionsEnabled!==(0!==a)&&((this.collisionsEnabled=0!==a)?this.set_bbox_changed():
(this.collcells.right>=this.collcells.left&&this.type.collision_grid.update(this,this.collcells,null),this.collcells.set(0,0,-1,-1)))};m.acts=new k;g.prototype.AnimationFrame=function(a){a.set_int(this.cur_frame)};g.prototype.AnimationFrameCount=function(a){a.set_int(this.cur_animation.frames.length)};g.prototype.AnimationName=function(a){a.set_string(this.cur_animation.name)};g.prototype.AnimationSpeed=function(a){a.set_float(this.animForwards?this.cur_anim_speed:-this.cur_anim_speed)};g.prototype.ImagePointX=
function(a,b){a.set_float(this.getImagePoint(b,!0))};g.prototype.ImagePointY=function(a,b){a.set_float(this.getImagePoint(b,!1))};g.prototype.ImagePointCount=function(a){a.set_int(this.curFrame.image_points.length)};g.prototype.ImageWidth=function(a){a.set_float(this.curFrame.width)};g.prototype.ImageHeight=function(a){a.set_float(this.curFrame.height)};m.exps=new g})();cr.plugins_.Text=function(a){this.runtime=a};
(function(){function a(){return g.length?g.pop():{}}function b(a){var b,c;b=0;for(c=a.length;b<c;b++)g.push(a[b]);a.length=0}function c(){}function d(){}function e(){}var h=cr.plugins_.Text.prototype;h.onCreate=function(){h.acts.SetWidth=function(a){this.width!==a&&(this.width=a,this.text_changed=!0,this.set_bbox_changed())}};h.Type=function(a){this.plugin=a;this.runtime=a.runtime};var f=h.Type.prototype;f.onCreate=function(){};f.onLostWebGLContext=function(){if(!this.is_family){var a,b,c;a=0;for(b=
this.instances.length;a<b;a++)c=this.instances[a],c.mycanvas=null,c.myctx=null,c.mytex=null}};h.Instance=function(a){this.type=a;this.runtime=a.runtime;this.recycled?this.lines.length=0:this.lines=[];this.text_changed=!0};var f=h.Instance.prototype,l={};f.onCreate=function(){this.text=this.properties[0];this.visible=0===this.properties[1];this.font=this.properties[2];this.color=this.properties[3];this.halign=this.properties[4];this.valign=this.properties[5];this.wrapbyword=0===this.properties[7];
this.lastwrapwidth=this.lastwidth=this.width;this.lastheight=this.height;this.line_height_offset=this.properties[8];this.fontstyle=this.facename="";this.textHeight=this.textWidth=this.ptSize=0;this.parseFont();this.mytex=this.myctx=this.mycanvas=null;this.need_text_redraw=!1;this.last_render_tick=this.runtime.tickcount;this.recycled?this.rcTex.set(0,0,1,1):this.rcTex=new cr.rect(0,0,1,1);this.runtime.glwrap&&this.runtime.tickMe(this)};f.parseFont=function(){var a=this.font.split(" "),b;for(b=0;b<
a.length;b++)if("pt"===a[b].substr(a[b].length-2,2)){this.ptSize=parseInt(a[b].substr(0,a[b].length-2));this.pxHeight=Math.ceil(this.ptSize/72*96)+4;0<b&&(this.fontstyle=a[b-1]);this.facename=a[b+1];for(b+=2;b<a.length;b++)this.facename+=" "+a[b];break}};f.saveToJSON=function(){return{t:this.text,f:this.font,c:this.color,ha:this.halign,va:this.valign,wr:this.wrapbyword,lho:this.line_height_offset,fn:this.facename,fs:this.fontstyle,ps:this.ptSize,pxh:this.pxHeight,tw:this.textWidth,th:this.textHeight,
lrt:this.last_render_tick}};f.loadFromJSON=function(a){this.text=a.t;this.font=a.f;this.color=a.c;this.halign=a.ha;this.valign=a.va;this.wrapbyword=a.wr;this.line_height_offset=a.lho;this.facename=a.fn;this.fontstyle=a.fs;this.ptSize=a.ps;this.pxHeight=a.pxh;this.textWidth=a.tw;this.textHeight=a.th;this.last_render_tick=a.lrt;this.text_changed=!0;this.lastwrapwidth=this.lastwidth=this.width;this.lastheight=this.height};f.tick=function(){if(this.runtime.glwrap&&this.mytex&&300<=this.runtime.tickcount-
this.last_render_tick){var a=this.layer;this.update_bbox();var b=this.bbox;if(b.right<a.viewLeft||b.bottom<a.viewTop||b.left>a.viewRight||b.top>a.viewBottom)this.runtime.glwrap.deleteTexture(this.mytex),this.mycanvas=this.myctx=this.mytex=null}};f.onDestroy=function(){this.mycanvas=this.myctx=null;this.runtime.glwrap&&this.mytex&&this.runtime.glwrap.deleteTexture(this.mytex);this.mytex=null};f.updateFont=function(){this.font=this.fontstyle+" "+this.ptSize.toString()+"pt "+this.facename;this.text_changed=
!0;this.runtime.redraw=!0};f.draw=function(a,b){a.font=this.font;a.textBaseline="top";a.fillStyle=this.color;a.globalAlpha=b?1:this.opacity;var c=1;b&&(c=this.layer.getScale(),a.save(),a.scale(c,c));if(this.text_changed||this.width!==this.lastwrapwidth)this.type.plugin.WordWrap(this.text,this.lines,a,this.width,this.wrapbyword),this.text_changed=!1,this.lastwrapwidth=this.width;this.update_bbox();var c=b?0:this.bquad.tlx,d=b?0:this.bquad.tly;this.runtime.pixel_rounding&&(c=c+0.5|0,d=d+0.5|0);0===
this.angle||b||(a.save(),a.translate(c,d),a.rotate(this.angle),d=c=0);var e=d+this.height,g=this.pxHeight,g=g+this.line_height_offset,f,h;1===this.valign?d+=Math.max(this.height/2-this.lines.length*g/2,0):2===this.valign&&(d+=Math.max(this.height-this.lines.length*g-2,0));for(h=0;h<this.lines.length&&!(f=c,1===this.halign?f=c+(this.width-this.lines[h].width)/2:2===this.halign&&(f=c+(this.width-this.lines[h].width)),a.fillText(this.lines[h].text,f,d),d+=g,d>=e-g);h++);(0!==this.angle||b)&&a.restore();
this.last_render_tick=this.runtime.tickcount};f.drawGL=function(a){if(!(1>this.width||1>this.height)){var b=this.text_changed||this.need_text_redraw;this.need_text_redraw=!1;var c=this.layer.getScale(),d=this.layer.getAngle(),e=this.rcTex,g=c*this.width,f=c*this.height,h=Math.ceil(g),k=Math.ceil(f),l=this.runtime.draw_width/2,G=this.runtime.draw_height/2;this.myctx||(this.mycanvas=document.createElement("canvas"),this.mycanvas.width=h,this.mycanvas.height=k,this.lastwidth=h,this.lastheight=k,b=!0,
this.myctx=this.mycanvas.getContext("2d"));if(h!==this.lastwidth||k!==this.lastheight)this.mycanvas.width=h,this.mycanvas.height=k,this.mytex&&(a.deleteTexture(this.mytex),this.mytex=null),b=!0;b&&(this.myctx.clearRect(0,0,h,k),this.draw(this.myctx,!0),this.mytex||(this.mytex=a.createEmptyTexture(h,k,this.runtime.linearSampling,this.runtime.isMobile)),a.videoToTexture(this.mycanvas,this.mytex,this.runtime.isMobile));this.lastwidth=h;this.lastheight=k;a.setTexture(this.mytex);a.setOpacity(this.opacity);
a.resetModelView();a.translate(-l,-G);a.updateModelView();var A=this.bquad,v=this.runtime.devicePixelRatio;this.runtime.devicePixelRatio=1;var b=this.layer.layerToCanvas(A.tlx,A.tly,!0,!0),l=this.layer.layerToCanvas(A.tlx,A.tly,!1,!0),G=this.layer.layerToCanvas(A.trx,A.try_,!0,!0),w=this.layer.layerToCanvas(A.trx,A.try_,!1,!0),x=this.layer.layerToCanvas(A.brx,A.bry,!0,!0),y=this.layer.layerToCanvas(A.brx,A.bry,!1,!0),D=this.layer.layerToCanvas(A.blx,A.bly,!0,!0),A=this.layer.layerToCanvas(A.blx,A.bly,
!1,!0);this.runtime.devicePixelRatio=v;if(this.runtime.pixel_rounding||0===this.angle&&0===d)var v=(b+0.5|0)-b,z=(l+0.5|0)-l,b=b+v,l=l+z,G=G+v,w=w+z,x=x+v,y=y+z,D=D+v,A=A+z;0===this.angle&&0===d?(G=b+h,w=l,x=G,y=l+k,D=b,A=y,e.right=1,e.bottom=1):(e.right=g/h,e.bottom=f/k);a.quadTex(b,l,G,w,x,y,D,A,e);a.resetModelView();a.scale(c,c);a.rotateZ(-this.layer.getAngle());a.translate((this.layer.viewLeft+this.layer.viewRight)/-2,(this.layer.viewTop+this.layer.viewBottom)/-2);a.updateModelView();this.last_render_tick=
this.runtime.tickcount}};var k=[];h.TokeniseWords=function(a){k.length=0;for(var b="",c,d=0;d<a.length;)if(c=a.charAt(d),"\n"===c)b.length&&(k.push(b),b=""),k.push("\n"),++d;else if(" "===c||"\t"===c||"-"===c){do b+=a.charAt(d),d++;while(d<a.length&&(" "===a.charAt(d)||"\t"===a.charAt(d)));k.push(b);b=""}else d<a.length&&(b+=c,d++);b.length&&k.push(b)};var g=[];h.WordWrap=function(c,d,e,g,f){if(c&&c.length)if(2>=g)b(d);else{if(100>=c.length&&-1===c.indexOf("\n")){var h=e.measureText(c).width;if(h<=
g){b(d);d.push(a());d[0].text=c;d[0].width=h;return}}this.WrapText(c,d,e,g,f)}else b(d)};h.WrapText=function(b,c,d,e,f){f&&(this.TokeniseWords(b),b=k);var h="",l,u,C,J=0;for(C=0;C<b.length;C++)"\n"===b[C]?(J>=c.length&&c.push(a()),u=c[J],u.text=h,u.width=d.measureText(h).width,J++,h=""):(l=h,h+=b[C],u=d.measureText(h).width,u>=e&&(J>=c.length&&c.push(a()),u=c[J],u.text=l,u.width=d.measureText(l).width,J++,h=b[C],f||" "!==h||(h="")));h.length&&(J>=c.length&&c.push(a()),u=c[J],u.text=h,u.width=d.measureText(h).width,
J++);for(C=J;C<c.length;C++)g.push(c[C]);c.length=J};c.prototype.CompareText=function(a,b){return b?this.text==a:cr.equals_nocase(this.text,a)};h.cnds=new c;d.prototype.SetText=function(a){cr.is_number(a)&&1E9>a&&(a=Math.round(1E10*a)/1E10);a=a.toString();this.text!==a&&(this.text=a,this.text_changed=!0,this.runtime.redraw=!0)};d.prototype.AppendText=function(a){cr.is_number(a)&&(a=Math.round(1E10*a)/1E10);if(a=a.toString())this.text+=a,this.text_changed=!0,this.runtime.redraw=!0};d.prototype.SetFontFace=
function(a,b){var c="";switch(b){case 1:c="bold";break;case 2:c="italic";break;case 3:c="bold italic"}if(a!==this.facename||c!==this.fontstyle)this.facename=a,this.fontstyle=c,this.updateFont()};d.prototype.SetFontSize=function(a){this.ptSize!==a&&(this.ptSize=a,this.pxHeight=Math.ceil(this.ptSize/72*96)+4,this.updateFont())};d.prototype.SetFontColor=function(a){a="rgb("+cr.GetRValue(a).toString()+","+cr.GetGValue(a).toString()+","+cr.GetBValue(a).toString()+")";a!==this.color&&(this.color=a,this.need_text_redraw=
!0,this.runtime.redraw=!0)};d.prototype.SetWebFont=function(a,b){if(this.runtime.isDomFree)cr.logexport("[Construct 2] Text plugin: 'Set web font' not supported on this platform - the action has been ignored");else{var c=this,d=function(){c.runtime.redraw=!0;c.text_changed=!0};if(l.hasOwnProperty(b)){var e="'"+a+"'";if(this.facename!==e)for(this.facename=e,this.updateFont(),e=1;10>e;e++)setTimeout(d,100*e),setTimeout(d,1E3*e)}else for(e=document.createElement("link"),e.href=b,e.rel="stylesheet",e.type=
"text/css",e.onload=d,document.getElementsByTagName("head")[0].appendChild(e),l[b]=!0,this.facename="'"+a+"'",this.updateFont(),e=1;10>e;e++)setTimeout(d,100*e),setTimeout(d,1E3*e)}};d.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);this.runtime.redraw=!0};h.acts=new d;e.prototype.Text=function(a){a.set_string(this.text)};e.prototype.FaceName=function(a){a.set_string(this.facename)};e.prototype.FaceSize=function(a){a.set_int(this.ptSize)};
e.prototype.TextWidth=function(a){var b=0,c,d,e;c=0;for(d=this.lines.length;c<d;c++)e=this.lines[c].width,b<e&&(b=e);a.set_int(b)};e.prototype.TextHeight=function(a){a.set_int(this.lines.length*(this.pxHeight+this.line_height_offset)-this.line_height_offset)};h.exps=new e})();cr.plugins_.TiledBg=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.plugins_.TiledBg.prototype;d.Type=function(a){this.plugin=a;this.runtime=a.runtime};var e=d.Type.prototype;e.onCreate=function(){this.is_family||(this.texture_img=new Image,this.texture_img.idtkLoadDisposed=!0,this.texture_img.src=this.texture_file,this.texture_img.cr_filesize=this.texture_filesize,this.runtime.waitForImageLoad(this.texture_img),this.webGL_texture=this.pattern=null)};e.onLostWebGLContext=function(){this.is_family||(this.webGL_texture=
null)};e.onRestoreWebGLContext=function(){if(!this.is_family&&this.instances.length){this.webGL_texture||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,this.texture_pixelformat));var a,b;a=0;for(b=this.instances.length;a<b;a++)this.instances[a].webGL_texture=this.webGL_texture}};e.loadTextures=function(){this.is_family||this.webGL_texture||!this.runtime.glwrap||(this.webGL_texture=this.runtime.glwrap.loadTexture(this.texture_img,!0,this.runtime.linearSampling,
this.texture_pixelformat))};e.unloadTextures=function(){this.is_family||this.instances.length||!this.webGL_texture||(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};e.preloadCanvas2D=function(a){a.drawImage(this.texture_img,0,0)};d.Instance=function(a){this.type=a;this.runtime=a.runtime};e=d.Instance.prototype;e.onCreate=function(){this.visible=0===this.properties[0];this.rcTex=new cr.rect(0,0,0,0);this.has_own_texture=!1;this.texture_img=this.type.texture_img;this.runtime.glwrap?
(this.type.loadTextures(),this.webGL_texture=this.type.webGL_texture):(this.type.pattern||(this.type.pattern=this.runtime.ctx.createPattern(this.type.texture_img,"repeat")),this.pattern=this.type.pattern)};e.afterLoad=function(){this.has_own_texture=!1;this.texture_img=this.type.texture_img};e.onDestroy=function(){this.runtime.glwrap&&this.has_own_texture&&this.webGL_texture&&(this.runtime.glwrap.deleteTexture(this.webGL_texture),this.webGL_texture=null)};e.draw=function(a){a.globalAlpha=this.opacity;
a.save();a.fillStyle=this.pattern;var b=this.x,c=this.y;this.runtime.pixel_rounding&&(b=b+0.5|0,c=c+0.5|0);var d=-(this.hotspotX*this.width),e=-(this.hotspotY*this.height),m=d%this.texture_img.width,n=e%this.texture_img.height;0>m&&(m+=this.texture_img.width);0>n&&(n+=this.texture_img.height);a.translate(b,c);a.rotate(this.angle);a.translate(m,n);a.fillRect(d-m,e-n,this.width,this.height);a.restore()};e.drawGL=function(a){a.setTexture(this.webGL_texture);a.setOpacity(this.opacity);var b=this.rcTex;
b.right=this.width/this.texture_img.width;b.bottom=this.height/this.texture_img.height;var c=this.bquad;if(this.runtime.pixel_rounding){var d=(this.x+0.5|0)-this.x,e=(this.y+0.5|0)-this.y;a.quadTex(c.tlx+d,c.tly+e,c.trx+d,c.try_+e,c.brx+d,c.bry+e,c.blx+d,c.bly+e,b)}else a.quadTex(c.tlx,c.tly,c.trx,c.try_,c.brx,c.bry,c.blx,c.bly,b)};a.prototype.OnURLLoaded=function(){return!0};d.cnds=new a;b.prototype.SetEffect=function(a){this.compositeOp=cr.effectToCompositeOp(a);cr.setGLBlend(this,a,this.runtime.gl);
this.runtime.redraw=!0};b.prototype.LoadURL=function(a){var b=new Image,c=this;b.onload=function(){c.texture_img=b;c.runtime.glwrap?(c.has_own_texture&&c.webGL_texture&&c.runtime.glwrap.deleteTexture(c.webGL_texture),c.webGL_texture=c.runtime.glwrap.loadTexture(b,!0,c.runtime.linearSampling)):c.pattern=c.runtime.ctx.createPattern(b,"repeat");c.has_own_texture=!0;c.runtime.redraw=!0;c.runtime.trigger(cr.plugins_.TiledBg.prototype.cnds.OnURLLoaded,c)};"data:"!==a.substr(0,5)&&(b.crossOrigin="anonymous");
b.src=a};d.acts=new b;c.prototype.ImageWidth=function(a){a.set_float(this.texture_img.width)};c.prototype.ImageHeight=function(a){a.set_float(this.texture_img.height)};d.exps=new c})();cr.plugins_.Touch=function(a){this.runtime=a};
(function(){function a(a){l=a.x;k=a.y;g=a.z}function b(a){m=a.x;n=a.y;p=a.z}function c(){}function d(){}var e=cr.plugins_.Touch.prototype;e.Type=function(a){this.plugin=a;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a){this.type=a;this.runtime=a.runtime;this.touches=[];this.mouseDown=!1};var h=e.Instance.prototype,f={left:0,top:0};h.findTouch=function(a){var b,c;b=0;for(c=this.touches.length;b<c;b++)if(this.touches[b].id===a)return b;return-1};var l=0,k=0,g=0,
m=0,n=0,p=0;h.onCreate=function(){this.isWindows8=!("undefined"===typeof window.c2isWindows8||!window.c2isWindows8);this.trigger_id=this.trigger_index=this.curTouchY=this.curTouchX=this.acc_z=this.acc_y=this.acc_x=this.acc_g_z=this.acc_g_y=this.acc_g_x=this.orient_gamma=this.orient_beta=this.orient_alpha=0;this.useMouseInput=0!==this.properties[0];var c=0<this.runtime.fullscreen_mode?document:this.runtime.canvas,d=document;this.runtime.isDirectCanvas?d=c=window.Canvas:this.runtime.isCocoonJs&&(d=
c=window);var e=this;window.navigator.pointerEnabled?(c.addEventListener("pointerdown",function(a){e.onPointerStart(a)},!1),c.addEventListener("pointermove",function(a){e.onPointerMove(a)},!1),d.addEventListener("pointerup",function(a){e.onPointerEnd(a)},!1),d.addEventListener("pointercancel",function(a){e.onPointerEnd(a)},!1),this.runtime.canvas&&(this.runtime.canvas.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1),document.addEventListener("MSGestureHold",function(a){a.preventDefault()},
!1),this.runtime.canvas.addEventListener("gesturehold",function(a){a.preventDefault()},!1),document.addEventListener("gesturehold",function(a){a.preventDefault()},!1))):window.navigator.msPointerEnabled?(c.addEventListener("MSPointerDown",function(a){e.onPointerStart(a)},!1),c.addEventListener("MSPointerMove",function(a){e.onPointerMove(a)},!1),d.addEventListener("MSPointerUp",function(a){e.onPointerEnd(a)},!1),d.addEventListener("MSPointerCancel",function(a){e.onPointerEnd(a)},!1),this.runtime.canvas&&
(this.runtime.canvas.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1),document.addEventListener("MSGestureHold",function(a){a.preventDefault()},!1))):(c.addEventListener("touchstart",function(a){e.onTouchStart(a)},!1),c.addEventListener("touchmove",function(a){e.onTouchMove(a)},!1),d.addEventListener("touchend",function(a){e.onTouchEnd(a)},!1),d.addEventListener("touchcancel",function(a){e.onTouchEnd(a)},!1));if(this.isWindows8){var g=function(a){a=a.reading;e.acc_x=a.accelerationX;
e.acc_y=a.accelerationY;e.acc_z=a.accelerationZ},f=function(a){a=a.reading;e.orient_alpha=a.yawDegrees;e.orient_beta=a.pitchDegrees;e.orient_gamma=a.rollDegrees},h=Windows.Devices.Sensors.Accelerometer.getDefault();h&&(h.reportInterval=Math.max(h.minimumReportInterval,16),h.addEventListener("readingchanged",g));var k=Windows.Devices.Sensors.Inclinometer.getDefault();k&&(k.reportInterval=Math.max(k.minimumReportInterval,16),k.addEventListener("readingchanged",f));document.addEventListener("visibilitychange",
function(a){document.hidden||document.msHidden?(h&&h.removeEventListener("readingchanged",g),k&&k.removeEventListener("readingchanged",f)):(h&&h.addEventListener("readingchanged",g),k&&k.addEventListener("readingchanged",f))},!1)}else window.addEventListener("deviceorientation",function(a){e.orient_alpha=a.alpha||0;e.orient_beta=a.beta||0;e.orient_gamma=a.gamma||0},!1),window.addEventListener("devicemotion",function(a){a.accelerationIncludingGravity&&(e.acc_g_x=a.accelerationIncludingGravity.x||0,
e.acc_g_y=a.accelerationIncludingGravity.y||0,e.acc_g_z=a.accelerationIncludingGravity.z||0);a.acceleration&&(e.acc_x=a.acceleration.x||0,e.acc_y=a.acceleration.y||0,e.acc_z=a.acceleration.z||0)},!1);this.useMouseInput&&!this.runtime.isDomFree&&(jQuery(document).mousemove(function(a){e.onMouseMove(a)}),jQuery(document).mousedown(function(a){e.onMouseDown(a)}),jQuery(document).mouseup(function(a){e.onMouseUp(a)}));this.runtime.isAppMobi&&!this.runtime.isDirectCanvas&&AppMobi.accelerometer.watchAcceleration(a,
{frequency:40,adjustForRotation:!0});this.runtime.isPhoneGap&&navigator.accelerometer&&navigator.accelerometer.watchAcceleration&&navigator.accelerometer.watchAcceleration(b,null,{frequency:40});this.runtime.tick2Me(this)};h.onPointerMove=function(a){if(a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType){a.preventDefault&&a.preventDefault();var b=this.findTouch(a.pointerId),c=cr.performance_now();if(0<=b){var d=this.runtime.isDomFree?f:jQuery(this.runtime.canvas).offset(),b=this.touches[b];
2>c-b.time||(b.lasttime=b.time,b.lastx=b.x,b.lasty=b.y,b.time=c,b.x=a.pageX-d.left,b.y=a.pageY-d.top)}}};h.onPointerStart=function(a){if(a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType){a.preventDefault&&a.preventDefault();var b=this.runtime.isDomFree?f:jQuery(this.runtime.canvas).offset(),c=a.pageX-b.left,b=a.pageY-b.top,d=cr.performance_now();this.trigger_index=this.touches.length;this.trigger_id=a.pointerId;this.touches.push({time:d,x:c,y:b,lasttime:d,lastx:c,lasty:b,id:a.pointerId,
startindex:this.trigger_index});this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart,this);this.curTouchX=c;this.curTouchY=b;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject,this);this.runtime.isInUserInputEvent=!1}};h.onPointerEnd=function(a){a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),a=this.findTouch(a.pointerId),
this.trigger_index=0<=a?this.touches[a].startindex:-1,this.trigger_id=0<=a?this.touches[a].id:-1,this.runtime.isInUserInputEvent=!0,this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,this),this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd,this),this.runtime.isInUserInputEvent=!1,0<=a&&this.touches.splice(a,1))};h.onTouchMove=function(a){a.preventDefault&&a.preventDefault();var b=cr.performance_now(),c,d,e,g;c=0;for(d=a.changedTouches.length;c<d;c++)if(e=a.changedTouches[c],
g=this.findTouch(e.identifier),0<=g){var h=this.runtime.isDomFree?f:jQuery(this.runtime.canvas).offset();g=this.touches[g];2>b-g.time||(g.lasttime=g.time,g.lastx=g.x,g.lasty=g.y,g.time=b,g.x=e.pageX-h.left,g.y=e.pageY-h.top)}};h.onTouchStart=function(a){a.preventDefault&&a.preventDefault();var b=this.runtime.isDomFree?f:jQuery(this.runtime.canvas).offset(),c=cr.performance_now();this.runtime.isInUserInputEvent=!0;var d,e,g,h;d=0;for(e=a.changedTouches.length;d<e;d++)if(g=a.changedTouches[d],h=this.findTouch(g.identifier),
-1===h){h=g.pageX-b.left;var k=g.pageY-b.top;this.trigger_index=this.touches.length;this.trigger_id=g.identifier;this.touches.push({time:c,x:h,y:k,lasttime:c,lastx:h,lasty:k,id:g.identifier,startindex:this.trigger_index});this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,this);this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart,this);this.curTouchX=h;this.curTouchY=k;this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject,this)}this.runtime.isInUserInputEvent=
!1};h.onTouchEnd=function(a){a.preventDefault&&a.preventDefault();this.runtime.isInUserInputEvent=!0;var b,c,d;b=0;for(c=a.changedTouches.length;b<c;b++)d=a.changedTouches[b],d=this.findTouch(d.identifier),0<=d&&(this.trigger_index=this.touches[d].startindex,this.trigger_id=this.touches[d].id,this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,this),this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd,this),this.touches.splice(d,1));this.runtime.isInUserInputEvent=!1};
h.getAlpha=function(){return this.runtime.isAppMobi&&0===this.orient_alpha&&0!==g?90*g:this.runtime.isPhoneGap&&0===this.orient_alpha&&0!==p?90*p:this.orient_alpha};h.getBeta=function(){return this.runtime.isAppMobi&&0===this.orient_beta&&0!==k?-90*k:this.runtime.isPhoneGap&&0===this.orient_beta&&0!==n?-90*n:this.orient_beta};h.getGamma=function(){return this.runtime.isAppMobi&&0===this.orient_gamma&&0!==l?90*l:this.runtime.isPhoneGap&&0===this.orient_gamma&&0!==m?90*m:this.orient_gamma};h.onMouseDown=
function(a){a.preventDefault&&this.runtime.had_a_click&&!this.runtime.isMobile&&a.preventDefault();this.onTouchStart({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]});this.mouseDown=!0};h.onMouseMove=function(a){if(this.mouseDown)this.onTouchMove({changedTouches:[{pageX:a.pageX,pageY:a.pageY,identifier:0}]})};h.onMouseUp=function(a){a.preventDefault&&this.runtime.had_a_click&&!this.runtime.isMobile&&a.preventDefault();this.runtime.had_a_click=!0;this.onTouchEnd({changedTouches:[{pageX:a.pageX,
pageY:a.pageY,identifier:0}]});this.mouseDown=!1};h.tick2=function(){var a,b,c,d=cr.performance_now();a=0;for(b=this.touches.length;a<b;a++)c=this.touches[a],c.time<=d-50&&(c.lasttime=d)};c.prototype.OnTouchStart=function(){return!0};c.prototype.OnTouchEnd=function(){return!0};c.prototype.IsInTouch=function(){return this.touches.length};c.prototype.OnTouchObject=function(a){return a?this.runtime.testAndSelectCanvasPointOverlap(a,this.curTouchX,this.curTouchY,!1):!1};c.prototype.IsTouchingObject=function(a){if(!a)return!1;
var b=a.getCurrentSol(),c=b.getObjects(),d,e,g=[],f,h,k,l;f=0;for(h=c.length;f<h;f++){var m=c[f];m.update_bbox();k=0;for(l=this.touches.length;k<l;k++)if(e=this.touches[k],d=m.layer.canvasToLayer(e.x,e.y,!0),e=m.layer.canvasToLayer(e.x,e.y,!1),m.contains_pt(d,e)){g.push(m);break}}return g.length?(b.select_all=!1,b.instances=g,a.applySolToContainer(),!0):!1};c.prototype.CompareTouchSpeed=function(a,b,c){a=Math.floor(a);if(0>a||a>=this.touches.length)return!1;var d=this.touches[a];a=cr.distanceTo(d.x,
d.y,d.lastx,d.lasty);var d=(d.time-d.lasttime)/1E3,e=0;0<d&&(e=a/d);return cr.do_cmp(e,b,c)};c.prototype.OrientationSupported=function(){return"undefined"!==typeof window.DeviceOrientationEvent};c.prototype.MotionSupported=function(){return"undefined"!==typeof window.DeviceMotionEvent};c.prototype.CompareOrientation=function(a,b,c){var d=0,d=0===a?this.getAlpha():1===a?this.getBeta():this.getGamma();return cr.do_cmp(d,b,c)};c.prototype.CompareAcceleration=function(a,b,c){var d=0;0===a?d=this.acc_g_x:
1===a?d=this.acc_g_y:2===a?d=this.acc_g_z:3===a?d=this.acc_x:4===a?d=this.acc_y:5===a&&(d=this.acc_z);return cr.do_cmp(d,b,c)};c.prototype.OnNthTouchStart=function(a){a=Math.floor(a);return a===this.trigger_index};c.prototype.OnNthTouchEnd=function(a){a=Math.floor(a);return a===this.trigger_index};c.prototype.HasNthTouch=function(a){a=Math.floor(a);return this.touches.length>=a+1};e.cnds=new c;d.prototype.TouchCount=function(a){a.set_int(this.touches.length)};d.prototype.X=function(a,b){if(this.touches.length){var c,
d,e,g,f;cr.is_undefined(b)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,g=c.parallaxX,f=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=g,c.angle=f):(c=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!0)):a.set_float(0)}else a.set_float(0)};
d.prototype.XAt=function(a,b,c){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var d,e,g,f;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,g=c.parallaxX,f=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=g,c.angle=f):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?
a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!0)):a.set_float(0)}};d.prototype.XForID=function(a,b,c){b=this.findTouch(b);if(0>b)a.set_float(0);else{b=this.touches[b];var d,e,g,f;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,g=c.parallaxX,f=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxX=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(b.x,b.y,!0)),c.scale=d,c.zoomRate=e,c.parallaxX=g,c.angle=f):(c=
cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(b.x,b.y,!0)):a.set_float(0)}};d.prototype.Y=function(a,b){if(this.touches.length){var c,d,e,g,f;cr.is_undefined(b)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,g=c.parallaxY,f=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!1)),c.scale=d,c.zoomRate=
e,c.parallaxY=g,c.angle=f):(c=cr.is_number(b)?this.runtime.getLayerByNumber(b):this.runtime.getLayerByName(b))?a.set_float(c.canvasToLayer(this.touches[0].x,this.touches[0].y,!1)):a.set_float(0)}else a.set_float(0)};d.prototype.YAt=function(a,b,c){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var d,e,g,f;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,g=c.parallaxY,f=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=
this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!1)),c.scale=d,c.zoomRate=e,c.parallaxY=g,c.angle=f):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(this.touches[b].x,this.touches[b].y,!1)):a.set_float(0)}};d.prototype.YForID=function(a,b,c){b=this.findTouch(b);if(0>b)a.set_float(0);else{b=this.touches[b];var d,e,g,f;cr.is_undefined(c)?(c=this.runtime.getLayerByNumber(0),d=c.scale,e=c.zoomRate,
g=c.parallaxY,f=c.angle,c.scale=this.runtime.running_layout.scale,c.zoomRate=1,c.parallaxY=1,c.angle=this.runtime.running_layout.angle,a.set_float(c.canvasToLayer(b.x,b.y,!1)),c.scale=d,c.zoomRate=e,c.parallaxY=g,c.angle=f):(c=cr.is_number(c)?this.runtime.getLayerByNumber(c):this.runtime.getLayerByName(c))?a.set_float(c.canvasToLayer(b.x,b.y,!1)):a.set_float(0)}};d.prototype.AbsoluteX=function(a){this.touches.length?a.set_float(this.touches[0].x):a.set_float(0)};d.prototype.AbsoluteXAt=function(a,
b){b=Math.floor(b);0>b||b>=this.touches.length?a.set_float(0):a.set_float(this.touches[b].x)};d.prototype.AbsoluteXForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):a.set_float(this.touches[c].x)};d.prototype.AbsoluteY=function(a){this.touches.length?a.set_float(this.touches[0].y):a.set_float(0)};d.prototype.AbsoluteYAt=function(a,b){b=Math.floor(b);0>b||b>=this.touches.length?a.set_float(0):a.set_float(this.touches[b].y)};d.prototype.AbsoluteYForID=function(a,b){var c=this.findTouch(b);
0>c?a.set_float(0):a.set_float(this.touches[c].y)};d.prototype.SpeedAt=function(a,b){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var c=this.touches[b],d=cr.distanceTo(c.x,c.y,c.lastx,c.lasty),c=(c.time-c.lasttime)/1E3;0===c?a.set_float(0):a.set_float(d/c)}};d.prototype.SpeedForID=function(a,b){var c=this.findTouch(b);if(0>c)a.set_float(0);else{var d=this.touches[c],c=cr.distanceTo(d.x,d.y,d.lastx,d.lasty),d=(d.time-d.lasttime)/1E3;0===d?a.set_float(0):a.set_float(c/d)}};d.prototype.AngleAt=
function(a,b){b=Math.floor(b);if(0>b||b>=this.touches.length)a.set_float(0);else{var c=this.touches[b];a.set_float(cr.to_degrees(cr.angleTo(c.lastx,c.lasty,c.x,c.y)))}};d.prototype.AngleForID=function(a,b){var c=this.findTouch(b);0>c?a.set_float(0):(c=this.touches[c],a.set_float(cr.to_degrees(cr.angleTo(c.lastx,c.lasty,c.x,c.y))))};d.prototype.Alpha=function(a){a.set_float(this.getAlpha())};d.prototype.Beta=function(a){a.set_float(this.getBeta())};d.prototype.Gamma=function(a){a.set_float(this.getGamma())};
d.prototype.AccelerationXWithG=function(a){a.set_float(this.acc_g_x)};d.prototype.AccelerationYWithG=function(a){a.set_float(this.acc_g_y)};d.prototype.AccelerationZWithG=function(a){a.set_float(this.acc_g_z)};d.prototype.AccelerationX=function(a){a.set_float(this.acc_x)};d.prototype.AccelerationY=function(a){a.set_float(this.acc_y)};d.prototype.AccelerationZ=function(a){a.set_float(this.acc_z)};d.prototype.TouchIndex=function(a){a.set_int(this.trigger_index)};d.prototype.TouchID=function(a){a.set_float(this.trigger_id)};
e.exps=new d})();cr.plugins_.Twitter=function(a){this.runtime=a};
(function(){function a(a){var c;c="none";1===f.buttonCount?c="horizontal":2===f.buttonCount&&(c="vertical");var d=0===f.buttonSize?"medium":"large";0===f.buttonType?a.widgets.createFollowButton(f.buttonShare,f.elem,b,{count:c,size:d,lang:f.buttonLang}):1===f.buttonType?(c={count:c,size:d,lang:f.buttonLang,text:f.buttonText},f.buttonVia&&(c.via=f.buttonVia),f.buttonHashtags&&(c.hashtags=f.buttonHashtags),a.widgets.createShareButton(f.buttonShare,f.elem,b,c)):2===f.buttonType?(c={count:c,size:d,lang:f.buttonLang,
text:f.buttonText},f.buttonVia&&(c.via=f.buttonVia),f.buttonHashtags&&(c.hashtags=f.buttonHashtags),a.widgets.createMentionButton(f.buttonShare,f.elem,b,c)):3===f.buttonType&&(c={count:c,size:d,lang:f.buttonLang,text:f.buttonText},f.buttonVia&&(c.via=f.buttonVia),f.buttonHashtags&&(c.hashtags=f.buttonHashtags),a.widgets.createHashtagButton(f.buttonShare,f.elem,b,c))}function b(){f.runtime.trigger(cr.plugins_.Twitter.prototype.cnds.OnLoaded,f)}function c(){}function d(){}var e=cr.plugins_.Twitter.prototype;
e.Type=function(a){this.plugin=a;this.runtime=a.runtime};e.Type.prototype.onCreate=function(){};e.Instance=function(a){this.type=a;this.runtime=a.runtime};var h=e.Instance.prototype,f=null;h.onCreate=function(){this.runtime.isDomFree?cr.logexport("[Construct 2] Twitter plugin not supported on this platform - the object will not be created"):(this.elem=document.createElement("div"),jQuery(this.elem).appendTo(this.runtime.canvasdiv?this.runtime.canvasdiv:"body"),this.element_hidden=!1,this.buttonType=
this.properties[0],this.buttonShare=this.properties[1],this.buttonText=this.properties[2],this.buttonVia=this.properties[3],this.buttonHashtags=this.properties[4],0===this.properties[5]&&(jQuery(this.elem).hide(),this.visible=!1,this.element_hidden=!0),this.buttonCount=this.properties[6],this.buttonSize=this.properties[7],this.buttonLang=this.properties[8]||"en",this.lastWinHeight=this.lastWinWidth=this.lastBottom=this.lastRight=this.lastTop=this.lastLeft=0,this.updatePosition(!0),this.runtime.tickMe(this),
window.twttr=function(a,b,c){var d,e=a.getElementsByTagName(b)[0];if(!a.getElementById(c))return a=a.createElement(b),a.id=c,a.src="https://platform.twitter.com/widgets.js",e.parentNode.insertBefore(a,e),window.twttr||(d={_e:[],ready:function(a){d._e.push(a)}})}(document,"script","twitter-wjs"),f=this,window.twttr.ready(a))};h.saveToJSON=function(){return{}};h.loadFromJSON=function(a){};h.onDestroy=function(){this.runtime.isDomFree||(jQuery(this.elem).remove(),this.elem=null)};h.tick=function(){this.updatePosition()};
h.updatePosition=function(a){if(!this.runtime.isDomFree){var b=this.layer.layerToCanvas(this.x,this.y,!0),c=this.layer.layerToCanvas(this.x,this.y,!1),d=this.layer.layerToCanvas(this.x+this.width,this.y+this.height,!0),e=this.layer.layerToCanvas(this.x+this.width,this.y+this.height,!1);if(!this.visible||!this.layer.visible||0>=d||0>=e||b>=this.runtime.width||c>=this.runtime.height)this.element_hidden||jQuery(this.elem).hide(),this.element_hidden=!0;else{1>b&&(b=1);1>c&&(c=1);d>=this.runtime.width&&
(d=this.runtime.width-1);e>=this.runtime.height&&(e=this.runtime.height-1);var f=window.innerWidth,h=window.innerHeight;a||this.lastLeft!==b||this.lastTop!==c||this.lastRight!==d||this.lastBottom!==e||this.lastWinWidth!==f||this.lastWinHeight!==h?(this.lastLeft=b,this.lastTop=c,this.lastRight=d,this.lastBottom=e,this.lastWinWidth=f,this.lastWinHeight=h,this.element_hidden&&(jQuery(this.elem).show(),this.element_hidden=!1),a=Math.round(b)+jQuery(this.runtime.canvas).offset().left,f=Math.round(c)+jQuery(this.runtime.canvas).offset().top,
jQuery(this.elem).css("position","absolute"),jQuery(this.elem).offset({left:a,top:f}),jQuery(this.elem).width(Math.round(d-b)),jQuery(this.elem).height(Math.round(e-c))):this.element_hidden&&(jQuery(this.elem).show(),this.element_hidden=!1)}}};h.draw=function(a){};h.drawGL=function(a){};c.prototype.OnLoaded=function(){return!0};e.cnds=new c;d.prototype.SetVisible=function(a){this.runtime.isDomFree||(this.visible=0!==a)};d.prototype.SetShare=function(a){this.buttonShare=a};d.prototype.SetText=function(a){this.buttonText=
a};d.prototype.SetVia=function(a){this.buttonVia=a};d.prototype.SetHashtags=function(a){this.buttonHashtags=a};d.prototype.Reload=function(){this.runtime.isDomFree||(jQuery(this.elem).remove(),this.elem=document.createElement("div"),jQuery(this.elem).appendTo(this.runtime.canvasdiv?this.runtime.canvasdiv:"body"),this.element_hidden&&jQuery(this.elem).hide(),a(window.twttr),this.updatePosition(!0))};e.acts=new d;e.exps=new function(){}})();cr.behaviors.Anchor=function(a){this.runtime=a};
(function(){function a(){}var b=cr.behaviors.Anchor.prototype;b.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};b.Type.prototype.onCreate=function(){};b.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var c=b.Instance.prototype;c.onCreate=function(){this.anch_left=this.properties[0];this.anch_top=this.properties[1];this.anch_right=this.properties[2];this.anch_bottom=this.properties[3];this.inst.update_bbox();this.xleft=this.inst.bbox.left;
this.ytop=this.inst.bbox.top;this.xright=this.runtime.original_width-this.inst.bbox.left;this.ybottom=this.runtime.original_height-this.inst.bbox.top;this.rdiff=this.runtime.original_width-this.inst.bbox.right;this.bdiff=this.runtime.original_height-this.inst.bbox.bottom;this.enabled=0!==this.properties[4]};c.saveToJSON=function(){return{xleft:this.xleft,ytop:this.ytop,xright:this.xright,ybottom:this.ybottom,rdiff:this.rdiff,bdiff:this.bdiff,enabled:this.enabled}};c.loadFromJSON=function(a){this.xleft=
a.xleft;this.ytop=a.ytop;this.xright=a.xright;this.ybottom=a.ybottom;this.rdiff=a.rdiff;this.bdiff=a.bdiff;this.enabled=a.enabled};c.tick=function(){if(this.enabled){var a,b=this.inst.layer,c=this.inst,f=this.inst.bbox;0===this.anch_left?(c.update_bbox(),a=b.viewLeft+this.xleft-f.left,0!==a&&(c.x+=a,c.set_bbox_changed())):1===this.anch_left&&(c.update_bbox(),a=b.viewRight-this.xright-f.left,0!==a&&(c.x+=a,c.set_bbox_changed()));0===this.anch_top?(c.update_bbox(),a=b.viewTop+this.ytop-f.top,0!==a&&
(c.y+=a,c.set_bbox_changed())):1===this.anch_top&&(c.update_bbox(),a=b.viewBottom-this.ybottom-f.top,0!==a&&(c.y+=a,c.set_bbox_changed()));1===this.anch_right&&(c.update_bbox(),a=b.viewRight-this.rdiff-f.right,0!==a&&(c.width+=a,0>c.width&&(c.width=0),c.set_bbox_changed()));1===this.anch_bottom&&(c.update_bbox(),a=b.viewBottom-this.bdiff-f.bottom,0!==a&&(c.height+=a,0>c.height&&(c.height=0),c.set_bbox_changed()))}};b.cnds=new function(){};a.prototype.SetEnabled=function(a){this.enabled&&0===a?this.enabled=
!1:this.enabled||0===a||(this.inst.update_bbox(),this.xleft=this.inst.bbox.left,this.ytop=this.inst.bbox.top,this.xright=this.runtime.original_width-this.inst.bbox.left,this.ybottom=this.runtime.original_height-this.inst.bbox.top,this.rdiff=this.runtime.original_width-this.inst.bbox.right,this.bdiff=this.runtime.original_height-this.inst.bbox.bottom,this.enabled=!0)};b.acts=new a;b.exps=new function(){}})();
cr.behaviors.DragnDrop=function(a){this.runtime=a;var b=this;this.runtime.isDomFree||(jQuery(document).mousemove(function(a){b.onMouseMove(a)}),jQuery(document).mousedown(function(a){b.onMouseDown(a)}),jQuery(document).mouseup(function(a){b.onMouseUp(a)}));a=0<this.runtime.fullscreen_mode?document:this.runtime.canvas;this.runtime.isDirectCanvas?a=window.Canvas:this.runtime.isCocoonJs&&(a=window);window.navigator.pointerEnabled?(a.addEventListener("pointerdown",function(a){b.onPointerStart(a)},!1),
a.addEventListener("pointermove",function(a){b.onPointerMove(a)},!1),a.addEventListener("pointerup",function(a){b.onPointerEnd(a)},!1),a.addEventListener("pointercancel",function(a){b.onPointerEnd(a)},!1)):window.navigator.msPointerEnabled?(a.addEventListener("MSPointerDown",function(a){b.onPointerStart(a)},!1),a.addEventListener("MSPointerMove",function(a){b.onPointerMove(a)},!1),a.addEventListener("MSPointerUp",function(a){b.onPointerEnd(a)},!1),a.addEventListener("MSPointerCancel",function(a){b.onPointerEnd(a)},
!1)):(a.addEventListener("touchstart",function(a){b.onTouchStart(a)},!1),a.addEventListener("touchmove",function(a){b.onTouchMove(a)},!1),a.addEventListener("touchend",function(a){b.onTouchEnd(a)},!1),a.addEventListener("touchcancel",function(a){b.onTouchEnd(a)},!1))};
(function(){function a(a){var b,c;b=0;for(c=a.behavior_insts.length;b<c;b++)if(a.behavior_insts[b]instanceof d.Instance)return a.behavior_insts[b];return null}function b(){}function c(){}var d=cr.behaviors.DragnDrop.prototype,e={left:0,top:0};d.onMouseDown=function(a){if(1===a.which)this.onInputDown("leftmouse",a.pageX,a.pageY)};d.onMouseMove=function(a){if(1===a.which)this.onInputMove("leftmouse",a.pageX,a.pageY)};d.onMouseUp=function(a){if(1===a.which)this.onInputUp("leftmouse")};d.onTouchStart=
function(a){a.preventDefault&&a.preventDefault();var b,c,d,e;b=0;for(c=a.changedTouches.length;b<c;b++)d=a.changedTouches[b],e=d.identifier,this.onInputDown(e?e.toString():"<none>",d.pageX,d.pageY)};d.onTouchMove=function(a){a.preventDefault&&a.preventDefault();var b,c,d,e;b=0;for(c=a.changedTouches.length;b<c;b++)d=a.changedTouches[b],e=d.identifier,this.onInputMove(e?e.toString():"<none>",d.pageX,d.pageY)};d.onTouchEnd=function(a){a.preventDefault&&a.preventDefault();var b,c,d;b=0;for(c=a.changedTouches.length;b<
c;b++)d=a.changedTouches[b],d=d.identifier,this.onInputUp(d?d.toString():"<none>")};d.onPointerStart=function(a){a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),this.onInputDown(a.pointerId.toString(),a.pageX,a.pageY))};d.onPointerMove=function(a){a.pointerType!==a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),this.onInputMove(a.pointerId.toString(),a.pageX,a.pageY))};d.onPointerEnd=function(a){a.pointerType!==
a.MSPOINTER_TYPE_MOUSE&&"mouse"!==a.pointerType&&(a.preventDefault&&a.preventDefault(),this.onInputUp(a.pointerId.toString()))};d.onInputDown=function(b,c,d){var g=this.runtime.isDomFree?e:jQuery(this.runtime.canvas).offset();c-=g.left;d-=g.top;var h,n,p,r,g=this.my_instances.valuesRef(),s,q,t,u=null;s=0;for(q=g.length;s<q;s++)if(t=g[s],h=a(t),h.enabled&&!h.dragging&&(h=t.layer.canvasToLayer(c,d,!0),n=t.layer.canvasToLayer(c,d,!1),t.update_bbox(),t.contains_pt(h,n)))u?t.layer.index>u.layer.index?
(u=t,p=h,r=n):t.layer.index===u.layer.index&&t.get_zindex()>u.get_zindex()&&(u=t,p=h,r=n):(u=t,p=h,r=n);if(u)a(u).onDown(b,p,r)};d.onInputMove=function(b,c,d){var g=this.runtime.isDomFree?e:jQuery(this.runtime.canvas).offset();c-=g.left;d-=g.top;var h,n=this.my_instances.valuesRef(),p,r,s;p=0;for(r=n.length;p<r;p++)h=n[p],s=a(h),!s.enabled||!s.dragging||s.dragging&&s.dragsource!==b||(g=h.layer.canvasToLayer(c,d,!0),h=h.layer.canvasToLayer(c,d,!1),s.onMove(g,h))};d.onInputUp=function(b){var c=this.my_instances.valuesRef(),
d,e,h;d=0;for(e=c.length;d<e;d++)if(h=c[d],h=a(h),h.dragging&&h.dragsource===b)h.onUp()};d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var h=d.Instance.prototype;h.onCreate=function(){this.dragging=!1;this.dy=this.dx=0;this.dragsource="<none>";this.axes=this.properties[0];this.enabled=0!==this.properties[1]};h.saveToJSON=function(){return{enabled:this.enabled}};
h.loadFromJSON=function(a){this.enabled=a.enabled;this.dragging=!1};h.onDown=function(a,b,c){this.dx=b-this.inst.x;this.dy=c-this.inst.y;this.dragging=!0;this.dragsource=a;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.behaviors.DragnDrop.prototype.cnds.OnDragStart,this.inst);this.runtime.isInUserInputEvent=!1};h.onMove=function(a,b){var c=a-this.dx,d=b-this.dy;if(0===this.axes){if(this.inst.x!==c||this.inst.y!==d)this.inst.x=c,this.inst.y=d,this.inst.set_bbox_changed()}else 1===this.axes?
this.inst.x!==c&&(this.inst.x=c,this.inst.set_bbox_changed()):2===this.axes&&this.inst.y!==d&&(this.inst.y=d,this.inst.set_bbox_changed())};h.onUp=function(){this.dragging=!1;this.runtime.isInUserInputEvent=!0;this.runtime.trigger(cr.behaviors.DragnDrop.prototype.cnds.OnDrop,this.inst);this.runtime.isInUserInputEvent=!1};h.tick=function(){};b.prototype.IsDragging=function(){return this.dragging};b.prototype.OnDragStart=function(){return!0};b.prototype.OnDrop=function(){return!0};b.prototype.IsEnabled=
function(){return!!this.enabled};d.cnds=new b;c.prototype.SetEnabled=function(a){this.enabled=0!==a;this.enabled||(this.dragging=!1)};c.prototype.Drop=function(){if(this.dragging)this.onUp()};d.acts=new c;d.exps=new function(){}})();cr.behaviors.Fade=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.behaviors.Fade.prototype;c.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){var a=1===this.properties[0];this.fadeInTime=this.properties[1];this.waitTime=this.properties[2];this.fadeOutTime=this.properties[3];this.destroy=this.properties[4];
this.stage=a?0:3;this.recycled?this.stageTime.reset():this.stageTime=new cr.KahanAdder;this.maxOpacity=this.inst.opacity?this.inst.opacity:1;a&&(0===this.fadeInTime?(this.stage=1,0===this.waitTime&&(this.stage=2)):(this.inst.opacity=0,this.runtime.redraw=!0))};d.saveToJSON=function(){return{fit:this.fadeInTime,wt:this.waitTime,fot:this.fadeOutTime,s:this.stage,st:this.stageTime.sum,mo:this.maxOpacity}};d.loadFromJSON=function(a){this.fadeInTime=a.fit;this.waitTime=a.wt;this.fadeOutTime=a.fot;this.stage=
a.s;this.stageTime.reset();this.stageTime.sum=a.st;this.maxOpacity=a.mo};d.tick=function(){this.stageTime.add(this.runtime.getDt(this.inst));0===this.stage&&(this.inst.opacity=this.stageTime.sum/this.fadeInTime*this.maxOpacity,this.runtime.redraw=!0,this.inst.opacity>=this.maxOpacity&&(this.inst.opacity=this.maxOpacity,this.stage=1,this.stageTime.reset()));1===this.stage&&this.stageTime.sum>=this.waitTime&&(this.stage=2,this.stageTime.reset());2===this.stage&&0!==this.fadeOutTime&&(this.inst.opacity=
this.maxOpacity-this.stageTime.sum/this.fadeOutTime*this.maxOpacity,this.runtime.redraw=!0,0>this.inst.opacity&&(this.inst.opacity=0,this.stage=3,this.stageTime.reset(),this.runtime.trigger(cr.behaviors.Fade.prototype.cnds.OnFadeOutEnd,this.inst),1===this.destroy&&this.runtime.DestroyInstance(this.inst)))};d.doStart=function(){this.stage=0;this.stageTime.reset();0===this.fadeInTime?(this.stage=1,0===this.waitTime&&(this.stage=2)):(this.inst.opacity=0,this.runtime.redraw=!0)};a.prototype.OnFadeOutEnd=
function(){return!0};c.cnds=new a;b.prototype.StartFade=function(){3===this.stage&&this.doStart()};b.prototype.RestartFade=function(){this.doStart()};c.acts=new b})();cr.behaviors.Flash=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.behaviors.Flash.prototype;c.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){this.timeleft=this.stagetimeleft=this.stage=this.offtime=this.ontime=0};d.saveToJSON=function(){return{ontime:this.ontime,offtime:this.offtime,stage:this.stage,stagetimeleft:this.stagetimeleft,
timeleft:this.timeleft}};d.loadFromJSON=function(a){this.ontime=a.ontime;this.offtime=a.offtime;this.stage=a.stage;this.stagetimeleft=a.stagetimeleft;this.timeleft=a.timeleft};d.tick=function(){if(!(0>=this.timeleft)){var a=this.runtime.getDt(this.inst);this.timeleft-=a;0>=this.timeleft?(this.timeleft=0,this.inst.visible=!0,this.runtime.redraw=!0,this.runtime.trigger(cr.behaviors.Flash.prototype.cnds.OnFlashEnded,this.inst)):(this.stagetimeleft-=a,0>=this.stagetimeleft&&(0===this.stage?(this.inst.visible=
!1,this.stage=1,this.stagetimeleft+=this.offtime):(this.inst.visible=!0,this.stage=0,this.stagetimeleft+=this.ontime),this.runtime.redraw=!0))}};a.prototype.IsFlashing=function(){return 0<this.timeleft};a.prototype.OnFlashEnded=function(){return!0};c.cnds=new a;b.prototype.Flash=function(a,b,c){this.ontime=a;this.offtime=b;this.stage=1;this.stagetimeleft=b;this.timeleft=c;this.inst.visible=!1;this.runtime.redraw=!0};b.prototype.StopFlashing=function(){this.timeleft=0;this.inst.visible=!0;this.runtime.redraw=
!0};c.acts=new b;c.exps=new function(){}})();cr.behaviors.NoSave=function(a){this.runtime=a};
(function(){var a=cr.behaviors.NoSave.prototype;a.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};a.Type.prototype.onCreate=function(){};a.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var b=a.Instance.prototype;b.onCreate=function(){this.myProperty=this.properties[0]};b.onDestroy=function(){};b.tick=function(){this.runtime.getDt(this.inst)};a.cnds=new function(){};a.acts=new function(){};a.exps=new function(){}})();
var Box2D={Dynamics:{}};Box2D.Dynamics.Joints={};Box2D.Common={};Box2D.Common.Math={};Box2D.Collision={};Box2D.Collision.Shapes={};function c2inherit(a,b){for(var c in b.prototype)b.prototype.hasOwnProperty(c)&&(a.prototype[c]=b.prototype[c])}
if(navigator.isCocoonJS&&"undefined"!==typeof window.cr_cjs_accelerated_physics)cr.logexport("Using CocoonJS native physics"),window.ext&&"undefined"!==typeof window.ext.IDTK_SRV_BOX2D?function(){var a=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.x=a;this.y=b};Box2D.Common.Math.b2Vec2=a;a._freeCache=[];a.Get=function(a,b){if(0<Box2D.Common.Math.b2Vec2._freeCache.length){var c=Box2D.Common.Math.b2Vec2._freeCache.pop();c.Set(a,b);return c}return new Box2D.Common.Math.b2Vec2(a,b)};a.Free=function(a){1E4>
Box2D.Common.Math.b2Vec2._freeCache.length&&Box2D.Common.Math.b2Vec2._freeCache.push(a)};a.prototype.SetZero=function(){this.y=this.x=0};a.prototype.Set=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.x=a;this.y=b};a.prototype.SetV=function(a){this.x=a.x;this.y=a.y};a.Make=function(b,c){void 0===b&&(b=0);void 0===c&&(c=0);return a.Get(b,c)};a.prototype.Copy=function(){return a.Get(this.x,this.y)};a.prototype.Add=function(a){this.x+=a.x;this.y+=a.y};a.prototype.Subtract=function(a){this.x-=
a.x;this.y-=a.y};a.prototype.Multiply=function(a){void 0===a&&(a=0);this.x*=a;this.y*=a};a.prototype.Length=function(){return Math.sqrt(this.x*this.x+this.y*this.y)};a.prototype.LengthSquared=function(){return this.x*this.x+this.y*this.y};a.prototype.Normalize=function(){var a=Math.sqrt(this.x*this.x+this.y*this.y);if(a<Number.MIN_VALUE)return 0;var b=1/a;this.x*=b;this.y*=b;return a};a.prototype.NegativeSelf=function(){this.x=-this.x;this.y=-this.y};var b=function(){this.col1=a.Get(0,0);this.col2=
a.Get(0,0);this.SetIdentity()};Box2D.Common.Math.b2Mat22=b;b.FromAngle=function(a){void 0===a&&(a=0);var c=new b;c.Set(a);return c};b.FromVV=function(a,c){var d=new b;d.SetVV(a,c);return d};b.prototype.Set=function(a){void 0===a&&(a=0);var b=Math.cos(a);a=Math.sin(a);this.col1.x=b;this.col2.x=-a;this.col1.y=a;this.col2.y=b};b.prototype.SetVV=function(a,b){this.col1.SetV(a);this.col2.SetV(b)};b.prototype.Copy=function(){var a=new b;a.SetM(this);return a};b.prototype.SetM=function(a){this.col1.SetV(a.col1);
this.col2.SetV(a.col2)};b.prototype.AddM=function(a){this.col1.x+=a.col1.x;this.col1.y+=a.col1.y;this.col2.x+=a.col2.x;this.col2.y+=a.col2.y};b.prototype.SetIdentity=function(){this.col1.x=1;this.col2.x=0;this.col1.y=0;this.col2.y=1};b.prototype.SetZero=function(){this.col1.x=0;this.col2.x=0;this.col1.y=0;this.col2.y=0};b.prototype.GetAngle=function(){return Math.atan2(this.col1.y,this.col1.x)};b.prototype.GetInverse=function(a){var b=this.col1.x,c=this.col2.x,d=this.col1.y,e=this.col2.y,f=b*e-c*
d;0!==f&&(f=1/f);a.col1.x=f*e;a.col2.x=-f*c;a.col1.y=-f*d;a.col2.y=f*b;return a};b.prototype.Solve=function(a,b,c){void 0===b&&(b=0);void 0===c&&(c=0);var d=this.col1.x,e=this.col2.x,f=this.col1.y,h=this.col2.y,k=d*h-e*f;0!==k&&(k=1/k);a.x=k*(h*b-e*c);a.y=k*(d*c-f*b);return a};b.prototype.Abs=function(){this.col1.Abs();this.col2.Abs()};var c=function(c,d){this.position=a.Get(0,0);this.R=new b;void 0===c&&(c=null);void 0===d&&(d=null);c&&(this.position.SetV(c),this.R.SetM(d))};Box2D.Common.Math.b2Transform=
c;c.prototype.Initialize=function(a,b){this.position.SetV(a);this.R.SetM(b)};c.prototype.SetIdentity=function(){this.position.SetZero();this.R.SetIdentity()};c.prototype.Set=function(a){this.position.SetV(a.position);this.R.SetM(a.R)};c.prototype.SetAngle=function(){return Math.atan2(this.R.col1.y,this.R.col1.x)};var d=function(){};Box2D.Common.Math.b2Math=d;d.IsValid=function(a){void 0===a&&(a=0);return isFinite(a)};d.Dot=function(a,b){return a.x*b.x+a.y*b.y};d.CrossVV=function(a,b){return a.x*b.y-
a.y*b.x};d.CrossVF=function(b,c){void 0===c&&(c=0);return a.Get(c*b.y,-c*b.x)};d.CrossFV=function(b,c){void 0===b&&(b=0);return a.Get(-b*c.y,b*c.x)};d.MulMV=function(b,c){return a.Get(b.col1.x*c.x+b.col2.x*c.y,b.col1.y*c.x+b.col2.y*c.y)};d.MulTMV=function(b,c){return a.Get(d.Dot(c,b.col1),d.Dot(c,b.col2))};d.MulX=function(a,b){var c=d.MulMV(a.R,b);c.x+=a.position.x;c.y+=a.position.y;return c};d.MulXT=function(a,b){var c=d.SubtractVV(b,a.position),e=c.x*a.R.col1.x+c.y*a.R.col1.y;c.y=c.x*a.R.col2.x+
c.y*a.R.col2.y;c.x=e;return c};d.AddVV=function(b,c){return a.Get(b.x+c.x,b.y+c.y)};d.SubtractVV=function(b,c){return a.Get(b.x-c.x,b.y-c.y)};d.Distance=function(a,b){var c=a.x-b.x,d=a.y-b.y;return Math.sqrt(c*c+d*d)};d.DistanceSquared=function(a,b){var c=a.x-b.x,d=a.y-b.y;return c*c+d*d};d.MulFV=function(b,c){void 0===b&&(b=0);return a.Get(b*c.x,b*c.y)};d.AddMM=function(a,c){return b.FromVV(d.AddVV(a.col1,c.col1),d.AddVV(a.col2,c.col2))};d.MulMM=function(a,c){return b.FromVV(d.MulMV(a,c.col1),d.MulMV(a,
c.col2))};d.MulTMM=function(c,e){var f=a.Get(d.Dot(c.col1,e.col1),d.Dot(c.col2,e.col1)),h=a.Get(d.Dot(c.col1,e.col2),d.Dot(c.col2,e.col2));return b.FromVV(f,h)};d.Abs=function(a){void 0===a&&(a=0);return 0<a?a:-a};d.AbsV=function(b){return a.Get(d.Abs(b.x),d.Abs(b.y))};d.AbsM=function(a){return b.FromVV(d.AbsV(a.col1),d.AbsV(a.col2))};d.Min=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);return a<b?a:b};d.MinV=function(b,c){return a.Get(d.Min(b.x,c.x),d.Min(b.y,c.y))};d.Max=function(a,b){void 0===
a&&(a=0);void 0===b&&(b=0);return a>b?a:b};d.MaxV=function(b,c){return a.Get(d.Max(b.x,c.x),d.Max(b.y,c.y))};d.Clamp=function(a,b,c){void 0===a&&(a=0);void 0===b&&(b=0);void 0===c&&(c=0);return a<b?b:a>c?c:a};d.ClampV=function(a,b,c){return d.MaxV(b,d.MinV(a,c))};d.Swap=function(a,b){var c=a[0];a[0]=b[0];b[0]=c};d.Random=function(){return 2*Math.random()-1};d.RandomRange=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);var c=Math.random();return(b-a)*c+a};d.NextPowerOfTwo=function(a){void 0===a&&
(a=0);a|=a>>1&2147483647;a|=a>>2&1073741823;a|=a>>4&268435455;a|=a>>8&16777215;return(a|a>>16&65535)+1};d.IsPowerOfTwo=function(a){void 0===a&&(a=0);return 0<a&&0===(a&a-1)};d.b2Vec2_zero=new a(0,0);d.b2Mat22_identity=b.FromVV(new a(1,0),new a(0,1));d.b2Transform_identity=new c(d.b2Vec2_zero,d.b2Mat22_identity);var e=function(){this.e_aabbBit=4;this.e_centerOfMassBit=16;this.e_controllerBit=32;this.e_jointBit=2;this.e_pairBit=8;this.e_shapeBit=0};Box2D.Dynamics.b2DebugDraw=e;e.prototype.AppendFlags=
function(){};e.prototype.ClearFlags=function(){};e.prototype.DrawCircle=function(){};e.prototype.DrawPolygon=function(){};e.prototype.DrawSegment=function(){};e.prototype.DrawSolidCircle=function(){};e.prototype.DrawSolidPolygon=function(){};e.prototype.DrawTransform=function(){};e.prototype.GetAlpha=function(){};e.prototype.GetDrawScale=function(){};e.prototype.GetFillAlpha=function(){};e.prototype.GetFlags=function(){};e.prototype.GetLineThickness=function(){};e.prototype.GetSprite=function(){};
e.prototype.GetXFormScale=function(){};e.prototype.SetAlpha=function(){};e.prototype.SetDrawScale=function(){};e.prototype.SetFillAlpha=function(){};e.prototype.SetFlags=function(){};e.prototype.SetLineThickness=function(){};e.prototype.SetSprite=function(){};e.prototype.SetXFormScale=function(){};Box2D.Dynamics.b2BodyDef=function(){this.position=a.Get(0,0);this.linearVelocity=a.Get(0,0);this.userData=null;this.angle=0;this.linearVelocity.Set(0,0);this.angularDamping=this.linearDamping=this.angularVelocity=
0;this.awake=this.allowSleep=!0;this.bullet=this.fixedRotation=!1;this.type=f.b2_staticBody;this.active=!0;this.inertiaScale=1};var h=function(b,c,d,e){this.m_body=b;this.m_userData=c;this.m_fixtureID=d;this.m_shape={};this.m_shape.m_centroid=a.Get(0,0);this.m_isSensor=!1;this.m_density=e.density;this.m_friction=e.friction;this.m_restitution=e.restitution;this.m_isSensor=e.isSensor};Box2D.Dynamics.b2Fixture=h;h.prototype.GetBody=function(){return this.m_body};h.prototype.GetShape=function(){console.log("fixture.GetShape not yet supported in CocoonJS Box2D binding");
return null};h.prototype.GetUserData=function(){return this.m_userData};h.prototype.SetSensor=function(a){this.m_isSensor=a;window.ext.IDTK_SRV_BOX2D.makeCall("setSensor",this.m_body.m_world.m_worldID,this.m_fixtureID,this.m_isSensor)};h.prototype.IsSensor=function(){return this.m_isSensor};h.prototype.SetDensity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setDensity",this.m_body.m_world.m_worldID,this.m_fixtureID,a);this.m_density=a};h.prototype.SetFriction=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFriction",
this.m_body.m_world.m_worldID,this.m_fixtureID,a);this.m_friction=a};h.prototype.SetRestitution=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setRestitution",this.m_body.m_world.m_worldID,this.m_fixtureID,a);this.m_restitution=a};h.prototype.GetDensity=function(){return this.m_density};h.prototype.GetFriction=function(){return this.m_friction};h.prototype.GetRestitution=function(){return this.m_restitution};var f=function(a,d){var e=a.userData;a.userData=null;this.m_world=d;this.m_xf=new c(a.position,
b.FromAngle(a.angle));this.m_fixtures=[];this.m_active=a.active;a.type===f.b2_staticBody&&(a.density=0);this.m_bodyID=window.ext.IDTK_SRV_BOX2D.makeCall("createBody",d.m_worldID,a);this.m_userData=e;a.userData=e};Box2D.Dynamics.b2Body=f;f.prototype.CreateFixture=function(a){var b=a.userData;a.userData=null;var c=window.ext.IDTK_SRV_BOX2D.makeCall("createFixture",this.m_world.m_worldID,this.m_bodyID,a);a.userData=b;a=new h(this,b,c,a);this.m_world.m_fixturesList[c]=a;this.m_fixtures.push(a);return a};
f.prototype.GetFixtureList=function(){return 0===this.m_fixtures.length?null:this.m_fixtures[0]};f.prototype.DestroyFixture=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteFixture",this.m_world.m_worldID,a.m_fixtureID);delete this.m_world.m_fixturesList[a.m_fixtureID]};f.prototype.SetPositionAndAngle=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("setBodyTransform",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b);this.m_xf.R.Set(b);this.m_xf.position.SetV(a)};f.prototype.GetPosition=function(){return this.m_xf.position};
f.prototype.SetPosition=function(a){this.SetPositionAndAngle(a,this.GetAngle())};f.prototype.GetLinearVelocity=function(){var b=window.ext.IDTK_SRV_BOX2D.makeCall("getLinearVelocity",this.m_world.m_worldID,this.m_bodyID);return a.Get(b[0],b[1])};f.prototype.GetWorldCenter=function(){var b=window.ext.IDTK_SRV_BOX2D.makeCall("getWorldCenter",this.m_world.m_worldID,this.m_bodyID);return a.Get(b[0],b[1])};f.prototype.GetLocalCenter=function(){var b=window.ext.IDTK_SRV_BOX2D.makeCall("getLocalCenter",
this.m_world.m_worldID,this.m_bodyID);return a.Get(b[0],b[1])};f.prototype.GetLocalPoint=function(a){return d.MulXT(this.m_xf,a)};f.prototype.ApplyImpulse=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyImpulse",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)};f.prototype.GetMass=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getMass",this.m_world.m_worldID,this.m_bodyID)};f.prototype.IsAwake=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("isAwake",this.m_world.m_worldID,
this.m_bodyID)};f.prototype.GetAngularVelocity=function(){return window.ext.IDTK_SRV_BOX2D.makeCall("getAngularVelocity",this.m_world.m_worldID,this.m_bodyID)};f.prototype.SetFixedRotation=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setFixedRotation",this.m_world.m_worldID,this.m_bodyID,a)};f.prototype.SetAwake=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAwake",this.m_world.m_worldID,this.m_bodyID,a)};f.prototype.SetLinearVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearVelocity",
this.m_world.m_worldID,this.m_bodyID,a.x,a.y)};f.prototype.ApplyForceToCenter=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyForceToCenter",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b)};f.prototype.ApplyForce=function(a,b,c){window.ext.IDTK_SRV_BOX2D.makeCall("applyForce",this.m_world.m_worldID,this.m_bodyID,a.x,a.y,b.x,b.y,c)};f.prototype.ApplyTorque=function(a,b){window.ext.IDTK_SRV_BOX2D.makeCall("applyTorque",this.m_world.m_worldID,this.m_bodyID,a,b)};f.prototype.SetLinearDamping=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setLinearDamping",
this.m_world.m_worldID,this.m_bodyID,a)};f.prototype.SetAngularVelocity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setAngularVelocity",this.m_world.m_worldID,this.m_bodyID,a)};f.prototype.SetType=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setType",this.m_world.m_worldID,this.m_bodyID,a)};f.prototype.SetActive=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setActive",this.m_world.m_worldID,this.m_bodyID,a);this.m_active=a};f.prototype.IsActive=function(){return this.m_active};f.prototype.GetAngle=
function(){return this.m_xf.R.GetAngle()};f.prototype.SetAngle=function(a){void 0===a&&(a=0);this.SetPositionAndAngle(this.GetPosition(),a)};f.prototype.GetContactList=function(){for(var a=window.ext.IDTK_SRV_BOX2D.makeCall("getObjectContacts",this.m_world.m_worldID,this.m_bodyID),b=[],c=0;c<a.length;c++)b.push(this.m_world.m_bodyList[a[c]]);return b};f.prototype.SetUserData=function(a){this.m_userData=a};f.prototype.GetUserData=function(){return this.m_userData};f.prototype.GetWorld=function(){return this.m_world};
Box2D.Dynamics.b2Body.b2_staticBody=0;Box2D.Dynamics.b2Body.b2_kinematicBody=1;Box2D.Dynamics.b2Body.b2_dynamicBody=2;var l=function(a,b,c){this.m_fixtureA=a;this.m_fixtureB=b;this.m_touching=c};Box2D.Dynamics.b2Contact=l;l.prototype.GetFixtureA=function(){return this.m_fixtureA};l.prototype.GetFixtureB=function(){return this.m_fixtureB};l.prototype.IsTouching=function(){return this.m_touching};e=function(){};Box2D.Dynamics.b2ContactListener=e;e.prototype.BeginContact=function(){};e.prototype.EndContact=
function(){};e.prototype.PreSolve=function(){};e.prototype.PostSolve=function(){};Box2D.Dynamics.b2ContactListener.b2_defaultListener=new e;Box2D.Dynamics.b2ContactFilter=function(){};e=function(a,b){this.m_bodyList=[];this.m_jointList=[];this.m_fixturesList=[];this.m_contactListener=null;this.m_jointsList=[];this.m_worldID=window.ext.IDTK_SRV_BOX2D.makeCall("createWorld",a.x,a.y,b)};Box2D.Dynamics.b2World=e;e.prototype.SetContactListener=function(a){this.m_contactListener=a};e.prototype.SetContactFilter=
function(a){var b=this;window.ext.IDTK_SRV_BOX2D.makeCall("setContactFilter",this.m_worldID,function(c,d){return a.ShouldCollide(b.m_fixturesList[c],b.m_fixturesList[d])})};e.prototype.CreateBody=function(a){a=new f(a,this);return this.m_bodyList[a.m_bodyID]=a};e.prototype.DestroyBody=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("deleteBody",this.m_worldID,a.m_bodyID);delete this.m_bodyList[a.m_bodyID];for(var b=0;b<a.m_fixtures.length;++b)delete this.m_fixturesList[a.m_fixtures[b].m_fixtureID]};
e.prototype.CreateJoint=function(a){if(a.bodyA.m_bodyID!==a.bodyB.m_bodyID){var b=a.bodyA,c=a.bodyB;a.bodyA=b.m_bodyID;a.bodyB=c.m_bodyID;var d="createDistanceJoint";a.type===k.e_revoluteJoint&&(d="createRevoluteJoint");var e=new k(a);e.m_jointID=window.ext.IDTK_SRV_BOX2D.makeCall(d,this.m_worldID,a);a.bodyA=b;a.bodyB=c;this.m_jointsList.push(e);return e}};e.prototype.DestroyJoint=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("destroyJoint",this.m_worldID,a.m_jointID)};e.prototype.GetJointList=function(){if(0===
this.m_jointsList.length)return null;for(var a=0;a<this.m_jointsList.length-1;++a)this.m_jointsList[a].next=this.m_jointsList[a+1];this.m_jointsList[this.m_jointsList.length-1].next=null;return this.m_jointsList[0]};e.prototype.SetContinuousPhysics=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setContinuous",this.m_worldID,a)};e.prototype.SetGravity=function(a){window.ext.IDTK_SRV_BOX2D.makeCall("setGravity",this.m_worldID,a.x,a.y)};e.prototype.Step=function(a,b,c){c=window.ext.IDTK_SRV_BOX2D.makeCall("step",
this.m_worldID,a,b,c);b=c[0];for(a=1;a<=4*b;a+=4){var d=this.m_bodyList[c[a+0]];if(null===d)break;d.m_xf.position.Set(c[a+1],c[a+2]);d.m_xf.R.Set(c[a+3])}if(null!==this.m_contactListener)for(c=window.ext.IDTK_SRV_BOX2D.makeCall("getLastContacts",this.m_worldID),b=c[0],a=1;a<=3*b;a+=3){var d=c[a+2],e=this.m_fixturesList[c[a+0]],f=this.m_fixturesList[c[a+1]];"undefined"===typeof e||"undefined"===typeof f?console.log("One of the fixtures in a contact DOESN'T EXIST!!"):this.m_contactListener.BeginContact(new l(e,
f,d))}};e.prototype.ClearForces=function(){window.ext.IDTK_SRV_BOX2D.makeCall("clearForces",this.m_worldID)};e.prototype.SetDebugDraw=function(){};e.prototype.DrawDebugData=function(){};Box2D.Collision.Shapes.b2CircleShape=function(a){this.radius=a;this.type="circle"};Box2D.Collision.Shapes.b2PolygonShape=function(){};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsBox=function(a,b){this.type="box";this.width=a;this.height=b};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsEdge=function(a,
b){this.type="edge";this.p1x=a.x;this.p1y=a.y;this.p2x=b.x;this.p2y=b.y};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsArray=function(a,b){this.type="polygon";this.vertices=[];for(var c=0;c<b;c++)this.vertices.push(a[c].x),this.vertices.push(a[c].y)};Box2D.Dynamics.b2FixtureDef=function(){this.userData=this.shape=null;this.friction=0.2;this.density=this.restitution=0;this.isSensor=!1;this.filter={categoryBits:1,maskBits:65535,groupIndex:0}};var k=function(a){this.bodyA=a.bodyA;this.bodyB=a.bodyB;
this.userData=a.userData;this.type=a.type;this.next=null};Box2D.Dynamics.Joints.b2Joint=k;k.prototype.GetBodyA=function(){return this.bodyA};k.prototype.GetBodyB=function(){return this.bodyB};k.prototype.GetUserData=function(){return this.userData};k.prototype.GetType=function(){return this.type};k.prototype.GetNext=function(){return this.next};k.e_distanceJoint=0;k.e_revoluteJoint=1;Box2D.Dynamics.Joints.b2DistanceJointDef=function(b,c,d,e){this.type=k.e_distanceJoint;this.localAnchorA=a.Get(0,0);
this.localAnchorB=a.Get(0,0);this.userData=null;void 0!==b&&(this.bodyA=b);void 0!==c&&(this.bodyB=c);void 0!==d&&this.localAnchorA.SetV(d);void 0!==e&&this.localAnchorB.SetV(e);void 0!==d&&void 0!==e&&(b=e.x-d.x,d=e.y-d.y,this.length=Math.sqrt(b*b+d*d));this.dampingRatio=this.frequencyHz=0};e=function(b,c,d,e){this.type=k.e_revoluteJoint;this.localAnchorA=new a;this.localAnchorB=new a;this.userData=null;void 0!==b&&(this.bodyA=b);void 0!==c&&(this.bodyB=c);void 0!==d&&this.localAnchorA.SetV(d);void 0!==
e&&this.localAnchorB.SetV(e);this.motorSpeed=this.maxMotorTorque=this.upperAngle=this.lowerAngle=this.referenceAngle=0;this.enableMotor=this.enableLimit=!1};e.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2RevoluteJointDef=e}():console.log("The CocoonJS binding for Box2D has been ignored because ext.IDTK_SRV_BOX2D is not available");
else{Box2D.Collision.b2Collision={};Box2D.Collision.b2Distance={};Box2D.Common.b2Settings={};Box2D.Common.Math.b2Math={};Box2D.Consts={};Box2D.Dynamics.Contacts={};Box2D.Dynamics.Controllers={};Box2D.generateCallback=function(a,b){return function(){b.apply(a,arguments)}};Box2D.Consts.MIN_VALUE_SQUARED=Number.MIN_VALUE*Number.MIN_VALUE;Box2D.Common.b2Settings.b2MixFriction=function(a,b){return Math.sqrt(a*b)};Box2D.Common.b2Settings.b2MixRestitution=function(a,b){return a>b?a:b};Box2D.Common.b2Settings.VERSION=
"2.1alpha-illandril";Box2D.Common.b2Settings.USHRT_MAX=65535;Box2D.Common.b2Settings.b2_maxManifoldPoints=2;Box2D.Common.b2Settings.b2_aabbExtension=0.1;Box2D.Common.b2Settings.b2_aabbMultiplier=2;Box2D.Common.b2Settings.b2_polygonRadius=2*Box2D.Common.b2Settings.b2_linearSlop;Box2D.Common.b2Settings.b2_linearSlop=0.005;Box2D.Common.b2Settings.b2_angularSlop=2/180*Math.PI;Box2D.Common.b2Settings.b2_toiSlop=8*Box2D.Common.b2Settings.b2_linearSlop;Box2D.Common.b2Settings.b2_maxTOIContactsPerIsland=
32;Box2D.Common.b2Settings.b2_maxTOIJointsPerIsland=32;Box2D.Common.b2Settings.b2_velocityThreshold=1;Box2D.Common.b2Settings.b2_maxLinearCorrection=0.2;Box2D.Common.b2Settings.b2_maxAngularCorrection=8/180*Math.PI;Box2D.Common.b2Settings.b2_maxTranslation=2;Box2D.Common.b2Settings.b2_maxTranslationSquared=Box2D.Common.b2Settings.b2_maxTranslation*Box2D.Common.b2Settings.b2_maxTranslation;Box2D.Common.b2Settings.b2_maxRotation=0.5*Math.PI;Box2D.Common.b2Settings.b2_maxRotationSquared=Box2D.Common.b2Settings.b2_maxRotation*
Box2D.Common.b2Settings.b2_maxRotation;Box2D.Common.b2Settings.b2_contactBaumgarte=0.2;Box2D.Common.b2Settings.b2_timeToSleep=0.5;Box2D.Common.b2Settings.b2_linearSleepTolerance=0.01;Box2D.Common.b2Settings.b2_linearSleepToleranceSquared=Box2D.Common.b2Settings.b2_linearSleepTolerance*Box2D.Common.b2Settings.b2_linearSleepTolerance;Box2D.Common.b2Settings.b2_angularSleepTolerance=2/180*Math.PI;Box2D.Common.b2Settings.b2_angularSleepToleranceSquared=Box2D.Common.b2Settings.b2_angularSleepTolerance*
Box2D.Common.b2Settings.b2_angularSleepTolerance;Box2D.Common.b2Settings.MIN_VALUE_SQUARED=Number.MIN_VALUE*Number.MIN_VALUE;Box2D.Common.Math.b2Math.Dot=function(a,b){return a.x*b.x+a.y*b.y};Box2D.Common.Math.b2Math.CrossVV=function(a,b){return a.x*b.y-a.y*b.x};Box2D.Common.Math.b2Math.CrossVF=function(a,b){return Box2D.Common.Math.b2Vec2.Get(b*a.y,-b*a.x)};Box2D.Common.Math.b2Math.CrossFV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(-a*b.y,a*b.x)};Box2D.Common.Math.b2Math.MulMV=function(a,
b){return Box2D.Common.Math.b2Vec2.Get(a.col1.x*b.x+a.col2.x*b.y,a.col1.y*b.x+a.col2.y*b.y)};Box2D.Common.Math.b2Math.MulTMV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(Box2D.Common.Math.b2Math.Dot(b,a.col1),Box2D.Common.Math.b2Math.Dot(b,a.col2))};Box2D.Common.Math.b2Math.MulX=function(a,b){var c=Box2D.Common.Math.b2Math.MulMV(a.R,b);c.x+=a.position.x;c.y+=a.position.y;return c};Box2D.Common.Math.b2Math.MulXT=function(a,b){var c=Box2D.Common.Math.b2Math.SubtractVV(b,a.position),d=c.x*a.R.col1.x+
c.y*a.R.col1.y;c.y=c.x*a.R.col2.x+c.y*a.R.col2.y;c.x=d;return c};Box2D.Common.Math.b2Math.AddVV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(a.x+b.x,a.y+b.y)};Box2D.Common.Math.b2Math.SubtractVV=function(a,b){return Box2D.Common.Math.b2Vec2.Get(a.x-b.x,a.y-b.y)};Box2D.Common.Math.b2Math.Distance=function(a,b){return Math.sqrt(Box2D.Common.Math.b2Math.DistanceSquared(a,b))};Box2D.Common.Math.b2Math.DistanceSquared=function(a,b){var c=a.x-b.x,d=a.y-b.y;return c*c+d*d};Box2D.Common.Math.b2Math.MulFV=
function(a,b){return Box2D.Common.Math.b2Vec2.Get(a*b.x,a*b.y)};Box2D.Common.Math.b2Math.AddMM=function(a,b){return Box2D.Common.Math.b2Mat22.FromVV(Box2D.Common.Math.b2Math.AddVV(a.col1,b.col1),Box2D.Common.Math.b2Math.AddVV(a.col2,b.col2))};Box2D.Common.Math.b2Math.MulMM=function(a,b){return Box2D.Common.Math.b2Mat22.FromVV(Box2D.Common.Math.b2Math.MulMV(a,b.col1),Box2D.Common.Math.b2Math.MulMV(a,b.col2))};Box2D.Common.Math.b2Math.MulTMM=function(a,b){var c=Box2D.Common.Math.b2Vec2.Get(Box2D.Common.Math.b2Math.Dot(a.col1,
b.col1),Box2D.Common.Math.b2Math.Dot(a.col2,b.col1)),d=Box2D.Common.Math.b2Vec2.Get(Box2D.Common.Math.b2Math.Dot(a.col1,b.col2),Box2D.Common.Math.b2Math.Dot(a.col2,b.col2));return Box2D.Common.Math.b2Mat22.FromVV(c,d)};Box2D.Common.Math.b2Math.AbsV=function(a){return Box2D.Common.Math.b2Vec2.Get(Math.abs(a.x),Math.abs(a.y))};Box2D.Common.Math.b2Math.AbsM=function(a){return Box2D.Common.Math.b2Mat22.FromVV(Box2D.Common.Math.b2Math.AbsV(a.col1),Box2D.Common.Math.b2Math.AbsV(a.col2))};Box2D.Common.Math.b2Math.Clamp=
function(a,b,c){return a<b?b:a>c?c:a};Box2D.Common.Math.b2Math.ClampV=function(a,b,c){var d=Box2D.Common.Math.b2Math.Clamp(a.x,b.x,c.x);a=Box2D.Common.Math.b2Math.Clamp(a.y,b.y,c.y);return Box2D.Common.Math.b2Vec2.Get(d,a)};Box2D.Common.Math.b2Mat22=function(){this.col1=Box2D.Common.Math.b2Vec2.Get(0,0);this.col2=Box2D.Common.Math.b2Vec2.Get(0,0);this.SetIdentity()};Box2D.Common.Math.b2Mat22.FromAngle=function(a){var b=new Box2D.Common.Math.b2Mat22;b.Set(a);return b};Box2D.Common.Math.b2Mat22.FromVV=
function(a,b){var c=new Box2D.Common.Math.b2Mat22;c.SetVV(a,b);return c};Box2D.Common.Math.b2Mat22.prototype.Set=function(a){var b=Math.cos(a);a=Math.sin(a);this.col1.Set(b,a);this.col2.Set(-a,b)};Box2D.Common.Math.b2Mat22.prototype.SetVV=function(a,b){this.col1.SetV(a);this.col2.SetV(b)};Box2D.Common.Math.b2Mat22.prototype.Copy=function(){var a=new Box2D.Common.Math.b2Mat22;a.SetM(this);return a};Box2D.Common.Math.b2Mat22.prototype.SetM=function(a){this.col1.SetV(a.col1);this.col2.SetV(a.col2)};
Box2D.Common.Math.b2Mat22.prototype.AddM=function(a){this.col1.Add(a.col1);this.col2.Add(a.col2)};Box2D.Common.Math.b2Mat22.prototype.SetIdentity=function(){this.col1.Set(1,0);this.col2.Set(0,1)};Box2D.Common.Math.b2Mat22.prototype.SetZero=function(){this.col1.Set(0,0);this.col2.Set(0,0)};Box2D.Common.Math.b2Mat22.prototype.GetAngle=function(){return Math.atan2(this.col1.y,this.col1.x)};Box2D.Common.Math.b2Mat22.prototype.GetInverse=function(a){var b=this.col1.x*this.col2.y-this.col2.x*this.col1.y;
0!==b&&(b=1/b);a.col1.x=b*this.col2.y;a.col2.x=-b*this.col2.x;a.col1.y=-b*this.col1.y;a.col2.y=b*this.col1.x;return a};Box2D.Common.Math.b2Mat22.prototype.Solve=function(a,b,c){var d=this.col1.x*this.col2.y-this.col2.x*this.col1.y;0!==d&&(d=1/d);a.x=d*(this.col2.y*b-this.col2.x*c);a.y=d*(this.col1.x*c-this.col1.y*b);return a};Box2D.Common.Math.b2Mat22.prototype.Abs=function(){this.col1.Abs();this.col2.Abs()};Box2D.Common.Math.b2Mat33=function(a,b,c){this.col1=new Box2D.Common.Math.b2Vec3(0,0,0);this.col2=
new Box2D.Common.Math.b2Vec3(0,0,0);this.col3=new Box2D.Common.Math.b2Vec3(0,0,0);a&&this.col1.SetV(a);b&&this.col2.SetV(b);c&&this.col3.SetV(c)};Box2D.Common.Math.b2Mat33.prototype.SetVVV=function(a,b,c){this.col1.SetV(a);this.col2.SetV(b);this.col3.SetV(c)};Box2D.Common.Math.b2Mat33.prototype.Copy=function(){return new Box2D.Common.Math.b2Mat33(this.col1,this.col2,this.col3)};Box2D.Common.Math.b2Mat33.prototype.SetM=function(a){this.col1.SetV(a.col1);this.col2.SetV(a.col2);this.col3.SetV(a.col3)};
Box2D.Common.Math.b2Mat33.prototype.AddM=function(a){this.col1.x+=a.col1.x;this.col1.y+=a.col1.y;this.col1.z+=a.col1.z;this.col2.x+=a.col2.x;this.col2.y+=a.col2.y;this.col2.z+=a.col2.z;this.col3.x+=a.col3.x;this.col3.y+=a.col3.y;this.col3.z+=a.col3.z};Box2D.Common.Math.b2Mat33.prototype.SetIdentity=function(){this.col1.Set(1,0,0);this.col2.Set(0,1,0);this.col3.Set(0,0,1)};Box2D.Common.Math.b2Mat33.prototype.SetZero=function(){this.col1.Set(0,0,0);this.col2.Set(0,0,0);this.col3.Set(0,0,0)};Box2D.Common.Math.b2Mat33.prototype.Solve22=
function(a,b,c){var d=this.col1.x,e=this.col2.x,h=this.col1.y,f=this.col2.y,l=d*f-e*h;0!=l&&(l=1/l);a.x=l*(f*b-e*c);a.y=l*(d*c-h*b);return a};Box2D.Common.Math.b2Mat33.prototype.Solve33=function(a,b,c,d){var e=this.col1.x,h=this.col1.y,f=this.col1.z,l=this.col2.x,k=this.col2.y,g=this.col2.z,m=this.col3.x,n=this.col3.y,p=this.col3.z,r=e*(k*p-g*n)+h*(g*m-l*p)+f*(l*n-k*m);0!=r&&(r=1/r);a.x=r*(b*(k*p-g*n)+c*(g*m-l*p)+d*(l*n-k*m));a.y=r*(e*(c*p-d*n)+h*(d*m-b*p)+f*(b*n-c*m));a.z=r*(e*(k*d-g*c)+h*(g*b-l*
d)+f*(l*c-k*b));return a};Box2D.Common.Math.b2Sweep=function(){this.localCenter=Box2D.Common.Math.b2Vec2.Get(0,0);this.c0=Box2D.Common.Math.b2Vec2.Get(0,0);this.c=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Common.Math.b2Sweep.prototype.Set=function(a){this.localCenter.SetV(a.localCenter);this.c0.SetV(a.c0);this.c.SetV(a.c);this.a0=a.a0;this.a=a.a;this.t0=a.t0};Box2D.Common.Math.b2Sweep.prototype.Copy=function(){var a=new Box2D.Common.Math.b2Sweep;a.localCenter.SetV(this.localCenter);a.c0.SetV(this.c0);
a.c.SetV(this.c);a.a0=this.a0;a.a=this.a;a.t0=this.t0;return a};Box2D.Common.Math.b2Sweep.prototype.GetTransform=function(a,b){void 0===b&&(b=0);a.position.x=(1-b)*this.c0.x+b*this.c.x;a.position.y=(1-b)*this.c0.y+b*this.c.y;a.R.Set((1-b)*this.a0+b*this.a);var c=a.R;a.position.x-=c.col1.x*this.localCenter.x+c.col2.x*this.localCenter.y;a.position.y-=c.col1.y*this.localCenter.x+c.col2.y*this.localCenter.y};Box2D.Common.Math.b2Sweep.prototype.Advance=function(a){void 0===a&&(a=0);if(this.t0<a&&1-this.t0>
Number.MIN_VALUE){var b=(a-this.t0)/(1-this.t0);this.c0.x=(1-b)*this.c0.x+b*this.c.x;this.c0.y=(1-b)*this.c0.y+b*this.c.y;this.a0=(1-b)*this.a0+b*this.a;this.t0=a}};Box2D.Common.Math.b2Transform=function(a,b){this.position=Box2D.Common.Math.b2Vec2.Get(0,0);this.R=new Box2D.Common.Math.b2Mat22;a&&this.position.SetV(a);b&&this.R.SetM(b)};Box2D.Common.Math.b2Transform.prototype.Initialize=function(a,b){this.position.SetV(a);this.R.SetM(b)};Box2D.Common.Math.b2Transform.prototype.SetIdentity=function(){this.position.SetZero();
this.R.SetIdentity()};Box2D.Common.Math.b2Transform.prototype.Set=function(a){this.position.SetV(a.position);this.R.SetM(a.R)};Box2D.Common.Math.b2Transform.prototype.GetAngle=function(){return Math.atan2(this.R.col1.y,this.R.col1.x)};Box2D.Common.Math.b2Vec2=function(a,b){this.x=a;this.y=b};Box2D.Common.Math.b2Vec2._freeCache=[];Box2D.Common.Math.b2Vec2.Get=function(a,b){if(0<Box2D.Common.Math.b2Vec2._freeCache.length){var c=Box2D.Common.Math.b2Vec2._freeCache.pop();c.Set(a,b);return c}return new Box2D.Common.Math.b2Vec2(a,
b)};Box2D.Common.Math.b2Vec2.Free=function(a){Box2D.Common.Math.b2Vec2._freeCache.push(a)};Box2D.Common.Math.b2Vec2.prototype.SetZero=function(){this.y=this.x=0};Box2D.Common.Math.b2Vec2.prototype.Set=function(a,b){this.x=a;this.y=b};Box2D.Common.Math.b2Vec2.prototype.SetV=function(a){this.x=a.x;this.y=a.y};Box2D.Common.Math.b2Vec2.prototype.GetNegative=function(){return Box2D.Common.Math.b2Vec2.Get(-this.x,-this.y)};Box2D.Common.Math.b2Vec2.prototype.NegativeSelf=function(){this.x=-this.x;this.y=
-this.y};Box2D.Common.Math.b2Vec2.prototype.Copy=function(){return Box2D.Common.Math.b2Vec2.Get(this.x,this.y)};Box2D.Common.Math.b2Vec2.prototype.Add=function(a){this.x+=a.x;this.y+=a.y};Box2D.Common.Math.b2Vec2.prototype.Subtract=function(a){this.x-=a.x;this.y-=a.y};Box2D.Common.Math.b2Vec2.prototype.Multiply=function(a){this.x*=a;this.y*=a};Box2D.Common.Math.b2Vec2.prototype.MulM=function(a){var b=this.x;this.x=a.col1.x*b+a.col2.x*this.y;this.y=a.col1.y*b+a.col2.y*this.y};Box2D.Common.Math.b2Vec2.prototype.MulTM=
function(a){var b=this.x*a.col1.x+this.y*a.col1.y;this.y=this.x*a.col2.x+this.y*a.col2.y;this.x=b};Box2D.Common.Math.b2Vec2.prototype.CrossVF=function(a){var b=this.x;this.x=a*this.y;this.y=-a*b};Box2D.Common.Math.b2Vec2.prototype.CrossFV=function(a){var b=this.x;this.x=-a*this.y;this.y=a*b};Box2D.Common.Math.b2Vec2.prototype.MinV=function(a){this.x=Math.min(this.x,a.x);this.y=Math.min(this.y,a.y)};Box2D.Common.Math.b2Vec2.prototype.MaxV=function(a){this.x=Math.max(this.x,a.x);this.y=Math.max(this.y,
a.y)};Box2D.Common.Math.b2Vec2.prototype.Abs=function(){this.x=Math.abs(this.x);this.y=Math.abs(this.y)};Box2D.Common.Math.b2Vec2.prototype.Length=function(){return Math.sqrt(this.LengthSquared())};Box2D.Common.Math.b2Vec2.prototype.LengthSquared=function(){return this.x*this.x+this.y*this.y};Box2D.Common.Math.b2Vec2.prototype.Normalize=function(){var a=this.Length();if(a<Number.MIN_VALUE)return 0;var b=1/a;this.x*=b;this.y*=b;return a};Box2D.Common.Math.b2Vec2.prototype.IsValid=function(){return isFinite(this.x)&&
isFinite(this.y)};Box2D.Common.Math.b2Vec3=function(a,b,c){this.x=a;this.y=b;this.z=c};Box2D.Common.Math.b2Vec3.prototype.SetZero=function(){this.z=this.y=this.x=0};Box2D.Common.Math.b2Vec3.prototype.Set=function(a,b,c){this.x=a;this.y=b;this.z=c};Box2D.Common.Math.b2Vec3.prototype.SetV=function(a){this.x=a.x;this.y=a.y;this.z=a.z};Box2D.Common.Math.b2Vec3.prototype.GetNegative=function(){return new Box2D.Common.Math.b2Vec3(-this.x,-this.y,-this.z)};Box2D.Common.Math.b2Vec3.prototype.NegativeSelf=
function(){this.x=-this.x;this.y=-this.y;this.z=-this.z};Box2D.Common.Math.b2Vec3.prototype.Copy=function(){return new Box2D.Common.Math.b2Vec3(this.x,this.y,this.z)};Box2D.Common.Math.b2Vec3.prototype.Add=function(a){this.x+=a.x;this.y+=a.y;this.z+=a.z};Box2D.Common.Math.b2Vec3.prototype.Subtract=function(a){this.x-=a.x;this.y-=a.y;this.z-=a.z};Box2D.Common.Math.b2Vec3.prototype.Multiply=function(a){this.x*=a;this.y*=a;this.z*=a};Box2D.Collision.Shapes.b2Shape=function(){this.m_radius=Box2D.Common.b2Settings.b2_linearSlop};
Box2D.Collision.Shapes.b2Shape.prototype.GetTypeName=function(){};Box2D.Collision.Shapes.b2Shape.prototype.Copy=function(){};Box2D.Collision.Shapes.b2Shape.prototype.Set=function(a){this.m_radius=a.m_radius};Box2D.Collision.Shapes.b2Shape.prototype.TestPoint=function(){};Box2D.Collision.Shapes.b2Shape.prototype.RayCast=function(){};Box2D.Collision.Shapes.b2Shape.prototype.ComputeAABB=function(){};Box2D.Collision.Shapes.b2Shape.prototype.ComputeMass=function(){};Box2D.Collision.Shapes.b2Shape.prototype.ComputeSubmergedArea=
function(){};Box2D.Collision.Shapes.b2Shape.prototype.SetDistanceProxy=function(){};Box2D.Collision.Shapes.b2Shape.TestOverlap=function(a,b,c,d){var e=new Box2D.Collision.b2DistanceInput;e.proxyA=new Box2D.Collision.b2DistanceProxy;e.proxyA.Set(a);e.proxyB=new Box2D.Collision.b2DistanceProxy;e.proxyB.Set(c);e.transformA=b;e.transformB=d;e.useRadii=!0;a=new Box2D.Collision.b2SimplexCache;a.count=0;b=new Box2D.Collision.b2DistanceOutput;Box2D.Collision.b2Distance.Distance(b,a,e);return b.distance<10*
Number.MIN_VALUE};Box2D.Collision.Shapes.b2Shape.e_startsInsideCollide=-1;Box2D.Collision.Shapes.b2Shape.e_missCollide=0;Box2D.Collision.Shapes.b2Shape.e_hitCollide=1;Box2D.Collision.Shapes.b2CircleShape=function(a){Box2D.Collision.Shapes.b2Shape.call(this);this.m_radius=a;this.m_radiusSquared=a*a;this.m_p=Box2D.Common.Math.b2Vec2.Get(0,0)};c2inherit(Box2D.Collision.Shapes.b2CircleShape,Box2D.Collision.Shapes.b2Shape);Box2D.Collision.Shapes.b2CircleShape.prototype.GetTypeName=function(){return Box2D.Collision.Shapes.b2CircleShape.NAME};
Box2D.Collision.Shapes.b2CircleShape.prototype.Copy=function(){var a=new Box2D.Collision.Shapes.b2CircleShape(this.m_radius);a.Set(this);return a};Box2D.Collision.Shapes.b2CircleShape.prototype.Set=function(a){Box2D.Collision.Shapes.b2Shape.prototype.Set.call(this,a);a instanceof Box2D.Collision.Shapes.b2CircleShape&&this.m_p.SetV(a.m_p)};Box2D.Collision.Shapes.b2CircleShape.prototype.TestPoint=function(a,b){var c=b.x-(a.position.x+(a.R.col1.x*this.m_p.x+a.R.col2.x*this.m_p.y)),d=b.y-(a.position.y+
(a.R.col1.y*this.m_p.x+a.R.col2.y*this.m_p.y));return c*c+d*d<=this.m_radiusSquared};Box2D.Collision.Shapes.b2CircleShape.prototype.RayCast=function(a,b,c){var d=c.R,e=b.p1.x-(c.position.x+(d.col1.x*this.m_p.x+d.col2.x*this.m_p.y));c=b.p1.y-(c.position.y+(d.col1.y*this.m_p.x+d.col2.y*this.m_p.y));var d=b.p2.x-b.p1.x,h=b.p2.y-b.p1.y,f=e*d+c*h,l=d*d+h*h,k=f*f-l*(e*e+c*c-this.m_radiusSquared);if(0>k||l<Number.MIN_VALUE)return!1;f=-(f+Math.sqrt(k));return 0<=f&&f<=b.maxFraction*l?(f/=l,a.fraction=f,a.normal.x=
e+f*d,a.normal.y=c+f*h,a.normal.Normalize(),!0):!1};Box2D.Collision.Shapes.b2CircleShape.prototype.ComputeAABB=function(a,b){var c=b.R,d=b.position.x+(c.col1.x*this.m_p.x+c.col2.x*this.m_p.y),c=b.position.y+(c.col1.y*this.m_p.x+c.col2.y*this.m_p.y);a.lowerBound_.Set(d-this.m_radius,c-this.m_radius);a.upperBound_.Set(d+this.m_radius,c+this.m_radius)};Box2D.Collision.Shapes.b2CircleShape.prototype.ComputeMass=function(a,b){a.mass=b*Math.PI*this.m_radiusSquared;a.center.SetV(this.m_p);a.I=a.mass*(0.5*
this.m_radiusSquared+(this.m_p.x*this.m_p.x+this.m_p.y*this.m_p.y))};Box2D.Collision.Shapes.b2CircleShape.prototype.ComputeSubmergedArea=function(a,b,c,d){c=Box2D.Common.Math.b2Math.MulX(c,this.m_p);var e=-(Box2D.Common.Math.b2Math.Dot(a,c)-b);if(e<-this.m_radius+Number.MIN_VALUE)return 0;if(e>this.m_radius)return d.SetV(c),Math.PI*this.m_radiusSquared;b=e*e;e=this.m_radiusSquared*(Math.asin(e/this.m_radius)+Math.PI/2)+e*Math.sqrt(this.m_radiusSquared-b);b=-2/3*Math.pow(this.m_radiusSquared-b,1.5)/
e;d.x=c.x+a.x*b;d.y=c.y+a.y*b;return e};Box2D.Collision.Shapes.b2CircleShape.prototype.SetDistanceProxy=function(a){a.m_vertices=[this.m_p];a.m_count=1;a.m_radius=this.m_radius};Box2D.Collision.Shapes.b2CircleShape.prototype.GetLocalPosition=function(){return this.m_p};Box2D.Collision.Shapes.b2CircleShape.prototype.SetLocalPosition=function(a){this.m_p.SetV(a)};Box2D.Collision.Shapes.b2CircleShape.prototype.GetRadius=function(){return this.m_radius};Box2D.Collision.Shapes.b2CircleShape.prototype.SetRadius=
function(a){this.m_radius=a;this.m_radiusSquared=a*a};Box2D.Collision.Shapes.b2CircleShape.NAME="b2CircleShape";Box2D.Collision.Shapes.b2EdgeChainDef=function(){this.vertexCount=0;this.isALoop=!0;this.vertices=[]};Box2D.Collision.Shapes.b2EdgeShape=function(a,b){Box2D.Collision.Shapes.b2Shape.call(this);this.m_nextEdge=this.m_prevEdge=null;this.m_v1=a;this.m_v2=b;this.m_direction=Box2D.Common.Math.b2Vec2.Get(this.m_v2.x-this.m_v1.x,this.m_v2.y-this.m_v1.y);this.m_length=this.m_direction.Normalize();
this.m_normal=Box2D.Common.Math.b2Vec2.Get(this.m_direction.y,-this.m_direction.x);this.m_coreV1=Box2D.Common.Math.b2Vec2.Get(-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.x-this.m_direction.x)+this.m_v1.x,-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.y-this.m_direction.y)+this.m_v1.y);this.m_coreV2=Box2D.Common.Math.b2Vec2.Get(-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.x+this.m_direction.x)+this.m_v2.x,-Box2D.Common.b2Settings.b2_toiSlop*(this.m_normal.y+this.m_direction.y)+this.m_v2.y);
this.m_cornerDir1=this.m_normal;this.m_cornerDir2=Box2D.Common.Math.b2Vec2.Get(-this.m_normal.x,-this.m_normal.y);this.m_cornerConvex2=this.m_cornerConvex1=!1};c2inherit(Box2D.Collision.Shapes.b2EdgeShape,Box2D.Collision.Shapes.b2Shape);Box2D.Collision.Shapes.b2EdgeShape.prototype.GetTypeName=function(){return Box2D.Collision.Shapes.b2EdgeShape.NAME};Box2D.Collision.Shapes.b2EdgeShape.prototype.TestPoint=function(a,b){return!1};Box2D.Collision.Shapes.b2EdgeShape.prototype.RayCast=function(a,b,c){var d=
b.p2.x-b.p1.x,e=b.p2.y-b.p1.y,h=c.R,f=c.position.x+(h.col1.x*this.m_v1.x+h.col2.x*this.m_v1.y),l=c.position.y+(h.col1.y*this.m_v1.x+h.col2.y*this.m_v1.y),k=c.position.y+(h.col1.y*this.m_v2.x+h.col2.y*this.m_v2.y)-l;c=-(c.position.x+(h.col1.x*this.m_v2.x+h.col2.x*this.m_v2.y)-f);var h=100*Number.MIN_VALUE,g=-(d*k+e*c);if(g>h){var f=b.p1.x-f,m=b.p1.y-l,l=f*k+m*c;if(0<=l&&l<=b.maxFraction*g&&(b=-d*m+e*f,-h*g<=b&&b<=g*(1+h)))return a.fraction=l/g,b=Math.sqrt(k*k+c*c),a.normal.x=k/b,a.normal.y=c/b,!0}return!1};
Box2D.Collision.Shapes.b2EdgeShape.prototype.ComputeAABB=function(a,b){var c=b.R,d=b.position.x+(c.col1.x*this.m_v1.x+c.col2.x*this.m_v1.y),e=b.position.y+(c.col1.y*this.m_v1.x+c.col2.y*this.m_v1.y),h=b.position.x+(c.col1.x*this.m_v2.x+c.col2.x*this.m_v2.y),c=b.position.y+(c.col1.y*this.m_v2.x+c.col2.y*this.m_v2.y);d<h?(a.lowerBound_.x=d,a.upperBound_.x=h):(a.lowerBound_.x=h,a.upperBound_.x=d);e<c?(a.lowerBound_.y=e,a.upperBound_.y=c):(a.lowerBound_.y=c,a.upperBound_.y=e)};Box2D.Collision.Shapes.b2EdgeShape.prototype.ComputeMass=
function(a,b){a.mass=0;a.center.SetV(this.m_v1);a.I=0};Box2D.Collision.Shapes.b2EdgeShape.prototype.ComputeSubmergedArea=function(a,b,c,d){void 0===b&&(b=0);var e=Box2D.Common.Math.b2Vec2.Get(a.x*b,a.y*b),h=Box2D.Common.Math.b2Math.MulX(c,this.m_v1);c=Box2D.Common.Math.b2Math.MulX(c,this.m_v2);var f=Box2D.Common.Math.b2Math.Dot(a,h)-b;a=Box2D.Common.Math.b2Math.Dot(a,c)-b;if(0<f){if(0<a)return 0;h.x=-a/(f-a)*h.x+f/(f-a)*c.x;h.y=-a/(f-a)*h.y+f/(f-a)*c.y}else 0<a&&(c.x=-a/(f-a)*h.x+f/(f-a)*c.x,c.y=
-a/(f-a)*h.y+f/(f-a)*c.y);d.x=(e.x+h.x+c.x)/3;d.y=(e.y+h.y+c.y)/3;return 0.5*((h.x-e.x)*(c.y-e.y)-(h.y-e.y)*(c.x-e.x))};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetLength=function(){return this.m_length};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetVertex1=function(){return this.m_v1};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetVertex2=function(){return this.m_v2};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCoreVertex1=function(){return this.m_coreV1};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCoreVertex2=
function(){return this.m_coreV2};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetNormalVector=function(){return this.m_normal};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetDirectionVector=function(){return this.m_direction};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCorner1Vector=function(){return this.m_cornerDir1};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetCorner2Vector=function(){return this.m_cornerDir2};Box2D.Collision.Shapes.b2EdgeShape.prototype.Corner1IsConvex=function(){return this.m_cornerConvex1};
Box2D.Collision.Shapes.b2EdgeShape.prototype.Corner2IsConvex=function(){return this.m_cornerConvex2};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetFirstVertex=function(a){var b=a.R;return Box2D.Common.Math.b2Vec2.Get(a.position.x+(b.col1.x*this.m_coreV1.x+b.col2.x*this.m_coreV1.y),a.position.y+(b.col1.y*this.m_coreV1.x+b.col2.y*this.m_coreV1.y))};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetNextEdge=function(){return this.m_nextEdge};Box2D.Collision.Shapes.b2EdgeShape.prototype.GetPrevEdge=function(){return this.m_prevEdge};
Box2D.Collision.Shapes.b2EdgeShape.prototype.Support=function(a,b,c){var d=a.R,e=a.position.x+(d.col1.x*this.m_coreV1.x+d.col2.x*this.m_coreV1.y),h=a.position.y+(d.col1.y*this.m_coreV1.x+d.col2.y*this.m_coreV1.y),f=a.position.x+(d.col1.x*this.m_coreV2.x+d.col2.x*this.m_coreV2.y);a=a.position.y+(d.col1.y*this.m_coreV2.x+d.col2.y*this.m_coreV2.y);return e*b+h*c>f*b+a*c?Box2D.Common.Math.b2Vec2.Get(e,h):Box2D.Common.Math.b2Vec2.Get(f,a)};Box2D.Collision.Shapes.b2EdgeShape.prototype.SetPrevEdge=function(a,
b,c,d){this.m_prevEdge=a;this.m_coreV1=b;this.m_cornerDir1=c;this.m_cornerConvex1=d};Box2D.Collision.Shapes.b2EdgeShape.prototype.SetNextEdge=function(a,b,c,d){this.m_nextEdge=a;this.m_coreV2=b;this.m_cornerDir2=c;this.m_cornerConvex2=d};Box2D.Collision.Shapes.b2EdgeShape.NAME="b2EdgeShape";Box2D.Collision.Shapes.b2MassData=function(){this.mass=0;this.center=Box2D.Common.Math.b2Vec2.Get(0,0);this.I=0};Box2D.Collision.Shapes.b2PolygonShape=function(){Box2D.Collision.Shapes.b2Shape.call(this);this.m_centroid=
Box2D.Common.Math.b2Vec2.Get(0,0);this.m_vertices=[];this.m_normals=[]};c2inherit(Box2D.Collision.Shapes.b2PolygonShape,Box2D.Collision.Shapes.b2Shape);Box2D.Collision.Shapes.b2PolygonShape.prototype.GetTypeName=function(){return Box2D.Collision.Shapes.b2PolygonShape.NAME};Box2D.Collision.Shapes.b2PolygonShape.prototype.Copy=function(){var a=new Box2D.Collision.Shapes.b2PolygonShape;a.Set(this);return a};Box2D.Collision.Shapes.b2PolygonShape.prototype.Set=function(a){Box2D.Collision.Shapes.b2Shape.prototype.Set.call(this,
a);if(a instanceof Box2D.Collision.Shapes.b2PolygonShape){this.m_centroid.SetV(a.m_centroid);this.m_vertexCount=a.m_vertexCount;this.Reserve(this.m_vertexCount);for(var b=0;b<this.m_vertexCount;b++)this.m_vertices[b].SetV(a.m_vertices[b]),this.m_normals[b].SetV(a.m_normals[b])}};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsArray=function(a){this.SetAsVector(a)};Box2D.Collision.Shapes.b2PolygonShape.AsArray=function(a){var b=new Box2D.Collision.Shapes.b2PolygonShape;b.SetAsArray(a);return b};
Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsVector=function(a){var b=a.length;this.m_vertexCount=b;this.Reserve(b);for(b=b=0;b<this.m_vertexCount;b++)this.m_vertices[b].SetV(a[b]);for(b=0;b<this.m_vertexCount;++b)a=Box2D.Common.Math.b2Math.SubtractVV(this.m_vertices[b+1<this.m_vertexCount?b+1:0],this.m_vertices[b]),this.m_normals[b].SetV(Box2D.Common.Math.b2Math.CrossVF(a,1)),this.m_normals[b].Normalize();this.m_centroid=Box2D.Collision.Shapes.b2PolygonShape.ComputeCentroid(this.m_vertices,
this.m_vertexCount)};Box2D.Collision.Shapes.b2PolygonShape.AsVector=function(a){var b=new Box2D.Collision.Shapes.b2PolygonShape;b.SetAsVector(a);return b};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsBox=function(a,b){this.m_vertexCount=4;this.Reserve(4);this.m_vertices[0].Set(-a,-b);this.m_vertices[1].Set(a,-b);this.m_vertices[2].Set(a,b);this.m_vertices[3].Set(-a,b);this.m_normals[0].Set(0,-1);this.m_normals[1].Set(1,0);this.m_normals[2].Set(0,1);this.m_normals[3].Set(-1,0);this.m_centroid.SetZero()};
Box2D.Collision.Shapes.b2PolygonShape.AsBox=function(a,b){var c=new Box2D.Collision.Shapes.b2PolygonShape;c.SetAsBox(a,b);return c};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsOrientedBox=function(a,b,c,d){this.m_vertexCount=4;this.Reserve(4);this.m_vertices[0].Set(-a,-b);this.m_vertices[1].Set(a,-b);this.m_vertices[2].Set(a,b);this.m_vertices[3].Set(-a,b);this.m_normals[0].Set(0,-1);this.m_normals[1].Set(1,0);this.m_normals[2].Set(0,1);this.m_normals[3].Set(-1,0);this.m_centroid=c;a=new Box2D.Common.Math.b2Mat22;
a.Set(d);c=new Box2D.Common.Math.b2Transform(c,a);for(d=0;d<this.m_vertexCount;++d)this.m_vertices[d]=Box2D.Common.Math.b2Math.MulX(c,this.m_vertices[d]),this.m_normals[d]=Box2D.Common.Math.b2Math.MulMV(c.R,this.m_normals[d])};Box2D.Collision.Shapes.b2PolygonShape.AsOrientedBox=function(a,b,c,d){var e=new Box2D.Collision.Shapes.b2PolygonShape;e.SetAsOrientedBox(a,b,c,d);return e};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetAsEdge=function(a,b){this.m_vertexCount=2;this.Reserve(2);this.m_vertices[0].SetV(a);
this.m_vertices[1].SetV(b);this.m_centroid.x=0.5*(a.x+b.x);this.m_centroid.y=0.5*(a.y+b.y);this.m_normals[0]=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(b,a),1);this.m_normals[0].Normalize();this.m_normals[1].x=-this.m_normals[0].x;this.m_normals[1].y=-this.m_normals[0].y};Box2D.Collision.Shapes.b2PolygonShape.AsEdge=function(a,b){var c=new Box2D.Collision.Shapes.b2PolygonShape;c.SetAsEdge(a,b);return c};Box2D.Collision.Shapes.b2PolygonShape.prototype.TestPoint=function(a,
b){var c;c=a.R;for(var d=b.x-a.position.x,e=b.y-a.position.y,h=d*c.col1.x+e*c.col1.y,f=d*c.col2.x+e*c.col2.y,l=0;l<this.m_vertexCount;++l)if(c=this.m_vertices[l],d=h-c.x,e=f-c.y,c=this.m_normals[l],0<c.x*d+c.y*e)return!1;return!0};Box2D.Collision.Shapes.b2PolygonShape.prototype.RayCast=function(a,b,c){var d=0,e=b.maxFraction,h=0,f=0,l,k,h=b.p1.x-c.position.x,f=b.p1.y-c.position.y;l=c.R;var g=h*l.col1.x+f*l.col1.y,m=h*l.col2.x+f*l.col2.y,h=b.p2.x-c.position.x,f=b.p2.y-c.position.y;l=c.R;b=h*l.col1.x+
f*l.col1.y-g;l=h*l.col2.x+f*l.col2.y-m;for(var n=-1,p=0;p<this.m_vertexCount;++p){k=this.m_vertices[p];h=k.x-g;f=k.y-m;k=this.m_normals[p];h=k.x*h+k.y*f;f=k.x*b+k.y*l;if(0==f){if(0>h)return!1}else 0>f&&h<d*f?(d=h/f,n=p):0<f&&h<e*f&&(e=h/f);if(e<d-Number.MIN_VALUE)return!1}return 0<=n?(a.fraction=d,l=c.R,k=this.m_normals[n],a.normal.x=l.col1.x*k.x+l.col2.x*k.y,a.normal.y=l.col1.y*k.x+l.col2.y*k.y,!0):!1};Box2D.Collision.Shapes.b2PolygonShape.prototype.ComputeAABB=function(a,b){for(var c=b.R,d=this.m_vertices[0],
e=b.position.x+(c.col1.x*d.x+c.col2.x*d.y),h=b.position.y+(c.col1.y*d.x+c.col2.y*d.y),f=e,l=h,k=1;k<this.m_vertexCount;++k)var d=this.m_vertices[k],g=b.position.x+(c.col1.x*d.x+c.col2.x*d.y),d=b.position.y+(c.col1.y*d.x+c.col2.y*d.y),e=e<g?e:g,h=h<d?h:d,f=f>g?f:g,l=l>d?l:d;a.lowerBound_.x=e-this.m_radius;a.lowerBound_.y=h-this.m_radius;a.upperBound_.x=f+this.m_radius;a.upperBound_.y=l+this.m_radius};Box2D.Collision.Shapes.b2PolygonShape.prototype.ComputeMass=function(a,b){if(2==this.m_vertexCount)a.center.x=
0.5*(this.m_vertices[0].x+this.m_vertices[1].x),a.center.y=0.5*(this.m_vertices[0].y+this.m_vertices[1].y),a.mass=0,a.I=0;else{for(var c=0,d=0,e=0,h=0,f=1/3,l=0;l<this.m_vertexCount;++l)var k=this.m_vertices[l],g=l+1<this.m_vertexCount?this.m_vertices[l+1]:this.m_vertices[0],m=k.x-0,n=k.y-0,p=g.x-0,r=g.y-0,s=m*r-n*p,q=0.5*s,e=e+q,c=c+q*f*(0+k.x+g.x),d=d+q*f*(0+k.y+g.y),k=m,h=h+s*(f*(0.25*(k*k+p*k+p*p)+(0*k+0*p))+0+(f*(0.25*(n*n+r*n+r*r)+(0*n+0*r))+0));a.mass=b*e;a.center.Set(1/e*c,1/e*d);a.I=b*h}};
Box2D.Collision.Shapes.b2PolygonShape.prototype.ComputeSubmergedArea=function(a,b,c,d){var e=Box2D.Common.Math.b2Math.MulTMV(c.R,a),h=b-Box2D.Common.Math.b2Math.Dot(a,c.position),f=[],l=0,k=-1;b=-1;var g=!1;for(a=a=0;a<this.m_vertexCount;++a){f[a]=Box2D.Common.Math.b2Math.Dot(e,this.m_vertices[a])-h;var m=f[a]<-Number.MIN_VALUE;0<a&&(m?g||(k=a-1,l++):g&&(b=a-1,l++));g=m}switch(l){case 0:return g?(a=new Box2D.Collision.Shapes.b2MassData,this.ComputeMass(a,1),d.SetV(Box2D.Common.Math.b2Math.MulX(c,
a.center)),a.mass):0;case 1:-1==k?k=this.m_vertexCount-1:b=this.m_vertexCount-1}a=(k+1)%this.m_vertexCount;e=(b+1)%this.m_vertexCount;h=(0-f[k])/(f[a]-f[k]);f=(0-f[b])/(f[e]-f[b]);k=Box2D.Common.Math.b2Vec2.Get(this.m_vertices[k].x*(1-h)+this.m_vertices[a].x*h,this.m_vertices[k].y*(1-h)+this.m_vertices[a].y*h);b=Box2D.Common.Math.b2Vec2.Get(this.m_vertices[b].x*(1-f)+this.m_vertices[e].x*f,this.m_vertices[b].y*(1-f)+this.m_vertices[e].y*f);f=0;h=Box2D.Common.Math.b2Vec2.Get(0,0);for(l=this.m_vertices[a];a!=
e;)a=(a+1)%this.m_vertexCount,g=a==e?b:this.m_vertices[a],m=0.5*((l.x-k.x)*(g.y-k.y)-(l.y-k.y)*(g.x-k.x)),f+=m,h.x+=m*(k.x+l.x+g.x)/3,h.y+=m*(k.y+l.y+g.y)/3,l=g;h.Multiply(1/f);d.SetV(Box2D.Common.Math.b2Math.MulX(c,h));return f};Box2D.Collision.Shapes.b2PolygonShape.prototype.SetDistanceProxy=function(a){a.m_vertices=this.m_vertices;a.m_count=this.m_vertexCount;a.m_radius=this.m_radius};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetVertexCount=function(){return this.m_vertexCount};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetVertices=
function(){return this.m_vertices};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetNormals=function(){return this.m_normals};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetSupport=function(a){for(var b=0,c=this.m_vertices[0].x*a.x+this.m_vertices[0].y*a.y,d=1;d<this.m_vertexCount;++d){var e=this.m_vertices[d].x*a.x+this.m_vertices[d].y*a.y;e>c&&(b=d,c=e)}return b};Box2D.Collision.Shapes.b2PolygonShape.prototype.GetSupportVertex=function(a){for(var b=0,c=this.m_vertices[0].x*a.x+this.m_vertices[0].y*
a.y,d=1;d<this.m_vertexCount;++d){var e=this.m_vertices[d].x*a.x+this.m_vertices[d].y*a.y;e>c&&(b=d,c=e)}return this.m_vertices[b]};Box2D.Collision.Shapes.b2PolygonShape.prototype.Reserve=function(a){this.m_vertices=[];this.m_normals=[];for(var b=this.m_vertices.length;b<a;b++)this.m_vertices[b]=Box2D.Common.Math.b2Vec2.Get(0,0),this.m_normals[b]=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.Shapes.b2PolygonShape.ComputeCentroid=function(a,b){for(var c=Box2D.Common.Math.b2Vec2.Get(0,0),d=0,e=
1/3,h=0;h<b;++h){var f=a[h],l=h+1<b?a[h+1]:a[0],k=0.5*((f.x-0)*(l.y-0)-(f.y-0)*(l.x-0)),d=d+k;c.x+=k*e*(0+f.x+l.x);c.y+=k*e*(0+f.y+l.y)}c.x*=1/d;c.y*=1/d;return c};Box2D.Collision.Shapes.b2PolygonShape.s_mat=new Box2D.Common.Math.b2Mat22;Box2D.Collision.Shapes.b2PolygonShape.NAME="b2PolygonShape";Box2D.Collision.b2ContactID=function(){this._incidentVertex=this._incidentEdge=this._referenceEdge=this._key=0};Box2D.Collision.b2ContactID.prototype.GetKey=function(){return this._key};Box2D.Collision.b2ContactID.prototype.SetKey=
function(a){this._key=a;this._referenceEdge=this._key&255;this._incidentEdge=(this._key&65280)>>8&255;this._incidentVertex=(this._key&16711680)>>16&255;this._flip=(this._key&4278190080)>>24&255};Box2D.Collision.b2ContactID.prototype.Set=function(a){this.SetKey(a._key)};Box2D.Collision.b2ContactID.prototype.SetReferenceEdge=function(a){this._referenceEdge=a;this._key=this._key&4294967040|this._referenceEdge&255};Box2D.Collision.b2ContactID.prototype.SetIncidentEdge=function(a){this._incidentEdge=a;
this._key=this._key&4294902015|this._incidentEdge<<8&65280};Box2D.Collision.b2ContactID.prototype.SetIncidentVertex=function(a){this._incidentVertex=a;this._key=this._key&4278255615|this._incidentVertex<<16&16711680};Box2D.Collision.b2ContactID.prototype.SetFlip=function(a){this._flip=a;this._key=this._key&16777215|this._flip<<24&4278190080};Box2D.Collision.b2ContactID.prototype.Copy=function(){var a=new Box2D.Collision.b2ContactID;a.Set(this);return a};Box2D.Collision.ClipVertex=function(){this.v=
Box2D.Common.Math.b2Vec2.Get(0,0);this.id=new Box2D.Collision.b2ContactID};Box2D.Collision.ClipVertex.prototype.Set=function(a){this.v.SetV(a.v);this.id.Set(a.id)};Box2D.Collision.IBroadPhase="Box2D.Collision.IBroadPhase";Box2D.Collision.b2AABB=function(){this.lowerBound_=Box2D.Common.Math.b2Vec2.Get(0,0);this.upperBound_=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2AABB._freeCache=[];Box2D.Collision.b2AABB.Get=function(){if(0<Box2D.Collision.b2AABB._freeCache.length){var a=Box2D.Collision.b2AABB._freeCache.pop();
a.SetZero();return a}return new Box2D.Collision.b2AABB};Box2D.Collision.b2AABB.Free=function(a){Box2D.Collision.b2AABB._freeCache.push(a)};Box2D.Collision.b2AABB.prototype.SetZero=function(){this.lowerBound_.Set(0,0);this.upperBound_.Set(0,0)};Box2D.Collision.b2AABB.prototype.IsValid=function(){return 0>this.upperBound_.x-this.lowerBound_.x||0>this.upperBound_.y-this.lowerBound_.y?!1:this.lowerBound_.IsValid()&&this.upperBound_.IsValid()};Box2D.Collision.b2AABB.prototype.GetCenter=function(){return Box2D.Common.Math.b2Vec2.Get((this.lowerBound_.x+
this.upperBound_.x)/2,(this.lowerBound_.y+this.upperBound_.y)/2)};Box2D.Collision.b2AABB.prototype.SetCenter=function(a){var b=this.GetCenter();this.lowerBound_.Subtract(b);this.upperBound_.Subtract(b);this.lowerBound_.Add(a);this.upperBound_.Add(a);Box2D.Common.Math.b2Vec2.Free(b)};Box2D.Collision.b2AABB.prototype.GetExtents=function(){return Box2D.Common.Math.b2Vec2.Get((this.upperBound_.x-this.lowerBound_.x)/2,(this.upperBound_.y-this.lowerBound_.y)/2)};Box2D.Collision.b2AABB.prototype.Contains=
function(a){var b;return b=(b=(b=(b=this.lowerBound_.x<=a.lowerBound_.x)&&this.lowerBound_.y<=a.lowerBound_.y)&&a.upperBound_.x<=this.upperBound_.x)&&a.upperBound_.y<=this.upperBound_.y};Box2D.Collision.b2AABB.prototype.RayCast=function(a,b){var c=-Number.MAX_VALUE,d=Number.MAX_VALUE,e=b.p2.x-b.p1.x;if(Math.abs(e)<Number.MIN_VALUE){if(b.p1.x<this.lowerBound_.x||this.upperBound_.x<b.p1.x)return!1}else{var h=1/e,e=(this.lowerBound_.x-b.p1.x)*h,h=(this.upperBound_.x-b.p1.x)*h,f=-1;e>h&&(f=e,e=h,h=f,
f=1);e>c&&(a.normal.x=f,a.normal.y=0,c=e);d=Math.min(d,h);if(c>d)return!1}e=b.p2.y-b.p1.y;if(Math.abs(e)<Number.MIN_VALUE){if(b.p1.y<this.lowerBound_.y||this.upperBound_.y<b.p1.y)return!1}else if(h=1/e,e=(this.lowerBound_.y-b.p1.y)*h,h*=this.upperBound_.y-b.p1.y,f=-1,e>h&&(f=e,e=h,h=f,f=1),e>c&&(a.normal.y=f,a.normal.x=0,c=e),d=Math.min(d,h),c>d)return!1;a.fraction=c;return!0};Box2D.Collision.b2AABB.prototype.TestOverlap=function(a){return 0<a.lowerBound_.x-this.upperBound_.x||0<a.lowerBound_.y-this.upperBound_.y||
0<this.lowerBound_.x-a.upperBound_.x||0<this.lowerBound_.y-a.upperBound_.y?!1:!0};Box2D.Collision.b2AABB.Combine=function(a,b){var c=Box2D.Collision.b2AABB.Get();c.Combine(a,b);return c};Box2D.Collision.b2AABB.prototype.Combine=function(a,b){this.lowerBound_.x=Math.min(a.lowerBound_.x,b.lowerBound_.x);this.lowerBound_.y=Math.min(a.lowerBound_.y,b.lowerBound_.y);this.upperBound_.x=Math.max(a.upperBound_.x,b.upperBound_.x);this.upperBound_.y=Math.max(a.upperBound_.y,b.upperBound_.y)};Box2D.Collision.b2Collision.ClipSegmentToLine=
function(a,b,c,d){var e=0,h=b[0].v,f=b[1].v,l=c.x*h.x+c.y*h.y-d;c=c.x*f.x+c.y*f.y-d;0>=l&&a[e++].Set(b[0]);0>=c&&a[e++].Set(b[1]);0>l*c&&(c=l/(l-c),d=a[e].v,d.x=h.x+c*(f.x-h.x),d.y=h.y+c*(f.y-h.y),a[e].id=0<l?b[0].id:b[1].id,e++);return e};Box2D.Collision.b2Collision.EdgeSeparation=function(a,b,c,d,e){for(var h=b.R.col1.x*a.m_normals[c].x+b.R.col2.x*a.m_normals[c].y,f=b.R.col1.y*a.m_normals[c].x+b.R.col2.y*a.m_normals[c].y,l=e.R.col1.x*h+e.R.col1.y*f,k=e.R.col2.x*h+e.R.col2.y*f,g=0,m=Number.MAX_VALUE,
n=0;n<d.m_vertexCount;n++){var p=d.m_vertices[n].x*l+d.m_vertices[n].y*k;p<m&&(m=p,g=n)}return(e.position.x+(e.R.col1.x*d.m_vertices[g].x+e.R.col2.x*d.m_vertices[g].y)-(b.position.x+(b.R.col1.x*a.m_vertices[c].x+b.R.col2.x*a.m_vertices[c].y)))*h+(e.position.y+(e.R.col1.y*d.m_vertices[g].x+e.R.col2.y*d.m_vertices[g].y)-(b.position.y+(b.R.col1.y*a.m_vertices[c].x+b.R.col2.y*a.m_vertices[c].y)))*f};Box2D.Collision.b2Collision.FindMaxSeparation=function(a,b,c,d){for(var e=d.position.x+(d.R.col1.x*c.m_centroid.x+
d.R.col2.x*c.m_centroid.y),h=d.position.y+(d.R.col1.y*c.m_centroid.x+d.R.col2.y*c.m_centroid.y),e=e-(b.position.x+(b.R.col1.x*a.m_centroid.x+b.R.col2.x*a.m_centroid.y)),h=h-(b.position.y+(b.R.col1.y*a.m_centroid.x+b.R.col2.y*a.m_centroid.y)),f=e*b.R.col1.x+h*b.R.col1.y,h=e*b.R.col2.x+h*b.R.col2.y,e=0,l=-Number.MAX_VALUE,k=0;k<a.m_vertexCount;++k){var g=a.m_normals[k].x*f+a.m_normals[k].y*h;g>l&&(l=g,e=k)}f=Box2D.Collision.b2Collision.EdgeSeparation(a,b,e,c,d);h=e-1;0>h&&(h=a.m_vertexCount-1);l=Box2D.Collision.b2Collision.EdgeSeparation(a,
b,h,c,d);k=e+1;k>=a.m_vertexCount&&(k=0);var g=Box2D.Collision.b2Collision.EdgeSeparation(a,b,k,c,d),m=0,n=0;if(l>f&&l>g)for(m=h,n=l;;)if(e=m-1,0>e&&(e=a.m_vertexCount-1),f=Box2D.Collision.b2Collision.EdgeSeparation(a,b,e,c,d),f>n)m=e,n=f;else break;else if(g>f)for(m=k,n=g;;)if(e=m+1,e>=a.m_vertexCount&&(e=0),f=Box2D.Collision.b2Collision.EdgeSeparation(a,b,e,c,d),f>n)m=e,n=f;else break;else m=e,n=f;return{bestEdge:m,separation:n}};Box2D.Collision.b2Collision.FindIncidentEdge=function(a,b,c,d,e,h){void 0===
d&&(d=0);var f=c.R.col1.x*b.m_normals[d].x+c.R.col2.x*b.m_normals[d].y;b=c.R.col1.y*b.m_normals[d].x+c.R.col2.y*b.m_normals[d].y;c=h.R.col1.x*f+h.R.col1.y*b;b=h.R.col2.x*f+h.R.col2.y*b;f=c;c=0;for(var l=Number.MAX_VALUE,k=0;k<e.m_vertexCount;k++){var g=f*e.m_normals[k].x+b*e.m_normals[k].y;g<l&&(l=g,c=k)}f=c+1;f>=e.m_vertexCount&&(f=0);a[0].v.x=h.position.x+(h.R.col1.x*e.m_vertices[c].x+h.R.col2.x*e.m_vertices[c].y);a[0].v.y=h.position.y+(h.R.col1.y*e.m_vertices[c].x+h.R.col2.y*e.m_vertices[c].y);
a[0].id.SetReferenceEdge(d);a[0].id.SetIncidentEdge(c);a[0].id.SetIncidentVertex(0);a[1].v.x=h.position.x+(h.R.col1.x*e.m_vertices[f].x+h.R.col2.x*e.m_vertices[f].y);a[1].v.y=h.position.y+(h.R.col1.y*e.m_vertices[f].x+h.R.col2.y*e.m_vertices[f].y);a[1].id.SetReferenceEdge(d);a[1].id.SetIncidentEdge(f);a[1].id.SetIncidentVertex(1)};Box2D.Collision.b2Collision.MakeClipPointVector=function(){return[new Box2D.Collision.ClipVertex,new Box2D.Collision.ClipVertex]};Box2D.Collision.b2Collision.CollidePolygons=
function(a,b,c,d,e){a.m_pointCount=0;var h=b.m_radius+d.m_radius,f=Box2D.Collision.b2Collision.FindMaxSeparation(b,c,d,e),l=f.bestEdge;if(!(f.separation>h)){var k=Box2D.Collision.b2Collision.FindMaxSeparation(d,e,b,c);if(!(k.separation>h)){var g=b,m=d,n=c,p=e,r=0;a.m_type=Box2D.Collision.b2Manifold.e_faceA;k.separation>0.98*f.separation+0.001&&(g=d,m=b,n=e,p=c,l=k.bestEdge,a.m_type=Box2D.Collision.b2Manifold.e_faceB,r=1);b=Box2D.Collision.b2Collision.s_incidentEdge;Box2D.Collision.b2Collision.FindIncidentEdge(b,
g,n,l,m,p);m=g.m_vertices[l];l=l+1<g.m_vertexCount?g.m_vertices[l+1]:g.m_vertices[0];Box2D.Collision.b2Collision.s_localTangent.Set(l.x-m.x,l.y-m.y);Box2D.Collision.b2Collision.s_localTangent.Normalize();Box2D.Collision.b2Collision.s_localNormal.x=Box2D.Collision.b2Collision.s_localTangent.y;Box2D.Collision.b2Collision.s_localNormal.y=-Box2D.Collision.b2Collision.s_localTangent.x;Box2D.Collision.b2Collision.s_planePoint.Set(0.5*(m.x+l.x),0.5*(m.y+l.y));Box2D.Collision.b2Collision.s_tangent.x=n.R.col1.x*
Box2D.Collision.b2Collision.s_localTangent.x+n.R.col2.x*Box2D.Collision.b2Collision.s_localTangent.y;Box2D.Collision.b2Collision.s_tangent.y=n.R.col1.y*Box2D.Collision.b2Collision.s_localTangent.x+n.R.col2.y*Box2D.Collision.b2Collision.s_localTangent.y;Box2D.Collision.b2Collision.s_tangent2.x=-Box2D.Collision.b2Collision.s_tangent.x;Box2D.Collision.b2Collision.s_tangent2.y=-Box2D.Collision.b2Collision.s_tangent.y;Box2D.Collision.b2Collision.s_normal.x=Box2D.Collision.b2Collision.s_tangent.y;Box2D.Collision.b2Collision.s_normal.y=
-Box2D.Collision.b2Collision.s_tangent.x;Box2D.Collision.b2Collision.s_v11.x=n.position.x+(n.R.col1.x*m.x+n.R.col2.x*m.y);Box2D.Collision.b2Collision.s_v11.y=n.position.y+(n.R.col1.y*m.x+n.R.col2.y*m.y);Box2D.Collision.b2Collision.s_v12.x=n.position.x+(n.R.col1.x*l.x+n.R.col2.x*l.y);Box2D.Collision.b2Collision.s_v12.y=n.position.y+(n.R.col1.y*l.x+n.R.col2.y*l.y);if(!(2>Box2D.Collision.b2Collision.ClipSegmentToLine(Box2D.Collision.b2Collision.s_clipPoints1,b,Box2D.Collision.b2Collision.s_tangent2,
-Box2D.Collision.b2Collision.s_tangent.x*Box2D.Collision.b2Collision.s_v11.x-Box2D.Collision.b2Collision.s_tangent.y*Box2D.Collision.b2Collision.s_v11.y+h)||2>Box2D.Collision.b2Collision.ClipSegmentToLine(Box2D.Collision.b2Collision.s_clipPoints2,Box2D.Collision.b2Collision.s_clipPoints1,Box2D.Collision.b2Collision.s_tangent,Box2D.Collision.b2Collision.s_tangent.x*Box2D.Collision.b2Collision.s_v12.x+Box2D.Collision.b2Collision.s_tangent.y*Box2D.Collision.b2Collision.s_v12.y+h))){a.m_localPlaneNormal.SetV(Box2D.Collision.b2Collision.s_localNormal);
a.m_localPoint.SetV(Box2D.Collision.b2Collision.s_planePoint);n=Box2D.Collision.b2Collision.s_normal.x*Box2D.Collision.b2Collision.s_v11.x+Box2D.Collision.b2Collision.s_normal.y*Box2D.Collision.b2Collision.s_v11.y;for(g=l=0;g<Box2D.Common.b2Settings.b2_maxManifoldPoints;++g)Box2D.Collision.b2Collision.s_normal.x*Box2D.Collision.b2Collision.s_clipPoints2[g].v.x+Box2D.Collision.b2Collision.s_normal.y*Box2D.Collision.b2Collision.s_clipPoints2[g].v.y-n<=h&&(m=Box2D.Collision.b2Collision.s_clipPoints2[g].v.x-
p.position.x,b=Box2D.Collision.b2Collision.s_clipPoints2[g].v.y-p.position.y,a.m_points[l].m_localPoint.x=m*p.R.col1.x+b*p.R.col1.y,a.m_points[l].m_localPoint.y=m*p.R.col2.x+b*p.R.col2.y,a.m_points[l].m_id.Set(Box2D.Collision.b2Collision.s_clipPoints2[g].id),a.m_points[l].m_id.SetFlip(r),l++);a.m_pointCount=l}}}};Box2D.Collision.b2Collision.CollideCircles=function(a,b,c,d,e){a.m_pointCount=0;var h=e.position.x+(e.R.col1.x*d.m_p.x+e.R.col2.x*d.m_p.y)-(c.position.x+(c.R.col1.x*b.m_p.x+c.R.col2.x*b.m_p.y));
c=e.position.y+(e.R.col1.y*d.m_p.x+e.R.col2.y*d.m_p.y)-(c.position.y+(c.R.col1.y*b.m_p.x+c.R.col2.y*b.m_p.y));e=b.m_radius+d.m_radius;h*h+c*c>e*e||(a.m_type=Box2D.Collision.b2Manifold.e_circles,a.m_localPoint.SetV(b.m_p),a.m_localPlaneNormal.SetZero(),a.m_pointCount=1,a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0))};Box2D.Collision.b2Collision.CollidePolygonAndCircle=function(a,b,c,d,e){a.m_pointCount=0;var h=e.position.x+(e.R.col1.x*d.m_p.x+e.R.col2.x*d.m_p.y)-c.position.x,f=
e.position.y+(e.R.col1.y*d.m_p.x+e.R.col2.y*d.m_p.y)-c.position.y;e=h*c.R.col1.x+f*c.R.col1.y;c=h*c.R.col2.x+f*c.R.col2.y;for(var h=0,f=-Number.MAX_VALUE,l=b.m_radius+d.m_radius,k=0;k<b.m_vertexCount;++k){var g=b.m_normals[k].x*(e-b.m_vertices[k].x)+b.m_normals[k].y*(c-b.m_vertices[k].y);if(g>l)return;g>f&&(f=g,h=k)}g=h+1;g>=b.m_vertexCount&&(g=0);var k=b.m_vertices[h],m=b.m_vertices[g];f<Number.MIN_VALUE?(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.SetV(b.m_normals[h]),
a.m_localPoint.x=0.5*(k.x+m.x),a.m_localPoint.y=0.5*(k.y+m.y),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)):0>=(e-k.x)*(m.x-k.x)+(c-k.y)*(m.y-k.y)?(e-k.x)*(e-k.x)+(c-k.y)*(c-k.y)>l*l||(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.x=e-k.x,a.m_localPlaneNormal.y=c-k.y,a.m_localPlaneNormal.Normalize(),a.m_localPoint.SetV(k),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)):0>=(e-m.x)*(k.x-m.x)+(c-m.y)*(k.y-m.y)?(e-m.x)*(e-
m.x)+(c-m.y)*(c-m.y)>l*l||(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.x=e-m.x,a.m_localPlaneNormal.y=c-m.y,a.m_localPlaneNormal.Normalize(),a.m_localPoint.SetV(m),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)):(g=0.5*(k.x+m.x),k=0.5*(k.y+m.y),f=(e-g)*b.m_normals[h].x+(c-k)*b.m_normals[h].y,f>l||(a.m_pointCount=1,a.m_type=Box2D.Collision.b2Manifold.e_faceA,a.m_localPlaneNormal.x=b.m_normals[h].x,a.m_localPlaneNormal.y=b.m_normals[h].y,a.m_localPlaneNormal.Normalize(),
a.m_localPoint.Set(g,k),a.m_points[0].m_localPoint.SetV(d.m_p),a.m_points[0].m_id.SetKey(0)))};Box2D.Collision.b2Collision.TestOverlap=function(a,b){return 0<b.lowerBound_.x-a.upperBound_.x||0<b.lowerBound_.y-a.upperBound_.y||0<a.lowerBound_.x-b.upperBound_.x||0<a.lowerBound_.y-b.upperBound_.y?!1:!0};Box2D.Collision.b2ContactPoint=function(){this.position=Box2D.Common.Math.b2Vec2.Get(0,0);this.velocity=Box2D.Common.Math.b2Vec2.Get(0,0);this.normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.id=new Box2D.Collision.b2ContactID};
Box2D.Collision.b2Distance.Distance=function(a,b,c){var d=new Box2D.Collision.b2Simplex;d.ReadCache(b,c.proxyA,c.transformA,c.proxyB,c.transformB);for(var e=0;20>e;){for(var h=[],f=0;f<d.m_count;f++)h[f]={},h[f].indexA=d.m_vertices[f].indexA,h[f].indexB=d.m_vertices[f].indexB;2==d.m_count?d.Solve2():3==d.m_count&&d.Solve3();if(3==d.m_count)break;f=d.GetSearchDirection();if(f.LengthSquared()<Box2D.Common.b2Settings.MIN_VALUE_SQUARED)break;var l=f.GetNegative();d.m_vertices[d.m_count].indexA=c.proxyA.GetSupport(Box2D.Common.Math.b2Math.MulTMV(c.transformA.R,
l));d.m_vertices[d.m_count].wA=Box2D.Common.Math.b2Math.MulX(c.transformA,c.proxyA.GetVertex(d.m_vertices[d.m_count].indexA));d.m_vertices[d.m_count].indexB=c.proxyB.GetSupport(Box2D.Common.Math.b2Math.MulTMV(c.transformB.R,f));d.m_vertices[d.m_count].wB=Box2D.Common.Math.b2Math.MulX(c.transformB,c.proxyB.GetVertex(d.m_vertices[d.m_count].indexB));d.m_vertices[d.m_count].w=Box2D.Common.Math.b2Math.SubtractVV(d.m_vertices[d.m_count].wB,d.m_vertices[d.m_count].wA);Box2D.Common.Math.b2Vec2.Free(f);Box2D.Common.Math.b2Vec2.Free(l);
e++;l=!1;for(f=0;f<h.length;f++)if(d.m_vertices[d.m_count].indexA==h[f].indexA&&d.m_vertices[d.m_count].indexB==h[f].indexB){l=!0;break}if(l)break;d.m_count++}d.GetWitnessPoints(a.pointA,a.pointB);a.distance=Box2D.Common.Math.b2Math.SubtractVV(a.pointA,a.pointB).Length();d.WriteCache(b);c.useRadii&&(b=c.proxyA.m_radius,c=c.proxyB.m_radius,a.distance>b+c&&a.distance>Number.MIN_VALUE?(a.distance-=b+c,d=Box2D.Common.Math.b2Math.SubtractVV(a.pointB,a.pointA),d.Normalize(),a.pointA.x+=b*d.x,a.pointA.y+=
b*d.y,a.pointB.x-=c*d.x,a.pointB.y-=c*d.y,Box2D.Common.Math.b2Vec2.Free(d)):(c=Box2D.Common.Math.b2Vec2.Get(0,0),c.x=0.5*(a.pointA.x+a.pointB.x),c.y=0.5*(a.pointA.y+a.pointB.y),a.pointA.x=a.pointB.x=c.x,a.pointA.y=a.pointB.y=c.y,a.distance=0,Box2D.Common.Math.b2Vec2.Free(c)))};Box2D.Collision.b2DistanceInput=function(){};Box2D.Collision.b2DistanceOutput=function(){this.pointA=Box2D.Common.Math.b2Vec2.Get(0,0);this.pointB=Box2D.Common.Math.b2Vec2.Get(0,0);this.distance=0};Box2D.Collision.b2DistanceProxy=
function(){};Box2D.Collision.b2DistanceProxy.prototype.Set=function(a){a.SetDistanceProxy(this)};Box2D.Collision.b2DistanceProxy.prototype.GetSupport=function(a){for(var b=0,c=this.m_vertices[0].x*a.x+this.m_vertices[0].y*a.y,d=1;d<this.m_count;d++){var e=this.m_vertices[d].x*a.x+this.m_vertices[d].y*a.y;e>c&&(b=d,c=e)}return b};Box2D.Collision.b2DistanceProxy.prototype.GetSupportVertex=function(a){return this.m_vertices[this.GetSupport(a)]};Box2D.Collision.b2DistanceProxy.prototype.GetVertexCount=
function(){return this.m_count};Box2D.Collision.b2DistanceProxy.prototype.GetVertex=function(a){void 0===a&&(a=0);return this.m_vertices[a]};Box2D.Collision.b2DynamicTree=function(){this.m_root=null;this.m_insertionCount=this.m_path=0};Box2D.Collision.b2DynamicTree.prototype.CreateProxy=function(a,b){var c=Box2D.Collision.b2DynamicTreeNode.Get(b),d=Box2D.Common.b2Settings.b2_aabbExtension,e=Box2D.Common.b2Settings.b2_aabbExtension;c.aabb.lowerBound_.x=a.lowerBound_.x-d;c.aabb.lowerBound_.y=a.lowerBound_.y-
e;c.aabb.upperBound_.x=a.upperBound_.x+d;c.aabb.upperBound_.y=a.upperBound_.y+e;this.InsertLeaf(c);return c};Box2D.Collision.b2DynamicTree.prototype.DestroyProxy=function(a){this.RemoveLeaf(a);a.Destroy()};Box2D.Collision.b2DynamicTree.prototype.MoveProxy=function(a,b,c){if(a.aabb.Contains(b))return!1;this.RemoveLeaf(a);var d=Box2D.Common.b2Settings.b2_aabbExtension+Box2D.Common.b2Settings.b2_aabbMultiplier*Math.abs(c.x);c=Box2D.Common.b2Settings.b2_aabbExtension+Box2D.Common.b2Settings.b2_aabbMultiplier*
Math.abs(c.y);a.aabb.lowerBound_.x=b.lowerBound_.x-d;a.aabb.lowerBound_.y=b.lowerBound_.y-c;a.aabb.upperBound_.x=b.upperBound_.x+d;a.aabb.upperBound_.y=b.upperBound_.y+c;this.InsertLeaf(a);return!0};Box2D.Collision.b2DynamicTree.prototype.Rebalance=function(a){if(null!==this.m_root)for(var b=0;b<a;b++){for(var c=this.m_root,d=0;!c.IsLeaf();)c=this.m_path>>d&1?c.child2:c.child1,d=d+1&31;this.m_path++;this.RemoveLeaf(c);this.InsertLeaf(c)}};Box2D.Collision.b2DynamicTree.prototype.GetFatAABB=function(a){return a.aabb};
Box2D.Collision.b2DynamicTree.prototype.Query=function(a,b){if(null!==this.m_root){var c=[];for(c.push(this.m_root);0<c.length;){var d=c.pop();if(d.aabb.TestOverlap(b))if(d.IsLeaf()){if(!a(d.fixture))break}else c.push(d.child1),c.push(d.child2)}}};Box2D.Collision.b2DynamicTree.prototype.RayCast=function(a,b){if(null!==this.m_root){var c=Box2D.Common.Math.b2Math.SubtractVV(b.p1,b.p2);c.Normalize();var c=Box2D.Common.Math.b2Math.CrossFV(1,c),d=Box2D.Common.Math.b2Math.AbsV(c),e=b.maxFraction,h=b.p1.x+
e*(b.p2.x-b.p1.x),e=b.p1.y+e*(b.p2.y-b.p1.y),f=Box2D.Collision.b2AABB.Get();f.lowerBound_.x=Math.min(b.p1.x,h);f.lowerBound_.y=Math.min(b.p1.y,e);f.upperBound_.x=Math.max(b.p1.x,h);f.upperBound_.y=Math.max(b.p1.y,e);var l=[];for(l.push(this.m_root);0<l.length;)if(h=l.pop(),h.aabb.TestOverlap(f)){var e=h.aabb.GetCenter(),k=h.aabb.GetExtents();if(!(0<Math.abs(c.x*(b.p1.x-e.x)+c.y*(b.p1.y-e.y))-d.x*k.x-d.y*k.y))if(h.IsLeaf()){new Box2D.Collision.b2RayCastInput(b.p1,b.p2,b.maxFraction);e=a(b,h.fixture);
if(0==e)break;0<e&&(h=b.p1.x+e*(b.p2.x-b.p1.x),e=b.p1.y+e*(b.p2.y-b.p1.y),f.lowerBound_.x=Math.min(b.p1.x,h),f.lowerBound_.y=Math.min(b.p1.y,e),f.upperBound_.x=Math.max(b.p1.x,h),f.upperBound_.y=Math.max(b.p1.y,e))}else l.push(h.child1),l.push(h.child2)}Box2D.Collision.b2AABB.Free(f)}};Box2D.Collision.b2DynamicTree.prototype.InsertLeaf=function(a){this.m_insertionCount++;if(null===this.m_root)this.m_root=a,this.m_root.parent=null;else{var b=this.GetBestSibling(a),c=b.parent,d=Box2D.Collision.b2DynamicTreeNode.Get();
d.parent=c;d.aabb.Combine(a.aabb,b.aabb);if(c)for(b.parent.child1==b?c.child1=d:c.child2=d,d.child1=b,d.child2=a,b.parent=d,a.parent=d;c&&!c.aabb.Contains(d.aabb);)c.aabb.Combine(c.child1.aabb,c.child2.aabb),d=c,c=c.parent;else d.child1=b,d.child2=a,b.parent=d,this.m_root=a.parent=d}};Box2D.Collision.b2DynamicTree.prototype.GetBestSibling=function(a){a=a.aabb.GetCenter();for(var b=this.m_root;!b.IsLeaf();)var c=b.child1,b=b.child2,d=Math.abs((c.aabb.lowerBound_.x+c.aabb.upperBound_.x)/2-a.x)+Math.abs((c.aabb.lowerBound_.y+
c.aabb.upperBound_.y)/2-a.y),e=Math.abs((b.aabb.lowerBound_.x+b.aabb.upperBound_.x)/2-a.x)+Math.abs((b.aabb.lowerBound_.y+b.aabb.upperBound_.y)/2-a.y),b=d<e?c:b;Box2D.Common.Math.b2Vec2.Free(a);return b};Box2D.Collision.b2DynamicTree.prototype.RemoveLeaf=function(a){if(a==this.m_root)this.m_root=null;else{var b=a.parent,c=b.parent;a=b.child1==a?b.child2:b.child1;if(c)for(c.child1==b?c.child1=a:c.child2=a,a.parent=c;c;){a=c.aabb;c.aabb.Combine(c.child1.aabb,c.child2.aabb);if(a.Contains(c.aabb))break;
c=c.parent}else this.m_root=a,a.parent=null;b.Destroy()}};Box2D.Collision.b2DynamicTreeBroadPhase=function(){this.m_tree=new Box2D.Collision.b2DynamicTree;this.m_moveBuffer=[]};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.CreateProxy=function(a,b){var c=this.m_tree.CreateProxy(a,b);this.BufferMove(c);return c};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.DestroyProxy=function(a){this.UnBufferMove(a);this.m_tree.DestroyProxy(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.MoveProxy=
function(a,b,c){this.m_tree.MoveProxy(a,b,c)&&this.BufferMove(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.TestOverlap=function(a,b){var c=this.m_tree.GetFatAABB(a),d=this.m_tree.GetFatAABB(b);return c.TestOverlap(d)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.GetFatAABB=function(a){return this.m_tree.GetFatAABB(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.GetProxyCount=function(){return this.m_tree.length};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.UpdatePairs=function(a){for(var b=
[];0<this.m_moveBuffer.length;){var c=this.m_moveBuffer.pop(),d=this.m_tree.GetFatAABB(c);this.m_tree.Query(function(a){a!=c.fixture&&b.push(new Box2D.Collision.b2DynamicTreePair(c.fixture,a));return!0},d)}for(d=0;d<b.length;){var e=b[d];a(e.fixtureA,e.fixtureB);for(d++;d<b.length;){var h=b[d];if(!(h.fixtureA==e.fixtureA&&h.fixtureB==e.fixtureB||h.fixtureA==e.fixtureB&&h.fixtureB==e.fixtureA))break;d++}}};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.Query=function(a,b){this.m_tree.Query(a,b)};
Box2D.Collision.b2DynamicTreeBroadPhase.prototype.RayCast=function(a,b){this.m_tree.RayCast(a,b)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.Rebalance=function(a){this.m_tree.Rebalance(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.BufferMove=function(a){this.m_moveBuffer.push(a)};Box2D.Collision.b2DynamicTreeBroadPhase.prototype.UnBufferMove=function(a){cr.arrayFindRemove(this.m_moveBuffer,a)};Box2D.Collision.b2DynamicTreeBroadPhase.__implements={};Box2D.Collision.b2DynamicTreeBroadPhase.__implements[Box2D.Collision.IBroadPhase]=
!0;Box2D.Collision.b2DynamicTreeNode=function(a){this.aabb=Box2D.Collision.b2AABB.Get();this.fixture=this.parent=this.child2=this.child1=null;"undefined"!=typeof a&&(this.fixture=a)};Box2D.Collision.b2DynamicTreeNode._freeCache=[];Box2D.Collision.b2DynamicTreeNode.Get=function(a){if(0<Box2D.Collision.b2DynamicTreeNode._freeCache.length){var b=Box2D.Collision.b2DynamicTreeNode._freeCache.pop();"undefined"!=typeof a&&(b.fixture=a);b.aabb.SetZero();return b}return new Box2D.Collision.b2DynamicTreeNode(a)};
Box2D.Collision.b2DynamicTreeNode.prototype.Destroy=function(){this.fixture=this.parent=this.child2=this.child1=null;Box2D.Collision.b2DynamicTreeNode._freeCache.push(this)};Box2D.Collision.b2DynamicTreeNode.prototype.IsLeaf=function(){return null===this.child1};Box2D.Collision.b2DynamicTreePair=function(a,b){this.fixtureA=a;this.fixtureB=b};Box2D.Collision.b2Manifold=function(){this.m_type=this.m_pointCount=0;this.m_points=[];for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a]=
new Box2D.Collision.b2ManifoldPoint;this.m_localPlaneNormal=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localPoint=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Manifold.prototype.Reset=function(){for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a].Reset();this.m_localPlaneNormal.SetZero();this.m_localPoint.SetZero();this.m_pointCount=this.m_type=0};Box2D.Collision.b2Manifold.prototype.Set=function(a){this.m_pointCount=a.m_pointCount;for(var b=0;b<Box2D.Common.b2Settings.b2_maxManifoldPoints;b++)this.m_points[b].Set(a.m_points[b]);
this.m_localPlaneNormal.SetV(a.m_localPlaneNormal);this.m_localPoint.SetV(a.m_localPoint);this.m_type=a.m_type};Box2D.Collision.b2Manifold.prototype.Copy=function(){var a=new Box2D.Collision.b2Manifold;a.Set(this);return a};Box2D.Collision.b2Manifold.e_circles=1;Box2D.Collision.b2Manifold.e_faceA=2;Box2D.Collision.b2Manifold.e_faceB=4;Box2D.Collision.b2ManifoldPoint=function(){this.m_localPoint=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_id=new Box2D.Collision.b2ContactID;this.Reset()};Box2D.Collision.b2ManifoldPoint.prototype.Reset=
function(){this.m_localPoint.SetZero();this.m_tangentImpulse=this.m_normalImpulse=0;this.m_id.SetKey(0)};Box2D.Collision.b2ManifoldPoint.prototype.Set=function(a){this.m_localPoint.SetV(a.m_localPoint);this.m_normalImpulse=a.m_normalImpulse;this.m_tangentImpulse=a.m_tangentImpulse;this.m_id.Set(a.m_id)};Box2D.Collision.b2RayCastInput=function(a,b,c){this.p1=Box2D.Common.Math.b2Vec2.Get(0,0);this.p2=Box2D.Common.Math.b2Vec2.Get(0,0);void 0===c&&(c=1);a&&this.p1.SetV(a);b&&this.p2.SetV(b);this.maxFraction=
c};Box2D.Collision.b2RayCastOutput=function(){this.normal=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Segment=function(){this.p1=Box2D.Common.Math.b2Vec2.Get(0,0);this.p2=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Segment.prototype.TestSegment=function(a,b,c,d){void 0===d&&(d=0);var e=c.p1,h=c.p2.x-e.x,f=c.p2.y-e.y;c=this.p2.y-this.p1.y;var l=-(this.p2.x-this.p1.x),k=100*Number.MIN_VALUE,g=-(h*c+f*l);if(g>k){var m=e.x-this.p1.x,n=e.y-this.p1.y,e=m*c+n*l;if(0<=e&&e<=d*g&&(d=-h*n+
f*m,-k*g<=d&&d<=g*(1+k)))return e/=g,d=Math.sqrt(c*c+l*l),a[0]=e,b.Set(c/d,l/d),!0}return!1};Box2D.Collision.b2Segment.prototype.Extend=function(a){this.ExtendForward(a);this.ExtendBackward(a)};Box2D.Collision.b2Segment.prototype.ExtendForward=function(a){var b=this.p2.x-this.p1.x,c=this.p2.y-this.p1.y;a=Math.min(0<b?(a.upperBound_.x-this.p1.x)/b:0>b?(a.lowerBound_.x-this.p1.x)/b:Number.POSITIVE_INFINITY,0<c?(a.upperBound_.y-this.p1.y)/c:0>c?(a.lowerBound_.y-this.p1.y)/c:Number.POSITIVE_INFINITY);
this.p2.x=this.p1.x+b*a;this.p2.y=this.p1.y+c*a};Box2D.Collision.b2Segment.prototype.ExtendBackward=function(a){var b=-this.p2.x+this.p1.x,c=-this.p2.y+this.p1.y;a=Math.min(0<b?(a.upperBound_.x-this.p2.x)/b:0>b?(a.lowerBound_.x-this.p2.x)/b:Number.POSITIVE_INFINITY,0<c?(a.upperBound_.y-this.p2.y)/c:0>c?(a.lowerBound_.y-this.p2.y)/c:Number.POSITIVE_INFINITY);this.p1.x=this.p2.x+b*a;this.p1.y=this.p2.y+c*a};Box2D.Collision.b2SeparationFunction=function(){this.m_localPoint=Box2D.Common.Math.b2Vec2.Get(0,
0);this.m_axis=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2SeparationFunction.prototype.Initialize=function(a,b,c,d,e){this.m_proxyA=b;this.m_proxyB=d;var h,f,l,k=l=f=0,g=0;d=b=0;var m,n,k=0;1==a.count?(this.m_type=Box2D.Collision.b2SeparationFunction.e_points,h=this.m_proxyA.GetVertex(a.indexA[0]),a=this.m_proxyB.GetVertex(a.indexB[0]),n=h,m=c.R,f=c.position.x+(m.col1.x*n.x+m.col2.x*n.y),l=c.position.y+(m.col1.y*n.x+m.col2.y*n.y),n=a,m=e.R,k=e.position.x+(m.col1.x*n.x+m.col2.x*n.y),g=e.position.y+
(m.col1.y*n.x+m.col2.y*n.y),this.m_axis.x=k-f,this.m_axis.y=g-l,this.m_axis.Normalize()):(a.indexB[0]==a.indexB[1]?(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceA,b=this.m_proxyA.GetVertex(a.indexA[0]),d=this.m_proxyA.GetVertex(a.indexA[1]),a=this.m_proxyB.GetVertex(a.indexB[0]),this.m_localPoint.x=0.5*(b.x+d.x),this.m_localPoint.y=0.5*(b.y+d.y),this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(d,b),1),this.m_axis.Normalize(),n=this.m_axis,m=c.R,b=m.col1.x*
n.x+m.col2.x*n.y,d=m.col1.y*n.x+m.col2.y*n.y,n=this.m_localPoint,m=c.R,f=c.position.x+(m.col1.x*n.x+m.col2.x*n.y),l=c.position.y+(m.col1.y*n.x+m.col2.y*n.y),n=a,m=e.R,k=e.position.x+(m.col1.x*n.x+m.col2.x*n.y),g=e.position.y+(m.col1.y*n.x+m.col2.y*n.y),k=(k-f)*b+(g-l)*d):a.indexA[0]==a.indexA[0]?(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceB,f=this.m_proxyB.GetVertex(a.indexB[0]),l=this.m_proxyB.GetVertex(a.indexB[1]),h=this.m_proxyA.GetVertex(a.indexA[0]),this.m_localPoint.x=0.5*(f.x+
l.x),this.m_localPoint.y=0.5*(f.y+l.y),this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(l,f),1),this.m_axis.Normalize(),n=this.m_axis,m=e.R,b=m.col1.x*n.x+m.col2.x*n.y,d=m.col1.y*n.x+m.col2.y*n.y,n=this.m_localPoint,m=e.R,k=e.position.x+(m.col1.x*n.x+m.col2.x*n.y),g=e.position.y+(m.col1.y*n.x+m.col2.y*n.y),n=h,m=c.R,f=c.position.x+(m.col1.x*n.x+m.col2.x*n.y),l=c.position.y+(m.col1.y*n.x+m.col2.y*n.y),k=(f-k)*b+(l-g)*d):(b=this.m_proxyA.GetVertex(a.indexA[0]),d=this.m_proxyA.GetVertex(a.indexA[1]),
f=this.m_proxyB.GetVertex(a.indexB[0]),l=this.m_proxyB.GetVertex(a.indexB[1]),k=Box2D.Common.Math.b2Math.MulMV(c.R,Box2D.Common.Math.b2Math.SubtractVV(d,b)),g=Box2D.Common.Math.b2Math.MulMV(e.R,Box2D.Common.Math.b2Math.SubtractVV(l,f)),e=k.x*k.x+k.y*k.y,c=g.x*g.x+g.y*g.y,h=Box2D.Common.Math.b2Math.SubtractVV(g,k),a=k.x*h.x+k.y*h.y,h=g.x*h.x+g.y*h.y,g=k.x*g.x+k.y*g.y,m=e*c-g*g,k=0,0!=m&&(k=Box2D.Common.Math.b2Math.Clamp((g*h-a*c)/m,0,1)),0>(g*k+h)/c&&(k=Box2D.Common.Math.b2Math.Clamp((g-a)/e,0,1)),
h=Box2D.Common.Math.b2Vec2.Get(0,0),h.x=b.x+k*(d.x-b.x),h.y=b.y+k*(d.y-b.y),a=Box2D.Common.Math.b2Vec2.Get(0,0),a.x=f.x+k*(l.x-f.x),a.y=f.y+k*(l.y-f.y),0==k||1==k?(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceB,this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(l,f),1),this.m_axis.Normalize(),this.m_localPoint=a):(this.m_type=Box2D.Collision.b2SeparationFunction.e_faceA,this.m_axis=Box2D.Common.Math.b2Math.CrossVF(Box2D.Common.Math.b2Math.SubtractVV(d,b),1),
this.m_localPoint=h)),0>k&&this.m_axis.NegativeSelf())};Box2D.Collision.b2SeparationFunction.prototype.Evaluate=function(a,b){var c,d,e=0;switch(this.m_type){case Box2D.Collision.b2SeparationFunction.e_points:c=Box2D.Common.Math.b2Math.MulTMV(a.R,this.m_axis);d=Box2D.Common.Math.b2Math.MulTMV(b.R,this.m_axis.GetNegative());c=this.m_proxyA.GetSupportVertex(c);d=this.m_proxyB.GetSupportVertex(d);c=Box2D.Common.Math.b2Math.MulX(a,c);d=Box2D.Common.Math.b2Math.MulX(b,d);e=(d.x-c.x)*this.m_axis.x+(d.y-
c.y)*this.m_axis.y;break;case Box2D.Collision.b2SeparationFunction.e_faceA:e=Box2D.Common.Math.b2Math.MulMV(a.R,this.m_axis);c=Box2D.Common.Math.b2Math.MulX(a,this.m_localPoint);d=Box2D.Common.Math.b2Math.MulTMV(b.R,e.GetNegative());d=this.m_proxyB.GetSupportVertex(d);d=Box2D.Common.Math.b2Math.MulX(b,d);e=(d.x-c.x)*e.x+(d.y-c.y)*e.y;break;case Box2D.Collision.b2SeparationFunction.e_faceB:e=Box2D.Common.Math.b2Math.MulMV(b.R,this.m_axis),d=Box2D.Common.Math.b2Math.MulX(b,this.m_localPoint),c=Box2D.Common.Math.b2Math.MulTMV(a.R,
e.GetNegative()),c=this.m_proxyA.GetSupportVertex(c),c=Box2D.Common.Math.b2Math.MulX(a,c),e=(c.x-d.x)*e.x+(c.y-d.y)*e.y}return e};Box2D.Collision.b2SeparationFunction.e_points=1;Box2D.Collision.b2SeparationFunction.e_faceA=2;Box2D.Collision.b2SeparationFunction.e_faceB=4;Box2D.Collision.b2Simplex=function(){this.m_v1=new Box2D.Collision.b2SimplexVertex;this.m_v2=new Box2D.Collision.b2SimplexVertex;this.m_v3=new Box2D.Collision.b2SimplexVertex;this.m_vertices=[this.m_v1,this.m_v2,this.m_v3]};Box2D.Collision.b2Simplex.prototype.ReadCache=
function(a,b,c,d,e){var h,f;this.m_count=a.count;for(var l=this.m_vertices,k=0;k<this.m_count;k++){var g=l[k];g.indexA=a.indexA[k];g.indexB=a.indexB[k];h=b.GetVertex(g.indexA);f=d.GetVertex(g.indexB);g.wA=Box2D.Common.Math.b2Math.MulX(c,h);g.wB=Box2D.Common.Math.b2Math.MulX(e,f);g.w=Box2D.Common.Math.b2Math.SubtractVV(g.wB,g.wA);g.a=0}1<this.m_count&&(a=a.metric,h=this.GetMetric(),h<0.5*a||2*a<h||h<Number.MIN_VALUE)&&(this.m_count=0);0==this.m_count&&(g=l[0],g.indexA=0,g.indexB=0,h=b.GetVertex(0),
f=d.GetVertex(0),g.wA=Box2D.Common.Math.b2Math.MulX(c,h),g.wB=Box2D.Common.Math.b2Math.MulX(e,f),g.w=Box2D.Common.Math.b2Math.SubtractVV(g.wB,g.wA),this.m_count=1)};Box2D.Collision.b2Simplex.prototype.WriteCache=function(a){a.metric=this.GetMetric();a.count=this.m_count;for(var b=this.m_vertices,c=0;c<this.m_count;c++)a.indexA[c]=b[c].indexA,a.indexB[c]=b[c].indexB};Box2D.Collision.b2Simplex.prototype.GetSearchDirection=function(){if(1==this.m_count)return this.m_v1.w.GetNegative();if(2==this.m_count){var a=
Box2D.Common.Math.b2Math.SubtractVV(this.m_v2.w,this.m_v1.w);return 0<Box2D.Common.Math.b2Math.CrossVV(a,this.m_v1.w.GetNegative())?Box2D.Common.Math.b2Math.CrossFV(1,a):Box2D.Common.Math.b2Math.CrossVF(a,1)}return Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2Simplex.prototype.GetClosestPoint=function(){return 1==this.m_count?this.m_v1.w:2==this.m_count?Box2D.Common.Math.b2Vec2.Get(this.m_v1.a*this.m_v1.w.x+this.m_v2.a*this.m_v2.w.x,this.m_v1.a*this.m_v1.w.y+this.m_v2.a*this.m_v2.w.y):Box2D.Common.Math.b2Vec2.Get(0,
0)};Box2D.Collision.b2Simplex.prototype.GetWitnessPoints=function(a,b){1==this.m_count?(a.SetV(this.m_v1.wA),b.SetV(this.m_v1.wB)):2==this.m_count?(a.x=this.m_v1.a*this.m_v1.wA.x+this.m_v2.a*this.m_v2.wA.x,a.y=this.m_v1.a*this.m_v1.wA.y+this.m_v2.a*this.m_v2.wA.y,b.x=this.m_v1.a*this.m_v1.wB.x+this.m_v2.a*this.m_v2.wB.x,b.y=this.m_v1.a*this.m_v1.wB.y+this.m_v2.a*this.m_v2.wB.y):3==this.m_count&&(b.x=a.x=this.m_v1.a*this.m_v1.wA.x+this.m_v2.a*this.m_v2.wA.x+this.m_v3.a*this.m_v3.wA.x,b.y=a.y=this.m_v1.a*
this.m_v1.wA.y+this.m_v2.a*this.m_v2.wA.y+this.m_v3.a*this.m_v3.wA.y)};Box2D.Collision.b2Simplex.prototype.GetMetric=function(){return 1==this.m_count?0:2==this.m_count?Box2D.Common.Math.b2Math.SubtractVV(this.m_v1.w,this.m_v2.w).Length():3==this.m_count?Box2D.Common.Math.b2Math.CrossVV(Box2D.Common.Math.b2Math.SubtractVV(this.m_v2.w,this.m_v1.w),Box2D.Common.Math.b2Math.SubtractVV(this.m_v3.w,this.m_v1.w)):0};Box2D.Collision.b2Simplex.prototype.Solve2=function(){var a=this.m_v1.w,b=this.m_v2.w,c=
Box2D.Common.Math.b2Math.SubtractVV(b,a),a=-(a.x*c.x+a.y*c.y);0>=a?this.m_count=this.m_v1.a=1:(b=b.x*c.x+b.y*c.y,0>=b?(this.m_count=this.m_v2.a=1,this.m_v1.Set(this.m_v2)):(c=1/(b+a),this.m_v1.a=b*c,this.m_v2.a=a*c,this.m_count=2))};Box2D.Collision.b2Simplex.prototype.Solve3=function(){var a=this.m_v1.w,b=this.m_v2.w,c=this.m_v3.w,d=Box2D.Common.Math.b2Math.SubtractVV(b,a),e=Box2D.Common.Math.b2Math.Dot(a,d),h=Box2D.Common.Math.b2Math.Dot(b,d),e=-e,f=Box2D.Common.Math.b2Math.SubtractVV(c,a),l=Box2D.Common.Math.b2Math.Dot(a,
f),k=Box2D.Common.Math.b2Math.Dot(c,f),l=-l,g=Box2D.Common.Math.b2Math.SubtractVV(c,b),m=Box2D.Common.Math.b2Math.Dot(b,g),g=Box2D.Common.Math.b2Math.Dot(c,g),m=-m,f=Box2D.Common.Math.b2Math.CrossVV(d,f),d=f*Box2D.Common.Math.b2Math.CrossVV(b,c),c=f*Box2D.Common.Math.b2Math.CrossVV(c,a),a=f*Box2D.Common.Math.b2Math.CrossVV(a,b);0>=e&&0>=l?this.m_count=this.m_v1.a=1:0<h&&0<e&&0>=a?(k=1/(h+e),this.m_v1.a=h*k,this.m_v2.a=e*k,this.m_count=2):0<k&&0<l&&0>=c?(h=1/(k+l),this.m_v1.a=k*h,this.m_v3.a=l*h,this.m_count=
2,this.m_v2.Set(this.m_v3)):0>=h&&0>=m?(this.m_count=this.m_v2.a=1,this.m_v1.Set(this.m_v2)):0>=k&&0>=g?(this.m_count=this.m_v3.a=1,this.m_v1.Set(this.m_v3)):0<g&&0<m&&0>=d?(h=1/(g+m),this.m_v2.a=g*h,this.m_v3.a=m*h,this.m_count=2,this.m_v1.Set(this.m_v3)):(h=1/(d+c+a),this.m_v1.a=d*h,this.m_v2.a=c*h,this.m_v3.a=a*h,this.m_count=3)};Box2D.Collision.b2SimplexCache=function(){this.indexA=[0,0,0];this.indexB=[0,0,0]};Box2D.Collision.b2SimplexVertex=function(){};Box2D.Collision.b2SimplexVertex.prototype.Set=
function(a){this.wA.SetV(a.wA);this.wB.SetV(a.wB);this.w.SetV(a.w);this.a=a.a;this.indexA=a.indexA;this.indexB=a.indexB};Box2D.Collision.b2TOIInput=function(){this.proxyA=new Box2D.Collision.b2DistanceProxy;this.proxyB=new Box2D.Collision.b2DistanceProxy;this.sweepA=new Box2D.Common.Math.b2Sweep;this.sweepB=new Box2D.Common.Math.b2Sweep};Box2D.Collision.b2TimeOfImpact={};Box2D.Collision.b2TimeOfImpact.TimeOfImpact=function(a){Box2D.Collision.b2TimeOfImpact.b2_toiCalls++;var b=a.proxyA,c=a.proxyB,
d=a.sweepA,e=a.sweepB,h=b.m_radius+c.m_radius;a=a.tolerance;var f=0,l=0,k=0;Box2D.Collision.b2TimeOfImpact.s_cache.count=0;for(Box2D.Collision.b2TimeOfImpact.s_distanceInput.useRadii=!1;;){d.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfA,f);e.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfB,f);Box2D.Collision.b2TimeOfImpact.s_distanceInput.proxyA=b;Box2D.Collision.b2TimeOfImpact.s_distanceInput.proxyB=c;Box2D.Collision.b2TimeOfImpact.s_distanceInput.transformA=Box2D.Collision.b2TimeOfImpact.s_xfA;
Box2D.Collision.b2TimeOfImpact.s_distanceInput.transformB=Box2D.Collision.b2TimeOfImpact.s_xfB;Box2D.Collision.b2Distance.Distance(Box2D.Collision.b2TimeOfImpact.s_distanceOutput,Box2D.Collision.b2TimeOfImpact.s_cache,Box2D.Collision.b2TimeOfImpact.s_distanceInput);if(0>=Box2D.Collision.b2TimeOfImpact.s_distanceOutput.distance){f=1;break}Box2D.Collision.b2TimeOfImpact.s_fcn.Initialize(Box2D.Collision.b2TimeOfImpact.s_cache,b,Box2D.Collision.b2TimeOfImpact.s_xfA,c,Box2D.Collision.b2TimeOfImpact.s_xfB);
var g=Box2D.Collision.b2TimeOfImpact.s_fcn.Evaluate(Box2D.Collision.b2TimeOfImpact.s_xfA,Box2D.Collision.b2TimeOfImpact.s_xfB);if(0>=g){f=1;break}0==l&&(k=g>h?Math.max(h-a,0.75*h):Math.max(g-a,0.02*h));if(g-k<0.5*a){if(0==l){f=1;break}break}var m=f,n=f,p=1;d.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfA,p);e.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfB,p);var r=Box2D.Collision.b2TimeOfImpact.s_fcn.Evaluate(Box2D.Collision.b2TimeOfImpact.s_xfA,Box2D.Collision.b2TimeOfImpact.s_xfB);if(r>=k){f=
1;break}for(var s=0;;){var q=0,q=s&1?n+(k-g)*(p-n)/(r-g):0.5*(n+p);d.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfA,q);e.GetTransform(Box2D.Collision.b2TimeOfImpact.s_xfB,q);var t=Box2D.Collision.b2TimeOfImpact.s_fcn.Evaluate(Box2D.Collision.b2TimeOfImpact.s_xfA,Box2D.Collision.b2TimeOfImpact.s_xfB);if(Math.abs(t-k)<0.025*a){m=q;break}t>k?(n=q,g=t):(p=q,r=t);s++;Box2D.Collision.b2TimeOfImpact.b2_toiRootIters++;if(50==s)break}Box2D.Collision.b2TimeOfImpact.b2_toiMaxRootIters=Math.max(Box2D.Collision.b2TimeOfImpact.b2_toiMaxRootIters,
s);if(m<(1+100*Number.MIN_VALUE)*f)break;f=m;l++;Box2D.Collision.b2TimeOfImpact.b2_toiIters++;if(1E3==l)break}Box2D.Collision.b2TimeOfImpact.b2_toiMaxIters=Math.max(Box2D.Collision.b2TimeOfImpact.b2_toiMaxIters,l);return f};Box2D.Collision.b2WorldManifold=function(){this.m_normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_points=[];for(var a=this.m_pointCount=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a]=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Collision.b2WorldManifold.prototype.Initialize=
function(a,b,c,d,e){if(0!=a.m_pointCount){var h=0,f,l,k=0,g=0,m=0,n=0,p=0;f=0;switch(a.m_type){case Box2D.Collision.b2Manifold.e_circles:l=b.R;f=a.m_localPoint;h=b.position.x+l.col1.x*f.x+l.col2.x*f.y;b=b.position.y+l.col1.y*f.x+l.col2.y*f.y;l=d.R;f=a.m_points[0].m_localPoint;a=d.position.x+l.col1.x*f.x+l.col2.x*f.y;d=d.position.y+l.col1.y*f.x+l.col2.y*f.y;f=a-h;l=d-b;k=f*f+l*l;k>Box2D.Common.b2Settings.MIN_VALUE_SQUARED?(k=Math.sqrt(k),this.m_normal.x=f/k,this.m_normal.y=l/k):(this.m_normal.x=1,
this.m_normal.y=0);f=b+c*this.m_normal.y;d-=e*this.m_normal.y;this.m_points[0].x=0.5*(h+c*this.m_normal.x+(a-e*this.m_normal.x));this.m_points[0].y=0.5*(f+d);break;case Box2D.Collision.b2Manifold.e_faceA:l=b.R;f=a.m_localPlaneNormal;k=l.col1.x*f.x+l.col2.x*f.y;g=l.col1.y*f.x+l.col2.y*f.y;l=b.R;f=a.m_localPoint;m=b.position.x+l.col1.x*f.x+l.col2.x*f.y;n=b.position.y+l.col1.y*f.x+l.col2.y*f.y;this.m_normal.x=k;this.m_normal.y=g;for(h=0;h<a.m_pointCount;h++)l=d.R,f=a.m_points[h].m_localPoint,p=d.position.x+
l.col1.x*f.x+l.col2.x*f.y,f=d.position.y+l.col1.y*f.x+l.col2.y*f.y,this.m_points[h].x=p+0.5*(c-(p-m)*k-(f-n)*g-e)*k,this.m_points[h].y=f+0.5*(c-(p-m)*k-(f-n)*g-e)*g;break;case Box2D.Collision.b2Manifold.e_faceB:for(l=d.R,f=a.m_localPlaneNormal,k=l.col1.x*f.x+l.col2.x*f.y,g=l.col1.y*f.x+l.col2.y*f.y,l=d.R,f=a.m_localPoint,m=d.position.x+l.col1.x*f.x+l.col2.x*f.y,n=d.position.y+l.col1.y*f.x+l.col2.y*f.y,this.m_normal.x=-k,this.m_normal.y=-g,h=0;h<a.m_pointCount;h++)l=b.R,f=a.m_points[h].m_localPoint,
p=b.position.x+l.col1.x*f.x+l.col2.x*f.y,f=b.position.y+l.col1.y*f.x+l.col2.y*f.y,this.m_points[h].x=p+0.5*(e-(p-m)*k-(f-n)*g-c)*k,this.m_points[h].y=f+0.5*(e-(p-m)*k-(f-n)*g-c)*g}}};Box2D.Dynamics.b2Body=function(a,b){this.ID="Body"+Box2D.Dynamics.b2Body.NEXT_ID++;this.m_xf=new Box2D.Common.Math.b2Transform;this.m_xf.position.SetV(a.position);this.m_xf.R.Set(a.angle);this.m_sweep=new Box2D.Common.Math.b2Sweep;this.m_sweep.localCenter.SetZero();this.m_sweep.t0=1;this.m_sweep.a0=this.m_sweep.a=a.angle;
this.m_sweep.c.x=this.m_xf.R.col1.x*this.m_sweep.localCenter.x+this.m_xf.R.col2.x*this.m_sweep.localCenter.y;this.m_sweep.c.y=this.m_xf.R.col1.y*this.m_sweep.localCenter.x+this.m_xf.R.col2.y*this.m_sweep.localCenter.y;this.m_sweep.c.x+=this.m_xf.position.x;this.m_sweep.c.y+=this.m_xf.position.y;this.m_sweep.c0.SetV(this.m_sweep.c);this.m_linearVelocity=a.linearVelocity.Copy();this.m_force=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_bullet=a.bullet;this.m_fixedRotation=a.fixedRotation;this.m_allowSleep=
a.allowSleep;this.m_awake=a.awake;this.m_active=a.active;this.m_world=b;this.m_jointList=null;this.contactList=new Box2D.Dynamics.Contacts.b2ContactList;this.controllerList=new Box2D.Dynamics.Controllers.b2ControllerList;this.m_controllerCount=0;this.m_angularVelocity=a.angularVelocity;this.m_linearDamping=a.linearDamping;this.m_angularDamping=a.angularDamping;this.m_sleepTime=this.m_torque=0;this.m_type=a.type;this.m_mass=this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody?1:0;this.m_invMass=this.m_type==
Box2D.Dynamics.b2BodyDef.b2_dynamicBody?1:0;this.m_invI=this.m_I=0;this.m_inertiaScale=a.inertiaScale;this.fixtureList=new Box2D.Dynamics.b2FixtureList;this.m_lists=[]};Box2D.Dynamics.b2Body.prototype.CreateFixture=function(a){a=new Box2D.Dynamics.b2Fixture(this,this.m_xf,a);this.m_active&&a.CreateProxy(this.m_world.m_contactManager.m_broadPhase,this.m_xf);this.fixtureList.AddFixture(a);a.m_body=this;0<a.m_density&&this.ResetMassData();this.m_world.m_newFixture=!0;return a};Box2D.Dynamics.b2Body.prototype.CreateFixture2=
function(a,b){void 0===b&&(b=0);var c=new Box2D.Dynamics.b2FixtureDef;c.shape=a;c.density=b;return this.CreateFixture(c)};Box2D.Dynamics.b2Body.prototype.Destroy=function(){Box2D.Common.Math.b2Vec2.Free(this.m_linearVelocity);Box2D.Common.Math.b2Vec2.Free(this.m_force)};Box2D.Dynamics.b2Body.prototype.DestroyFixture=function(a){this.fixtureList.RemoveFixture(a);for(var b=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);b;b=b.GetNextNode())a!=b.contact.m_fixtureA&&
a!=b.contact.m_fixtureB||this.m_world.m_contactManager.Destroy(b.contact);this.m_active&&a.DestroyProxy(this.m_world.m_contactManager.m_broadPhase);a.Destroy();a.m_body=null;this.ResetMassData()};Box2D.Dynamics.b2Body.prototype.SetPositionAndAngle=function(a,b){this.m_xf.R.Set(b);this.m_xf.position.SetV(a);var c=this.m_xf.R,d=this.m_sweep.localCenter;this.m_sweep.c.x=c.col1.x*d.x+c.col2.x*d.y;this.m_sweep.c.y=c.col1.y*d.x+c.col2.y*d.y;this.m_sweep.c.x+=this.m_xf.position.x;this.m_sweep.c.y+=this.m_xf.position.y;
this.m_sweep.c0.SetV(this.m_sweep.c);this.m_sweep.a0=this.m_sweep.a=b;c=this.m_world.m_contactManager.m_broadPhase;for(d=this.fixtureList.GetFirstNode();d;d=d.GetNextNode())d.fixture.Synchronize(c,this.m_xf,this.m_xf);this.m_world.m_contactManager.FindNewContacts()};Box2D.Dynamics.b2Body.prototype.SetTransform=function(a){this.SetPositionAndAngle(a.position,a.GetAngle())};Box2D.Dynamics.b2Body.prototype.GetTransform=function(){return this.m_xf};Box2D.Dynamics.b2Body.prototype.GetPosition=function(){return this.m_xf.position};
Box2D.Dynamics.b2Body.prototype.SetPosition=function(a){this.SetPositionAndAngle(a,this.GetAngle())};Box2D.Dynamics.b2Body.prototype.GetAngle=function(){return this.m_sweep.a};Box2D.Dynamics.b2Body.prototype.SetAngle=function(a){this.SetPositionAndAngle(this.GetPosition(),a)};Box2D.Dynamics.b2Body.prototype.GetWorldCenter=function(){return this.m_sweep.c};Box2D.Dynamics.b2Body.prototype.GetLocalCenter=function(){return this.m_sweep.localCenter};Box2D.Dynamics.b2Body.prototype.SetLinearVelocity=function(a){this.m_type!=
Box2D.Dynamics.b2BodyDef.b2_staticBody&&this.m_linearVelocity.SetV(a)};Box2D.Dynamics.b2Body.prototype.GetLinearVelocity=function(){return this.m_linearVelocity};Box2D.Dynamics.b2Body.prototype.SetAngularVelocity=function(a){void 0===a&&(a=0);this.m_type!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(this.m_angularVelocity=a)};Box2D.Dynamics.b2Body.prototype.GetAngularVelocity=function(){return this.m_angularVelocity};Box2D.Dynamics.b2Body.prototype.GetDefinition=function(){var a=new Box2D.Dynamics.b2BodyDef;
a.type=this.GetType();a.allowSleep=this.m_allowSleep;a.angle=this.GetAngle();a.angularDamping=this.m_angularDamping;a.angularVelocity=this.m_angularVelocity;a.fixedRotation=this.m_fixedRotation;a.bullet=this.m_bullet;a.active=this.m_active;a.awake=this.m_awake;a.linearDamping=this.m_linearDamping;a.linearVelocity.SetV(this.GetLinearVelocity());a.position=this.GetPosition();return a};Box2D.Dynamics.b2Body.prototype.ApplyForce=function(a,b){this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(this.SetAwake(!0),
this.m_force.x+=a.x,this.m_force.y+=a.y,this.m_torque+=(b.x-this.m_sweep.c.x)*a.y-(b.y-this.m_sweep.c.y)*a.x)};Box2D.Dynamics.b2Body.prototype.ApplyTorque=function(a){void 0===a&&(a=0);this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(this.SetAwake(!0),this.m_torque+=a)};Box2D.Dynamics.b2Body.prototype.ApplyImpulse=function(a,b){this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(this.SetAwake(!0),this.m_linearVelocity.x+=this.m_invMass*a.x,this.m_linearVelocity.y+=this.m_invMass*a.y,this.m_angularVelocity+=
this.m_invI*((b.x-this.m_sweep.c.x)*a.y-(b.y-this.m_sweep.c.y)*a.x))};Box2D.Dynamics.b2Body.prototype.Split=function(a){for(var b=this.GetLinearVelocity().Copy(),c=this.GetAngularVelocity(),d=this.GetWorldCenter(),e=this.m_world.CreateBody(this.GetDefinition()),h=this.fixtureList.GetFirstNode();h;h=h.GetNextNode()){var f=h.fixture;a(f)&&(this.fixtureList.RemoveFixture(f),e.fixtureList.AddFixture(f))}this.ResetMassData();e.ResetMassData();h=this.GetWorldCenter();a=e.GetWorldCenter();h=Box2D.Common.Math.b2Math.AddVV(b,
Box2D.Common.Math.b2Math.CrossFV(c,Box2D.Common.Math.b2Math.SubtractVV(h,d)));b=Box2D.Common.Math.b2Math.AddVV(b,Box2D.Common.Math.b2Math.CrossFV(c,Box2D.Common.Math.b2Math.SubtractVV(a,d)));this.SetLinearVelocity(h);e.SetLinearVelocity(b);this.SetAngularVelocity(c);e.SetAngularVelocity(c);this.SynchronizeFixtures();e.SynchronizeFixtures();return e};Box2D.Dynamics.b2Body.prototype.Merge=function(a){for(var b=a.fixtureList.GetFirstNode();b;b=b.GetNextNode())this.fixtureList.AddFixture(b.fixture),a.fixtureList.RemoveFixture(b.fixture);
a.ResetMassData();this.ResetMassData();this.SynchronizeFixtures()};Box2D.Dynamics.b2Body.prototype.GetMass=function(){return this.m_mass};Box2D.Dynamics.b2Body.prototype.GetInertia=function(){return this.m_I};Box2D.Dynamics.b2Body.prototype.GetMassData=function(a){a||(a=new Box2D.Collision.Shapes.b2MassData);a.mass=this.m_mass;a.I=this.m_I;a.center.SetV(this.m_sweep.localCenter);return a};Box2D.Dynamics.b2Body.prototype.SetMassData=function(a){if(this.m_type==Box2D.Dynamics.b2BodyDef.b2_dynamicBody){this.m_invI=
this.m_I=this.m_invMass=0;this.m_mass=a.mass;0>=this.m_mass&&(this.m_mass=1);this.m_invMass=1/this.m_mass;0<a.I&&!this.m_fixedRotation&&(this.m_I=a.I-this.m_mass*(a.center.x*a.center.x+a.center.y*a.center.y),this.m_invI=1/this.m_I);var b=this.m_sweep.c.Copy();this.m_sweep.localCenter.SetV(a.center);this.m_sweep.c0.SetV(Box2D.Common.Math.b2Math.MulX(this.m_xf,this.m_sweep.localCenter));this.m_sweep.c.SetV(this.m_sweep.c0);this.m_linearVelocity.x+=this.m_angularVelocity*-(this.m_sweep.c.y-b.y);this.m_linearVelocity.y+=
this.m_angularVelocity*+(this.m_sweep.c.x-b.x)}};Box2D.Dynamics.b2Body.prototype.ResetMassData=function(){this.m_invI=this.m_I=this.m_invMass=this.m_mass=0;this.m_sweep.localCenter.SetZero();if(this.m_type!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&this.m_type!=Box2D.Dynamics.b2BodyDef.b2_kinematicBody){for(var a=Box2D.Common.Math.b2Vec2.Get(0,0),b=this.fixtureList.GetFirstNode();b;b=b.GetNextNode()){var c=b.fixture;0!=c.m_density&&(c=c.GetMassData(),this.m_mass+=c.mass,a.x+=c.center.x*c.mass,a.y+=
c.center.y*c.mass,this.m_I+=c.I)}0<this.m_mass?(this.m_invMass=1/this.m_mass,a.x*=this.m_invMass,a.y*=this.m_invMass):this.m_invMass=this.m_mass=1;0<this.m_I&&!this.m_fixedRotation?(this.m_I-=this.m_mass*(a.x*a.x+a.y*a.y),this.m_I*=this.m_inertiaScale,this.m_invI=1/this.m_I):this.m_invI=this.m_I=0;b=this.m_sweep.c.Copy();this.m_sweep.localCenter.SetV(a);this.m_sweep.c0.SetV(Box2D.Common.Math.b2Math.MulX(this.m_xf,this.m_sweep.localCenter));this.m_sweep.c.SetV(this.m_sweep.c0);this.m_linearVelocity.x+=
this.m_angularVelocity*-(this.m_sweep.c.y-b.y);this.m_linearVelocity.y+=this.m_angularVelocity*+(this.m_sweep.c.x-b.x);Box2D.Common.Math.b2Vec2.Free(a);Box2D.Common.Math.b2Vec2.Free(b)}};Box2D.Dynamics.b2Body.prototype.GetWorldPoint=function(a){var b=this.m_xf.R;a=Box2D.Common.Math.b2Vec2.Get(b.col1.x*a.x+b.col2.x*a.y,b.col1.y*a.x+b.col2.y*a.y);a.x+=this.m_xf.position.x;a.y+=this.m_xf.position.y;return a};Box2D.Dynamics.b2Body.prototype.GetWorldVector=function(a){return Box2D.Common.Math.b2Math.MulMV(this.m_xf.R,
a)};Box2D.Dynamics.b2Body.prototype.GetLocalPoint=function(a){return Box2D.Common.Math.b2Math.MulXT(this.m_xf,a)};Box2D.Dynamics.b2Body.prototype.GetLocalVector=function(a){return Box2D.Common.Math.b2Math.MulTMV(this.m_xf.R,a)};Box2D.Dynamics.b2Body.prototype.GetLinearVelocityFromWorldPoint=function(a){return Box2D.Common.Math.b2Vec2.Get(this.m_linearVelocity.x-this.m_angularVelocity*(a.y-this.m_sweep.c.y),this.m_linearVelocity.y+this.m_angularVelocity*(a.x-this.m_sweep.c.x))};Box2D.Dynamics.b2Body.prototype.GetLinearVelocityFromLocalPoint=
function(a){var b=this.m_xf.R;a=Box2D.Common.Math.b2Vec2.Get(b.col1.x*a.x+b.col2.x*a.y,b.col1.y*a.x+b.col2.y*a.y);a.x+=this.m_xf.position.x;a.y+=this.m_xf.position.y;b=Box2D.Common.Math.b2Vec2.Get(this.m_linearVelocity.x-this.m_angularVelocity*(a.y-this.m_sweep.c.y),this.m_linearVelocity.y+this.m_angularVelocity*(a.x-this.m_sweep.c.x));Box2D.Common.Math.b2Vec2.Free(a);return b};Box2D.Dynamics.b2Body.prototype.GetLinearDamping=function(){return this.m_linearDamping};Box2D.Dynamics.b2Body.prototype.SetLinearDamping=
function(a){this.m_linearDamping=a};Box2D.Dynamics.b2Body.prototype.GetAngularDamping=function(){return this.m_angularDamping};Box2D.Dynamics.b2Body.prototype.SetAngularDamping=function(a){this.m_angularDamping=a};Box2D.Dynamics.b2Body.prototype.SetType=function(a){if(this.m_type!=a){this.m_type=a;this.ResetMassData();this.m_type==Box2D.Dynamics.b2BodyDef.b2_staticBody&&(this.m_linearVelocity.SetZero(),this.m_angularVelocity=0);this.SetAwake(!0);this.m_force.SetZero();this.m_torque=0;for(a=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=
a.GetNextNode())a.contact.FlagForFiltering();for(a=0;a<this.m_lists.length;a++)this.m_lists[a].UpdateBody(this)}};Box2D.Dynamics.b2Body.prototype.GetType=function(){return this.m_type};Box2D.Dynamics.b2Body.prototype.SetBullet=function(a){this.m_bullet=a};Box2D.Dynamics.b2Body.prototype.IsBullet=function(){return this.m_bullet};Box2D.Dynamics.b2Body.prototype.SetSleepingAllowed=function(a){(this.m_allowSleep=a)||this.SetAwake(!0)};Box2D.Dynamics.b2Body.prototype.SetAwake=function(a){if(this.m_awake!=
a)for(this.m_awake=a,this.m_sleepTime=0,a||(this.m_linearVelocity.SetZero(),this.m_angularVelocity=0,this.m_force.SetZero(),this.m_torque=0),a=0;a<this.m_lists.length;a++)this.m_lists[a].UpdateBody(this)};Box2D.Dynamics.b2Body.prototype.IsAwake=function(){return this.m_awake};Box2D.Dynamics.b2Body.prototype.SetFixedRotation=function(a){this.m_fixedRotation=a;this.ResetMassData()};Box2D.Dynamics.b2Body.prototype.IsFixedRotation=function(){return this.m_fixedRotation};Box2D.Dynamics.b2Body.prototype.SetActive=
function(a){if(a!=this.m_active){if(a){this.m_active=!0;a=this.m_world.m_contactManager.m_broadPhase;for(var b=this.fixtureList.GetFirstNode();b;b=b.GetNextNode())b.fixture.CreateProxy(a,this.m_xf)}else{this.m_active=!1;a=this.m_world.m_contactManager.m_broadPhase;for(b=this.fixtureList.GetFirstNode();b;b=b.GetNextNode())b.fixture.DestroyProxy(a);for(a=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())this.m_world.m_contactManager.Destroy(a.contact)}for(a=
0;a<this.m_lists.length;a++)this.m_lists[a].UpdateBody(this)}};Box2D.Dynamics.b2Body.prototype.IsActive=function(){return this.m_active};Box2D.Dynamics.b2Body.prototype.IsSleepingAllowed=function(){return this.m_allowSleep};Box2D.Dynamics.b2Body.prototype.GetFixtureList=function(){return this.fixtureList};Box2D.Dynamics.b2Body.prototype.GetJointList=function(){return this.m_jointList};Box2D.Dynamics.b2Body.prototype.GetControllerList=function(){return this.controllerList};Box2D.Dynamics.b2Body.prototype.AddController=
function(a){this.controllerList.AddController(a)};Box2D.Dynamics.b2Body.prototype.RemoveController=function(a){this.controllerList.RemoveController(a)};Box2D.Dynamics.b2Body.prototype.GetContactList=function(){return this.contactList};Box2D.Dynamics.b2Body.prototype.GetWorld=function(){return this.m_world};Box2D.Dynamics.b2Body.prototype.SynchronizeFixtures=function(){var a=Box2D.Dynamics.b2Body.s_xf1;a.R.Set(this.m_sweep.a0);var b=a.R,c=this.m_sweep.localCenter;a.position.x=this.m_sweep.c0.x-(b.col1.x*
c.x+b.col2.x*c.y);a.position.y=this.m_sweep.c0.y-(b.col1.y*c.x+b.col2.y*c.y);b=this.m_world.m_contactManager.m_broadPhase;for(c=this.fixtureList.GetFirstNode();c;c=c.GetNextNode())c.fixture.Synchronize(b,a,this.m_xf)};Box2D.Dynamics.b2Body.prototype.SynchronizeTransform=function(){this.m_xf.R.Set(this.m_sweep.a);var a=this.m_xf.R,b=this.m_sweep.localCenter;this.m_xf.position.x=this.m_sweep.c.x-(a.col1.x*b.x+a.col2.x*b.y);this.m_xf.position.y=this.m_sweep.c.y-(a.col1.y*b.x+a.col2.y*b.y)};Box2D.Dynamics.b2Body.prototype.ShouldCollide=
function(a){if(this.m_type!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&a.m_type!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody)return!1;for(var b=this.m_jointList;b;b=b.next)if(b.other==a&&!1==b.joint.m_collideConnected)return!1;return!0};Box2D.Dynamics.b2Body.prototype.Advance=function(a){this.m_sweep.Advance(a);this.m_sweep.c.SetV(this.m_sweep.c0);this.m_sweep.a=this.m_sweep.a0;this.SynchronizeTransform()};Box2D.Dynamics.b2Body.NEXT_ID=0;Box2D.Dynamics.b2BodyDef=function(){this.position=Box2D.Common.Math.b2Vec2.Get(0,
0);this.linearVelocity=Box2D.Common.Math.b2Vec2.Get(0,0);this.angularDamping=this.linearDamping=this.angularVelocity=this.angle=0;this.awake=this.allowSleep=!0;this.bullet=this.fixedRotation=!1;this.type=Box2D.Dynamics.b2BodyDef.b2_staticBody;this.active=!0;this.inertiaScale=1};Box2D.Dynamics.b2BodyDef.b2_staticBody=0;Box2D.Dynamics.b2BodyDef.b2_kinematicBody=1;Box2D.Dynamics.b2BodyDef.b2_dynamicBody=2;Box2D.Dynamics.b2BodyList=function(){this.bodyFirstNodes=[];for(var a=0;a<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;a++)this.bodyFirstNodes[a]=
null;this.bodyLastNodes=[];for(a=0;a<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;a++)this.bodyLastNodes[a]=null;this.bodyNodeLookup={};this.bodyCount=0};Box2D.Dynamics.b2BodyList.prototype.GetFirstNode=function(a){return this.bodyFirstNodes[a]};Box2D.Dynamics.b2BodyList.prototype.AddBody=function(a){var b=a.ID;null==this.bodyNodeLookup[b]&&(this.CreateNode(a,b,Box2D.Dynamics.b2BodyList.TYPES.allBodies),this.UpdateBody(a),a.m_lists.push(this),this.bodyCount++)};Box2D.Dynamics.b2BodyList.prototype.UpdateBody=
function(a){var b=a.GetType(),c=a.ID,d=a.IsAwake(),e=a.IsActive();b==Box2D.Dynamics.b2BodyDef.b2_dynamicBody?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.dynamicBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.dynamicBodies);b!=Box2D.Dynamics.b2BodyDef.b2_staticBody?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticBodies);b!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&e&&d?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies):
this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies);d?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.awakeBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);e?this.CreateNode(a,c,Box2D.Dynamics.b2BodyList.TYPES.activeBodies):this.RemoveNode(c,Box2D.Dynamics.b2BodyList.TYPES.activeBodies)};Box2D.Dynamics.b2BodyList.prototype.RemoveBody=function(a){var b=a.ID;if(null!=this.bodyNodeLookup[b]){cr.arrayFindRemove(a.m_lists,this);for(a=0;a<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;a++)this.RemoveNode(b,
a);delete this.bodyNodeLookup[b];this.bodyCount--}};Box2D.Dynamics.b2BodyList.prototype.RemoveNode=function(a,b){var c=this.bodyNodeLookup[a];if(null!=c){var d=c[b];null!=d&&(c[b]=null,c=d.GetPreviousNode(),d=d.GetNextNode(),null==c?this.bodyFirstNodes[b]=d:c.SetNextNode(d),null==d?this.bodyLastNodes[b]=c:d.SetPreviousNode(c))}};Box2D.Dynamics.b2BodyList.prototype.CreateNode=function(a,b,c){var d=this.bodyNodeLookup[b];if(null==d){for(var d=[],e=0;e<=Box2D.Dynamics.b2BodyList.TYPES.allBodies;e++)d[e]=
null;this.bodyNodeLookup[b]=d}null==d[c]&&(d[c]=new Box2D.Dynamics.b2BodyListNode(a),a=this.bodyLastNodes[c],null!=a?a.SetNextNode(d[c]):this.bodyFirstNodes[c]=d[c],d[c].SetPreviousNode(a),this.bodyLastNodes[c]=d[c])};Box2D.Dynamics.b2BodyList.prototype.GetBodyCount=function(){return this.bodyCount};Box2D.Dynamics.b2BodyList.TYPES={dynamicBodies:0,nonStaticBodies:1,activeBodies:2,nonStaticActiveAwakeBodies:3,awakeBodies:4,allBodies:5};Box2D.Dynamics.b2BodyListNode=function(a){this.body=a;this.previous=
this.next=null};Box2D.Dynamics.b2BodyListNode.prototype.SetNextNode=function(a){this.next=a};Box2D.Dynamics.b2BodyListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.b2BodyListNode.prototype.GetBody=function(){return this.body};Box2D.Dynamics.b2BodyListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.b2BodyListNode.prototype.GetPreviousNode=function(){return this.previous};Box2D.Dynamics.b2ContactFilter=function(){};Box2D.Dynamics.b2ContactFilter.prototype.ShouldCollide=
function(a,b){var c=a.GetFilterData(),d=b.GetFilterData();return c.groupIndex==d.groupIndex&&0!=c.groupIndex?0<c.groupIndex:0!=(c.maskBits&d.categoryBits)&&0!=(c.categoryBits&d.maskBits)};Box2D.Dynamics.b2ContactFilter.b2_defaultFilter=new Box2D.Dynamics.b2ContactFilter;Box2D.Dynamics.b2ContactImpulse=function(){this.normalImpulses=[];this.tangentImpulses=[]};Box2D.Dynamics.b2ContactListener=function(){};Box2D.Dynamics.b2ContactListener.prototype.BeginContact=function(a){};Box2D.Dynamics.b2ContactListener.prototype.EndContact=
function(a){};Box2D.Dynamics.b2ContactListener.prototype.PreSolve=function(a,b){};Box2D.Dynamics.b2ContactListener.prototype.PostSolve=function(a,b){};Box2D.Dynamics.b2ContactManager=function(a){this.m_world=a;this.m_contactFilter=Box2D.Dynamics.b2ContactFilter.b2_defaultFilter;this.m_contactListener=Box2D.Dynamics.b2ContactListener.b2_defaultListener;this.m_contactFactory=new Box2D.Dynamics.Contacts.b2ContactFactory;this.m_broadPhase=new Box2D.Collision.b2DynamicTreeBroadPhase};Box2D.Dynamics.b2ContactManager.prototype.AddPair=
function(a,b){var c=a.GetBody(),d=b.GetBody();if(c!=d&&d.ShouldCollide(c)&&this.m_contactFilter.ShouldCollide(a,b)){for(c=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);c;c=c.GetNextNode())if(d=c.contact.m_fixtureA,d==a){if(d=c.contact.m_fixtureB,d==b)return}else if(d==b&&(d=c.contact.m_fixtureB,d==a))return;this.m_contactFactory.Create(a,b)}};Box2D.Dynamics.b2ContactManager.prototype.FindNewContacts=function(){var a=this;this.m_broadPhase.UpdatePairs(function(b,
c){a.AddPair(b,c)})};Box2D.Dynamics.b2ContactManager.prototype.Destroy=function(a){var b=a.m_fixtureB;a.m_fixtureA.GetBody();b.GetBody();a.touching&&this.m_contactListener.EndContact(a);0<a.m_manifold.m_pointCount&&(a.m_fixtureA.GetBody().SetAwake(!0),a.m_fixtureB.GetBody().SetAwake(!0));a.RemoveFromLists();this.m_contactFactory.Destroy(a)};Box2D.Dynamics.b2ContactManager.prototype.Collide=function(){for(var a=this.m_world.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=
a.GetNextNode()){var b=a.contact,c=b.m_fixtureA,d=b.m_fixtureB,e=c.GetBody(),h=d.GetBody();if(!1!=e.IsAwake()||!1!=h.IsAwake()){if(b.IsFiltering()){if(!1==h.ShouldCollide(e)){this.Destroy(b);continue}if(!1==this.m_contactFilter.ShouldCollide(c,d)){this.Destroy(b);continue}b.ClearFiltering()}!1==this.m_broadPhase.TestOverlap(c.m_proxy,d.m_proxy)?this.Destroy(b):b.Update(this.m_contactListener)}}};Box2D.Dynamics.b2DestructionListener=function(){};Box2D.Dynamics.b2DestructionListener.prototype.SayGoodbyeJoint=
function(a){};Box2D.Dynamics.b2DestructionListener.prototype.SayGoodbyeFixture=function(a){};Box2D.Dynamics.b2FilterData=function(){this.categoryBits=1;this.maskBits=65535;this.groupIndex=0};Box2D.Dynamics.b2FilterData.prototype.Copy=function(){var a=new Box2D.Dynamics.b2FilterData;a.categoryBits=this.categoryBits;a.maskBits=this.maskBits;a.groupIndex=this.groupIndex;return a};Box2D.Dynamics.b2Fixture=function(a,b,c){this.ID="Fixture"+Box2D.Dynamics.b2Fixture.NEXT_ID++;this.m_filter=c.filter.Copy();
this.m_aabb=Box2D.Collision.b2AABB.Get();this.m_body=a;this.m_shape=c.shape.Copy();this.m_density=c.density;this.m_friction=c.friction;this.m_restitution=c.restitution;this.m_isSensor=c.isSensor};Box2D.Dynamics.b2Fixture.prototype.GetShape=function(){return this.m_shape};Box2D.Dynamics.b2Fixture.prototype.SetSensor=function(a){if(this.m_isSensor!=a&&(this.m_isSensor=a,null!=this.m_body))for(a=this.m_body.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode()){var b=
a.contact.m_fixtureA,c=a.contact.m_fixtureB;b!=this&&c!=this||a.contact.SetSensor(b.sensor||c.sensor)}};Box2D.Dynamics.b2Fixture.prototype.IsSensor=function(){return this.m_isSensor};Box2D.Dynamics.b2Fixture.prototype.SetFilterData=function(a){this.m_filter=a.Copy();if(null!=this.m_body)for(a=this.m_body.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())a.contact.m_fixtureA!=this&&a.contact.m_fixtureB!=this||a.contact.FlagForFiltering()};Box2D.Dynamics.b2Fixture.prototype.GetFilterData=
function(){return this.m_filter.Copy()};Box2D.Dynamics.b2Fixture.prototype.GetBody=function(){return this.m_body};Box2D.Dynamics.b2Fixture.prototype.TestPoint=function(a){return this.m_shape.TestPoint(this.m_body.GetTransform(),a)};Box2D.Dynamics.b2Fixture.prototype.RayCast=function(a,b){return this.m_shape.RayCast(a,b,this.m_body.GetTransform())};Box2D.Dynamics.b2Fixture.prototype.GetMassData=function(a){a||(a=new Box2D.Collision.Shapes.b2MassData);this.m_shape.ComputeMass(a,this.m_density);return a};
Box2D.Dynamics.b2Fixture.prototype.SetDensity=function(a){this.m_density=a};Box2D.Dynamics.b2Fixture.prototype.GetDensity=function(){return this.m_density};Box2D.Dynamics.b2Fixture.prototype.GetFriction=function(){return this.m_friction};Box2D.Dynamics.b2Fixture.prototype.SetFriction=function(a){this.m_friction=a};Box2D.Dynamics.b2Fixture.prototype.GetRestitution=function(){return this.m_restitution};Box2D.Dynamics.b2Fixture.prototype.SetRestitution=function(a){this.m_restitution=a};Box2D.Dynamics.b2Fixture.prototype.GetAABB=
function(){return this.m_aabb};Box2D.Dynamics.b2Fixture.prototype.Destroy=function(){Box2D.Collision.b2AABB.Free(this.m_aabb)};Box2D.Dynamics.b2Fixture.prototype.CreateProxy=function(a,b){this.m_shape.ComputeAABB(this.m_aabb,b);this.m_proxy=a.CreateProxy(this.m_aabb,this)};Box2D.Dynamics.b2Fixture.prototype.DestroyProxy=function(a){null!=this.m_proxy&&(a.DestroyProxy(this.m_proxy),this.m_proxy=null)};Box2D.Dynamics.b2Fixture.prototype.Synchronize=function(a,b,c){if(this.m_proxy){var d=Box2D.Collision.b2AABB.Get(),
e=Box2D.Collision.b2AABB.Get();this.m_shape.ComputeAABB(d,b);this.m_shape.ComputeAABB(e,c);this.m_aabb.Combine(d,e);Box2D.Collision.b2AABB.Free(d);Box2D.Collision.b2AABB.Free(e);b=Box2D.Common.Math.b2Math.SubtractVV(c.position,b.position);a.MoveProxy(this.m_proxy,this.m_aabb,b);Box2D.Common.Math.b2Vec2.Free(b)}};Box2D.Dynamics.b2Fixture.NEXT_ID=0;Box2D.Dynamics.b2FixtureDef=function(){this.filter=new Box2D.Dynamics.b2FilterData;this.filter.categoryBits=1;this.filter.maskBits=65535;this.filter.groupIndex=
0;this.shape=null;this.friction=0.2;this.density=this.restitution=0;this.isSensor=!1};Box2D.Dynamics.b2FixtureList=function(){this.fixtureLastNode=this.fixtureFirstNode=null;this.fixtureNodeLookup={};this.fixtureCount=0};Box2D.Dynamics.b2FixtureList.prototype.GetFirstNode=function(){return this.fixtureFirstNode};Box2D.Dynamics.b2FixtureList.prototype.AddFixture=function(a){var b=a.ID;if(null==this.fixtureNodeLookup[b]){a=new Box2D.Dynamics.b2FixtureListNode(a);var c=this.fixtureLastNode;null!=c?c.SetNextNode(a):
this.fixtureFirstNode=a;a.SetPreviousNode(c);this.fixtureLastNode=a;this.fixtureNodeLookup[b]=a;this.fixtureCount++}};Box2D.Dynamics.b2FixtureList.prototype.RemoveFixture=function(a){a=a.ID;var b=this.fixtureNodeLookup[a];if(null!=b){var c=b.GetPreviousNode(),b=b.GetNextNode();null==c?this.fixtureFirstNode=b:c.SetNextNode(b);null==b?this.fixtureLastNode=c:b.SetPreviousNode(c);delete this.fixtureNodeLookup[a];this.fixtureCount--}};Box2D.Dynamics.b2FixtureList.prototype.GetFixtureCount=function(){return this.fixtureCount};
Box2D.Dynamics.b2FixtureListNode=function(a){this.fixture=a;this.previous=this.next=null};Box2D.Dynamics.b2FixtureListNode.prototype.SetNextNode=function(a){this.next=a};Box2D.Dynamics.b2FixtureListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.b2FixtureListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.b2FixtureListNode.prototype.GetPreviousNode=function(){return this.previous};Box2D.Dynamics.b2Island=function(a,b){this.m_listener=a;this.m_contactSolver=
b;this.m_bodies=[];this.m_dynamicBodies=[];this.m_nonStaticBodies=[];this.m_contacts=[];this.m_joints=[]};Box2D.Dynamics.b2Island.prototype.Clear=function(){this.m_bodies=[];this.m_dynamicBodies=[];this.m_nonStaticBodies=[];this.m_contacts=[];this.m_joints=[]};Box2D.Dynamics.b2Island.prototype.Solve=function(a,b,c){this._InitializeVelocities(a,b);this.m_contactSolver.Initialize(a,this.m_contacts,this.m_contacts.length);this._SolveVelocityConstraints(a);this._SolveBodies(a);this._SolvePositionConstraints(a);
this.Report(this.m_contactSolver.m_constraints);c&&this._SleepIfTired(a)};Box2D.Dynamics.b2Island.prototype._InitializeVelocities=function(a,b){for(var c=0;c<this.m_dynamicBodies.length;c++){var d=this.m_dynamicBodies[c];d.m_linearVelocity.x+=a.dt*(b.x+d.m_invMass*d.m_force.x);d.m_linearVelocity.y+=a.dt*(b.y+d.m_invMass*d.m_force.y);d.m_angularVelocity+=a.dt*d.m_invI*d.m_torque;d.m_linearVelocity.Multiply(Box2D.Common.Math.b2Math.Clamp(1-a.dt*d.m_linearDamping,0,1));d.m_angularVelocity*=Box2D.Common.Math.b2Math.Clamp(1-
a.dt*d.m_angularDamping,0,1)}};Box2D.Dynamics.b2Island.prototype._SolveVelocityConstraints=function(a){this.m_contactSolver.InitVelocityConstraints(a);for(var b=0;b<this.m_joints.length;b++)this.m_joints[b].InitVelocityConstraints(a);for(b=0;b<a.velocityIterations;b++){for(var c=0;c<this.m_joints.length;c++)this.m_joints[c].SolveVelocityConstraints(a);this.m_contactSolver.SolveVelocityConstraints()}for(a=0;a<this.m_joints.length;a++)this.m_joints[a].FinalizeVelocityConstraints();this.m_contactSolver.FinalizeVelocityConstraints()};
Box2D.Dynamics.b2Island.prototype._SolveBodies=function(a){for(var b=0;b<this.m_nonStaticBodies.length;++b){var c=this.m_nonStaticBodies[b],d=a.dt*c.m_linearVelocity.x,e=a.dt*c.m_linearVelocity.y;d*d+e*e>Box2D.Common.b2Settings.b2_maxTranslationSquared&&(c.m_linearVelocity.Normalize(),c.m_linearVelocity.x=c.m_linearVelocity.x*Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt,c.m_linearVelocity.y=c.m_linearVelocity.y*Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt);d=a.dt*c.m_angularVelocity;d*
d>Box2D.Common.b2Settings.b2_maxRotationSquared&&(c.m_angularVelocity=0>c.m_angularVelocity?-Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt:Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt);c.m_sweep.c0.SetV(c.m_sweep.c);c.m_sweep.a0=c.m_sweep.a;c.m_sweep.c.x+=a.dt*c.m_linearVelocity.x;c.m_sweep.c.y+=a.dt*c.m_linearVelocity.y;c.m_sweep.a+=a.dt*c.m_angularVelocity;c.SynchronizeTransform()}};Box2D.Dynamics.b2Island.prototype._SolvePositionConstraints=function(a){for(var b=0;b<a.positionIterations;b++){for(var c=
this.m_contactSolver.SolvePositionConstraints(Box2D.Common.b2Settings.b2_contactBaumgarte),d=!0,e=0;e<this.m_joints.length;e++)var h=this.m_joints[e].SolvePositionConstraints(Box2D.Common.b2Settings.b2_contactBaumgarte),d=d&&h;if(c&&d)break}};Box2D.Dynamics.b2Island.prototype._SleepIfTired=function(a){for(var b=Number.MAX_VALUE,c=0;c<this.m_nonStaticBodies.length;c++){var d=this.m_nonStaticBodies[c];!d.m_allowSleep||Math.abs(d.m_angularVelocity)>Box2D.Common.b2Settings.b2_angularSleepTolerance||Box2D.Common.Math.b2Math.Dot(d.m_linearVelocity,
d.m_linearVelocity)>Box2D.Common.b2Settings.b2_linearSleepToleranceSquared?b=d.m_sleepTime=0:(d.m_sleepTime+=a.dt,b=Math.min(b,d.m_sleepTime))}if(b>=Box2D.Common.b2Settings.b2_timeToSleep)for(a=0;a<this.m_bodies.length;a++)this.m_bodies[a].SetAwake(!1)};Box2D.Dynamics.b2Island.prototype.SolveTOI=function(a){var b=0,c=0;this.m_contactSolver.Initialize(a,this.m_contacts,this.m_contacts.length);for(var d=this.m_contactSolver,b=0;b<this.m_joints.length;++b)this.m_joints[b].InitVelocityConstraints(a);
for(b=0;b<a.velocityIterations;++b)for(d.SolveVelocityConstraints(),c=0;c<this.m_joints.length;++c)this.m_joints[c].SolveVelocityConstraints(a);for(b=0;b<this.m_nonStaticBodies.length;++b){var c=this.m_nonStaticBodies[b],e=a.dt*c.m_linearVelocity.x,h=a.dt*c.m_linearVelocity.y;e*e+h*h>Box2D.Common.b2Settings.b2_maxTranslationSquared&&(c.m_linearVelocity.Normalize(),c.m_linearVelocity.x=c.m_linearVelocity.x*Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt,c.m_linearVelocity.y=c.m_linearVelocity.y*
Box2D.Common.b2Settings.b2_maxTranslation*a.inv_dt);e=a.dt*c.m_angularVelocity;e*e>Box2D.Common.b2Settings.b2_maxRotationSquared&&(c.m_angularVelocity=0>c.m_angularVelocity?-Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt:Box2D.Common.b2Settings.b2_maxRotation*a.inv_dt);c.m_sweep.c0.SetV(c.m_sweep.c);c.m_sweep.a0=c.m_sweep.a;c.m_sweep.c.x+=a.dt*c.m_linearVelocity.x;c.m_sweep.c.y+=a.dt*c.m_linearVelocity.y;c.m_sweep.a+=a.dt*c.m_angularVelocity;c.SynchronizeTransform()}for(b=0;b<a.positionIterations;++b){e=
d.SolvePositionConstraints(0.75);h=!0;for(c=0;c<this.m_joints.length;++c)var f=this.m_joints[c].SolvePositionConstraints(Box2D.Common.b2Settings.b2_contactBaumgarte),h=h&&f;if(e&&h)break}this.Report(d.m_constraints)};Box2D.Dynamics.b2Island.prototype.Report=function(a){if(null!=this.m_listener)for(var b=0;b<this.m_contacts.length;++b){for(var c=this.m_contacts[b],d=a[b],e=new Box2D.Dynamics.b2ContactImpulse,h=0;h<d.pointCount;++h)e.normalImpulses[h]=d.points[h].normalImpulse,e.tangentImpulses[h]=
d.points[h].tangentImpulse;this.m_listener.PostSolve(c,e)}};Box2D.Dynamics.b2Island.prototype.AddBody=function(a){this.m_bodies.push(a);a.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(this.m_nonStaticBodies.push(a),a.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&this.m_dynamicBodies.push(a))};Box2D.Dynamics.b2Island.prototype.AddContact=function(a){this.m_contacts.push(a)};Box2D.Dynamics.b2Island.prototype.AddJoint=function(a){this.m_joints.push(a)};Box2D.Dynamics.b2TimeStep=function(a,
b,c,d,e){this.dt=a;var h=0;0<a&&(h=1/a);this.inv_dt=h;this.dtRatio=b;this.positionIterations=c;this.velocityIterations=d;this.warmStarting=e};Box2D.Dynamics.b2World=function(a,b){this.m_contactManager=new Box2D.Dynamics.b2ContactManager(this);this.m_contactSolver=new Box2D.Dynamics.Contacts.b2ContactSolver;this.m_newFixture=this.m_isLocked=!1;this.m_destructionListener=null;this.bodyList=new Box2D.Dynamics.b2BodyList;this.contactList=new Box2D.Dynamics.Contacts.b2ContactList;this.m_jointList=null;
this.controllerList=new Box2D.Dynamics.Controllers.b2ControllerList;this.m_jointCount=0;this.m_continuousPhysics=this.m_warmStarting=!0;this.m_allowSleep=b;this.m_gravity=a;this.m_inv_dt0=0;this.m_groundBody=this.CreateBody(new Box2D.Dynamics.b2BodyDef)};Box2D.Dynamics.b2World.MAX_TOI=1-100*Number.MIN_VALUE;Box2D.Dynamics.b2World.prototype.SetDestructionListener=function(a){this.m_destructionListener=a};Box2D.Dynamics.b2World.prototype.SetContactFilter=function(a){this.m_contactManager.m_contactFilter=
a};Box2D.Dynamics.b2World.prototype.SetContactListener=function(a){this.m_contactManager.m_contactListener=a};Box2D.Dynamics.b2World.prototype.SetBroadPhase=function(a){var b=this.m_contactManager.m_broadPhase;this.m_contactManager.m_broadPhase=a;for(var c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);c;c=c.GetNextNode())for(var d=c.body.GetFixtureList().GetFirstNode();d;d=d.GetNextNode()){var e=d.fixture;e.m_proxy=a.CreateProxy(b.GetFatAABB(e.m_proxy),e)}};Box2D.Dynamics.b2World.prototype.GetProxyCount=
function(){return this.m_contactManager.m_broadPhase.GetProxyCount()};Box2D.Dynamics.b2World.prototype.CreateBody=function(a){a=new Box2D.Dynamics.b2Body(a,this);this.bodyList.AddBody(a);return a};Box2D.Dynamics.b2World.prototype.DestroyBody=function(a){for(var b=a.m_jointList;b;){var c=b,b=b.next;this.m_destructionListener&&this.m_destructionListener.SayGoodbyeJoint(c.joint);this.DestroyJoint(c.joint)}for(b=a.GetControllerList().GetFirstNode();b;b=b.GetNextNode())b.controller.RemoveBody(a);for(b=
a.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);b;b=b.GetNextNode())this.m_contactManager.Destroy(b.contact);for(b=a.GetFixtureList().GetFirstNode();b;b=b.GetNextNode())this.m_destructionListener&&this.m_destructionListener.SayGoodbyeFixture(b.fixture),a.DestroyFixture(b.fixture);a.Destroy();this.bodyList.RemoveBody(a)};Box2D.Dynamics.b2World.prototype.CreateJoint=function(a){var b=Box2D.Dynamics.Joints.b2Joint.Create(a);b.m_prev=null;if(b.m_next=this.m_jointList)this.m_jointList.m_prev=
b;this.m_jointList=b;this.m_jointCount++;b.m_edgeA.joint=b;b.m_edgeA.other=b.m_bodyB;b.m_edgeA.prev=null;if(b.m_edgeA.next=b.m_bodyA.m_jointList)b.m_bodyA.m_jointList.prev=b.m_edgeA;b.m_bodyA.m_jointList=b.m_edgeA;b.m_edgeB.joint=b;b.m_edgeB.other=b.m_bodyA;b.m_edgeB.prev=null;if(b.m_edgeB.next=b.m_bodyB.m_jointList)b.m_bodyB.m_jointList.prev=b.m_edgeB;b.m_bodyB.m_jointList=b.m_edgeB;var c=a.bodyA,d=a.bodyB;if(!a.collideConnected)for(a=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=
a.GetNextNode())a.contact.GetOther(d)==c&&a.contact.FlagForFiltering();return b};Box2D.Dynamics.b2World.prototype.DestroyJoint=function(a){var b=a.m_collideConnected;a.m_prev&&(a.m_prev.m_next=a.m_next);a.m_next&&(a.m_next.m_prev=a.m_prev);a==this.m_jointList&&(this.m_jointList=a.m_next);var c=a.m_bodyA,d=a.m_bodyB;c.SetAwake(!0);d.SetAwake(!0);a.m_edgeA.prev&&(a.m_edgeA.prev.next=a.m_edgeA.next);a.m_edgeA.next&&(a.m_edgeA.next.prev=a.m_edgeA.prev);a.m_edgeA==c.m_jointList&&(c.m_jointList=a.m_edgeA.next);
a.m_edgeA.prev=null;a.m_edgeA.next=null;a.m_edgeB.prev&&(a.m_edgeB.prev.next=a.m_edgeB.next);a.m_edgeB.next&&(a.m_edgeB.next.prev=a.m_edgeB.prev);a.m_edgeB==d.m_jointList&&(d.m_jointList=a.m_edgeB.next);a.m_edgeB.prev=null;a.m_edgeB.next=null;this.m_jointCount--;if(!b)for(a=d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);a;a=a.GetNextNode())a.contact.GetOther(d)==c&&a.contact.FlagForFiltering()};Box2D.Dynamics.b2World.prototype.GetControllerList=function(){return this.controllerList};
Box2D.Dynamics.b2World.prototype.AddController=function(a){if(null!==a.m_world&&a.m_world!=this)throw Error("Controller can only be a member of one world");this.controllerList.AddController(a);a.m_world=this;return a};Box2D.Dynamics.b2World.prototype.RemoveController=function(a){this.controllerList.RemoveController(a);a.m_world=null;a.Clear()};Box2D.Dynamics.b2World.prototype.CreateController=function(a){return this.AddController(a)};Box2D.Dynamics.b2World.prototype.DestroyController=function(a){this.RemoveController(a)};
Box2D.Dynamics.b2World.prototype.SetWarmStarting=function(a){this.m_warmStarting=a};Box2D.Dynamics.b2World.prototype.SetContinuousPhysics=function(a){this.m_continuousPhysics=a};Box2D.Dynamics.b2World.prototype.GetBodyCount=function(){return this.bodyList.GetBodyCount()};Box2D.Dynamics.b2World.prototype.GetJointCount=function(){return this.m_jointCount};Box2D.Dynamics.b2World.prototype.GetContactCount=function(){return this.contactList.GetContactCount()};Box2D.Dynamics.b2World.prototype.SetGravity=
function(a){this.m_gravity=a};Box2D.Dynamics.b2World.prototype.GetGravity=function(){return this.m_gravity};Box2D.Dynamics.b2World.prototype.GetGroundBody=function(){return this.m_groundBody};Box2D.Dynamics.b2World.prototype.Step=function(a,b,c){this.m_newFixture&&(this.m_contactManager.FindNewContacts(),this.m_newFixture=!1);this.m_isLocked=!0;a=new Box2D.Dynamics.b2TimeStep(a,this.m_inv_dt0*a,b,c,this.m_warmStarting);this.m_contactManager.Collide();0<a.dt&&(this.Solve(a),this.m_continuousPhysics&&
this.SolveTOI(a),this.m_inv_dt0=a.inv_dt);this.m_isLocked=!1};Box2D.Dynamics.b2World.prototype.ClearForces=function(){for(var a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.dynamicBodies);a;a=a.GetNextNode())a.body.m_force.SetZero(),a.body.m_torque=0};Box2D.Dynamics.b2World.prototype.QueryAABB=function(a,b){this.m_contactManager.m_broadPhase.Query(a,b)};Box2D.Dynamics.b2World.prototype.QueryPoint=function(a,b){var c=Box2D.Collision.b2AABB.Get();c.lowerBound_.Set(b.x-Box2D.Common.b2Settings.b2_linearSlop,
b.y-Box2D.Common.b2Settings.b2_linearSlop);c.upperBound_.Set(b.x+Box2D.Common.b2Settings.b2_linearSlop,b.y+Box2D.Common.b2Settings.b2_linearSlop);this.m_contactManager.m_broadPhase.Query(function(c){return c.TestPoint(b)?a(c):!0},c);Box2D.Collision.b2AABB.Free(c)};Box2D.Dynamics.b2World.prototype.RayCast=function(a,b,c){var d=this.m_contactManager.m_broadPhase,e=new Box2D.Collision.b2RayCastOutput,h=new Box2D.Collision.b2RayCastInput(b,c,1);d.RayCast(function(d,h){if(h.RayCast(e,d)){var k=1-e.fraction,
k=Box2D.Common.Math.b2Vec2.Get(k*b.x+e.fraction*c.x,k*b.y+e.fraction*c.y),g=a(h,k,e.normal,e.fraction);Box2D.Common.Math.b2Vec2.Free(k);return g}return d.maxFraction},h)};Box2D.Dynamics.b2World.prototype.RayCastOne=function(a,b){var c=null;this.RayCast(function(a,b,h,f){c=a;return f},a,b);return c};Box2D.Dynamics.b2World.prototype.RayCastAll=function(a,b){var c=[];this.RayCast(function(a,b,h,f){c.push(a);return 1},a,b);return c};Box2D.Dynamics.b2World.prototype.GetBodyList=function(){return this.bodyList};
Box2D.Dynamics.b2World.prototype.GetJointList=function(){return this.m_jointList};Box2D.Dynamics.b2World.prototype.GetContactList=function(){return this.contactList};Box2D.Dynamics.b2World.prototype.IsLocked=function(){return this.m_isLocked};var b2solvearray=[];Box2D.Dynamics.b2World.prototype.Solve=function(a){for(var b=this.controllerList.GetFirstNode();b;b=b.GetNextNode())b.controller.Step(a);for(var b=new Box2D.Dynamics.b2Island(this.m_contactManager.m_contactListener,this.m_contactSolver),c=
this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);c;c=c.GetNextNode())c.body.m_islandFlag=!1;for(var d=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);d;d=d.GetNextNode())d.contact.m_islandFlag=!1;for(c=this.m_jointList;c;c=c.m_next)c.m_islandFlag=!1;for(c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies);c;c=c.GetNextNode())if(d=c.body,!d.m_islandFlag){b.Clear();b2solvearray.length=0;var e=b2solvearray;
e.push(d);for(d.m_islandFlag=!0;0<e.length;){var h=e.pop();b.AddBody(h);h.IsAwake()||h.SetAwake(!0);if(h.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody){for(d=h.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts);d;d=d.GetNextNode()){var f=d.contact;f.m_islandFlag||(b.AddContact(f),f.m_islandFlag=!0,f=f.GetOther(h),f.m_islandFlag||(e.push(f),f.m_islandFlag=!0))}for(d=h.m_jointList;d;d=d.next)!d.joint.m_islandFlag&&d.other.IsActive()&&(b.AddJoint(d.joint),
d.joint.m_islandFlag=!0,d.other.m_islandFlag||(e.push(d.other),d.other.m_islandFlag=!0))}}b.Solve(a,this.m_gravity,this.m_allowSleep)}for(c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.nonStaticActiveAwakeBodies);c;c=c.GetNextNode())c.body.SynchronizeFixtures();this.m_contactManager.FindNewContacts()};Box2D.Dynamics.b2World.prototype.SolveTOI=function(a){for(var b=new Box2D.Dynamics.b2Island(this.m_contactManager.m_contactListener,this.m_contactSolver),c=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);c;c=
c.GetNextNode()){var d=c.body;d.m_islandFlag=!1;d.m_sweep.t0=0}for(var e=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);e;e=e.GetNextNode())e.contact.m_islandFlag=!1,e.contact.m_toi=null;for(c=this.m_jointList;c;c=c.m_next)c.m_islandFlag=!1;for(;;){var c=this._SolveTOI2(a),h=c.minContact,c=c.minTOI;if(null===h||Box2D.Dynamics.b2World.MAX_TOI<c)break;e=h.m_fixtureA.GetBody();d=h.m_fixtureB.GetBody();Box2D.Dynamics.b2World.s_backupA.Set(e.m_sweep);Box2D.Dynamics.b2World.s_backupB.Set(d.m_sweep);
e.Advance(c);d.Advance(c);h.Update(this.m_contactManager.m_contactListener);h.m_toi=null;if(h.sensor||!h.enabled)e.m_sweep.Set(Box2D.Dynamics.b2World.s_backupA),d.m_sweep.Set(Box2D.Dynamics.b2World.s_backupB),e.SynchronizeTransform(),d.SynchronizeTransform();else if(h.touching){e.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&(e=d);b.Clear();b2solvearray.length=0;h=b2solvearray;h.push(e);for(e.m_islandFlag=!0;0<h.length;)if(d=h.pop(),b.AddBody(d),d.IsAwake()||d.SetAwake(!0),d.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody){for(e=
d.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts);e&&b.m_contactCount!=Box2D.Common.b2Settings.b2_maxTOIContactsPerIsland;e=e.GetNextNode()){var f=e.contact;f.m_islandFlag||(b.AddContact(f),f.m_islandFlag=!0,f=f.GetOther(d),f.m_islandFlag||(f.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(f.Advance(c),f.SetAwake(!0),h.push(f)),f.m_islandFlag=!0))}for(d=d.m_jointList;d;d=d.next)b.m_jointCount!=Box2D.Common.b2Settings.b2_maxTOIJointsPerIsland&&
!d.joint.m_islandFlag&&d.other.IsActive()&&(b.AddJoint(d.joint),d.joint.m_islandFlag=!0,d.other.m_islandFlag||(d.other.GetType()!=Box2D.Dynamics.b2BodyDef.b2_staticBody&&(d.other.Advance(c),d.other.SetAwake(!0),h.push(d.other)),d.other.m_islandFlag=!0))}b.SolveTOI(new Box2D.Dynamics.b2TimeStep((1-c)*a.dt,0,a.velocityIterations,a.positionIterations,!1));for(c=0;c<b.m_bodies.length;c++)if(b.m_bodies[c].m_islandFlag=!1,b.m_bodies[c].IsAwake()&&b.m_bodies[c].GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody)for(b.m_bodies[c].SynchronizeFixtures(),
e=b.m_bodies[c].contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);e;e=e.GetNextNode())e.contact.m_toi=null;for(c=0;c<b.m_contactCount;c++)b.m_contacts[c].m_islandFlag=!1,b.m_contacts[c].m_toi=null;for(c=0;c<b.m_jointCount;c++)b.m_joints[c].m_islandFlag=!1;this.m_contactManager.FindNewContacts()}}};Box2D.Dynamics.b2World.prototype._SolveTOI2=function(a){for(var b=null,c=1,d=this.contactList.GetFirstNode(Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledContinuousContacts);d;d=
d.GetNextNode()){var e=d.contact;if(!this._SolveTOI2SkipContact(a,e)){var h=1;if(null!=e.m_toi)h=e.m_toi;else{if(e.touching)h=1;else{var h=e.m_fixtureA.GetBody(),f=e.m_fixtureB.GetBody(),l=h.m_sweep.t0;h.m_sweep.t0<f.m_sweep.t0?(l=f.m_sweep.t0,h.m_sweep.Advance(l)):f.m_sweep.t0<h.m_sweep.t0&&(l=h.m_sweep.t0,f.m_sweep.Advance(l));h=e.ComputeTOI(h.m_sweep,f.m_sweep);0<h&&1>h&&(h=(1-h)*l+h)}e.m_toi=h}Number.MIN_VALUE<h&&h<c&&(b=e,c=h)}}return{minContact:b,minTOI:c}};Box2D.Dynamics.b2World.prototype._SolveTOI2SkipContact=
function(a,b){var c=b.m_fixtureA.GetBody(),d=b.m_fixtureB.GetBody();return c.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&c.IsAwake()||d.GetType()==Box2D.Dynamics.b2BodyDef.b2_dynamicBody&&d.IsAwake()?!1:!0};Box2D.Dynamics.Contacts.b2Contact=function(a,b){this.ID="Contact"+Box2D.Dynamics.Contacts.b2Contact.NEXT_ID++;this.m_manifold=new Box2D.Collision.b2Manifold;this.m_oldManifold=new Box2D.Collision.b2Manifold;this.touching=!1;var c=a.GetBody(),d=b.GetBody();this.continuous=c.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||
c.IsBullet()||d.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||d.IsBullet();this.sensor=a.IsSensor()||b.IsSensor();this.filtering=!1;this.m_fixtureA=a;this.m_fixtureB=b;this.enabled=!0;this.bodyAList=c.GetContactList();this.bodyBList=d.GetContactList();this.worldList=d.GetWorld().GetContactList();this.AddToLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.Reset=function(a,b){this.m_manifold.Reset();this.m_oldManifold.Reset();this.touching=!1;var c=a.GetBody(),d=b.GetBody();this.continuous=
c.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||c.IsBullet()||d.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||d.IsBullet();this.sensor=a.IsSensor()||b.IsSensor();this.filtering=!1;this.m_fixtureA=a;this.m_fixtureB=b;this.enabled=!0;this.bodyAList=c.GetContactList();this.bodyBList=d.GetContactList();this.worldList=d.GetWorld().GetContactList();this.AddToLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.AddToLists=function(){this.bodyAList.AddContact(this);this.bodyBList.AddContact(this);
this.worldList.AddContact(this);this.UpdateLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.UpdateLists=function(){var a=!1,b=!1;!this.IsSensor()&&this.IsEnabled()&&(this.IsTouching()&&(a=!0),this.IsContinuous()&&(b=!0));this.bodyAList.UpdateContact(this,a,b);this.bodyBList.UpdateContact(this,a,b);this.worldList.UpdateContact(this,a,b)};Box2D.Dynamics.Contacts.b2Contact.prototype.RemoveFromLists=function(){this.bodyAList.RemoveContact(this);this.bodyBList.RemoveContact(this);this.worldList.RemoveContact(this)};
Box2D.Dynamics.Contacts.b2Contact.prototype.GetManifold=function(){return this.m_manifold};Box2D.Dynamics.Contacts.b2Contact.prototype.GetWorldManifold=function(a){var b=this.m_fixtureA.GetBody(),c=this.m_fixtureB.GetBody(),d=this.m_fixtureA.GetShape(),e=this.m_fixtureB.GetShape();a.Initialize(this.m_manifold,b.GetTransform(),d.m_radius,c.GetTransform(),e.m_radius)};Box2D.Dynamics.Contacts.b2Contact.prototype.IsTouching=function(){return this.touching};Box2D.Dynamics.Contacts.b2Contact.prototype.IsContinuous=
function(){return this.continuous};Box2D.Dynamics.Contacts.b2Contact.prototype.SetSensor=function(a){this.sensor=a;this.UpdateLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.IsSensor=function(){return this.sensor};Box2D.Dynamics.Contacts.b2Contact.prototype.SetEnabled=function(a){this.enabled=a;this.UpdateLists()};Box2D.Dynamics.Contacts.b2Contact.prototype.IsEnabled=function(){return this.enabled};Box2D.Dynamics.Contacts.b2Contact.prototype.GetNext=function(){return this.m_next};Box2D.Dynamics.Contacts.b2Contact.prototype.GetFixtureA=
function(){return this.m_fixtureA};Box2D.Dynamics.Contacts.b2Contact.prototype.GetFixtureB=function(){return this.m_fixtureB};Box2D.Dynamics.Contacts.b2Contact.prototype.GetOther=function(a){var b=this.m_fixtureA.GetBody();return b!=a?b:this.m_fixtureB.GetBody()};Box2D.Dynamics.Contacts.b2Contact.prototype.FlagForFiltering=function(){this.filtering=!0};Box2D.Dynamics.Contacts.b2Contact.prototype.ClearFiltering=function(){this.filtering=!1};Box2D.Dynamics.Contacts.b2Contact.prototype.IsFiltering=function(){return this.filtering};
Box2D.Dynamics.Contacts.b2Contact.prototype.Update=function(a){var b=this.m_oldManifold;this.m_oldManifold=this.m_manifold;this.m_manifold=b;this.enabled=!0;var b=!1,c=this.IsTouching(),d=this.m_fixtureA.GetBody(),e=this.m_fixtureB.GetBody(),h=this.m_fixtureA.m_aabb.TestOverlap(this.m_fixtureB.m_aabb);if(this.sensor)h&&(b=Box2D.Collision.Shapes.b2Shape.TestOverlap(this.m_fixtureA.GetShape(),d.GetTransform(),this.m_fixtureB.GetShape(),e.GetTransform())),this.m_manifold.m_pointCount=0;else{d.GetType()!=
Box2D.Dynamics.b2BodyDef.b2_dynamicBody||d.IsBullet()||e.GetType()!=Box2D.Dynamics.b2BodyDef.b2_dynamicBody||e.IsBullet()?this.continuous=!0:this.continuous=!1;if(h)for(this.Evaluate(),b=0<this.m_manifold.m_pointCount,h=0;h<this.m_manifold.m_pointCount;h++){var f=this.m_manifold.m_points[h];f.m_normalImpulse=0;for(var l=f.m_tangentImpulse=0;l<this.m_oldManifold.m_pointCount;l++){var k=this.m_oldManifold.m_points[l];if(k.m_id.GetKey()==f.m_id.GetKey()){f.m_normalImpulse=k.m_normalImpulse;f.m_tangentImpulse=
k.m_tangentImpulse;break}}}else this.m_manifold.m_pointCount=0;b!=c&&(d.SetAwake(!0),e.SetAwake(!0))}this.touching=b;b!=c&&this.UpdateLists();!c&&b&&a.BeginContact(this);c&&!b&&a.EndContact(this);this.sensor||a.PreSolve(this,this.m_oldManifold)};Box2D.Dynamics.Contacts.b2Contact.prototype.Evaluate=function(){};Box2D.Dynamics.Contacts.b2Contact.prototype.ComputeTOI=function(a,b){Box2D.Dynamics.Contacts.b2Contact.s_input.proxyA.Set(this.m_fixtureA.GetShape());Box2D.Dynamics.Contacts.b2Contact.s_input.proxyB.Set(this.m_fixtureB.GetShape());
Box2D.Dynamics.Contacts.b2Contact.s_input.sweepA=a;Box2D.Dynamics.Contacts.b2Contact.s_input.sweepB=b;Box2D.Dynamics.Contacts.b2Contact.s_input.tolerance=Box2D.Common.b2Settings.b2_linearSlop;return Box2D.Collision.b2TimeOfImpact.TimeOfImpact(Box2D.Dynamics.Contacts.b2Contact.s_input)};Box2D.Dynamics.Contacts.b2Contact.s_input=new Box2D.Collision.b2TOIInput;Box2D.Dynamics.Contacts.b2Contact.NEXT_ID=0;Box2D.Dynamics.Contacts.b2CircleContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,
a,b)};c2inherit(Box2D.Dynamics.Contacts.b2CircleContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2CircleContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2CircleContact.prototype.Evaluate=function(){Box2D.Collision.b2Collision.CollideCircles(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2ContactConstraint=
function(){this.localPlaneNormal=Box2D.Common.Math.b2Vec2.Get(0,0);this.localPoint=Box2D.Common.Math.b2Vec2.Get(0,0);this.normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.normalMass=new Box2D.Common.Math.b2Mat22;this.K=new Box2D.Common.Math.b2Mat22;this.points=[];for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.points[a]=new Box2D.Dynamics.Contacts.b2ContactConstraintPoint};Box2D.Dynamics.Contacts.b2ContactConstraintPoint=function(){this.localPoint=Box2D.Common.Math.b2Vec2.Get(0,0);
this.rA=Box2D.Common.Math.b2Vec2.Get(0,0);this.rB=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Dynamics.Contacts.b2ContactConstraintPoint.prototype.Reset=function(){this.localPoint.Set(0,0);this.rA.Set(0,0);this.rB.Set(0,0)};Box2D.Dynamics.Contacts.b2ContactFactory=function(){this.m_registers={};this.m_freeContacts={};this.AddType(Box2D.Dynamics.Contacts.b2CircleContact,Box2D.Collision.Shapes.b2CircleShape.NAME,Box2D.Collision.Shapes.b2CircleShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2PolyAndCircleContact,
Box2D.Collision.Shapes.b2PolygonShape.NAME,Box2D.Collision.Shapes.b2CircleShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2PolygonContact,Box2D.Collision.Shapes.b2PolygonShape.NAME,Box2D.Collision.Shapes.b2PolygonShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2EdgeAndCircleContact,Box2D.Collision.Shapes.b2EdgeShape.NAME,Box2D.Collision.Shapes.b2CircleShape.NAME);this.AddType(Box2D.Dynamics.Contacts.b2PolyAndEdgeContact,Box2D.Collision.Shapes.b2PolygonShape.NAME,Box2D.Collision.Shapes.b2EdgeShape.NAME)};
Box2D.Dynamics.Contacts.b2ContactFactory.prototype.AddType=function(a,b,c){this.m_freeContacts[b]=this.m_freeContacts[b]||{};this.m_freeContacts[b][c]=this.m_freeContacts[b][c]||[];this.m_registers[b]=this.m_registers[b]||{};this.m_registers[b][c]=new Box2D.Dynamics.Contacts.b2ContactRegister;this.m_registers[b][c].ctor=a;this.m_registers[b][c].primary=!0;b!=c&&(this.m_registers[c]=this.m_registers[c]||{},this.m_registers[c][b]=new Box2D.Dynamics.Contacts.b2ContactRegister,this.m_registers[c][b].ctor=
a,this.m_registers[c][b].primary=!1)};Box2D.Dynamics.Contacts.b2ContactFactory.prototype.Create=function(a,b){var c=a.GetShape().GetTypeName(),d=b.GetShape().GetTypeName(),e=this.m_registers[c][d],h=e.ctor;return null!=h?e.primary?0<this.m_freeContacts[c][d].length?(c=this.m_freeContacts[c][d].pop(),c.Reset(a,b),c):new h(a,b):0<this.m_freeContacts[d][c].length?(c=this.m_freeContacts[d][c].pop(),c.Reset(b,a),c):new h(b,a):null};Box2D.Dynamics.Contacts.b2ContactFactory.prototype.Destroy=function(a){var b=
a.m_fixtureA.GetShape().GetTypeName(),c=a.m_fixtureB.GetShape().GetTypeName();this.m_freeContacts[b][c].push(a)};Box2D.Dynamics.Contacts.b2ContactList=function(){this.contactFirstNodes=[];for(var a=0;a<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;a++)this.contactFirstNodes[a]=null;this.contactLastNodes=[];for(a=0;a<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;a++)this.contactLastNodes[a]=null;this.contactNodeLookup={};this.contactCount=0};Box2D.Dynamics.Contacts.b2ContactList.prototype.GetFirstNode=
function(a){return this.contactFirstNodes[a]};Box2D.Dynamics.Contacts.b2ContactList.prototype.AddContact=function(a){var b=a.ID;if(null==this.contactNodeLookup[b]){this.contactNodeLookup[b]=[];for(var c=0;c<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;c++)this.contactNodeLookup[b][c]=null;this.CreateNode(a,b,Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts);this.contactCount++}};Box2D.Dynamics.Contacts.b2ContactList.prototype.UpdateContact=function(a,b,c){b?this.CreateNode(a,a.ID,
Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts):this.RemoveNode(a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledTouchingContacts);c?this.CreateNode(a,a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledContinuousContacts):this.RemoveNode(a.ID,Box2D.Dynamics.Contacts.b2ContactList.TYPES.nonSensorEnabledContinuousContacts)};Box2D.Dynamics.Contacts.b2ContactList.prototype.RemoveContact=function(a){a=a.ID;if(null!=this.contactNodeLookup[a]){for(var b=
0;b<=Box2D.Dynamics.Contacts.b2ContactList.TYPES.allContacts;b++)this.RemoveNode(a,b);delete this.contactNodeLookup[a];this.contactCount--}};Box2D.Dynamics.Contacts.b2ContactList.prototype.RemoveNode=function(a,b){var c=this.contactNodeLookup[a];if(null!=c){var d=c[b];if(null!=d){c[b]=null;var c=d.GetPreviousNode(),e=d.GetNextNode();null==c?this.contactFirstNodes[b]=e:c.SetNextNode(e);null==e?this.contactLastNodes[b]=c:e.SetPreviousNode(c);Box2D.Dynamics.Contacts.b2ContactListNode.FreeNode(d)}}};
Box2D.Dynamics.Contacts.b2ContactList.prototype.CreateNode=function(a,b,c){b=this.contactNodeLookup[b];null==b[c]&&(b[c]=Box2D.Dynamics.Contacts.b2ContactListNode.GetNode(a),a=this.contactLastNodes[c],null!=a?(a.SetNextNode(b[c]),b[c].SetPreviousNode(a)):this.contactFirstNodes[c]=b[c],this.contactLastNodes[c]=b[c])};Box2D.Dynamics.Contacts.b2ContactList.prototype.GetContactCount=function(){return this.contactCount};Box2D.Dynamics.Contacts.b2ContactList.TYPES={nonSensorEnabledTouchingContacts:0,nonSensorEnabledContinuousContacts:1,
allContacts:2};Box2D.Dynamics.Contacts.b2ContactListNode=function(a){this.contact=a;this.previous=this.next=null};Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes=[];Box2D.Dynamics.Contacts.b2ContactListNode.GetNode=function(a){if(0<Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes.length){var b=Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes.pop();b.next=null;b.previous=null;b.contact=a;return b}return new Box2D.Dynamics.Contacts.b2ContactListNode(a)};Box2D.Dynamics.Contacts.b2ContactListNode.FreeNode=
function(a){Box2D.Dynamics.Contacts.b2ContactListNode.freeNodes.push(a)};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.SetNextNode=function(a){this.next=a};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.GetContact=function(){return this.contact};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.Contacts.b2ContactListNode.prototype.GetPreviousNode=
function(){return this.previous};Box2D.Dynamics.Contacts.b2ContactRegister=function(){this.pool=null;this.poolCount=0};Box2D.Dynamics.Contacts.b2PositionSolverManifold=function(){this.m_normal=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_separations=[];this.m_points=[];for(var a=0;a<Box2D.Common.b2Settings.b2_maxManifoldPoints;a++)this.m_points[a]=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype.Initialize=function(a){switch(a.type){case Box2D.Collision.b2Manifold.e_circles:this._InitializeCircles(a);
break;case Box2D.Collision.b2Manifold.e_faceA:this._InitializeFaceA(a);break;case Box2D.Collision.b2Manifold.e_faceB:this._InitializeFaceB(a)}};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype._InitializeCircles=function(a){var b=a.bodyA.m_xf.R,c=a.localPoint,d=a.bodyA.m_xf.position.x+(b.col1.x*c.x+b.col2.x*c.y),e=a.bodyA.m_xf.position.y+(b.col1.y*c.x+b.col2.y*c.y),b=a.bodyB.m_xf.R,c=a.points[0].localPoint,h=a.bodyB.m_xf.position.x+(b.col1.x*c.x+b.col2.x*c.y),b=a.bodyB.m_xf.position.y+(b.col1.y*
c.x+b.col2.y*c.y),c=h-d,f=b-e,l=c*c+f*f;l>Box2D.Common.b2Settings.MIN_VALUE_SQUARED?(l=Math.sqrt(l),this.m_normal.x=c/l,this.m_normal.y=f/l):(this.m_normal.x=1,this.m_normal.y=0);this.m_points[0].x=0.5*(d+h);this.m_points[0].y=0.5*(e+b);this.m_separations[0]=c*this.m_normal.x+f*this.m_normal.y-a.radius};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype._InitializeFaceA=function(a){this.m_normal.x=a.bodyA.m_xf.R.col1.x*a.localPlaneNormal.x+a.bodyA.m_xf.R.col2.x*a.localPlaneNormal.y;this.m_normal.y=
a.bodyA.m_xf.R.col1.y*a.localPlaneNormal.x+a.bodyA.m_xf.R.col2.y*a.localPlaneNormal.y;for(var b=a.bodyA.m_xf.position.x+(a.bodyA.m_xf.R.col1.x*a.localPoint.x+a.bodyA.m_xf.R.col2.x*a.localPoint.y),c=a.bodyA.m_xf.position.y+(a.bodyA.m_xf.R.col1.y*a.localPoint.x+a.bodyA.m_xf.R.col2.y*a.localPoint.y),d=0;d<a.pointCount;d++){var e=a.bodyB.m_xf.position.x+(a.bodyB.m_xf.R.col1.x*a.points[d].localPoint.x+a.bodyB.m_xf.R.col2.x*a.points[d].localPoint.y),h=a.bodyB.m_xf.position.y+(a.bodyB.m_xf.R.col1.y*a.points[d].localPoint.x+
a.bodyB.m_xf.R.col2.y*a.points[d].localPoint.y);this.m_separations[d]=(e-b)*this.m_normal.x+(h-c)*this.m_normal.y-a.radius;this.m_points[d].x=e;this.m_points[d].y=h}};Box2D.Dynamics.Contacts.b2PositionSolverManifold.prototype._InitializeFaceB=function(a){this.m_normal.x=a.bodyB.m_xf.R.col1.x*a.localPlaneNormal.x+a.bodyB.m_xf.R.col2.x*a.localPlaneNormal.y;this.m_normal.y=a.bodyB.m_xf.R.col1.y*a.localPlaneNormal.x+a.bodyB.m_xf.R.col2.y*a.localPlaneNormal.y;for(var b=a.bodyB.m_xf.position.x+(a.bodyB.m_xf.R.col1.x*
a.localPoint.x+a.bodyB.m_xf.R.col2.x*a.localPoint.y),c=a.bodyB.m_xf.position.y+(a.bodyB.m_xf.R.col1.y*a.localPoint.x+a.bodyB.m_xf.R.col2.y*a.localPoint.y),d=0;d<a.pointCount;d++){var e=a.bodyA.m_xf.position.x+(a.bodyA.m_xf.R.col1.x*a.points[d].localPoint.x+a.bodyA.m_xf.R.col2.x*a.points[d].localPoint.y),h=a.bodyA.m_xf.position.y+(a.bodyA.m_xf.R.col1.y*a.points[d].localPoint.x+a.bodyA.m_xf.R.col2.y*a.points[d].localPoint.y);this.m_separations[d]=(e-b)*this.m_normal.x+(h-c)*this.m_normal.y-a.radius;
this.m_points[d].Set(e,h)}this.m_normal.x*=-1;this.m_normal.y*=-1};Box2D.Dynamics.Contacts.b2ContactSolver=function(){this.m_constraints=[]};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.Initialize=function(a,b,c){for(this.m_constraintCount=c;this.m_constraints.length<this.m_constraintCount;)this.m_constraints[this.m_constraints.length]=new Box2D.Dynamics.Contacts.b2ContactConstraint;for(a=0;a<c;a++){var d=b[a],e=d.m_fixtureA,h=d.m_fixtureB,f=e.m_shape.m_radius,l=h.m_shape.m_radius,k=e.GetBody(),
g=h.GetBody(),m=d.GetManifold(),n=Box2D.Common.b2Settings.b2MixFriction(e.GetFriction(),h.GetFriction()),p=Box2D.Common.b2Settings.b2MixRestitution(e.GetRestitution(),h.GetRestitution()),r=k.m_linearVelocity.x,s=k.m_linearVelocity.y,q=g.m_linearVelocity.x,t=g.m_linearVelocity.y,u=k.m_angularVelocity,C=g.m_angularVelocity;Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.Initialize(m,k.m_xf,f,g.m_xf,l);h=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_normal.x;d=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_normal.y;
e=this.m_constraints[a];e.bodyA=k;e.bodyB=g;e.manifold=m;e.normal.x=h;e.normal.y=d;e.pointCount=m.m_pointCount;e.friction=n;e.restitution=p;e.localPlaneNormal.x=m.m_localPlaneNormal.x;e.localPlaneNormal.y=m.m_localPlaneNormal.y;e.localPoint.x=m.m_localPoint.x;e.localPoint.y=m.m_localPoint.y;e.radius=f+l;e.type=m.m_type;for(f=0;f<e.pointCount;++f){n=m.m_points[f];l=e.points[f];l.normalImpulse=n.m_normalImpulse;l.tangentImpulse=n.m_tangentImpulse;l.localPoint.SetV(n.m_localPoint);var n=l.rA.x=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[f].x-
k.m_sweep.c.x,p=l.rA.y=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[f].y-k.m_sweep.c.y,J=l.rB.x=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[f].x-g.m_sweep.c.x,G=l.rB.y=Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold.m_points[f].y-g.m_sweep.c.y,A=n*d-p*h,v=J*d-G*h,A=A*A,v=v*v;l.normalMass=1/(k.m_invMass+g.m_invMass+k.m_invI*A+g.m_invI*v);var w=k.m_mass*k.m_invMass+g.m_mass*g.m_invMass,w=w+(k.m_mass*k.m_invI*A+g.m_mass*g.m_invI*v);l.equalizedMass=1/w;
v=d;w=-h;A=n*w-p*v;v=J*w-G*v;A*=A;v*=v;l.tangentMass=1/(k.m_invMass+g.m_invMass+k.m_invI*A+g.m_invI*v);l.velocityBias=0;n=e.normal.x*(q+-C*G-r- -u*p)+e.normal.y*(t+C*J-s-u*n);n<-Box2D.Common.b2Settings.b2_velocityThreshold&&(l.velocityBias+=-e.restitution*n)}2==e.pointCount&&(t=e.points[0],q=e.points[1],m=k.m_invMass,k=k.m_invI,r=g.m_invMass,g=g.m_invI,s=t.rA.x*d-t.rA.y*h,t=t.rB.x*d-t.rB.y*h,u=q.rA.x*d-q.rA.y*h,q=q.rB.x*d-q.rB.y*h,h=m+r+k*s*s+g*t*t,d=m+r+k*u*u+g*q*q,g=m+r+k*s*u+g*t*q,h*h<100*(h*d-
g*g)?(e.K.col1.Set(h,g),e.K.col2.Set(g,d),e.K.GetInverse(e.normalMass)):e.pointCount=1)}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.InitVelocityConstraints=function(a){for(var b=0;b<this.m_constraintCount;++b){var c=this.m_constraints[b],d=c.bodyA,e=c.bodyB,h=d.m_invMass,f=d.m_invI,l=e.m_invMass,k=e.m_invI,g=c.normal.x,m=c.normal.y,n=m,p=-g,r=0,s=0;if(a.warmStarting)for(s=c.pointCount,r=0;r<s;++r){var q=c.points[r];q.normalImpulse*=a.dtRatio;q.tangentImpulse*=a.dtRatio;var t=q.normalImpulse*
g+q.tangentImpulse*n,u=q.normalImpulse*m+q.tangentImpulse*p;d.m_angularVelocity-=f*(q.rA.x*u-q.rA.y*t);d.m_linearVelocity.x-=h*t;d.m_linearVelocity.y-=h*u;e.m_angularVelocity+=k*(q.rB.x*u-q.rB.y*t);e.m_linearVelocity.x+=l*t;e.m_linearVelocity.y+=l*u}else for(s=c.pointCount,r=0;r<s;++r)d=c.points[r],d.normalImpulse=0,d.tangentImpulse=0}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints=function(){for(var a=0;a<this.m_constraintCount;a++)this.SolveVelocityConstraints_Constraint(this.m_constraints[a])};
Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_Constraint=function(a){for(var b=a.normal.x,c=a.normal.y,d=0;d<a.pointCount;d++)Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_ConstraintPoint(a,a.points[d]);if(1==a.pointCount){var d=a.points[0],e=d.normalImpulse-d.normalMass*((a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*d.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*d.rA.y)*b+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*
d.rB.x-a.bodyA.m_linearVelocity.y-a.bodyA.m_angularVelocity*d.rA.x)*c-d.velocityBias),e=0<e?e:0,h=e-d.normalImpulse,f=h*b,c=h*c;a.bodyA.m_linearVelocity.x-=a.bodyA.m_invMass*f;a.bodyA.m_linearVelocity.y-=a.bodyA.m_invMass*c;a.bodyA.m_angularVelocity-=a.bodyA.m_invI*(d.rA.x*c-d.rA.y*f);a.bodyB.m_linearVelocity.x+=a.bodyB.m_invMass*f;a.bodyB.m_linearVelocity.y+=a.bodyB.m_invMass*c;a.bodyB.m_angularVelocity+=a.bodyB.m_invI*(d.rB.x*c-d.rB.y*f);d.normalImpulse=e}else for(var d=a.points[0],e=a.points[1],
h=d.normalImpulse,f=e.normalImpulse,l=(a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*d.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*d.rA.y)*b+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*d.rB.x-a.bodyA.m_linearVelocity.y-a.bodyA.m_angularVelocity*d.rA.x)*c-d.velocityBias,c=(a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*e.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*e.rA.y)*b+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*e.rB.x-a.bodyA.m_linearVelocity.y-
a.bodyA.m_angularVelocity*e.rA.x)*c-e.velocityBias,l=l-(a.K.col1.x*h+a.K.col2.x*f),c=c-(a.K.col1.y*h+a.K.col2.y*f);;){b=-(a.normalMass.col1.x*l+a.normalMass.col2.x*c);if(0<=b){var k=-(a.normalMass.col1.y*l+a.normalMass.col2.y*c);if(0<=k){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,b-h,k-f);d.normalImpulse=b;e.normalImpulse=k;break}}b=-d.normalMass*l;if(0<=b&&0<=a.K.col1.y*b+c){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,b-h,-f);d.normalImpulse=b;e.normalImpulse=0;break}b=
-e.normalMass*c;if(0<=b&&0<=a.K.col2.x*b+l){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,-h,b-f);d.normalImpulse=0;e.normalImpulse=b;break}if(0<=l&&0<=c){this.SolveVelocityConstraints_ConstraintPointUpdate(a,d,e,-h,-f);d.normalImpulse=0;e.normalImpulse=0;break}break}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_ConstraintPoint=function(a,b){var c=a.normal.y,d=-a.normal.x,e=a.friction*b.normalImpulse,e=Box2D.Common.Math.b2Math.Clamp(b.tangentImpulse-b.tangentMass*
((a.bodyB.m_linearVelocity.x-a.bodyB.m_angularVelocity*b.rB.y-a.bodyA.m_linearVelocity.x+a.bodyA.m_angularVelocity*b.rA.y)*c+(a.bodyB.m_linearVelocity.y+a.bodyB.m_angularVelocity*b.rB.x-a.bodyA.m_linearVelocity.y-a.bodyA.m_angularVelocity*b.rA.x)*d),-e,e),h=e-b.tangentImpulse,c=h*c,d=h*d;a.bodyA.m_linearVelocity.x-=a.bodyA.m_invMass*c;a.bodyA.m_linearVelocity.y-=a.bodyA.m_invMass*d;a.bodyA.m_angularVelocity-=a.bodyA.m_invI*(b.rA.x*d-b.rA.y*c);a.bodyB.m_linearVelocity.x+=a.bodyB.m_invMass*c;a.bodyB.m_linearVelocity.y+=
a.bodyB.m_invMass*d;a.bodyB.m_angularVelocity+=a.bodyB.m_invI*(b.rB.x*d-b.rB.y*c);b.tangentImpulse=e};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolveVelocityConstraints_ConstraintPointUpdate=function(a,b,c,d,e){var h=d*a.normal.x;d*=a.normal.y;var f=e*a.normal.x;e*=a.normal.y;a.bodyA.m_linearVelocity.x-=a.bodyA.m_invMass*(h+f);a.bodyA.m_linearVelocity.y-=a.bodyA.m_invMass*(d+e);a.bodyA.m_angularVelocity-=a.bodyA.m_invI*(b.rA.x*d-b.rA.y*h+c.rA.x*e-c.rA.y*f);a.bodyB.m_linearVelocity.x+=a.bodyB.m_invMass*
(h+f);a.bodyB.m_linearVelocity.y+=a.bodyB.m_invMass*(d+e);a.bodyB.m_angularVelocity+=a.bodyB.m_invI*(b.rB.x*d-b.rB.y*h+c.rB.x*e-c.rB.y*f);b.normalImpulse=0;c.normalImpulse=0};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.FinalizeVelocityConstraints=function(){for(var a=0;a<this.m_constraintCount;++a)for(var b=this.m_constraints[a],c=b.manifold,d=0;d<b.pointCount;++d){var e=c.m_points[d],h=b.points[d];e.m_normalImpulse=h.normalImpulse;e.m_tangentImpulse=h.tangentImpulse}};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolvePositionConstraints=
function(a){void 0===a&&(a=0);for(var b=0,c=0;c<this.m_constraintCount;c++){var d=this.m_constraints[c],e=d.bodyA,h=d.bodyB,f=e.m_mass*e.m_invMass,l=e.m_mass*e.m_invI,k=h.m_mass*h.m_invMass,g=h.m_mass*h.m_invI;Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.Initialize(d);for(var m=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_normal,n=0;n<d.pointCount;n++){var p=d.points[n],r=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_points[n],s=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_separations[n],
q=r.x-e.m_sweep.c.x,t=r.y-e.m_sweep.c.y,u=r.x-h.m_sweep.c.x,r=r.y-h.m_sweep.c.y,b=b<s?b:s,s=Box2D.Common.Math.b2Math.Clamp(a*(s+Box2D.Common.b2Settings.b2_linearSlop),-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),s=-p.equalizedMass*s,p=s*m.x,s=s*m.y;e.m_sweep.c.x-=f*p;e.m_sweep.c.y-=f*s;e.m_sweep.a-=l*(q*s-t*p);e.SynchronizeTransform();h.m_sweep.c.x+=k*p;h.m_sweep.c.y+=k*s;h.m_sweep.a+=g*(u*s-r*p);h.SynchronizeTransform()}}return b>-1.5*Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Contacts.b2ContactSolver.prototype.SolvePositionConstraints_NEW=
function(a){void 0===a&&(a=0);for(var b=0,c=0;c<this.m_constraintCount;c++){var d=this.m_constraints[c],e=d.bodyA,h=d.bodyB,f=e.m_mass*e.m_invMass,l=e.m_mass*e.m_invI,k=h.m_mass*h.m_invMass,g=h.m_mass*h.m_invI;Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.Initialize(d);for(var m=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_normal,n=0;n<d.pointCount;n++){var p=d.points[n],r=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_points[n],s=Box2D.Dynamics.Contacts.b2ContactSolver.s_psm.m_separations[n],
q=r.x-e.m_sweep.c.x,t=r.y-e.m_sweep.c.y,u=r.x-h.m_sweep.c.x,r=r.y-h.m_sweep.c.y;s<b&&(b=s);0!=a&&Box2D.Common.Math.b2Math.Clamp(a*(s+Box2D.Common.b2Settings.b2_linearSlop),-Box2D.Common.b2Settings.b2_maxLinearCorrection,0);s=0*-p.equalizedMass;p=s*m.x;s*=m.y;e.m_sweep.c.x-=f*p;e.m_sweep.c.y-=f*s;e.m_sweep.a-=l*(q*s-t*p);e.SynchronizeTransform();h.m_sweep.c.x+=k*p;h.m_sweep.c.y+=k*s;h.m_sweep.a+=g*(u*s-r*p);h.SynchronizeTransform()}}return b>-1.5*Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Contacts.b2EdgeAndCircleContact=
function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2EdgeAndCircleContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2EdgeAndCircleContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2EdgeAndCircleContact.prototype.Evaluate=function(){this.m_fixtureA.GetBody();this.m_fixtureB.GetBody();this.b2CollideEdgeAndCircle(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,
this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2EdgeAndCircleContact.prototype.b2CollideEdgeAndCircle=function(a,b,c,d,e){};Box2D.Dynamics.Contacts.b2PolyAndCircleContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2PolyAndCircleContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2PolyAndCircleContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,
a,b)};Box2D.Dynamics.Contacts.b2PolyAndCircleContact.prototype.Evaluate=function(){Box2D.Collision.b2Collision.CollidePolygonAndCircle(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2PolyAndEdgeContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,a,b)};c2inherit(Box2D.Dynamics.Contacts.b2PolyAndEdgeContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2PolyAndEdgeContact.prototype.Reset=
function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2PolyAndEdgeContact.prototype.Evaluate=function(){this.b2CollidePolyAndEdge(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Contacts.b2PolyAndEdgeContact.prototype.b2CollidePolyAndEdge=function(a,b,c,d,e){};Box2D.Dynamics.Contacts.b2PolygonContact=function(a,b){Box2D.Dynamics.Contacts.b2Contact.call(this,
a,b)};c2inherit(Box2D.Dynamics.Contacts.b2PolygonContact,Box2D.Dynamics.Contacts.b2Contact);Box2D.Dynamics.Contacts.b2PolygonContact.prototype.Reset=function(a,b){Box2D.Dynamics.Contacts.b2Contact.prototype.Reset.call(this,a,b)};Box2D.Dynamics.Contacts.b2PolygonContact.prototype.Evaluate=function(){Box2D.Collision.b2Collision.CollidePolygons(this.m_manifold,this.m_fixtureA.GetShape(),this.m_fixtureA.GetBody().m_xf,this.m_fixtureB.GetShape(),this.m_fixtureB.GetBody().m_xf)};Box2D.Dynamics.Controllers.b2Controller=
function(){this.ID="Controller"+Box2D.Dynamics.Controllers.b2Controller.NEXT_ID++;this.m_world=null;this.bodyList=new Box2D.Dynamics.b2BodyList};Box2D.Dynamics.Controllers.b2Controller.prototype.Step=function(a){};Box2D.Dynamics.Controllers.b2Controller.prototype.AddBody=function(a){this.bodyList.AddBody(a);a.AddController(this)};Box2D.Dynamics.Controllers.b2Controller.prototype.RemoveBody=function(a){this.bodyList.RemoveBody(a);a.RemoveController(this)};Box2D.Dynamics.Controllers.b2Controller.prototype.Clear=
function(){for(var a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);a;a=a.GetNextNode())this.RemoveBody(a.body)};Box2D.Dynamics.Controllers.b2Controller.prototype.GetBodyList=function(){return this.bodyList};Box2D.Dynamics.Controllers.b2Controller.NEXT_ID=0;Box2D.Dynamics.Controllers.b2BuoyancyController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.normal=Box2D.Common.Math.b2Vec2.Get(0,-1);this.density=this.offset=0;this.velocity=Box2D.Common.Math.b2Vec2.Get(0,
0);this.linearDrag=2;this.angularDrag=1;this.useDensity=!1;this.useWorldGravity=!0;this.gravity=null};c2inherit(Box2D.Dynamics.Controllers.b2BuoyancyController,Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2BuoyancyController.prototype.Step=function(a){this.useWorldGravity&&(this.gravity=this.m_world.GetGravity().Copy());for(a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);a;a=a.GetNextNode()){for(var b=a.body,c=Box2D.Common.Math.b2Vec2.Get(0,0),d=Box2D.Common.Math.b2Vec2.Get(0,
0),e=0,h=0,f=b.GetFixtureList().GetFirstNode();f;f=f.GetNextNode()){var l=Box2D.Common.Math.b2Vec2.Get(0,0),k=f.fixture.GetShape().ComputeSubmergedArea(this.normal,this.offset,b.GetTransform(),l),e=e+k;c.x+=k*l.x;c.y+=k*l.y;var g=0,g=1,h=h+k*g;d.x+=k*l.x*g;d.y+=k*l.y*g}e<Number.MIN_VALUE||(c.x/=e,c.y/=e,d.x/=h,d.y/=h,h=this.gravity.GetNegative(),h.Multiply(this.density*e),b.ApplyForce(h,d),h=b.GetLinearVelocityFromWorldPoint(c),h.Subtract(this.velocity),h.Multiply(-this.linearDrag*e),b.ApplyForce(h,
c),b.ApplyTorque(-b.GetInertia()/b.GetMass()*e*b.GetAngularVelocity()*this.angularDrag),Box2D.Common.Math.b2Vec2.Free(c),Box2D.Common.Math.b2Vec2.Free(d))}};Box2D.Dynamics.Controllers.b2ConstantAccelController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.A=Box2D.Common.Math.b2Vec2.Get(0,0)};c2inherit(Box2D.Dynamics.Controllers.b2ConstantAccelController,Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2ConstantAccelController.prototype.Step=function(a){a=Box2D.Common.Math.b2Vec2.Get(this.A.x*
a.dt,this.A.y*a.dt);for(var b=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);b;b=b.GetNextNode()){var c=b.body,d=c.GetLinearVelocity();c.SetLinearVelocity(Box2D.Common.Math.b2Vec2.Get(d.x+a.x,d.y+a.y))}Box2D.Common.Math.b2Vec2.Free(a)};Box2D.Dynamics.Controllers.b2ConstantForceController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.F=Box2D.Common.Math.b2Vec2.Get(0,0)};c2inherit(Box2D.Dynamics.Controllers.b2ConstantForceController,Box2D.Dynamics.Controllers.b2Controller);
Box2D.Dynamics.Controllers.b2ConstantForceController.prototype.Step=function(a){for(a=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);a;a=a.GetNextNode()){var b=a.body;b.ApplyForce(this.F,b.GetWorldCenter())}};Box2D.Dynamics.Controllers.b2ControllerList=function(){this.controllerLastNode=this.controllerFirstNode=null;this.controllerNodeLookup={};this.controllerCount=0};Box2D.Dynamics.Controllers.b2ControllerList.prototype.GetFirstNode=function(){return this.controllerFirstNode};
Box2D.Dynamics.Controllers.b2ControllerList.prototype.AddController=function(a){var b=a.ID;if(null==this.controllerNodeLookup[b]){a=new Box2D.Dynamics.Controllers.b2ControllerListNode(a);var c=this.controllerLastNode;null!=c?c.SetNextNode(a):this.controllerFirstNode=a;a.SetPreviousNode(c);this.controllerLastNode=a;this.controllerNodeLookup[b]=a;this.controllerCount++}};Box2D.Dynamics.Controllers.b2ControllerList.prototype.RemoveController=function(a){a=a.ID;var b=this.controllerNodeLookup[a];if(null!=
b){var c=b.GetPreviousNode(),b=b.GetNextNode();null==c?this.controllerFirstNode=b:c.SetNextNode(b);null==b?this.controllerLastNode=c:b.SetPreviousNode(c);delete this.controllerNodeLookup[a];this.controllerCount--}};Box2D.Dynamics.Controllers.b2ControllerList.prototype.GetControllerCount=function(){return this.controllerCount};Box2D.Dynamics.Controllers.b2ControllerListNode=function(a){this.controller=a;this.previous=this.next=null};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.SetNextNode=
function(a){this.next=a};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.SetPreviousNode=function(a){this.previous=a};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.GetNextNode=function(){return this.next};Box2D.Dynamics.Controllers.b2ControllerListNode.prototype.GetPreviousNode=function(){return this.previous};Box2D.Dynamics.Controllers.b2GravityController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.G=1;this.invSqr=!0};c2inherit(Box2D.Dynamics.Controllers.b2GravityController,
Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2GravityController.prototype.Step=function(a){var b=a=null,c=0,d=null,e=null,h=0,f=0,l=0,h=null;if(this.invSqr)for(var k=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);k;k=k.GetNextNode()){a=k.body;for(var b=a.GetWorldCenter(),c=a.GetMass(),g=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);g;g=g.GetNextNode())if(d=g.body,a.IsAwake()||d.IsAwake())e=d.GetWorldCenter(),h=e.x-b.x,f=e.y-b.y,
l=h*h+f*f,l<Number.MIN_VALUE||(h=Box2D.Common.Math.b2Vec2.Get(h,f),h.Multiply(this.G/l/Math.sqrt(l)*c*d.GetMass()),a.IsAwake()&&a.ApplyForce(h,b),h.Multiply(-1),d.IsAwake()&&d.ApplyForce(h,e),Box2D.Common.Math.b2Vec2.Free(h))}else for(k=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);k;k=k.GetNextNode())for(a=bodyNode.body,b=a.GetWorldCenter(),c=a.GetMass(),g=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.allBodies);g;g=g.GetNextNode())if(d=bodyNode.body,a.IsAwake()||
d.IsAwake())e=d.GetWorldCenter(),h=e.x-b.x,f=e.y-b.y,l=h*h+f*f,l<Number.MIN_VALUE||(h=Box2D.Common.Math.b2Vec2.Get(h,f),h.Multiply(this.G/l*c*d.GetMass()),a.IsAwake()&&a.ApplyForce(h,b),h.Multiply(-1),d.IsAwake()&&d.ApplyForce(h,e),Box2D.Common.Math.b2Vec2.Free(h))};Box2D.Dynamics.Controllers.b2TensorDampingController=function(){Box2D.Dynamics.Controllers.b2Controller.call(this);this.T=new Box2D.Common.Math.b2Mat22;this.maxTimestep=0};c2inherit(Box2D.Dynamics.Controllers.b2TensorDampingController,
Box2D.Dynamics.Controllers.b2Controller);Box2D.Dynamics.Controllers.b2TensorDampingController.prototype.SetAxisAligned=function(a,b){this.T.col1.x=-a;this.T.col1.y=0;this.T.col2.x=0;this.T.col2.y=-b;this.maxTimestep=0<a||0<b?1/Math.max(a,b):0};Box2D.Dynamics.Controllers.b2TensorDampingController.prototype.Step=function(a){a=a.dt;if(!(a<=Number.MIN_VALUE)){a>this.maxTimestep&&0<this.maxTimestep&&(a=this.maxTimestep);for(var b=this.bodyList.GetFirstNode(Box2D.Dynamics.b2BodyList.TYPES.awakeBodies);b;b=
b.GetNextNode()){var c=b.body,d=c.GetWorldVector(Box2D.Common.Math.b2Math.MulMV(this.T,c.GetLocalVector(c.GetLinearVelocity())));c.SetLinearVelocity(Box2D.Common.Math.b2Vec2.Get(c.GetLinearVelocity().x+d.x*a,c.GetLinearVelocity().y+d.y*a))}}};Box2D.Dynamics.Joints.b2Joint=function(a){this.m_edgeA=new Box2D.Dynamics.Joints.b2JointEdge;this.m_edgeB=new Box2D.Dynamics.Joints.b2JointEdge;this.m_localCenterA=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localCenterB=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_type=
a.type;this.m_next=this.m_prev=null;this.m_bodyA=a.bodyA;this.m_bodyB=a.bodyB;this.m_collideConnected=a.collideConnected};Box2D.Dynamics.Joints.b2Joint.prototype.GetType=function(){return this.m_type};Box2D.Dynamics.Joints.b2Joint.prototype.GetAnchorA=function(){return null};Box2D.Dynamics.Joints.b2Joint.prototype.GetAnchorB=function(){return null};Box2D.Dynamics.Joints.b2Joint.prototype.GetReactionForce=function(a){return null};Box2D.Dynamics.Joints.b2Joint.prototype.GetReactionTorque=function(a){return 0};
Box2D.Dynamics.Joints.b2Joint.prototype.GetBodyA=function(){return this.m_bodyA};Box2D.Dynamics.Joints.b2Joint.prototype.GetBodyB=function(){return this.m_bodyB};Box2D.Dynamics.Joints.b2Joint.prototype.GetNext=function(){return this.m_next};Box2D.Dynamics.Joints.b2Joint.prototype.IsActive=function(){return this.m_bodyA.IsActive()&&this.m_bodyB.IsActive()};Box2D.Dynamics.Joints.b2Joint.Create=function(a){return a.Create()};Box2D.Dynamics.Joints.b2Joint.prototype.InitVelocityConstraints=function(a){};
Box2D.Dynamics.Joints.b2Joint.prototype.SolveVelocityConstraints=function(a){};Box2D.Dynamics.Joints.b2Joint.prototype.FinalizeVelocityConstraints=function(){};Box2D.Dynamics.Joints.b2Joint.prototype.SolvePositionConstraints=function(a){return!1};Box2D.Dynamics.Joints.b2Joint.e_unknownJoint=0;Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint=1;Box2D.Dynamics.Joints.b2Joint.e_prismaticJoint=2;Box2D.Dynamics.Joints.b2Joint.e_distanceJoint=3;Box2D.Dynamics.Joints.b2Joint.e_pulleyJoint=4;Box2D.Dynamics.Joints.b2Joint.e_mouseJoint=
5;Box2D.Dynamics.Joints.b2Joint.e_gearJoint=6;Box2D.Dynamics.Joints.b2Joint.e_lineJoint=7;Box2D.Dynamics.Joints.b2Joint.e_weldJoint=8;Box2D.Dynamics.Joints.b2Joint.e_frictionJoint=9;Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit=0;Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit=1;Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit=2;Box2D.Dynamics.Joints.b2Joint.e_equalLimits=3;Box2D.Dynamics.Joints.b2JointDef=function(){this.type=Box2D.Dynamics.Joints.b2Joint.e_unknownJoint;this.bodyB=this.bodyA=null;this.collideConnected=
!1};Box2D.Dynamics.Joints.b2JointEdge=function(){};Box2D.Dynamics.Joints.b2DistanceJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_u=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);this.m_length=a.length;this.m_frequencyHz=a.frequencyHz;this.m_dampingRatio=a.dampingRatio;this.m_bias=this.m_gamma=this.m_impulse=
0};c2inherit(Box2D.Dynamics.Joints.b2DistanceJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetReactionForce=function(a){return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse*this.m_u.x,a*this.m_impulse*this.m_u.y)};
Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetReactionTorque=function(a){return 0};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetLength=function(){return this.m_length};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SetLength=function(a){this.m_length=a};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetFrequency=function(){return this.m_frequencyHz};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SetFrequency=function(a){this.m_frequencyHz=a};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.GetDampingRatio=
function(){return this.m_dampingRatio};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SetDampingRatio=function(a){this.m_dampingRatio=a};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.InitVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB;b=d.m_xf.R;var h=this.m_localAnchor1.x-d.m_sweep.localCenter.x,f=this.m_localAnchor1.y-d.m_sweep.localCenter.y,c=b.col1.x*h+b.col2.x*f,f=b.col1.y*h+b.col2.y*f,h=c;b=e.m_xf.R;var l=this.m_localAnchor2.x-e.m_sweep.localCenter.x,k=this.m_localAnchor2.y-
e.m_sweep.localCenter.y,c=b.col1.x*l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=c;this.m_u.x=e.m_sweep.c.x+l-d.m_sweep.c.x-h;this.m_u.y=e.m_sweep.c.y+k-d.m_sweep.c.y-f;c=Math.sqrt(this.m_u.x*this.m_u.x+this.m_u.y*this.m_u.y);c>Box2D.Common.b2Settings.b2_linearSlop?this.m_u.Multiply(1/c):this.m_u.SetZero();b=h*this.m_u.y-f*this.m_u.x;var g=l*this.m_u.y-k*this.m_u.x;b=d.m_invMass+d.m_invI*b*b+e.m_invMass+e.m_invI*g*g;this.m_mass=0!=b?1/b:0;if(0<this.m_frequencyHz){var c=c-this.m_length,g=2*Math.PI*this.m_frequencyHz,
m=this.m_mass*g*g;this.m_gamma=a.dt*(2*this.m_mass*this.m_dampingRatio*g+a.dt*m);this.m_gamma=0!=this.m_gamma?1/this.m_gamma:0;this.m_bias=c*a.dt*m*this.m_gamma;this.m_mass=b+this.m_gamma;this.m_mass=0!=this.m_mass?1/this.m_mass:0}a.warmStarting?(this.m_impulse*=a.dtRatio,a=this.m_impulse*this.m_u.x,b=this.m_impulse*this.m_u.y,d.m_linearVelocity.x-=d.m_invMass*a,d.m_linearVelocity.y-=d.m_invMass*b,d.m_angularVelocity-=d.m_invI*(h*b-f*a),e.m_linearVelocity.x+=e.m_invMass*a,e.m_linearVelocity.y+=e.m_invMass*
b,e.m_angularVelocity+=e.m_invI*(l*b-k*a)):this.m_impulse=0};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SolveVelocityConstraints=function(a){a=this.m_localAnchor1.x-this.m_bodyA.m_sweep.localCenter.x;var b=this.m_localAnchor1.y-this.m_bodyA.m_sweep.localCenter.y,c=this.m_bodyA.m_xf.R.col1.x*a+this.m_bodyA.m_xf.R.col2.x*b,b=this.m_bodyA.m_xf.R.col1.y*a+this.m_bodyA.m_xf.R.col2.y*b;a=c;var d=this.m_localAnchor2.x-this.m_bodyB.m_sweep.localCenter.x,e=this.m_localAnchor2.y-this.m_bodyB.m_sweep.localCenter.y,
c=this.m_bodyB.m_xf.R.col1.x*d+this.m_bodyB.m_xf.R.col2.x*e,e=this.m_bodyB.m_xf.R.col1.y*d+this.m_bodyB.m_xf.R.col2.y*e,d=c,h=-this.m_mass*(this.m_u.x*(this.m_bodyB.m_linearVelocity.x-this.m_bodyB.m_angularVelocity*e-(this.m_bodyA.m_linearVelocity.x-this.m_bodyA.m_angularVelocity*b))+this.m_u.y*(this.m_bodyB.m_linearVelocity.y+this.m_bodyB.m_angularVelocity*d-(this.m_bodyA.m_linearVelocity.y+this.m_bodyA.m_angularVelocity*a))+this.m_bias+this.m_gamma*this.m_impulse);this.m_impulse+=h;c=h*this.m_u.x;
h*=this.m_u.y;this.m_bodyA.m_linearVelocity.x-=this.m_bodyA.m_invMass*c;this.m_bodyA.m_linearVelocity.y-=this.m_bodyA.m_invMass*h;this.m_bodyA.m_angularVelocity-=this.m_bodyA.m_invI*(a*h-b*c);this.m_bodyB.m_linearVelocity.x+=this.m_bodyB.m_invMass*c;this.m_bodyB.m_linearVelocity.y+=this.m_bodyB.m_invMass*h;this.m_bodyB.m_angularVelocity+=this.m_bodyB.m_invI*(d*h-e*c)};Box2D.Dynamics.Joints.b2DistanceJoint.prototype.SolvePositionConstraints=function(a){if(0<this.m_frequencyHz)return!0;a=this.m_localAnchor1.x-
this.m_bodyA.m_sweep.localCenter.x;var b=this.m_localAnchor1.y-this.m_bodyA.m_sweep.localCenter.y,c=this.m_bodyA.m_xf.R.col1.x*a+this.m_bodyA.m_xf.R.col2.x*b,b=this.m_bodyA.m_xf.R.col1.y*a+this.m_bodyA.m_xf.R.col2.y*b;a=c;var d=this.m_localAnchor2.x-this.m_bodyB.m_sweep.localCenter.x,e=this.m_localAnchor2.y-this.m_bodyB.m_sweep.localCenter.y,c=this.m_bodyB.m_xf.R.col1.x*d+this.m_bodyB.m_xf.R.col2.x*e,e=this.m_bodyB.m_xf.R.col1.y*d+this.m_bodyB.m_xf.R.col2.y*e,d=c,h=this.m_bodyB.m_sweep.c.x+d-this.m_bodyA.m_sweep.c.x-
a,f=this.m_bodyB.m_sweep.c.y+e-this.m_bodyA.m_sweep.c.y-b,c=Math.sqrt(h*h+f*f),h=h/c,f=f/c,c=Box2D.Common.Math.b2Math.Clamp(c-this.m_length,-Box2D.Common.b2Settings.b2_maxLinearCorrection,Box2D.Common.b2Settings.b2_maxLinearCorrection),l=-this.m_mass*c;this.m_u.Set(h,f);h=l*this.m_u.x;f=l*this.m_u.y;this.m_bodyA.m_sweep.c.x-=this.m_bodyA.m_invMass*h;this.m_bodyA.m_sweep.c.y-=this.m_bodyA.m_invMass*f;this.m_bodyA.m_sweep.a-=this.m_bodyA.m_invI*(a*f-b*h);this.m_bodyB.m_sweep.c.x+=this.m_bodyB.m_invMass*
h;this.m_bodyB.m_sweep.c.y+=this.m_bodyB.m_invMass*f;this.m_bodyB.m_sweep.a+=this.m_bodyB.m_invI*(d*f-e*h);this.m_bodyA.SynchronizeTransform();this.m_bodyB.SynchronizeTransform();return Math.abs(c)<Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Joints.b2DistanceJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_distanceJoint;this.length=
1;this.dampingRatio=this.frequencyHz=0};c2inherit(Box2D.Dynamics.Joints.b2DistanceJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2DistanceJointDef.prototype.Initialize=function(a,b,c,d){this.bodyA=a;this.bodyB=b;this.localAnchorA.SetV(this.bodyA.GetLocalPoint(c));this.localAnchorB.SetV(this.bodyB.GetLocalPoint(d));a=d.x-c.x;c=d.y-c.y;this.length=Math.sqrt(a*a+c*c);this.dampingRatio=this.frequencyHz=0};Box2D.Dynamics.Joints.b2DistanceJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2DistanceJoint(this)};
Box2D.Dynamics.Joints.b2FrictionJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_linearMass=new Box2D.Common.Math.b2Mat22;this.m_linearImpulse=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchorA.SetV(a.localAnchorA);this.m_localAnchorB.SetV(a.localAnchorB);this.m_linearMass.SetZero();this.m_angularMass=0;this.m_linearImpulse.SetZero();this.m_angularImpulse=0;this.m_maxForce=
a.maxForce;this.m_maxTorque=a.maxTorque};c2inherit(Box2D.Dynamics.Joints.b2FrictionJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchorA)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchorB)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return new b2Vec2(a*this.m_linearImpulse.x,
a*this.m_linearImpulse.y)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);return a*this.m_angularImpulse};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SetMaxForce=function(a){void 0===a&&(a=0);this.m_maxForce=a};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetMaxForce=function(){return this.m_maxForce};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SetMaxTorque=function(a){void 0===a&&(a=0);this.m_maxTorque=a};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.GetMaxTorque=
function(){return this.m_maxTorque};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.InitVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB;b=d.m_xf.R;var h=this.m_localAnchorA.x-d.m_sweep.localCenter.x,f=this.m_localAnchorA.y-d.m_sweep.localCenter.y,c=b.col1.x*h+b.col2.x*f,f=b.col1.y*h+b.col2.y*f,h=c;b=e.m_xf.R;var l=this.m_localAnchorB.x-e.m_sweep.localCenter.x,k=this.m_localAnchorB.y-e.m_sweep.localCenter.y,c=b.col1.x*l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=c;b=d.m_invMass;var c=
e.m_invMass,g=d.m_invI,m=e.m_invI,n=new Box2D.Common.Math.b2Mat22;n.col1.x=b+c;n.col2.x=0;n.col1.y=0;n.col2.y=b+c;n.col1.x+=g*f*f;n.col2.x+=-g*h*f;n.col1.y+=-g*h*f;n.col2.y+=g*h*h;n.col1.x+=m*k*k;n.col2.x+=-m*l*k;n.col1.y+=-m*l*k;n.col2.y+=m*l*l;n.GetInverse(this.m_linearMass);this.m_angularMass=g+m;0<this.m_angularMass&&(this.m_angularMass=1/this.m_angularMass);a.warmStarting?(this.m_linearImpulse.x*=a.dtRatio,this.m_linearImpulse.y*=a.dtRatio,this.m_angularImpulse*=a.dtRatio,a=this.m_linearImpulse,
d.m_linearVelocity.x-=b*a.x,d.m_linearVelocity.y-=b*a.y,d.m_angularVelocity-=g*(h*a.y-f*a.x+this.m_angularImpulse),e.m_linearVelocity.x+=c*a.x,e.m_linearVelocity.y+=c*a.y,e.m_angularVelocity+=m*(l*a.y-k*a.x+this.m_angularImpulse)):(this.m_linearImpulse.SetZero(),this.m_angularImpulse=0)};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SolveVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB,h=d.m_linearVelocity,f=d.m_angularVelocity,l=e.m_linearVelocity,k=e.m_angularVelocity,g=
d.m_invMass,m=e.m_invMass,n=d.m_invI,p=e.m_invI;b=d.m_xf.R;var r=this.m_localAnchorA.x-d.m_sweep.localCenter.x,s=this.m_localAnchorA.y-d.m_sweep.localCenter.y,c=b.col1.x*r+b.col2.x*s,s=b.col1.y*r+b.col2.y*s,r=c;b=e.m_xf.R;var q=this.m_localAnchorB.x-e.m_sweep.localCenter.x,t=this.m_localAnchorB.y-e.m_sweep.localCenter.y,c=b.col1.x*q+b.col2.x*t,t=b.col1.y*q+b.col2.y*t,q=c;b=0;var c=-this.m_angularMass*(k-f),u=this.m_angularImpulse;b=a.dt*this.m_maxTorque;this.m_angularImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_angularImpulse+
c,-b,b);c=this.m_angularImpulse-u;f-=n*c;k+=p*c;b=Box2D.Common.Math.b2Math.MulMV(this.m_linearMass,Box2D.Common.Math.b2Vec2.Get(-(l.x-k*t-h.x+f*s),-(l.y+k*q-h.y-f*r)));c=this.m_linearImpulse.Copy();this.m_linearImpulse.Add(b);b=a.dt*this.m_maxForce;this.m_linearImpulse.LengthSquared()>b*b&&(this.m_linearImpulse.Normalize(),this.m_linearImpulse.Multiply(b));b=Box2D.Common.Math.b2Math.SubtractVV(this.m_linearImpulse,c);h.x-=g*b.x;h.y-=g*b.y;f-=n*(r*b.y-s*b.x);l.x+=m*b.x;l.y+=m*b.y;k+=p*(q*b.y-t*b.x);
d.m_angularVelocity=f;e.m_angularVelocity=k};Box2D.Dynamics.Joints.b2FrictionJoint.prototype.SolvePositionConstraints=function(a){return!0};Box2D.Dynamics.Joints.b2FrictionJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_frictionJoint;this.maxTorque=this.maxForce=0};c2inherit(Box2D.Dynamics.Joints.b2FrictionJointDef,Box2D.Dynamics.Joints.b2JointDef);
Box2D.Dynamics.Joints.b2FrictionJointDef.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA.SetV(this.bodyA.GetLocalPoint(c));this.localAnchorB.SetV(this.bodyB.GetLocalPoint(c))};Box2D.Dynamics.Joints.b2FrictionJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2FrictionJoint(this)};Box2D.Dynamics.Joints.b2GearJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_groundAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_groundAnchor2=Box2D.Common.Math.b2Vec2.Get(0,
0);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_J=new Box2D.Dynamics.Joints.b2Jacobian;var b=a.joint1.m_type,c=a.joint2.m_type;this.m_prismatic2=this.m_revolute2=this.m_prismatic1=this.m_revolute1=null;var d=0,e=0;this.m_ground1=a.joint1.GetBodyA();this.m_bodyA=a.joint1.GetBodyB();b==Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint?(this.m_revolute1=a.joint1,this.m_groundAnchor1.SetV(this.m_revolute1.m_localAnchor1),this.m_localAnchor1.SetV(this.m_revolute1.m_localAnchor2),
d=this.m_revolute1.GetJointAngle()):(this.m_prismatic1=a.joint1,this.m_groundAnchor1.SetV(this.m_prismatic1.m_localAnchor1),this.m_localAnchor1.SetV(this.m_prismatic1.m_localAnchor2),d=this.m_prismatic1.GetJointTranslation());this.m_ground2=a.joint2.GetBodyA();this.m_bodyB=a.joint2.GetBodyB();c==Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint?(this.m_revolute2=a.joint2,this.m_groundAnchor2.SetV(this.m_revolute2.m_localAnchor1),this.m_localAnchor2.SetV(this.m_revolute2.m_localAnchor2),e=this.m_revolute2.GetJointAngle()):
(this.m_prismatic2=a.joint2,this.m_groundAnchor2.SetV(this.m_prismatic2.m_localAnchor1),this.m_localAnchor2.SetV(this.m_prismatic2.m_localAnchor2),e=this.m_prismatic2.GetJointTranslation());this.m_ratio=a.ratio;this.m_constant=d+this.m_ratio*e;this.m_impulse=0};c2inherit(Box2D.Dynamics.Joints.b2GearJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2GearJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetAnchorB=
function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse*this.m_J.linearB.x,a*this.m_impulse*this.m_J.linearB.y)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);var b=this.m_bodyB.m_xf.R,c=this.m_localAnchor1.x-this.m_bodyB.m_sweep.localCenter.x,d=this.m_localAnchor1.y-this.m_bodyB.m_sweep.localCenter.y,
e=b.col1.x*c+b.col2.x*d,d=b.col1.y*c+b.col2.y*d;return a*(this.m_impulse*this.m_J.angularB-e*this.m_impulse*this.m_J.linearB.y+d*this.m_impulse*this.m_J.linearB.x)};Box2D.Dynamics.Joints.b2GearJoint.prototype.GetRatio=function(){return this.m_ratio};Box2D.Dynamics.Joints.b2GearJoint.prototype.SetRatio=function(a){void 0===a&&(a=0);this.m_ratio=a};Box2D.Dynamics.Joints.b2GearJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_ground1,c=this.m_ground2,d=this.m_bodyA,e=this.m_bodyB,h=0,
f=0,l=0,k=0,g=l=0,m=0;this.m_J.SetZero();this.m_revolute1?(this.m_J.angularA=-1,m+=d.m_invI):(b=b.m_xf.R,f=this.m_prismatic1.m_localXAxis1,h=b.col1.x*f.x+b.col2.x*f.y,f=b.col1.y*f.x+b.col2.y*f.y,b=d.m_xf.R,l=this.m_localAnchor1.x-d.m_sweep.localCenter.x,k=this.m_localAnchor1.y-d.m_sweep.localCenter.y,g=b.col1.x*l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=g*f-k*h,this.m_J.linearA.Set(-h,-f),this.m_J.angularA=-l,m+=d.m_invMass+d.m_invI*l*l);this.m_revolute2?(this.m_J.angularB=-this.m_ratio,m+=this.m_ratio*
this.m_ratio*e.m_invI):(b=c.m_xf.R,f=this.m_prismatic2.m_localXAxis1,h=b.col1.x*f.x+b.col2.x*f.y,f=b.col1.y*f.x+b.col2.y*f.y,b=e.m_xf.R,l=this.m_localAnchor2.x-e.m_sweep.localCenter.x,k=this.m_localAnchor2.y-e.m_sweep.localCenter.y,g=b.col1.x*l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=g*f-k*h,this.m_J.linearB.Set(-this.m_ratio*h,-this.m_ratio*f),this.m_J.angularB=-this.m_ratio*l,m+=this.m_ratio*this.m_ratio*(e.m_invMass+e.m_invI*l*l));this.m_mass=0<m?1/m:0;a.warmStarting?(d.m_linearVelocity.x+=d.m_invMass*
this.m_impulse*this.m_J.linearA.x,d.m_linearVelocity.y+=d.m_invMass*this.m_impulse*this.m_J.linearA.y,d.m_angularVelocity+=d.m_invI*this.m_impulse*this.m_J.angularA,e.m_linearVelocity.x+=e.m_invMass*this.m_impulse*this.m_J.linearB.x,e.m_linearVelocity.y+=e.m_invMass*this.m_impulse*this.m_J.linearB.y,e.m_angularVelocity+=e.m_invI*this.m_impulse*this.m_J.angularB):this.m_impulse=0};Box2D.Dynamics.Joints.b2GearJoint.prototype.SolveVelocityConstraints=function(a){a=this.m_bodyA;var b=this.m_bodyB,c=this.m_J.Compute(a.m_linearVelocity,
a.m_angularVelocity,b.m_linearVelocity,b.m_angularVelocity),c=-this.m_mass*c;this.m_impulse+=c;a.m_linearVelocity.x+=a.m_invMass*c*this.m_J.linearA.x;a.m_linearVelocity.y+=a.m_invMass*c*this.m_J.linearA.y;a.m_angularVelocity+=a.m_invI*c*this.m_J.angularA;b.m_linearVelocity.x+=b.m_invMass*c*this.m_J.linearB.x;b.m_linearVelocity.y+=b.m_invMass*c*this.m_J.linearB.y;b.m_angularVelocity+=b.m_invI*c*this.m_J.angularB};Box2D.Dynamics.Joints.b2GearJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;
var b=this.m_bodyB,c=0,d=0,c=this.m_revolute1?this.m_revolute1.GetJointAngle():this.m_prismatic1.GetJointTranslation(),d=this.m_revolute2?this.m_revolute2.GetJointAngle():this.m_prismatic2.GetJointTranslation(),c=-this.m_mass*(this.m_constant-(c+this.m_ratio*d));a.m_sweep.c.x+=a.m_invMass*c*this.m_J.linearA.x;a.m_sweep.c.y+=a.m_invMass*c*this.m_J.linearA.y;a.m_sweep.a+=a.m_invI*c*this.m_J.angularA;b.m_sweep.c.x+=b.m_invMass*c*this.m_J.linearB.x;b.m_sweep.c.y+=b.m_invMass*c*this.m_J.linearB.y;b.m_sweep.a+=
b.m_invI*c*this.m_J.angularB;a.SynchronizeTransform();b.SynchronizeTransform();return 0<Box2D.Common.b2Settings.b2_linearSlop};Box2D.Dynamics.Joints.b2GearJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.type=Box2D.Dynamics.Joints.b2Joint.e_gearJoint;this.joint2=this.joint1=null;this.ratio=1};c2inherit(Box2D.Dynamics.Joints.b2GearJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2GearJointDef.prototype.Initialize=function(a,b,c){this.joint1=a;this.bodyA=a.GetBodyA();
this.joint2=b;this.bodyB=b.GetBodyA();this.ratio=c};Box2D.Dynamics.Joints.b2GearJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2GearJoint(this)};Box2D.Dynamics.Joints.b2Jacobian=function(){this.linearA=Box2D.Common.Math.b2Vec2.Get(0,0);this.linearB=Box2D.Common.Math.b2Vec2.Get(0,0)};Box2D.Dynamics.Joints.b2Jacobian.prototype.SetZero=function(){this.linearA.SetZero();this.angularA=0;this.linearB.SetZero();this.angularB=0};Box2D.Dynamics.Joints.b2Jacobian.prototype.Set=function(a,
b,c,d){void 0===b&&(b=0);void 0===d&&(d=0);this.linearA.SetV(a);this.angularA=b;this.linearB.SetV(c);this.angularB=d};Box2D.Dynamics.Joints.b2Jacobian.prototype.Compute=function(a,b,c,d){void 0===b&&(b=0);void 0===d&&(d=0);return this.linearA.x*a.x+this.linearA.y*a.y+this.angularA*b+(this.linearB.x*c.x+this.linearB.y*c.y)+this.angularB*d};Box2D.Dynamics.Joints.b2LineJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=
Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localXAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localYAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_axis=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_perp=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_K=new Box2D.Common.Math.b2Mat22;this.m_impulse=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);this.m_localXAxis1.SetV(a.localAxisA);this.m_localYAxis1.x=-this.m_localXAxis1.y;this.m_localYAxis1.y=
this.m_localXAxis1.x;this.m_impulse.SetZero();this.m_motorImpulse=this.m_motorMass=0;this.m_lowerTranslation=a.lowerTranslation;this.m_upperTranslation=a.upperTranslation;this.m_maxMotorForce=a.maxMotorForce;this.m_motorSpeed=a.motorSpeed;this.m_enableLimit=a.enableLimit;this.m_enableMotor=a.enableMotor;this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;this.m_axis.SetZero();this.m_perp.SetZero()};c2inherit(Box2D.Dynamics.Joints.b2LineJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2LineJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*(this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.y)*this.m_axis.x),a*(this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+this.m_impulse.y)*this.m_axis.y))};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetReactionTorque=
function(a){void 0===a&&(a=0);return a*this.m_impulse.y};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetJointTranslation=function(){var a=this.m_bodyA,b=this.m_bodyB,c=a.GetWorldPoint(this.m_localAnchor1),d=b.GetWorldPoint(this.m_localAnchor2),b=d.x-c.x,c=d.y-c.y,a=a.GetWorldVector(this.m_localXAxis1);return a.x*b+a.y*c};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetJointSpeed=function(){var a=this.m_bodyA,b=this.m_bodyB,c;c=a.m_xf.R;var d=this.m_localAnchor1.x-a.m_sweep.localCenter.x,e=this.m_localAnchor1.y-
a.m_sweep.localCenter.y,h=c.col1.x*d+c.col2.x*e,e=c.col1.y*d+c.col2.y*e,d=h;c=b.m_xf.R;var f=this.m_localAnchor2.x-b.m_sweep.localCenter.x,l=this.m_localAnchor2.y-b.m_sweep.localCenter.y,h=c.col1.x*f+c.col2.x*l,l=c.col1.y*f+c.col2.y*l,f=h;c=b.m_sweep.c.x+f-(a.m_sweep.c.x+d);var h=b.m_sweep.c.y+l-(a.m_sweep.c.y+e),k=a.GetWorldVector(this.m_localXAxis1),g=a.m_linearVelocity,m=b.m_linearVelocity,a=a.m_angularVelocity,b=b.m_angularVelocity;return c*-a*k.y+h*a*k.x+(k.x*(m.x+-b*l-g.x- -a*e)+k.y*(m.y+b*
f-g.y-a*d))};Box2D.Dynamics.Joints.b2LineJoint.prototype.IsLimitEnabled=function(){return this.m_enableLimit};Box2D.Dynamics.Joints.b2LineJoint.prototype.EnableLimit=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableLimit=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetLowerLimit=function(){return this.m_lowerTranslation};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetUpperLimit=function(){return this.m_upperTranslation};Box2D.Dynamics.Joints.b2LineJoint.prototype.SetLimits=
function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_lowerTranslation=a;this.m_upperTranslation=b};Box2D.Dynamics.Joints.b2LineJoint.prototype.IsMotorEnabled=function(){return this.m_enableMotor};Box2D.Dynamics.Joints.b2LineJoint.prototype.EnableMotor=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableMotor=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.SetMotorSpeed=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);
this.m_bodyB.SetAwake(!0);this.m_motorSpeed=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetMotorSpeed=function(){return this.m_motorSpeed};Box2D.Dynamics.Joints.b2LineJoint.prototype.SetMaxMotorForce=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_maxMotorForce=a};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetMaxMotorForce=function(){return this.m_maxMotorForce};Box2D.Dynamics.Joints.b2LineJoint.prototype.GetMotorForce=function(){return this.m_motorImpulse};
Box2D.Dynamics.Joints.b2LineJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d,e=0;this.m_localCenterA.SetV(b.GetLocalCenter());this.m_localCenterB.SetV(c.GetLocalCenter());var h=b.GetTransform();c.GetTransform();d=b.m_xf.R;var f=this.m_localAnchor1.x-this.m_localCenterA.x,l=this.m_localAnchor1.y-this.m_localCenterA.y,e=d.col1.x*f+d.col2.x*l,l=d.col1.y*f+d.col2.y*l,f=e;d=c.m_xf.R;var k=this.m_localAnchor2.x-this.m_localCenterB.x,g=this.m_localAnchor2.y-this.m_localCenterB.y,
e=d.col1.x*k+d.col2.x*g,g=d.col1.y*k+d.col2.y*g,k=e;d=c.m_sweep.c.x+k-b.m_sweep.c.x-f;e=c.m_sweep.c.y+g-b.m_sweep.c.y-l;this.m_invMassA=b.m_invMass;this.m_invMassB=c.m_invMass;this.m_invIA=b.m_invI;this.m_invIB=c.m_invI;this.m_axis.SetV(Box2D.Common.Math.b2Math.MulMV(h.R,this.m_localXAxis1));this.m_a1=(d+f)*this.m_axis.y-(e+l)*this.m_axis.x;this.m_a2=k*this.m_axis.y-g*this.m_axis.x;this.m_motorMass=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_a1*this.m_a1+this.m_invIB*this.m_a2*this.m_a2;this.m_motorMass=
this.m_motorMass>Number.MIN_VALUE?1/this.m_motorMass:0;this.m_perp.SetV(Box2D.Common.Math.b2Math.MulMV(h.R,this.m_localYAxis1));this.m_s1=(d+f)*this.m_perp.y-(e+l)*this.m_perp.x;this.m_s2=k*this.m_perp.y-g*this.m_perp.x;h=this.m_invMassA;f=this.m_invMassB;l=this.m_invIA;k=this.m_invIB;this.m_K.col1.x=h+f+l*this.m_s1*this.m_s1+k*this.m_s2*this.m_s2;this.m_K.col1.y=l*this.m_s1*this.m_a1+k*this.m_s2*this.m_a2;this.m_K.col2.x=this.m_K.col1.y;this.m_K.col2.y=h+f+l*this.m_a1*this.m_a1+k*this.m_a2*this.m_a2;
this.m_enableLimit?(d=this.m_axis.x*d+this.m_axis.y*e,Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_equalLimits:d<=this.m_lowerTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit&&(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit,this.m_impulse.y=0):d>=this.m_upperTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_limitState=
Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit,this.m_impulse.y=0):(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse.y=0)):this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;!1==this.m_enableMotor&&(this.m_motorImpulse=0);a.warmStarting?(this.m_impulse.x*=a.dtRatio,this.m_impulse.y*=a.dtRatio,this.m_motorImpulse*=a.dtRatio,a=this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.y)*this.m_axis.x,d=this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+
this.m_impulse.y)*this.m_axis.y,e=this.m_impulse.x*this.m_s1+(this.m_motorImpulse+this.m_impulse.y)*this.m_a1,h=this.m_impulse.x*this.m_s2+(this.m_motorImpulse+this.m_impulse.y)*this.m_a2,b.m_linearVelocity.x-=this.m_invMassA*a,b.m_linearVelocity.y-=this.m_invMassA*d,b.m_angularVelocity-=this.m_invIA*e,c.m_linearVelocity.x+=this.m_invMassB*a,c.m_linearVelocity.y+=this.m_invMassB*d,c.m_angularVelocity+=this.m_invIB*h):(this.m_impulse.SetZero(),this.m_motorImpulse=0)};Box2D.Dynamics.Joints.b2LineJoint.prototype.SolveVelocityConstraints=
function(a){var b=this.m_bodyA,c=this.m_bodyB,d=b.m_linearVelocity,e=b.m_angularVelocity,h=c.m_linearVelocity,f=c.m_angularVelocity,l=0,k=0,g=0,m=0;this.m_enableMotor&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_equalLimits&&(m=this.m_motorMass*(this.m_motorSpeed-(this.m_axis.x*(h.x-d.x)+this.m_axis.y*(h.y-d.y)+this.m_a2*f-this.m_a1*e)),l=this.m_motorImpulse,k=a.dt*this.m_maxMotorForce,this.m_motorImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_motorImpulse+m,-k,k),m=this.m_motorImpulse-l,l=
m*this.m_axis.x,k=m*this.m_axis.y,g=m*this.m_a1,m*=this.m_a2,d.x-=this.m_invMassA*l,d.y-=this.m_invMassA*k,e-=this.m_invIA*g,h.x+=this.m_invMassB*l,h.y+=this.m_invMassB*k,f+=this.m_invIB*m);k=this.m_perp.x*(h.x-d.x)+this.m_perp.y*(h.y-d.y)+this.m_s2*f-this.m_s1*e;this.m_enableLimit&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit?(g=this.m_axis.x*(h.x-d.x)+this.m_axis.y*(h.y-d.y)+this.m_a2*f-this.m_a1*e,l=this.m_impulse.Copy(),a=this.m_K.Solve(Box2D.Common.Math.b2Vec2.Get(0,0),-k,
-g),this.m_impulse.Add(a),this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?this.m_impulse.y=Math.max(this.m_impulse.y,0):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_impulse.y=Math.min(this.m_impulse.y,0)),k=-k-(this.m_impulse.y-l.y)*this.m_K.col2.x,g=0,g=0!=this.m_K.col1.x?k/this.m_K.col1.x+l.x:l.x,this.m_impulse.x=g,a.x=this.m_impulse.x-l.x,a.y=this.m_impulse.y-l.y,l=a.x*this.m_perp.x+a.y*this.m_axis.x,k=a.x*this.m_perp.y+a.y*this.m_axis.y,g=a.x*this.m_s1+
a.y*this.m_a1,m=a.x*this.m_s2+a.y*this.m_a2):(a=0,a=0!=this.m_K.col1.x?-k/this.m_K.col1.x:0,this.m_impulse.x+=a,l=a*this.m_perp.x,k=a*this.m_perp.y,g=a*this.m_s1,m=a*this.m_s2);d.x-=this.m_invMassA*l;d.y-=this.m_invMassA*k;e-=this.m_invIA*g;h.x+=this.m_invMassB*l;h.y+=this.m_invMassB*k;f+=this.m_invIB*m;b.m_linearVelocity.SetV(d);b.m_angularVelocity=e;c.m_linearVelocity.SetV(h);c.m_angularVelocity=f};Box2D.Dynamics.Joints.b2LineJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;var b=
this.m_bodyB,c=a.m_sweep.c,d=a.m_sweep.a,e=b.m_sweep.c,h=b.m_sweep.a,f,l=0,k=0,g=0,m=0,n=f=0,p=0,k=!1,r=0,s=Box2D.Common.Math.b2Mat22.FromAngle(d),g=Box2D.Common.Math.b2Mat22.FromAngle(h);f=s;var p=this.m_localAnchor1.x-this.m_localCenterA.x,q=this.m_localAnchor1.y-this.m_localCenterA.y,l=f.col1.x*p+f.col2.x*q,q=f.col1.y*p+f.col2.y*q,p=l;f=g;g=this.m_localAnchor2.x-this.m_localCenterB.x;m=this.m_localAnchor2.y-this.m_localCenterB.y;l=f.col1.x*g+f.col2.x*m;m=f.col1.y*g+f.col2.y*m;g=l;f=e.x+g-c.x-p;
l=e.y+m-c.y-q;if(this.m_enableLimit){this.m_axis=Box2D.Common.Math.b2Math.MulMV(s,this.m_localXAxis1);this.m_a1=(f+p)*this.m_axis.y-(l+q)*this.m_axis.x;this.m_a2=g*this.m_axis.y-m*this.m_axis.x;var t=this.m_axis.x*f+this.m_axis.y*l;Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?(r=Box2D.Common.Math.b2Math.Clamp(t,-Box2D.Common.b2Settings.b2_maxLinearCorrection,Box2D.Common.b2Settings.b2_maxLinearCorrection),n=Math.abs(t),k=!0):t<=this.m_lowerTranslation?
(r=Box2D.Common.Math.b2Math.Clamp(t-this.m_lowerTranslation+Box2D.Common.b2Settings.b2_linearSlop,-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),n=this.m_lowerTranslation-t,k=!0):t>=this.m_upperTranslation&&(r=Box2D.Common.Math.b2Math.Clamp(t-this.m_upperTranslation+Box2D.Common.b2Settings.b2_linearSlop,0,Box2D.Common.b2Settings.b2_maxLinearCorrection),n=t-this.m_upperTranslation,k=!0)}this.m_perp=Box2D.Common.Math.b2Math.MulMV(s,this.m_localYAxis1);this.m_s1=(f+p)*this.m_perp.y-(l+q)*this.m_perp.x;
this.m_s2=g*this.m_perp.y-m*this.m_perp.x;s=Box2D.Common.Math.b2Vec2.Get(0,0);q=this.m_perp.x*f+this.m_perp.y*l;n=Math.max(n,Math.abs(q));p=0;k?(k=this.m_invMassA,g=this.m_invMassB,m=this.m_invIA,f=this.m_invIB,this.m_K.col1.x=k+g+m*this.m_s1*this.m_s1+f*this.m_s2*this.m_s2,this.m_K.col1.y=m*this.m_s1*this.m_a1+f*this.m_s2*this.m_a2,this.m_K.col2.x=this.m_K.col1.y,this.m_K.col2.y=k+g+m*this.m_a1*this.m_a1+f*this.m_a2*this.m_a2,this.m_K.Solve(s,-q,-r)):(k=this.m_invMassA,g=this.m_invMassB,m=this.m_invIA,
f=this.m_invIB,r=k+g+m*this.m_s1*this.m_s1+f*this.m_s2*this.m_s2,s.x=0!=r?-q/r:0,s.y=0);r=s.x*this.m_perp.x+s.y*this.m_axis.x;k=s.x*this.m_perp.y+s.y*this.m_axis.y;q=s.x*this.m_s1+s.y*this.m_a1;s=s.x*this.m_s2+s.y*this.m_a2;c.x-=this.m_invMassA*r;c.y-=this.m_invMassA*k;d-=this.m_invIA*q;e.x+=this.m_invMassB*r;e.y+=this.m_invMassB*k;h+=this.m_invIB*s;a.m_sweep.a=d;b.m_sweep.a=h;a.SynchronizeTransform();b.SynchronizeTransform();return n<=Box2D.Common.b2Settings.b2_linearSlop&&p<=Box2D.Common.b2Settings.b2_angularSlop};
Box2D.Dynamics.Joints.b2LineJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAxisA=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_lineJoint;this.localAxisA.Set(1,0);this.enableLimit=!1;this.upperTranslation=this.lowerTranslation=0;this.enableMotor=!1;this.motorSpeed=this.maxMotorForce=0};c2inherit(Box2D.Dynamics.Joints.b2LineJointDef,Box2D.Dynamics.Joints.b2JointDef);
Box2D.Dynamics.Joints.b2LineJointDef.prototype.Initialize=function(a,b,c,d){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);this.localAxisA=this.bodyA.GetLocalVector(d)};Box2D.Dynamics.Joints.b2LineJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2LineJoint(this)};Box2D.Dynamics.Joints.b2PrismaticJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,
0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localXAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localYAxis1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_axis=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_perp=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_K=new Box2D.Common.Math.b2Mat33;this.m_impulse=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);this.m_localXAxis1.SetV(a.localAxisA);this.m_localYAxis1.x=-this.m_localXAxis1.y;
this.m_localYAxis1.y=this.m_localXAxis1.x;this.m_refAngle=a.referenceAngle;this.m_impulse.SetZero();this.m_motorImpulse=this.m_motorMass=0;this.m_lowerTranslation=a.lowerTranslation;this.m_upperTranslation=a.upperTranslation;this.m_maxMotorForce=a.maxMotorForce;this.m_motorSpeed=a.motorSpeed;this.m_enableLimit=a.enableLimit;this.m_enableMotor=a.enableMotor;this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;this.m_axis.SetZero();this.m_perp.SetZero()};c2inherit(Box2D.Dynamics.Joints.b2PrismaticJoint,
Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*(this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.x),
a*(this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.y))};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);return a*this.m_impulse.y};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetJointTranslation=function(){var a=this.m_bodyA,b=this.m_bodyB,c=a.GetWorldPoint(this.m_localAnchor1),d=b.GetWorldPoint(this.m_localAnchor2),b=d.x-c.x,c=d.y-c.y,a=a.GetWorldVector(this.m_localXAxis1);return a.x*b+a.y*c};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetJointSpeed=
function(){var a=this.m_bodyA,b=this.m_bodyB,c;c=a.m_xf.R;var d=this.m_localAnchor1.x-a.m_sweep.localCenter.x,e=this.m_localAnchor1.y-a.m_sweep.localCenter.y,h=c.col1.x*d+c.col2.x*e,e=c.col1.y*d+c.col2.y*e,d=h;c=b.m_xf.R;var f=this.m_localAnchor2.x-b.m_sweep.localCenter.x,l=this.m_localAnchor2.y-b.m_sweep.localCenter.y,h=c.col1.x*f+c.col2.x*l,l=c.col1.y*f+c.col2.y*l,f=h;c=b.m_sweep.c.x+f-(a.m_sweep.c.x+d);var h=b.m_sweep.c.y+l-(a.m_sweep.c.y+e),k=a.GetWorldVector(this.m_localXAxis1),g=a.m_linearVelocity,
m=b.m_linearVelocity,a=a.m_angularVelocity,b=b.m_angularVelocity;return c*-a*k.y+h*a*k.x+(k.x*(m.x+-b*l-g.x- -a*e)+k.y*(m.y+b*f-g.y-a*d))};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.IsLimitEnabled=function(){return this.m_enableLimit};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.EnableLimit=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableLimit=a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetLowerLimit=function(){return this.m_lowerTranslation};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetUpperLimit=
function(){return this.m_upperTranslation};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SetLimits=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_lowerTranslation=a;this.m_upperTranslation=b};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.IsMotorEnabled=function(){return this.m_enableMotor};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.EnableMotor=function(a){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_enableMotor=
a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SetMotorSpeed=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_motorSpeed=a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetMotorSpeed=function(){return this.m_motorSpeed};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SetMaxMotorForce=function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_maxMotorForce=a};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.GetMotorForce=
function(){return this.m_motorImpulse};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d,e=0;this.m_localCenterA.SetV(b.GetLocalCenter());this.m_localCenterB.SetV(c.GetLocalCenter());var h=b.GetTransform();c.GetTransform();d=b.m_xf.R;var f=this.m_localAnchor1.x-this.m_localCenterA.x,l=this.m_localAnchor1.y-this.m_localCenterA.y,e=d.col1.x*f+d.col2.x*l,l=d.col1.y*f+d.col2.y*l,f=e;d=c.m_xf.R;var k=this.m_localAnchor2.x-this.m_localCenterB.x,
g=this.m_localAnchor2.y-this.m_localCenterB.y,e=d.col1.x*k+d.col2.x*g,g=d.col1.y*k+d.col2.y*g,k=e;d=c.m_sweep.c.x+k-b.m_sweep.c.x-f;e=c.m_sweep.c.y+g-b.m_sweep.c.y-l;this.m_invMassA=b.m_invMass;this.m_invMassB=c.m_invMass;this.m_invIA=b.m_invI;this.m_invIB=c.m_invI;this.m_axis.SetV(Box2D.Common.Math.b2Math.MulMV(h.R,this.m_localXAxis1));this.m_a1=(d+f)*this.m_axis.y-(e+l)*this.m_axis.x;this.m_a2=k*this.m_axis.y-g*this.m_axis.x;this.m_motorMass=this.m_invMassA+this.m_invMassB+this.m_invIA*this.m_a1*
this.m_a1+this.m_invIB*this.m_a2*this.m_a2;this.m_motorMass>Number.MIN_VALUE&&(this.m_motorMass=1/this.m_motorMass);this.m_perp.SetV(Box2D.Common.Math.b2Math.MulMV(h.R,this.m_localYAxis1));this.m_s1=(d+f)*this.m_perp.y-(e+l)*this.m_perp.x;this.m_s2=k*this.m_perp.y-g*this.m_perp.x;h=this.m_invMassA;f=this.m_invMassB;l=this.m_invIA;k=this.m_invIB;this.m_K.col1.x=h+f+l*this.m_s1*this.m_s1+k*this.m_s2*this.m_s2;this.m_K.col1.y=l*this.m_s1+k*this.m_s2;this.m_K.col1.z=l*this.m_s1*this.m_a1+k*this.m_s2*
this.m_a2;this.m_K.col2.x=this.m_K.col1.y;this.m_K.col2.y=l+k;this.m_K.col2.z=l*this.m_a1+k*this.m_a2;this.m_K.col3.x=this.m_K.col1.z;this.m_K.col3.y=this.m_K.col2.z;this.m_K.col3.z=h+f+l*this.m_a1*this.m_a1+k*this.m_a2*this.m_a2;this.m_enableLimit?(d=this.m_axis.x*d+this.m_axis.y*e,Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_equalLimits:d<=this.m_lowerTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit&&
(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit,this.m_impulse.z=0):d>=this.m_upperTranslation?this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit,this.m_impulse.z=0):(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse.z=0)):this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;!1==this.m_enableMotor&&(this.m_motorImpulse=0);a.warmStarting?(this.m_impulse.x*=a.dtRatio,
this.m_impulse.y*=a.dtRatio,this.m_motorImpulse*=a.dtRatio,a=this.m_impulse.x*this.m_perp.x+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.x,d=this.m_impulse.x*this.m_perp.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_axis.y,e=this.m_impulse.x*this.m_s1+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a1,h=this.m_impulse.x*this.m_s2+this.m_impulse.y+(this.m_motorImpulse+this.m_impulse.z)*this.m_a2,b.m_linearVelocity.x-=this.m_invMassA*a,b.m_linearVelocity.y-=this.m_invMassA*d,
b.m_angularVelocity-=this.m_invIA*e,c.m_linearVelocity.x+=this.m_invMassB*a,c.m_linearVelocity.y+=this.m_invMassB*d,c.m_angularVelocity+=this.m_invIB*h):(this.m_impulse.SetZero(),this.m_motorImpulse=0)};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SolveVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d=b.m_linearVelocity,e=b.m_angularVelocity,h=c.m_linearVelocity,f=c.m_angularVelocity,l=0,k=0,g=0,m=0;this.m_enableMotor&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_equalLimits&&
(m=this.m_motorMass*(this.m_motorSpeed-(this.m_axis.x*(h.x-d.x)+this.m_axis.y*(h.y-d.y)+this.m_a2*f-this.m_a1*e)),l=this.m_motorImpulse,a=a.dt*this.m_maxMotorForce,this.m_motorImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_motorImpulse+m,-a,a),m=this.m_motorImpulse-l,l=m*this.m_axis.x,k=m*this.m_axis.y,g=m*this.m_a1,m*=this.m_a2,d.x-=this.m_invMassA*l,d.y-=this.m_invMassA*k,e-=this.m_invIA*g,h.x+=this.m_invMassB*l,h.y+=this.m_invMassB*k,f+=this.m_invIB*m);g=this.m_perp.x*(h.x-d.x)+this.m_perp.y*(h.y-
d.y)+this.m_s2*f-this.m_s1*e;k=f-e;this.m_enableLimit&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit?(a=this.m_axis.x*(h.x-d.x)+this.m_axis.y*(h.y-d.y)+this.m_a2*f-this.m_a1*e,l=this.m_impulse.Copy(),a=this.m_K.Solve33(new Box2D.Common.Math.b2Vec3(0,0,0),-g,-k,-a),this.m_impulse.Add(a),this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?this.m_impulse.z=Math.max(this.m_impulse.z,0):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_impulse.z=Math.min(this.m_impulse.z,
0)),g=-g-(this.m_impulse.z-l.z)*this.m_K.col3.x,k=-k-(this.m_impulse.z-l.z)*this.m_K.col3.y,k=this.m_K.Solve22(Box2D.Common.Math.b2Vec2.Get(0,0),g,k),k.x+=l.x,k.y+=l.y,this.m_impulse.x=k.x,this.m_impulse.y=k.y,a.x=this.m_impulse.x-l.x,a.y=this.m_impulse.y-l.y,a.z=this.m_impulse.z-l.z,l=a.x*this.m_perp.x+a.z*this.m_axis.x,k=a.x*this.m_perp.y+a.z*this.m_axis.y,g=a.x*this.m_s1+a.y+a.z*this.m_a1,m=a.x*this.m_s2+a.y+a.z*this.m_a2):(a=this.m_K.Solve22(Box2D.Common.Math.b2Vec2.Get(0,0),-g,-k),this.m_impulse.x+=
a.x,this.m_impulse.y+=a.y,l=a.x*this.m_perp.x,k=a.x*this.m_perp.y,g=a.x*this.m_s1+a.y,m=a.x*this.m_s2+a.y);d.x-=this.m_invMassA*l;d.y-=this.m_invMassA*k;e-=this.m_invIA*g;h.x+=this.m_invMassB*l;h.y+=this.m_invMassB*k;f+=this.m_invIB*m;b.m_linearVelocity.SetV(d);b.m_angularVelocity=e;c.m_linearVelocity.SetV(h);c.m_angularVelocity=f};Box2D.Dynamics.Joints.b2PrismaticJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;var b=this.m_bodyB,c=a.m_sweep.c,d=a.m_sweep.a,e=b.m_sweep.c,h=b.m_sweep.a,
f,l=0,k=0,g=0,m=l=f=0,n=0,k=!1,p=0,r=Box2D.Common.Math.b2Mat22.FromAngle(d),s=Box2D.Common.Math.b2Mat22.FromAngle(h);f=r;var n=this.m_localAnchor1.x-this.m_localCenterA.x,q=this.m_localAnchor1.y-this.m_localCenterA.y,l=f.col1.x*n+f.col2.x*q,q=f.col1.y*n+f.col2.y*q,n=l;f=s;s=this.m_localAnchor2.x-this.m_localCenterB.x;g=this.m_localAnchor2.y-this.m_localCenterB.y;l=f.col1.x*s+f.col2.x*g;g=f.col1.y*s+f.col2.y*g;s=l;f=e.x+s-c.x-n;l=e.y+g-c.y-q;if(this.m_enableLimit){this.m_axis=Box2D.Common.Math.b2Math.MulMV(r,
this.m_localXAxis1);this.m_a1=(f+n)*this.m_axis.y-(l+q)*this.m_axis.x;this.m_a2=s*this.m_axis.y-g*this.m_axis.x;var t=this.m_axis.x*f+this.m_axis.y*l;Math.abs(this.m_upperTranslation-this.m_lowerTranslation)<2*Box2D.Common.b2Settings.b2_linearSlop?(p=Box2D.Common.Math.b2Math.Clamp(t,-Box2D.Common.b2Settings.b2_maxLinearCorrection,Box2D.Common.b2Settings.b2_maxLinearCorrection),m=Math.abs(t),k=!0):t<=this.m_lowerTranslation?(p=Box2D.Common.Math.b2Math.Clamp(t-this.m_lowerTranslation+Box2D.Common.b2Settings.b2_linearSlop,
-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),m=this.m_lowerTranslation-t,k=!0):t>=this.m_upperTranslation&&(p=Box2D.Common.Math.b2Math.Clamp(t-this.m_upperTranslation+Box2D.Common.b2Settings.b2_linearSlop,0,Box2D.Common.b2Settings.b2_maxLinearCorrection),m=t-this.m_upperTranslation,k=!0)}this.m_perp=Box2D.Common.Math.b2Math.MulMV(r,this.m_localYAxis1);this.m_s1=(f+n)*this.m_perp.y-(l+q)*this.m_perp.x;this.m_s2=s*this.m_perp.y-g*this.m_perp.x;r=new Box2D.Common.Math.b2Vec3(0,0,0);q=this.m_perp.x*
f+this.m_perp.y*l;s=h-d-this.m_refAngle;m=Math.max(m,Math.abs(q));n=Math.abs(s);k?(k=this.m_invMassA,g=this.m_invMassB,f=this.m_invIA,l=this.m_invIB,this.m_K.col1.x=k+g+f*this.m_s1*this.m_s1+l*this.m_s2*this.m_s2,this.m_K.col1.y=f*this.m_s1+l*this.m_s2,this.m_K.col1.z=f*this.m_s1*this.m_a1+l*this.m_s2*this.m_a2,this.m_K.col2.x=this.m_K.col1.y,this.m_K.col2.y=f+l,this.m_K.col2.z=f*this.m_a1+l*this.m_a2,this.m_K.col3.x=this.m_K.col1.z,this.m_K.col3.y=this.m_K.col2.z,this.m_K.col3.z=k+g+f*this.m_a1*
this.m_a1+l*this.m_a2*this.m_a2,this.m_K.Solve33(r,-q,-s,-p)):(k=this.m_invMassA,g=this.m_invMassB,f=this.m_invIA,l=this.m_invIB,p=f*this.m_s1+l*this.m_s2,t=f+l,this.m_K.col1.Set(k+g+f*this.m_s1*this.m_s1+l*this.m_s2*this.m_s2,p,0),this.m_K.col2.Set(p,t,0),p=this.m_K.Solve22(Box2D.Common.Math.b2Vec2.Get(0,0),-q,-s),r.x=p.x,r.y=p.y,r.z=0);p=r.x*this.m_perp.x+r.z*this.m_axis.x;k=r.x*this.m_perp.y+r.z*this.m_axis.y;q=r.x*this.m_s1+r.y+r.z*this.m_a1;r=r.x*this.m_s2+r.y+r.z*this.m_a2;c.x-=this.m_invMassA*
p;c.y-=this.m_invMassA*k;d-=this.m_invIA*q;e.x+=this.m_invMassB*p;e.y+=this.m_invMassB*k;h+=this.m_invIB*r;a.m_sweep.a=d;b.m_sweep.a=h;a.SynchronizeTransform();b.SynchronizeTransform();return m<=Box2D.Common.b2Settings.b2_linearSlop&&n<=Box2D.Common.b2Settings.b2_angularSlop};Box2D.Dynamics.Joints.b2PrismaticJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAxisA=Box2D.Common.Math.b2Vec2.Get(0,
0);this.type=Box2D.Dynamics.Joints.b2Joint.e_prismaticJoint;this.localAxisA.Set(1,0);this.referenceAngle=0;this.enableLimit=!1;this.upperTranslation=this.lowerTranslation=0;this.enableMotor=!1;this.motorSpeed=this.maxMotorForce=0};c2inherit(Box2D.Dynamics.Joints.b2PrismaticJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2PrismaticJointDef.prototype.Initialize=function(a,b,c,d){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);
this.localAxisA=this.bodyA.GetLocalVector(d);this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2PrismaticJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2PrismaticJoint(this)};Box2D.Dynamics.Joints.b2PulleyJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_groundAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_groundAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=
Box2D.Common.Math.b2Vec2.Get(0,0);this.m_u1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_u2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_ground=this.m_bodyA.m_world.m_groundBody;this.m_groundAnchor1.x=a.groundAnchorA.x-this.m_ground.m_xf.position.x;this.m_groundAnchor1.y=a.groundAnchorA.y-this.m_ground.m_xf.position.y;this.m_groundAnchor2.x=a.groundAnchorB.x-this.m_ground.m_xf.position.x;this.m_groundAnchor2.y=a.groundAnchorB.y-this.m_ground.m_xf.position.y;this.m_localAnchor1.SetV(a.localAnchorA);this.m_localAnchor2.SetV(a.localAnchorB);
this.m_ratio=a.ratio;this.m_constant=a.lengthA+this.m_ratio*a.lengthB;this.m_maxLength1=Math.min(a.maxLengthA,this.m_constant-this.m_ratio*Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength);this.m_maxLength2=Math.min(a.maxLengthB,(this.m_constant-Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength)/this.m_ratio);this.m_limitImpulse2=this.m_limitImpulse1=this.m_impulse=0};c2inherit(Box2D.Dynamics.Joints.b2PulleyJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse*this.m_u2.x,a*this.m_impulse*this.m_u2.y)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetReactionTorque=function(a){return 0};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetGroundAnchorA=
function(){var a=this.m_ground.m_xf.position.Copy();a.Add(this.m_groundAnchor1);return a};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetGroundAnchorB=function(){var a=this.m_ground.m_xf.position.Copy();a.Add(this.m_groundAnchor2);return a};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetLength1=function(){var a=this.m_bodyA.GetWorldPoint(this.m_localAnchor1),b=a.x-(this.m_ground.m_xf.position.x+this.m_groundAnchor1.x),a=a.y-(this.m_ground.m_xf.position.y+this.m_groundAnchor1.y);return Math.sqrt(b*
b+a*a)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetLength2=function(){var a=this.m_bodyB.GetWorldPoint(this.m_localAnchor2),b=a.x-(this.m_ground.m_xf.position.x+this.m_groundAnchor2.x),a=a.y-(this.m_ground.m_xf.position.y+this.m_groundAnchor2.y);return Math.sqrt(b*b+a*a)};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.GetRatio=function(){return this.m_ratio};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.InitVelocityConstraints=function(a){var b=this.m_bodyA,c=this.m_bodyB,d;d=b.m_xf.R;var e=
this.m_localAnchor1.x-b.m_sweep.localCenter.x,h=this.m_localAnchor1.y-b.m_sweep.localCenter.y,f=d.col1.x*e+d.col2.x*h,h=d.col1.y*e+d.col2.y*h,e=f;d=c.m_xf.R;var l=this.m_localAnchor2.x-c.m_sweep.localCenter.x,k=this.m_localAnchor2.y-c.m_sweep.localCenter.y,f=d.col1.x*l+d.col2.x*k,k=d.col1.y*l+d.col2.y*k,l=f;d=c.m_sweep.c.x+l;var f=c.m_sweep.c.y+k,g=this.m_ground.m_xf.position.x+this.m_groundAnchor2.x,m=this.m_ground.m_xf.position.y+this.m_groundAnchor2.y;this.m_u1.Set(b.m_sweep.c.x+e-(this.m_ground.m_xf.position.x+
this.m_groundAnchor1.x),b.m_sweep.c.y+h-(this.m_ground.m_xf.position.y+this.m_groundAnchor1.y));this.m_u2.Set(d-g,f-m);d=this.m_u1.Length();f=this.m_u2.Length();d>Box2D.Common.b2Settings.b2_linearSlop?this.m_u1.Multiply(1/d):this.m_u1.SetZero();f>Box2D.Common.b2Settings.b2_linearSlop?this.m_u2.Multiply(1/f):this.m_u2.SetZero();0<this.m_constant-d-this.m_ratio*f?(this.m_state=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse=0):this.m_state=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit;d<
this.m_maxLength1?(this.m_limitState1=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_limitImpulse1=0):this.m_limitState1=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit;f<this.m_maxLength2?(this.m_limitState2=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_limitImpulse2=0):this.m_limitState2=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit;d=e*this.m_u1.y-h*this.m_u1.x;f=l*this.m_u2.y-k*this.m_u2.x;this.m_limitMass1=b.m_invMass+b.m_invI*d*d;this.m_limitMass2=c.m_invMass+c.m_invI*f*f;this.m_pulleyMass=
this.m_limitMass1+this.m_ratio*this.m_ratio*this.m_limitMass2;this.m_limitMass1=1/this.m_limitMass1;this.m_limitMass2=1/this.m_limitMass2;this.m_pulleyMass=1/this.m_pulleyMass;a.warmStarting?(this.m_impulse*=a.dtRatio,this.m_limitImpulse1*=a.dtRatio,this.m_limitImpulse2*=a.dtRatio,a=(-this.m_impulse-this.m_limitImpulse1)*this.m_u1.x,d=(-this.m_impulse-this.m_limitImpulse1)*this.m_u1.y,f=(-this.m_ratio*this.m_impulse-this.m_limitImpulse2)*this.m_u2.x,g=(-this.m_ratio*this.m_impulse-this.m_limitImpulse2)*
this.m_u2.y,b.m_linearVelocity.x+=b.m_invMass*a,b.m_linearVelocity.y+=b.m_invMass*d,b.m_angularVelocity+=b.m_invI*(e*d-h*a),c.m_linearVelocity.x+=c.m_invMass*f,c.m_linearVelocity.y+=c.m_invMass*g,c.m_angularVelocity+=c.m_invI*(l*g-k*f)):this.m_limitImpulse2=this.m_limitImpulse1=this.m_impulse=0};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.SolveVelocityConstraints=function(a){a=this.m_bodyA;var b=this.m_bodyB,c;c=a.m_xf.R;var d=this.m_localAnchor1.x-a.m_sweep.localCenter.x,e=this.m_localAnchor1.y-
a.m_sweep.localCenter.y,h=c.col1.x*d+c.col2.x*e,e=c.col1.y*d+c.col2.y*e,d=h;c=b.m_xf.R;var f=this.m_localAnchor2.x-b.m_sweep.localCenter.x,l=this.m_localAnchor2.y-b.m_sweep.localCenter.y,h=c.col1.x*f+c.col2.x*l,l=c.col1.y*f+c.col2.y*l,f=h,k=h=c=0,g=0;c=g=c=g=k=h=c=0;this.m_state==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_linearVelocity.x+-a.m_angularVelocity*e,h=a.m_linearVelocity.y+a.m_angularVelocity*d,k=b.m_linearVelocity.x+-b.m_angularVelocity*l,g=b.m_linearVelocity.y+b.m_angularVelocity*
f,c=-(this.m_u1.x*c+this.m_u1.y*h)-this.m_ratio*(this.m_u2.x*k+this.m_u2.y*g),g=this.m_pulleyMass*-c,c=this.m_impulse,this.m_impulse=Math.max(0,this.m_impulse+g),g=this.m_impulse-c,c=-g*this.m_u1.x,h=-g*this.m_u1.y,k=-this.m_ratio*g*this.m_u2.x,g=-this.m_ratio*g*this.m_u2.y,a.m_linearVelocity.x+=a.m_invMass*c,a.m_linearVelocity.y+=a.m_invMass*h,a.m_angularVelocity+=a.m_invI*(d*h-e*c),b.m_linearVelocity.x+=b.m_invMass*k,b.m_linearVelocity.y+=b.m_invMass*g,b.m_angularVelocity+=b.m_invI*(f*g-l*k));this.m_limitState1==
Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_linearVelocity.x+-a.m_angularVelocity*e,h=a.m_linearVelocity.y+a.m_angularVelocity*d,c=-(this.m_u1.x*c+this.m_u1.y*h),g=-this.m_limitMass1*c,c=this.m_limitImpulse1,this.m_limitImpulse1=Math.max(0,this.m_limitImpulse1+g),g=this.m_limitImpulse1-c,c=-g*this.m_u1.x,h=-g*this.m_u1.y,a.m_linearVelocity.x+=a.m_invMass*c,a.m_linearVelocity.y+=a.m_invMass*h,a.m_angularVelocity+=a.m_invI*(d*h-e*c));this.m_limitState2==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&
(k=b.m_linearVelocity.x+-b.m_angularVelocity*l,g=b.m_linearVelocity.y+b.m_angularVelocity*f,c=-(this.m_u2.x*k+this.m_u2.y*g),g=-this.m_limitMass2*c,c=this.m_limitImpulse2,this.m_limitImpulse2=Math.max(0,this.m_limitImpulse2+g),g=this.m_limitImpulse2-c,k=-g*this.m_u2.x,g=-g*this.m_u2.y,b.m_linearVelocity.x+=b.m_invMass*k,b.m_linearVelocity.y+=b.m_invMass*g,b.m_angularVelocity+=b.m_invI*(f*g-l*k))};Box2D.Dynamics.Joints.b2PulleyJoint.prototype.SolvePositionConstraints=function(a){a=this.m_bodyA;var b=
this.m_bodyB,c,d=this.m_ground.m_xf.position.x+this.m_groundAnchor1.x,e=this.m_ground.m_xf.position.y+this.m_groundAnchor1.y,h=this.m_ground.m_xf.position.x+this.m_groundAnchor2.x,f=this.m_ground.m_xf.position.y+this.m_groundAnchor2.y,l=0,k=0,g=0,m=0,n=c=0,p=0,r=0,s=n=r=c=n=c=0;this.m_state==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_xf.R,l=this.m_localAnchor1.x-a.m_sweep.localCenter.x,k=this.m_localAnchor1.y-a.m_sweep.localCenter.y,n=c.col1.x*l+c.col2.x*k,k=c.col1.y*l+c.col2.y*k,l=n,c=
b.m_xf.R,g=this.m_localAnchor2.x-b.m_sweep.localCenter.x,m=this.m_localAnchor2.y-b.m_sweep.localCenter.y,n=c.col1.x*g+c.col2.x*m,m=c.col1.y*g+c.col2.y*m,g=n,c=a.m_sweep.c.x+l,n=a.m_sweep.c.y+k,p=b.m_sweep.c.x+g,r=b.m_sweep.c.y+m,this.m_u1.Set(c-d,n-e),this.m_u2.Set(p-h,r-f),c=this.m_u1.Length(),n=this.m_u2.Length(),c>Box2D.Common.b2Settings.b2_linearSlop?this.m_u1.Multiply(1/c):this.m_u1.SetZero(),n>Box2D.Common.b2Settings.b2_linearSlop?this.m_u2.Multiply(1/n):this.m_u2.SetZero(),c=this.m_constant-
c-this.m_ratio*n,s=Math.max(s,-c),c=Box2D.Common.Math.b2Math.Clamp(c+Box2D.Common.b2Settings.b2_linearSlop,-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),r=-this.m_pulleyMass*c,c=-r*this.m_u1.x,n=-r*this.m_u1.y,p=-this.m_ratio*r*this.m_u2.x,r=-this.m_ratio*r*this.m_u2.y,a.m_sweep.c.x+=a.m_invMass*c,a.m_sweep.c.y+=a.m_invMass*n,a.m_sweep.a+=a.m_invI*(l*n-k*c),b.m_sweep.c.x+=b.m_invMass*p,b.m_sweep.c.y+=b.m_invMass*r,b.m_sweep.a+=b.m_invI*(g*r-m*p),a.SynchronizeTransform(),b.SynchronizeTransform());
this.m_limitState1==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=a.m_xf.R,l=this.m_localAnchor1.x-a.m_sweep.localCenter.x,k=this.m_localAnchor1.y-a.m_sweep.localCenter.y,n=c.col1.x*l+c.col2.x*k,k=c.col1.y*l+c.col2.y*k,l=n,c=a.m_sweep.c.x+l,n=a.m_sweep.c.y+k,this.m_u1.Set(c-d,n-e),c=this.m_u1.Length(),c>Box2D.Common.b2Settings.b2_linearSlop?(this.m_u1.x*=1/c,this.m_u1.y*=1/c):this.m_u1.SetZero(),c=this.m_maxLength1-c,s=Math.max(s,-c),c=Box2D.Common.Math.b2Math.Clamp(c+Box2D.Common.b2Settings.b2_linearSlop,
-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),r=-this.m_limitMass1*c,c=-r*this.m_u1.x,n=-r*this.m_u1.y,a.m_sweep.c.x+=a.m_invMass*c,a.m_sweep.c.y+=a.m_invMass*n,a.m_sweep.a+=a.m_invI*(l*n-k*c),a.SynchronizeTransform());this.m_limitState2==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(c=b.m_xf.R,g=this.m_localAnchor2.x-b.m_sweep.localCenter.x,m=this.m_localAnchor2.y-b.m_sweep.localCenter.y,n=c.col1.x*g+c.col2.x*m,m=c.col1.y*g+c.col2.y*m,g=n,p=b.m_sweep.c.x+g,r=b.m_sweep.c.y+m,this.m_u2.Set(p-
h,r-f),n=this.m_u2.Length(),n>Box2D.Common.b2Settings.b2_linearSlop?(this.m_u2.x*=1/n,this.m_u2.y*=1/n):this.m_u2.SetZero(),c=this.m_maxLength2-n,s=Math.max(s,-c),c=Box2D.Common.Math.b2Math.Clamp(c+Box2D.Common.b2Settings.b2_linearSlop,-Box2D.Common.b2Settings.b2_maxLinearCorrection,0),r=-this.m_limitMass2*c,p=-r*this.m_u2.x,r=-r*this.m_u2.y,b.m_sweep.c.x+=b.m_invMass*p,b.m_sweep.c.y+=b.m_invMass*r,b.m_sweep.a+=b.m_invI*(g*r-m*p),b.SynchronizeTransform());return s<Box2D.Common.b2Settings.b2_linearSlop};
Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength=1;Box2D.Dynamics.Joints.b2PulleyJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.groundAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.groundAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_pulleyJoint;this.groundAnchorA.Set(-1,1);this.groundAnchorB.Set(1,1);this.localAnchorA.Set(-1,0);this.localAnchorB.Set(1,
0);this.maxLengthB=this.lengthB=this.maxLengthA=this.lengthA=0;this.ratio=1;this.collideConnected=!0};c2inherit(Box2D.Dynamics.Joints.b2PulleyJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2PulleyJointDef.prototype.Initialize=function(a,b,c,d,e,h,f){void 0===f&&(f=0);this.bodyA=a;this.bodyB=b;this.groundAnchorA.SetV(c);this.groundAnchorB.SetV(d);this.localAnchorA=this.bodyA.GetLocalPoint(e);this.localAnchorB=this.bodyB.GetLocalPoint(h);a=e.x-c.x;c=e.y-c.y;this.lengthA=Math.sqrt(a*
a+c*c);c=h.x-d.x;d=h.y-d.y;this.lengthB=Math.sqrt(c*c+d*d);this.ratio=f;f=this.lengthA+this.ratio*this.lengthB;this.maxLengthA=f-this.ratio*Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength;this.maxLengthB=(f-Box2D.Dynamics.Joints.b2PulleyJoint.b2_minPulleyLength)/this.ratio};Box2D.Dynamics.Joints.b2PulleyJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2PulleyJoint(this)};Box2D.Dynamics.Joints.b2RevoluteJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.K=
new Box2D.Common.Math.b2Mat22;this.K1=new Box2D.Common.Math.b2Mat22;this.K2=new Box2D.Common.Math.b2Mat22;this.K3=new Box2D.Common.Math.b2Mat22;this.impulse3=new Box2D.Common.Math.b2Vec3(0,0,0);this.impulse2=Box2D.Common.Math.b2Vec2.Get(0,0);this.reduced=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor1=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchor2=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_impulse=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass=new Box2D.Common.Math.b2Mat33;this.m_localAnchor1.SetV(a.localAnchorA);
this.m_localAnchor2.SetV(a.localAnchorB);this.m_referenceAngle=a.referenceAngle;this.m_impulse.SetZero();this.m_motorImpulse=0;this.m_lowerAngle=a.lowerAngle;this.m_upperAngle=a.upperAngle;this.m_maxMotorTorque=a.maxMotorTorque;this.m_motorSpeed=a.motorSpeed;this.m_enableLimit=a.enableLimit;this.m_enableMotor=a.enableMotor;this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit};c2inherit(Box2D.Dynamics.Joints.b2RevoluteJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetAnchorA=
function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchor1)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchor2)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetReactionForce=function(a){void 0===a&&(a=0);return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse.x,a*this.m_impulse.y)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetReactionTorque=function(a){void 0===a&&(a=0);return a*this.m_impulse.z};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetJointAngle=
function(){return this.m_bodyB.m_sweep.a-this.m_bodyA.m_sweep.a-this.m_referenceAngle};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetJointSpeed=function(){return this.m_bodyB.m_angularVelocity-this.m_bodyA.m_angularVelocity};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.IsLimitEnabled=function(){return this.m_enableLimit};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.EnableLimit=function(a){this.m_enableLimit=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetLowerLimit=function(){return this.m_lowerAngle};
Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetUpperLimit=function(){return this.m_upperAngle};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SetLimits=function(a,b){void 0===a&&(a=0);void 0===b&&(b=0);this.m_lowerAngle=a;this.m_upperAngle=b};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.IsMotorEnabled=function(){this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);return this.m_enableMotor};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.EnableMotor=function(a){this.m_enableMotor=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SetMotorSpeed=
function(a){void 0===a&&(a=0);this.m_bodyA.SetAwake(!0);this.m_bodyB.SetAwake(!0);this.m_motorSpeed=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetMotorSpeed=function(){return this.m_motorSpeed};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SetMaxMotorTorque=function(a){void 0===a&&(a=0);this.m_maxMotorTorque=a};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.GetMotorTorque=function(){return this.m_maxMotorTorque};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.InitVelocityConstraints=function(a){var b=
this.m_bodyA,c=this.m_bodyB,d,e=0;d=b.m_xf.R;var h=this.m_localAnchor1.x-b.m_sweep.localCenter.x,f=this.m_localAnchor1.y-b.m_sweep.localCenter.y,e=d.col1.x*h+d.col2.x*f,f=d.col1.y*h+d.col2.y*f,h=e;d=c.m_xf.R;var l=this.m_localAnchor2.x-c.m_sweep.localCenter.x,k=this.m_localAnchor2.y-c.m_sweep.localCenter.y,e=d.col1.x*l+d.col2.x*k,k=d.col1.y*l+d.col2.y*k,l=e;d=b.m_invMass;var e=c.m_invMass,g=b.m_invI,m=c.m_invI;this.m_mass.col1.x=d+e+f*f*g+k*k*m;this.m_mass.col2.x=-f*h*g-k*l*m;this.m_mass.col3.x=-f*
g-k*m;this.m_mass.col1.y=this.m_mass.col2.x;this.m_mass.col2.y=d+e+h*h*g+l*l*m;this.m_mass.col3.y=h*g+l*m;this.m_mass.col1.z=this.m_mass.col3.x;this.m_mass.col2.z=this.m_mass.col3.y;this.m_mass.col3.z=g+m;this.m_motorMass=1/(g+m);this.m_enableMotor||(this.m_motorImpulse=0);if(this.m_enableLimit){var n=c.m_sweep.a-b.m_sweep.a-this.m_referenceAngle;Math.abs(this.m_upperAngle-this.m_lowerAngle)<2*Box2D.Common.b2Settings.b2_angularSlop?this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_equalLimits:n<=
this.m_lowerAngle?(this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit&&(this.m_impulse.z=0),this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit):n>=this.m_upperAngle?(this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(this.m_impulse.z=0),this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit):(this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit,this.m_impulse.z=0)}else this.m_limitState=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit;a.warmStarting?
(this.m_impulse.x*=a.dtRatio,this.m_impulse.y*=a.dtRatio,this.m_motorImpulse*=a.dtRatio,a=this.m_impulse.x,n=this.m_impulse.y,b.m_linearVelocity.x-=d*a,b.m_linearVelocity.y-=d*n,b.m_angularVelocity-=g*(h*n-f*a+this.m_motorImpulse+this.m_impulse.z),c.m_linearVelocity.x+=e*a,c.m_linearVelocity.y+=e*n,c.m_angularVelocity+=m*(l*n-k*a+this.m_motorImpulse+this.m_impulse.z)):(this.m_impulse.SetZero(),this.m_motorImpulse=0)};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SolveVelocityConstraints=function(a){var b=
this.m_bodyA,c=this.m_bodyB,d=0,e=d=0,h=0,f=0,l=0,k=b.m_linearVelocity,g=b.m_angularVelocity,m=c.m_linearVelocity,n=c.m_angularVelocity,p=b.m_invMass,r=c.m_invMass,s=b.m_invI,q=c.m_invI;this.m_enableMotor&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_equalLimits&&(e=this.m_motorMass*-(n-g-this.m_motorSpeed),h=this.m_motorImpulse,f=a.dt*this.m_maxMotorTorque,this.m_motorImpulse=Box2D.Common.Math.b2Math.Clamp(this.m_motorImpulse+e,-f,f),e=this.m_motorImpulse-h,g-=s*e,n+=q*e);if(this.m_enableLimit&&
this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit){a=b.m_xf.R;e=this.m_localAnchor1.x-b.m_sweep.localCenter.x;h=this.m_localAnchor1.y-b.m_sweep.localCenter.y;d=a.col1.x*e+a.col2.x*h;h=a.col1.y*e+a.col2.y*h;e=d;a=c.m_xf.R;f=this.m_localAnchor2.x-c.m_sweep.localCenter.x;l=this.m_localAnchor2.y-c.m_sweep.localCenter.y;d=a.col1.x*f+a.col2.x*l;l=a.col1.y*f+a.col2.y*l;f=d;a=m.x+-n*l-k.x- -g*h;var t=m.y+n*f-k.y-g*e;this.m_mass.Solve33(this.impulse3,-a,-t,-(n-g));this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_equalLimits?
this.m_impulse.Add(this.impulse3):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?(d=this.m_impulse.z+this.impulse3.z,0>d&&(this.m_mass.Solve22(this.reduced,-a,-t),this.impulse3.x=this.reduced.x,this.impulse3.y=this.reduced.y,this.impulse3.z=-this.m_impulse.z,this.m_impulse.x+=this.reduced.x,this.m_impulse.y+=this.reduced.y,this.m_impulse.z=0)):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(d=this.m_impulse.z+this.impulse3.z,0<d&&(this.m_mass.Solve22(this.reduced,
-a,-t),this.impulse3.x=this.reduced.x,this.impulse3.y=this.reduced.y,this.impulse3.z=-this.m_impulse.z,this.m_impulse.x+=this.reduced.x,this.m_impulse.y+=this.reduced.y,this.m_impulse.z=0));k.x-=p*this.impulse3.x;k.y-=p*this.impulse3.y;g-=s*(e*this.impulse3.y-h*this.impulse3.x+this.impulse3.z);m.x+=r*this.impulse3.x;m.y+=r*this.impulse3.y;n+=q*(f*this.impulse3.y-l*this.impulse3.x+this.impulse3.z)}else a=b.m_xf.R,e=this.m_localAnchor1.x-b.m_sweep.localCenter.x,h=this.m_localAnchor1.y-b.m_sweep.localCenter.y,
d=a.col1.x*e+a.col2.x*h,h=a.col1.y*e+a.col2.y*h,e=d,a=c.m_xf.R,f=this.m_localAnchor2.x-c.m_sweep.localCenter.x,l=this.m_localAnchor2.y-c.m_sweep.localCenter.y,d=a.col1.x*f+a.col2.x*l,l=a.col1.y*f+a.col2.y*l,f=d,this.m_mass.Solve22(this.impulse2,-(m.x+-n*l-k.x- -g*h),-(m.y+n*f-k.y-g*e)),this.m_impulse.x+=this.impulse2.x,this.m_impulse.y+=this.impulse2.y,k.x-=p*this.impulse2.x,k.y-=p*this.impulse2.y,g-=s*(e*this.impulse2.y-h*this.impulse2.x),m.x+=r*this.impulse2.x,m.y+=r*this.impulse2.y,n+=q*(f*this.impulse2.y-
l*this.impulse2.x);b.m_linearVelocity.SetV(k);b.m_angularVelocity=g;c.m_linearVelocity.SetV(m);c.m_angularVelocity=n};Box2D.Dynamics.Joints.b2RevoluteJoint.prototype.SolvePositionConstraints=function(a){var b=0,c;a=this.m_bodyA;var d=this.m_bodyB,e=0,h=c=0,f=0,l=0;if(this.m_enableLimit&&this.m_limitState!=Box2D.Dynamics.Joints.b2Joint.e_inactiveLimit){var b=d.m_sweep.a-a.m_sweep.a-this.m_referenceAngle,k=0;this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_equalLimits?(b=Box2D.Common.Math.b2Math.Clamp(b-
this.m_lowerAngle,-Box2D.Common.b2Settings.b2_maxAngularCorrection,Box2D.Common.b2Settings.b2_maxAngularCorrection),k=-this.m_motorMass*b,e=Math.abs(b)):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atLowerLimit?(b-=this.m_lowerAngle,e=-b,b=Box2D.Common.Math.b2Math.Clamp(b+Box2D.Common.b2Settings.b2_angularSlop,-Box2D.Common.b2Settings.b2_maxAngularCorrection,0),k=-this.m_motorMass*b):this.m_limitState==Box2D.Dynamics.Joints.b2Joint.e_atUpperLimit&&(e=b-=this.m_upperAngle,b=Box2D.Common.Math.b2Math.Clamp(b-
Box2D.Common.b2Settings.b2_angularSlop,0,Box2D.Common.b2Settings.b2_maxAngularCorrection),k=-this.m_motorMass*b);a.m_sweep.a-=a.m_invI*k;d.m_sweep.a+=d.m_invI*k;a.SynchronizeTransform();d.SynchronizeTransform()}c=a.m_xf.R;k=this.m_localAnchor1.x-a.m_sweep.localCenter.x;b=this.m_localAnchor1.y-a.m_sweep.localCenter.y;h=c.col1.x*k+c.col2.x*b;b=c.col1.y*k+c.col2.y*b;k=h;c=d.m_xf.R;var g=this.m_localAnchor2.x-d.m_sweep.localCenter.x,m=this.m_localAnchor2.y-d.m_sweep.localCenter.y,h=c.col1.x*g+c.col2.x*
m,m=c.col1.y*g+c.col2.y*m,g=h,f=d.m_sweep.c.x+g-a.m_sweep.c.x-k,l=d.m_sweep.c.y+m-a.m_sweep.c.y-b,n=f*f+l*l;c=Math.sqrt(n);var h=a.m_invMass,p=d.m_invMass,r=a.m_invI,s=d.m_invI,q=10*Box2D.Common.b2Settings.b2_linearSlop;n>q*q&&(n=1/(h+p),f=n*-f,l=n*-l,a.m_sweep.c.x-=0.5*h*f,a.m_sweep.c.y-=0.5*h*l,d.m_sweep.c.x+=0.5*p*f,d.m_sweep.c.y+=0.5*p*l,f=d.m_sweep.c.x+g-a.m_sweep.c.x-k,l=d.m_sweep.c.y+m-a.m_sweep.c.y-b);this.K1.col1.x=h+p;this.K1.col2.x=0;this.K1.col1.y=0;this.K1.col2.y=h+p;this.K2.col1.x=r*
b*b;this.K2.col2.x=-r*k*b;this.K2.col1.y=-r*k*b;this.K2.col2.y=r*k*k;this.K3.col1.x=s*m*m;this.K3.col2.x=-s*g*m;this.K3.col1.y=-s*g*m;this.K3.col2.y=s*g*g;this.K.SetM(this.K1);this.K.AddM(this.K2);this.K.AddM(this.K3);this.K.Solve(Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse,-f,-l);f=Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse.x;l=Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse.y;a.m_sweep.c.x-=a.m_invMass*f;a.m_sweep.c.y-=a.m_invMass*l;a.m_sweep.a-=a.m_invI*(k*l-b*f);d.m_sweep.c.x+=d.m_invMass*
f;d.m_sweep.c.y+=d.m_invMass*l;d.m_sweep.a+=d.m_invI*(g*l-m*f);a.SynchronizeTransform();d.SynchronizeTransform();return c<=Box2D.Common.b2Settings.b2_linearSlop&&e<=Box2D.Common.b2Settings.b2_angularSlop};Box2D.Dynamics.Joints.b2RevoluteJoint.tImpulse=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Dynamics.Joints.b2RevoluteJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_revoluteJoint;
this.localAnchorA.SetZero();this.localAnchorB.SetZero();this.motorSpeed=this.maxMotorTorque=this.upperAngle=this.lowerAngle=this.referenceAngle=0;this.enableMotor=this.enableLimit=!1};c2inherit(Box2D.Dynamics.Joints.b2RevoluteJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2RevoluteJointDef.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA=this.bodyA.GetLocalPoint(c);this.localAnchorB=this.bodyB.GetLocalPoint(c);this.referenceAngle=this.bodyB.GetAngle()-
this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2RevoluteJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2RevoluteJoint(this)};Box2D.Dynamics.Joints.b2WeldJoint=function(a){Box2D.Dynamics.Joints.b2Joint.call(this,a);this.m_localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.m_impulse=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass=new Box2D.Common.Math.b2Mat33;this.m_localAnchorA.SetV(a.localAnchorA);this.m_localAnchorB.SetV(a.localAnchorB);
this.m_referenceAngle=a.referenceAngle};c2inherit(Box2D.Dynamics.Joints.b2WeldJoint,Box2D.Dynamics.Joints.b2Joint);Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetAnchorA=function(){return this.m_bodyA.GetWorldPoint(this.m_localAnchorA)};Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetAnchorB=function(){return this.m_bodyB.GetWorldPoint(this.m_localAnchorB)};Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetReactionForce=function(a){return Box2D.Common.Math.b2Vec2.Get(a*this.m_impulse.x,a*this.m_impulse.y)};
Box2D.Dynamics.Joints.b2WeldJoint.prototype.GetReactionTorque=function(a){return a*this.m_impulse.z};Box2D.Dynamics.Joints.b2WeldJoint.prototype.InitVelocityConstraints=function(a){var b,c=0,d=this.m_bodyA,e=this.m_bodyB;b=d.m_xf.R;var h=this.m_localAnchorA.x-d.m_sweep.localCenter.x,f=this.m_localAnchorA.y-d.m_sweep.localCenter.y,c=b.col1.x*h+b.col2.x*f,f=b.col1.y*h+b.col2.y*f,h=c;b=e.m_xf.R;var l=this.m_localAnchorB.x-e.m_sweep.localCenter.x,k=this.m_localAnchorB.y-e.m_sweep.localCenter.y,c=b.col1.x*
l+b.col2.x*k,k=b.col1.y*l+b.col2.y*k,l=c;b=d.m_invMass;var c=e.m_invMass,g=d.m_invI,m=e.m_invI;this.m_mass.col1.x=b+c+f*f*g+k*k*m;this.m_mass.col2.x=-f*h*g-k*l*m;this.m_mass.col3.x=-f*g-k*m;this.m_mass.col1.y=this.m_mass.col2.x;this.m_mass.col2.y=b+c+h*h*g+l*l*m;this.m_mass.col3.y=h*g+l*m;this.m_mass.col1.z=this.m_mass.col3.x;this.m_mass.col2.z=this.m_mass.col3.y;this.m_mass.col3.z=g+m;a.warmStarting?(this.m_impulse.x*=a.dtRatio,this.m_impulse.y*=a.dtRatio,this.m_impulse.z*=a.dtRatio,d.m_linearVelocity.x-=
b*this.m_impulse.x,d.m_linearVelocity.y-=b*this.m_impulse.y,d.m_angularVelocity-=g*(h*this.m_impulse.y-f*this.m_impulse.x+this.m_impulse.z),e.m_linearVelocity.x+=c*this.m_impulse.x,e.m_linearVelocity.y+=c*this.m_impulse.y,e.m_angularVelocity+=m*(l*this.m_impulse.y-k*this.m_impulse.x+this.m_impulse.z)):this.m_impulse.SetZero()};Box2D.Dynamics.Joints.b2WeldJoint.prototype.SolveVelocityConstraints=function(a){var b,c=0;a=this.m_bodyA;var d=this.m_bodyB,e=a.m_linearVelocity,h=a.m_angularVelocity,f=d.m_linearVelocity,
l=d.m_angularVelocity,k=a.m_invMass,g=d.m_invMass,m=a.m_invI,n=d.m_invI;b=a.m_xf.R;var p=this.m_localAnchorA.x-a.m_sweep.localCenter.x,r=this.m_localAnchorA.y-a.m_sweep.localCenter.y,c=b.col1.x*p+b.col2.x*r,r=b.col1.y*p+b.col2.y*r,p=c;b=d.m_xf.R;var s=this.m_localAnchorB.x-d.m_sweep.localCenter.x,q=this.m_localAnchorB.y-d.m_sweep.localCenter.y,c=b.col1.x*s+b.col2.x*q,q=b.col1.y*s+b.col2.y*q,s=c;b=f.x-l*q-e.x+h*r;var c=f.y+l*s-e.y-h*p,t=l-h,u=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass.Solve33(u,
-b,-c,-t);this.m_impulse.Add(u);e.x-=k*u.x;e.y-=k*u.y;h-=m*(p*u.y-r*u.x+u.z);f.x+=g*u.x;f.y+=g*u.y;l+=n*(s*u.y-q*u.x+u.z);a.m_angularVelocity=h;d.m_angularVelocity=l};Box2D.Dynamics.Joints.b2WeldJoint.prototype.SolvePositionConstraints=function(a){var b,c=0;a=this.m_bodyA;var d=this.m_bodyB;b=a.m_xf.R;var e=this.m_localAnchorA.x-a.m_sweep.localCenter.x,h=this.m_localAnchorA.y-a.m_sweep.localCenter.y,c=b.col1.x*e+b.col2.x*h,h=b.col1.y*e+b.col2.y*h,e=c;b=d.m_xf.R;var f=this.m_localAnchorB.x-d.m_sweep.localCenter.x,
l=this.m_localAnchorB.y-d.m_sweep.localCenter.y,c=b.col1.x*f+b.col2.x*l,l=b.col1.y*f+b.col2.y*l,f=c;b=a.m_invMass;var c=d.m_invMass,k=a.m_invI,g=d.m_invI,m=d.m_sweep.c.x+f-a.m_sweep.c.x-e,n=d.m_sweep.c.y+l-a.m_sweep.c.y-h,p=d.m_sweep.a-a.m_sweep.a-this.m_referenceAngle,r=10*Box2D.Common.b2Settings.b2_linearSlop,s=Math.sqrt(m*m+n*n),q=Math.abs(p);s>r&&(k*=1,g*=1);this.m_mass.col1.x=b+c+h*h*k+l*l*g;this.m_mass.col2.x=-h*e*k-l*f*g;this.m_mass.col3.x=-h*k-l*g;this.m_mass.col1.y=this.m_mass.col2.x;this.m_mass.col2.y=
b+c+e*e*k+f*f*g;this.m_mass.col3.y=e*k+f*g;this.m_mass.col1.z=this.m_mass.col3.x;this.m_mass.col2.z=this.m_mass.col3.y;this.m_mass.col3.z=k+g;r=new Box2D.Common.Math.b2Vec3(0,0,0);this.m_mass.Solve33(r,-m,-n,-p);a.m_sweep.c.x-=b*r.x;a.m_sweep.c.y-=b*r.y;a.m_sweep.a-=k*(e*r.y-h*r.x+r.z);d.m_sweep.c.x+=c*r.x;d.m_sweep.c.y+=c*r.y;d.m_sweep.a+=g*(f*r.y-l*r.x+r.z);a.SynchronizeTransform();d.SynchronizeTransform();return s<=Box2D.Common.b2Settings.b2_linearSlop&&q<=Box2D.Common.b2Settings.b2_angularSlop};
Box2D.Dynamics.Joints.b2WeldJointDef=function(){Box2D.Dynamics.Joints.b2JointDef.call(this);this.localAnchorA=Box2D.Common.Math.b2Vec2.Get(0,0);this.localAnchorB=Box2D.Common.Math.b2Vec2.Get(0,0);this.type=Box2D.Dynamics.Joints.b2Joint.e_weldJoint;this.referenceAngle=0};c2inherit(Box2D.Dynamics.Joints.b2WeldJointDef,Box2D.Dynamics.Joints.b2JointDef);Box2D.Dynamics.Joints.b2WeldJointDef.prototype.Initialize=function(a,b,c){this.bodyA=a;this.bodyB=b;this.localAnchorA.SetV(this.bodyA.GetLocalPoint(c));
this.localAnchorB.SetV(this.bodyB.GetLocalPoint(c));this.referenceAngle=this.bodyB.GetAngle()-this.bodyA.GetAngle()};Box2D.Dynamics.Joints.b2WeldJointDef.prototype.Create=function(){return new Box2D.Dynamics.Joints.b2WeldJoint(this)};Box2D.Collision.b2Collision.s_incidentEdge=Box2D.Collision.b2Collision.MakeClipPointVector();Box2D.Collision.b2Collision.s_clipPoints1=Box2D.Collision.b2Collision.MakeClipPointVector();Box2D.Collision.b2Collision.s_clipPoints2=Box2D.Collision.b2Collision.MakeClipPointVector();
Box2D.Collision.b2Collision.s_localTangent=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_localNormal=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_planePoint=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_normal=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_tangent=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_tangent2=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2Collision.s_v11=Box2D.Common.Math.b2Vec2.Get(0,
0);Box2D.Collision.b2Collision.s_v12=Box2D.Common.Math.b2Vec2.Get(0,0);Box2D.Collision.b2TimeOfImpact.b2_toiCalls=0;Box2D.Collision.b2TimeOfImpact.b2_toiIters=0;Box2D.Collision.b2TimeOfImpact.b2_toiMaxIters=0;Box2D.Collision.b2TimeOfImpact.b2_toiRootIters=0;Box2D.Collision.b2TimeOfImpact.b2_toiMaxRootIters=0;Box2D.Collision.b2TimeOfImpact.s_cache=new Box2D.Collision.b2SimplexCache;Box2D.Collision.b2TimeOfImpact.s_distanceInput=new Box2D.Collision.b2DistanceInput;Box2D.Collision.b2TimeOfImpact.s_xfA=
new Box2D.Common.Math.b2Transform;Box2D.Collision.b2TimeOfImpact.s_xfB=new Box2D.Common.Math.b2Transform;Box2D.Collision.b2TimeOfImpact.s_fcn=new Box2D.Collision.b2SeparationFunction;Box2D.Collision.b2TimeOfImpact.s_distanceOutput=new Box2D.Collision.b2DistanceOutput;Box2D.Dynamics.b2Body.s_xf1=new Box2D.Common.Math.b2Transform;Box2D.Dynamics.b2ContactListener.b2_defaultListener=new Box2D.Dynamics.b2ContactListener;Box2D.Dynamics.b2ContactManager.s_evalCP=new Box2D.Collision.b2ContactPoint;Box2D.Dynamics.b2World.s_xf=
new Box2D.Common.Math.b2Transform;Box2D.Dynamics.b2World.s_backupA=new Box2D.Common.Math.b2Sweep;Box2D.Dynamics.b2World.s_backupB=new Box2D.Common.Math.b2Sweep;Box2D.Dynamics.Contacts.b2Contact.s_input=new Box2D.Collision.b2TOIInput;Box2D.Dynamics.Contacts.b2ContactSolver.s_worldManifold=new Box2D.Collision.b2WorldManifold;Box2D.Dynamics.Contacts.b2ContactSolver.s_psm=new Box2D.Dynamics.Contacts.b2PositionSolverManifold}cr.b2Separator=function(){};
cr.b2Separator.det=function(a,b,c,d,e,h){return a*d+c*h+e*b-b*c-d*e-h*a};cr.b2Separator.hitRay=function(a,b,c,d,e,h,f,l){var k=c-a,g=d-b,m=f-e,n=l-h,m=(m*(h-b)-n*(e-a))/(g*m-k*n),k=a+m*k,g=b+m*g;a=cr.b2Separator.isOnSegment(c,d,a,b,k,g);e=cr.b2Separator.isOnSegment(k,g,e,h,f,l);return a&&e?Box2D.Common.Math.b2Vec2.Get(k,g):null};
cr.b2Separator.isOnSegment=function(a,b,c,d,e,h){return(c+0.1>=a&&a>=e-0.1||c-0.1<=a&&a<=e+0.1)&&(d+0.1>=b&&b>=h-0.1||d-0.1<=b&&b<=h+0.1)&&cr.b2Separator.isOnLine(a,b,c,d,e,h)};cr.b2Separator.isOnLine=function(a,b,c,d,e,h){return 0.1<Math.abs(e-c)?0.1>Math.abs((h-d)/(e-c)*(a-c)+d-b):0.1>Math.abs(a-c)};cr.b2Separator.pointsMatch=function(a,b,c,d){return 0.1>Math.abs(c-a)&&0.1>Math.abs(d-b)};
cr.b2Separator.Separate=function(a,b){var c=Box2D.Common.Math.b2Vec2,d=cr.b2Separator.calcShapes(a),e=[],h,f,l,k,g,m,n,p,r;g=0;for(m=d.length;g<m;g++){f=d[g];h=[];h.length=f.length;n=r=0;for(p=f.length;n<p;n++)l=f[n],k=f[(n+1)%p],r+=l.x*k.y-l.y*k.x,h[n]=c.Get(l.x,l.y);r=Math.abs(r/2);r>=0.001*b&&e.push(h)}return e};
cr.b2Separator.calcShapes=function(a){var b=[],c=0,d=0,e=0,h=0,f=0,l=f=0,k=0,g=0,m=0,h=0,n,p,r,s=h=c=0,q=0,e=[],k=[],t=!1,u=[],C=[];for(C.push(a);C.length;){b=C[0];d=b.length;t=!0;for(c=0;c<d;c++)if(g=c,m=c<d-1?c+1:c+1-d,h=c<d-2?c+2:c+2-d,a=b[g],n=b[m],h=b[h],h=cr.b2Separator.det(a.x,a.y,n.x,n.y,h.x,h.y),0>h){t=!1;k=1E9;for(e=0;e<d;e++)e!==g&&e!==m&&(c=e,h=e<d-1?e+1:0,f=b[c],l=b[h],p=cr.b2Separator.hitRay(a.x,a.y,n.x,n.y,f.x,f.y,l.x,l.y))&&(f=n.x-p.x,l=n.y-p.y,f=f*f+l*l,f<k&&(q=c,s=h,r=p,k=f));if(1E9===
k)return[];e=[];k=[];c=q;h=s;f=b[c];l=b[h];cr.b2Separator.pointsMatch(r.x,r.y,l.x,l.y)||e.push(r);cr.b2Separator.pointsMatch(r.x,r.y,f.x,f.y)||k.push(r);q=-1;for(s=g;;){if(s!==h)e.push(b[s]);else{if(0>q||q>=d)return[];cr.b2Separator.isOnSegment(l.x,l.y,b[q].x,b[q].y,a.x,a.y)||e.push(b[s]);break}q=s;0>s-1?s=d-1:s--}e.reverse();q=-1;for(s=m;;){if(s!==c)k.push(b[s]);else{if(0>q||q>=d)return[];s!==c||cr.b2Separator.isOnSegment(f.x,f.y,b[q].x,b[q].y,n.x,n.y)||k.push(b[s]);break}q=s;s+1>d-1?s=0:s++}C.push(e,
k);C.shift();break}t&&u.push(C.shift())}return u};
cr.behaviors.Physics=function(a){for(var b=0;4E3>b;b++)Box2D.Common.Math.b2Vec2._freeCache.push(new Box2D.Common.Math.b2Vec2(0,0));this.runtime=a;this.world=new Box2D.Dynamics.b2World(Box2D.Common.Math.b2Vec2.Get(0,10),!0);this.worldG=10;this.lastUpdateTick=-1;a=new Box2D.Dynamics.b2ContactListener;a.behavior=this;a.BeginContact=function(a){var b=a.m_fixtureA.GetBody().c2userdata;a=a.m_fixtureB.GetBody().c2userdata;this.behavior.runtime.registerCollision(b.inst,a.inst)};this.world.SetContactListener(a);
a=new Box2D.Dynamics.b2ContactFilter;a.behavior=this;a.ShouldCollide=function(a,b){if(this.behavior.allCollisionsEnabled)return!0;var e=a.GetBody().c2userdata.inst.type,h=b.GetBody().c2userdata.inst.type,f=e.extra.Physics_DisabledCollisions;return f&&f.contains(h)?!1:(f=h.extra.Physics_DisabledCollisions)&&f.contains(e)?!1:!0};this.world.SetContactFilter(a);this.steppingMode=0;this.velocityIterations=8;this.positionIterations=3;this.allCollisionsEnabled=!0};
(function(){function a(){}function b(){}function c(a,b,c){c?((c=a.extra.Physics_DisabledCollisions)&&c.remove(b),(c=b.extra.Physics_DisabledCollisions)&&c.remove(a)):(a.extra.Physics_DisabledCollisions||(a.extra.Physics_DisabledCollisions=new cr.ObjectSet),a.extra.Physics_DisabledCollisions.add(b),b.extra.Physics_DisabledCollisions||(b.extra.Physics_DisabledCollisions=new cr.ObjectSet),b.extra.Physics_DisabledCollisions.add(a))}function d(){}var e=Box2D.Common.Math.b2Vec2,h=Box2D.Dynamics.b2BodyDef,
f=Box2D.Dynamics.b2FixtureDef,l=Box2D.Collision.Shapes.b2PolygonShape,k=Box2D.Collision.Shapes.b2CircleShape,g=Box2D.Dynamics.Joints.b2DistanceJointDef,m=Box2D.Dynamics.Joints.b2RevoluteJointDef,n=cr.behaviors.Physics.prototype;n.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};n.Type.prototype.onCreate=function(){};n.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime;this.world=this.behavior.world};var p=n.Instance.prototype;p.onCreate=
function(){this.immovable=0!==this.properties[0];this.collisionmask=this.properties[1];this.preventRotation=0!==this.properties[2];this.density=this.properties[3];this.friction=this.properties[4];this.restitution=this.properties[5];this.linearDamping=this.properties[6];this.angularDamping=this.properties[7];this.bullet=0!==this.properties[8];this.enabled=0!==this.properties[9];this.body=null;this.inst.update_bbox();this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y;this.lastKnownAngle=this.inst.angle;
this.lastHeight=this.lastWidth=0;this.recreateBody=this.lastTickOverride=!1;this.lastAnimation=null;this.lastAnimationFrame=-1;this.myJoints?(this.myJoints.length=0,this.myCreatedJoints.length=0,this.joiningMe.clear()):(this.myJoints=[],this.myCreatedJoints=[],this.joiningMe=new cr.ObjectSet);var a=this;this.recycled||(this.myDestroyCallback=function(b){a.onInstanceDestroyed(b)});this.runtime.addDestroyCallback(this.myDestroyCallback)};p.postCreate=function(){this.inst.update_bbox();this.createBody();
this.lastAnimation=this.inst.cur_animation;this.lastAnimationFrame=this.inst.cur_frame};p.onDestroy=function(){this.destroyMyJoints();this.myCreatedJoints.length=0;this.joiningMe.clear();this.body&&(this.world.DestroyBody(this.body),this.body=null);this.runtime.removeDestroyCallback(this.myDestroyCallback)};p.saveToJSON=function(){var a={e:this.enabled,im:this.immovable,pr:this.preventRotation,d:this.density,fr:this.friction,re:this.restitution,ld:this.linearDamping,ad:this.angularDamping,b:this.bullet,
mcj:this.myCreatedJoints};if(this.enabled){var b=e.Get(0,0);b.SetV(this.body.GetLinearVelocity());a.vx=b.x;a.vy=b.y;a.om=this.body.GetAngularVelocity()}return a};p.loadFromJSON=function(a){this.destroyMyJoints();this.myCreatedJoints.length=0;this.joiningMe.clear();this.body&&(this.world.DestroyBody(this.body),this.body=null);this.enabled=a.e;this.immovable=a.im;this.preventRotation=a.pr;this.density=a.d;this.friction=a.fr;this.restitution=a.re;this.linearDamping=a.ld;this.angularDamping=a.ad;this.bullet=
a.b;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y;this.lastKnownAngle=this.inst.angle;this.lastWidth=this.inst.width;this.lastHeight=this.inst.height;this.enabled&&(this.createBody(),this.body.SetLinearVelocity(e.Get(a.vx,a.vy)),this.body.SetAngularVelocity(a.om),0===a.vx&&0===a.vy&&0===a.om||this.body.SetAwake(!0),this.myCreatedJoints=a.mcj)};p.afterLoad=function(){this.enabled&&this.recreateMyJoints();this.behavior.lastUpdateTick=this.runtime.tickcount-1};p.onInstanceDestroyed=function(a){var b,
c,d,e=a.uid;d=b=0;for(c=this.myCreatedJoints.length;b<c;b++)this.myCreatedJoints[d]=this.myCreatedJoints[b],d<this.myJoints.length&&(this.myJoints[d]=this.myJoints[b]),this.myCreatedJoints[b].params[1]==e?this.world.DestroyJoint(this.myJoints[b]):d++;this.myCreatedJoints.length=d;d<this.myJoints.length&&(this.myJoints.length=d);this.joiningMe.remove(a)};p.destroyMyJoints=function(){var a,b;a=0;for(b=this.myJoints.length;a<b;a++)this.world.DestroyJoint(this.myJoints[a]);this.myJoints.length=0};p.recreateMyJoints=
function(){var a,b,c;a=0;for(b=this.myCreatedJoints.length;a<b;a++)switch(c=this.myCreatedJoints[a],c.type){case 0:this.doCreateDistanceJoint(c.params[0],c.params[1],c.params[2],c.params[3],c.params[4]);break;case 1:this.doCreateRevoluteJoint(c.params[0],c.params[1]);break;case 2:this.doCreateLimitedRevoluteJoint(c.params[0],c.params[1],c.params[2],c.params[3])}};p.destroyBody=function(){this.body&&(this.destroyMyJoints(),this.world.DestroyBody(this.body),this.body=null,this.inst.extra.box2dbody=
null)};var r=[];p.createBody=function(){if(this.enabled){var a=this.inst,b=!1,c=null,d=null,g,m,n,p,v,w,x,y,D,z,H,I,S;if(this.body){b=!0;c=e.Get(0,0);c.SetV(this.body.GetLinearVelocity());d=this.body.GetAngularVelocity();y=this.joiningMe.valuesRef();g=0;for(m=y.length;g<m;g++)D=y[g].extra.box2dbody.c2userdata,D.destroyMyJoints();this.destroyBody()}D=new f;D.density=this.density;D.friction=this.friction;D.restitution=this.restitution;g=new h;g.type=this.immovable?0:2;a.update_bbox();g.position.x=0.02*
a.bquad.midX();g.position.y=0.02*a.bquad.midY();g.angle=a.angle;g.fixedRotation=this.preventRotation;g.linearDamping=this.linearDamping;g.angularDamping=this.angularDamping;g.bullet=this.bullet;y=this.inst.collision_poly&&!this.inst.collision_poly.is_empty();this.body=this.world.CreateBody(g);this.body.c2userdata=this;g=this.collisionmask;y||this.inst.tilemap_exists||0!==this.collisionmask||(g=1);m=Math.max(Math.abs(a.width),1);n=Math.max(Math.abs(a.height),1);z=0>a.width;H=0>a.height;if(0===g)if(a.tilemap_exists)for(I=
a.bquad.midX()-a.x,x=a.bquad.midY()-a.y,a.getAllCollisionRects(r),y=[],g=0,m=r.length;g<m;++g){z=r[g];H=z.rc;if(z.poly){if(!z.poly.convexpolys){v=z.poly.pts_cache;p=z.poly.pts_count;for(n=0;n<p;++n)y.push(e.Get(v[2*n],v[2*n+1]));n=z.id&3758096384;(-2147483648===n||1073741824===n||536870912===n||n&-2147483648&&n&1073741824&&n&536870912)&&y.reverse();z.poly.convexpolys=cr.b2Separator.Separate(y,(H.right-H.left)*(H.bottom-H.top));n=0;for(p=y.length;n<p;++n)e.Free(y[n]);y.length=0}n=0;for(p=z.poly.convexpolys.length;n<
p;++n){S=z.poly.convexpolys[n];v=0;for(w=S.length;v<w;++v)y.push(e.Get(0.02*(H.left+S[v].x-I),0.02*(H.top+S[v].y-x)));D.shape=new l;D.shape.SetAsArray(y,y.length);this.body.CreateFixture(D);v=0;for(w=y.length;v<w;++v)e.Free(y[v]);y.length=0}}else y.push(e.Get(0.02*(H.left-I),0.02*(H.top-x))),y.push(e.Get(0.02*(H.right-I),0.02*(H.top-x))),y.push(e.Get(0.02*(H.right-I),0.02*(H.bottom-x))),y.push(e.Get(0.02*(H.left-I),0.02*(H.bottom-x))),D.shape=new l,D.shape.SetAsArray(y,y.length),this.body.CreateFixture(D);
n=0;for(p=y.length;n<p;++n)e.Free(y[n]);y.length=0}else{g=a.angle;a.angle=0;a.set_bbox_changed();a.update_bbox();I=a.bquad.midX()-a.x;x=a.bquad.midY()-a.y;a.angle=g;a.set_bbox_changed();a.collision_poly.cache_poly(z?-m:m,H?-n:n,0);v=a.collision_poly.pts_cache;p=a.collision_poly.pts_count;y=[];y.length=p;for(g=0;g<p;g++)y[g]=e.Get(v[2*g]-I,v[2*g+1]-x);z!==H&&y.reverse();I=cr.b2Separator.Separate(y,m*n);for(g=0;g<p;g++)e.Free(y[g]);if(I.length)for(g=0,m=I.length;g<m;g++){y=I[g];n=0;for(p=y.length;n<
p;n++)x=y[n],x.x*=0.02,x.y*=0.02;D.shape=new l;D.shape.SetAsArray(y,y.length);this.body.CreateFixture(D);n=0;for(p=y.length;n<p;n++)e.Free(y[n])}else D.shape=new l,D.shape.SetAsBox(0.01*m,0.01*n),this.body.CreateFixture(D)}else 1===g?(D.shape=new l,D.shape.SetAsBox(0.01*m,0.01*n)):D.shape=new k(0.01*Math.min(m,n)),this.body.CreateFixture(D);a.extra.box2dbody=this.body;this.lastWidth=a.width;this.lastHeight=a.height;if(b)for(this.body.SetLinearVelocity(c),this.body.SetAngularVelocity(d),e.Free(c),
this.recreateMyJoints(),y=this.joiningMe.valuesRef(),g=0,m=y.length;g<m;g++)D=y[g].extra.box2dbody.c2userdata,D.recreateMyJoints();r.length=0}};p.tick=function(){if(this.enabled){var a=this.inst,b;0===this.behavior.steppingMode?b=this.runtime.timescale/60:(b=this.runtime.getDt(this.inst),b>1/30&&(b=1/30));this.runtime.tickcount>this.behavior.lastUpdateTick&&0<this.runtime.timescale&&(this.world.Step(b,this.behavior.velocityIterations,this.behavior.positionIterations),this.world.ClearForces(),this.behavior.lastUpdateTick=
this.runtime.tickcount);if(this.recreateBody||a.width!==this.lastWidth||a.height!==this.lastHeight||a.cur_animation!==this.lastAnimation||a.cur_frame!==this.lastAnimationFrame||a.tilemap_exists&&a.physics_changed)this.createBody(),this.recreateBody=!1,this.lastAnimation=a.cur_animation,this.lastAnimationFrame=a.cur_frame,a.tilemap_exists&&a.physics_changed&&(a.physics_changed=!1);b=a.angle!==this.lastKnownAngle;if(a.x!==this.lastKnownX||a.y!==this.lastKnownY){a.update_bbox();var c=a.bquad.midX(),
d=a.bquad.midY(),f=c-this.lastKnownX,g=d-this.lastKnownY;this.body.SetPosition(e.Get(0.02*c,0.02*d));this.body.SetLinearVelocity(e.Get(f,g));this.lastTickOverride=!0;this.body.SetAwake(!0)}else this.lastTickOverride&&(this.lastTickOverride=!1,this.body.SetLinearVelocity(e.Get(0,0)),this.body.SetPosition(e.Get(0.02*a.bquad.midX(),0.02*a.bquad.midY())));b&&(this.body.SetAngle(a.angle),this.body.SetAwake(!0));c=this.body.GetPosition();b=c.x/0.02;c=c.y/0.02;d=this.body.GetAngle();if(b!==a.x||c!==a.y||
d!==a.angle)if(a.x=b,a.y=c,a.angle=d,a.set_bbox_changed(),a.update_bbox(),b=a.bquad.midX()-a.x,c=a.bquad.midY()-a.y,0!==b||0!==c)a.x-=b,a.y-=c,a.set_bbox_changed();this.lastKnownX=a.x;this.lastKnownY=a.y;this.lastKnownAngle=a.angle}};p.getInstImgPointX=function(a){return-1!==a&&this.inst.getImagePoint?0===a&&this.body?(this.body.GetPosition().x+this.body.GetLocalCenter().x)/0.02:this.inst.getImagePoint(a,!0):this.inst.x};p.getInstImgPointY=function(a){return-1!==a&&this.inst.getImagePoint?0===a&&
this.body?(this.body.GetPosition().y+this.body.GetLocalCenter().y)/0.02:this.inst.getImagePoint(a,!1):this.inst.y};a.prototype.IsSleeping=function(){return this.enabled?!this.body.IsAwake():!1};a.prototype.CompareVelocity=function(a,b,c){if(!this.enabled)return!1;var d=this.body.GetLinearVelocity();0===a?d=d.x/0.02:1===a?d=d.y/0.02:(a=d.x/0.02,d=d.y/0.02,d=cr.distanceTo(0,0,a,d));return cr.do_cmp(d,b,c)};a.prototype.CompareAngularVelocity=function(a,b){if(!this.enabled)return!1;var c=cr.to_degrees(this.body.GetAngularVelocity());
return cr.do_cmp(c,a,b)};a.prototype.CompareMass=function(a,b){if(!this.enabled)return!1;var c=this.body.GetMass()/0.02;return cr.do_cmp(c,a,b)};a.prototype.IsEnabled=function(){return this.enabled};n.cnds=new a;b.prototype.ApplyForce=function(a,b,c){if(this.enabled){var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);this.body.ApplyForce(e.Get(a,b),e.Get(0.02*d,0.02*c))}};b.prototype.ApplyForceToward=function(a,b,c,d){if(this.enabled){var f=this.getInstImgPointX(d);d=this.getInstImgPointY(d);
b=cr.angleTo(f,d,b,c);this.body.ApplyForce(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*f,0.02*d))}};b.prototype.ApplyForceAtAngle=function(a,b,c){if(this.enabled){b=cr.to_radians(b);var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);this.body.ApplyForce(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*d,0.02*c))}};b.prototype.ApplyImpulse=function(a,b,c){if(this.enabled){var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);this.body.ApplyImpulse(e.Get(a,b),e.Get(0.02*d,0.02*c));this.lastTickOverride=
!1;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y}};b.prototype.ApplyImpulseToward=function(a,b,c,d){if(this.enabled){var f=this.getInstImgPointX(d);d=this.getInstImgPointY(d);b=cr.angleTo(f,d,b,c);this.body.ApplyImpulse(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*f,0.02*d));this.lastTickOverride=!1;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y}};b.prototype.ApplyImpulseAtAngle=function(a,b,c){if(this.enabled){b=cr.to_radians(b);var d=this.getInstImgPointX(c);c=this.getInstImgPointY(c);
this.body.ApplyImpulse(e.Get(Math.cos(b)*a,Math.sin(b)*a),e.Get(0.02*d,0.02*c));this.lastTickOverride=!1;this.lastKnownX=this.inst.x;this.lastKnownY=this.inst.y}};b.prototype.ApplyTorque=function(a){this.enabled&&this.body.ApplyTorque(cr.to_radians(a))};b.prototype.ApplyTorqueToAngle=function(a,b){this.enabled&&(a=cr.to_radians(a),b=cr.to_radians(b),cr.angleClockwise(this.inst.angle,b)?this.body.ApplyTorque(-a):this.body.ApplyTorque(a))};b.prototype.ApplyTorqueToPosition=function(a,b,c){this.enabled&&
(a=cr.to_radians(a),b=cr.angleTo(this.inst.x,this.inst.y,b,c),cr.angleClockwise(this.inst.angle,b)?this.body.ApplyTorque(-a):this.body.ApplyTorque(a))};b.prototype.SetAngularVelocity=function(a){this.enabled&&(this.body.SetAngularVelocity(cr.to_radians(a)),this.body.SetAwake(!0))};b.prototype.CreateDistanceJoint=function(a,b,c,d,e){b&&this.enabled&&(b=b.getFirstPicked(this.inst))&&b!=this.inst&&b.extra.box2dbody&&(this.myCreatedJoints.push({type:0,params:[a,b.uid,c,d,e]}),this.doCreateDistanceJoint(a,
b.uid,c,d,e))};p.doCreateDistanceJoint=function(a,b,c,d,f){if(this.enabled&&(b=this.runtime.getObjectByUID(b))&&b!=this.inst&&b.extra.box2dbody){b.extra.box2dbody.c2userdata.joiningMe.add(this.inst);var h=this.getInstImgPointX(a);a=this.getInstImgPointY(a);var k;b.getImagePoint?(k=b.getImagePoint(c,!0),c=b.getImagePoint(c,!1)):(k=b.x,c=b.y);var l=h-k,m=a-c,n=new g;n.Initialize(this.body,b.extra.box2dbody,e.Get(0.02*h,0.02*a),e.Get(0.02*k,0.02*c));n.length=0.02*Math.sqrt(l*l+m*m);n.dampingRatio=d;
n.frequencyHz=f;this.myJoints.push(this.world.CreateJoint(n))}};b.prototype.CreateRevoluteJoint=function(a,b){if(b&&this.enabled){var c=b.getFirstPicked(this.inst);c&&c!=this.inst&&c.extra.box2dbody&&(this.myCreatedJoints.push({type:1,params:[a,c.uid]}),this.doCreateRevoluteJoint(a,c.uid))}};p.doCreateRevoluteJoint=function(a,b){if(this.enabled){var c=this.runtime.getObjectByUID(b);if(c&&c!=this.inst&&c.extra.box2dbody){c.extra.box2dbody.c2userdata.joiningMe.add(this.inst);var d=this.getInstImgPointX(a),
f=this.getInstImgPointY(a),g=new m;g.Initialize(this.body,c.extra.box2dbody,e.Get(0.02*d,0.02*f));this.myJoints.push(this.world.CreateJoint(g))}}};b.prototype.CreateLimitedRevoluteJoint=function(a,b,c,d){b&&this.enabled&&(b=b.getFirstPicked(this.inst))&&b!=this.inst&&b.extra.box2dbody&&(this.myCreatedJoints.push({type:2,params:[a,b.uid,c,d]}),this.doCreateLimitedRevoluteJoint(a,b.uid,c,d))};p.doCreateLimitedRevoluteJoint=function(a,b,c,d){if(this.enabled&&(b=this.runtime.getObjectByUID(b))&&b!=this.inst&&
b.extra.box2dbody){b.extra.box2dbody.c2userdata.joiningMe.add(this.inst);var f=this.getInstImgPointX(a);a=this.getInstImgPointY(a);var g=new m;g.Initialize(this.body,b.extra.box2dbody,e.Get(0.02*f,0.02*a));g.enableLimit=!0;g.lowerAngle=cr.to_radians(c);g.upperAngle=cr.to_radians(d);this.myJoints.push(this.world.CreateJoint(g))}};b.prototype.SetWorldGravity=function(a){if(a!==this.behavior.worldG){this.world.SetGravity(e.Get(0,a));this.behavior.worldG=a;var b,c=this.behavior.my_instances.valuesRef();
a=0;for(b=c.length;a<b;a++)c[a].extra.box2dbody&&c[a].extra.box2dbody.SetAwake(!0)}};b.prototype.SetSteppingMode=function(a){this.behavior.steppingMode=a};b.prototype.SetIterations=function(a,b){1>a&&(a=1);1>b&&(b=1);this.behavior.velocityIterations=a;this.behavior.positionIterations=b};b.prototype.SetVelocity=function(a,b){this.enabled&&(this.body.SetLinearVelocity(e.Get(0.02*a,0.02*b)),this.body.SetAwake(!0),this.lastTickOverride=!1,this.lastKnownX=this.inst.x,this.lastKnownY=this.inst.y)};b.prototype.SetDensity=
function(a){this.enabled&&this.density!==a&&(this.density=a,this.recreateBody=!0)};b.prototype.SetFriction=function(a){this.enabled&&this.friction!==a&&(this.friction=a,this.recreateBody=!0)};b.prototype.SetElasticity=function(a){this.enabled&&this.restitution!==a&&(this.restitution=a,this.recreateBody=!0)};b.prototype.SetLinearDamping=function(a){this.enabled&&this.linearDamping!==a&&(this.linearDamping=a,this.body.SetLinearDamping(a))};b.prototype.SetAngularDamping=function(a){this.enabled&&this.angularDamping!==
a&&(this.angularDamping=a,this.body.SetAngularDamping(a))};b.prototype.SetImmovable=function(a){this.enabled&&this.immovable!==(0!==a)&&(this.immovable=0!==a,this.body.SetType(this.immovable?0:2),this.body.SetAwake(!0))};b.prototype.EnableCollisions=function(a,b){if(a&&this.enabled){var d,e;if(a.is_family)for(d=0,e=a.members.length;d<e;d++)c(this.inst.type,a.members[d],0!==b);else c(this.inst.type,a,0!==b);this.behavior.allCollisionsEnabled=!1}};b.prototype.SetPreventRotate=function(a){this.enabled&&
this.preventRotation!==(0!==a)&&(this.preventRotation=0!==a,this.body.SetFixedRotation(this.preventRotation),this.body.m_torque=0,this.body.SetAngularVelocity(0),this.body.SetAwake(!0))};b.prototype.SetBullet=function(a){this.enabled&&this.bullet!==(0!==a)&&(this.bullet=0!==a,this.body.SetBullet(this.bullet),this.body.SetAwake(!0))};b.prototype.RemoveJoints=function(){this.enabled&&(this.destroyMyJoints(),this.myCreatedJoints.length=0,this.joiningMe.clear())};b.prototype.SetEnabled=function(a){this.enabled&&
0===a?(this.destroyBody(),this.enabled=!1):this.enabled||1!==a||(this.enabled=!0,this.createBody())};n.acts=new b;d.prototype.VelocityX=function(a){a.set_float(this.enabled?this.body.GetLinearVelocity().x/0.02:0)};d.prototype.VelocityY=function(a){a.set_float(this.enabled?this.body.GetLinearVelocity().y/0.02:0)};d.prototype.AngularVelocity=function(a){a.set_float(this.enabled?cr.to_degrees(this.body.GetAngularVelocity()):0)};d.prototype.Mass=function(a){a.set_float(this.enabled?this.body.GetMass()/
0.02:0)};d.prototype.CenterOfMassX=function(a){a.set_float(this.enabled?(this.body.GetPosition().x+this.body.GetLocalCenter().x)/0.02:0)};d.prototype.CenterOfMassY=function(a){a.set_float(this.enabled?(this.body.GetPosition().y+this.body.GetLocalCenter().y)/0.02:0)};d.prototype.Density=function(a){a.set_float(this.enabled?this.density:0)};d.prototype.Friction=function(a){a.set_float(this.enabled?this.friction:0)};d.prototype.Elasticity=function(a){a.set_float(this.enabled?this.restitution:0)};d.prototype.LinearDamping=
function(a){a.set_float(this.enabled?this.linearDamping:0)};d.prototype.AngularDamping=function(a){a.set_float(this.enabled?this.angularDamping:0)};n.exps=new d})();cr.behaviors.Pin=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.behaviors.Pin.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var e=d.Instance.prototype;e.onCreate=function(){this.pinObject=null;this.pinObjectUid=-1;this.mode=this.lastKnownAngle=this.theirStartAngle=this.myStartAngle=this.pinDist=this.pinAngle=0;var a=this;this.recycled||
(this.myDestroyCallback=function(b){a.onInstanceDestroyed(b)});this.runtime.addDestroyCallback(this.myDestroyCallback)};e.saveToJSON=function(){return{uid:this.pinObject?this.pinObject.uid:-1,pa:this.pinAngle,pd:this.pinDist,msa:this.myStartAngle,tsa:this.theirStartAngle,lka:this.lastKnownAngle,m:this.mode}};e.loadFromJSON=function(a){this.pinObjectUid=a.uid;this.pinAngle=a.pa;this.pinDist=a.pd;this.myStartAngle=a.msa;this.theirStartAngle=a.tsa;this.lastKnownAngle=a.lka;this.mode=a.m};e.afterLoad=
function(){this.pinObject=-1===this.pinObjectUid?null:this.runtime.getObjectByUID(this.pinObjectUid);this.pinObjectUid=-1};e.onInstanceDestroyed=function(a){this.pinObject==a&&(this.pinObject=null)};e.onDestroy=function(){this.pinObject=null;this.runtime.removeDestroyCallback(this.myDestroyCallback)};e.tick=function(){};e.tick2=function(){if(this.pinObject){this.lastKnownAngle!==this.inst.angle&&(this.myStartAngle=cr.clamp_angle(this.myStartAngle+(this.inst.angle-this.lastKnownAngle)));var a=this.inst.x,
b=this.inst.y;if(3===this.mode||4===this.mode){var c=cr.distanceTo(this.inst.x,this.inst.y,this.pinObject.x,this.pinObject.y);if(c>this.pinDist||4===this.mode&&c<this.pinDist)b=cr.angleTo(this.pinObject.x,this.pinObject.y,this.inst.x,this.inst.y),a=this.pinObject.x+Math.cos(b)*this.pinDist,b=this.pinObject.y+Math.sin(b)*this.pinDist}else a=this.pinObject.x+Math.cos(this.pinObject.angle+this.pinAngle)*this.pinDist,b=this.pinObject.y+Math.sin(this.pinObject.angle+this.pinAngle)*this.pinDist;this.lastKnownAngle=
c=cr.clamp_angle(this.myStartAngle+(this.pinObject.angle-this.theirStartAngle));0!==this.mode&&1!==this.mode&&3!==this.mode&&4!==this.mode||this.inst.x===a&&this.inst.y===b||(this.inst.x=a,this.inst.y=b,this.inst.set_bbox_changed());0!==this.mode&&2!==this.mode||this.inst.angle===c||(this.inst.angle=c,this.inst.set_bbox_changed())}};a.prototype.IsPinned=function(){return!!this.pinObject};d.cnds=new a;b.prototype.Pin=function(a,b){if(a){var c=a.getFirstPicked(this.inst);c&&(this.pinObject=c,this.pinAngle=
cr.angleTo(c.x,c.y,this.inst.x,this.inst.y)-c.angle,this.pinDist=cr.distanceTo(c.x,c.y,this.inst.x,this.inst.y),this.lastKnownAngle=this.myStartAngle=this.inst.angle,this.theirStartAngle=c.angle,this.mode=b)}};b.prototype.Unpin=function(){this.pinObject=null};d.acts=new b;c.prototype.PinnedUID=function(a){a.set_int(this.pinObject?this.pinObject.uid:-1)};d.exps=new c})();cr.behaviors.Sin=function(a){this.runtime=a};
(function(){function a(){}function b(){}function c(){}var d=cr.behaviors.Sin.prototype;d.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};d.Type.prototype.onCreate=function(){};d.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime;this.i=0};var e=d.Instance.prototype,h=2*Math.PI,f=Math.PI/2,l=3*Math.PI/2;e.onCreate=function(){this.active=1===this.properties[0];this.movement=this.properties[1];this.wave=this.properties[2];this.period=
this.properties[3];this.period+=Math.random()*this.properties[4];0===this.period?this.i=0:(this.i=this.properties[5]/this.period*h,this.i+=Math.random()*this.properties[6]/this.period*h);this.mag=this.properties[7];this.mag+=Math.random()*this.properties[8];this.ratio=this.initialValue2=this.initialValue=0;this.init()};e.saveToJSON=function(){return{i:this.i,a:this.active,mv:this.movement,w:this.wave,p:this.period,mag:this.mag,iv:this.initialValue,iv2:this.initialValue2,r:this.ratio,lkv:this.lastKnownValue,
lkv2:this.lastKnownValue2}};e.loadFromJSON=function(a){this.i=a.i;this.active=a.a;this.movement=a.mv;this.wave=a.w;this.period=a.p;this.mag=a.mag;this.initialValue=a.iv;this.initialValue2=a.iv2||0;this.ratio=a.r;this.lastKnownValue=a.lkv;this.lastKnownValue2=a.lkv2||0};e.init=function(){switch(this.movement){case 0:this.initialValue=this.inst.x;break;case 1:this.initialValue=this.inst.y;break;case 2:this.initialValue=this.inst.width;this.ratio=this.inst.height/this.inst.width;break;case 3:this.initialValue=
this.inst.width;break;case 4:this.initialValue=this.inst.height;break;case 5:this.initialValue=this.inst.angle;this.mag=cr.to_radians(this.mag);break;case 6:this.initialValue=this.inst.opacity;break;case 7:this.initialValue=0;break;case 8:this.initialValue=this.inst.x,this.initialValue2=this.inst.y}this.lastKnownValue=this.initialValue;this.lastKnownValue2=this.initialValue2};e.waveFunc=function(a){a%=h;switch(this.wave){case 0:return Math.sin(a);case 1:return a<=f?a/f:a<=l?1-2*(a-f)/Math.PI:(a-l)/
f-1;case 2:return 2*a/h-1;case 3:return-2*a/h+1;case 4:return a<Math.PI?-1:1}return 0};e.tick=function(){var a=this.runtime.getDt(this.inst);if(this.active&&0!==a){0===this.period?this.i=0:(this.i+=a/this.period*h,this.i%=h);switch(this.movement){case 0:this.inst.x!==this.lastKnownValue&&(this.initialValue+=this.inst.x-this.lastKnownValue);this.inst.x=this.initialValue+this.waveFunc(this.i)*this.mag;this.lastKnownValue=this.inst.x;break;case 1:this.inst.y!==this.lastKnownValue&&(this.initialValue+=
this.inst.y-this.lastKnownValue);this.inst.y=this.initialValue+this.waveFunc(this.i)*this.mag;this.lastKnownValue=this.inst.y;break;case 2:this.inst.width=this.initialValue+this.waveFunc(this.i)*this.mag;this.inst.height=this.inst.width*this.ratio;break;case 3:this.inst.width=this.initialValue+this.waveFunc(this.i)*this.mag;break;case 4:this.inst.height=this.initialValue+this.waveFunc(this.i)*this.mag;break;case 5:this.inst.angle!==this.lastKnownValue&&(this.initialValue=cr.clamp_angle(this.initialValue+
(this.inst.angle-this.lastKnownValue)));this.inst.angle=cr.clamp_angle(this.initialValue+this.waveFunc(this.i)*this.mag);this.lastKnownValue=this.inst.angle;break;case 6:this.inst.opacity=this.initialValue+this.waveFunc(this.i)*this.mag/100;0>this.inst.opacity?this.inst.opacity=0:1<this.inst.opacity&&(this.inst.opacity=1);break;case 8:this.inst.x!==this.lastKnownValue&&(this.initialValue+=this.inst.x-this.lastKnownValue),this.inst.y!==this.lastKnownValue2&&(this.initialValue2+=this.inst.y-this.lastKnownValue2),
this.inst.x=this.initialValue+Math.cos(this.inst.angle)*this.waveFunc(this.i)*this.mag,this.inst.y=this.initialValue2+Math.sin(this.inst.angle)*this.waveFunc(this.i)*this.mag,this.lastKnownValue=this.inst.x,this.lastKnownValue2=this.inst.y}this.inst.set_bbox_changed()}};e.onSpriteFrameChanged=function(a,b){switch(this.movement){case 2:this.initialValue*=b.width/a.width;this.ratio=b.height/b.width;break;case 3:this.initialValue*=b.width/a.width;break;case 4:this.initialValue*=b.height/a.height}};a.prototype.IsActive=
function(){return this.active};a.prototype.CompareMovement=function(a){return this.movement===a};a.prototype.ComparePeriod=function(a,b){return cr.do_cmp(this.period,a,b)};a.prototype.CompareMagnitude=function(a,b){return 5===this.movement?cr.do_cmp(this.mag,a,cr.to_radians(b)):cr.do_cmp(this.mag,a,b)};a.prototype.CompareWave=function(a){return this.wave===a};d.cnds=new a;b.prototype.SetActive=function(a){this.active=1===a};b.prototype.SetPeriod=function(a){this.period=a};b.prototype.SetMagnitude=
function(a){this.mag=a;5===this.movement&&(this.mag=cr.to_radians(this.mag))};b.prototype.SetMovement=function(a){5===this.movement&&(this.mag=cr.to_degrees(this.mag));this.movement=a;this.init()};b.prototype.SetWave=function(a){this.wave=a};d.acts=new b;c.prototype.CyclePosition=function(a){a.set_float(this.i/h)};c.prototype.Period=function(a){a.set_float(this.period)};c.prototype.Magnitude=function(a){5===this.movement?a.set_float(cr.to_degrees(this.mag)):a.set_float(this.mag)};c.prototype.Value=
function(a){a.set_float(this.waveFunc(this.i)*this.mag)};d.exps=new c})();cr.behaviors.scrollto=function(a){this.runtime=a;this.shakeMode=this.shakeEnd=this.shakeStart=this.shakeMag=0};
(function(){function a(){}var b=cr.behaviors.scrollto.prototype;b.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};b.Type.prototype.onCreate=function(){};b.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var c=b.Instance.prototype;c.onCreate=function(){this.enabled=0!==this.properties[0]};c.saveToJSON=function(){return{smg:this.behavior.shakeMag,ss:this.behavior.shakeStart,se:this.behavior.shakeEnd,smd:this.behavior.shakeMode}};
c.loadFromJSON=function(a){this.behavior.shakeMag=a.smg;this.behavior.shakeStart=a.ss;this.behavior.shakeEnd=a.se;this.behavior.shakeMode=a.smd};c.tick=function(){};c.tick2=function(){if(this.enabled){var a=this.behavior.my_instances.valuesRef(),b=0,c=0,f,l,k,g=0;f=0;for(l=a.length;f<l;f++){a:{k=a[f];for(var m=void 0,n=void 0,p=void 0,m=0,n=k.behavior_insts.length;m<n;++m)if(p=k.behavior_insts[m],p.behavior instanceof cr.behaviors.scrollto){k=p;break a}k=null}k&&k.enabled&&(b+=a[f].x,c+=a[f].y,++g)}a=
this.inst.layer.layout;l=this.runtime.kahanTime.sum;k=f=0;l>=this.behavior.shakeStart&&l<this.behavior.shakeEnd&&(f=this.behavior.shakeMag*Math.min(this.runtime.timescale,1),0===this.behavior.shakeMode&&(f*=1-(l-this.behavior.shakeStart)/(this.behavior.shakeEnd-this.behavior.shakeStart)),l=Math.random()*Math.PI*2,k=Math.random()*f,f=Math.cos(l)*k,k*=Math.sin(l));a.scrollToX(b/g+f);a.scrollToY(c/g+k)}};a.prototype.Shake=function(a,b,c){this.behavior.shakeMag=a;this.behavior.shakeStart=this.runtime.kahanTime.sum;
this.behavior.shakeEnd=this.behavior.shakeStart+b;this.behavior.shakeMode=c};a.prototype.SetEnabled=function(a){this.enabled=0!==a};b.acts=new a})();cr.behaviors.solid=function(a){this.runtime=a};
(function(){function a(){}function b(){}var c=cr.behaviors.solid.prototype;c.Type=function(a,b){this.behavior=a;this.objtype=b;this.runtime=a.runtime};c.Type.prototype.onCreate=function(){};c.Instance=function(a,b){this.type=a;this.behavior=a.behavior;this.inst=b;this.runtime=a.runtime};var d=c.Instance.prototype;d.onCreate=function(){this.inst.extra.solidEnabled=0!==this.properties[0]};d.tick=function(){};a.prototype.IsEnabled=function(){return this.inst.extra.solidEnabled};c.cnds=new a;b.prototype.SetEnabled=
function(a){this.inst.extra.solidEnabled=!!a};c.acts=new b})();
cr.getProjectModel=function(){return[null,"intro",[[cr.plugins_.Audio,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Clay,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Browser,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.CJSAds,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Facebook,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Function,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Keyboard,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Particles,!1,!0,!0,!1,!0,!0,!0,!0,!0],[cr.plugins_.Sprite,!1,!0,!0,!0,!0,!0,!0,!0,!1],[cr.plugins_.Text,
!1,!0,!0,!0,!0,!0,!0,!0,!1],[cr.plugins_.TiledBg,!1,!0,!0,!0,!0,!0,!0,!0,!0],[cr.plugins_.Touch,!0,!1,!1,!1,!1,!1,!1,!1,!1],[cr.plugins_.Twitter,!1,!0,!0,!0,!1,!1,!1,!1,!1]],[["t0",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x6dd713e633e30,[["collision-sheet0.png",93,0,0,18,18,1,0.5,0.5,[["Imagepoint 1",1,0]],[],1]]]],[["Physics",cr.behaviors.Physics,0x605fb71361e1e]],!1,!1,9095120919711904,[],null],["t1",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xc9387345f5eeb,[["frontaxel_2-sheet0.png",
98,0,0,64,64,1,0.5,0.5,[],[],1]]]],[["Physics",cr.behaviors.Physics,0x4b1f188d2d230]],!1,!1,8917397362844635,[],null],["t2",cr.plugins_.Keyboard,!1,[],0,0,null,null,[],!1,!1,0xf7b675e81c76a,[],null,[]],["t3",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,7981845048905806,[["collision2-sheet0.png",93,0,0,18,18,1,0.5,0.5,[],[],1]]]],[["Physics",cr.behaviors.Physics,8942266267269331]],!1,!1,9650661954073684,[],null],["t4",cr.plugins_.Sprite,!1,[0x576571b065daf],1,0,null,[["Default",0,!1,1,
0,!1,8226104912823647,[["throttle-sheet1.png",1104,0,0,377,317,1,0.4986737370491028,0.5899053812026978,[],[],0],["throttle-sheet0.png",324310,0,0,961,900,1,0.5005202889442444,0.5,[],[],0]]]],[["Anchor",cr.behaviors.Anchor,5305511937399965]],!1,!1,457367048360232,[],null],["t5",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,762310432483732,[["brake-sheet0.png",1104,0,0,377,317,1,0.5013262629508972,0.5015772581100464,[],[],0]]]],[["Anchor",cr.behaviors.Anchor,9359541474672992]],!1,!1,0x8a2c163d99fc4,
[],null],["t6",cr.plugins_.Touch,!1,[],0,0,null,null,[],!1,!1,7403174051126093,[],null,[1]],["t7",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,7618850096596047,[["sky-sheet0.png",284,0,0,438,445,1,0.5,0.5011236071586609,[],[],1]]]],[["Anchor",cr.behaviors.Anchor,8500908013380077]],!1,!1,0xaedda5c8b7813,[],null],["t8",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x84e271f26a785,[["sprite-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,9789006824777452,[],null],
["t9",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,9307871780007936,[["frontaxel_2-sheet0.png",98,0,0,64,64,1,0.5,0.5,[],[],1]]]],[["Physics",cr.behaviors.Physics,0xca0eeceaaa7f9]],!1,!1,4715719706826863,[],null],["t10",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,772823103875985,[["treebottom-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[["Physics",cr.behaviors.Physics,0xcf89928ea24af]],!1,!1,0x9e2b5aed5641e,[],null],["t11",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",
5,!1,1,0,!1,724433068242464,[["treebottom-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[["Physics",cr.behaviors.Physics,5192508972187826]],!1,!1,7659642711846265,[],null],["t12",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",0,!1,1,0,!1,6083947818926044,[["oildrum-sheet0.png",56728,0,0,300,400,1,0.4933333396911621,0.5049999952316284,[],[-0.3466663360595703,-0.3799999952316284,0.3333336710929871,-0.375,0.3366666436195374,0.3624999523162842,-0.3233333230018616,0.3624999523162842],0]]]],[["Physics",
cr.behaviors.Physics,0x9646ac06937ac]],!1,!1,6879009405156544,[],null],["t13",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",0,!1,1,0,!1,5694077457181604,[["oildrum-sheet0.png",56728,0,0,300,400,1,0.4933333396911621,0.5049999952316284,[],[-0.3466663360595703,-0.3799999952316284,0.3333336710929871,-0.375,0.3366666436195374,0.3624999523162842,-0.3233333230018616,0.3624999523162842],0]]]],[["Physics",cr.behaviors.Physics,0xec7e52b4b2fd5]],!1,!1,6491071391696439,[],null],["t14",cr.plugins_.Sprite,!1,[],
1,0,null,[["Default",5,!1,1,0,!1,9321490724618332,[["collision3-sheet0.png",12824,0,0,400,200,1,0.5,0.5,[],[],0]]]],[["Physics",cr.behaviors.Physics,0x7f705799c5d0]],!1,!1,0xc48747c1d9d08,[],null],["t15",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,8330580566677491,[["jump-sheet0.png",2916,0,0,800,512,1,0.5,0.5,[],[-0.2925000190734863,0.0625,-0.143750011920929,0.04492199420928955,0.03874897956848145,-0.004882991313934326,0.2031239867210388,-0.09423801302909851,0.3003119826316834,-0.176025003194809,
0.3689060211181641,-0.2559809982776642,0.4300779700279236,-0.3525999784469605,0.4725390076637268,-0.3403629958629608,0.4725000262260437,0.1464840173721314,-0.5,0.06835901737213135],0]]]],[["Physics",cr.behaviors.Physics,0x97334f60f9ece]],!1,!1,0x7a8df79970791,[],null],["t16",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",0,!1,1,0,!1,0x8ae94fdb3f43a,[["oildrum-sheet0.png",56728,0,0,300,400,1,0.4933333396911621,0.5049999952316284,[],[-0.3466663360595703,-0.3799999952316284,0.3333336710929871,-0.375,
0.3366666436195374,0.3624999523162842,-0.3233333230018616,0.3624999523162842],0],["oildrum2-sheet0.png",40737,0,0,300,400,1,0.4933333396911621,0.5049999952316284,[],[-0.3466663360595703,-0.3799999952316284,0.3333336710929871,-0.375,0.3366666436195374,0.3624999523162842,-0.3233333230018616,0.3624999523162842],0]]]],[["Physics",cr.behaviors.Physics,9528451220845446]],!1,!1,6907584940943864,[],null],["t17",cr.plugins_.TiledBg,!1,[],0,0,["ramppillars.png",168,0],null,[],!1,!1,6274639560530974,[],null],
["t18",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xb0742365ad556,[["rampextenderend-sheet0.png",332,0,0,279,256,1,0.4982078969478607,0.5,[],[-0.4982078969478607,0.0859379768371582,-0.4982078969478607,-0.007811993360519409,0.5017920732498169,-0.007811993360519409,0.5017920732498169,0.0898439884185791],0]]]],[["Physics",cr.behaviors.Physics,0xd575663939fc7]],!1,!1,0x430fe7032306e,[],null],["t19",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x92c3b351942be,[["restart-sheet0.png",
5861,0,0,501,400,1,0.5009980201721191,0.5,[],[-0.5009980201721191,-0.1299999952316284,0.4990019798278809,-0.1299999952316284,0.4990019798278809,0.1274999976158142,-0.5009980201721191,0.1299999952316284],0]]]],[["Anchor",cr.behaviors.Anchor,4652735923390358]],!1,!1,0x67226d6d213ef,[],null],["t20",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4935110309612462,[["scroller-sheet0.png",155,0,0,250,250,1,0.5,0.5,[["attach to car",0,0.5],["scroller",1,0.5]],[],1]]]],[],!1,!1,0x75c3a574788ba,
[],null],["t21",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6418837204842641,[["scroller-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[["ScrollTo",cr.behaviors.scrollto,8598763828058728]],!1,!1,965009927687437,[],null],["t22",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xf979c5d4dd30a,[["mojobg-sheet0.png",753,0,0,1041,651,1,0.5004802942276001,0.5007680654525757,[],[],1]]]],[],!1,!1,5391939726733786,[],null],["t23",cr.plugins_.CJSAds,!1,[],0,0,null,null,[],!1,!1,9877927655215302,
[],null,[0,0]],["t24",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xbfdf7ae46edac,[["rampextenderend2-sheet0.png",323,0,0,279,256,1,0.4982078969478607,0.5,[],[-0.4982078969478607,-0.01269501447677612,0.5017920732498169,-0.0117189884185791,0.5017920732498169,0.0859379768371582,-0.4982078969478607,0.0820310115814209],0]]]],[["Physics",cr.behaviors.Physics,5716492021040427]],!1,!1,0x5cdac6826f223,[],null],["t25",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,8640759443403494,
[["rampextenderend3-sheet0.png",336,0,0,279,256,1,0.5017921328544617,0.5,[["Imagepoint 1",0.9820788502693176,0.53515625]],[-0.5017921328544617,0.078125,-0.5017921328544617,-0.00976601243019104,0.4982078671455383,-0.007811993360519409,0.4982078671455383,0.0820310115814209],0]]]],[["Physics",cr.behaviors.Physics,8123432394330419]],!1,!1,0xad0527fbff4fe,[],null],["t26",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5897642513326965,[["b8-sheet0.png",158,0,0,74,54,1,0.5,0.5,[["Imagepoint 1",
0.06756756454706192,0.2777777910232544],["Imagepoint 2",0.9594594836235046,0.2962962985038757]],[-0.4341216087341309,-0.4189814925193787,0.4628379940986633,-0.4166666865348816,0.4628379940986633,0.006945013999938965,-0.4290539920330048,0.006944000720977783],0]]]],[],!1,!1,0x76f4a96ae023a,[],null],["t27",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7128405599629512,[["b8-sheet0.png",158,0,0,74,54,1,0.5,0.5,[["Imagepoint 1",0.06756756454706192,0.2777777910232544],["Imagepoint 2",0.9594594836235046,
0.2962962985038757]],[-0.4341216087341309,-0.4189814925193787,0.4628379940986633,-0.4166666865348816,0.4628379940986633,0.006945013999938965,-0.4290539920330048,0.006944000720977783],0]]]],[],!1,!1,0x728351b917f17,[],null],["t28",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6825142883213247,[["b8-sheet0.png",158,0,0,74,54,1,0.5,0.5,[["Imagepoint 1",0.06756756454706192,0.2777777910232544],["Imagepoint 2",0.9594594836235046,0.2962962985038757]],[-0.4341216087341309,-0.4189814925193787,
0.4628379940986633,-0.4166666865348816,0.4628379940986633,0.006945013999938965,-0.4290539920330048,0.006944000720977783],0]]]],[],!1,!1,0x4944a48d79a11,[],null],["t29",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xa31d75608b62c,[["b8-sheet0.png",158,0,0,74,54,1,0.5,0.5,[["Imagepoint 1",0.06756756454706192,0.2777777910232544],["Imagepoint 2",0.9594594836235046,0.2962962985038757]],[-0.4341216087341309,-0.4189814925193787,0.4628379940986633,-0.4166666865348816,0.4628379940986633,0.006945013999938965,
-0.4290539920330048,0.006944000720977783],0]]]],[],!1,!1,5783714057615988,[],null],["t30",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x4037361038ad9,[["b8-sheet0.png",158,0,0,74,54,1,0.5,0.5,[["Imagepoint 1",0.06756756454706192,0.2777777910232544],["Imagepoint 2",0.9594594836235046,0.2962962985038757]],[-0.4341216087341309,-0.4189814925193787,0.4628379940986633,-0.4166666865348816,0.4628379940986633,0.006945013999938965,-0.4290539920330048,0.006944000720977783],0]]]],[],!1,!1,0xc22d016310577,
[],null],["t31",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xd47c9924db70b,[["b8-sheet0.png",158,0,0,74,54,1,0.5,0.5,[["Imagepoint 1",0.06756756454706192,0.2777777910232544],["Imagepoint 2",0.9594594836235046,0.2962962985038757]],[-0.4341216087341309,-0.4189814925193787,0.4628379940986633,-0.4166666865348816,0.4628379940986633,0.006945013999938965,-0.4290539920330048,0.006944000720977783],0]]]],[],!1,!1,0x64f91795dde0,[],null],["t32",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,
!1,1,0,!1,9764303518541864,[["b8-sheet0.png",158,0,0,74,54,1,0.5,0.5,[["Imagepoint 1",0.06756756454706192,0.2777777910232544],["Imagepoint 2",0.9594594836235046,0.2962962985038757]],[-0.4341216087341309,-0.4189814925193787,0.4628379940986633,-0.4166666865348816,0.4628379940986633,0.006945013999938965,-0.4290539920330048,0.006944000720977783],0]]]],[],!1,!1,0x7e13b0fa1e7a,[],null],["t33",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x4af710953e46d,[["b8-sheet0.png",158,0,0,74,54,1,0.5,
0.5,[["Imagepoint 1",0.06756756454706192,0.2777777910232544],["Imagepoint 2",0.9594594836235046,0.2962962985038757]],[-0.4341216087341309,-0.4189814925193787,0.4628379940986633,-0.4166666865348816,0.4628379940986633,0.006945013999938965,-0.4290539920330048,0.006944000720977783],0]]]],[],!1,!1,0xdc77818f4d4ce,[],null],["t34",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x953968254f7d3,[["b8-sheet0.png",158,0,0,74,54,1,0.5,0.5,[["Imagepoint 1",0.06756756454706192,0.2777777910232544],["Imagepoint 2",
0.9594594836235046,0.2962962985038757]],[-0.4341216087341309,-0.4189814925193787,0.4628379940986633,-0.4166666865348816,0.4628379940986633,0.006945013999938965,-0.4290539920330048,0.006944000720977783],0]]]],[],!1,!1,389221370010293,[],null],["t35",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xb88c1f7bf22fb,[["b8-sheet0.png",158,0,0,74,54,1,0.5,0.5,[["Imagepoint 1",0.06756756454706192,0.2777777910232544],["Imagepoint 2",0.9594594836235046,0.2962962985038757]],[-0.4341216087341309,-0.4189814925193787,
0.4628379940986633,-0.4166666865348816,0.4628379940986633,0.006945013999938965,-0.4290539920330048,0.006944000720977783],0]]]],[],!1,!1,0x422396a255e13,[],null],["t36",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8462767922673472,[["b8-sheet0.png",158,0,0,74,54,1,0.5,0.5,[["Imagepoint 1",0.06756756454706192,0.2777777910232544],["Imagepoint 2",0.9594594836235046,0.2962962985038757]],[-0.4341216087341309,-0.4189814925193787,0.4628379940986633,-0.4166666865348816,0.4628379940986633,0.006945013999938965,
-0.4290539920330048,0.006944000720977783],0]]]],[],!1,!1,8351554016858002,[],null],["t37",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x7f39cbf3e4591,[["b8-sheet0.png",158,0,0,74,54,1,0.5,0.5,[["Imagepoint 1",0.06756756454706192,0.2777777910232544],["Imagepoint 2",0.9594594836235046,0.2962962985038757]],[-0.4341216087341309,-0.4189814925193787,0.4628379940986633,-0.4166666865348816,0.4628379940986633,0.006945013999938965,-0.4290539920330048,0.006944000720977783],0]]]],[],!1,!1,0xa4fbc3a096024,
[],null],["t38",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xdc45f5e1245e4,[["rampextenderend-sheet0.png",332,0,0,279,256,1,0.4982078969478607,0.5,[["Imagepoint 1",0.00358422938734293,0.53515625]],[-0.4982078969478607,0.0898439884185791,-0.4982078969478607,0.007812976837158203,0.5017920732498169,-0.0117189884185791,0.5017920732498169,0.0820310115814209],0]]]],[["Physics",cr.behaviors.Physics,0x7d3f264bd0eef]],!1,!1,0x573c7a135bfd4,[],null],["t39",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",
5,!1,1,0,!1,6015585037715452,[["rampextenderend3-sheet0.png",336,0,0,279,256,1,0.5017921328544617,0.5,[["Imagepoint 1",0.9820788502693176,0.48828125]],[-0.5017921328544617,0.08789098262786865,-0.5017921328544617,-0.003906011581420898,0.4982078671455383,-0.00585898756980896,0.4982078671455383,0.08398401737213135],0]]]],[["Physics",cr.behaviors.Physics,7872653611805327]],!1,!1,0xdf5d8c9720c00,[],null],["t40",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8606534796923017,[["sprite2-sheet0.png",
110041,0,0,1263,729,1,0.5003958940505981,0.5006858706474304,[],[],1]]]],[],!1,!1,6116710164169926,[],null],["t41",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5941478085007537,[["backgrounbuymenu-sheet0.png",43375,0,0,667,461,1,0.5007496476173401,0.5010846257209778,[],[],0]]]],[],!1,!1,737713994879812,[],null],["t42",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground.png",7567,0],null,[],!1,!1,9405132468535160,[],null],["t43",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",0,!1,1,0,!1,4878342821195391,
[["gjmbike-sheet0.png",1167402,0,0,1397,782,1,0.4996415674686432,0.5,[["RearForce",-7.168458541855216E-4,0.6435897350311279],["FrontForce",0.9741935729980469,0.7333333492279053],["Imagepoint 3",0.3491039574146271,0.03717948868870735],["Imagepoint 4",0.4996415674686432,0.5115384459495544],["hand",0.6315411925315857,0.04487179592251778],["foot",0.4365591406822205,0.7653846144676208],["ridersseat",0.34336918592453,0.2243589758872986],["exhaustsmoke",0.1111111119389534,0.3884615302085877],["knee",0.4781362116336823,
0.5243589878082275],["frontwheel",0.8996415734291077,0.8371794819831848],["rearwheel",0.08387096971273422,0.8987179398536682]],[-0.3383515477180481,-0.07948800921440125,0.1347674429416657,-0.4743588864803314,0.4673844277858734,-0.09999999403953552,0.4336914122104645,0.5,0.09498241543769836,0.3583329916000366,-0.08655956387519836,0.3682699799537659,-0.4465949535369873,0.4743589758872986],0],["gjmbike-sheet0.png",1167402,0,782,1397,782,1,0.5003584027290344,0.5,[["RearForce",-7.168458541855216E-4,0.6435897350311279],
["FrontForce",0.9741935729980469,0.7333333492279053],["Imagepoint 3",0.3491039574146271,0.03717948868870735],["Imagepoint 4",0.4996415674686432,0.5115384459495544],["hand",0.6315411925315857,0.04487179592251778],["foot",0.4365591406822205,0.7653846144676208],["ridersseat",0.34336918592453,0.2243589758872986],["knee",0.4781362116336823,0.5243589878082275],["exhaustsmoke",0.1340501755475998,0.3679487109184265],["frontwheel",0.8996415734291077,0.8371794819831848],["rearwheel",0.08387096971273422,0.8987179398536682]],
[-0.3792113959789276,-0.05897501111030579,0.1340506076812744,-0.4743588864803314,0.456631600856781,-0.1538459956645966,0.4329745769500732,0.5,0.09426558017730713,0.3583329916000366,-0.0872763991355896,0.3682699799537659,-0.4473118185997009,0.4743589758872986],0],["gjmbike-sheet1.png",1173562,0,0,1397,782,1,0.4996415674686432,0.5,[["RearForce",-7.168458541855216E-4,0.6435897350311279],["FrontForce",0.9741935729980469,0.7333333492279053],["Imagepoint 3",0.3491039574146271,0.03717948868870735],["Imagepoint 4",
0.4996415674686432,0.5115384459495544],["hand",0.6315411925315857,0.04487179592251778],["foot",0.4365591406822205,0.7653846144676208],["ridersseat",0.34336918592453,0.2243589758872986],["knee",0.4781362116336823,0.5243589878082275],["exhaustsmoke",0.05949820950627327,0.321794867515564],["frontwheel",0.8996415734291077,0.8371794819831848],["rearwheel",0.08387096971273422,0.8987179398536682]],[-0.3512545824050903,-0.1692309975624085,0.1347674429416657,-0.4743588864803314,0.4802874028682709,-0.14615398645401,
0.4336914122104645,0.5,0.09498241543769836,0.3583329916000366,-0.08655956387519836,0.3682699799537659,-0.4465949535369873,0.4743589758872986],0],["gjmbike-sheet1.png",1173562,0,782,1397,782,1,0.4996415674686432,0.5115384459495544,[["RearForce",-7.168458541855216E-4,0.6435897350311279],["FrontForce",0.9741935729980469,0.7333333492279053],["Imagepoint 3",0.3491039574146271,0.03717948868870735],["Imagepoint 4",0.4996415674686432,0.5115384459495544],["hand",0.6315411925315857,0.04487179592251778],["foot",
0.4365591406822205,0.7653846144676208],["ridersseat",0.34336918592453,0.2243589758872986],["knee",0.4781362116336823,0.5243589878082275],["exhaustsmoke",0.1512544751167297,0.3961538374423981],["frontwheel",0.8996415734291077,0.8371794819831848],["rearwheel",0.08387096971273422,0.8987179398536682]],[-0.3598565459251404,-0.07051345705986023,0.1347674429416657,-0.4858973324298859,0.4673844277858734,-0.11153843998909,0.4336914122104645,0.4884615540504456,0.09498241543769836,0.3467945456504822,-0.08655956387519836,
0.3567315340042114,-0.4465949535369873,0.4628205299377441],0]]]],[["Physics",cr.behaviors.Physics,0x52df9c24db5df],["ScrollTo",cr.behaviors.scrollto,5556794373415785]],!1,!1,4634312869446577,[],null],["t44",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5857709048120372,[["rearwheel-sheet0.png",5936,0,0,91,91,1,0.4945054948329926,0.4945054948329926,[["Imagepoint 1",0.4945054948329926,0.4945054948329926],["Imagepoint 2",0.3296703398227692,0.901098906993866]],[-0.3296704888343811,-0.340659499168396,
-5.066394805908203E-7,-0.4835163950920105,0.3406595289707184,-0.3516474962234497,0.4835164844989777,-5.066394805908203E-7,0.3516484797000885,0.3626364767551422,-5.066394805908203E-7,0.5054944753646851,-0.340659499168396,0.3516475260257721,-0.4945054948329926,-5.066394805908203E-7],0]]]],[["Physics",cr.behaviors.Physics,0x94b493cffa095]],!1,!1,4841964834435422,[],null],["t45",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,9769289749173044,[["frontwheel-sheet0.png",5946,0,0,91,91,1,0.4945054948329926,
0.4945054948329926,[["Imagepoint 1",0.4945054948329926,0.4945054948329926]],[0.1950555145740509,-0.03846150636672974,-0.005494505167007446,0.134614497423172,-0.1126374900341034,-0.14010950922966],0]]]],[["Physics",cr.behaviors.Physics,0xa25992fbe58ef]],!1,!1,0xd37741f1b70c,[],null],["t46",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x600ffc3672de1,[["shaft2-sheet0.png",21737,0,0,391,168,1,0.5012787580490112,0.511904776096344,[["CarBody2",0.9795396327972412,0.2142857164144516],["Wheel2",
0.04347826167941093,0.9166666865348816]],[0.4684182405471802,-0.4606226682662964,0.07447922229766846,-0.02472576498985291,-0.4709757566452026,0.436813235282898,-0.0770367681980133,-0.02472576498985291],0]]]],[["Physics",cr.behaviors.Physics,8765548710637665]],!1,!1,0x81ad957a91d57,[],null],["t47",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,9146006878407848,[["shaft3-sheet0.png",576,0,0,66,39,1,0.5,0.5128205418586731,[["CarBody3",0.9545454382896423,0.07692307978868484],["Wheel3",0.04545454680919647,
0.9230769276618958]],[0,-0.1025645434856415,0.4696969985961914,-0.4615384340286255,0.04545497894287109,0.02564042806625366,-0.4696969985961914,0.4358974695205689],0]]]],[["Physics",cr.behaviors.Physics,0x9067062e8ff3]],!1,!1,0xf1169944f5caa,[],null],["t48",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,7062294164831118,[["shaft3-sheet0.png",576,0,0,66,39,1,0.5,0.5128205418586731,[["CarBody4",0.9545454382896423,0.07692307978868484],["Wheel4",0.5,0.5128205418586731]],[0,-0.1025645434856415,
0.4696969985961914,-0.4615384340286255,0.06060600280761719,0.01923048496246338,-0.4696969985961914,0.4358974695205689],0]]]],[["Physics",cr.behaviors.Physics,0xaa482a0268dd9]],!1,!1,696506164621648,[],null],["t49",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6963958193894592,[["frontdisk-sheet0.png",25396,0,0,205,203,1,0.5121951103210449,0.4975369572639465,[["Imagepoint 1",0.502439022064209,0.5024630427360535]],[-0.08292710781097412,-0.05418696999549866,0.1024388670921326,-0.04433494806289673,
-1.192092895507813E-7,0.1133010387420654],0]]]],[["Pin",cr.behaviors.Pin,0xed3ba1b1691d3]],!1,!1,0xe1d4532fc0889,[],null],["t50",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xfa1a86ceb4212,[["frontdisk-sheet0.png",25396,0,0,205,203,1,0.5121951103210449,0.4975369572639465,[["Imagepoint 1",0.502439022064209,0.5024630427360535]],[0.03902488946914673,-0.093595951795578,0.05365890264511108,0.08374404907226562,-0.1268291175365448,0.01970505714416504],0]]]],[["Pin",cr.behaviors.Pin,0x4624e37b64739]],
!1,!1,9718984205784224,[],null],["t51",cr.plugins_.Facebook,!1,[],0,0,null,null,[],!1,!1,0xb84980170d173,[],null,["",""]],["t52",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4744464013801651,[["sprite-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,7533642480115754,[],null],["t53",cr.plugins_.TiledBg,!1,[],1,0,["tiledbackground2.png",317,1],null,[["Physics",cr.behaviors.Physics,0x3bd1f1180c5f6]],!1,!1,7475733515826275,[],null],["t54",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",
5,!1,1,0,!1,5431017820738456,[["helmet-sheet0.png",275304,0,0,692,540,1,0.5,0.5,[],[-0.4479768872261047,-0.3796299993991852,0.5,-0.5,0.5,0.5,-0.5,0.5],0]]]],[["Physics",cr.behaviors.Physics,7277976573856548]],!1,!1,0xbefa0d84e82aa,[],null],["t55",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x3e32ba58ebbba,[["treebottom-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[["Physics",cr.behaviors.Physics,0xed817f522fc35]],!1,!1,0xd812a229435e3,[],null],["t56",cr.plugins_.Sprite,!1,[],2,
0,null,[["Default",5,!1,1,0,!1,0x4427db6ad10f8,[["riderbody-sheet0.png",1185,0,0,116,248,1,0.5,0.5,[["head",0.5,0],["hips",0.3965517282485962,0.8870967626571655],["arm",0.5603448152542114,0.2056451588869095],["Imagepoint 4",0.5086206793785095,0.9879032373428345]],[-0.2244440019130707,-0.4961089491844177,0.2893880009651184,-0.5,0.1975100040435791,0.5,-0.2560920119285584,0.5],0]]]],[["Physics",cr.behaviors.Physics,5507931312852635],["NoSave",cr.behaviors.NoSave,0xbe649f32dadde]],!1,!1,0x4adc048965791,
[],null],["t57",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,0xf4c496fdf5da8,[["topleg-sheet0.png",1111,0,0,120,290,1,0.5,0.5,[["toptobody",0.4583333432674408,0.1344827562570572],["bottomleg",0.6166666746139526,0.9068965315818787]],[0.0945349931716919,-0.5,0.2908449769020081,0.4965519905090332,0.001730024814605713,0.5,-0.2564449906349182,-0.5],0]]]],[["Physics",cr.behaviors.Physics,4625038467652553],["NoSave",cr.behaviors.NoSave,9393995081688566]],!1,!1,0xcd4b29c1e95de,[],null],["t58",
cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5103490260722276,[["bottomleg-sheet0.png",1137,0,0,106,311,1,0.5,0.5016077160835266,[["toknee",0.4905660450458527,0.1254019290208817],["tofoot",0.5660377144813538,0.8553054928779602]],[0.1584190130233765,-0.5016077160835266,0.2174230217933655,0.4983922839164734,-0.07329300045967102,0.4983922839164734,-0.2405929863452911,-0.5016077160835266],0]]]],[["Physics",cr.behaviors.Physics,7275822138656831]],!1,!1,6892986519002738,[],null],["t59",cr.plugins_.Sprite,
!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x5d72bcc883b59,[["foot-sheet0.png",1126,0,0,348,170,1,0.5,0.5,[["Imagepoint 1",0.2844827473163605,0.4764705896377564],["foottopeg",0.3390804529190064,0.9176470637321472]],[],0]]]],[["Physics",cr.behaviors.Physics,6243570225416812]],!1,!1,0x8475c4bae31c3,[],null],["t60",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,8740663612883005,[["toparm-sheet0.png",1124,0,0,133,303,1,0.5037593841552734,0.5016501545906067,[["shoulder",0.4210526347160339,0.1221122145652771],
["Imagepoint 2",0.4135338366031647,0.8910890817642212]],[0.04740160703659058,-0.4666117429733276,0.03893363475799561,0.4636968374252319,-0.1877743899822235,0.4631008505821228,-0.2074163854122162,-0.4658891558647156],0]]]],[["Physics",cr.behaviors.Physics,7424292119506729],["NoSave",cr.behaviors.NoSave,9274205250754764]],!1,!1,6841745964610514,[],null],["t61",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5679180449805044,[["forarm-sheet0.png",899,0,0,350,86,1,0.5,0.5,[["elbow",0.1171428561210632,
0.5],["hand",0.8657143115997314,0.6744186282157898]],[-0.4496059119701386,0.2668399810791016,-0.4562217891216278,-0.3005210161209106,0.4518569707870483,-0.1647950112819672,0.4527590274810791,0.2996519804000855],0]]]],[["Physics",cr.behaviors.Physics,0x96ab0fc4a5060]],!1,!1,0x80f6a6fb62e25,[],null],["t62",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,4720424063722985,[["pausebutton-sheet0.png",573,0,0,146,149,1,0.5,0.5033556818962097,[],[],0]]]],[["Anchor",cr.behaviors.Anchor,5591982616317529]],
!1,!1,6826162060190273,[],null],["t63",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,4642001969670206,[["pausebutton2-sheet0.png",628,0,0,146,149,1,0.5,0.5033556818962097,[],[],0]]]],[["Anchor",cr.behaviors.Anchor,6506446502479779]],!1,!1,6878843986743084,[],null],["t64",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xe14f351859367,[["pausecontainer-sheet0.png",155,0,0,250,250,1,0.5,0.5,[["Imagepoint 1",0.5,0.5]],[],1]]]],[],!1,!1,0x4d154098c280f,[],null],["t65",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,9191897807829016,[["sprite4-sheet0.png",7995,0,0,75,75,1,0.5066666603088379,0.5066666603088379,[],[],0]]]],[],!1,!1,9377821242693398,[],null],["t66",cr.plugins_.Particles,!1,[],0,0,["particles.png",1418,0],null,[],!1,!1,9057182811520724,[],null],["t67",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,4810765887524344,[["treebottom-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[["Physics",cr.behaviors.Physics,0x9e6e7476a2ab]],!1,!1,7861041233863166,
[],null],["t68",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x64a9a9e0b520b,[["companyname-sheet0.png",4241,0,0,1708,960,1,0.5005854964256287,0.5010416507720947,[],[-0.06498849391937256,-0.09374964237213135,0.0644025206565857,-0.09374964237213135,0.0644025206565857,0.09270834922790527,-0.06498849391937256,0.09270834922790527],1]]]],[["Fade",cr.behaviors.Fade,5276293616368235]],!1,!1,6063775912300159,[],null],["t69",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9180331614621212,
[["introbg-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],4]]]],[],!1,!1,4850601631790249,[],null],["t70",cr.plugins_.Audio,!1,[],0,0,null,null,[],!1,!1,0x87f7918c30bd4,[],null,[0,0,1,1,600,600,1E4,1,5E3,1]],["t71",cr.plugins_.Function,!1,[],0,0,null,null,[],!1,!1,0x5c5097570a6f7,[],null,[]],["t72",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x4e6fd605bac27,[["sprite-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,0xd7d81579eeca5,[],null],["t73",cr.plugins_.Sprite,!1,[],0,0,
null,[["Default",5,!1,1,0,!1,570557399075428,[["abandonlevel-sheet0.png",23156,0,0,610,500,1,0.5,0.5,[],[-0.5,-0.5,0.5,-0.5,0.5,0.5,-0.5,0.4980000257492065],0]]]],[],!1,!1,0x4d681be69cf2a,[],null],["t74",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x774bdba997b07,[["youwin-sheet0.png",621,0,0,148,240,1,0.5,0.5,[],[-0.2364859879016876,-0.5,0.5,-0.5,0.5,0.5,-0.2364870011806488,0.4958329796791077],0]]]],[],!1,!1,7709154059352954,[],null],["t75",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,9404441691091568,[["sprite-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,8024377743557615,[],null],["t76",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6612997862393839,[["appear-sheet0.png",155,0,0,250,250,1,0.5,0.5,[["Imagepoint 1",0.5,0.5]],[],1]]]],[["Anchor",cr.behaviors.Anchor,5507137896699393]],!1,!1,0xed639505cb975,[],null],["t77",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground3.png",169,0],null,[],!1,!1,8729136547562402,[],null],["t78",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,5129078544198713,[["pausebg-sheet0.png",168,0,0,250,250,1,0.5,0.5,[["Imagepoint 1",0.5,0.5]],[],0]]]],[],!1,!1,8303784349009734,[],null],["t79",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xb2286e0207541,[["allgone-sheet0.png",168,0,0,250,250,1,0.5,0.5,[["Imagepoint 1",0.5,0.5]],[],0]]]],[],!1,!1,0x84acd7df344d8,[],null],["t80",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xd28b528e7e0d1,[["pole-sheet0.png",223,0,0,35,240,1,0.5142857432365417,
0.5,[],[],0]]]],[],!1,!1,9042055212212764,[],null],["t81",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",0,!1,1,0,!1,7381428580819242,[["gjmbike2-sheet0.png",1180740,0,0,1397,732,1,0.4996415674686432,0.5123287439346313,[["RearForce",0.006451612804085016,0.6575342416763306],["FrontForce",0.9863799214363098,0.7575342655181885],["Imagepoint 3",0.3462365567684174,0.01095890440046787],["Imagepoint 4",0.4996415674686432,0.5123287439346313],["hand",0.6272401213645935,0.04383561760187149],["foot",0.4451612830162048,
0.8219178318977356],["ridersseat",0.3390681147575378,0.2876712381839752],["Imagepoint 8",0.1555555611848831,0.4164383709430695],["Knee",0.4853046536445618,0.5369862914085388]],[-0.4996415674686432,-0.3493147492408752,0.121863454580307,-0.5123287439346313,0.4308244287967682,-0.2561637461185455,0.09534046053886414,-0.2547947466373444,0.1261644065380096,0.2616442441940308,-0.107526570558548,0.2465752363204956,-0.1620075702667236,-0.1863007545471191],0],["gjmbike2-sheet0.png",1180740,0,732,1397,732,1,
0.4996415674686432,0.5,[["RearForce",0.006451612804085016,0.6575342416763306],["FrontForce",0.9863799214363098,0.7575342655181885],["Imagepoint 3",0.3462365567684174,0.01095890440046787],["Imagepoint 4",0.4996415674686432,0.5123287439346313],["hand",0.6272401213645935,0.04383561760187149],["foot",0.4451612830162048,0.8219178318977356],["ridersseat",0.3390681147575378,0.2876712381839752],["Imagepoint 8",0.1096774190664291,0.4273972511291504],["Knee",0.4853046536445618,0.5369862914085388]],[-0.4996415674686432,
-0.3561649918556213,0.1290324032306671,-0.5,0.4616484344005585,-0.2438350021839142,0.1512544453144074,-0.2006840109825134,0.06200745701789856,0.2318500280380249,-0.1275985538959503,0.2095890045166016,-0.1641575694084168,-0.1876699924468994],0],["gjmbike2-sheet1.png",552306,0,0,1395,730,1,0.4996415674686432,0.5,[["RearForce",0.006451612804085016,0.6575342416763306],["FrontForce",0.9863799214363098,0.7575342655181885],["Imagepoint 3",0.3462365567684174,0.01095890440046787],["Imagepoint 4",0.4996415674686432,
0.5123287439346313],["hand",0.6272401213645935,0.04383561760187149],["foot",0.4451612830162048,0.8219178318977356],["ridersseat",0.3390681147575378,0.2876712381839752],["Imagepoint 8",0.06379928439855576,0.3780821859836578],["Knee",0.4853046536445618,0.5369862914085388]],[-0.3182795643806458,-0.3342459797859192,0.1118284165859222,-0.5,0.4602154195308685,-0.24931401014328,0.0921144187450409,-0.154792994260788,0.06810042262077332,0.2246580123901367,-0.1279575824737549,0.228767991065979,-0.1362005770206451,
-0.104108989238739],0]]]],[["Physics",cr.behaviors.Physics,7999844801722671]],!1,!1,9680857098496316,[],null],["t82",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,9490610455299028,[["shaft3-sheet0.png",576,0,0,66,39,1,0.5,0.5128205418586731,[["CarBody3",0.9545454382896423,0.07692307978868484],["Wheel3",0.04545454680919647,0.9230769276618958]],[0,-0.1025645434856415,0.4696969985961914,-0.4615384340286255,0.04545497894287109,0.02564042806625366,-0.4696969985961914,0.4358974695205689],0]]]],
[["Physics",cr.behaviors.Physics,0xe61b0e2957e2f]],!1,!1,0x5482426cae909,[],null],["t83",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,453360747852093,[["shaft3-sheet0.png",576,0,0,66,39,1,0.5,0.5128205418586731,[["CarBody4",0.9545454382896423,0.07692307978868484],["Wheel4",0.5,0.5128205418586731]],[0,-0.1025645434856415,0.4696969985961914,-0.4615384340286255,0.06060600280761719,0.01923048496246338,-0.4696969985961914,0.4358974695205689],0]]]],[["Physics",cr.behaviors.Physics,8154613718955248]],
!1,!1,0x599b7fafa0141,[],null],["t84",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,8524499021626708,[["shaft2-sheet0.png",21737,0,0,391,168,1,0.5012787580490112,0.511904776096344,[["CarBody2",0.9795396327972412,0.2142857164144516],["Wheel2",0.04347826167941093,0.9166666865348816]],[0.4684182405471802,-0.4606226682662964,0.07447922229766846,-0.02472576498985291,-0.4709757566452026,0.436813235282898,-0.0770367681980133,-0.02472576498985291],0]]]],[["Physics",cr.behaviors.Physics,0xefe518adc565a]],
!1,!1,6788175816364297,[],null],["t85",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6212286037404266,[["frontwheel2-sheet0.png",6017,0,0,100,102,1,0.5,0.5,[["Imagepoint 1",0.5,0.5]],[-0.300000011920929,-0.3039219975471497,0,-0.4313724935054779,0.3100000023841858,-0.3137249946594238,0.4399999976158142,0,0.3199999928474426,0.3235290050506592,0,0.450980007648468,-0.3100000023841858,0.3137249946594238,-0.4600000083446503,0],0]]]],[["Physics",cr.behaviors.Physics,8158936165800751]],!1,!1,
0x6688771efa6da,[],null],["t86",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8049159101099124,[["frontdisk-sheet0.png",25396,0,0,205,203,1,0.5121951103210449,0.4975369572639465,[["Imagepoint 1",0.502439022064209,0.5024630427360535]],[0.02439087629318237,-0.08374395966529846,0.02439087629318237,0.0738910436630249,-0.117073118686676,0.009852051734924316],0]]]],[],!1,!1,0x440d8ce8e3b02,[],null],["t87",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x3f93417850d28,[["frontdisk-sheet0.png",
25396,0,0,205,203,1,0.5121951103210449,0.4975369572639465,[["Imagepoint 1",0.502439022064209,0.5024630427360535]],[-0.0926831066608429,-0.093595951795578,0.06341487169265747,-0.07881796360015869,-0.01463410258293152,0.09359604120254517],0]]]],[],!1,!1,0x503d4c670c5c9,[],null],["t88",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6817152680008565,[["frontwheel2-sheet0.png",6017,0,0,100,102,1,0.5,0.5,[["Imagepoint 1",0.5,0.5],["Imagepoint 2",0.3499999940395355,0.8627451062202454]],[-0.300000011920929,
-0.3039219975471497,0,-0.4313724935054779,0.3100000023841858,-0.3137249946594238,0.4399999976158142,0,0.3199999928474426,0.3235290050506592,0,0.450980007648468,-0.3100000023841858,0.3137249946594238,-0.4600000083446503,0],0]]]],[["Physics",cr.behaviors.Physics,6536096994184386]],!1,!1,5863976959247265,[],null],["t89",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xcb6656ff8d722,[["foot2-sheet0.png",1349,0,0,545,309,1,0.5009174346923828,0.5016181468963623,[["Imagepoint 1",0.2055045813322067,
0.5469255447387695],["foottopeg",0.5009174346923828,0.7734627723693848]],[-0.3137614130973816,0.01941788196563721,0.1541285514831543,0.03236186504364014,0.1614675521850586,0.2912618517875671,-0.3045874238014221,0.2718448638916016],0]]]],[["Physics",cr.behaviors.Physics,0xd52fa92f66f7e]],!1,!1,4993405954362027,[],null],["t90",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x893779d49969a,[["bottomleg2-sheet0.png",1272,0,0,171,337,1,0.5029239654541016,0.501483678817749,[["toknee",0.4093567132949829,
0.1721068322658539],["tofoot",0.4385964870452881,0.9139465689659119]],[-0.1228069663047791,-0.43916916847229,0.157895028591156,-0.008902668952941895,-0.05263197422027588,0.4421363472938538,-0.3567249774932861,2.980232238769531E-7],0]]]],[["Physics",cr.behaviors.Physics,7481808179456406]],!1,!1,0xaff9169a3107b,[],null],["t91",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x82f04d5e01038,[["topleg2-sheet0.png",1288,0,0,289,313,1,0.5017300844192505,0.5015974640846252,[["toptobody",0.4325259625911713,
0.1405750811100006],["bottomleg",0.4913494884967804,0.8466453552246094]],[-0.1280280947685242,-0.4920127987861633,0.1349478960037231,-0.05111846327781677,-5.9604644775390625E-8,0.4249205589294434,-0.2456750869750977,0.02236455678939819],0]]]],[["Physics",cr.behaviors.Physics,706543657487958]],!1,!1,939768649778759,[],null],["t92",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xf42eff1bafdd9,[["riderbody2-sheet0.png",1324,0,0,225,257,1,0.5022222399711609,0.5019454956054688,[["head",0.5022222399711609,
0],["hips",0.4355555474758148,0.9610894918441772],["arm",0.6355555653572083,0.3735408484935761],["Imagepoint 4",0.5066666603088379,0.9883268475532532]],[-0.2266662418842316,-0.4980544447898865,0.08888977766036987,-0.5019454956054688,0.1866667866706848,0.4124515056610107,-0.2755552530288696,0.4435794949531555],0]]]],[["Physics",cr.behaviors.Physics,8006082537788146]],!1,!1,0x8852ee4056f41,[],null],["t93",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xa6200074605f5,[["toparm2-sheet0.png",
1219,0,0,289,313,1,0.5017300844192505,0.5015974640846252,[["shoulder",0.418685108423233,0.1214057505130768],["Imagepoint 2",0.4117647111415863,0.8913738131523132]],[-0.09342607855796814,-0.4632587730884552,0.1349478960037231,-0.09904146194458008,-0.06920409202575684,0.4664535522460938,-0.2768160700798035,-0.03514346480369568],0]]]],[["Physics",cr.behaviors.Physics,0x78ad7e323237]],!1,!1,0xf94524fc59b8a,[],null],["t94",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xece0e59988cc6,[["forarm2-sheet0.png",
987,0,0,377,174,1,0.5013262629508972,0.5,[["elbow",0.1538461595773697,0.5574712753295898],["hand",0.8488063812255859,0.7011494040489197]],[-0.4323607683181763,0.05172401666641235,-0.01326227188110352,-0.1551719903945923,0.4005307555198669,0.1724140048027039,-0.01856726408004761,0.2298849821090698],0]]]],[["Physics",cr.behaviors.Physics,6479875609690504]],!1,!1,0xd2c79a4dde0b4,[],null],["t95",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,637924661871945,[["helmet2-sheet0.png",279070,0,
0,736,736,1,0.5,0.5,[],[],0]]]],[["Physics",cr.behaviors.Physics,6505285358045596]],!1,!1,6637561041481481,[],null],["t96",cr.plugins_.Particles,!1,[],0,0,["particles3.png",1260,0],null,[],!1,!1,6511576511354016,[],null],["t97",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,8602758014269937,[["collision2-sheet0.png",93,0,0,18,18,1,0.5,0.5,[],[],1]]]],[["Physics",cr.behaviors.Physics,0xcc166f5454068]],!1,!1,6009113712796194,[],null],["t98",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,
!1,1,0,!1,0x8e7d8628285df,[["redlight-sheet0.png",339,0,0,107,430,1,0.5046728849411011,0.5,[],[],0]]]],[],!1,!1,5216448241998577,[],null],["t99",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,7101114082019266,[["lightsystem-sheet0.png",3237,0,0,318,145,1,0.5,0.503496527671814,[],[],0],["lightsystem-sheet0.png",3237,0,145,318,145,1,0.5,0.503496527671814,[],[],0],["lightsystem-sheet0.png",3237,0,290,318,145,1,0.5,0.503496527671814,[],[],0],["lightsystem-sheet1.png",3253,0,0,318,145,1,0.5,
0.503496527671814,[],[],0],["lightsystem-sheet1.png",3253,0,145,318,145,1,0.5,0.503496527671814,[],[],0],["lightsystem-sheet1.png",3253,0,290,318,145,1,0.5,0.503496527671814,[],[],0]]]],[],!1,!1,0x55226c8553e1f,[],null],["t100",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9345940287159804,[["redlight2-sheet0.png",337,0,0,107,430,1,0.4953271150588989,0.5,[],[0.5046728849411011,0.5,-0.4953271150588989,0.5,-0.4953271150588989,-0.5,0.5046728849411011,-0.5],0]]]],[],!1,!1,0x6d23c87558da,[],
null],["t101",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",0,!1,1,0,!1,8777104738133574,[["startergrid-sheet0.png",293,0,0,219,127,1,0.5022830963134766,0.5039370059967041,[],[0.4794518947601318,0.2598429918289185,-0.2420091032981873,0.2598429918289185,-0.2465750873088837,-0.4645669162273407,0.4977169036865234,-0.5039370059967041],0],["startergrid-sheet1.png",202,0,0,219,127,1,0.5022830963134766,0.5039370059967041,[],[-0.2397260963916779,0.2125979661941528,0.3630139231681824,0.2125979661941528,0.3630139231681824,
0.2637799978256226,-0.2397260963916779,0.2598429918289185],0]]]],[["Physics",cr.behaviors.Physics,0xfd42c211982f7]],!1,!1,0xbb57053959a11,[],null],["t102",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,658319064230714,[["ready-sheet0.png",12668,0,0,1E3,1E3,1,0.5,0.5,[],[-0.3240000009536743,-0.3240000009536743,0.3240000009536743,-0.3240000009536743,0.3240000009536743,0.3240000009536743,-0.3240000009536743,0.3240000009536743],0]]]],[["Anchor",cr.behaviors.Anchor,286864580198024]],!1,!1,5366460154801013,
[],null],["t103",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5598996366429452,[["readyscreen-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xe176908342610,[],null],["t104",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,4553328163738989,[["jump2-sheet0.png",2908,0,0,800,512,1,0.5,0.5,[],[0.5,0.06835901737213135,-0.4724999964237213,0.1464840173721314,-0.4725390076637268,-0.3403629958629608,-0.430077999830246,-0.3525999784469605,-0.3689060211181641,-0.2559809982776642,
-0.3003119826316834,-0.176025003194809,-0.2031239867210388,-0.09423801302909851,-0.03874900937080383,-0.004882991313934326,0.143750011920929,0.04492199420928955,0.2925000190734863,0.0625],0]]]],[["Physics",cr.behaviors.Physics,0xc665181937aa0]],!1,!1,7849031844526539,[],null],["t105",cr.plugins_.TiledBg,!1,[],0,0,["bgtrees.png",1943,0],null,[],!1,!1,0xf5fea412fe8c3,[],null],["t106",cr.plugins_.TiledBg,!1,[],0,0,["bgtrees2.png",1838,0],null,[],!1,!1,5163950739398996,[],null],["t107",cr.plugins_.TiledBg,
!1,[],0,0,["bgtrees3.png",1931,0],null,[],!1,!1,6723517432635586,[],null],["t108",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground4.png",270,1],null,[],!1,!1,0xbd7aa6679c0eb,[],null],["t109",cr.plugins_.TiledBg,!1,[],0,0,["bgtrees4.png",389,0],null,[],!1,!1,5556017478600788,[],null],["t110",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground5.png",270,1],null,[],!1,!1,0xe22483da7cdc5,[],null],["t111",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground6.png",270,1],null,[],!1,!1,7144773506889316,[],null],["t112",
cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground7.png",270,1],null,[],!1,!1,7983216057821753,[],null],["t113",cr.plugins_.TiledBg,!1,[],1,0,["tiledbackground2.png",317,1],null,[["Physics",cr.behaviors.Physics,6133012874241398]],!1,!1,0x460d672fffa0f,[],null],["t114",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6722341405836575,[["sprite12-sheet0.png",1206,0,0,266,58,1,0.5,0.5,[],[-0.4661653935909271,-0.3448280096054077,0,-0.2068969905376434,0.4548869729042053,-0.2931029796600342,0.4473680257797241,
0,0.4097740054130554,0.08620697259902954,0,0.3275859951972961,-0.4661653935909271,0.3448280096054077,-0.4774436056613922,0],0]]]],[],!1,!1,7867298561501929,[],null],["t115",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,746434034614489,[["sky2-sheet0.png",284,0,0,438,445,1,0.5,0.5011236071586609,[],[],1]]]],[["Anchor",cr.behaviors.Anchor,9335740703243236]],!1,!1,9020448076163096,[],null],["t116",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,4511521453884143,[["redlight3-sheet0.png",
308,0,0,107,430,1,0.5046728849411011,0.5,[],[0.1962621212005615,-0.3976739943027496,0.3364490866661072,-0.3976739943027496,0.3644860982894898,0.4767439961433411,0.2242991328239441,0.4744179844856262],0]]]],[["Physics",cr.behaviors.Physics,0xd192327fb4695]],!1,!1,9432057955048554,[],null],["t117",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,68397531645936,[["redlight3-sheet0.png",308,0,0,107,430,1,0.5046728849411011,0.5,[],[],0]]]],[],!1,!1,9009592680809208,[],null],["t118",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,8746163744759873,[["playbg-sheet0.png",33315,0,0,1341,803,1,0.5003728270530701,0.5006226897239685,[],[],1]]]],[],!1,!1,0xc26a6c97b6376,[],null],["t119",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,4751404193933957,[["sky-sheet0.png",284,0,0,438,445,1,0.5,0.5011236071586609,[],[],1]]]],[["Anchor",cr.behaviors.Anchor,5201968019433677]],!1,!1,0xfc8dd9bbf2602,[],null],["t120",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",4,!0,1,0,!1,0x4258070bdc6c9,
[["playbutton-sheet0.png",3488,0,0,211,106,1,0.5023696422576904,0.5,[],[],0]]]],[],!1,!1,8191188145192234,[],null],["t121",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,9645685126888892,[["sky4-sheet0.png",284,0,0,438,445,1,0.5,0.5011236071586609,[],[],4]]]],[["Anchor",cr.behaviors.Anchor,0xf16850d6b87b8],["Fade",cr.behaviors.Fade,5625310300227265]],!1,!1,743969033795005,[],null],["t122",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xeb85f37157db6,[["fbpublish-sheet0.png",
10658,0,0,300,300,1,0.5,0.5,[],[-0.3166670203208923,-0.3166670203208923,0.3166670203208923,-0.3166670203208923,0.3166670203208923,0.3166670203208923,-0.3166670203208923,0.3166670203208923],0]]]],[],!1,!1,6540011839216128,[],null],["t123",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8848098995965807,[["fbfindpage-sheet0.png",11909,0,0,1788,594,1,0.5,0.5,[],[-0.4927293062210083,-0.4781144857406616,0.4927290081977844,-0.4781144857406616,0.4927290081977844,0.4781140089035034,-0.4927293062210083,
0.4781140089035034],0]]]],[],!1,!1,0x6e7e9870f8693,[],null],["t124",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x9eb7a59a1f8c1,[["fblike-sheet0.png",97976,0,0,1126,830,1,0.5,0.5,[],[],0]]]],[],!1,!1,7745941503449202,[],null],["t125",cr.plugins_.Browser,!1,[],0,0,null,null,[],!1,!1,0x7f58229bcbc54,[],null,[]],["t126",cr.plugins_.Clay,!1,[],0,0,null,null,[],!1,!1,6556178117322595,[],null,["mxadventure",1,0,1]],["t127",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground9.png",270,1],null,
[],!1,!1,680497737939535,[],null],["t128",cr.plugins_.TiledBg,!1,[],0,0,["bgtrees3.png",1931,0],null,[],!1,!1,4561651970742708,[],null],["t129",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground10.png",270,1],null,[],!1,!1,0x5e294ae02212e,[],null],["t130",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground11.png",270,1],null,[],!1,!1,5570403491057967,[],null],["t131",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground12.png",270,1],null,[],!1,!1,0xde1e6b7cef377,[],null],["t132",cr.plugins_.TiledBg,!1,[],1,0,
["tiledbackground2.png",317,1],null,[["Physics",cr.behaviors.Physics,0x517669bde7534]],!1,!1,8636219058168801,[],null],["t133",cr.plugins_.TiledBg,!1,[],1,0,["tiledbackground14.png",270,1],null,[["Physics",cr.behaviors.Physics,7275965026768641]],!1,!1,0xf09d8062ecae5,[],null],["t134",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,4868868628451383,[["treebottom-sheet0.png",155,0,0,250,250,1,0.5,0.5,[["Imagepoint 1",0.5,0]],[],1]]]],[["Physics",cr.behaviors.Physics,9829006219950052]],!1,
!1,0xf5a35b1428e09,[],null],["t135",cr.plugins_.Particles,!1,[],0,0,["particles5.png",1339,0],null,[],!1,!1,0x98b1270843853,[],null],["t136",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xdb436cc4d87f,[["treebottom-sheet0.png",155,0,0,250,250,1,0.5,0.5,[["Imagepoint 1",0.5,0.5]],[],1]]]],[["Physics",cr.behaviors.Physics,8673518269052206]],!1,!1,0xc40224cbced26,[],null],["t137",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",0,!1,1,0,!1,6594633892361169,[["gjmbike3-sheet0.png",589393,0,
0,1600,1200,1,0.5,0.5074999928474426,[["RearForce",0.05249999836087227,0.596666693687439],["FrontForce",0.9243749976158142,0.6566666960716248],["Imagepoint 3",0.3662500083446503,0.1641666740179062],["Imagepoint 4",0.5,0.5074999928474426],["hand",0.5881249904632568,0.1333333402872086],["foot",0.4518750011920929,0.628333330154419],["ridersseat",0.3618749976158142,0.2058333307504654],["Imagepoint 8",0.1687500029802322,0.362500011920929],["Imagepoint 9",0.1693750023841858,0.8566666841506958]],[-0.4449999928474426,
-0.2125000059604645,0.106249988079071,-0.3725000023841858,0.3756250143051148,-0.1558330059051514,0.08312499523162842,-0.1550000011920929,0.1100000143051148,0.1591669917106628,-0.09375,0.1499999761581421,-0.1412500143051148,-0.113332986831665],0],["gjmbike3-sheet1.png",575213,0,0,1600,1200,1,0.5,0.5,[["RearForce",0.05249999836087227,0.596666693687439],["FrontForce",0.9243749976158142,0.6566666960716248],["Imagepoint 3",0.3662500083446503,0.1641666740179062],["Imagepoint 4",0.5,0.5074999928474426],
["hand",0.5881249904632568,0.1333333402872086],["foot",0.4518750011920929,0.628333330154419],["ridersseat",0.3618749976158142,0.2058333307504654],["Imagepoint 8",0.1368750035762787,0.3549999892711639],["Imagepoint 9",0.1693750023841858,0.8566666841506958]],[-0.4518750011920929,-0.2166669964790344,0.112500011920929,-0.3666670024394989,0.4025000333786011,-0.1483330130577087,0.1318749785423279,-0.1220830082893372,0.05406302213668823,0.1410419940948486,-0.1112500131130219,0.1274999976158142,-0.1431249976158142,
-0.1141659915447235],0],["gjmbike3-sheet2.png",564282,0,0,1600,1200,1,0.5,0.5,[["RearForce",0.05249999836087227,0.596666693687439],["FrontForce",0.9243749976158142,0.6566666960716248],["Imagepoint 3",0.3662500083446503,0.1641666740179062],["Imagepoint 4",0.5,0.5074999928474426],["hand",0.5893750190734863,0.1308333277702332],["foot",0.4518750011920929,0.628333330154419],["ridersseat",0.3318749964237213,0.2408333271741867],["Imagepoint 8",0.08812499791383743,0.3166666626930237],["Imagepoint 9",0.1693750023841858,
0.8566666841506958]],[-0.2775000035762787,-0.2033329904079437,0.09749996662139893,-0.3700000047683716,0.4012500047683716,-0.151665985584259,0.08031201362609863,-0.09416601061820984,0.05937498807907105,0.136667013168335,-0.1115629971027374,0.1391670107841492,-0.1187500059604645,-0.06333300471305847],0]]]],[["Physics",cr.behaviors.Physics,0xcf9b898575553]],!1,!1,5010967024801801,[],null],["t138",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",0,!1,1,0,!1,9859319653877954,[["gjmbike3-sheet0.png",589393,
0,0,1600,1200,1,0.5,0.5074999928474426,[["RearForce",0.05249999836087227,0.596666693687439],["FrontForce",0.9243749976158142,0.6566666960716248],["Imagepoint 3",0.3662500083446503,0.1641666740179062],["Imagepoint 4",0.5,0.5074999928474426],["hand",0.5881249904632568,0.1333333402872086],["foot",0.4518750011920929,0.628333330154419],["ridersseat",0.3618749976158142,0.2058333307504654],["Imagepoint 8",0.1687500029802322,0.362500011920929],["Imagepoint 9",0.1693750023841858,0.8566666841506958]],[-0.4449999928474426,
-0.2125000059604645,0.106249988079071,-0.3725000023841858,0.3756250143051148,-0.1558330059051514,0.08312499523162842,-0.1550000011920929,0.1100000143051148,0.1591669917106628,-0.09375,0.1499999761581421,-0.1412500143051148,-0.113332986831665],0],["gjmbike3-sheet1.png",575213,0,0,1600,1200,1,0.5,0.5,[["RearForce",0.05249999836087227,0.596666693687439],["FrontForce",0.9243749976158142,0.6566666960716248],["Imagepoint 3",0.3662500083446503,0.1641666740179062],["Imagepoint 4",0.5,0.5074999928474426],
["hand",0.5881249904632568,0.1333333402872086],["foot",0.4518750011920929,0.628333330154419],["ridersseat",0.3618749976158142,0.2058333307504654],["Imagepoint 8",0.1368750035762787,0.3549999892711639],["Imagepoint 9",0.1693750023841858,0.8566666841506958]],[-0.4518750011920929,-0.2166669964790344,0.112500011920929,-0.3666670024394989,0.4025000333786011,-0.1483330130577087,0.1318749785423279,-0.1220830082893372,0.05406302213668823,0.1410419940948486,-0.1112500131130219,0.1274999976158142,-0.1431249976158142,
-0.1141659915447235],0],["gjmbike3-sheet2.png",564282,0,0,1600,1200,1,0.5,0.5,[["RearForce",0.05249999836087227,0.596666693687439],["FrontForce",0.9243749976158142,0.6566666960716248],["Imagepoint 3",0.3662500083446503,0.1641666740179062],["Imagepoint 4",0.5,0.5074999928474426],["hand",0.5893750190734863,0.1308333277702332],["foot",0.4518750011920929,0.628333330154419],["ridersseat",0.3318749964237213,0.2408333271741867],["Imagepoint 8",0.08812499791383743,0.3166666626930237],["Imagepoint 9",0.1693750023841858,
0.8566666841506958]],[-0.2775000035762787,-0.2033329904079437,0.09749996662139893,-0.3700000047683716,0.4012500047683716,-0.151665985584259,0.08031201362609863,-0.09416601061820984,0.05937498807907105,0.136667013168335,-0.1115629971027374,0.1391670107841492,-0.1187500059604645,-0.06333300471305847],0]]]],[["Physics",cr.behaviors.Physics,0xb8344185e6f80]],!1,!1,8270727886890981,[],null],["t139",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xb3aa09d56796b,[["redlight5-sheet0.png",311,0,
0,107,430,1,0.5046728849411011,0.5,[["Imagepoint 1",0.7757009267807007,0.02790697664022446]],[0.1962611079216003,-0.4837208986282349,0.3364490866661072,-0.4825581014156342,0.3364490866661072,0.411628007888794,0.1962611079216003,0.4104660153388977],0]]]],[["Physics",cr.behaviors.Physics,0xa9702c205d27c]],!1,!1,7090971659334965,[],null],["t140",cr.plugins_.TiledBg,!1,[],0,0,["bgtrees6.png",2885,0],null,[],!1,!1,0xdf8069911656,[],null],["t141",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground15.png",270,
1],null,[],!1,!1,9420106063584124,[],null],["t142",cr.plugins_.TiledBg,!1,[],0,0,["bgtrees7.png",2069,0],null,[],!1,!1,0x566043f1aeb9e,[],null],["t143",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground16.png",270,1],null,[],!1,!1,0x44e576661ea60,[],null],["t144",cr.plugins_.TiledBg,!1,[],0,0,["bgtrees8.png",963,0],null,[],!1,!1,6311739785929656,[],null],["t145",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground17.png",270,1],null,[],!1,!1,390914024490209,[],null],["t146",cr.plugins_.TiledBg,!1,[],0,0,
["bgtrees9.png",594,0],null,[],!1,!1,0x90463a844063,[],null],["t147",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground18.png",270,1],null,[],!1,!1,0xf97f6a371d979,[],null],["t148",cr.plugins_.TiledBg,!1,[],1,0,["tiledbackground14.png",270,1],null,[["Physics",cr.behaviors.Physics,8240477077364309]],!1,!1,0xe8106ec47987c,[],null],["t149",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x759a185886d0b,[["collision-sheet0.png",93,0,0,18,18,1,0.5,0.5,[["Imagepoint 1",0,0]],[],1]]]],[["Physics",
cr.behaviors.Physics,9005789847531175]],!1,!1,5429778063436633,[],null],["t150",cr.plugins_.Sprite,!1,[],0,1,null,[["Default",5,!1,1,0,!1,5481286407558174,[["water-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xc11cd857d5c36,[["water","Water"]],null],["t151",cr.plugins_.Sprite,!1,[],0,3,null,[["Default",5,!1,1,0,!1,4960939431643924,[["water-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,9036988604028268,[["water","Water"],["warpripple","WarpRipple"],["crystalball","CrystalBall"]],
null],["t152",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6326585856144584,[["housewood-sheet0.png",1252,0,0,281,220,1,0.5017793774604797,0.5,[],[-0.1992883682250977,-0.2363629937171936,-0.007117390632629395,-0.3181819915771484,0.1992875933647156,-0.195455014705658,-0.2882563769817352,0.04545497894287109],0]]]],[["Physics",cr.behaviors.Physics,9222387598286028]],!1,!1,6866560926817157,[],null],["t153",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,4959373311024671,[["woodpanel-sheet0.png",
137,0,0,17,451,1,0.529411792755127,0.5011086463928223,[["Imagepoint 1",0.529411792755127,0.5011086463928223]],[],1]]]],[["Physics",cr.behaviors.Physics,5983699277760779]],!1,!1,568678124840845,[],null],["t154",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x4325a77438982,[["woodpanel-sheet0.png",137,0,0,17,451,1,0.529411792755127,0.5011086463928223,[["Imagepoint 1",0.529411792755127,0.5011086463928223]],[],1]]]],[["Physics",cr.behaviors.Physics,5146976815338746]],!1,!1,7634962224592575,
[],null],["t155",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xf7b80ddd26bd7,[["housedoor-sheet0.png",620,0,0,250,450,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xfd9650f11a4e,[],null],["t156",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8349206061637697,[["window2-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,0x411fb940f89e0,[],null],["t157",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,6573155286238053,[["woodpanel-sheet0.png",137,0,0,17,451,1,0.529411792755127,
0.5011086463928223,[["Imagepoint 1",0.529411792755127,0.5011086463928223]],[],1]]]],[["Physics",cr.behaviors.Physics,9301791542667064]],!1,!1,9366263610057124,[],null],["t158",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground20.png",306,0],null,[],!1,!1,5132997614107358,[],null],["t159",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground21.png",339,0],null,[],!1,!1,0xcb6ed76066c19,[],null],["t160",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,297792954183426,[["rollingwood-sheet0.png",1092,
0,0,158,151,1,0.5126582384109497,0.4966887533664703,[],[],0]]]],[["Physics",cr.behaviors.Physics,0xc8dd7e2988b80]],!1,!1,6595716553796353,[],null],["t161",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9375520297558316,[["waveeffect-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xad0701b71c09d,[],null],["t162",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xbe0d49f72287f,[["waveeffect-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xd0d55b7329877,[],
null],["t163",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x7ddc2e6baa3f3,[["rope-sheet0.png",101,0,0,25,250,1,0.5199999809265137,0.5,[],[],1]]]],[],!1,!1,0x4b800f3d21078,[],null],["t164",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8379346482614419,[["rope-sheet0.png",101,0,0,25,250,1,0.5199999809265137,0.5,[],[],1]]]],[],!1,!1,8158478215458054,[],null],["t165",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xe9c2b3493fa4d,[["newgame-sheet0.png",6634,0,0,441,
89,1,0.5011337995529175,0.5056179761886597,[],[],0]]]],[],!1,!1,704214108070036,[],null],["t166",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8609393147027927,[["continue-sheet0.png",5309,0,0,375,89,1,0.5013333559036255,0.5056179761886597,[],[],0]]]],[],!1,!1,73488455653522,[],null],["t167",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xdc552648d1575,[["sprite7-sheet0.png",23479,0,0,610,500,1,0.5,0.5019999742507935,[],[-0.1196720004081726,-0.1499999761581421,0.1196720004081726,
-0.1499999761581421,0.1196720004081726,0.1480000019073486,-0.1196720004081726,0.1480000019073486],0]]]],[],!1,!1,8803047575272607,[],null],["t168",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,9169187687091356,[],null],["t169",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,6362595205676133,[],null],["t170",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,7465972456687389,[],null],["t171",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,5504155626434299,[],null],["t172",cr.plugins_.Sprite,!1,[],0,0,null,
[["Default",5,!1,1,0,!1,7357468955242043,[["logocredits-sheet0.png",2407,0,0,221,179,1,0.5022624731063843,0.5027933120727539,[],[],1]]]],[],!1,!1,0x8761e627dcf26,[],null],["t173",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xef894dcff6e09,[],null],["t174",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x771bead780409,[],null],["t175",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0x8b80ba6f9352,[],null],["t176",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,6862501956532493,[],null],["t177",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,5263279834903733,[["creditsprite-sheet0.png",5220,0,0,311,89,1,0.5016077160835266,0.5056179761886597,[],[0.4983922839164734,-0.5056179761886597,0.4983922839164734,0.4943820238113403,-0.5016077160835266,0.4943820238113403,-0.5016077160835266,-0.5056179761886597],0]]]],[],!1,!1,9827826703903588,[],null],["t178",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!0,1,0,!1,0xf2799d76b225a,[["frog-sheet0.png",617,0,0,102,102,1,0.5,0.5,[],[],0],["frog-sheet0.png",617,
102,0,102,102,1,0.5,0.5,[],[],0],["frog-sheet0.png",617,0,102,102,102,1,0.5,0.5,[],[],0],["frog-sheet0.png",617,102,102,102,102,1,0.5,0.5,[],[],0],["frog-sheet1.png",615,0,0,102,102,1,0.5,0.5,[],[],0],["frog-sheet1.png",615,102,0,102,102,1,0.5,0.5,[],[],0],["frog-sheet1.png",615,0,102,102,102,1,0.5,0.5,[],[],0],["frog-sheet1.png",615,102,102,102,102,1,0.5,0.5,[],[],0]]]],[["DragDrop",cr.behaviors.DragnDrop,7657190384537662]],!1,!1,5637957117945223,[],null],["t179",cr.plugins_.Text,!1,[],0,0,null,
null,[],!1,!1,7566255884778832,[],null],["t180",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5280036681696972,[["areyousure-sheet0.png",16691,0,0,700,109,1,0.5,0.5045871734619141,[],[-0.5,-0.5045871734619141,0.5,-0.5045871734619141,0.5,0.4862388372421265,-0.5,0.4954128265380859],0]]]],[],!1,!1,0x9847af883f68,[],null],["t181",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8715478455522379,[["bggrey-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,610535599309615,[],
null],["t182",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5868613321874728,[["no-sheet0.png",5613,0,0,226,109,1,0.5,0.5045871734619141,[],[],0]]]],[],!1,!1,6984446835720105,[],null],["t183",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5716329322877372,[["yes-sheet0.png",7106,0,0,249,109,1,0.5020080208778381,0.5045871734619141,[],[],0]]]],[],!1,!1,653804684659399,[],null],["t184",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x3ff4f22086984,[["sprite6-sheet0.png",
359,0,0,140,117,1,0.5,0.504273533821106,[],[],0]]]],[],!1,!1,9203759280701364,[],null],["t185",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!1,1,0,!1,6393167343055589,[["soundbutton-sheet0.png",639,0,0,146,149,1,0.5,0.5033556818962097,[],[-0.5,-0.2348996698856354,0.5,-0.2348996698856354,0.5,0.4966443181037903,-0.5,0.4966443181037903],0],["soundbutton-sheet1.png",977,0,0,146,149,1,0.5,0.5033556818962097,[],[],0]]]],[],!1,!1,0x778b2621b0feb,[],null],["t186",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!1,1,0,!1,7869026169435065,[["soundbutton-sheet1.png",977,0,0,146,149,1,0.5,0.5033556818962097,[],[-0.5,-0.2348996698856354,0.5,-0.2348996698856354,0.5,0.4966443181037903,-0.5,0.4966443181037903],0]]]],[],!1,!1,750889885510714,[],null],["t187",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,5053729787055487,[],null],["t188",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x7ed76333c2107,[["sprite9-sheet0.png",1014,0,0,250,800,1,0.5,0.5,[],[],0]]]],[],!1,!1,782508995691116,[],null],["t189",
cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8470351011795042,[["sprite10-sheet0.png",956,0,0,250,800,1,0.5,0.5,[],[0.5,0.5,-0.5,0.5,-0.5,-0.5,0.5,-0.5],0]]]],[],!1,!1,5342568830731149,[],null],["t190",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xa451b26d154e,[],null],["t191",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xbed15e32111ef,[["chain-sheet0.png",159,0,0,7,50,1,0.5714285969734192,0.5,[],[],0]]]],[],!1,!1,0x78c0998dfe3ed,[],null],["t192",cr.plugins_.Sprite,!1,
[],0,0,null,[["Default",5,!1,1,0,!1,5607221318109497,[["chain-sheet0.png",159,0,0,7,50,1,0.5714285969734192,0.5,[],[],0]]]],[],!1,!1,4878861788490099,[],null],["t193",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,697335297512909,[["chain3-sheet0.png",205,0,0,4,49,1,0.5,0.5102040767669678,[],[],0]]]],[],!1,!1,7179045312454321,[],null],["t194",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5945989864721486,[["chain3-sheet0.png",205,0,0,4,49,1,0.5,0.5102040767669678,[],[],0]]]],
[],!1,!1,472231748251171,[],null],["t195",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6041220947033096,[["chain-sheet0.png",159,0,0,7,50,1,0.5714285969734192,0.5,[],[],0]]]],[],!1,!1,0x54372d126bfe0,[],null],["t196",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x5fbf451cb4136,[["chain3-sheet0.png",205,0,0,4,49,1,0.5,0.5102040767669678,[],[],0]]]],[],!1,!1,4875488227069586,[],null],["t197",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xeaadfbdce2087,[["trucktrailer-sheet0.png",
7014,0,0,818,287,1,0.5,0.5017421841621399,[["Imagepoint 1",0.1100244522094727,0.8606271743774414],["Imagepoint 2",0.2053789794445038,0.8606271743774414]],[-0.4883863031864166,-0.4668989777565002,0.5,-0.4634146690368652,0.5,0.1986067891120911,0.1653419733047485,0.29616779088974,-0.4883863031864166,0.1846688389778137],0]]]],[["Physics",cr.behaviors.Physics,5289122456601095]],!1,!1,5444837902465083,[],null],["t198",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xb5846daafdbcd,[["trailerwheelrear-sheet0.png",
120305,0,0,400,400,1,0.5,0.5,[],[-0.3499999940395355,-0.3499999940395355,0,-0.4975000023841858,0.3525000214576721,-0.3525000214576721,0.4950000047683716,0,0.3500000238418579,0.3500000238418579,0,0.4900000095367432,-0.3449999988079071,0.3450000286102295,-0.4925000071525574,0],0]]]],[["Physics",cr.behaviors.Physics,0xf27f50e4d5ab1]],!1,!1,0x5721716abe186,[],null],["t199",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,7389868874653722,[["trailerwheelrear-sheet0.png",120305,0,0,400,400,1,0.5,
0.5,[],[-0.3499999940395355,-0.3499999940395355,0,-0.4975000023841858,0.3525000214576721,-0.3525000214576721,0.4950000047683716,0,0.3500000238418579,0.3500000238418579,0,0.4900000095367432,-0.3449999988079071,0.3450000286102295,-0.4925000071525574,0],0]]]],[["Physics",cr.behaviors.Physics,6047360086453955]],!1,!1,0x438207218d97d,[],null],["t200",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xe98f54be70c1b,[["truckrg-sheet0.png",5384,0,0,732,584,1,0.5,0.5,[["Imagepoint 1",0.812841534614563,
0.8784246444702148],["Imagepoint 2",0.1284153014421463,0.8801369667053223],["Imagepoint 3",0.8196721076965332,0.5958904027938843]],[0.07376998662948608,-0.2722600102424622,0.4071040153503418,-0.2688360214233398,0.4754099845886231,0.3989719748497009,-0.4808745086193085,0.3150690197944641,0.05191200971603394,0.2457190155982971],0]]]],[["Physics",cr.behaviors.Physics,9465909316699932]],!1,!1,4973739362422344,[],null],["t201",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x724ccde5aa61f,[["trailerwheelrear-sheet0.png",
120305,0,0,400,400,1,0.5,0.5,[],[-0.3499999940395355,-0.3499999940395355,0,-0.4975000023841858,0.3525000214576721,-0.3525000214576721,0.4950000047683716,0,0.3500000238418579,0.3500000238418579,0,0.4900000095367432,-0.3449999988079071,0.3450000286102295,-0.4925000071525574,0],0]]]],[["Physics",cr.behaviors.Physics,900936992729515]],!1,!1,4507995661343891,[],null],["t202",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,7455021858620995,[["trailerwheelrear-sheet0.png",120305,0,0,400,400,1,
0.5,0.5,[],[-0.3499999940395355,-0.3499999940395355,0,-0.4975000023841858,0.3525000214576721,-0.3525000214576721,0.4950000047683716,0,0.3500000238418579,0.3500000238418579,0,0.4900000095367432,-0.3449999988079071,0.3450000286102295,-0.4925000071525574,0],0]]]],[["Physics",cr.behaviors.Physics,8921855385559941]],!1,!1,9851808517218432,[],null],["t203",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,9672631366459832,[["rearwheelarche1-sheet0.png",656,0,0,168,137,1,0.5,0.5036496520042419,[],
[0.494047999382019,-0.5036496520042419,0.5,-0.2116786539554596,-0.5,-0.2262776494026184,-0.5,-0.5036496520042419],0]]]],[["Physics",cr.behaviors.Physics,0x5d804e651f16e]],!1,!1,0xd0861f21c54b0,[],null],["t204",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x678c4841d85bf,[["rearwheelarche1-sheet0.png",656,0,0,168,137,1,0.5,0.5036496520042419,[],[0.5,-0.5036496520042419,0.4880949854850769,-0.2700726389884949,-0.5,-0.2627736330032349,-0.5,-0.5036496520042419],0]]]],[["Physics",cr.behaviors.Physics,
7763355483048509]],!1,!1,0x877295c2ea29c,[],null],["t205",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6981933608390377,[["rglogotrucklight-sheet0.png",8466,0,0,724,89,1,0.5,0.5056179761886597,[],[-0.439226508140564,-0.01123598217964172,0,-0.04494398832321167,0.4102209806442261,0.2247190475463867,0.4171270132064819,-0.1797749698162079,0,0.3707870244979858,-0.439226508140564,0,-0.439226508140564,-0.01123598217964172],0]]]],[],!1,!1,0xc9cdff9784e60,[],null],["t206",cr.plugins_.Sprite,!1,
[],0,0,null,[["Default",5,!1,1,0,!1,0xe1021f9846bc0,[["rglogotruckdark-sheet0.png",8134,0,0,724,89,1,0.5,0.5056179761886597,[],[-0.439226508140564,-0.01123598217964172,0,-0.04494398832321167,0.4102209806442261,0.2247190475463867,0.4171270132064819,-0.1797749698162079,0,0.3707870244979858,-0.439226508140564,0,-0.439226508140564,-0.01123598217964172],0]]]],[],!1,!1,0xa84e7a6bae85d,[],null],["t207",cr.plugins_.Sprite,!1,[],2,0,null,[["Default",5,!1,1,0,!1,34098520619931,[["boat-sheet0.png",1303,0,0,
400,430,1,0.5,0.5,[["Imagepoint 1",0.7049999833106995,0.0651162788271904],["Imagepoint 2",0.7149999737739563,0.4395348727703095]],[-0.175000011920929,-0.2950000166893005,0.20250004529953,-0.4625000059604645,0.2074999809265137,-0.4275000095367432,-0.1725000143051148,-0.2524999976158142],0]]]],[["Sine",cr.behaviors.Sin,0x6e5be3deb4bca],["Sine2",cr.behaviors.Sin,5341080558322247]],!1,!1,5266661462531557,[],null],["t208",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,9750145641983604,[["redlight5-sheet0.png",
311,0,0,107,430,1,0.7383177280426025,0.02093023248016834,[["Imagepoint 1",0.7757009267807007,0.02790697664022446]],[-0.03738373517990112,-0.004651132971048355,0.1028042435646057,-0.003488332033157349,0.1028042435646057,0.8906977772712708,-0.03738373517990112,0.8895357847213745],0]]]],[["Physics",cr.behaviors.Physics,0x69b140ce42041]],!1,!1,9261098038123134,[],null],["t209",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xaa546cac63e47,[["redlight7-sheet0.png",184,0,0,18,387,1,2.111111164093018,
0.4935400485992432,[["Imagepoint 1",1.888888835906982,0.4134366810321808]],[-2.083333253860474,-0.4935400485992432,-1.111111164093018,-0.4935400485992432,-1.111111164093018,0.5064599514007568,-2.111111164093018,0.5064599514007568],0]]]],[["Physics",cr.behaviors.Physics,4974252951447015]],!1,!1,8293411082302676,[],null],["t210",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,796828191262078,[["redlight5-sheet0.png",311,0,0,107,430,1,0.7663551568984985,0.4953488409519196,[["Imagepoint 1",
0.7289719581604004,0.4232558012008667]],[-0.06542116403579712,-0.4790697395801544,0.07476681470870972,-0.4779069423675537,0.07476681470870972,0.4162791669368744,-0.06542116403579712,0.4151171743869782],0]]]],[["Physics",cr.behaviors.Physics,0x8c1a0075e3dcd]],!1,!1,5502670898613998,[],null],["t211",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xdec394430e916,[["redlight5-sheet0.png",311,0,0,107,430,1,0.7663551568984985,0.4953488409519196,[["Imagepoint 1",0.7663551568984985,0.0325581394135952]],
[-0.06542116403579712,-0.4790697395801544,0.07476681470870972,-0.4779069423675537,0.07476681470870972,0.4162791669368744,-0.06542116403579712,0.4151171743869782],0]]]],[["Physics",cr.behaviors.Physics,944487648513912]],!1,!1,9650248096389824,[],null],["t212",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5760809676509001,[["die-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[],!1,!1,9581173415263784,[],null],["t213",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x8558222eac171,
[["rglogotruckdark-sheet0.png",8134,0,0,724,89,1,0.5,0.5056179761886597,[],[-0.439226508140564,-0.01123598217964172,0,-0.04494398832321167,0.4102209806442261,0.2247190475463867,0.4171270132064819,-0.1797749698162079,0,0.3707870244979858,-0.439226508140564,0,-0.439226508140564,-0.01123598217964172],0]]]],[],!1,!1,8838313778990878,[],null],["t214",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,8110368217794931,[["rglogotrucklight-sheet0.png",8466,0,0,724,89,1,0.5,0.5056179761886597,[],[-0.439226508140564,
-0.01123598217964172,0,-0.04494398832321167,0.4102209806442261,0.2247190475463867,0.4171270132064819,-0.1797749698162079,0,0.3707870244979858,-0.439226508140564,0,-0.439226508140564,-0.01123598217964172],0]]]],[],!1,!1,319450953617419,[],null],["t215",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x737b6a8c35bdd,[["rglogotruckdark-sheet0.png",8134,0,0,724,89,1,0.5,0.5056179761886597,[],[-0.439226508140564,-0.01123598217964172,0,-0.04494398832321167,0.4102209806442261,0.2247190475463867,
0.4171270132064819,-0.1797749698162079,0,0.3707870244979858,-0.439226508140564,0,-0.439226508140564,-0.01123598217964172],0]]]],[],!1,!1,8480932815374051,[],null],["t216",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,6988180756789142,[["sprite11-sheet0.png",6993,0,0,483,83,1,0.501035213470459,0.5060241222381592,[],[-0.4223603010177612,-0.04819312691688538,-0.002070218324661255,-0.4216868281364441,0.4099377989768982,0.01204788684844971,0.4099377989768982,-0.02409613132476807,-0.002070218324661255,
0.3975898623466492,-0.4223603010177612,0.03614485263824463],0]]]],[],!1,!1,0xfba9d6891877d,[],null],["t217",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9489318059017052,[["sprite13-sheet0.png",6660,0,0,483,83,1,0.501035213470459,0.5060241222381592,[],[-0.4223603010177612,-0.04819312691688538,-0.002070218324661255,-0.4216868281364441,0.4099377989768982,0.01204788684844971,0.4099377989768982,-0.02409613132476807,-0.002070218324661255,0.3975898623466492,-0.4223603010177612,0.03614485263824463],
0]]]],[],!1,!1,8788467053465308,[],null],["t218",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xeff6d7c2cd51e,[["truckrg2-sheet0.png",5382,0,0,732,584,1,0.5,0.5,[["Imagepoint 1",0.187158465385437,0.8784246444702148],["Imagepoint 2",0.8715847134590149,0.8801369667053223],["Imagepoint 3",0.1803278625011444,0.5958904027938843]],[-0.05191200971603394,0.2457190155982971,0.05054599046707153,0.2825350165367127,0.3975409865379334,0.2594180107116699,0.4890710115432739,0.3069350123405457,-0.4754099845886231,
0.3989719748497009,-0.4467217028141022,-0.2174659967422485,-0.3859289884567261,-0.2739720046520233,-0.07376998662948608,-0.2722600102424622],0]]]],[["Physics",cr.behaviors.Physics,0x7641d45dbc47e]],!1,!1,0x48cef15b7d0e8,[],null],["t219",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,5597006661086165,[["trailerwheelrear-sheet0.png",120305,0,0,400,400,1,0.5,0.5,[],[-0.3499999940395355,-0.3499999940395355,0,-0.4975000023841858,0.3525000214576721,-0.3525000214576721,0.4950000047683716,0,0.3500000238418579,
0.3500000238418579,0,0.4900000095367432,-0.3449999988079071,0.3450000286102295,-0.4925000071525574,0],0]]]],[["Physics",cr.behaviors.Physics,0x7e3669feaeaa8]],!1,!1,0xbceb351fe1326,[],null],["t220",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xe8b26da409f00,[["trailerwheelrear-sheet0.png",120305,0,0,400,400,1,0.5,0.5,[],[-0.3499999940395355,-0.3499999940395355,0,-0.4975000023841858,0.3525000214576721,-0.3525000214576721,0.4950000047683716,0,0.3500000238418579,0.3500000238418579,0,0.4900000095367432,
-0.3449999988079071,0.3450000286102295,-0.4925000071525574,0],0]]]],[["Physics",cr.behaviors.Physics,6569706468542836]],!1,!1,0xb98af57d1622e,[],null],["t221",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9890827907521764,[["rglogotruckdark4-sheet0.png",8105,0,0,724,89,1,0.5,0.5056179761886597,[],[-0.439226508140564,-0.01123598217964172,0,-0.04494398832321167,0.4102209806442261,0.2247190475463867,0.4171270132064819,-0.1797749698162079,0,0.3707870244979858,-0.439226508140564,0,-0.439226508140564,
-0.01123598217964172],0]]]],[],!1,!1,0xbd36d1e294fcb,[],null],["t222",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7512477287679066,[["rglogotruckdark-sheet0.png",8134,0,0,724,89,1,0.5,0.5056179761886597,[],[-0.439226508140564,-0.01123598217964172,0,-0.04494398832321167,0.4102209806442261,0.2247190475463867,0.4171270132064819,-0.1797749698162079,0,0.3707870244979858,-0.439226508140564,0,-0.439226508140564,-0.01123598217964172],0]]]],[],!1,!1,0xdeb19db44e54f,[],null],["t223",cr.plugins_.Sprite,
!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x6317aa195162d,[["rglogotrucklight3-sheet0.png",8437,0,0,724,89,1,0.5,0.5056179761886597,[],[-0.439226508140564,-0.01123598217964172,0,-0.04494398832321167,0.4102209806442261,0.2247190475463867,0.4171270132064819,-0.1797749698162079,0,0.3707870244979858,-0.439226508140564,0,-0.439226508140564,-0.01123598217964172],0]]]],[],!1,!1,0xd2e4dee9dbf6,[],null],["t224",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x54f50e3bab3c9,[["rglogotruckdark-sheet0.png",
8134,0,0,724,89,1,0.5,0.5056179761886597,[],[-0.439226508140564,-0.01123598217964172,0,-0.04494398832321167,0.4102209806442261,0.2247190475463867,0.4171270132064819,-0.1797749698162079,0,0.3707870244979858,-0.439226508140564,0,-0.439226508140564,-0.01123598217964172],0]]]],[],!1,!1,0xcc45e9fff6082,[],null],["t225",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x9b5035f463c92,[["rglogotrucklight3-sheet0.png",8437,0,0,724,89,1,0.5,0.5056179761886597,[],[-0.439226508140564,-0.01123598217964172,
0,-0.04494398832321167,0.4102209806442261,0.2247190475463867,0.4171270132064819,-0.1797749698162079,0,0.3707870244979858,-0.439226508140564,0,-0.439226508140564,-0.01123598217964172],0]]]],[],!1,!1,29090272837128,[],null],["t226",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x7cd28be9db246,[["pausebg2-sheet0.png",168,0,0,250,250,1,0.5,0.5,[["Imagepoint 1",0.5,0.5]],[],0]]]],[],!1,!1,8374021907416237,[],null],["t227",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xf7c640645b0ec,
[["sprite14-sheet0.png",310,0,0,500,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,7060867423210518,[],null],["t228",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,4744121133415182,[["trucktrailer-sheet0.png",7014,0,0,818,287,1,0.5,0.5017421841621399,[["Imagepoint 1",0.1100244522094727,0.8606271743774414],["Imagepoint 2",0.2053789794445038,0.8606271743774414]],[-0.4847187995910645,0.1881527900695801,0.4975550174713135,0.1846688389778137,0.4987779855728149,0.4982578158378601,0.1421149969100952,0.4982578158378601,
-0.4407089948654175,0.4912888407707214],0]]]],[["Physics",cr.behaviors.Physics,0x71912997c63a6]],!1,!1,0xf34cf79e08583,[],null],["t229",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,8780838164946428,[["redlight5-sheet0.png",311,0,0,107,430,1,0.5046728849411011,0.5,[["Imagepoint 1",0.7757009267807007,0.02790697664022446]],[0.1962611079216003,-0.4837208986282349,0.3364490866661072,-0.4825581014156342,0.3364490866661072,0.411628007888794,0.1962611079216003,0.4104660153388977],0]]]],[["Physics",
cr.behaviors.Physics,0x5328b6aaec528]],!1,!1,6908412451312317,[],null],["t230",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xdf75b5ce06d2e,[["redlight5-sheet0.png",311,0,0,107,430,1,0.5046728849411011,0.5,[["Imagepoint 1",0.7757009267807007,0.02790697664022446]],[0.1962611079216003,-0.4837208986282349,0.3364490866661072,-0.4825581014156342,0.3364490866661072,0.411628007888794,0.1962611079216003,0.4104660153388977],0]]]],[["Physics",cr.behaviors.Physics,7196313830798822]],!1,!1,834465497218016,
[],null],["t231",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x4bdc463fbb56b,[["trailerwheelrear-sheet0.png",120305,0,0,400,400,1,0.5,0.5,[],[-0.3499999940395355,-0.3499999940395355,0,-0.4975000023841858,0.3525000214576721,-0.3525000214576721,0.4950000047683716,0,0.3500000238418579,0.3500000238418579,0,0.4900000095367432,-0.3449999988079071,0.3450000286102295,-0.4925000071525574,0],0]]]],[["Physics",cr.behaviors.Physics,0x8787294723aa2]],!1,!1,7489942166241697,[],null],["t232",cr.plugins_.Sprite,
!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x4621820dee79e,[["rearwheelarche1-sheet0.png",656,0,0,168,137,1,0.5,0.5036496520042419,[],[0.494047999382019,-0.5036496520042419,0.5,-0.2116786539554596,-0.5,-0.2262776494026184,-0.5,-0.5036496520042419],0]]]],[["Physics",cr.behaviors.Physics,4817918596880658]],!1,!1,4867829896446973,[],null],["t233",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,8087899527449161,[["redlight12-sheet0.png",174,0,0,16,386,1,0.5,0.5,[["Imagepoint 1",0.5,0.01554404105991125]],
[],0]]]],[["Physics",cr.behaviors.Physics,926553937785458]],!1,!1,0x7e02a22da16d,[],null],["t234",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x6e7bbd5722da2,[["redlight5-sheet0.png",311,0,0,107,430,1,0.5046728849411011,0.5,[["Imagepoint 1",0.7663551568984985,0.9069767594337463]],[0.1962611079216003,-0.4837208986282349,0.3364490866661072,-0.4825581014156342,0.3364490866661072,0.411628007888794,0.1962611079216003,0.4104660153388977],0]]]],[["Physics",cr.behaviors.Physics,8959790644263091]],
!1,!1,8673924173623121,[],null],["t235",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,761549051423604,[["redlight5-sheet0.png",311,0,0,107,430,1,0.5046728849411011,0.5,[["Imagepoint 1",0.7757009267807007,0.02790697664022446]],[0.1962611079216003,-0.4837208986282349,0.3364490866661072,-0.4825581014156342,0.3364490866661072,0.411628007888794,0.1962611079216003,0.4104660153388977],0]]]],[["Physics",cr.behaviors.Physics,5565050499281234]],!1,!1,7349928494178017,[],null],["t236",cr.plugins_.TiledBg,
!1,[],1,0,["tiledbackground14.png",270,1],null,[["Physics",cr.behaviors.Physics,9777953904880824]],!1,!1,0x5ddb078db0c5a,[],null],["t237",cr.plugins_.Particles,!1,[],0,0,["particles2.png",793,0],null,[],!1,!1,0xa2c1474fc7a55,[],null],["t238",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4874804001145195,[["activatelog-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[],!1,!1,0x53ad6cb3512f2,[],null],["t239",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5995666332797973,[["activatelog-sheet0.png",
155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[],!1,!1,0x73ce0cfc5d40c,[],null],["t240",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x63604a6d0a14d,[["activatelog-sheet0.png",155,0,0,250,250,1,0.5,0.5,[],[],1]]]],[],!1,!1,0xcfb62257ef377,[],null],["t241",cr.plugins_.Twitter,!1,[],0,0,null,null,[],!0,!1,22383988138633,[],null],["t242",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,7316217594713784,[],null],["t243",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xbc5bc07db0e2,[],null],["t244",cr.plugins_.TiledBg,
!1,[],1,0,["tiledbackground23.png",749,0],null,[["Physics",cr.behaviors.Physics,9459626349474496]],!1,!1,0xfc485f63c0c43,[],null],["t245",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,0xeff287bcc85c0,[],null],["t246",cr.plugins_.Text,!1,[],0,0,null,null,[],!1,!1,9178722955272372,[],null],["t247",cr.plugins_.TiledBg,!1,[],1,0,["tiledbackground24.png",290,1],null,[["Physics",cr.behaviors.Physics,4785961433549081]],!1,!1,6578997130873293,[],null],["t248",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",
5,!0,1,0,!1,9305904128095536,[["light-sheet0.png",589,0,0,342,270,1,0.5,0.5,[],[],0],["light-sheet1.png",589,0,0,342,270,1,0.5,0.5,[],[],0]]]],[],!1,!1,5336947500530235,[],null],["t249",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,498914694337089,[["building-sheet0.png",102082,0,0,456,824,1,0.5,0.5,[],[],0]]]],[],!1,!1,7997936418859627,[],null],["t250",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xf3bf082400bb6,[["buildinginside-sheet0.png",101955,0,0,456,824,1,0.5,0.5,
[],[],0]]]],[],!1,!1,0xb14b3512d97b5,[],null],["t251",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xbccc5802ecf51,[["windows-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,942235438917451,[],null],["t252",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7996972914885651,[["sprite-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],3]]]],[],!1,!1,6186320160870371,[],null],["t253",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,9282808312503308,[["siderollinglog-sheet0.png",
1513,0,0,465,347,1,0.501075267791748,0.5014409422874451,[],[-0.2193542718887329,0.02305507659912109,-0.169892281293869,-0.07492795586585999,-0.03870928287506104,-0.1613829433917999,0.08010774850845337,-0.1822769343852997,0.1860217452049255,0.007204055786132813,0.08440876007080078,0.1880400776863098,-0.1728492677211762,0.1862390637397766,-0.2451612651348114,0.1123920679092407],0]]]],[["Physics",cr.behaviors.Physics,0x8e1dcb6cadb94]],!1,!1,7102410349542694,[],null],["t254",cr.plugins_.Sprite,!1,[],
0,0,null,[["Default",5,!1,1,0,!1,9659800743222928,[["streetart-sheet0.png",1786,0,0,266,58,1,0.5,0.5,[],[-0.4661653935909271,-0.3448280096054077,0.4097740054130554,0.08620697259902954,-0.4661653935909271,0.3448280096054077],0]]]],[],!1,!1,9128928088126566,[],null],["t255",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",0,!0,1,0,!1,0xcbba9eaa24fdd,[["brokelight-sheet0.png",876,0,0,342,270,1,0.5,0.5,[],[],0],["light-sheet1.png",589,0,0,342,270,1,0.5,0.5,[],[],0]]]],[],!1,!1,7156322209763213,[],null],
["t256",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0x74ec7f9d13ba9,[["4x4-sheet0.png",22747,0,0,272,112,1,0.5,0.5,[],[-0.4503675997257233,-0.1383930146694183,-0.2444849908351898,-0.15625,-0.1985290050506592,-0.3348209857940674,0.08823597431182861,-0.3236609995365143,0.233456015586853,-0.1127229928970337,0.4549630284309387,-0.0429689884185791,0.4761030077934265,0.34375,-0.466911792755127,0.3392850160598755],0]]]],[["Physics",cr.behaviors.Physics,0x6b7f9561763ad]],!1,!1,733289908731864,
[],null],["t257",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5901916235056071,[["brick-sheet0.png",267,0,0,250,250,1,0.5,0.5,[],[-0.4079999923706055,-0.1879999935626984,0.4559999704360962,-0.1879999935626984,0.472000002861023,0.1880000233650208,-0.4120000004768372,0.1840000152587891],0]]]],[],!1,!1,5684319497942349,[],null],["t258",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4519856639616727,[["streetart1-sheet0.png",1786,0,0,266,58,1,0.5,0.5,[],[-0.4661653935909271,-0.3448280096054077,
0.4097740054130554,0.08620697259902954,-0.4661653935909271,0.3448280096054077],0]]]],[],!1,!1,0xccc914c299d37,[],null],["t259",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x453f211101c0b,[["sprite24-sheet0.png",168,0,0,250,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xb091aa6480f64,[],null],["t260",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x394ae409da968,[["streetart2-sheet0.png",1774,0,0,266,58,1,0.5,0.5,[],[-0.4661653935909271,-0.3448280096054077,0.4097740054130554,0.08620697259902954,
-0.4661653935909271,0.3448280096054077],0]]]],[],!1,!1,0xe8cb4e4fa433e,[],null],["t261",cr.plugins_.Sprite,!1,[],1,0,null,[["Default",5,!1,1,0,!1,0xe626f54ea6966,[["driftcar-sheet0.png",39033,0,0,352,143,1,0.5,0.503496527671814,[],[-0.4019885957241058,-0.08391651511192322,-0.2542610168457031,-0.06643351912498474,-0.1605109870433807,-0.2080415189266205,0.01065301895141602,-0.2141605317592621,0.1661930084228516,-0.03496551513671875,0.3267049789428711,-0.01223853230476379,0.4247159957885742,0.1302444934844971,
0.4318180084228516,0.3286714553833008,-0.4048295915126801,0.3111884593963623],0]]]],[["Physics",cr.behaviors.Physics,0xfc1080e46f51b]],!1,!1,5978640970169899,[],null],["t262",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,4934584753684739,[["driftwheel-sheet0.png",3693,0,0,41,46,1,0.5121951103210449,0.5,[],[-0.3658541142940521,-0.3695650100708008,-0.02439010143280029,-0.4347825944423676,0.317072868347168,-0.3478260040283203,0.4634149074554443,0,0.2926828861236572,0.3260869979858398,-0.02439010143280029,
0.4130430221557617,-0.3170731067657471,0.3260869979858398,-0.5121951103210449,0],0]]]],[],!1,!1,7624550495774947,[],null],["t263",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9354075983904156,[["sprite15-sheet0.png",636,0,0,250,250,1,0.5,0.5,[],[],0]]]],[],!1,!1,6339594413538928,[],null],["t264",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x457167bee0b36,[["sprite16-sheet0.png",1693,0,0,465,347,1,0.501075267791748,0.5014409422874451,[],[],0]]]],[],!1,!1,865576455806146,
[],null],["t265",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground25.png",3331,0],null,[],!1,!1,8278884207763887,[],null],["t266",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground26.png",14130,0],null,[],!1,!1,8449753672219352,[],null],["t267",cr.plugins_.TiledBg,!1,[],0,0,["tiledbackground26.png",14130,0],null,[],!1,!1,4960102583639015,[],null],["t268",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x5ca8a89d262d7,[["sprite19-sheet0.png",944598,0,0,1680,1092,1,0.5,0.5,[],[],1]]]],[],!1,!1,
9885608583658476,[],null],["t269",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7690849388627908,[["sprite20-sheet0.png",449,0,0,100,100,1,0.5,0.5,[],[],0]]]],[],!1,!1,8792299617838135,[],null],["t270",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,9298685924926996,[["sprite21-sheet0.png",449,0,0,100,100,1,0.5,0.5,[],[],0]]]],[],!1,!1,0xc1eaabfa26622,[],null],["t271",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x86966118bf9a4,[["sprite22-sheet0.png",449,0,0,100,
100,1,0.5,0.5,[],[],0]]]],[],!1,!1,0x669f1c879ec65,[],null],["t272",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,942711715458275,[["sprite23-sheet0.png",466,0,0,100,100,1,0.5,0.5,[],[],0]]]],[],!1,!1,6430000107813152,[],null],["t273",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0x3df1ba0d03c24,[["sprite25-sheet0.png",1981,0,0,36,36,1,0.5,0.5,[],[-0.300000011920929,-0.3039219975471497,0,-0.4313724935054779,0.3100000023841858,-0.3137249946594238,0.4399999976158142,0,0.3199999928474426,
0.3235290050506592,0,0.450980007648468,-0.3100000023841858,0.3137249946594238,-0.4600000083446503,0],0]]]],[],!1,!1,9074312786705480,[],null],["t274",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,729070147545153,[["continue-sheet0.png",5309,0,0,375,89,1,0.5013333559036255,0.5056179761886597,[],[],0]]]],[],!1,!1,4711554412675933,[],null],["t275",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7670921518991688,[["continue-sheet0.png",5309,0,0,375,89,1,0.5013333559036255,0.5056179761886597,
[],[],0]]]],[],!1,!1,7141830707958925,[],null],["t276",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,0xff9842a228d13,[["continue-sheet0.png",5309,0,0,375,89,1,0.5013333559036255,0.5056179761886597,[],[],0]]]],[],!1,!1,0xab27283264659,[],null],["t277",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,963041072085663,[["continue-sheet0.png",5309,0,0,375,89,1,0.5013333559036255,0.5056179761886597,[],[],0]]]],[],!1,!1,907458525455284,[],null],["t278",cr.plugins_.Sprite,!1,[],0,0,null,
[["Default",5,!1,1,0,!1,0xb009d425dccd7,[["continue-sheet0.png",5309,0,0,375,89,1,0.5013333559036255,0.5056179761886597,[],[],0]]]],[],!1,!1,819710130617908,[],null],["t279",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5780658915169888,[["continue-sheet0.png",5309,0,0,375,89,1,0.5013333559036255,0.5056179761886597,[],[],0]]]],[],!1,!1,6668663037548375,[],null],["t280",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,7661482954101981,[["continue-sheet0.png",5309,0,0,375,89,1,
0.5013333559036255,0.5056179761886597,[],[],0]]]],[],!1,!1,8052820251267483,[],null],["t281",cr.plugins_.Sprite,!1,[],0,0,null,[["Default",5,!1,1,0,!1,5036941049925012,[["twittericon-sheet0.png",21849,0,0,1067,1067,1,0.5004686117172241,0.5004686117172241,[],[-0.4817245006561279,-0.4817245006561279,-9.376108646392822E-4,-0.5004686117172241,0.4798504114151001,-0.4807873070240021,0.4995313882827759,-9.376108646392822E-4,0.4798504114151001,0.4798504114151001,-9.376108646392822E-4,0.4995313882827759,-0.4807873070240021,
0.4798504114151001,-0.5004686117172241,-9.376108646392822E-4],0]]]],[],!1,!1,354121324490905,[],null],["t282",cr.plugins_.Sprite,!0,[],2,0,null,null,[["Physics",cr.behaviors.Physics,6295741346385679],["Solid",cr.behaviors.solid,6325216591777332]],!1,!1,0xb74e36b1ee0d9,[],null],["t283",cr.plugins_.Sprite,!0,[],1,0,null,null,[["NoSave",cr.behaviors.NoSave,7271626020844776]],!1,!1,0xe43ea40442003,[],null],["t284",cr.plugins_.Sprite,!0,[],0,0,null,null,[],!1,!1,0xf92f079f2a104,[],null],["t285",cr.plugins_.Sprite,
!0,[],0,0,null,null,[],!1,!1,0xf62ce1e7778f,[],null],["t286",cr.plugins_.Sprite,!0,[],2,0,null,null,[["Flash",cr.behaviors.Flash,0xaf7c682751e6b],["NoSave2",cr.behaviors.NoSave,8786136336759817]],!1,!1,9642444886489636,[],null]],[[282,33,35,36,37,34,32,31,30,29,28,26,27],[283,45,85,43,81,137,138,54,95,44,88],[284,12,16],[285,58,59,61,56,60,57],[286,90,89,94,86,85,81,137,138,95,87,88,92,82,83,84,93,91]],[["Level1",1708,960,!0,"Level1Event",0xb0be272da0098,[["Layer 4",0,8454027527268701,!0,[255,255,
255],!0,0.2000000029802322,0.2000000029802322,1,!1,1,0,0,[[[999,567.2314453125,0,2048,1163,0,0,1,0.5,0.5011236071586609,0,0,[]],7,17,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-10003,401,0,21728,176,0,0,1,0,0,0,0,[]],109,251,[],[],[0,0]],[[-10436,544,0,22870,1408,0,0,1,0,0,0,0,[]],112,254,[],[],[0,0]]],[]],["Layer 1",1,4517852026686719,!0,[255,255,255],!0,0.4000000059604645,0.4000000059604645,1,!1,1,0,0,[[[-10054,13,0,21840,725,0,0,1,0,0,0,0,[]],105,73,[],[],[0,0]],[[-10348,597,0,22380,1408,0,0,1,0,0,
0,0,[]],111,253,[],[],[0,0]]],[]],["Layer 2",2,5066054151558011,!0,[255,255,255],!0,0.6000000238418579,0.6000000238418579,1,!1,1,0,0,[[[-9925,87,0,21590,758,0,0,1,0,0,0,0,[]],106,75,[],[],[0,0]],[[-10553,664,0,22530,1408,0,0,1,0,0,0,0,[]],110,252,[],[],[0,0]]],[]],["Layer 3",3,7765204342441883,!0,[255,255,255],!0,0.8999999761581421,0.800000011920929,1,!1,1,0,0,[[[-10553,188,0,24928,621,0,0,1,0,0,0,0,[]],107,238,[],[],[0,0]],[[-13742,762,0,28463,1533,0,0,1,0,0,0,0,[]],108,241,[],[],[0,0]]],[]],["Layer 0",
4,0xb2ed4561d1a03,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1076,317,0,38,710.125244140625,0,0,1,0,0,0,0,[]],17,262,[],[],[0,0]],[[-9200,520,0,107,703,0,0,1,0.4953271150588989,0.5,0,0,[]],100,243,[],[],[0,"Default",0,1]],[[-9680,572,0,38,710.125244140625,0,0,1,0,0,0,0,[]],17,231,[],[],[0,0]],[[14136.3154296875,661.3118286132812,0,70.6806640625,376.8765258789063,0,0,1,0.5142857432365417,0.5,0,0,[]],80,208,[],[],[0,"Default",0,1]],[[-6711,251,0,42,687,0,0,1,0,0,0,0,[]],17,33,[],[],[0,0]],[[-7251,306,0,
37,679,0,0,1,0,0,0,0,[]],17,96,[],[],[0,0]],[[-7573,307,0,40,689,0,0,1,0,0,0,0,[]],17,101,[],[],[0,0]],[[-4797,143,0,35,792,0,0,1,0,0,0,0,[]],17,115,[],[],[0,0]],[[-5405,137,0,37,703,0,0,1,0,0,0,0,[]],17,126,[],[],[0,0]],[[-6100,140.375,0,41,809.625,0,0,1,0,0,0,0,[]],17,113,[],[],[0,0]],[[-5060,-230,0,35,334,0,0,1,0,0,0,0,[]],17,112,[],[],[0,0]],[[-5610,-202,0,39,306,0,0,1,0,0,0,0,[]],17,111,[],[],[0,0]],[[-5944.4921875,-197.75,0,39,301.5,0,0,1,0,0,0,0,[]],17,110,[],[],[0,0]],[[-3456,145.6249389648438,
0,39,756.3750610351562,0,0,1,0,0,0,0,[]],17,152,[],[],[0,0]],[[-3261,-601,0,38,710.125244140625,0,0,1,0,0,0,0,[]],17,170,[],[],[0,0]],[[-2689,146.375,0,36,689.625,0,0,1,0,0,0,0,[]],17,154,[],[],[0,0]],[[2551,970,0,1022,485,0,-0.3201249241828919,1,0.5,0.5,0,0,[]],3,8,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-10017,451,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,20,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,"Default",0,1]],[[15001.365234375,462.5004272460938,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,21,[],[[1,
0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2165,923,0,444,239,0,-0.1061305925250053,1,0.5,0.5,0,0,[]],3,19,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8528,532,0,38,710.125244140625,0,0,1,0,0,0,0,[]],17,237,[],[],[0,0]],[[-8440,778,0,800,512,0,-0.02082444168627262,1,0.5,0.5,0,0,[]],15,94,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-943,767,0,10,88,0,0,1,0.5,0.5,0,0,[]],10,25,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5637,770,0,10,88,0,0,1,0.5,0.5,0,0,[]],
11,82,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5600,721,0,10,88,0,1.570796370506287,1,0.5,0.5,0,0,[]],11,83,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5563,772,0,10,88,0,0,1,0.5,0.5,0,0,[]],11,84,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1026,767,0,10,88,0,0,1,0.5,0.5,0,0,[]],11,85,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5572,691,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,86,[],[[0,0,0,1,0.5,0.2,
0,0.01,0,1]],[0,"Default",0,1]],[[-5636,692,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,87,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5605,692,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,88,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5605,537,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,89,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5619,
640,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,90,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5589,640,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,91,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5604,589,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,95,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7006,233,0,800,512,0,-0.02082444168627262,1,0.5,0.5,0,
0,[]],15,34,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7544,278,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],18,105,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8791.880859375,502.7225952148438,0,1816,5,0,-0.4628249108791351,1,0.5,0.5,0,0,[]],20,93,[],[],[1,"Default",0,1]],[[-9710,545,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,233,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9615.23828125,792.8369140625,0,40,40,0,0,1,0.4945054948329926,0.4945054948329926,
0,0,[]],44,78,[],[[],[0,2,0,1,1,0,0,0.1,0,1]],[0,"Default",0,1]],[[-9511.759765625,791.5281982421875,0,41,41,0,0,1,0.4945054948329926,0.4945054948329926,0,0,[]],45,79,[],[[],[0,2,0,1,30,0.2,0,0.1,0,1]],[0,"Default",0,1]],[[-9614,793,0,15.86400032043457,15.2819995880127,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],50,165,[],[[]],[0,"Default",0,1]],[[-9512.0673828125,791.501708984375,0,15.86417293548584,15.28224849700928,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],49,81,[],[[]],[0,"Default",
0,1]],[[-8626,454,0,53,54,0,0,1,0.5,0.5,0,0,[]],21,98,[],[[1]],[1,"Default",0,1]],[[-5445,109,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,133,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6096,109,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],18,128,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4794,109,0,326,340,0,0,1,0.5017921328544617,0.5,0,0,[]],25,134,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5355,-275,0,800,512,0,-0.02082444168627262,1,0.5,0.5,0,0,[]],
15,117,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5892,-230,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],18,121,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5119,109,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,135,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4008,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],26,136,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-3928,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],27,137,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",
0,1]],[[-4088,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],28,138,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-4168,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],29,139,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-4248,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],30,140,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-4328,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],31,141,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-4408,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],32,142,[],[[0,0,0,1,0.5,0.2,0,
0.01,0,1],[1]],[0,"Default",0,1]],[[-4574,136,0,103,60,0,0,1,0.5,0.5,0,0,[]],33,143,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-4488,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],34,144,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-3848,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],35,145,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-3768,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],36,146,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-3682.5,136,0,102,60,0,0,1,0.5,0.5,0,0,[]],
37,147,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-3439,114,0,371,340,0,0,1,0.4982078969478607,0.5,0,0,[]],38,148,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3068.87109375,114,0,371,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,149,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2723,114,0,371,340,0,0,1,0.5017921328544617,0.5,0,0,[]],39,150,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5770,109,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,155,[],[[1,
0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9566.88671875,766.9984130859375,0,139.9325256347656,71.58200073242188,0,0,1,0.4996415674686432,0.5,0,0,[]],43,77,[],[[],[0,0,0,0.1,0.5,0,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-9581,730,0,13.80819606781006,38.2735595703125,0,0.3524599075317383,1,0.5,0.5,0,0,[]],56,31,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9577.9462890625,780.4381713867188,0,80.68636322021484,27.58581161499023,0,-0.02719682641327381,1,0.5012787580490112,0.511904776096344,
0,0,[]],46,80,[],[[0,0,0,1,0.5,0,0,0,0,1]],[0,"Default",0,1]],[[-9498.4892578125,783.7494506835938,0,33.02397918701172,15.33616733551025,0,-0.1354803889989853,1,0.5,0.5128205418586731,0,0,[]],47,163,[],[[0,0,0,1,0.5,0,0,0,0,1]],[1,"Default",0,1]],[[-9540,791,0,54.239990234375,29.06821441650391,0,-2.640111923217773,1,0.5,0.5128205418586731,0,0,[]],48,164,[],[[0,0,0,1,0.5,0,0,0,0,1]],[1,"Default",0,1]],[[-3617,-628,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],38,166,[],[[1,0,0,1,0.5,0.2,0,0.01,0,
1]],[0,"Default",0,1]],[[-3291.12109375,-627.6262817382812,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,167,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2989,-628,0,326,340,0,0,1,0.5017921328544617,0.5,0,0,[]],39,168,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9571.0166015625,704.9074096679688,0,23.86647987365723,19.45467376708984,0,0.237887367606163,1,0.5,0.5,0,0,[]],54,29,[],[[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-1115,762,0,10,188,0,1.099713444709778,1,
0.5,0.5,0,0,[]],55,30,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9582.931640625,751.6878051757812,0,11.43257808685303,27.75306510925293,0,-0.5601918697357178,1,0.5,0.5,0,0,[]],57,54,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9575.8310546875,770.6934814453125,0,7.694767951965332,28.18980026245117,0,-0.102828323841095,1,0.5,0.5016077160835266,0,0,[]],58,55,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9571.6787109375,784.861083984375,0,12.75531768798828,8.073624610900879,
0,0,1,0.5,0.5,0,0,[]],59,59,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9572,726,0,8.534109115600586,24.24663543701172,0,-0.7138661742210388,1,0.5037593841552734,0.5016501545906067,0,0,[]],60,60,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9556,734,0,25.45074844360352,6.639465808868408,0,0.07037980109453201,1,0.5,0.5,0,0,[]],61,61,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-7705,305,0,40,665,0,0,1,0,0,0,0,[]],17,100,[],[],[0,0]],[[-7388,310,0,37,669,0,0,1,0,0,0,0,[]],
17,97,[],[],[0,0]],[[-6823,259,0,40,690,0,0,1,0,0,0,0,[]],17,35,[],[],[0,0]],[[-6251,140,0,37,717,0,0,1,0,0,0,0,[]],17,127,[],[],[0,0]],[[-5546,140,0,38,725,0,0,1,0,0,0,0,[]],17,114,[],[],[0,0]],[[-4906,142,0,37,778,0,0,1,0,0,0,0,[]],17,116,[],[],[0,0]],[[-3584,146.4998168945313,0,40,776.5001831054688,0,0,1,0,0,0,0,[]],17,151,[],[],[0,0]],[[-2795,146.7496948242188,0,39,769.2503051757812,0,0,1,0,0,0,0,[]],17,153,[],[],[0,0]],[[-9614,763,0,109.9668197631836,113.9811706542969,0,-3.083474397659302,1,
0,0.5,0,0,[]],66,102,[],[],[400,60,0,200,10,100,10,0,0,0,0,0,-150,0,0,800,0,0,1]],[[14231.22265625,672.3741455078125,0,240.50390625,422.2508850097656,0,0,1,0.5,0.5,0,0,[]],74,198,[],[],[0,"Default",0,1]],[[-807,771,0,10,88,0,0,1,0.5,0.5,0,0,[]],11,161,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-882,771,0,10,88,0,0,1,0.5,0.5,0,0,[]],11,176,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[618.5,3793,0,55,102,0,0,1,0.5,0.5,0,0,[]],79,205,[],[],[0,"Default",0,1]],[[-3457,-601,0,40,709.4998168945312,
0,0,1,0,0,0,0,[]],17,169,[],[],[0,0]],[[-6056.11865234375,-198.25,0,38,301.5,0,0,1,0,0,0,0,[]],17,120,[],[],[0,0]],[[-5734,-199,0,39,303.5,0,0,1,0,0,0,0,[]],17,119,[],[],[0,0]],[[-5171,-226,0,38,330,0,0,1,0,0,0,0,[]],17,118,[],[],[0,0]],[[-9823.86328125,496.6243286132813,0,44,44,0,0,1,0.5,0.5,0,0,[]],88,222,[],[[],[],[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9722,498,0,44,44,0,0,1,0.5,0.5,0,0,[]],85,219,[],[[],[],[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9825.7568359375,498.626220703125,
0,15.86400032043457,15.2819995880127,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],87,221,[],[[],[]],[0,"Default",0,1]],[[-9722,500,0,15.86400032043457,15.2819995880127,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],86,220,[],[[],[]],[0,"Default",0,1]],[[-9775.0634765625,472.8135681152344,0,139.9324493408203,66.99331665039062,0,0,1,0.4996415674686432,0.5123287439346313,0,0,[]],81,215,[],[[],[],[],[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9712,492,0,33.02399826049805,15.33600044250488,
0,-0.1354803889989853,1,0.5,0.5128205418586731,0,0,[]],82,216,[],[[],[],[0,2,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9749,497,0,54.2400016784668,29.06800079345703,0,-2.640111923217773,1,0.5,0.5128205418586731,0,0,[]],83,217,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9789,486,0,80.68599700927734,27.58600044250488,0,-0.02719682641327381,1,0.5012787580490112,0.511904776096344,0,0,[]],84,218,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9780.4365234375,478.6243286132813,
0,12.41300010681152,33.72999954223633,0,-0.102828323841095,1,0.5029239654541016,0.501483678817749,0,0,[]],90,224,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9777.6884765625,493,0,25.02561759948731,11.98656940460205,0,0,1,0.5009174346923828,0.5016181468963623,0,0,[]],89,223,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9788,435,0,26.78300094604492,39.66299819946289,0,0.3524599075317383,1,0.5022222399711609,0.5019454956054688,0,0,[]],92,226,[],[[],[],[0,0,0,1,0.5,0.2,0,0,
0,1]],[0,"Default",0,1]],[[-9787.8779296875,457.0625305175781,0,27.53300094604492,29.95400047302246,0,-0.3999198377132416,1,0.5017300844192505,0.5015974640846252,0,0,[]],91,225,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9777,433,0,18.54400062561035,25.04700088500977,0,-0.7138661742210388,1,0.5017300844192505,0.5015974640846252,0,0,[]],93,227,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9761,441,0,27.41399955749512,13.43299961090088,0,0.07037980109453201,1,0.5013262629508972,
0.5,0,0,[]],94,228,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9782,411,0,25.3841667175293,26.51634979248047,0,0.237887367606163,1,0.5,0.5,0,0,[]],95,229,[],[[],[],[],[0,0,1,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9822,463,0,109.9668197631836,113.9811706542969,0,-3.083474397659302,1,0,0.5,0,0,[]],96,230,[],[],[50,60,0,200,20,100,0,0,0,0,0,0,-150,0,0,800,0,0,1]],[[-10036,545,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],38,232,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],
[[-9385,545,0,326,340,0,0,1,0.5017921328544617,0.5,0,0,[]],39,234,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9876,572,0,40,709.4998168945312,0,0,1,0,0,0,0,[]],17,239,[],[],[0,0]],[[-8822,508,0,800,512,0,0,1,0.5,0.5,0,0,[]],15,235,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8640,538,0,40,709.4998168945312,0,0,1,0,0,0,0,[]],17,236,[],[],[0,0]],[[-9142,530,0,165,728,0,0,1,0.5046728849411011,0.5,0,0,[]],98,203,[],[],[0,"Default",0,1]],[[-9189,247,0,134,44,0,0,1,0.5,0.503496527671814,
0,0,[]],99,32,[],[],[0,"Default",0,1]],[[-9412.576171875,797.624267578125,0,78.99500274658203,64,0,0,1,0.5022830963134766,0.5039370059967041,0,0,[]],101,244,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9143,919,0,165,728,0,0,1,0.5046728849411011,0.5,0,0,[]],98,246,[],[],[0,"Default",0,1]],[[-9194,637,0,134,44,0,0,1,0.5,0.503496527671814,0,0,[]],99,247,[],[],[0,"Default",0,1]],[[-9647.296875,523.2921752929688,0,78.99500274658203,64,0,0,1,0.5022830963134766,0.5039370059967041,0,0,[]],101,
248,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4776.38525390625,790.3737182617188,0,800,512,0,0,1,0.5,0.5,0,0,[]],104,249,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6580,779,0,800,512,0,-0.02082444168627262,1,0.5,0.5,0,0,[]],15,250,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[11,1023,0,-11.87509155273438,16.24591064453125,0,0,1,0.5,0.5,0,0,[]],64,76,[],[],[0,"Default",0,1]],[[-3290,777,0,800,512,0,-0.02082444168627262,1,0.5,0.5,0,0,[]],15,257,[],[[1,0,0,1,0.5,0.2,
0,0.01,0,1]],[0,"Default",0,1]],[[-5605,487,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,258,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1528.25244140625,284.6253051757813,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],38,259,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1202,285,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,260,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-877,284,0,326,340,0,0,1,0.5017921328544617,0.5,
0,0,[]],39,261,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1556,316,0,40,709.4998168945312,0,0,1,0,0,0,0,[]],17,275,[],[],[0,0]],[[-10554,815,0,25797,512,0,0,1,0,0,0,0,[]],53,0,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[7844,725,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,15,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7845,777,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,195,[],[[0,0,0,1,0.5,0.2,
0,0.01,0,1]],[0,"Default",0,1]],[[8035,725,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,211,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8036,776,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,213,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8207,727,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,440,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8209,777,
0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,450,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8031,625,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,457,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8032,677,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,461,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8025,809,0,10,480,0,1.570796370506287,1,0.5,0.5,0,0,[]],10,
462,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8894.248046875,620.749755859375,0,10,205,0,1.570796370506287,1,0.5,0.5,0,0,[]],55,6,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8800,719,0,10,188,0,0,1,0.5,0.5,0,0,[]],55,40,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8987,719,0,10,188,0,0,1,0.5,0.5,0,0,[]],55,41,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8851.34765625,531.4992065429688,0,10,188,0,0.5255944728851318,1,0.5,0.5,0,0,[]],55,42,[],[[0,0,0,5,0.5,
0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8951.4833984375,528.626220703125,0,10,188,0,-0.4851999282836914,1,0.5,0.5,0,0,[]],55,43,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-10209,864,0,24934,512,0,0,1,0,0,0,0,[]],266,1461,[],[],[0,0]],[[697,288,0,25,23,0,0,1,0.5,0.5,0,0,[]],76,202,[],[[0,0,0,0,1]],[1,"Default",0,1]],[[522,77,0,49,42,0,0,1,0.5,0.5033556818962097,0,0,[]],62,62,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[879,82,0,81.50032043457031,51.99996185302734,0,0,1,0.5,0.5033556818962097,0,
0,[]],63,74,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[697,75,0,242.4135437011719,184.9008636474609,0,0,1,0.5009980201721191,0.5,0,0,[]],19,92,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1277,657,0,290.3739929199219,236.5,0,0,1,0.4986737370491028,0.5899053812026978,0,0,[]],4,9,[[0]],[[0,0,0,0,1]],[0,"Default",0,1]],[[116,637,0,290.3739929199219,236.5,0,0,1,0.5013262629508972,0.5015772581100464,0,0,[]],5,10,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-9233.697265625,752.5008544921875,0,2603,1572,0,0,1,0.5,0.5,0,0,
[]],226,515,[],[],[0,"Default",0,1]],[[693,362,0,2184,1480,0,0,1,0.5,0.5,0,0,[]],102,245,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[2236,2132,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],78,204,[],[],[0,"Default",0,1]],[[767.5,1906.5,0,319,266,0,0,1,0.5,0.5,0,0,[]],73,197,[],[],[0,"Default",0,1]]],[]]],[],[]],["Level1part2",1708,960,!0,"Level1part2Event",9917746596212146,[["Layer 4",0,9159252535641862,!0,[255,255,255],!0,0.2000000029802322,0.2000000029802322,1,!1,1,0,0,[[[955,491,0,2048,1163,0,0,1,0.5,0.5011236071586609,
0,0,[]],7,196,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[906,348.9528198242188,0,2062,1293,0,0,1,0.5,0.5011236071586609,0,0,[]],121,13,[],[[0,0,0,0,1],[1,4,0,0,1]],[0,"Default",0,1]],[[-10003,401,0,21728,176,0,0,1,0,0,0,0,[]],109,209,[],[],[0,0]],[[-10436,544,0,22870,1408,0,0,1,0,0,0,0,[]],112,212,[],[],[0,0]]],[]],["Layer 1",1,8231407392386653,!0,[255,255,255],!0,0.4000000059604645,0.4000000059604645,1,!1,1,0,0,[[[-10054,13,0,21840,725,0,0,1,0,0,0,0,[]],105,242,[],[],[0,0]],[[-10348,597,0,22380,1408,
0,0,1,0,0,0,0,[]],111,263,[],[],[0,0]]],[]],["Layer 2",2,9631991982041268,!0,[255,255,255],!0,0.6000000238418579,0.6000000238418579,1,!1,1,0,0,[[[-9925,87,0,21590,758,0,0,1,0,0,0,0,[]],106,264,[],[],[0,0]],[[-10553,664,0,22530,1408,0,0,1,0,0,0,0,[]],110,265,[],[],[0,0]]],[]],["Layer 3",3,6358736797410016,!0,[255,255,255],!0,0.8999999761581421,0.800000011920929,1,!1,1,0,0,[[[-10553,188,0,24928,621,0,0,1,0,0,0,0,[]],107,266,[],[],[0,0]],[[-13742,762,0,28463,1533,0,0,1,0,0,0,0,[]],108,267,[],[],[0,0]]],
[]],["Layer 0",4,7617733694888036,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[-1076,317,0,38,710.125244140625,0,0,1,0,0,0,0,[]],17,270,[],[],[0,0]],[[-9200,520,0,107,703,0,0,1,0.4953271150588989,0.5,0,0,[]],100,271,[],[],[0,"Default",0,1]],[[-9680,572,0,38,710.125244140625,0,0,1,0,0,0,0,[]],17,272,[],[],[0,0]],[[14136.3154296875,661.3118286132812,0,70.6806640625,376.8765258789063,0,0,1,0.5142857432365417,0.5,0,0,[]],80,273,[],[],[0,"Default",0,1]],[[-6711,251,0,42,687,0,0,1,0,0,0,0,[]],17,276,[],[],[0,
0]],[[-7251,306,0,37,679,0,0,1,0,0,0,0,[]],17,277,[],[],[0,0]],[[-7573,307,0,40,689,0,0,1,0,0,0,0,[]],17,278,[],[],[0,0]],[[-4797,143,0,35,792,0,0,1,0,0,0,0,[]],17,279,[],[],[0,0]],[[-5405,137,0,37,703,0,0,1,0,0,0,0,[]],17,280,[],[],[0,0]],[[-6100,140.375,0,41,809.625,0,0,1,0,0,0,0,[]],17,281,[],[],[0,0]],[[-5060,-230,0,35,334,0,0,1,0,0,0,0,[]],17,282,[],[],[0,0]],[[-5610,-202,0,39,306,0,0,1,0,0,0,0,[]],17,283,[],[],[0,0]],[[-5944.4921875,-197.75,0,39,301.5,0,0,1,0,0,0,0,[]],17,284,[],[],[0,0]],[[-3456,
145.6249389648438,0,39,756.3750610351562,0,0,1,0,0,0,0,[]],17,285,[],[],[0,0]],[[-3261,-601,0,38,710.125244140625,0,0,1,0,0,0,0,[]],17,286,[],[],[0,0]],[[-2689,146.375,0,36,689.625,0,0,1,0,0,0,0,[]],17,287,[],[],[0,0]],[[2115,910,0,444,239,0,-0.1742372959852219,1,0.5,0.5,0,0,[]],3,291,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2598,895,0,1022,485,0,-0.3675376772880554,1,0.5,0.5,0,0,[]],3,288,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-10017,451,0,32,804,0,0,1,0.5,0.5,0,0,[]],
0,289,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,"Default",0,1]],[[15001.365234375,462.5004272460938,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,290,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8528,532,0,38,710.125244140625,0,0,1,0,0,0,0,[]],17,292,[],[],[0,0]],[[-8440,778,0,800,512,0,-0.02082444168627262,1,0.5,0.5,0,0,[]],15,293,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-943,767,0,10,88,0,0,1,0.5,0.5,0,0,[]],10,294,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5637,770,0,10,88,
0,0,1,0.5,0.5,0,0,[]],11,295,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5600,721,0,10,88,0,1.570796370506287,1,0.5,0.5,0,0,[]],11,296,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5563,772,0,10,88,0,0,1,0.5,0.5,0,0,[]],11,297,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1026,767,0,10,88,0,0,1,0.5,0.5,0,0,[]],11,298,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5572,691,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],
12,299,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5636,692,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,300,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5605,692,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,301,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5605,537,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,302,[],[[0,0,0,1,0.5,0.2,0,
0.01,0,1]],[0,"Default",0,1]],[[-5619,640,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,303,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5589,640,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,304,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5604,589,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,305,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7006,233,0,800,
512,0,-0.02082444168627262,1,0.5,0.5,0,0,[]],15,306,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7544,278,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],18,307,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8791.880859375,502.7225952148438,0,1816,5,0,-0.4628249108791351,1,0.5,0.5,0,0,[]],20,308,[],[],[1,"Default",0,1]],[[-9710,545,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,309,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9829,515,0,40,40,0,0,1,0.4945054948329926,
0.4945054948329926,0,0,[]],44,310,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9729,514,0,41,41,0,0,1,0.4945054948329926,0.4945054948329926,0,0,[]],45,311,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9829,513,0,15.86400032043457,15.2819995880127,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],50,312,[],[[]],[0,"Default",0,1]],[[-9728,514,0,15.86417293548584,15.28224849700928,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],49,313,[],[[]],[0,"Default",0,1]],[[-8626,
454,0,53,54,0,0,1,0.5,0.5,0,0,[]],21,314,[],[[1]],[1,"Default",0,1]],[[-5445,109,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,315,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6096,109,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],18,316,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4794,109,0,326,340,0,0,1,0.5017921328544617,0.5,0,0,[]],25,317,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5355,-275,0,800,512,0,-0.02082444168627262,1,0.5,0.5,0,0,[]],15,318,[],[[1,
0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5892,-230,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],18,319,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5119,109,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,320,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4008,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],26,321,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-3928,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],27,322,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-4088,
136,0,91,60,0,0,1,0.5,0.5,0,0,[]],28,323,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-4168,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],29,324,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-4248,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],30,325,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-4328,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],31,326,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-4408,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],32,327,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],
[0,"Default",0,1]],[[-4574,136,0,103,60,0,0,1,0.5,0.5,0,0,[]],33,328,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-4488,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],34,329,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-3848,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],35,330,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-3768,136,0,91,60,0,0,1,0.5,0.5,0,0,[]],36,331,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-3682.5,136,0,102,60,0,0,1,0.5,0.5,0,0,[]],37,332,[],[[0,
0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-3439,114,0,371,340,0,0,1,0.4982078969478607,0.5,0,0,[]],38,333,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3068.87109375,114,0,371,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,334,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2723,114,0,371,340,0,0,1,0.5017921328544617,0.5,0,0,[]],39,335,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5770,109,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,336,[],[[1,0,0,1,0.5,0.2,
0,0.01,0,1]],[0,"Default",0,1]],[[-9783.7353515625,489.1863708496094,0,139.9329986572266,71.58155822753906,0,0,1,0.4996415674686432,0.5,0,0,[]],43,337,[],[[],[0,0,0,0.1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-9796,450,0,13.80799961090088,38.27399826049805,0,0.3524599075317383,1,0.5,0.5,0,0,[]],56,338,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9792,502,0,80.68636322021484,27.58581161499023,0,-0.02719682641327381,1,0.5012787580490112,0.511904776096344,0,0,[]],46,339,[],[[0,0,0,1,
0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9711,505,0,33.02397918701172,15.33616733551025,0,-0.1354803889989853,1,0.5,0.5128205418586731,0,0,[]],47,340,[],[[0,2,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9755,511,0,54.239990234375,29.06821441650391,0,-2.640111923217773,1,0.5,0.5128205418586731,0,0,[]],48,341,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-3617,-628,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],38,342,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3291.12109375,-627.6262817382812,
0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,343,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2989,-628,0,326,340,0,0,1,0.5017921328544617,0.5,0,0,[]],39,344,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9785.84765625,425.2186279296875,0,23.86599922180176,19.45499992370606,0,0.237887367606163,1,0.5,0.5,0,0,[]],54,388,[],[[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-1115,762,0,10,188,0,1.099713444709778,1,0.5,0.5,0,0,[]],55,389,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,
"Default",0,1]],[[-9797.4736328125,472.1560668945313,0,11.43299961090088,27.75300025939941,0,-0.5456231236457825,1,0.5,0.5,0,0,[]],57,390,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9791.1240234375,491.3435363769531,0,7.695000171661377,28.19000053405762,0,0.0226987935602665,1,0.5,0.5016077160835266,0,0,[]],58,391,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9788.5361328125,506.8124694824219,0,12.75500011444092,8.074000358581543,0,0,1,0.5,0.5,0,0,[]],59,392,[],[[0,0,0,1,0.5,0.2,
0,0,0,1]],[0,"Default",0,1]],[[-9787.15234375,445.6876220703125,0,8.534000396728516,24.24699974060059,0,-0.7138661742210388,1,0.5037593841552734,0.5016501545906067,0,0,[]],60,393,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9771,454,0,25.45100021362305,6.638999938964844,0,0.07037980109453201,1,0.5,0.5,0,0,[]],61,394,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-7705,305,0,40,665,0,0,1,0,0,0,0,[]],17,395,[],[],[0,0]],[[-7388,310,0,37,669,0,0,1,0,0,0,0,[]],17,396,[],[],[0,0]],[[-6823,
259,0,40,690,0,0,1,0,0,0,0,[]],17,397,[],[],[0,0]],[[-6251,140,0,37,717,0,0,1,0,0,0,0,[]],17,398,[],[],[0,0]],[[-5546,140,0,38,725,0,0,1,0,0,0,0,[]],17,399,[],[],[0,0]],[[-4906,142,0,37,778,0,0,1,0,0,0,0,[]],17,400,[],[],[0,0]],[[-3584,146.4998168945313,0,40,776.5001831054688,0,0,1,0,0,0,0,[]],17,401,[],[],[0,0]],[[-2795,146.7496948242188,0,39,769.2503051757812,0,0,1,0,0,0,0,[]],17,402,[],[],[0,0]],[[-9829,483,0,109.9668197631836,113.9811706542969,0,-3.083474397659302,1,0,0.5,0,0,[]],66,403,[],[],
[300,60,0,200,10,100,0,0,0,0,0,0,-150,0,0,800,0,0,1]],[[14231.22265625,672.3741455078125,0,240.50390625,422.2508850097656,0,0,1,0.5,0.5,0,0,[]],74,404,[],[],[0,"Default",0,1]],[[-807,771,0,10,88,0,0,1,0.5,0.5,0,0,[]],11,405,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-882,771,0,10,88,0,0,1,0.5,0.5,0,0,[]],11,406,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[618.5,3793,0,55,102,0,0,1,0.5,0.5,0,0,[]],79,411,[],[],[0,"Default",0,1]],[[-3457,-601,0,40,709.4998168945312,0,0,1,0,0,0,
0,[]],17,413,[],[],[0,0]],[[-6056.11865234375,-198.25,0,38,301.5,0,0,1,0,0,0,0,[]],17,414,[],[],[0,0]],[[-5734,-199,0,39,303.5,0,0,1,0,0,0,0,[]],17,415,[],[],[0,0]],[[-5171,-226,0,38,330,0,0,1,0,0,0,0,[]],17,416,[],[],[0,0]],[[-9627,789,0,44,44,0,0,1,0.5,0.5,0,0,[]],88,418,[],[[],[],[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9527,791,0,44,44,0,0,1,0.5,0.5,0,0,[]],85,419,[],[[],[],[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9627,791,0,15.86400032043457,15.2819995880127,0,0,1,0.5121951103210449,
0.4975369572639465,0,0,[]],87,420,[],[[],[]],[0,"Default",0,1]],[[-9527,793,0,15.86400032043457,15.2819995880127,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],86,421,[],[[],[]],[0,"Default",0,1]],[[-9580.689453125,765.49951171875,0,139.9324493408203,66.99331665039062,0,0,1,0.4996415674686432,0.5123287439346313,0,0,[]],81,422,[],[[],[],[],[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9593,728,0,26.78300094604492,39.66299819946289,0,0.3524599075317383,1,0.5022222399711609,0.5019454956054688,
0,0,[]],92,428,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9595.0625,749.1251220703125,0,27.53300094604492,29.95400047302246,0,-0.3047521710395813,1,0.5017300844192505,0.5015974640846252,0,0,[]],91,429,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9517,785,0,33.02399826049805,15.33600044250488,0,-0.1354803889989853,1,0.5,0.5128205418586731,0,0,[]],82,423,[],[[],[],[0,2,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9554,790,0,54.2400016784668,29.06800079345703,0,-2.640111923217773,
1,0.5,0.5128205418586731,0,0,[]],83,424,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9594,779,0,80.68599700927734,27.58600044250488,0,-0.02719682641327381,1,0.5012787580490112,0.511904776096344,0,0,[]],84,425,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9588.2470703125,770.374755859375,0,12.41300010681152,33.72999954223633,0,-0.102828323841095,1,0.5029239654541016,0.501483678817749,0,0,[]],90,426,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9584.8740234375,
784.7503662109375,0,19.97599983215332,14.67500019073486,0,0,1,0.5009174346923828,0.5016181468963623,0,0,[]],89,427,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9584.19921875,725.6878662109375,0,18.54400062561035,25.04700088500977,0,-0.7138661742210388,1,0.5017300844192505,0.5015974640846252,0,0,[]],93,430,[],[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9569.4365234375,734,0,27.41399955749512,13.43299961090088,0,0.07037980109453201,1,0.5013262629508972,0.5,0,0,[]],94,431,[],
[[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9587,704,0,25.3841667175293,26.51634979248047,0,0.237887367606163,1,0.5,0.5,0,0,[]],95,432,[],[[],[],[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9627,756,0,109.9668197631836,113.9811706542969,0,-3.083474397659302,1,0,0.5,0,0,[]],96,433,[],[],[50,60,0,200,20,100,0,0,0,0,0,0,-150,0,0,800,0,0,1]],[[-10036,545,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],38,434,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9385,545,0,326,340,
0,0,1,0.5017921328544617,0.5,0,0,[]],39,435,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9876,572,0,40,709.4998168945312,0,0,1,0,0,0,0,[]],17,436,[],[],[0,0]],[[-8822,508,0,800,512,0,0,1,0.5,0.5,0,0,[]],15,437,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8640,538,0,40,709.4998168945312,0,0,1,0,0,0,0,[]],17,438,[],[],[0,0]],[[-9142,530,0,165,728,0,0,1,0.5046728849411011,0.5,0,0,[]],98,439,[],[],[0,"Default",0,1]],[[-9189,247,0,134,44,0,0,1,0.5,0.503496527671814,0,0,[]],99,441,
[],[],[0,"Default",0,1]],[[-9456,797,0,78.99500274658203,64,0,0,1,0.5022830963134766,0.5039370059967041,0,0,[]],101,442,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9143,919,0,165,728,0,0,1,0.5046728849411011,0.5,0,0,[]],98,443,[],[],[0,"Default",0,1]],[[-9194,637,0,134,44,0,0,1,0.5,0.503496527671814,0,0,[]],99,444,[],[],[0,"Default",0,1]],[[-9649,523.2500610351562,0,78.99500274658203,64,0,0,1,0.5022830963134766,0.5039370059967041,0,0,[]],101,446,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[-4776.38525390625,790.3737182617188,0,800,512,0,0,1,0.5,0.5,0,0,[]],104,447,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6580,779,0,800,512,0,-0.02082444168627262,1,0.5,0.5,0,0,[]],15,448,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[11,1023,0,-11.87509155273438,16.24591064453125,0,0,1,0.5,0.5,0,0,[]],64,452,[],[],[0,"Default",0,1]],[[670,308,0,25,23,0,0,1,0.5,0.5,0,0,[]],76,456,[],[[0,0,0,0,1]],[1,"Default",0,1]],[[-3290,781.3740844726562,0,800,512,0,-0.02082444168627262,
1,0.5,0.5,0,0,[]],15,465,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5605,487,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,466,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1528.25244140625,284.6253051757813,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],38,467,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1202,285,0,326,340,0,0,1,0.4982078969478607,0.5,0,0,[]],24,468,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-877,
284,0,326,340,0,0,1,0.5017921328544617,0.5,0,0,[]],39,469,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1556,316,0,40,709.4998168945312,0,0,1,0,0,0,0,[]],17,471,[],[],[0,0]],[[-10554,815,0,25797,512,0,0,1,0,0,0,0,[]],53,505,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-11226,865,0,24934,512,0,0,1,0,0,0,0,[]],266,1462,[],[],[0,0]],[[6845,772,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,26,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6845,
723,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,27,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7120,717,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,28,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7121,767,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,36,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6984,771,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,
0.5049999952316284,0,0,[]],12,37,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6984,722,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,38,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6984,675,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,39,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6992,804,0,10,524,0,1.570796370506287,1,0.5,0.5,0,0,[]],55,5,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[7847.50537109375,618.4995727539062,0,10,205,0,1.570796370506287,1,0.5,0.5,0,0,[]],55,46,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7753.50537109375,717.4995727539062,0,10,188,0,0,1,0.5,0.5,0,0,[]],55,47,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7940.50537109375,717.4995727539062,0,10,188,0,0,1,0.5,0.5,0,0,[]],55,48,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7805.50537109375,529.4995727539062,0,10,188,0,0.5255944728851318,1,0.5,0.5,0,0,[]],55,49,[],[[0,
0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7905.50537109375,526.4995727539062,0,10,188,0,-0.4851999282836914,1,0.5,0.5,0,0,[]],55,50,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[116,637,0,290.3739929199219,236.5,0,-0.01518769562244415,1,0.5013262629508972,0.5015772581100464,0,0,[]],5,455,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1277,657,0,290.3739929199219,236.5,0,0.01873116753995419,1,0.4986737370491028,0.5899053812026978,0,0,[]],4,454,[[0]],[[0,0,0,0,1]],[0,"Default",0,1]],[[697,75,
0,242.4135437011719,184.9008636474609,0,0,1,0.5009980201721191,0.5,0,0,[]],19,459,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[879,82,0,81.50032043457031,51.99996185302734,0,0,1,0.5,0.5033556818962097,0,0,[]],63,460,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[522,77,0,49,42,0,0,1,0.5,0.5033556818962097,0,0,[]],62,458,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-9589,485,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],226,516,[],[],[0,"Default",0,1]],[[693,362,0,2184,1480,0,0,1,0.5,0.5,0,0,[]],102,463,[],[[0,0,0,0,1]],[0,"Default",
0,1]],[[1074,2169.5,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],78,445,[],[],[0,"Default",0,1]],[[767.5,1906.5,0,319,266,0,0,1,0.5,0.5,0,0,[]],73,464,[],[],[0,"Default",0,1]]],[]]],[],[]],["Level2",1708,960,!0,"Level2Event",0x892fd6ef197c3,[["Layer 4",0,9825147508730680,!0,[255,255,255],!0,0.2000000029802322,0.2000000029802322,1,!1,1,0,0,[[[835,483,0,2048,1163,0,0,1,0.5,0.5011236071586609,0,0,[]],7,51,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-1322,3039,0,2062,1293,0,0,1,0.5,0.5011236071586609,0,0,[]],121,52,[],
[[0,0,0,0,1],[1,4,0,0,1]],[0,"Default",0,1]],[[-10003,401,0,21728,176,0,0,1,0,0,0,0,[]],109,53,[],[],[0,0]],[[-10436,544,0,22870,1408,0,0,1,0,0,0,0,[]],131,58,[],[],[0,0]]],[]],["Layer 1",1,5327817061112681,!0,[255,255,255],!0,0.4000000059604645,0.4000000059604645,1,!1,1,0,0,[[[-10054,13,0,21840,725,0,0,1,0,0,0,0,[]],105,57,[],[],[0,0]],[[-10348,597,0,22380,1408,0,0,1,0,0,0,0,[]],130,64,[],[],[0,0]]],[]],["Layer 2",2,8646555531214107,!0,[255,255,255],!0,0.6000000238418579,0.6000000238418579,1,!1,
1,0,0,[[[-9925,87,0,21590,758,0,0,1,0,0,0,0,[]],106,63,[],[],[0,0]],[[-10553,664,0,22530,1408,0,0,1,0,0,0,0,[]],129,65,[],[],[0,0]]],[]],["Layer 3",3,8596517739858124,!0,[255,255,255],!0,0.8999999761581421,0.800000011920929,1,!1,1,0,0,[[[-10556,179,0,24928,621,0,0,1,0,0,0,0,[]],128,66,[],[],[0,0]],[[-13742,762,0,28463,1533,0,0,1,0,0,0,0,[]],127,67,[],[],[0,0]]],[]],["Layer 0",4,8048031109306726,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[14136.3154296875,661.3118286132812,0,70.6806640625,376.8765258789063,
0,0,1,0.5142857432365417,0.5,0,0,[]],80,122,[],[],[0,"Default",0,1]],[[-10017,451,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,345,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,"Default",0,1]],[[15001.365234375,462.5004272460938,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,346,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6005,554,0,10,88,0,0,1,0.5,0.5,0,0,[]],11,351,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5968,505,0,10,88,0,1.570796370506287,1,0.5,0.5,0,0,[]],11,352,[],[[0,0,0,5,0.5,0.2,0,0.01,0,1]],[0,
"Default",0,1]],[[-5931,556,0,10,88,0,0,1,0.5,0.5,0,0,[]],11,353,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5940,475,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,355,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6004,476,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,356,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5973,476,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,
0.5049999952316284,0,0,[]],12,357,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5973,321,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,358,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5987,424,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,359,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5957,424,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,360,[],[[0,
0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5972,373,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,361,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8940.818359375,582.412353515625,0,1479,5,0,-0.3187622725963593,1,0.5,0.5,0,0,[]],20,364,[],[],[1,"Default",0,1]],[[-9652.48828125,788.4996337890625,0,40.04000091552734,39.25490188598633,0,0,1,0.4945054948329926,0.4945054948329926,0,0,[]],44,366,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9552,
790,0,40.04000091552734,39.25490188598633,0,0,1,0.4945054948329926,0.4945054948329926,0,0,[]],45,367,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9652,789,0,15.86400032043457,15.2819995880127,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],50,368,[],[[]],[0,"Default",0,1]],[[-9551,790,0,15.86417293548584,15.28224849700928,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],49,369,[],[[]],[0,"Default",0,1]],[[-8626,454,0,53,54,0,0,1,0.5,0.5,0,0,[]],21,370,[],[[1]],[1,"Default",0,1]],
[[-9606.5048828125,766.4993896484375,0,139.9325256347656,71.58200073242188,0,0,1,0.4996415674686432,0.5,0,0,[]],43,451,[],[[],[0,0,0,0.1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-9619,726,0,13.80819606781006,38.2735595703125,0,0.3524599075317383,1,0.5,0.5,0,0,[]],56,453,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9615,778,0,80.68636322021484,27.58581161499023,0,-0.02719682641327381,1,0.5012787580490112,0.511904776096344,0,0,[]],46,470,[],[[0,0,0,1.2,0.5,0.2,0,0,0,1]],[0,"Default",
0,1]],[[-9534,781,0,33.02397918701172,15.33616733551025,0,-0.1354803889989853,1,0.5,0.5128205418586731,0,0,[]],47,476,[],[[0,2,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9578,787,0,54.239990234375,29.06821441650391,0,-2.640111923217773,1,0.5,0.5128205418586731,0,0,[]],48,477,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9610.7470703125,702.249755859375,0,23.86647987365723,19.45467376708984,0,0.237887367606163,1,0.5,0.5,0,0,[]],54,508,[],[[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9620,
748,0,11.43257808685303,27.75306510925293,0,-0.6223453283309937,1,0.5,0.5,0,0,[]],57,510,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9611,768.3751831054688,0,7.694767951965332,31.12800598144531,0,-0.102828323841095,1,0.5,0.5016077160835266,0,0,[]],58,511,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9607.7451171875,782.2498779296875,0,11.7958459854126,7.79836893081665,0,0,1,0.5,0.5,0,0,[]],59,512,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9610,722,0,8.534109115600586,
24.24663543701172,0,-0.7138661742210388,1,0.5037593841552734,0.5016501545906067,0,0,[]],60,513,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9594,730,0,25.45074844360352,6.639465808868408,0,0.07037980109453201,1,0.5,0.5,0,0,[]],61,514,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9659,760,0,109.9668197631836,113.9811706542969,0,-3.083474397659302,1,0,0.5,0,0,[]],66,523,[],[],[300,60,0,200,10,100,0,0,0,0,0,0,-150,0,0,800,0,0,1]],[[14231.22265625,672.3741455078125,0,240.50390625,422.2508850097656,
0,0,1,0.5,0.5,0,0,[]],74,524,[],[],[0,"Default",0,1]],[[618.5,3793,0,55,102,0,0,1,0.5,0.5,0,0,[]],79,528,[],[],[0,"Default",0,1]],[[-9456,797,0,78.99500274658203,64,0,0,1,0.5022830963134766,0.5039370059967041,0,0,[]],101,556,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9143,919,0,165,728,0,0,1,0.5046728849411011,0.5,0,0,[]],98,557,[],[],[0,"Default",0,1]],[[-9194,637,0,134,44,0,0,1,0.5,0.503496527671814,0,0,[]],99,558,[],[],[0,"Default",0,1]],[[11,1023,0,-11.87509155273438,16.24591064453125,
0,0,1,0.5,0.5,0,0,[]],64,564,[],[],[0,"Default",0,1]],[[670,308,0,25,23,0,0,1,0.5,0.5,0,0,[]],76,567,[],[[0,0,0,0,1]],[1,"Default",0,1]],[[-5973,271,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,574,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8863.7509765625,762.874755859375,0,10,168.8712615966797,0,0.9568356871604919,1,0.5,0.5,0,0,[]],11,68,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8706.759765625,721,0,10,170,0,1.570796370506287,
1,0.5,0.5,0,0,[]],11,123,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8558,651,0,10,225,0,1.013711094856262,1,0.5,0.5,0,0,[]],11,71,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8423,596,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,132,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8388,596,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,199,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8349,
595,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,200,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8308,593,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,201,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8268,593,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,206,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8228,593,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,
0.5049999952316284,0,0,[]],13,207,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8186,592,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,255,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8145,590,0,40.6150016784668,63.75,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],13,256,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7959,537,0,10,348,0,1.080548405647278,1,0.5,0.5,0,0,[]],11,380,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],
[[-7575,460,0,10,448,0,1.570796370506287,1,0.5,0.5,0,0,[]],11,382,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6464.7763671875,676.3715209960938,0,10,585,0,1.106455564498901,1,0.5,0.5,0,0,[]],136,386,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5173,734,0,10,357,0,1.125097751617432,1,0.5,0.5,0,0,[]],11,408,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4663,608,0,10,376,0,1.570796370506287,1,0.5,0.5,0,0,[]],11,410,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],
[[-4378.49951171875,507.02001953125,0,10,306,0,1.009910702705383,1,0.5,0.5,0,0,[]],11,504,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3904,463,0,10,688,0,1.570796370506287,1,0.5,0.5,0,0,[]],134,507,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3743,359,0,10,419,0,1.14260458946228,1,0.5,0.5,0,0,[]],11,520,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2956,725,0,10,335,0,1.081289887428284,1,0.5,0.5,0,0,[]],11,522,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2273,
639.0000610351562,0,10,692,0,1.106455564498901,1,0.5,0.5,0,0,[]],136,530,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4290,677,0,107,474,0,0,1,0.5046728849411011,0.5,0,0,[]],139,532,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3586,608.5,0,107,663,0,0,1,0.5046728849411011,0.5,0,0,[]],139,506,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4514,838.5,0,107,465,0,0,1,0.5046728849411011,0.5,0,0,[]],139,417,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4866,810,
0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,412,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4893,784,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,409,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5042,868,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,519,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2854,872,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,521,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5974,577,0,107,370,0,1.570796370506287,
1,0.5046728849411011,0.5,0,0,[]],139,518,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8807,925.1251831054688,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,69,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8664,925,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,70,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8135,837,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,124,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8494,837,0,107,412,0,0,1,0.5046728849411011,
0.5,0,0,[]],139,125,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8300,602,0,107,412,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,129,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7841,670,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,130,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7808,668,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,131,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7399,668,0,107,412,0,0,1,0.5046728849411011,0.5,0,
0,[]],139,379,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2289,842,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,381,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6495,886,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,383,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1281,819,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,350,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1230,820,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,354,[],[[1,
0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1175,820,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,384,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1124,820,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,385,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1068,821,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,509,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1018,820,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,525,[],[[1,0,0,1,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[-966,820,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,526,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-916,820,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,529,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-863,821,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,531,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-610,499,0,10,585,0,1.106455564498901,1,0.5,0.5,0,0,[]],136,533,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],
[[-406,688,0,107,612,0,0,1,0.5046728849411011,0.5,0,0,[]],139,534,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-277,592.5,0,107,633,0,0,1,0.5046728849411011,0.5,0,0,[]],139,535,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-134,171,0,10,585,0,0.8519508242607117,1,0.5,0.5,0,0,[]],136,536,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-71,518,0,107,849,0,0,1,0.5046728849411011,0.5,0,0,[]],139,537,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[285,-237,0,107,412,0,
1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,538,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[655,-237,0,107,412,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,539,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[229,452,0,107,986,0,0,1,0.5046728849411011,0.5,0,0,[]],139,540,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[510,-31,0,10,585,0,1.570796370506287,1,0.5,0.5,0,0,[]],136,541,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[760,444,0,107,970,
0,0,1,0.5046728849411011,0.5,0,0,[]],139,542,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1024,432.5,0,107,1065,0,0,1,0.5046728849411011,0.5,0,0,[]],139,543,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[840,456.5,0,107,987,0,0,1,0.5046728849411011,0.5,0,0,[]],139,544,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1149,-130,0,10,585,0,1.201479077339172,1,0.5,0.5,0,0,[]],136,545,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1638,431,0,107,1048,0,0,1,0.5046728849411011,
0.5,0,0,[]],139,546,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1895,700,0,107,1205,0,0,1,0.5046728849411011,0.5,0,0,[]],139,547,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2114,569.5,0,107,805,0,0,1,0.5046728849411011,0.5,0,0,[]],139,548,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1797,13,0,10,321,0,2.252978801727295,1,0.5,0.5,0,0,[]],136,549,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2047.90380859375,142.267822265625,0,10,252,0,1.849040627479553,1,0.5,
0.5,0,0,[]],136,550,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2151,583,0,107,828,0,0,1,0.5046728849411011,0.5,0,0,[]],139,551,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1459,711,0,10,441,0,1.106455564498901,1,0.5,0.5,0,0,[]],136,552,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3064,673.5,0,107,604,0,0,1,0.5046728849411011,0.5,0,0,[]],139,553,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2465,187,0,10,585,0,1.616836667060852,1,0.5,0.5,0,0,[]],136,554,[],
[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2712,637,0,107,890,0,0,1,0.5046728849411011,0.5,0,0,[]],139,555,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3362,376,0,10,585,0,1.570796370506287,1,0.5,0.5,0,0,[]],136,561,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3916,709,0,107,495,0,0,1,0.5046728849411011,0.5,0,0,[]],139,575,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4262,696,0,107,467,0,0,1,0.5046728849411011,0.5,0,0,[]],139,576,[],[[1,0,0,1,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[4118,468,0,10,372,0,1.570796370506287,1,0.5,0.5,0,0,[]],136,577,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4566,780,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,578,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4915,780,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,579,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4770,577,0,10,374,0,1.570796370506287,1,0.5,0.5,0,0,[]],136,580,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],
[[5459,787,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,581,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5495,786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,583,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5539,786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,584,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5574,786,0,40.615234375,63.74981689453125,
0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,585,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5614,787,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,586,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5648,787,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,587,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5684,786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,
0,0,[]],12,588,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5728,786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,589,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5763,786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,590,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5803,787,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,591,[],[[0,0,0,1,0.5,0.2,
0,0.01,0,1]],[0,"Default",0,1]],[[5837,786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,592,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5873,785,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,593,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5917,785,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,594,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5952,
785,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,595,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5992,786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,596,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6026,786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,597,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6062,785,0,40.615234375,63.74981689453125,
0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,598,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6106,785,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,599,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6141,785,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,600,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6181,786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,
0,0,[]],12,601,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6216,786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,602,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6260,786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,603,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6295,786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,604,[],[[0,0,0,1,0.5,0.2,
0,0.01,0,1]],[0,"Default",0,1]],[[6335,787,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,605,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6373,788,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,606,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6408,787,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,607,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6447,
786,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,608,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6870,778,0,10,243,0,1.337221026420593,1,0.5,0.5,0,0,[]],136,609,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6953,1E3,0,107,495,0,0,1,0.5046728849411011,0.5,0,0,[]],139,610,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7427,998,0,107,495,0,0,1,0.5046728849411011,0.5,0,0,[]],139,611,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,
1]],[[7938,1001,0,107,495,0,0,1,0.5046728849411011,0.5,0,0,[]],139,612,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7339,778,0,10,243,0,1.337221026420593,1,0.5,0.5,0,0,[]],136,613,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7850,783,0,10,243,0,1.337221026420593,1,0.5,0.5,0,0,[]],136,614,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3599,683.5,0,107,625,0,0,1,0.5046728849411011,0.5,0,0,[]],139,615,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4998,875,0,107,412,
0,0,1,0.5046728849411011,0.5,0,0,[]],139,560,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5347,875,0,107,412,0,0,1,0.5046728849411011,0.5,0,0,[]],139,562,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5202,672,0,10,374,0,1.570796370506287,1,0.5,0.5,0,0,[]],136,573,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3244,424,0,96,419,0,0,1,0,0,0,0,[]],159,827,[],[],[0,0]],[[-3255,351.5,0,107,653,0,0,1,0.5046728849411011,0.5,0,0,[]],139,387,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,
"Default",0,1]],[[-10554,815,0,25797,512,0,0,1,0,0,0,0,[]],133,56,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[431,-593,0,250,800,0,0.09602309763431549,1,0.5,0.5,0,0,[]],189,1261,[],[],[0,"Default",0,1]],[[798,-592,0,250,800,0,0.09602309763431549,1,0.5,0.5,0,0,[]],189,1262,[],[],[0,"Default",0,1]],[[206,-585,0,250,800,0,0,1,0.5,0.5,0,0,[]],188,1263,[],[],[0,"Default",0,1]],[[574,-587,0,250,800,0,0,1,0.5,0.5,0,0,[]],188,1264,[],[],[0,"Default",0,1]],[[-10211,815,0,24934,512,0,0,1,0,0,0,0,[]],266,1463,
[],[],[0,0]],[[697,75,0,242.4135437011719,184.9008636474609,0,0,1,0.5009980201721191,0.5,0,0,[]],19,569,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[879,82,0,81.50032043457031,51.99996185302734,0,0,1,0.5,0.5033556818962097,0,0,[]],63,570,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[522,77,0,49,42,0,0,1,0.5,0.5033556818962097,0,0,[]],62,568,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1277,657,0,290.3739929199219,236.5,0,0.01873116753995419,1,0.4986737370491028,0.5899053812026978,0,0,[]],4,565,[[0]],[[0,0,0,0,1]],[0,"Default",
0,1]],[[116,637,0,290.3739929199219,236.5,0,-0.01518769562244415,1,0.5013262629508972,0.5015772581100464,0,0,[]],5,566,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-9354,777,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],226,517,[],[],[0,"Default",0,1]],[[693,362,0,2184,1480,0,0,1,0.5,0.5,0,0,[]],102,571,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1074,2169.5,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],78,559,[],[],[0,"Default",0,1]],[[-445,2379,0,319,266,0,0,1,0.5,0.5,0,0,[]],73,572,[],[],[0,"Default",0,1]]],[]]],[],[]],["Level3",
1708,960,!0,"Level3Event",0xb7f37dc693301,[["Layer 4",0,0x8bdcb24fc2498,!0,[255,255,255],!0,0.2000000029802322,0.2000000029802322,1,!1,1,0,0,[[[835,483,0,2048,1163,0,0,1,0.5,0.5011236071586609,0,0,[]],7,268,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-1322,3039,0,2062,1293,0,0,1,0.5,0.5011236071586609,0,0,[]],121,269,[],[[0,0,0,0,1],[1,4,0,0,1]],[0,"Default",0,1]],[[-10003,417,0,21728,176,0,0,1,0,0,0,0,[]],146,349,[],[],[0,0]],[[-10436,544,0,22870,1408,0,0,1,0,0,0,0,[]],147,274,[],[],[0,0]]],[]],["Layer 1",
1,0x981ef0ca8b315,!0,[255,255,255],!0,0.4000000059604645,0.4000000059604645,1,!1,1,0,0,[[[-10054,407,0,21840,725,0,0,1,0,0,0,0,[]],144,363,[],[],[0,0]],[[-10348,597,0,22380,1408,0,0,1,0,0,0,0,[]],145,348,[],[],[0,0]]],[]],["Layer 2",2,9589994659519624,!0,[255,255,255],!0,0.6000000238418579,0.6000000238418579,1,!1,1,0,0,[[[-10079,311,0,21590,758,0,0,1,0,0,0,0,[]],142,371,[],[],[0,0]],[[-10553,664,0,22530,1408,0,0,1,0,0,0,0,[]],143,362,[],[],[0,0]]],[]],["Layer 3",3,7566710600013319,!0,[255,255,255],
!0,0.8999999761581421,0.800000011920929,1,!1,1,0,0,[[[-10584,411,0,24928,621,0,0,1,0,0,0,0,[]],140,779,[],[],[0,0]],[[-13742,762,0,28463,1533,0,0,1,0,0,0,0,[]],141,365,[],[],[0,0]],[[-5122,423,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,747,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5124,438,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,748,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5123,453,0,16,580,0,
1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,749,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5121,409,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,750,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5122,364,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,751,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5124,379,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,
0,0,[]],153,752,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5123,394,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,753,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5121,350,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,754,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5123,482,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,755,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[-5125,497,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,756,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5124,512,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,757,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5122,468,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,758,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5124,541,0,16,580,0,1.570796370506287,1,0.529411792755127,
0.5011086463928223,0,0,[]],153,759,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5126,556,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,760,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5125,571,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,761,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5123,527,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,762,[],[[1,0,0,2,0.5,0.2,
0,0.01,0,1]],[0,"Default",0,1]],[[-5125,657,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,763,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5127,672,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,764,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5126,687,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,765,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5124,643,0,16,580,0,
1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,766,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5125,598,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,767,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5127,613,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,768,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5126,628,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,
0,0,[]],153,769,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5124,584,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,770,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5126,716,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,771,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5128,731,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,772,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[-5127,746,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,773,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5125,702,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,774,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5127,775,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,775,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5129,790,0,16,580,0,1.570796370506287,1,0.529411792755127,
0.5011086463928223,0,0,[]],153,776,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5128,805,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,777,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5126,761,0,16,580,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,780,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]]],[]],["Layer 0",4,7525105772503428,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[14136.3154296875,661.3118286132812,0,70.6806640625,
376.8765258789063,0,0,1,0.5142857432365417,0.5,0,0,[]],80,372,[],[],[0,"Default",0,1]],[[-10017,451,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,373,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,"Default",0,1]],[[15001.365234375,462.5004272460938,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,374,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8791.880859375,502.7225952148438,0,1479,5,0,-0.3187613487243652,1,0.5,0.5,0,0,[]],20,622,[],[],[1,"Default",0,1]],[[-9645,782.250244140625,0,40.04000091552734,39.25490188598633,0,0,1,
0.4945054948329926,0.4945054948329926,0,0,[]],44,623,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9543,783,0,40.04000091552734,39.25490188598633,0,0,1,0.4945054948329926,0.4945054948329926,0,0,[]],45,624,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9645,783,0,15.86400032043457,15.2819995880127,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],50,625,[],[[]],[0,"Default",0,1]],[[-9543,783,0,15.86417293548584,15.28224849700928,0,0,1,0.5121951103210449,0.4975369572639465,
0,0,[]],49,626,[],[[]],[0,"Default",0,1]],[[-8626,454,0,53,54,0,0,1,0.5,0.5,0,0,[]],21,627,[],[[1]],[1,"Default",0,1]],[[-9597.2783203125,759.56201171875,0,139.9329986572266,71.58155822753906,0,0,1,0.4996415674686432,0.5,0,0,[]],43,628,[],[[],[0,0,0,0.1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-9612,722.1870727539062,0,13.80819606781006,38.2735595703125,0,0.3524599075317383,1,0.5,0.5,0,0,[]],56,629,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9606,771,0,80.68636322021484,27.58581161499023,
0,-0.02719682641327381,1,0.5012787580490112,0.511904776096344,0,0,[]],46,630,[],[[0,0,0,1.2,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9525,774,0,33.02397918701172,15.33616733551025,0,-0.1354803889989853,1,0.5,0.5128205418586731,0,0,[]],47,631,[],[[0,2,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9570,780,0,54.239990234375,29.06821441650391,0,-2.640111923217773,1,0.5,0.5128205418586731,0,0,[]],48,632,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9602.9716796875,698.3436889648438,0,23.86647987365723,
19.45467376708984,0,0.237887367606163,1,0.5,0.5,0,0,[]],54,633,[],[[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9612,744.12548828125,0,11.43257808685303,27.75306510925293,0,-0.6223453283309937,1,0.5,0.5,0,0,[]],57,634,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9603.626953125,763.1256103515625,0,7.694767951965332,31.12800598144531,0,-0.102828323841095,1,0.5,0.5016077160835266,0,0,[]],58,635,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9600.626953125,777.1871948242188,0,
11.7958459854126,7.79836893081665,0,0,1,0.5,0.5,0,0,[]],59,636,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9602.373046875,717.9379272460938,0,8.534109115600586,24.24663543701172,0,-0.7138661742210388,1,0.5037593841552734,0.5016501545906067,0,0,[]],60,637,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9586.7470703125,725.9989624023438,0,25.45074844360352,6.639465808868408,0,0.07037980109453201,1,0.5,0.5,0,0,[]],61,638,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9645,753,
0,109.9668197631836,113.9811706542969,0,-3.083474397659302,1,0,0.5,0,0,[]],66,639,[],[],[300,60,0,200,10,100,0,0,0,0,0,0,-150,0,0,800,0,0,1]],[[14231.22265625,672.3741455078125,0,240.50390625,422.2508850097656,0,0,1,0.5,0.5,0,0,[]],74,640,[],[],[0,"Default",0,1]],[[618.5,3793,0,55,102,0,0,1,0.5,0.5,0,0,[]],79,642,[],[],[0,"Default",0,1]],[[-9456,797,0,78.99500274658203,64,0,0,1,0.5022830963134766,0.5039370059967041,0,0,[]],101,643,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9143,919,0,
165,728,0,0,1,0.5046728849411011,0.5,0,0,[]],98,644,[],[],[0,"Default",0,1]],[[-9194,637,0,134,44,0,0,1,0.5,0.503496527671814,0,0,[]],99,645,[],[],[0,"Default",0,1]],[[-8045,851,0,91,60,0,0,1,0.5,0.5,0,0,[]],26,377,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-7965,851,0,91,60,0,0,1,0.5,0.5,0,0,[]],27,378,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-8125,851,0,91,60,0,0,1,0.5,0.5,0,0,[]],28,616,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-8205,851,0,91,
60,0,0,1,0.5,0.5,0,0,[]],29,617,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-8285,851,0,91,60,0,0,1,0.5,0.5,0,0,[]],30,618,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-8365,851,0,91,60,0,0,1,0.5,0.5,0,0,[]],31,619,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-8445,851,0,91,60,0,0,1,0.5,0.5,0,0,[]],32,620,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-8611,851,0,103,60,0,0,1,0.5,0.5,0,0,[]],33,621,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",
0,1]],[[-8525,851,0,91,60,0,0,1,0.5,0.5,0,0,[]],34,648,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-7885,851,0,91,60,0,0,1,0.5,0.5,0,0,[]],35,652,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-7805,851,0,91,60,0,0,1,0.5,0.5,0,0,[]],36,653,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-7719,851,0,102,60,0,0,1,0.5,0.5,0,0,[]],37,654,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-5849.05810546875,345.0000305175781,0,16,666,0,1.570796370506287,1,0.529411792755127,
0.5011086463928223,0,0,[]],153,665,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5850,360,0,16,614,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,664,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5850,375,0,16,614,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,666,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6004.490234375,470.1181945800781,0,3,163,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,
742,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6003.66064453125,469.7521667480469,0,3,163,0,0,1,0.529411792755127,0.5011086463928223,0,0,[]],153,744,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6111.4189453125,464.9705810546875,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,673,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5683.162109375,465.2532043457031,0,3,163,0,0,1,0.529411792755127,0.5011086463928223,0,0,[]],153,745,[],[[1,0,0,
2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5685.16552734375,471.2528686523438,0,3,163,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,743,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5850,405,0,16,614,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,667,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5850,390,0,16,614,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,668,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[-6111.4189453125,419.9705810546875,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,669,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6111.4189453125,434.9705810546875,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,670,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6111.4189453125,449.9705810546875,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,671,[],[[1,0,0,2,0.5,0.2,0,0.01,0,
1]],[0,"Default",0,1]],[[-6111.4189453125,479.9705810546875,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,672,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6165,435,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,662,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6165,375,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,663,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6111.4189453125,494.9705810546875,0,15,90,0,1.570796370506287,1,
0.529411792755127,0.5011086463928223,0,0,[]],153,674,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6111.4189453125,509.9705810546875,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,675,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6111.4189453125,524.9705810546875,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,676,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5850,555,0,16,614,0,1.570796370506287,1,0.529411792755127,
0.5011086463928223,0,0,[]],153,677,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5850,540,0,16,614,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,678,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5850,570,0,16,614,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,679,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5850,585,0,16,614,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,680,[],[[1,0,0,2,0.5,0.2,
0,0.01,0,1]],[0,"Default",0,1]],[[-6165,495,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,660,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6165,555,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,659,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5850,600,0,16,614,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,681,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6036.5849609375,629.9705810546875,0,15,240,0,1.570796370506287,1,0.529411792755127,
0.5011086463928223,0,0,[]],153,682,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6036.5849609375,614.9705810546875,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,683,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6037.38330078125,645,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,684,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6037.38330078125,660,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,
0,0,[]],153,685,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6037.38330078125,675,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,686,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6037.38330078125,705,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,687,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6037.38330078125,690,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,688,[],
[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6165,615,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,661,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6037.38330078125,720,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,689,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6037.38330078125,735,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,690,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6037.38330078125,
750,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,691,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6037.38330078125,780,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,692,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6037.38330078125,765,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,693,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6165,675,0,107,94,0,0,1,0.5017793774604797,
0.5,0,0,[]],152,658,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,630,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,694,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,615,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,695,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,645,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,696,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],
[0,"Default",0,1]],[[-5655,660,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,697,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,675,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,698,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,705,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,699,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,690,0,15,240,0,1.570796370506287,
1,0.529411792755127,0.5011086463928223,0,0,[]],153,700,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,720,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,701,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,735,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,702,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,750,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,703,
[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,780,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,704,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,765,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,705,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,795,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,706,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,
825,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,707,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5655,810,0,15,240,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,708,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5535,795,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,709,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5535,735,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,710,[],[[1,2,0,1,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[-5535,675,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,711,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6044.96630859375,795,0,15,255,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,717,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6045,810,0,15,255,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,723,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6045,825,0,15,255,0,1.570796370506287,1,0.529411792755127,
0.5011086463928223,0,0,[]],153,724,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6165,735,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,657,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6165,795,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,656,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5580,525,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,726,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5580,510,0,15,90,0,1.570796370506287,
1,0.529411792755127,0.5011086463928223,0,0,[]],153,727,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5580,495,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,728,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5580,480,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,729,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5580,465,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,730,[],
[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5580,450,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,731,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5580,435,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,725,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5580,420,0,15,90,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,732,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5535,
555,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,712,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5535,615,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,714,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5535,495,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,713,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5535,375,0,107,94,0,0,1,0.5017793774604797,0.5,0,0,[]],152,716,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5535,435,0,107,94,0,0,1,0.5017793774604797,
0.5,0,0,[]],152,715,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5842.51708984375,420,0,15,195,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,733,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5842.51708984375,435,0,15,195,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,734,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5842.6171875,450,0,15,195,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,735,[],
[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5842.6162109375,465,0,15,195,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,736,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5842.6162109375,480,0,15,195,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,737,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5842.6162109375,495,0,15,195,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,738,[],[[1,0,0,2,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[-5842.6162109375,510,0,15,195,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,739,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5842.6162109375,525,0,15,195,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,740,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5846.77587890625,713.004150390625,0,144.4990234375,212.4990844726563,0,0,1,0.5,0.5,0,0,[]],155,746,[],[],[0,"Default",0,1]],[[-5851.5,343,0,647,15,0,0,1,
0.5,0.5,0,0,[]],156,801,[],[],[0,"Default",0,1]],[[-5844.818359375,91.99999237060547,0,16,51,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,784,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5843.96826171875,107,0,16,89,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,785,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5844.99365234375,121,0,16,120,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,786,[],[[1,0,0,2,
0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5842.43017578125,135,0,16,152,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,787,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5845.4697265625,150,0,16,188,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,788,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5844,165,0,16,223,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,789,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[-5846.05078125,180.0000152587891,0,16,261,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,790,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5844,194,0,16,297,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,791,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5846.13037109375,208.9999847412109,0,16,333,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,792,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],
[[-5846.5029296875,224,0,16,371,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,793,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5847.71435546875,238.9999847412109,0,16,408,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,794,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5850.751953125,253,0,16,442,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,795,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5851.86767578125,
296.0000305175781,0,16,546,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,798,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5853.4765625,327.9999694824219,0,20,622,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,800,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5851.40869140625,310.0000305175781,0,16,583,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,799,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],
[[-5849.7939453125,268.0000305175781,0,16,480,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,796,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5850.33056640625,282,0,16,513,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],153,797,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6030.84765625,221.8842163085938,0,16,466,0,0.9002230763435364,1,0.529411792755127,0.5011086463928223,0,0,[]],153,781,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[-5664.765625,222.3525695800781,0,16,452,0,2.273101568222046,1,0.529411792755127,0.5011086463928223,0,0,[]],153,782,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5841,75,0,45,35,0,0,1,0.5017793774604797,0.5,0,0,[]],152,783,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7294,734,0,17,679,0,1.338569283485413,1,0.529411792755127,0.5011086463928223,0,0,[]],157,802,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8137,961,0,1261,481,0,0,1,0.5,0.5,0,0,[]],227,956,[],[],
[0,"Default",0,1]],[[-6413,460,0,17,451,0,1.04581093788147,1,0.529411792755127,0.5011086463928223,0,0,[]],157,803,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6753,595,0,17,451,0,1.206802368164063,1,0.529411792755127,0.5011086463928223,0,0,[]],157,804,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6986,922,0,107,495,0,0,1,0.5046728849411011,0.5,0,0,[]],139,805,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6648,798,0,107,495,0,0,1,0.5046728849411011,0.5,0,0,[]],139,806,
[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6627,818,0,107,495,0,0,1,0.5046728849411011,0.5,0,0,[]],139,807,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7019,911,0,107,495,0,0,1,0.5046728849411011,0.5,0,0,[]],139,808,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6252,703,0,107,695,0,0,1,0.5046728849411011,0.5,0,0,[]],139,809,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[670,308,0,25,23,0,0,1,0.5,0.5,0,0,[]],76,649,[],[[0,0,0,0,1]],[1,"Default",0,1]],[[-5440,
622,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,810,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5148,763,0,107,903,0,0,1,0.5046728849411011,0.5,0,0,[]],139,811,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5282,325,0,17,485,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,0,0,[]],157,812,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4835,293,0,17,451,0,1.354681968688965,1,0.529411792755127,0.5011086463928223,0,0,[]],157,813,[],[[1,0,0,2,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[-3982,307,0,17,753,0,1.328040599822998,1,0.529411792755127,0.5011086463928223,0,0,[]],157,814,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5097,763,0,107,903,0,0,1,0.5046728849411011,0.5,0,0,[]],139,815,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5053,784,0,107,903,0,0,1,0.5046728849411011,0.5,0,0,[]],139,816,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4654,693,0,107,903,0,0,1,0.5046728849411011,0.5,0,0,[]],139,817,[],[[1,0,0,1,0.5,0.2,
0,0.01,0,1]],[0,"Default",0,1]],[[-4337,833,0,107,903,0,0,1,0.5046728849411011,0.5,0,0,[]],139,818,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4387,819,0,107,903,0,0,1,0.5046728849411011,0.5,0,0,[]],139,819,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3661,661,0,107,903,0,0,1,0.5046728849411011,0.5,0,0,[]],139,820,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3422,-3,0,98,384,0,0,1,0,0,0,0,[]],158,824,[],[],[0,0]],[[-3422,364,0,98,379,0,0,1,0,0,0,0,[]],158,825,[],
[],[0,0]],[[-2817,-258,0,107,903,0,-0.575120747089386,1,0.5046728849411011,0.5,0,0,[]],139,821,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3422,727,0,98,379,0,0,1,0,0,0,0,[]],158,826,[],[],[0,0]],[[-2491.919921875,806.0469360351562,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,822,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2466,807,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,823,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2418,
807,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,828,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2394,807,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,829,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2346,807,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,830,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2442,807,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,831,[],[[0,2,0,1,0.5,0.2,0,0.01,0,
1]],[0,"Default",0,1]],[[-2370,807,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,832,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2322,801,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,833,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2298,759,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,834,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2310,780,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,835,
[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2526,954,0,72,287,0,0,1,0.5046728849411011,0.5,0,0,[]],139,836,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2340,783,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,838,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2328,762,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,841,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2364,783,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,
0,0,[]],160,842,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2253,735,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,843,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2412,783,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,844,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2436,783,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,845,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2424,762,0,24,24,0,0,1,0.5126582384109497,
0.4966887533664703,0,0,[]],160,846,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2388,783,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,847,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2460,783,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,848,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2376,762,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,849,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2352,762,0,
24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,850,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2400,762,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,851,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2229,735,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,852,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2157,735,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,853,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,
"Default",0,1]],[[-2133,735,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,854,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2205,735,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,855,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2277,735,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,856,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2181,735,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,839,[],[[0,
2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2121,711,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,840,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2340,741,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,857,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2313,741,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,858,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2298,723,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,
0,0,[]],160,859,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2265,714,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,860,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2145,714,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,862,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2241,714,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,863,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2169,714,0,24,24,0,0,1,0.5126582384109497,
0.4966887533664703,0,0,[]],160,864,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2193,714,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,865,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2217,714,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,866,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2091,690,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,867,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2157,783,0,
72,287,0,0.6032877564430237,1,0.5046728849411011,0.5,0,0,[]],139,869,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2022.5,660,0,72,114,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,868,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2361,852,0,72,287,0,0.6221991777420044,1,0.5046728849411011,0.5,0,0,[]],139,870,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2151,733,0,72,297,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,837,[],[[1,0,0,1,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[-2028,744,0,72,270,0,0.5575708150863647,1,0.5046728849411011,0.5,0,0,[]],139,871,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1980,663,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,872,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2004,663,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,873,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2052,663,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,
874,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2028,663,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,877,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2016,642,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,879,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1992,642,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,880,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2040,642,0,24,24,0,0,1,0.5126582384109497,
0.4966887533664703,0,0,[]],160,881,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1968,642,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,882,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7416,519,0,107,495,0,1.337897419929504,1,0.5046728849411011,0.5,0,0,[]],139,894,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6999,393,0,107,495,0,1.211746335029602,1,0.5046728849411011,0.5,0,0,[]],139,895,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6597,
225,0,107,495,0,1.127162933349609,1,0.5046728849411011,0.5,0,0,[]],139,896,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6176.56005859375,-16.28125,0,108,621,0,0.9829020500183105,1,0.5046728849411011,0.5,0,0,[]],139,897,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5712,-186,0,107,495,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,898,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5292,-78,0,107,495,0,2.111536502838135,1,0.5046728849411011,0.5,0,0,[]],139,899,
[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1605,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,900,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1575,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,901,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1545,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,902,[],[[0,0,0,1,0.5,0.2,0,0.01,0,
1]],[0,"Default",0,1]],[[-1515,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,903,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1485,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,904,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1455,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,905,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1425,
789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,906,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1395,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,907,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1365,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,908,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1335,789,0,40.615234375,63.74981689453125,
0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,909,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1305,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,910,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1275,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,911,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1245,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,
0,0,[]],12,912,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1215,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,913,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1185,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,914,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1155,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,915,[],[[0,0,0,1,0.5,
0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1125,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,916,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1095,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,917,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1065,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,918,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[-1035,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,919,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1005,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,920,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-975,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,921,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-945,789,0,40.615234375,
63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,922,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-915,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,923,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-885,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,924,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-855,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,
0.5049999952316284,0,0,[]],12,925,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-825,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,926,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-795,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,927,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-765,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,928,
[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-735,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,929,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-705,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,930,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-675,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,931,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],
[0,"Default",0,1]],[[-645,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,932,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-615,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,933,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-585,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,934,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1815,789,0,
40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,884,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1785,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,885,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1755,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,886,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1725,789,0,40.615234375,63.74981689453125,
0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,887,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1695,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,888,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1665,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,889,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1635,789,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,
0,0,[]],12,890,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-582,906,0,72,287,0,0,1,0.5046728849411011,0.5,0,0,[]],139,891,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1857,903,0,72,287,0,0,1,0.5046728849411011,0.5,0,0,[]],139,892,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-570,900,0,72,287,0,0,1,0.5046728849411011,0.5,0,0,[]],139,935,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-558,888,0,72,287,0,0,1,0.5046728849411011,0.5,0,0,[]],139,936,[],[[1,0,0,1,
0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-543,879,0,72,287,0,0,1,0.5046728849411011,0.5,0,0,[]],139,937,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-528,867,0,72,287,0,0,1,0.5046728849411011,0.5,0,0,[]],139,938,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-513,855,0,72,287,0,0,1,0.5046728849411011,0.5,0,0,[]],139,939,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-372,966,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,942,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[-42,804,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,940,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-130.2976684570313,570.7855224609375,0,18,771,0,1.124711513519287,1,0.529411792755127,0.5011086463928223,0,0,[]],157,941,[],[[1,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1881.5009765625,726.99365234375,0,108,469,0,1.190446734428406,1,0.5046728849411011,0.5,0,0,[]],139,988,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1554,849,0,1194,481,0,0,1,0.5,0.5,0,0,[]],
227,494,[],[],[0,"Default",0,1]],[[981,981,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,973,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[993,981,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,974,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[966,981,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,975,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[951,981,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,976,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,
1]],[[2148,978,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,986,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2079,978,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,979,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2118,978,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,982,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2133,978,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,983,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2094,978,0,107,603,
0,0,1,0.5046728849411011,0.5,0,0,[]],139,977,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2106,978,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,978,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2064,978,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,980,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[936,981,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,984,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[921,981,0,107,603,0,0,1,0.5046728849411011,0.5,
0,0,[]],139,985,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[906,981,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,987,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7521,219,0,250,800,0,0,1,0.5,0.5,0,0,[]],188,1253,[],[],[0,"Default",0,1]],[[-7236,111,0,250,800,0,0.09602309763431549,1,0.5,0.5,0,0,[]],189,1254,[],[],[0,"Default",0,1]],[[-6828,-45,0,250,800,0,0.09602309763431549,1,0.5,0.5,0,0,[]],189,1255,[],[],[0,"Default",0,1]],[[-6429,-234,0,250,800,0,0.09602309763431549,
1,0.5,0.5,0,0,[]],189,1256,[],[],[0,"Default",0,1]],[[-5892,-540,0,250,800,0,0.2996516823768616,1,0.5,0.5,0,0,[]],189,1257,[],[],[0,"Default",0,1]],[[-5529,-540,0,250,800,0,0.09602309763431549,1,0.5,0.5,0,0,[]],189,1258,[],[],[0,"Default",0,1]],[[-5154,-315,0,250,800,0,0.09602309763431549,1,0.5,0.5,0,0,[]],189,1259,[],[],[0,"Default",0,1]],[[-2640,-339,0,250,800,0,0.09602309763431549,1,0.5,0.5,0,0,[]],189,1260,[],[],[0,"Default",0,1]],[[2520,663,0,107,603,0,0.8801217079162598,1,0.5046728849411011,
0.5,0,0,[]],139,1265,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2682,849,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1266,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2940,324,0,107,603,0,0.9001672267913818,1,0.5046728849411011,0.5,0,0,[]],139,1267,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2976,615,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1268,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3648,597,0,107,603,0,0,1,0.5046728849411011,0.5,
0,0,[]],139,1269,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3744,390,0,107,603,0,-0.8076303005218506,1,0.5046728849411011,0.5,0,0,[]],139,1270,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4179,525,0,107,603,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1271,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3951,852,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1272,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4419,852,0,107,603,0,0,1,0.5046728849411011,
0.5,0,0,[]],139,1273,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4689,423,0,107,603,0,1.144501209259033,1,0.5046728849411011,0.5,0,0,[]],139,1274,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5196,24,0,107,603,0,-1.271030306816101,1,0.5046728849411011,0.5,0,0,[]],139,1275,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5157,543,0,107,603,0,1.404558420181274,1,0.5046728849411011,0.5,0,0,[]],139,1276,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5421,360,0,107,603,
0,0,1,0.5046728849411011,0.5,0,0,[]],139,1277,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4629,771,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1278,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5382,-312,0,250,800,0,0.09602309763431549,1,0.5,0.5,0,0,[]],189,1279,[],[],[0,"Default",0,1]],[[5268,-981,0,250,800,0,0.09602309763431549,1,0.5,0.5,0,0,[]],189,1280,[],[],[0,"Default",0,1]],[[5019,-468,0,250,800,0,0,1,0.5,0.5,0,0,[]],188,1281,[],[],[0,"Default",0,1]],[[5214,-1194,
0,250,800,0,0,1,0.5,0.5,0,0,[]],188,1282,[],[],[0,"Default",0,1]],[[5541,-303,0,250,800,0,0,1,0.5,0.5,0,0,[]],188,1283,[],[],[0,"Default",0,1]],[[5712,-930,0,250,800,0,0,1,0.5,0.5,0,0,[]],188,1284,[],[],[0,"Default",0,1]],[[5964,729,0,17,451,0,1.206602573394775,1,0.529411792755127,0.5011086463928223,0,0,[]],157,1285,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6396,600,0,17,451,0,1.354681968688965,1,0.529411792755127,0.5011086463928223,0,0,[]],157,1286,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],
[0,"Default",0,1]],[[6837,531,0,17,451,0,1.476611137390137,1,0.529411792755127,0.5011086463928223,0,0,[]],157,1287,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7287,510,0,17,451,0,1.570937871932983,1,0.529411792755127,0.5011086463928223,0,0,[]],157,1288,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7734,465,0,17,451,0,1.354681968688965,1,0.529411792755127,0.5011086463928223,0,0,[]],157,1289,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8181,393,0,17,451,0,1.464062213897705,
1,0.529411792755127,0.5011086463928223,0,0,[]],157,1290,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8634,378,0,17,451,0,1.599878907203674,1,0.529411792755127,0.5011086463928223,0,0,[]],157,1291,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[9078,438,0,17,451,0,1.79352080821991,1,0.529411792755127,0.5011086463928223,0,0,[]],157,1292,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[11007,591,0,17,451,0,0,1,0.529411792755127,0.5011086463928223,0,0,[]],157,1293,[],[[0,0,0,2,0.5,
0.2,0,0.01,0,1]],[0,"Default",0,1]],[[11007,144,0,17,451,0,0,1,0.529411792755127,0.5011086463928223,0,0,[]],157,1294,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6015,1002,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1295,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6333,909,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1296,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6432,891,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1297,[],[[1,0,0,1,0.5,0.2,0,
0.01,0,1]],[0,"Default",0,1]],[[6762,840,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1298,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6858,831,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1299,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7200,813,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1300,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7284,813,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1301,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[7650,780,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1302,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[7740,759,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1303,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8097,699,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1304,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8196,690,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1305,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8562,681,0,107,
603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1306,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8649,681,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1307,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[8904,708,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1308,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[9267,789,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1309,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-10499,815,0,1823,512,0,0,1,0,0,0,0,
[]],148,347,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-8683,1217,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,375,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,"Default",0,1]],[[-7644,1290,0,44,944,0,0,1,0.5,0.5,0,0,[]],149,376,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,"Default",0,1]],[[-7626,818,0,25285,512,0,0,1,0,0,0,0,[]],133,778,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-7694,821,0,21434,512,0,0,1,0,0,0,0,[]],266,1464,[],[],[0,0]],[[-10379,816,0,1730,512,0,0,1,0,0,0,0,[]],266,1465,[],[],[0,0]],[[697,75,0,242.4135437011719,
184.9008636474609,0,0,1,0.5009980201721191,0.5,0,0,[]],19,719,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[879,82,0,81.50032043457031,51.99996185302734,0,0,1,0.5,0.5033556818962097,0,0,[]],63,718,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[522,77,0,49,42,0,0,1,0.5,0.5033556818962097,0,0,[]],62,720,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1277,657,0,290.3739929199219,236.5,0,0.01873116753995419,1,0.4986737370491028,0.5899053812026978,0,0,[]],4,721,[[0]],[[0,0,0,0,1]],[0,"Default",0,1]],[[116,637,0,290.3739929199219,
236.5,0,-0.01518769562244415,1,0.5013262629508972,0.5015772581100464,0,0,[]],5,722,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-9350.765625,769.1263427734375,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],226,582,[],[],[0,"Default",0,1]],[[693,362,0,2184,1480,0,0,1,0.5,0.5,0,0,[]],102,650,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1074,2169.5,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],78,646,[],[],[0,"Default",0,1]],[[939,1410,0,319,266,0,0,1,0.5,0.5,0,0,[]],73,651,[],[],[0,"Default",0,1]]],[]]],[],[]],["Level4",1708,960,!0,"Level4Event",
0x44644980cf0ce,[["Layer 4",0,0x583ace8e14c6c,!0,[255,255,255],!0,0.2000000029802322,0.2000000029802322,1,!1,1,0,0,[[[835,483,0,2048,1163,0,0,1,0.5,0.5011236071586609,0,0,[]],7,177,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-1322,3039,0,2062,1293,0,0,1,0.5,0.5011236071586609,0,0,[]],121,178,[],[[0,0,0,0,1],[1,4,0,0,1]],[0,"Default",0,1]],[[-10003,417,0,21728,176,0,0,1,0,0,0,0,[]],146,179,[],[],[0,0]],[[-10436,544,0,22870,1408,0,0,1,0,0,0,0,[]],147,180,[],[],[0,0]]],[]],["Layer 1",1,5044499875936925,!0,
[255,255,255],!0,0.4000000059604645,0.4000000059604645,1,!1,1,0,0,[[[-10054,407,0,21840,725,0,0,1,0,0,0,0,[]],144,181,[],[],[0,0]],[[-10348,597,0,22380,1408,0,0,1,0,0,0,0,[]],145,182,[],[],[0,0]]],[]],["Layer 2",2,8708137401168979,!0,[255,255,255],!0,0.6000000238418579,0.6000000238418579,1,!1,1,0,0,[[[-10079,311,0,21590,758,0,0,1,0,0,0,0,[]],142,183,[],[],[0,0]],[[-10553,664,0,22530,1408,0,0,1,0,0,0,0,[]],143,184,[],[],[0,0]]],[]],["Layer 3",3,5884967923497818,!0,[255,255,255],!0,0.8999999761581421,
0.800000011920929,1,!1,1,0,0,[[[-10584,411,0,24928,621,0,0,1,0,0,0,0,[]],140,185,[],[],[0,0]],[[-13742,762,0,28463,1533,0,0,1,0,0,0,0,[]],141,186,[],[],[0,0]]],[]],["Layer 0",4,729080403336473,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[14136.3154296875,661.3118286132812,0,70.6806640625,376.8765258789063,0,0,1,0.5142857432365417,0.5,0,0,[]],80,495,[],[],[0,"Default",0,1]],[[-10017,451,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,496,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,"Default",0,1]],[[15001.365234375,462.5004272460938,
0,32,804,0,0,1,0.5,0.5,0,0,[]],0,497,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6932,574,0,780,778.2999877929688,0,0,1,0.5,0.5,0,0,[]],207,481,[],[[1,5,0,4,0,0,0,10,0],[1,1,0,4,0,0,0,10,0]],[0,"Default",0,1]],[[-6956,1074,0,2401,1282,0,0,1,0.5,0.5,0,0,[]],227,957,[],[],[0,"Default",0,1]],[[-8755.794921875,490.8134765625,0,1555,5,0,-0.3187670707702637,1,0.5,0.5,0,0,[]],20,498,[],[],[1,"Default",0,1]],[[-9643.2529296875,781,0,40.04000091552734,39.25490188598633,0,0,1,0.4945054948329926,
0.4945054948329926,0,0,[]],44,499,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9543,783,0,40.04000091552734,39.25490188598633,0,0,1,0.4945054948329926,0.4945054948329926,0,0,[]],45,500,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9643.240234375,782.5,0,15.86400032043457,15.2819995880127,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],50,501,[],[[]],[0,"Default",0,1]],[[-9543,783,0,15.86417293548584,15.28224849700928,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],
49,502,[],[[]],[0,"Default",0,1]],[[-8626,454,0,53,54,0,0,1,0.5,0.5,0,0,[]],21,503,[],[[1]],[1,"Default",0,1]],[[-9598.5029296875,758.9990234375,0,139.9329986572266,71.58155822753906,0,0,1,0.4996415674686432,0.5,0,0,[]],43,527,[],[[],[0,0,0,0.1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-9613.6123046875,721.9996948242188,0,13.80799961090088,38.27399826049805,0,0.3524599075317383,1,0.5,0.5,0,0,[]],56,563,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9606,771,0,80.68636322021484,27.58581161499023,
0,-0.02719682641327381,1,0.5012787580490112,0.511904776096344,0,0,[]],46,641,[],[[0,0,0,1.2,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9525,774,0,33.02397918701172,15.33616733551025,0,-0.1354803889989853,1,0.5,0.5128205418586731,0,0,[]],47,647,[],[[0,2,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9570,780,0,54.239990234375,29.06821441650391,0,-2.640111923217773,1,0.5,0.5128205418586731,0,0,[]],48,861,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9602.8720703125,696.8746948242188,0,23.86599922180176,
19.45499992370606,0,0.237887367606163,1,0.5,0.5,0,0,[]],54,875,[],[[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9614.8876953125,743.749267578125,0,11.43299961090088,27.75300025939941,0,-0.5489532947540283,1,0.5,0.5,0,0,[]],57,876,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9608.376953125,762.5008544921875,0,7.695000171661377,28.19000053405762,0,-0.06733601540327072,1,0.5,0.5016077160835266,0,0,[]],58,893,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9604.7529296875,776.8749389648438,
0,12.75500011444092,8.074000358581543,0,0,1,0.5,0.5,0,0,[]],59,943,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9604.8681640625,717.6243286132812,0,8.534000396728516,24.24699974060059,0,-0.7757092118263245,1,0.5037593841552734,0.5016501545906067,0,0,[]],60,944,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9587.9931640625,725.24951171875,0,25.45100021362305,6.638999938964844,0,0.07037980109453201,1,0.5,0.5,0,0,[]],61,945,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9653.1259765625,
751.1251220703125,0,109.9668197631836,113.9811706542969,0,-3.083474397659302,1,0,0.5,0,0,[]],66,946,[],[],[300,60,0,200,10,100,0,0,0,0,0,0,-150,0,0,800,0,0,1]],[[14231.22265625,672.3741455078125,0,240.50390625,422.2508850097656,0,0,1,0.5,0.5,0,0,[]],74,947,[],[],[0,"Default",0,1]],[[618.5,3793,0,55,102,0,0,1,0.5,0.5,0,0,[]],79,948,[],[],[0,"Default",0,1]],[[-9482.3662109375,798.2501831054688,0,78.9951171875,64,0,0,1,0.5022830963134766,0.5039370059967041,0,0,[]],101,949,[],[[1,0,0,1,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[-9143,919,0,165,728,0,0,1,0.5046728849411011,0.5,0,0,[]],98,950,[],[],[0,"Default",0,1]],[[-9194,637,0,134,44,0,0,1,0.5,0.503496527671814,0,0,[]],99,951,[],[],[0,"Default",0,1]],[[670,308,0,25,23,0,0,1,0.5,0.5,0,0,[]],76,1100,[],[[0,0,0,0,1]],[1,"Default",0,1]],[[-5974,2074,0,107,495,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1169,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7370,2035,0,17,1224,0,1.570796370506287,1,0.529411792755127,0.5011086463928223,
0,0,[]],157,955,[],[[0,0,0,2,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8410,820,0,800,512,0,-0.1790853142738342,1,0.5,0.5,0,0,[]],15,187,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9352,1688,0,4,49,0,0,1,0.5714285969734192,0.5,0,0,[]],191,188,[],[],[0,"Default",0,1]],[[-9352,1733,0,4,49,0,0,1,0.5714285969734192,0.5,0,0,[]],192,189,[],[],[0,"Default",0,1]],[[-9352,1781,0,4,49,0,0,1,0.5,0.5102040767669678,0,0,[]],193,190,[],[],[0,"Default",0,1]],[[-9352,1823,0,4,49,0,0,1,0.5,0.5102040767669678,
0,0,[]],194,191,[],[],[0,"Default",0,1]],[[-9352,1643,0,4,49,0,0,1,0.5714285969734192,0.5,0,0,[]],195,192,[],[],[0,"Default",0,1]],[[-9352,1595,0,4,49,0,0,1,0.5,0.5102040767669678,0,0,[]],196,193,[],[],[0,"Default",0,1]],[[-5572,579,0,1479,477,0,0,1,0.5,0.5017421841621399,0,0,[]],197,194,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6130,753,0,129,129,0,0,1,0.5,0.5,0,0,[]],198,214,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5979,753,0,129,129,0,0,1,0.5,0.5,0,0,[]],199,240,[],
[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4844,536,0,732,584,0,0,1,0.5,0.5,0,0,[]],200,407,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5119,753,0,129,129,0,0,1,0.5,0.5,0,0,[]],201,449,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4617,753,0,129,129,0,0,1,0.5,0.5,0,0,[]],202,472,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6145,736,0,156,132,0,0,1,0.5,0.5036496520042419,0,0,[]],203,473,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6006,734,0,153,
132,0,0,1,0.5,0.5036496520042419,0,0,[]],204,474,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5741,463,0,534,51,0,0,1,0.5,0.5056179761886597,0,0,[]],205,475,[],[],[0,"Default",0,1]],[[-5747,457,0,534,51,0,0,1,0.5,0.5056179761886597,0,0,[]],206,478,[],[],[0,"Default",0,1]],[[-4611.24853515625,591.0003662109375,0,117,12,0,0.174037367105484,1,0.5,0.5056179761886597,0,0,[]],205,479,[],[],[0,"Default",0,1]],[[-4612.00439453125,589.5006103515625,0,117,12,0,0.1740341186523438,1,0.5,0.5056179761886597,
0,0,[]],206,480,[],[],[0,"Default",0,1]],[[-6760,226,0,107,430,0,1.186159729957581,1,0.7383177280426025,0.02093023248016834,0,0,[]],208,482,[],[[1,0,0,0,1,0.2,0,0,0,1]],[0,"Default",0,1]],[[-6206,2146,0,107,542,0,0,1,2.111111164093018,0.4935400485992432,0,0,[]],209,483,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7019,1316,0,2496,28,0,0,1,0.5,0.5,0,0,[]],212,484,[],[],[1,"Default",0,1]],[[-4649,390,0,210,19,0,0,1,0.5,0.5056179761886597,0,0,[]],214,486,[],[],[0,"Default",0,1]],[[-4652,388,
0,210,19,0,0,1,0.5,0.5056179761886597,0,0,[]],215,485,[],[],[0,"Default",0,1]],[[-5288.99609375,463.0241088867188,0,379,53,0,0,1,0.501035213470459,0.5060241222381592,0,0,[]],216,487,[],[],[0,"Default",0,1]],[[-5295,458,0,379,53,0,0,1,0.501035213470459,0.5060241222381592,0,0,[]],217,488,[],[],[0,"Default",0,1]],[[-4035,542,0,732,584,0,0,1,0.5,0.5,0,0,[]],218,489,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4263,754,0,129,129,0,0,1,0.5,0.5,0,0,[]],219,490,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],
[0,"Default",0,1]],[[-3761,754,0,129,129,0,0,1,0.5,0.5,0,0,[]],220,491,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4222,396,0,210,19,0,0,1,0.5,0.5056179761886597,0,0,[]],223,493,[],[],[0,"Default",0,1]],[[-4224,393,0,210,19,0,0,1,0.5,0.5056179761886597,0,0,[]],221,492,[],[],[0,"Default",0,1]],[[-4266,593,0,117,12,0,-0.1570796966552734,1,0.5,0.5056179761886597,0,0,[]],225,954,[],[],[0,"Default",0,1]],[[-4267.5009765625,592,0,117,12,0,-0.1570796966552734,1,0.5,0.5056179761886597,0,0,[]],
224,953,[],[],[0,"Default",0,1]],[[-516,580,0,1479,477,0,0,1,0.5,0.5017421841621399,0,0,[]],228,981,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,0]],[[1974,537,0,732,584,0,0,1,0.5,0.5,0,0,[]],200,960,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1699,754,0,129,129,0,0,1,0.5,0.5,0,0,[]],201,961,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2201,754,0,129,129,0,0,1,0.5,0.5,0,0,[]],202,962,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-685,464,0,534,51,0,0,1,0.5,0.5056179761886597,
0,0,[]],205,965,[],[],[0,"Default",0,1]],[[-691,458,0,534,51,0,0,1,0.5,0.5056179761886597,0,0,[]],206,966,[],[],[0,"Default",0,1]],[[2207,592,0,117,12,0,0.174037367105484,1,0.5,0.5056179761886597,0,0,[]],205,967,[],[],[0,"Default",0,1]],[[2206,590,0,117,12,0,0.1740341186523438,1,0.5,0.5056179761886597,0,0,[]],206,968,[],[],[0,"Default",0,1]],[[2069,351,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,0.5049999952316284,0,0,[]],12,1209,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],
[[2169,391,0,210,19,0,0,1,0.5,0.5056179761886597,0,0,[]],214,969,[],[],[0,"Default",0,1]],[[2166,389,0,210,19,0,0,1,0.5,0.5056179761886597,0,0,[]],215,970,[],[],[0,"Default",0,1]],[[-233,464,0,379,53,0,0,1,0.501035213470459,0.5060241222381592,0,0,[]],216,971,[],[],[0,"Default",0,1]],[[-239,459,0,379,53,0,0,1,0.501035213470459,0.5060241222381592,0,0,[]],217,972,[],[],[0,"Default",0,1]],[[-571,330,0,149,1620,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,741,[],[[1,0,0,1,0.5,0.2,0,0.01,0,
1]],[1,"Default",0,1]],[[-565,619,0,149,1622,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,989,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,"Default",0,1]],[[-1177,829,0,107,332,0,0,1,0.5046728849411011,0.5,0,0,[]],229,990,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,"Default",0,1]],[[-2222,695,0,107,476,0,1.073105216026306,1,0.5046728849411011,0.5,0,0,[]],230,991,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2050,839,0,107,430,0,0,1,0.5046728849411011,0.5,0,0,[]],230,992,[],[[1,0,0,1,0.5,0.2,
0,0.01,0,1]],[0,"Default",0,1]],[[1404,743,0,107,476,0,1.237996578216553,1,0.5046728849411011,0.5,0,0,[]],230,993,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1799,521,0,107,591,0,0.8622212409973145,1,0.5046728849411011,0.5,0,0,[]],230,994,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1080,755,0,129,129,0,0,1,0.5,0.5,0,0,[]],231,995,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-920,756,0,129,129,0,0,1,0.5,0.5,0,0,[]],231,996,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[-1080,731,0,168,137,0,0,1,0.5,0.5036496520042419,0,0,[]],232,958,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-918,729,0,168,137,0,0,1,0.5,0.5036496520042419,0,0,[]],232,959,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2983,648,0,107,591,0,0.9030811786651611,1,0.5046728849411011,0.5,0,0,[]],230,998,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2318,54,0,107,591,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,963,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[2548,-298,0,250,800,0,0.09602309763431549,1,0.5,0.5,0,0,[]],189,964,[],[],[0,"Default",0,1]],[[2102,-299,0,250,800,0,0.2996516823768616,1,0.5,0.5,0,0,[]],189,997,[],[],[0,"Default",0,1]],[[3468,466,0,107,591,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,999,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3930,331,0,107,591,0,0.9359760284423828,1,0.5046728849411011,0.5,0,0,[]],230,1E3,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4380,56,0,107,591,0,1.11939013004303,
1,0.5046728849411011,0.5,0,0,[]],230,1001,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4863,-144,0,107,591,0,1.240338325500488,1,0.5046728849411011,0.5,0,0,[]],230,1002,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5014,-566,0,107,1437,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1003,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5927,-418,0,107,591,0,2.21237325668335,1,0.5046728849411011,0.5,0,0,[]],230,1004,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,
1]],[[6105,610,0,107,603,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1005,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5035,520,0,107,591,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1006,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5271,840,0,107,591,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1007,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4783,840,0,107,591,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1008,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4099,
560,0,107,691,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1009,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3715,786,0,107,591,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1010,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3215,788,0,107,591,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1011,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4607,462,0,107,1015,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1012,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4786,249,0,107,711,0,0,1,
0.5046728849411011,0.5,0,0,[]],230,1013,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5634,-1064,0,365,1116,0,0.09602309763431549,1,0.5,0.5,0,0,[]],189,1014,[],[],[0,"Default",0,1]],[[6024,-895,0,488,1397,0,0.09602309763431549,1,0.5,0.5,0,0,[]],189,1015,[],[],[0,"Default",0,1]],[[4582,-1182,0,473,1380,0,0.4932505786418915,1,0.5,0.5,0,0,[]],189,1016,[],[],[0,"Default",0,1]],[[5919,0,0,107,449,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1017,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,
"Default",0,1]],[[5810,286,0,107,683,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1018,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5546,662,0,107,591,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1019,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5780,980,0,107,591,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1020,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6368,815,0,25565,1060,0,0,1,0,0,0,0,[]],133,1248,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],
[[6138.4951171875,166.2500305175781,0,15.9912109375,274.5001220703125,0,0,1,0.5,0.5,0,0,[]],233,1021,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6111,-88,0,107,295,0,0,1,0.5046728849411011,0.5,0,0,[]],234,1022,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-10527,815,0,2485,932,0,0,1,0,0,0,0,[]],236,1101,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-10455,824,0,2468,930,0,0,1,0,0,0,0,[]],266,1466,[],[],[0,0]],[[-6404,819,0,21440,1084,0,0,1,0,0,0,0,[]],266,1467,[],[],[0,0]],[[116,
637,0,290.3739929199219,236.5,0,-0.01518769562244415,1,0.5013262629508972,0.5015772581100464,0,0,[]],5,1232,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1277,657,0,290.3739929199219,236.5,0,0.01873116753995419,1,0.4986737370491028,0.5899053812026978,0,0,[]],4,1249,[[0]],[[0,0,0,0,1]],[0,"Default",0,1]],[[879,82,0,81.50032043457031,51.99996185302734,0,0,1,0.5,0.5033556818962097,0,0,[]],63,1229,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[697,75,0,242.4135437011719,184.9008636474609,0,0,1,0.5009980201721191,0.5,
0,0,[]],19,1228,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[522,77,0,49,42,0,0,1,0.5,0.5033556818962097,0,0,[]],62,1227,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-9318,744,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],226,655,[],[],[0,"Default",0,1]],[[693,362,0,2184,1480,0,0,1,0.5,0.5,0,0,[]],102,1230,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1074,2169.5,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],78,1233,[],[],[0,"Default",0,1]],[[939,1410,0,319,266,0,0,1,0.5,0.5,0,0,[]],73,1251,[],[],[0,"Default",0,1]]],[]]],[],[]],["Level5",1708,
960,!0,"Level5Event",7069478944974785,[["Layer 4",0,9781551738572468,!0,[255,255,255],!0,0.2000000029802322,0.2000000029802322,1,!1,1,0,0,[[[859,499,0,2048,1163,0,0,1,0.5,0.5011236071586609,0,0,[]],7,1023,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[870,463,0,2062,1293,0,0,1,0.5,0.5011236071586609,0,0,[]],121,1024,[],[[0,0,0,0,1],[1,4,0,0,1]],[0,"Default",0,1]]],[]],["Layer 0",1,0x3bdba539ded1b,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[14136.3154296875,661.3118286132812,0,70.6806640625,376.8765258789063,0,0,
1,0.5142857432365417,0.5,0,0,[]],80,1033,[],[],[0,"Default",0,1]],[[-10009,9860,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,1034,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,"Default",0,1]],[[15001.365234375,462.5004272460938,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,1035,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8946,9903,0,1555,5,0,-0.3187670707702637,1,0.5,0.5,0,0,[]],20,1038,[],[],[1,"Default",0,1]],[[-9773,10173,0,40.04000091552734,39.25490188598633,0,0,1,0.4945054948329926,0.4945054948329926,0,0,[]],44,1039,
[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9673,10175,0,40.04000091552734,39.25490188598633,0,0,1,0.4945054948329926,0.4945054948329926,0,0,[]],45,1040,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-9773,10175,0,15.86400032043457,15.2819995880127,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],50,1041,[],[[]],[0,"Default",0,1]],[[-9673,10175,0,15.86417293548584,15.28224849700928,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],49,1042,[],[[]],[0,"Default",0,1]],[[-8756,
9846,0,53,54,0,0,1,0.5,0.5,0,0,[]],21,1043,[],[[1]],[1,"Default",0,1]],[[-9726.92578125,10147.505859375,0,139.9329986572266,71.58155822753906,0,0,1,0.4996415674686432,0.5,0,0,[]],43,1044,[],[[],[0,0,0,0.1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-9744.15234375,10111.6318359375,0,13.80799961090088,38.27399826049805,0,0.3524599075317383,1,0.5,0.5,0,0,[]],56,1045,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9736,10163,0,80.68636322021484,27.58581161499023,0,-0.02719682641327381,1,0.5012787580490112,
0.511904776096344,0,0,[]],46,1046,[],[[0,0,0,1.2,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9655,10166,0,33.02397918701172,15.33616733551025,0,-0.1354803889989853,1,0.5,0.5128205418586731,0,0,[]],47,1047,[],[[0,2,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9700,10172,0,54.239990234375,29.06821441650391,0,-2.640111923217773,1,0.5,0.5128205418586731,0,0,[]],48,1048,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-9733.5869140625,10086.37109375,0,23.86599922180176,19.45499992370606,0,0.237887367606163,
1,0.5,0.5,0,0,[]],54,1049,[],[[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9744.787109375,10133.28125,0,11.43299961090088,27.75300025939941,0,-0.6223453283309937,1,0.5,0.5,0,0,[]],57,1050,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9736.626953125,10151.59375,0,7.695000171661377,28.19000053405762,0,-0.102828323841095,1,0.5,0.5016077160835266,0,0,[]],58,1051,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9732.3046875,10165.158203125,0,12.75500011444092,8.074000358581543,0,0,
1,0.5,0.5,0,0,[]],59,1052,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9734.6181640625,10106.69921875,0,8.534000396728516,24.24699974060059,0,-0.8329386115074158,1,0.5037593841552734,0.5016501545906067,0,0,[]],60,1053,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-9718.4658203125,10113.904296875,0,25.45100021362305,6.638999938964844,0,0.07037980109453201,1,0.5,0.5,0,0,[]],61,1054,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-9782.0263671875,10138.9130859375,0,109.9668197631836,
113.9811706542969,0,-3.083474397659302,1,0,0.5,0,0,[]],66,1055,[],[],[300,60,0,200,10,100,0,0,0,0,0,0,-150,0,0,800,0,0,1]],[[14231.22265625,672.3741455078125,0,240.50390625,422.2508850097656,0,0,1,0.5,0.5,0,0,[]],74,1056,[],[],[0,"Default",0,1]],[[618.5,3793,0,55,102,0,0,1,0.5,0.5,0,0,[]],79,1057,[],[],[0,"Default",0,1]],[[-9612,10190,0,78.9951171875,64,0,0,1,0.5022830963134766,0.5039370059967041,0,0,[]],101,1058,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-9277,10309,0,165,728,0,0,1,0.5046728849411011,
0.5,0,0,[]],98,1059,[],[],[0,"Default",0,1]],[[-9324,10029,0,134,44,0,0,1,0.5,0.503496527671814,0,0,[]],99,1060,[],[],[0,"Default",0,1]],[[670,308,0,25,23,0,0,1,0.5,0.5,0,0,[]],76,1061,[],[[0,0,0,0,1]],[1,"Default",0,1]],[[-6206,2146,0,18,487.7999877929688,0,0,1,2.111111164093018,0.4935400485992432,0,0,[]],209,1086,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4377,7227,0,107,495,0,1.167796850204468,1,0.5046728849411011,0.5,0,0,[]],139,1065,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[-3959,7083,0,107,495,0,1.323001742362976,1,0.5046728849411011,0.5,0,0,[]],139,1080,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3520,7021,0,107,495,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1081,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2404.497314453125,7183.7509765625,0,16,276,0,0,1,0.5,0.5,0,0,[]],233,1084,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2432.626220703125,6934.13623046875,0,107,295,0,0,1,0.5046728849411011,0.5,0,0,[]],234,
1085,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3084,7021,0,107,495,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1089,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2653,7020,0,107,501,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1090,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-10091,10207,0,2485,932,0,0,1,0,0,0,0,[]],148,1087,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-8019,10221,0,771,1015,0,-0.05037767067551613,1,0,0,0,0,[]],148,1036,[],
[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-7860,10238,0,771,1015,0,-0.1355598568916321,1,0,0,0,0,[]],148,1073,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-7566,10216,0,771,1015,0,-0.2368018925189972,1,0,0,0,0,[]],148,1074,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-7564,10266,0,771,1015,0,-0.392177551984787,1,0,0,0,0,[]],148,1075,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-7346,10195,0,771,1015,0,-0.4734649956226349,1,0,0,0,0,[]],148,1076,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-7234,10181,0,771,
1015,0,-0.6086961030960083,1,0,0,0,0,[]],148,1077,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-7045.9990234375,10082.0009765625,0,3366,1654,0,-0.7518941164016724,1,0,0,0,0,[]],148,1078,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-3987,7374,0,245,293,0,0,1,0,0,0,0,[]],244,952,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-4586,7782.99951171875,0,771,1535,0,-0.5313488841056824,1,0,0,0,0,[]],148,1079,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-3924,7393,0,771,2113,0,-0.0795077234506607,1,0,0,0,0,[]],148,
1082,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-3165,7332,0,771,2105,0,0,1,0,0,0,0,[]],148,1083,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-2451,8350,0,2261,1648,0,0,1,0,0,0,0,[]],148,1091,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-430,8370,0,1015,970,0,-0.1020724698901177,1,0,0,0,0,[]],148,1092,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-508,8413,0,1159,970,0,-0.1826175004243851,1,0,0,0,0,[]],148,1093,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-886.5916748046875,8570.8857421875,0,1859,1430,0,-0.2702565491199493,
1,0,0,0,0,[]],148,1094,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-168,8425.0009765625,0,1159,1356,0,-0.3922425508499146,1,0,0,0,0,[]],148,1095,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-22,8400,0,1159,970,0,-0.4716006815433502,1,0,0,0,0,[]],148,1096,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[58,8448,0,1159,970,0,-0.6313051581382751,1,0,0,0,0,[]],148,1097,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[336,8278,0,1159,970,0,-0.7069017887115479,1,0,0,0,0,[]],148,1098,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],
[0,0]],[[227.370849609375,8494.5498046875,0,10427,1446,0,-0.8276975154876709,1,0,0,0,0,[]],148,1099,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[7285,815,0,11912,1060,0,0,1,0,0,0,0,[]],133,1151,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[3269,2994,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1067,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[3421,2482,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1068,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],
[[3524,2939,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1069,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[4212,2340,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1070,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[4740,1836,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1071,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[5676,1219,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1072,[],[[0,2,0,1,0.5,0.2,
0,0.01,0,0]],[0,"Default",0,1]],[[6436,564,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1088,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[5828,-140,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1062,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[6100,915,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1066,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[4764,1059,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],
160,1102,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[4212,1339,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1103,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[5252,259,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1104,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[7356,-1062,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1105,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-10211,10212,0,3612,745,0,0,1,0,0,0,
0,[]],266,1468,[],[],[0,0]],[[-7125,10179,0,3482,712,0,-0.7518329620361328,1,0,0,0,0,[]],266,1469,[],[],[0,0]],[[-7255,10168,0,152,153,0,-0.5774866342544556,1,0,0,0,0,[]],266,1470,[],[],[0,0]],[[-3931,7344,0,1562,2005,0,0,1,0,0,0,0,[]],266,1471,[],[],[0,0]],[[-4561,7772,0,731,770,0,-0.5313482284545898,1,0,0,0,0,[]],266,1472,[],[],[0,0]],[[-2368,8360,0,3276,1565,0,0,1,0,0,0,0,[]],266,1473,[],[],[0,0]],[[618,8092,0,9794,1426,0,-0.8277053833007812,1,0,0,0,0,[]],266,1474,[],[],[0,0]],[[526.0864868164062,
8176.54736328125,0,128,297,0,-0.5804417133331299,1,0,0,0,0,[]],266,1475,[],[],[0,0]],[[421,8255,0,128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1476,[],[],[0,0]],[[233.5165405273438,8330.515625,0,180,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1477,[],[],[0,0]],[[829,9033,0,606,594,0,-0.6840137243270874,1,0,0,0,0,[]],266,1478,[],[],[0,0]],[[861,8484,0,128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1479,[],[],[0,0]],[[1004,8627,0,128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1480,[],[],[0,0]],
[[889,8693,0,128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1481,[],[],[0,0]],[[8256,828,0,5983,1108,0,0,1,0,0,0,0,[]],266,1482,[],[],[0,0]],[[7306,894,0,128,148,0,-0.2416330575942993,1,0,0,0,0,[]],266,1483,[],[],[0,0]],[[7483,856,0,715,438,0,0,1,0,0,0,0,[]],266,1484,[],[],[0,0]],[[8109,897,0,128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1485,[],[],[0,0]],[[8064,1277,0,128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1486,[],[],[0,0]],[[7806,1380,0,128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,
1487,[],[],[0,0]],[[7936,1381,0,128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1488,[],[],[0,0]],[[8068,1496,0,128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1489,[],[],[0,0]],[[7979,1577,0,128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1490,[],[],[0,0]],[[697,75,0,242.4135437011719,184.9008636474609,0,0,1,0.5009980201721191,0.5,0,0,[]],19,1157,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[879,82,0,81.50032043457031,51.99996185302734,0,0,1,0.5,0.5033556818962097,0,0,[]],63,1156,[],[[0,0,0,0,1]],[0,"Default",
0,1]],[[522,77,0,49,42,0,0,1,0.5,0.5033556818962097,0,0,[]],62,1158,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1277,657,0,290.3739929199219,236.5,0,0.01873116753995419,1,0.4986737370491028,0.5899053812026978,0,0,[]],4,1155,[[0]],[[0,0,0,0,1]],[0,"Default",0,1]],[[116,637,0,290.3739929199219,236.5,0,-0.01518769562244415,1,0.5013262629508972,0.5015772581100464,0,0,[]],5,1154,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-9491.88671875,10145.0517578125,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],226,1159,[],[],[0,"Default",
0,1]],[[693,362,0,2184,1480,0,0,1,0.5,0.5,0,0,[]],102,1160,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1074,2169.5,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],78,1063,[],[],[0,"Default",0,1]],[[939,1410,0,319,266,0,0,1,0.5,0.5,0,0,[]],73,1064,[],[],[0,"Default",0,1]],[[811,7589,0,32,570,0,-0.4196294844150543,1,0.5,0.5,0,0,[]],238,1037,[],[],[1,"Default",0,1]]],[]]],[],[]],["Level6",1708,960,!0,"Level6Event",9097050509947636,[["Layer 4",0,7397785932933385,!0,[255,255,255],!0,0.2000000029802322,0.2000000029802322,
1,!1,1,0,0,[[[859,499,0,2048,1163,0,0,1,0.5,0.5011236071586609,0,0,[]],7,1025,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[870,463,0,2062,1293,0,0,1,0.5,0.5011236071586609,0,0,[]],121,1026,[],[[0,0,0,0,1],[1,4,0,0,1]],[0,"Default",0,1]]],[]],["Layer 0",1,5061574710464219,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[11243,-4855,0,70.6806640625,376.8765258789063,0,0,1,0.5142857432365417,0.5,0,0,[]],80,1203,[],[],[0,"Default",0,1]],[[6459,-3530,0,5248,4366,0,0,1,0.5,0.5,0,0,[]],227,1200,[],[],[0,"Default",0,1]],[[11340,
-4834,0,240.50390625,422.2508850097656,0,0,1,0.5,0.5,0,0,[]],74,1202,[],[],[0,"Default",0,1]],[[-461,-5368,0,771,2105,0,0,1,0,0,0,0,[]],148,1149,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-1541,-3560,0,4001,1648,0,0,1,0,0,0,0,[]],148,1150,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[1763,-3339,0,1859,1430,0,-0.2702565491199493,1,0,0,0,0,[]],148,1161,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[300.0627136230469,-5511.44873046875,0,16.37521362304688,281.8603515625,0,0,1,0.5,0.5,0,0,[]],233,1134,[],[[0,
0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[272,-5764,0,107,295,0,0,1,0.5046728849411011,0.5,0,0,[]],234,1135,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[51,-5680,0,107,501,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1137,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2220,-3540,0,1015,970,0,-0.1020724698901177,1,0,0,0,0,[]],148,1152,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[2142,-3497,0,1159,970,0,-0.1826175004243851,1,0,0,0,0,[]],148,1153,[],[[1,0,0,1,0.5,0.2,
0,0.01,0,1]],[0,0]],[[2482,-3485,0,1159,1356,0,-0.3922425508499146,1,0,0,0,0,[]],148,1162,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[2628,-3510,0,1159,970,0,-0.4716006815433502,1,0,0,0,0,[]],148,1163,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[2708,-3462,0,1159,970,0,-0.6313051581382751,1,0,0,0,0,[]],148,1164,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[3461,-4321,0,32,570,0,-0.4196294844150543,1,0.5,0.5,0,0,[]],238,1176,[],[],[1,"Default",0,1]],[[7566,-4716,0,12500,1060,0,0,1,0,0,0,0,[]],133,1167,[],
[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[1646.97412109375,-2488.262939453125,0,2920,4373,0,-0.7069017887115479,1,0,0,0,0,[]],148,1165,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[3821,-1516,0,4922,2825,0,-0.7069017887115479,1,0,0,0,0,[]],148,1201,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-8347,-5201,0,1685,1923,0,-0.1977391242980957,1,0,0,0,0,[]],148,1198,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-1283,-5326,0,245,293,0,0,1,0,0,0,0,[]],244,1146,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-1882,-4917.00048828125,
0,771,1887,0,-0.5313488841056824,1,0,0,0,0,[]],148,1147,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-1220,-5307,0,771,2443,0,-0.0795077234506607,1,0,0,0,0,[]],148,1148,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-5315,-2479,0,771,1015,0,-0.05037767067551613,1,0,0,0,0,[]],148,1139,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-5156,-2462,0,771,1015,0,-0.1355598568916321,1,0,0,0,0,[]],148,1140,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-4862,-2484,0,771,1015,0,-0.2368018925189972,1,0,0,0,0,[]],148,1141,
[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-4860,-2434,0,771,1015,0,-0.392177551984787,1,0,0,0,0,[]],148,1142,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-4642,-2505,0,771,1015,0,-0.4734649956226349,1,0,0,0,0,[]],148,1143,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-4530,-2519,0,771,1015,0,-0.6086961030960083,1,0,0,0,0,[]],148,1144,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-4342,-2618,0,3366,1654,0,-0.7518941164016724,1,0,0,0,0,[]],148,1145,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-6409,-3902,0,
771,1015,0,1.0008944272995,1,0,0,0,0,[]],148,1190,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-6170,-3521,0,771,1015,0,0.9157122373580933,1,0,0,0,0,[]],148,1191,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-5992,-3243,0,771,1015,0,0.8144701719284058,1,0,0,0,0,[]],148,1192,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-5778,-2929,0,771,1015,0,0.659094512462616,1,0,0,0,0,[]],148,1193,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-5532,-2716,0,771,1015,0,0.5778070688247681,1,0,0,0,0,[]],148,1194,[],[[1,0,0,1,
0.5,0.2,0,0.01,0,1]],[0,0]],[[-5528,-2670,0,771,1015,0,0.442575991153717,1,0,0,0,0,[]],148,1195,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-5443,-2595,0,771,1015,0,0.3027683198451996,1,0,0,0,0,[]],148,1196,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-5487,-2584,0,771,1015,0,0.2384104430675507,1,0,0,0,0,[]],148,1197,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-6497,-4135,0,771,1015,0,1.104179501533508,1,0,0,0,0,[]],148,1199,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-1673,-5473,0,107,495,0,1.167796850204468,
1,0.5046728849411011,0.5,0,0,[]],139,1131,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1255,-5617,0,107,495,0,1.323001742362976,1,0.5046728849411011,0.5,0,0,[]],139,1132,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-816,-5679,0,107,495,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1133,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-380,-5679,0,107,495,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1136,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[7356,-1062,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1189,[],[[0,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[14136.3154296875,661.3118286132812,0,70.6806640625,376.8765258789063,0,0,1,0.5142857432365417,0.5,0,0,[]],80,1027,[],[],[0,"Default",0,1]],[[-9129,-5916,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,1028,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,"Default",0,1]],[[15001.365234375,462.5004272460938,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,1029,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[-8066,-5873,0,1555,5,0,-0.3187670707702637,1,0.5,0.5,0,0,[]],20,1030,[],[],[1,"Default",0,1]],[[-8893,-5603,0,40.04000091552734,39.25490188598633,0,0,1,0.4945054948329926,0.4945054948329926,0,0,[]],44,1031,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-8793,-5601,0,40.04000091552734,39.25490188598633,0,0,1,0.4945054948329926,0.4945054948329926,0,0,[]],45,1032,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-8893,-5601,0,15.86400032043457,15.2819995880127,0,0,1,0.5121951103210449,
0.4975369572639465,0,0,[]],50,1107,[],[[]],[0,"Default",0,1]],[[-8793,-5601,0,15.86417293548584,15.28224849700928,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],49,1108,[],[[]],[0,"Default",0,1]],[[-7876,-5930,0,53,54,0,0,1,0.5,0.5,0,0,[]],21,1109,[],[[1]],[1,"Default",0,1]],[[-8848.1943359375,-5625.9970703125,0,139.9329986572266,71.58155822753906,0,0,1,0.4996415674686432,0.5,0,0,[]],43,1110,[],[[],[0,0,0,0.1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-8866.4248046875,-5662.03173828125,0,
13.80799961090088,38.27399826049805,0,0.3524599075317383,1,0.5,0.5,0,0,[]],56,1111,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-8856,-5613,0,80.68636322021484,27.58581161499023,0,-0.02719682641327381,1,0.5012787580490112,0.511904776096344,0,0,[]],46,1112,[],[[0,0,0,1.2,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-8775,-5610,0,33.02397918701172,15.33616733551025,0,-0.1354803889989853,1,0.5,0.5128205418586731,0,0,[]],47,1113,[],[[0,2,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-8820,-5604,0,54.239990234375,
29.06821441650391,0,-2.640111923217773,1,0.5,0.5128205418586731,0,0,[]],48,1114,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-8854.4580078125,-5687.126953125,0,23.86599922180176,19.45499992370606,0,0.237887367606163,1,0.5,0.5,0,0,[]],54,1115,[],[[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-8866.3408203125,-5640.4541015625,0,11.43299961090088,27.75300025939941,0,-0.6223453283309937,1,0.5,0.5,0,0,[]],57,1116,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-8858.654296875,-5622.140625,
0,7.695000171661377,28.19000053405762,0,-0.102828323841095,1,0.5,0.5016077160835266,0,0,[]],58,1117,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-8854.03125,-5608.73583984375,0,12.75500011444092,8.074000358581543,0,0,1,0.5,0.5,0,0,[]],59,1118,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-8856.677734375,-5667.0478515625,0,8.534000396728516,24.24699974060059,0,-0.7845441699028015,1,0.5037593841552734,0.5016501545906067,0,0,[]],60,1119,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],
[[-8840.494140625,-5659.74951171875,0,25.45100021362305,6.638999938964844,0,0.07037980109453201,1,0.5,0.5,0,0,[]],61,1120,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-8902.8125,-5634.12353515625,0,109.9668197631836,113.9811706542969,0,-3.083474397659302,1,0,0.5,0,0,[]],66,1121,[],[],[300,60,0,200,10,100,0,0,0,0,0,0,-150,0,0,800,0,0,1]],[[14231.22265625,672.3741455078125,0,240.50390625,422.2508850097656,0,0,1,0.5,0.5,0,0,[]],74,1122,[],[],[0,"Default",0,1]],[[618.5,3793,0,55,102,0,0,1,0.5,
0.5,0,0,[]],79,1123,[],[],[0,"Default",0,1]],[[-8730.998046875,-5578.00830078125,0,78.9951171875,64,0,0,1,0.5022830963134766,0.5039370059967041,0,0,[]],101,1124,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-8397,-5467,0,165,728,0,0,1,0.5046728849411011,0.5,0,0,[]],98,1125,[],[],[0,"Default",0,1]],[[-8444,-5747,0,134,44,0,0,1,0.5,0.503496527671814,0,0,[]],99,1126,[],[],[0,"Default",0,1]],[[670,308,0,25,23,0,0,1,0.5,0.5,0,0,[]],76,1127,[],[[0,0,0,0,1]],[1,"Default",0,1]],[[-6460,-5685,0,21,
519,0,-0.4876922369003296,1,2.111111164093018,0.4935400485992432,0,0,[]],209,1130,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-10427,-5561,0,3741,1292,0,0,1,0,0,0,0,[]],148,1138,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[5232,-5943,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1177,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[5384,-6455,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1178,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[5487,
-5998,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1179,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[6175,-6597,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1180,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[6703,-7101,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1181,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[7204,-5705,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1182,[],[[0,2,0,1,0.5,0.2,
0,0.01,0,0]],[0,"Default",0,1]],[[7964,-6360,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1183,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[7223,-7624,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1184,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[7628,-6009,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1185,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[6860,-7318,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,
0,0,[]],160,1186,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[5607,-6145,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1187,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[6780,-6665,0,24,24,0,0,1,0.5126582384109497,0.4966887533664703,0,0,[]],160,1188,[],[[0,2,0,1,0.5,0.2,0,0.01,0,0]],[0,"Default",0,1]],[[5395,-3631,0,2496,28,0,0,1,0.5,0.5,0,0,[]],212,1204,[],[],[1,"Default",0,1]],[[-10186,-5558,0,3498,1208,0,0,1,0,0,0,0,[]],266,1491,[],[],[0,0]],[[-6774,-5392,0,
128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1492,[],[],[0,0]],[[-6730,-5195,0,125,212,0,-0.5804417133331299,1,0,0,0,0,[]],266,1493,[],[],[0,0]],[[-6670.81396484375,-4926.9375,0,125,213,0,-0.5804417133331299,1,0,0,0,0,[]],266,1494,[],[],[0,0]],[[-6716.00048828125,-4718.00048828125,0,128,288,0,-0.5804417133331299,1,0,0,0,0,[]],266,1495,[],[],[0,0]],[[-7183.0791015625,-3367.15673828125,0,980,436,0,-0.5804417133331299,1,0,0,0,0,[]],266,1496,[],[],[0,0]],[[-7561.38037109375,-4196.517578125,0,1061,
704,0,-0.2571038007736206,1,0,0,0,0,[]],266,1497,[],[],[0,0]],[[-6548,-4291,0,128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1498,[],[],[0,0]],[[-6487,-3964,0,128,148,0,-0.5804417133331299,1,0,0,0,0,[]],266,1499,[],[],[0,0]],[[-6247.03125,-3545.77490234375,0,1661,874,0,0.8144810199737549,1,0,0,0,0,[]],266,1500,[],[],[0,0]],[[-5185,-2467,0,509,841,0,0,1,0,0,0,0,[]],266,1501,[],[],[0,0]],[[-5501,-2172,0,306,430,0,0,1,0,0,0,0,[]],266,1502,[],[],[0,0]],[[-4652,-2374,0,509,841,0,-0.6726242303848267,1,
0,0,0,0,[]],266,1503,[],[],[0,0]],[[-4715,-2209,0,369,796,0,0,1,0,0,0,0,[]],266,1504,[],[],[0,0]],[[-4260.00048828125,-2650.99951171875,0,3273,1229,0,-0.7518877983093262,1,0,0,0,0,[]],266,1505,[],[],[0,0]],[[-1189,-5335,0,1524,2908,0,0,1,0,0,0,0,[]],266,1506,[],[],[0,0]],[[-1208.9833984375,-5259.6767578125,0,114,746,0,1.071387887001038,1,0,0,0,0,[]],266,1507,[],[],[0,0]],[[-1733,-4915,0,546,366,0,0,1,0,0,0,0,[]],266,1508,[],[],[0,0]],[[-1504,-5069,0,381,161,0,0,1,0,0,0,0,[]],266,1509,[],[],[0,0]],
[[-1466,-4552,0,124,154,0,0,1,0,0,0,0,[]],266,1510,[],[],[0,0]],[[329,-3544,0,3032,1274,0,0,1,0,0,0,0,[]],266,1511,[],[],[0,0]],[[2979,-3728,0,124,214,0,0,1,0,0,0,0,[]],266,1512,[],[],[0,0]],[[3122,-3751,0,124,214,0,0,1,0,0,0,0,[]],266,1513,[],[],[0,0]],[[3795,-4336,0,124,214,0,0,1,0,0,0,0,[]],266,1514,[],[],[0,0]],[[3548,-4088,0,611,366,0,0,1,0,0,0,0,[]],266,1515,[],[],[0,0]],[[3398,-3958,0,124,214,0,0,1,0,0,0,0,[]],266,1516,[],[],[0,0]],[[3265,-3846,0,124,214,0,0,1,0,0,0,0,[]],266,1517,[],[],[0,
0]],[[4167,-3884,0,124,214,0,0,1,0,0,0,0,[]],266,1518,[],[],[0,0]],[[4260,-3761,0,124,214,0,0,1,0,0,0,0,[]],266,1519,[],[],[0,0]],[[3420,-3724,0,124,214,0,0,1,0,0,0,0,[]],266,1520,[],[],[0,0]],[[3587,-3691,0,699,1289,0,0,1,0,0,0,0,[]],266,1521,[],[],[0,0]],[[3417,-3421,0,124,1066,0,0,1,0,0,0,0,[]],266,1522,[],[],[0,0]],[[7554,-4714,0,5566,1018,0,0,1,0,0,0,0,[]],266,1523,[],[],[0,0]],[[4390,-3626,0,124,214,0,0,1,0,0,0,0,[]],266,1524,[],[],[0,0]],[[4498,-3488,0,124,214,0,0,1,0,0,0,0,[]],266,1525,[],
[],[0,0]],[[4605,-3378,0,124,214,0,0,1,0,0,0,0,[]],266,1526,[],[],[0,0]],[[6218,-3555,0,124,214,0,0,1,0,0,0,0,[]],266,1527,[],[],[0,0]],[[5901,-3284,0,124,214,0,0,1,0,0,0,0,[]],266,1528,[],[],[0,0]],[[5765,-3146,0,124,214,0,0,1,0,0,0,0,[]],266,1529,[],[],[0,0]],[[6047,-3413,0,124,214,0,0,1,0,0,0,0,[]],266,1530,[],[],[0,0]],[[4698,-3261,0,124,214,0,0,1,0,0,0,0,[]],266,1531,[],[],[0,0]],[[4788,-3165,0,124,214,0,0,1,0,0,0,0,[]],266,1532,[],[],[0,0]],[[7487.4619140625,-4617.41552734375,0,1191,1544,0,
0.8698054552078247,1,0,0,0,0,[]],266,1533,[],[],[0,0]],[[697,75,0,242.4135437011719,184.9008636474609,0,0,1,0.5009980201721191,0.5,0,0,[]],19,1168,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[879,82,0,81.50032043457031,51.99996185302734,0,0,1,0.5,0.5033556818962097,0,0,[]],63,1170,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[522,77,0,49,42,0,0,1,0.5,0.5033556818962097,0,0,[]],62,1171,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1277,657,0,290.3739929199219,236.5,0,0.01873116753995419,1,0.4986737370491028,0.5899053812026978,
0,0,[]],4,1172,[[0]],[[0,0,0,0,1]],[0,"Default",0,1]],[[116,637,0,290.3739929199219,236.5,0,-0.01518769562244415,1,0.5013262629508972,0.5015772581100464,0,0,[]],5,1173,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-8614,-5622,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],226,1174,[],[],[0,"Default",0,1]],[[693,362,0,2184,1480,0,0,1,0.5,0.5,0,0,[]],102,1175,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1074,2169.5,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],78,1128,[],[],[0,"Default",0,1]],[[939,1410,0,319,266,0,0,1,0.5,0.5,0,0,[]],73,
1129,[],[],[0,"Default",0,1]]],[]]],[],[]],["Level7",1708,960,!0,"Level7Event",5724766793721479,[["Layer 4",0,0xd6866b87bbdbb,!0,[255,255,255],!0,0,0,1,!1,1,0,0,[[[859,499,0,2048,1163,0,0,1,0.5,0.5011236071586609,0,0,[]],7,1206,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[-2270,-87,0,2062,1293,0,0,1,0.5,0.5011236071586609,0,0,[]],121,1207,[],[[0,0,0,0,1],[1,4,0,0,1]],[0,"Default",0,1]]],[]],["Layer 0",1,0x40a0195150073,!0,[255,255,255],!0,1,1,1,!1,1,0,0,[[[3120,9914,0,81,1041,0,0,1,0.5046728849411011,0.5,
0,0,[]],230,1772,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3259,9926,0,81,1041,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1771,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4075,9603,0,81,369,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1770,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3777.966552734375,9489.0458984375,0,57,395,0,2.208331823348999,1,0.5046728849411011,0.5,0,0,[]],230,1704,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2778,9077,0,
88,384,0,0.03033038973808289,1,0.5046728849411011,0.5,0,0,[]],230,1703,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2774.9345703125,9922.5,0,88,1045,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1688,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2431,10025,0,102,836,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1687,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[510,9472,0,102,836,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1684,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1728,
9792.533203125,0,74,395,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1685,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2268,9370,0,83,382,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1640,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2023,9668,0,69,479,0,0.7142786979675293,1,0.5046728849411011,0.5,0,0,[]],230,1639,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1724,9603,0,86,357,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1638,[],[[1,
0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[513,10177,0,84,407,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1637,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[857,9973,0,83,798,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1636,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[855,9807,0,83,798,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1635,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6521,10112,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,
0,0,[]],139,1551,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6520,9973,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1550,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5703,9953,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1549,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3580,9785,0,80,384,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1548,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2558,9605,0,78,398,
0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1547,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2384,10217,0,65,786,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1546,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2556,9790,0,81,408,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1439,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3088,9962,0,81,398,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1438,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[-7082,10504,0,80,317,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1403,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3581,9947,0,81,400,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1400,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3765,10181,0,81,430,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1402,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3758,10259,0,51.001953125,280.2744140625,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1388,[],[[1,0,0,1,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[-5879.0478515625,10259.9609375,0,51.001953125,280.2744140625,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1369,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5699.841796875,10106.8359375,0,81,398.38818359375,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1370,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-7010,10236,0,80,417,0,0,1,0.5046728849411011,0.5,0,0,[]],98,1211,[],[],[0,"Default",0,1]],[[-6715.9482421875,10341.673828125,0,90.72640991210938,
68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1222,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6730.533203125,10317.7568359375,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1223,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6761.142578125,10272.759765625,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1224,
[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6743.607421875,10294.599609375,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1225,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6769.86376953125,10298.3583984375,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1226,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6788.0087890625,10276.517578125,0,90.72640991210938,
68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1231,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6797.35693359375,10299.03125,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1234,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6824.65869140625,10297.5380859375,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1235,
[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6851.73828125,10297.998046875,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1236,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6839.228515625,10274.2626953125,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1237,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6866.080078125,10274.23046875,0,90.72640991210938,
68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1238,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6879.20068359375,10297.3564453125,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1239,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6893.603515625,10274.904296875,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1240,
[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6906.69384765625,10298.029296875,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1241,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6744.6689453125,10341.8955078125,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1242,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6771.74853515625,10342.35546875,0,90.72640991210938,
68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1243,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6759.23876953125,10318.6201171875,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1244,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6786.09033203125,10318.587890625,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,
1245,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6799.2109375,10341.7138671875,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1246,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6813.61376953125,10319.26171875,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1247,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6826.7041015625,10342.38671875,0,90.72640991210938,
68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1250,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6854.6572265625,10342.474609375,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1252,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6881.73681640625,10342.9345703125,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,
1311,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6839.01953125,10318.9521484375,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1317,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6869.22705078125,10319.19921875,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1312,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6896.07861328125,10319.1669921875,
0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1313,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6909.19921875,10342.29296875,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1314,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6923.60205078125,10319.8408203125,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,
0,0,[]],253,1315,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-6936.6923828125,10342.9658203125,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1316,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[14136.3154296875,661.3118286132812,0,70.6806640625,376.8765258789063,0,0,1,0.5142857432365417,0.5,0,0,[]],80,1319,[],[],[0,"Default",0,1]],[[15001.365234375,462.5004272460938,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,1321,[],[[1,0,0,
1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4068,9957,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1714,[],[],[0,"Default",0,1]],[[3444,9217,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1692,[],[],[0,"Default",0,1]],[[3444,9957,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1673,[],[],[0,"Default",0,1]],[[2955,9217,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1658,[],[],[0,"Default",0,1]],[[2956,9958,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1644,[],[],[0,"Default",0,1]],[[2269,9217,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1619,[],[],[0,"Default",
0,1]],[[2269,9957,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1606,[],[],[0,"Default",0,1]],[[-5699,9959,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1318,[],[],[0,"Default",0,1]],[[-6515,9957,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1213,[],[],[0,"Default",0,1]],[[-3578,9958,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1390,[],[],[0,"Default",0,1]],[[-2554,9960,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1407,[],[],[0,"Default",0,1]],[[693,9220,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1580,[],[],[0,"Default",0,1]],[[1729,9957,0,456,824,0,
0,1,0.5,0.5,0,0,[]],250,1593,[],[],[0,"Default",0,1]],[[1058,9961,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1567,[],[],[0,"Default",0,1]],[[693,9961,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1554,[],[],[0,"Default",0,1]],[[-7857,10010,0,1555,5,0,-0.3187670707702637,1,0.5,0.5,0,0,[]],20,1322,[],[],[1,"Default",0,1]],[[-8684,10280,0,40.04000091552734,39.25490188598633,0,0,1,0.4945054948329926,0.4945054948329926,0,0,[]],44,1323,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-8584,10282,0,40.04000091552734,
39.25490188598633,0,0,1,0.4945054948329926,0.4945054948329926,0,0,[]],45,1324,[],[[],[0,2,0,1,30,0.2,0,0.05,0,1]],[0,"Default",0,1]],[[-8684,10282,0,15.86400032043457,15.2819995880127,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],50,1325,[],[[]],[0,"Default",0,1]],[[-8584,10282,0,15.86417293548584,15.28224849700928,0,0,1,0.5121951103210449,0.4975369572639465,0,0,[]],49,1326,[],[[]],[0,"Default",0,1]],[[-7667,9953,0,53,54,0,0,1,0.5,0.5,0,0,[]],21,1327,[],[[1]],[1,"Default",0,1]],[[-8637.63671875,
10258.5693359375,0,139.9329986572266,71.58155822753906,0,0,1,0.4996415674686432,0.5,0,0,[]],43,1328,[],[[],[0,0,0,0.1,0.5,0.2,0,0.01,0,1],[1]],[0,"Default",0,1]],[[-8655,10223,0,13.80799961090088,38.27399826049805,0,0.3524599075317383,1,0.5,0.5,0,0,[]],56,1329,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-8647,10270,0,80.68636322021484,27.58581161499023,0,-0.02719682641327381,1,0.5012787580490112,0.511904776096344,0,0,[]],46,1330,[],[[0,0,0,1.2,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-8566,
10273,0,33.02397918701172,15.33616733551025,0,-0.1354803889989853,1,0.5,0.5128205418586731,0,0,[]],47,1331,[],[[0,2,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-8611,10279,0,54.239990234375,29.06821441650391,0,-2.640111923217773,1,0.5,0.5128205418586731,0,0,[]],48,1332,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[1,"Default",0,1]],[[-8643.9677734375,10197.908203125,0,23.86599922180176,19.45499992370606,0,0.237887367606163,1,0.5,0.5,0,0,[]],54,1333,[],[[],[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-8654.5341796875,
10244.19140625,0,11.43299961090088,27.75300025939941,0,-0.6223453283309937,1,0.5,0.5,0,0,[]],57,1334,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-8646.8466796875,10262.19140625,0,7.695000171661377,28.19000053405762,0,-0.102828323841095,1,0.5,0.5016077160835266,0,0,[]],58,1335,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-8642.6875,10276.068359375,0,12.75500011444092,8.074000358581543,0,0,1,0.5,0.5,0,0,[]],59,1336,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-8646.1220703125,
10217.9072265625,0,8.534000396728516,24.24699974060059,0,-0.8195666670799255,1,0.5037593841552734,0.5016501545906067,0,0,[]],60,1337,[],[[0,0,0,1,0.5,0.2,0,0,0,1],[]],[0,"Default",0,1]],[[-8630.083984375,10224.80859375,0,25.45100021362305,6.638999938964844,0,0.07037980109453201,1,0.5,0.5,0,0,[]],61,1338,[],[[0,0,0,1,0.5,0.2,0,0,0,1]],[0,"Default",0,1]],[[-8692.0947265625,10249.8154296875,0,109.9668197631836,113.9811706542969,0,-3.083474397659302,1,0,0.5,0,0,[]],66,1339,[],[],[300,60,0,200,10,100,
0,0,0,0,0,0,-150,0,0,800,0,0,1]],[[14231.22265625,672.3741455078125,0,240.50390625,422.2508850097656,0,0,1,0.5,0.5,0,0,[]],74,1340,[],[],[0,"Default",0,1]],[[618.5,3793,0,55,102,0,0,1,0.5,0.5,0,0,[]],79,1341,[],[],[0,"Default",0,1]],[[-9030,9984,0,32,804,0,0,1,0.5,0.5,0,0,[]],0,1320,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[1,"Default",0,1]],[[-8491.611328125,10336.1474609375,0,78.9951171875,64,0,0,1,0.5022830963134766,0.5039370059967041,0,0,[]],101,1342,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,
1]],[[-8143,10345,0,165,728,0,0,1,0.5046728849411011,0.5,0,0,[]],98,1343,[],[],[0,"Default",0,1]],[[-8195,10065,0,134,44,0,0,1,0.5,0.503496527671814,0,0,[]],99,1344,[],[],[0,"Default",0,1]],[[-8285,9333,0,107,542,0,0,1,2.111111164093018,0.4935400485992432,0,0,[]],209,1348,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,0]],[[-7018,10082,0,131.37060546875,87.505859375,0,0,1,0.5,0.5,0,0,[]],248,1210,[],[],[0,"Default",0,1]],[[-6515,9957,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1212,[],[],[0,"Default",0,
1]],[[-6579.0390625,9733.3701171875,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1214,[],[],[0,"Default",0,1]],[[-6418.08837890625,9734.5615234375,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1215,[],[],[0,"Default",0,1]],[[-6576.205078125,9895.85546875,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1216,[],[],[0,"Default",0,1]],[[-6418.087890625,9894.6025390625,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1217,[],[],[0,"Default",0,1]],[[-6574.96826171875,
10058.310546875,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1218,[],[],[0,"Default",0,1]],[[-6419.966796875,10059.58984375,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1219,[],[],[0,"Default",0,1]],[[-6576.8310546875,10214.587890625,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1220,[],[],[0,"Default",0,1]],[[-6421.21923828125,10217.091796875,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1221,[],[],[0,"Default",0,1]],[[-5763,9735,0,129.38037109375,
127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1357,[],[],[0,"Default",0,1]],[[-5602,9736,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1358,[],[],[0,"Default",0,1]],[[-5760,9898,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1359,[],[],[0,"Default",0,1]],[[-5602,9896,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1360,[],[],[0,"Default",0,1]],[[-5759,10060,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1361,[],[],[0,"Default",0,1]],[[-5604,10061,0,129.38037109375,
127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1362,[],[],[0,"Default",0,1]],[[-5761,10216,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1363,[],[],[0,"Default",0,1]],[[-5605,10219,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1364,[],[],[0,"Default",0,1]],[[-5699,9959,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1349,[],[],[0,"Default",0,1]],[[-6173.6806640625,10269.724609375,0,81,327.6146545410156,0,1.037291765213013,1,0.5046728849411011,0.5,0,0,[]],139,1365,[],[[1,0,0,1,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[-6137.8759765625,10459.6884765625,0,80,317,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1544,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-5814,10139,0,107.88330078125,21.7392578125,0,0.1492901742458344,1,0.5,0.5,0,0,[]],254,1367,[],[],[0,"Default",0,1]],[[-6420.61181640625,10316.9765625,0,156,35,0,-0.1886421591043472,1,0.5,0.5,0,0,[]],254,1368,[],[],[0,"Default",0,1]],[[-6014.12744140625,10252.6416015625,0,131.3710021972656,87.50599670410156,0,0.9911899566650391,
1,0.5,0.5,0,0,[]],255,1371,[],[],[0,"Default",0,1]],[[-4128,10119,0,430.7004699707031,181.2029876708984,0,-0.03836527466773987,1,0.5,0.5,0,0,[]],256,1366,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4286,10272,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1372,[],[],[0,"Default",0,1]],[[-4286,10302,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1373,[],[],[0,"Default",0,1]],[[-4288,10317,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1374,[],[],[0,"Default",0,1]],[[-4283,10287,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1375,[],[],[0,
"Default",0,1]],[[-4291,10346,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1376,[],[],[0,"Default",0,1]],[[-4285,10332,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1377,[],[],[0,"Default",0,1]],[[-4283,10256,0,50.62646484375,40.2529296875,0,0,1,0.5,0.5,0,0,[]],257,1378,[],[],[0,"Default",0,1]],[[-4039,10272,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1379,[],[],[0,"Default",0,1]],[[-4039,10302,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1380,[],[],[0,"Default",0,1]],[[-4041,10318,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1381,[],[],[0,"Default",
0,1]],[[-4036,10288,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1382,[],[],[0,"Default",0,1]],[[-4043,10347,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1383,[],[],[0,"Default",0,1]],[[-4038,10333,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1384,[],[],[0,"Default",0,1]],[[-4035,10257,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1385,[],[],[0,"Default",0,1]],[[-4089,10126,0,213,34,0,-0.1886421591043472,1,0.5,0.5,0,0,[]],258,1386,[],[],[0,"Default",0,1]],[[-4553,10222,0,81,553,0,1.037291765213013,1,0.5046728849411011,0.5,0,0,[]],139,1387,[],
[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3579,10106,0,81,398.38818359375,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1389,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3642,9734,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1391,[],[],[0,"Default",0,1]],[[-3481,9735,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1392,[],[],[0,"Default",0,1]],[[-3639,9897,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1393,[],[],[0,"Default",0,
1]],[[-3481,9895,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1394,[],[],[0,"Default",0,1]],[[-3638,10059,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1395,[],[],[0,"Default",0,1]],[[-3483,10060,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1396,[],[],[0,"Default",0,1]],[[-3640,10215,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1397,[],[],[0,"Default",0,1]],[[-3484,10218,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1398,[],[],[0,"Default",
0,1]],[[-3578,9958,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1399,[],[],[0,"Default",0,1]],[[-3558,9981,0,145,24,0,0.05463624373078346,1,0.5,0.5,0,0,[]],260,1401,[],[],[0,"Default",0,1]],[[670,308,0,25,23,0,0,1,0.5,0.5,0,0,[]],76,1345,[],[[0,0,0,0,1]],[1,"Default",0,1]],[[-2557,9949,0,81,400,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1404,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2741,10183,0,81,430,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1405,[],[[1,0,0,1,0.5,0.2,0,0.01,0,
1]],[0,"Default",0,1]],[[-2734,10098.63671875,0,51,605,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1406,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2859,9870,0,81,408,0,1.037291765213013,1,0.5046728849411011,0.5,0,0,[]],139,1434,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2555,10108,0,81,398.38818359375,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1408,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-2618,9736,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,
0,0,[]],251,1409,[],[],[0,"Default",0,1]],[[-2457,9737,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1410,[],[],[0,"Default",0,1]],[[-2615,9899,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1411,[],[],[0,"Default",0,1]],[[-2457,9897,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1412,[],[],[0,"Default",0,1]],[[-2614,10061,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1413,[],[],[0,"Default",0,1]],[[-2459,10062,0,129.38037109375,127.5029296875,0,0,1,0.5,
0.5,0,0,[]],251,1414,[],[],[0,"Default",0,1]],[[-2616,10217,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1415,[],[],[0,"Default",0,1]],[[-2460,10220,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1416,[],[],[0,"Default",0,1]],[[-2554,9960,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1417,[],[],[0,"Default",0,1]],[[-2432,9819,0,145,24,0,0.05463624373078346,1,0.5,0.5,0,0,[]],260,1418,[],[],[0,"Default",0,1]],[[-3087,10311,0,81,400,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],
139,1419,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3271,10545,0,81,430,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1420,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3264,10623,0,51.001953125,280.2744140625,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1421,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3084,10322,0,456,824,0,0,1,0.5,0.5,0,0,[]],250,1422,[],[],[0,"Default",0,1]],[[-3085,10470,0,81,398.38818359375,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1423,
[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-3148,10098,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1424,[],[],[0,"Default",0,1]],[[-2987,10099,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1425,[],[],[0,"Default",0,1]],[[-3145,10261,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1426,[],[],[0,"Default",0,1]],[[-2987,10259,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1427,[],[],[0,"Default",0,1]],[[-3144,10423,0,129.38037109375,127.5029296875,
0,0,1,0.5,0.5,0,0,[]],251,1428,[],[],[0,"Default",0,1]],[[-2989,10424,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1429,[],[],[0,"Default",0,1]],[[-3146,10579,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1430,[],[],[0,"Default",0,1]],[[-2990,10582,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1431,[],[],[0,"Default",0,1]],[[-3084,10322,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1432,[],[],[0,"Default",0,1]],[[-3074,10018,0,145,24,0,0.05463624373078346,1,0.5,0.5,0,
0,[]],260,1433,[],[],[0,"Default",0,1]],[[-1325.125122070313,10336.748046875,0,41,46,0,0,1,0.5121951103210449,0.5,0,0,[]],262,1436,[],[],[0,"Default",0,1]],[[-1152.125122070313,10335.748046875,0,41,46,0,0,1,0.5121951103210449,0.5,0,0,[]],262,1437,[],[],[0,"Default",0,1]],[[-1248.125122070313,10306.748046875,0,352,143,0,-0.007943060249090195,1,0.5,0.503496527671814,0,0,[]],261,1435,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-1619.748046875,10178.2421875,0,80,417,0,0,1,0.5046728849411011,
0.5,0,0,[]],98,1440,[],[],[0,"Default",0,1]],[[-1627.748046875,10024.2421875,0,131.37060546875,87.505859375,0,0,1,0.5,0.5,0,0,[]],248,1441,[],[],[0,"Default",0,1]],[[-1524,10543,0,81,408,0,0,1,0.5046728849411011,0.5,0,0,[]],139,1442,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-566,10311,0,80,417,0,1.171841502189636,1,0.5046728849411011,0.5,0,0,[]],98,1445,[],[],[0,"Default",0,1]],[[-427,10245,0,131.3710021972656,87.50599670410156,0,1.125734210014343,1,0.5,0.5,0,0,[]],255,1444,[],[],[0,
"Default",0,1]],[[-4864.25048828125,10196.388671875,0,80,417,0,0,1,0.5046728849411011,0.5,0,0,[]],98,1443,[],[],[0,"Default",0,1]],[[-4872.25048828125,10042.388671875,0,131.37060546875,87.505859375,0,0,1,0.5,0.5,0,0,[]],248,1446,[],[],[0,"Default",0,1]],[[-282.22998046875,10228.134765625,0,61,592,0,1.065997958183289,1,0.5046728849411011,0.5,0,0,[]],230,1543,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[125,10183,0,475,354,0,0,1,0.5,0.5,0,0,[]],200,1535,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,
"Default",0,1]],[[-50,10318,0,77,76,0,0,1,0.5,0.5,0,0,[]],201,1536,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[271,10317.5,0,77,76,0,0,1,0.5,0.5,0,0,[]],202,1537,[],[[1,2,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5311,10236,0,80,417,0,0,1,0.5046728849411011,0.5,0,0,[]],98,1773,[],[],[0,"Default",0,1]],[[-10011,10354.189453125,0,21762,592,0,0,1,0,0,0,0,[]],247,1208,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,0]],[[-364.5700073242188,10328.7802734375,0,40.615234375,63.74981689453125,0,0,1,0.4933333396911621,
0.5049999952316284,0,0,[]],12,1540,[],[[0,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[-4038,10199,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1447,[],[],[0,"Default",0,1]],[[-4038,10229,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1448,[],[],[0,"Default",0,1]],[[-4040,10245,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1449,[],[],[0,"Default",0,1]],[[-4035,10215,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1450,[],[],[0,"Default",0,1]],[[-4042,10274,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1451,[],[],[0,"Default",0,1]],[[-4037,10260,0,50,39,0,
0,1,0.5,0.5,0,0,[]],257,1452,[],[],[0,"Default",0,1]],[[-4034,10184,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1453,[],[],[0,"Default",0,1]],[[-4282,10196,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1454,[],[],[0,"Default",0,1]],[[-4282,10226,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1455,[],[],[0,"Default",0,1]],[[-4284,10242,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1456,[],[],[0,"Default",0,1]],[[-4279,10212,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1457,[],[],[0,"Default",0,1]],[[-4286,10271,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1458,[],[],
[0,"Default",0,1]],[[-4281,10257,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1459,[],[],[0,"Default",0,1]],[[-4278,10181,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1460,[],[],[0,"Default",0,1]],[[-12470,10374,0,27241,604,0,0,1,0,0,0,0,[]],266,1534,[],[],[0,0]],[[276.2487182617188,10216.310546875,0,77.28746032714844,6.296327114105225,0,0.174037367105484,1,0.5,0.5056179761886597,0,0,[]],205,1538,[],[],[0,"Default",0,1]],[[275.2487182617188,10214.310546875,0,77.28746032714844,6.296327114105225,0,0.1740341186523438,1,0.5,
0.5056179761886597,0,0,[]],206,1539,[],[],[0,"Default",0,1]],[[254.8064575195313,10098.7255859375,0,133.75,10.263671875,0,0,1,0.5,0.5056179761886597,0,0,[]],214,1541,[],[],[0,"Default",0,1]],[[252.2489624023438,10096.8818359375,0,133.75,10.26399993896484,0,0,1,0.5,0.5056179761886597,0,0,[]],215,1542,[],[],[0,"Default",0,1]],[[-4325.29248046875,10323.4619140625,0,131.3710021972656,87.50599670410156,0,-0.7990905046463013,1,0.5,0.5,0,0,[]],255,1545,[],[],[0,"Default",0,1]],[[687,10116,0,80,378,0,1.570796370506287,
1,0.5046728849411011,0.5,0,0,[]],139,1552,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[688,9977,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1553,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[693,9961,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1555,[],[],[0,"Default",0,1]],[[629,9737,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1556,[],[],[0,"Default",0,1]],[[790,9738,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1557,[],[],[0,"Default",
0,1]],[[631,9900,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1558,[],[],[0,"Default",0,1]],[[790,9898,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1559,[],[],[0,"Default",0,1]],[[633,10062,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1560,[],[],[0,"Default",0,1]],[[788,10063,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1561,[],[],[0,"Default",0,1]],[[631,10218,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1562,[],[],[0,"Default",0,
1]],[[786,10221,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1563,[],[],[0,"Default",0,1]],[[787,10321,0,156,35,0,-0.1886421591043472,1,0.5,0.5,0,0,[]],254,1564,[],[],[0,"Default",0,1]],[[1052,10116,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1565,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1053,9977,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1566,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1058,9961,0,456,824,0,0,1,
0.5,0.5,0,0,[]],249,1568,[],[],[0,"Default",0,1]],[[994,9737,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1569,[],[],[0,"Default",0,1]],[[1155,9738,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1570,[],[],[0,"Default",0,1]],[[996,9900,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1571,[],[],[0,"Default",0,1]],[[1155,9898,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1572,[],[],[0,"Default",0,1]],[[998,10062,0,129.38037109375,127.5029296875,0,0,1,0.5,
0.5,0,0,[]],251,1573,[],[],[0,"Default",0,1]],[[1153,10063,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1574,[],[],[0,"Default",0,1]],[[996,10218,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1575,[],[],[0,"Default",0,1]],[[1151,10221,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1576,[],[],[0,"Default",0,1]],[[964,9812,0,156,35,0,0.188472330570221,1,0.5,0.5,0,0,[]],254,1577,[],[],[0,"Default",0,1]],[[687,9375,0,80,378,0,1.570796370506287,1,0.5046728849411011,
0.5,0,0,[]],139,1578,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[688,9236,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1579,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[693,9220,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1581,[],[],[0,"Default",0,1]],[[629,8997,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1582,[],[],[0,"Default",0,1]],[[790,8998,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1583,[],[],[0,"Default",0,1]],[[632,9159,0,129.38037109375,
127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1584,[],[],[0,"Default",0,1]],[[790,9158,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1585,[],[],[0,"Default",0,1]],[[633,9322,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1586,[],[],[0,"Default",0,1]],[[788,9323,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1587,[],[],[0,"Default",0,1]],[[631,9478,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1588,[],[],[0,"Default",0,1]],[[787,9481,0,129.38037109375,127.5029296875,
0,0,1,0.5,0.5,0,0,[]],251,1589,[],[],[0,"Default",0,1]],[[542,9896,0,156,35,0,-1.507695078849793,1,0.5,0.5,0,0,[]],254,1590,[],[],[0,"Default",0,1]],[[1723,10112,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1591,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1724,9973,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1592,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1729,9957,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1594,[],[],[0,"Default",0,1]],[[1665,
9734,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1595,[],[],[0,"Default",0,1]],[[1826,9735,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1596,[],[],[0,"Default",0,1]],[[1668,9896,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1597,[],[],[0,"Default",0,1]],[[1826,9895,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1598,[],[],[0,"Default",0,1]],[[1669,10059,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1599,[],[],[0,"Default",0,1]],[[1824,
10060,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1600,[],[],[0,"Default",0,1]],[[1667,10215,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1601,[],[],[0,"Default",0,1]],[[1823,10218,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1602,[],[],[0,"Default",0,1]],[[1726,9825,0,156,35,0,0.02482424676418304,1,0.5,0.5,0,0,[]],254,1603,[],[],[0,"Default",0,1]],[[2263,10112,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1604,[],[[1,0,0,1,0.5,0.2,0,
0.01,0,1]],[0,"Default",0,1]],[[2264,9973,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1605,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2269,9957,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1607,[],[],[0,"Default",0,1]],[[2205,9733,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1608,[],[],[0,"Default",0,1]],[[2366,9735,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1609,[],[],[0,"Default",0,1]],[[2207,9896,0,129.38037109375,127.5029296875,0,0,1,0.5,
0.5,0,0,[]],251,1610,[],[],[0,"Default",0,1]],[[2366,9895,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1611,[],[],[0,"Default",0,1]],[[2209,10058,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1612,[],[],[0,"Default",0,1]],[[2364,10060,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1613,[],[],[0,"Default",0,1]],[[2207,10215,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1614,[],[],[0,"Default",0,1]],[[2362,10217,0,129.38037109375,127.5029296875,0,0,1,
0.5,0.5,0,0,[]],251,1615,[],[],[0,"Default",0,1]],[[2363,10317,0,156,35,0,-0.1886421591043472,1,0.5,0.5,0,0,[]],254,1616,[],[],[0,"Default",0,1]],[[2263,9372,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1617,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2264,9233,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1618,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2269,9217,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1620,[],[],[0,"Default",0,1]],[[2205,
8994,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1621,[],[],[0,"Default",0,1]],[[2366,8995,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1622,[],[],[0,"Default",0,1]],[[2207,9156,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1623,[],[],[0,"Default",0,1]],[[2366,9155,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1624,[],[],[0,"Default",0,1]],[[2209,9319,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1625,[],[],[0,"Default",0,1]],[[2364,
9320,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1626,[],[],[0,"Default",0,1]],[[2207,9475,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1627,[],[],[0,"Default",0,1]],[[2362,9478,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1628,[],[],[0,"Default",0,1]],[[2363,9577,0,156,35,0,-0.1886421591043472,1,0.5,0.5,0,0,[]],254,1629,[],[],[0,"Default",0,1]],[[1380.5537109375,9884.337890625,0,83,382,0,1.065997958183289,1,0.5046728849411011,0.5,0,0,[]],230,1630,[],[[1,
0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1403.061401367188,10059.8564453125,0,72,388,0,2.125214099884033,1,0.5046728849411011,0.5,0,0,[]],230,1632,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1492.495239257813,10122,0,90,567,0,0,1,0.5046728849411011,0.5,0,0,[]],230,1633,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1383,10257,0,77,377,0,1.065997958183289,1,0.5046728849411011,0.5,0,0,[]],230,1631,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[1287,10207,0,87,359,0,
0,1,0.5046728849411011,0.5,0,0,[]],230,1634,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2955,10111,0,83,382,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1641,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2950,10113,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1642,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2951,9974,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1643,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[2956,9958,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1645,[],[],[0,"Default",0,1]],[[2892,9735,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1646,[],[],[0,"Default",0,1]],[[3053,9736,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1647,[],[],[0,"Default",0,1]],[[2894,9897,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1648,[],[],[0,"Default",0,1]],[[3053,9896,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1649,[],[],[0,"Default",0,1]],[[2896,10060,0,129.38037109375,
127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1650,[],[],[0,"Default",0,1]],[[3051,10061,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1651,[],[],[0,"Default",0,1]],[[2894,10216,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1652,[],[],[0,"Default",0,1]],[[3049,10219,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1653,[],[],[0,"Default",0,1]],[[3050,10318,0,156,35,0,-0.1886421591043472,1,0.5,0.5,0,0,[]],254,1654,[],[],[0,"Default",0,1]],[[2954,9370,0,83,382,0,1.570796370506287,
1,0.5046728849411011,0.5,0,0,[]],230,1655,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2949,9372,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1656,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2950,9233,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1657,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[2955,9217,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1659,[],[],[0,"Default",0,1]],[[2891,8994,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,
0,0,[]],251,1660,[],[],[0,"Default",0,1]],[[3052,8995,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1661,[],[],[0,"Default",0,1]],[[2893,9156,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1662,[],[],[0,"Default",0,1]],[[3052,9155,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1663,[],[],[0,"Default",0,1]],[[2895,9319,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1664,[],[],[0,"Default",0,1]],[[3050,9320,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,
0,0,[]],251,1665,[],[],[0,"Default",0,1]],[[2893,9475,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1666,[],[],[0,"Default",0,1]],[[3048,9478,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1667,[],[],[0,"Default",0,1]],[[2948,9396,0,156,35,0,-0.04010196775197983,1,0.5,0.5,0,0,[]],254,1668,[],[],[0,"Default",0,1]],[[2533,9534,0,56,245,0,0.8471614718437195,1,0.5046728849411011,0.5,0,0,[]],230,1669,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3443,10110,0,83,382,0,
1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1670,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3438,10112,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1671,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3439,9973,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1672,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3444,9957,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1674,[],[],[0,"Default",0,1]],[[3380,9734,0,129.38037109375,127.5029296875,
0,0,1,0.5,0.5,0,0,[]],251,1675,[],[],[0,"Default",0,1]],[[3541,9735,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1676,[],[],[0,"Default",0,1]],[[3382,9896,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1677,[],[],[0,"Default",0,1]],[[3541,9895,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1678,[],[],[0,"Default",0,1]],[[3384,10059,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1679,[],[],[0,"Default",0,1]],[[3539,10060,0,129.38037109375,127.5029296875,
0,0,1,0.5,0.5,0,0,[]],251,1680,[],[],[0,"Default",0,1]],[[3382,10215,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1681,[],[],[0,"Default",0,1]],[[3537,10218,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1682,[],[],[0,"Default",0,1]],[[3437,10136,0,156,35,0,-0.04010196775197983,1,0.5,0.5,0,0,[]],254,1683,[],[],[0,"Default",0,1]],[[2266,9593,0,76,397,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1686,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3443,9370,
0,83,382,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1689,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3438,9372,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1690,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3439,9233,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1691,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[3444,9217,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1693,[],[],[0,"Default",0,1]],[[3380,8994,0,129.38037109375,
127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1694,[],[],[0,"Default",0,1]],[[3541,8995,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1695,[],[],[0,"Default",0,1]],[[3382,9156,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1696,[],[],[0,"Default",0,1]],[[3541,9155,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1697,[],[],[0,"Default",0,1]],[[3384,9319,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1698,[],[],[0,"Default",0,1]],[[3539,9320,0,129.38037109375,
127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1699,[],[],[0,"Default",0,1]],[[3382,9475,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1700,[],[],[0,"Default",0,1]],[[3537,9478,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1701,[],[],[0,"Default",0,1]],[[3437,9396,0,156,35,0,-0.04010196775197983,1,0.5,0.5,0,0,[]],254,1702,[],[],[0,"Default",0,1]],[[4404.548828125,9488.1455078125,0,81,369,0,2.208331823348999,1,0.5046728849411011,0.5,0,0,[]],230,1705,[],[[1,0,0,1,0.5,0.2,0,0.01,
0,1]],[0,"Default",0,1]],[[4067,10110,0,83,382,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],230,1711,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4062,10112,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1712,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4063,9973,0,80,378,0,1.570796370506287,1,0.5046728849411011,0.5,0,0,[]],139,1713,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4068,9957,0,456,824,0,0,1,0.5,0.5,0,0,[]],249,1715,[],[],[0,"Default",
0,1]],[[4004,9734,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1716,[],[],[0,"Default",0,1]],[[4165,9735,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1717,[],[],[0,"Default",0,1]],[[4006,9896,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1718,[],[],[0,"Default",0,1]],[[4165,9895,0,130.6328125,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1719,[],[],[0,"Default",0,1]],[[4008,10059,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1720,[],[],[0,"Default",
0,1]],[[4163,10060,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1721,[],[],[0,"Default",0,1]],[[4006,10215,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1722,[],[],[0,"Default",0,1]],[[4161,10218,0,129.38037109375,127.5029296875,0,0,1,0.5,0.5,0,0,[]],251,1723,[],[],[0,"Default",0,1]],[[4061,10136,0,156,35,0,-0.04010196775197983,1,0.5,0.5,0,0,[]],254,1724,[],[],[0,"Default",0,1]],[[4522,10122,0,430.7004699707031,181.2029876708984,0,-0.03836527466773987,1,0.5,0.5,0,0,[]],
256,1706,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[4364,10275,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1707,[],[],[0,"Default",0,1]],[[4364,10305,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1708,[],[],[0,"Default",0,1]],[[4362,10320,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1709,[],[],[0,"Default",0,1]],[[4367,10290,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1710,[],[],[0,"Default",0,1]],[[4359,10349,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1725,[],[],[0,"Default",0,1]],[[4365,10335,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1726,[],
[],[0,"Default",0,1]],[[4367,10259,0,50.62646484375,40.2529296875,0,0,1,0.5,0.5,0,0,[]],257,1727,[],[],[0,"Default",0,1]],[[4611,10275,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1728,[],[],[0,"Default",0,1]],[[4611,10305,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1729,[],[],[0,"Default",0,1]],[[4609,10321,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1730,[],[],[0,"Default",0,1]],[[4614,10291,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1731,[],[],[0,"Default",0,1]],[[4607,10350,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1732,[],[],[0,"Default",
0,1]],[[4612,10336,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1733,[],[],[0,"Default",0,1]],[[4615,10260,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1734,[],[],[0,"Default",0,1]],[[4561,10129,0,213,34,0,-0.1886421591043472,1,0.5,0.5,0,0,[]],258,1735,[],[],[0,"Default",0,1]],[[4612,10202,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1736,[],[],[0,"Default",0,1]],[[4612,10232,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1737,[],[],[0,"Default",0,1]],[[4610,10248,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1738,[],[],[0,"Default",0,1]],[[4615,10218,0,
50,39,0,0,1,0.5,0.5,0,0,[]],257,1739,[],[],[0,"Default",0,1]],[[4608,10277,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1740,[],[],[0,"Default",0,1]],[[4613,10263,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1741,[],[],[0,"Default",0,1]],[[4616,10187,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1742,[],[],[0,"Default",0,1]],[[4368,10199,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1743,[],[],[0,"Default",0,1]],[[4368,10229,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1744,[],[],[0,"Default",0,1]],[[4366,10245,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1745,[],
[],[0,"Default",0,1]],[[4371,10215,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1746,[],[],[0,"Default",0,1]],[[4364,10274,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1747,[],[],[0,"Default",0,1]],[[4369,10260,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1748,[],[],[0,"Default",0,1]],[[4372,10184,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1749,[],[],[0,"Default",0,1]],[[4903,10346,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1751,[],[],[0,"Default",0,1]],[[4906,10330,0,50.62646484375,40.2529296875,0,0,1,0.5,0.5,0,0,[]],257,1752,[],[],[0,"Default",
0,1]],[[5150,10346,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1753,[],[],[0,"Default",0,1]],[[5154,10331,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1754,[],[],[0,"Default",0,1]],[[5151,10273,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1756,[],[],[0,"Default",0,1]],[[5151,10303,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1757,[],[],[0,"Default",0,1]],[[5149,10319,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1758,[],[],[0,"Default",0,1]],[[5154,10289,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1759,[],[],[0,"Default",0,1]],[[5147,10348,0,50,39,0,0,1,0.5,0.5,
0,0,[]],257,1760,[],[],[0,"Default",0,1]],[[5152,10334,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1761,[],[],[0,"Default",0,1]],[[5155,10258,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1762,[],[],[0,"Default",0,1]],[[4907,10270,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1763,[],[],[0,"Default",0,1]],[[4907,10300,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1764,[],[],[0,"Default",0,1]],[[4905,10316,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1765,[],[],[0,"Default",0,1]],[[4910,10286,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1766,[],[],[0,"Default",0,1]],
[[4903,10345,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1767,[],[],[0,"Default",0,1]],[[4908,10331,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1768,[],[],[0,"Default",0,1]],[[4911,10255,0,50,39,0,0,1,0.5,0.5,0,0,[]],257,1769,[],[],[0,"Default",0,1]],[[5027,10205,0,352,143,0,-0.007943060249090195,1,0.5,0.503496527671814,0,0,[]],261,1750,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5023,10225,0,97,17,0,0.1838205605745316,1,0.5,0.5,0,0,[]],258,1755,[],[],[0,"Default",0,1]],[[5605,10342,0,90.72640991210938,68.89463806152344,
0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1774,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5591,10318,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1775,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5907,10324,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1776,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5922,
10341,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1777,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5896,10344,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1778,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5868,10344,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1779,[],[[1,0,0,1,0.5,
0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5524,10299,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1780,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5841,10344,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1781,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5814,10344,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,
0,0,[]],253,1782,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5826,10321,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1783,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5799,10321,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1784,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5786,10343,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,
1,0.501075267791748,0.5014409422874451,0,0,[]],253,1785,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5772,10322,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1786,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5759,10344,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1787,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5577,10342,0,90.72640991210938,
68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1788,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5550,10342,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1789,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5562,10319,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1790,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[5535,10319,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1791,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5522,10342,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1792,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5508,10319,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1793,[],
[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5495,10342,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1794,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5467,10343,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1795,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5440,10343,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,
0.5014409422874451,0,0,[]],253,1796,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5482,10319,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1797,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5452,10319,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1798,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5425,10319,0,90.72640991210938,68.89463806152344,
0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1799,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5412,10342,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1800,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5398,10320,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1801,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5385,
10343,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1802,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5303,10082,0,131.37060546875,87.505859375,0,0,1,0.5,0.5,0,0,[]],248,1803,[],[],[0,"Default",0,1]],[[6135,10322,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1804,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6149,10345,0,90.72640991210938,68.89463806152344,
0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1805,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6124.1357421875,10341.98046875,0,91,69,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1806,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6096,10342,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1807,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6069,10342,0,90.72640991210938,
68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1808,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6042,10342,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1809,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6054,10319,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1810,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",
0,1]],[[6027,10319,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1811,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6014,10341,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1812,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[6E3,10320,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1813,[],
[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[5987,10342,0,90.72640991210938,68.89463806152344,0,-0.1517999172210693,1,0.501075267791748,0.5014409422874451,0,0,[]],253,1814,[],[[1,0,0,1,0.5,0.2,0,0.01,0,1]],[0,"Default",0,1]],[[697,75,0,242.4135437011719,184.9008636474609,0,0,1,0.5009980201721191,0.5,0,0,[]],19,1350,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[879,82,0,81.50032043457031,51.99996185302734,0,0,1,0.5,0.5033556818962097,0,0,[]],63,1351,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[522,77,0,49,
42,0,0,1,0.5,0.5033556818962097,0,0,[]],62,1352,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1277,657,0,290.3739929199219,236.5,0,0.01873116753995419,1,0.4986737370491028,0.5899053812026978,0,0,[]],4,1353,[[0]],[[0,0,0,0,1]],[0,"Default",0,1]],[[116,637,0,290.3739929199219,236.5,0,-0.01518769562244415,1,0.5013262629508972,0.5015772581100464,0,0,[]],5,1354,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[1074,2169.5,0,2603,1572,0,0,1,0.5,0.5,0,0,[]],78,1346,[],[],[0,"Default",0,1]],[[-8388.462890625,10297.91015625,
0,2603,1572,0,0,1,0.5,0.5,0,0,[]],226,1355,[],[],[0,"Default",0,1]],[[693,362,0,2184,1480,0,0,1,0.5,0.5,0,0,[]],102,1356,[],[[0,0,0,0,1]],[0,"Default",0,1]],[[939,1410,0,319,266,0,0,1,0.5,0.5,0,0,[]],73,1347,[],[],[0,"Default",0,1]],[[-6282,10401,0,62,57,0,-0.3516345024108887,1,0.5,0.5,0,0,[]],269,1815,[],[],[0,"Default",0,1]],[[5276,10404,0,62,57,0,0,1,0.5,0.5,0,0,[]],269,1816,[],[],[0,"Default",0,1]],[[-760,10415,0,76,64,0,0.783185601234436,1,0.5,0.5,0,0,[]],270,1817,[],[],[0,"Default",0,1]],[[-4858,
10404,0,79,78,0,-2.048199653625488,1,0.5,0.5,0,0,[]],271,1818,[],[],[0,"Default",0,1]],[[6340,10401,0,57,46,0,-2.419408559799194,1,0.5,0.5,0,0,[]],272,1819,[],[],[0,"Default",0,1]],[[-1250.62890625,10324.697265625,0,109.2600555419922,16.39807510375977,0,0.05463624373078346,1,0.5,0.5,0,0,[]],260,1820,[],[],[0,"Default",0,1]],[[4525,8992,0,286,1310,0,0.1473676562309265,1,0.5,0.5,0,0,[]],189,4,[],[],[0,"Default",0,1]],[[4395,8797,0,335,1333,0,0,1,0.5,0.5,0,0,[]],188,16,[],[],[0,"Default",0,1]]],[]]],
[],[]],["intro",1708,960,!1,"introevent",0xee7261afc990f,[["Layer 0",0,7989642044912122,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[938,475,0,2250,1812,0,0,1,0.5,0.5,0,0,[]],69,103,[],[],[0,"Default",0,1]],[[910,477,0,2909,1420,0,0,1,0.5005854964256287,0.5010416507720947,0,0,[]],68,99,[],[[1,1,1,1,1]],[0,"Default",0,1]]],[]]],[],[]],["play",1708,960,!1,"playevent",9697634393842948,[["Layer 0",0,533737106629131,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[855,334,0,2642.311279296875,1498.845092773438,0,0,1,0.5003728270530701,
0.5006226897239685,0,0,[]],118,174,[],[],[0,"Default",0,1]],[[1105,598,0,894,728,0,0,1,0.5007496476173401,0.5010846257209778,0,0,[]],41,22,[],[],[0,"Default",0,1]],[[269,356,0,301,152,0,0,1,0.5023696422576904,0.5,0,0,[]],120,175,[],[],[0,"Default",0,1]],[[475,889,0,197,174,0,0,1,0.5,0.5,0,0,[]],122,18,[],[],[0,"Default",0,1]],[[200,892,0,376,110,0,0,1,0.5,0.5,0,0,[]],123,23,[],[],[0,"Default",0,1]],[[183,1177,0,264,144,0,0,1,0.5,0.5,0,0,[]],124,24,[],[],[0,"Default",0,1]],[[701,1375,0,535,133,0,0,
1,0.5011337995529175,0.5056179761886597,0,0,[]],165,878,[],[],[0,"Default",0,1]],[[214,1362,0,459,133,0,0,1,0.5013333559036255,0.5056179761886597,0,0,[]],166,883,[],[],[0,"Default",0,1]],[[1580,897,0,395,123,0,0,1,0.5016077160835266,0.5056179761886597,0,0,[]],177,157,[],[],[0,"Default",0,1]],[[1025,2029,0,2223,1140,0,0,1,0.5,0.5,0,0,[]],181,160,[],[],[0,"Default",0,1]],[[1270,1256,0,700,109,0,0,1,0.5,0.5045871734619141,0,0,[]],180,159,[],[],[0,"Default",0,1]],[[494,1222,0,226,109,0,0,1,0.5,0.5045871734619141,
0,0,[]],182,162,[],[],[0,"Default",0,1]],[[716,1226,0,249,109,0,0,1,0.5020080208778381,0.5045871734619141,0,0,[]],183,171,[],[],[0,"Default",0,1]],[[20,781,0,80,30,0,0,1,0,0,0,0,[]],241,1106,[],[],[0,"GJMojoStudio","My tweet text","","",1,1,1,"en"]],[[-326,1191,0,459,133,0,0,1,0.5013333559036255,0.5056179761886597,0,0,[]],274,1821,[],[],[0,"Default",0,1]],[[-328,1283,0,459,133,0,0,1,0.5013333559036255,0.5056179761886597,0,0,[]],275,1822,[],[],[0,"Default",0,1]],[[-332,1375,0,459,133,0,0,1,0.5013333559036255,
0.5056179761886597,0,0,[]],276,1823,[],[],[0,"Default",0,1]],[[-330,1462,0,459,133,0,0,1,0.5013333559036255,0.5056179761886597,0,0,[]],277,1824,[],[],[0,"Default",0,1]],[[-334,1552,0,459,133,0,0,1,0.5013333559036255,0.5056179761886597,0,0,[]],278,1825,[],[],[0,"Default",0,1]],[[-332,1624,0,459,133,0,0,1,0.5013333559036255,0.5056179761886597,0,0,[]],278,1826,[],[],[0,"Default",0,1]],[[-326,1691,0,459,133,0,0,1,0.5013333559036255,0.5056179761886597,0,0,[]],279,1827,[],[],[0,"Default",0,1]],[[-324,1758,
0,459,133,0,0,1,0.5013333559036255,0.5056179761886597,0,0,[]],280,1828,[],[],[0,"Default",0,1]],[[629,890,0,133,117,0,0,1,0.5004686117172241,0.5004686117172241,0,0,[]],281,1829,[],[],[0,"Default",0,1]]],[]]],[],[]],["credits",1708,960,!1,"creditevents",0xebc8c953461d8,[["Layer 0",0,5060230816381871,!0,[255,255,255],!1,1,1,1,!1,1,0,0,[[[561,568,0,834,48,0,0,1,0,0,0,0,[]],168,1,[],[],["http://www.playonloop.com/2014-music-loops/cyborg-wars/",0,"22pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[813,264,0,252,90,
0,0,1,0,0,0,0,[]],169,2,[],[],["CREDITS",0,"bold 36pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[765,468,0,374,74,0,0,1,0,0,0,0,[]],171,14,[],[],["Credit for these guys at:",0,"bold 22pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[923,135,0,325,235,0,0,1,0.5022624731063843,0.5027933120727539,0,0,[]],172,12,[],[],[0,"Default",0,1]],[[827,392,0,348,102,0,0,1,0,0,0,0,[]],173,72,[],[],["Gary Mocock",0,"22pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[843,354,0,262,64,0,0,1,0,0,0,0,[]],174,107,[],[],["Developer",0,"bold 22pt Arial",
"rgb(0,0,0)",0,0,0,0,0]],[[567,608,0,756,142,0,0,1,0,0,0,0,[]],175,109,[],[],["http://www.playonloop.com/2014-music-loops/lovushke/t",0,"22pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[563,648,0,782,50,0,0,1,0,0,0,0,[]],176,156,[],[],["http://www.playonloop.com/2014-music-loops/brave-worm/",0,"22pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[951,865,0,220,212,0,0,1,0.5,0.5,0,0,[]],178,158,[],[[0,1]],[0,"Default",0,1]],[[561,685,0,792,50,0,0,1,0,0,0,0,[]],190,1310,[],[],["http://www.playonloop.com/2013-music-loops/grid-breaking/",
0,"22pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[811,502,0,238,50,0,0,1,0,0,0,0,[]],243,172,[],[],["www.scirra.com",0,"22pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[815,536,0,214,56,0,0,1,0,0,0,0,[]],242,173,[],[],["www.ludei.com",0,"22pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[547,717,0,844,48,0,0,1,0,0,0,0,[]],245,1166,[],[],["http://www.playonloop.com/2011-music-loops/from-the-street/",0,"22pt Arial","rgb(0,0,0)",0,0,0,0,0]],[[579,749,0,766,40,0,0,1,0,0,0,0,[]],246,1205,[],[],["http://www.playonloop.com/2010-music-loops/lurking/",
0,"22pt Arial","rgb(0,0,0)",0,0,0,0,0]]],[]]],[],[]]],[["Level1Event",[[1,"levelsave",0,0,!1,!1,7299454163369433,!1],[1,"greenlight",0,0,!1,!1,635069698482586,!1],[1,"redlight",0,0,!1,!1,4639473122249938,!1],[1,"mph20",0,20,!1,!1,321517126687978,!1],[1,"mph1",0,1,!1,!1,6312522830941072,!1],[1,"mph10",0,10,!1,!1,8943173122324071,!1],[1,"idletouch",0,0,!1,!1,0x8ec7f45eecb93,!1],[1,"revtouch",0,0,!1,!1,931591186210851,!1],[1,"pause",0,0,!1,!1,5937568347615894,!1],[1,"zoom1",0,0,!1,!1,0x3c91a3e076a9c,
!1],[1,"mph50",0,50,!1,!1,8361485737378836,!1],[1,"mph600",0,600,!1,!1,0x55c889271877a,!1],[1,"mph550",0,550,!1,!1,7894233549880323,!1],[1,"mph500",0,500,!1,!1,6011341974936121,!1],[1,"mph450",0,450,!1,!1,9285861215888460,!1],[1,"mph400",0,400,!1,!1,4912720649270309,!1],[1,"mph350",0,350,!1,!1,6751607782194777,!1],[1,"mph300",0,300,!1,!1,5914336809157625,!1],[1,"mph250",0,250,!1,!1,8176748550864551,!1],[1,"mph200",0,200,!1,!1,9889691688315476,!1],[1,"mph150",0,150,!1,!1,8436187297114327,!1],[1,"mph100",
0,100,!1,!1,838282858273267,!1],[0,null,!1,null,9947321051410368,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7874358026051894,!1]],[[46,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",7259253295456459,!1,[[7,[2,"CarBody2"]],[4,43],[0,[1,0.8]],[0,[0,0]]]],[44,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",8121765791560088,!1,[[7,[2,"Wheel2"]],[4,46]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xaed512e0edf71,
!1,[[7,[2,"Wheel3"]],[4,47]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",6745430327764739,!1,[[7,[2,"Wheel4"]],[4,48]]],[47,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x99a490a379a15,!1,[[7,[2,"CarBody3"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[48,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",8831090488983087,!1,[[7,[2,"CarBody4"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[43,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",
7653660345520602,!1,[[0,[0,5]]]],[54,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x4ef8502ff1fd7,!1,[[7,[0,1]],[4,56],[0,[1,0.5]],[0,[1,0.5]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6601657918463818,!1,[[7,[0,2]],[4,57],[0,[0,2]],[0,[0,0]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x429d5190a3cc8,!1,[[7,[0,1]],[4,57],[0,[0,-2]],[0,[0,1]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",4508805872647377,!1,[[7,[0,2]],[4,59],[0,[0,-2]],[0,[0,0]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xbe6f04f4b0c98,!1,[[7,[0,3]],[4,60],[0,[0,2]],[0,[0,0]]]],[60,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x840a46b7ade6a,!1,[[7,[0,2]],[4,61],[0,[0,1]],[0,[0,-1]]]],[61,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",8216094020840732,!1,[[7,[0,2]],[4,43]]],[59,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",0x44d1a46d687cf,!1,[[7,[0,1]],[4,43]]],[56,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",8147520727790705,!1,[[7,[0,4]],[4,43]]],[57,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",6926875239191737,!1,[[7,[0,10]],[4,43]]],[45,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xa90a1891e44f2,!1,[[4,43],[3,0]]],[44,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x736e5cd0d4c35,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",9003015123088245,!1,[[4,43],[3,0]]],[58,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7539941027254966,!1,[[4,43],[3,0]]],[59,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",520091370836604,!1,[[4,43],[3,0]]],[60,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",6785926020901286,!1,[[4,43],[3,0]]],[57,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",6094713315871606,!1,[[4,43],[3,0]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,673843321880551,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,6882034682718987,!1,[[0,[1,1]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",9220496991162592,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,5690094593646086,!1,[[4,43],[7,[0,8]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6218577378423408,!1,[[11,"redlight"],[7,[0,0]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0x46637c5a4b6a5,!1,[[3,1]]],[43,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",4523249864361713,!1,[[4,46],[3,0]]],[43,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",432692050038425,!1,[[4,47],[3,0]]],[43,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x7537c29fc0550,!1,[[4,48],[3,0]]]]],[0,null,!1,null,0x89758cbea10ae,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xbeebe3585fef2,!1]],[[33,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",862934008224151,!1,[[7,[0,1]],[4,25]]],[34,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",5862759879607399,!1,[[7,[0,1]],[4,33],[0,[0,0]],[0,[0,0]]]],[32,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xb3691aadeda53,!1,[[7,[0,1]],[4,34],[0,[0,0]],[0,[0,0]]]],[31,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",7963892456971047,!1,[[7,[0,1]],[4,32],[0,[0,0]],[0,[0,0]]]],[30,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",5859486470539683,!1,[[7,[0,1]],[4,31],[0,[0,0]],[0,[0,0]]]],[29,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",9603363281952998,!1,[[7,[0,1]],[4,30],[0,[0,0]],[0,[0,0]]]],[28,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6272549291904802,!1,[[7,[0,1]],[4,29],[0,[0,0]],[0,[0,0]]]],[26,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x5240aca549309,!1,[[7,[0,1]],[4,28],[0,[0,0]],[0,[0,0]]]],[27,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9008091781931998,!1,[[7,[0,1]],[4,26],[0,[0,0]],[0,[0,0]]]],[35,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0xfd5f3adf49e5a,!1,[[7,[0,1]],[4,27],[0,[0,0]],[0,[0,0]]]],[36,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x6cbbab5873ff3,!1,[[7,[0,1]],[4,35],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6483744603444055,!1,[[7,[0,1]],[4,36],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x71a86d5cdc220,!1,[[7,[0,2]],[4,38]]]]],[0,null,!1,null,7822485066780978,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,593947129381085,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,5004905225612512,!1,[[0,[0,0]]]],[84,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x91bd3abfb80f9,!1,[[7,[2,"CarBody2"]],[4,81],[0,[0,1]],[0,[0,0]]]],[88,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x5b28d334fc785,!1,[[7,[2,"Wheel2"]],[4,84]]],[85,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",6667772984576801,!1,[[7,[2,"Wheel3"]],[4,82]]],[85,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",8010626136686995,!1,[[7,[2,"wheel4"]],[4,83]]],[82,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xb7bc56fb1648d,!1,[[7,[2,"CarBody3"]],[4,81]]],[83,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",5646123933077175,!1,[[7,[2,"CarBody4"]],[4,81],[0,[0,2]],[0,[0,-2]]]],[81,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",6441215333349926,!1,[[0,[0,5]]]],[95,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x6a1b2eb035333,
!1,[[7,[0,1]],[4,92],[0,[1,0.5]],[0,[1,0.5]]]],[92,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xbdc22fb1a45e5,!1,[[7,[0,2]],[4,91],[0,[0,2]],[0,[0,0]]]],[90,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x803b7f9246d00,!1,[[7,[0,1]],[4,91],[0,[0,4]],[0,[0,2]]]],[90,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",4605347713066996,!1,[[7,[0,2]],[4,89],[0,[0,-2]],[0,[0,2]]]],[92,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",421413515144249,!1,[[7,[0,3]],[4,93],[0,[0,2]],[0,[0,-2]]]],[93,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9380772922330376,!1,[[7,[0,2]],[4,94],[0,[0,1]],[0,[0,-1]]]],[85,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xfc13c0881cd7b,!1,[[4,286],[3,0]]],[88,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",9400409381657226,!1,[[4,286],[3,0]]],[94,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",6597145773913621,!1,
[[4,81],[3,0]]],[90,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x8548bff46768b,!1,[[4,81],[3,0]]],[89,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",5470193182893329,!1,[[4,81],[3,0]]],[93,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",5336861048795876,!1,[[4,81],[3,0]]],[91,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x7b2f20445b4ff,!1,[[4,81],[3,0]]],[94,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",7569040616335096,
!1,[[7,[0,2]],[4,81]]],[89,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",6885996367506855,!1,[[7,[0,1]],[4,81]]],[92,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xcb6a2ae884969,!1,[[7,[0,4]],[4,81]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,0x78fc3f1e7a6c6,!1,[[0,[1,1.3]]]],[70,cr.plugins_.Audio.prototype.acts.Preload,null,9375028572273028,!1,[[2,["motorbikerev_001",!1]]]]]],[0,null,!1,null,0x541c4dfecab38,[[-1,cr.system_object.prototype.cnds.EveryTick,
null,0,!1,!1,!1,9308278229939224,!1]],[[49,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,8961218001037253,!1,[[4,45],[7,[0,1]]]],[50,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,7424491188740906,!1,[[4,44],[7,[0,1]]]],[21,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6200144608385109,!1,[[4,20],[7,[0,2]]]],[20,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xac1706055b849,!1,[[4,43],[7,[0,4]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",884949885450926,
!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,8941067732433877,!1,[[4,43],[7,[0,8]]]],[86,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xd2850c6a42257,!1,[[4,85],[7,[0,1]]]],[87,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xa48a5c6a8fc9e,!1,[[4,88],[7,[0,1]]]],[96,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,325451785549931,!1,[[4,81],[7,[0,8]]]],[49,cr.behaviors.Pin.prototype.acts.Pin,"Pin",9568353931384700,!1,[[4,43],[3,0]]],[50,cr.behaviors.Pin.prototype.acts.Pin,
"Pin",9654586295893418,!1,[[4,46],[3,0]]]]],[0,null,!1,null,7930349870287229,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0x99c22e9585b4d,!1,[[4,4]]]],[[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",8893206968125916,!1,[[0,[23,"mph300"]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",8542226690714873,!1,[[0,[0,7]],[0,[0,90]],[7,[0,1]]]],[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",0xeea492db27296,!1,[[0,[23,"mph50"]]]],
[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,0x829a2d9aafd85,!1,[[4,43],[7,[0,8]]]],[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,7564750687289673,!1,[[3,1]]]],[[0,null,!1,null,8565356699766185,[[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,9122986910790992,!1]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,9472909678081724,!1,[[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.PlayByName,null,9319546774858256,!1,[[3,0],[1,[2,"Motorbikerev_001"]],[3,
0],[0,[0,0]],[1,[2,""]]]]],[[0,null,!1,null,0x92f6098ae082a,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,null,1,!1,!1,!1,0x3d840f0b9c94e,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,6424424982446463,!1,[[1,[2,""]]]]],[[0,null,!1,null,9652090557000140,[[6,cr.plugins_.Touch.prototype.cnds.HasNthTouch,null,0,!1,!1,!1,8027575292073806,!1,[[0,[0,1]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,5492302493780641,!1,[[1,[2,""]]]]]]]],[0,null,!1,null,5393125685293356,[[6,
cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,null,1,!1,!1,!1,0xb51334735f7e1,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,4761006783789943,!1,[[1,[2,""]]]]]]]]]],[0,null,!1,null,5740639857567556,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,8149711786215298,!1,[[4,5]]]],[[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",5676918624531737,!1,[[0,[3,[23,"mph200"]]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",8604955579703455,
!1,[[0,[0,7]],[0,[0,90]],[7,[0,2]]]],[70,cr.plugins_.Audio.prototype.acts.Stop,null,6167287711048659,!1,[[1,[2,""]]]],[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",5900388981756418,!1,[[0,[3,[23,"mph350"]]]]]]],[0,null,!1,null,7190355742972824,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6042635394512082,!1,[[4,53]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",7236267656078666,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",
6448657986857606,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x848a7777298a7,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,997646751986614,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x7ceeb3624301f,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xfbd85a2a83cd7,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",9516273073947600,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x815e9b461758c,
!1]]],[0,null,!1,null,7952582627282749,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8886969913367493,!1,[[4,282]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",610284337124562,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9123858550364528,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xdd00f06e2714c,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7406873406885676,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,7676235978685378,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xb1469ab2b96d4,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x8d8e0f152d847,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,9060140463341466,!1]]],[0,null,!1,null,4631178453307645,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,876941493668484,!1,[[4,14]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9555327974883994,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",5975675425277246,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x3cc2b6eca0dcb,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,4811461417844923,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x80882c22c7f25,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x7d3c4e3eb17f3,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x67ff3cdfc155f,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,4897580932204194,
!1]]],[0,null,!1,null,5493586203462674,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4902681973044611,!1,[[4,18]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6062390469980799,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6599062537569934,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x833868fa5071b,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7348701952587781,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,0x72b3e260475d8,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,7547670997013363,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0xbdd947f8295ed,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,6735678767824717,!1]]],[0,null,!1,null,0x3e2d3926576e5,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8713943684939599,!1,[[4,116]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xeb072fd54b1b,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",775669319019443,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,8871245495671701,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7786805690954723,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,5822374525155959,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,422973109000485,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",513308158868205,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,4828592636463666,
!1]]],[0,null,!1,null,0xd2537e6a21906,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,703413135335619,!1,[[4,24]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",7879282873838453,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",4570739913851172,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xa1e3c26ae81af,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8184605344513449,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,6061602117877708,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,9067788542859156,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0xf3fe4d052a936,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x46db837526841,!1]]],[0,null,!1,null,7693041694239646,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9562709123906056,!1,[[4,25]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xa911f77ce265,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",8800080556748657,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7166053005330948,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,4583039893065028,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,521175716906075,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,8006228335849452,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",5807353465485395,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,
0xfe56075f6a0b9,!1]]],[0,null,!1,null,5650422327717695,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5549702322697834,!1,[[4,38]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8941468879950883,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8180412209850402,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x8d65dd06e7d6c,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x5c2ebb93081fd,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,0x9087b98668337,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xf319e052b425f,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",8517269939726866,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,5745325629316647,!1]]],[0,null,!1,null,6781579201721746,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8906562029447133,!1,[[4,39]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",294943678631724,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",9523238519993024,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,4777646170800072,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6717939402452818,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x3b12699fe1778,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x7b91da4c1b764,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",8358846651558417,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,
7116976417435622,!1]]],[0,null,!1,null,9438504829319140,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8772691644668145,!1,[[4,3]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6750475780955839,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xfb09f33c40cdd,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,5380621736946709,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x7b7772343e634,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,
null,9135517008618452,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,6334656133801694,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",9594133498484112,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,6056235257295012,!1]]],[0,null,!1,null,930019020802702,[[284,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xad1f0105f909b,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0xbe7d75314ab41,!1,[[0,[0,2]]]],[12,cr.plugins_.Sprite.prototype.acts.Destroy,
null,8020711764146019,!1]]],[0,null,!1,null,0x3b635acbe4307,[[13,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9304526268355426,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0x3ec395715bd33,!1,[[0,[0,2]]]],[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,8570886137513108,!1]]],[0,null,!1,null,0x662b9a933b82b,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7101041556192969,!1,[[4,284]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0xdb141737e7901,
!1,[[0,[0,2]]]],[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,7126851180469144,!1]]],[0,null,!1,null,6493541609477537,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6787983136967639,!1,[[4,19]]]],[[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x949905ab9463f,!1,[[4,79],[7,[0,1]]]],[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x83389953b19d0,!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xd7b4bff02496a,!1],[70,cr.plugins_.Audio.prototype.acts.StopAll,
null,9442424163731468,!1]]],[0,null,!1,null,7429387324560665,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xe4a46a953296,!1,[[4,62]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,8857899874866126,!1,[[4,76],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xbdcb1e3feabc4,!1,[[4,76],[7,[0,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0x75b78851f4b7f,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8666394835586681,
!1,[[0,[0,0]]]]]],[0,null,!1,null,9520631271558308,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9786743049073712,!1,[[4,63]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9280916295621646,!1,[[4,79],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5216109018835086,!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,901474782884614,!1,[[0,[1,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,636104669565503,!1,
[[3,1]]]]],[0,null,!1,null,5561642583127746,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x7ebff084d8de0,!1,[[4,74]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,7425633560488938,!1,[[6,"Level1part2"]]],[126,cr.plugins_.Clay.prototype.acts.level_success,null,0x3a4cdcb521514,!1,[[1,[2,"ForestConstruction"]]]],[126,cr.plugins_.Clay.prototype.acts.facebook_post,null,0x7a78881ca44c9,!1,[[1,[2,"I Passed This Level On MX Adventure, Can You?"]],[1,[2,""]],[1,[2,"https://www.dropbox.com/s/82ul3rk0t1r509a/posttofacebookpic.png"]],
[3,0]]],[126,cr.plugins_.Clay.prototype.acts.achievements_award,null,0x3ce94408be3c2,!1,[[7,[0,4251]],[3,0]]]]],[0,null,!1,null,0xb57e9054160c4,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6487482643166046,!1,[[4,73]]]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,7016189865249657,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,6652216329944234,!1,[[6,"play"]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0xbb2065ea50615,!1,[[3,1]]]]],[0,null,!1,null,0xc4a02c02449c0,
[[95,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,386311805351745,!1,[[4,53]]]],[[286,cr.behaviors.Flash.prototype.acts.Flash,"Flash",0xc8609ede8f097,!1,[[0,[1,0.2]],[0,[1,0.1]],[0,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,null,8242667870938277,!1,[[0,[1,1]]]],[286,cr.plugins_.Sprite.prototype.acts.Destroy,null,889623517322406,!1],[96,cr.plugins_.Particles.prototype.acts.Destroy,null,947506230827064,!1]]],[0,null,!1,null,5766836295084632,[[95,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0xcf58ffbf246aa,!1,[[4,3]]]],[[286,cr.behaviors.Flash.prototype.acts.Flash,"Flash",759239614789394,!1,[[0,[1,0.2]],[0,[1,0.1]],[0,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,null,5528101555295663,!1,[[0,[1,1]]]],[286,cr.plugins_.Sprite.prototype.acts.Destroy,null,425312708539826,!1],[96,cr.plugins_.Particles.prototype.acts.Destroy,null,7834847849464806,!1]]],[0,null,!1,null,9292004396025062,[[81,cr.plugins_.Sprite.prototype.cnds.IsBetweenAngles,null,0,!1,!1,!1,7144895061644404,
!1,[[0,[0,10]],[0,[0,90]]]]],[[81,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",0x6c3ea3d39ea2,!1,[[0,[0,5]],[0,[0,100]],[7,[0,1]]]]]],[0,null,!1,null,0x860a1a99ba51f,[[81,cr.plugins_.Sprite.prototype.cnds.IsBetweenAngles,null,0,!1,!1,!1,784589621968346,!1,[[0,[0,240]],[0,[0,350]]]]],[[81,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",8611492359890635,!1,[[0,[0,5]],[0,[0,100]],[7,[0,2]]]]]],[0,null,!1,null,7916715350158007,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,0x6321eb28995cc,!1]],[[-1,cr.system_object.prototype.acts.SaveState,null,9015027777679444,!1,[[1,[2,"mysave"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8936340505328001,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,523898628326992,!1,[[11,"greenlight"],[7,[0,0]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xb6e416986ce0f,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xef683a0bc7818,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,0xf11a6b6637f0d,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,5538554126977723,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x4257f95fa4178,!1,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xc4409da247053,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6086930091109209,!1,[[0,[0,3]]]],[-1,cr.system_object.prototype.acts.Wait,null,5567211028038912,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,8112889020750353,!1,[[0,[0,4]]]],[-1,cr.system_object.prototype.acts.Wait,null,8944625709110309,!1,[[0,[1,0.7]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5785331139771837,!1,[[11,"greenlight"],[7,[0,1]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9445016692753752,!1,[[0,[0,5]]]],[70,cr.plugins_.Audio.prototype.acts.Play,null,6310258433891879,!1,[[2,["pol-afterburner-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,7186706276445975,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,0x47b862a110850,!1,[[11,"greenlight"],[8,0],[7,[0,1]]]]],[[88,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",6953480264978242,!1,[[0,[23,"mph300"]]]],[85,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",8190478064323062,!1,[[0,[23,"mph50"]]]]]],[0,null,!1,null,5465444143358839,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7003719330801178,!1,[[11,"greenlight"],[8,0],[7,[0,1]]]]],[[101,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x78c21a648a4ac,
!1,[[0,[0,1]]]]]],[0,null,!1,null,8514062338036611,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8322608991463972,!1,[[4,102]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,5570734819143043,!1,[[0,[1,1]]]],[70,cr.plugins_.Audio.prototype.acts.Play,null,5888462680114256,!1,[[2,["pol-afterburner-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.Play,null,8768163810873734,!1,[[2,["motorbikerev_001",!1]],[3,0],[0,[0,-100]],[1,[2,""]]]],[102,
cr.plugins_.Sprite.prototype.acts.Destroy,null,0x6567320cd738d,!1],[226,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x6da58969c77f3,!1]]],[0,null,!1,null,6899969969592113,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!0,!1,5290436039258851,!1,[[4,4]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,5770184508051734,!1,[[1,[2,""]]]]]],[0,null,!1,null,8926063170658413,[[102,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,7108400171754619,!1]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,
null,5828597160983227,!1]]],[0,null,!1,null,5633856043123476,[[126,cr.plugins_.Clay.prototype.cnds.cdns_facebook_post,null,1,!1,!1,!1,6542509207284873,!1]],[[51,cr.plugins_.Facebook.prototype.acts.PromptWallPost,null,0xd8e63959f1910,!1]]],[0,null,!1,null,0x6a378f6782bcd,[[-1,cr.system_object.prototype.cnds.OnLoadComplete,null,1,!1,!1,!1,0xe37cf1242cf37,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,0x9cfa60157244c,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,786117724776523,
!1],[70,cr.plugins_.Audio.prototype.acts.Play,null,0xb17c02d470701,!1,[[2,["pol-afterburner-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,4664921056038945,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,7365880046021357,!1]],[[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,5786064483602399,!1,[[3,0]]]]],[0,null,!1,null,0xfa189b13ffb21,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9941995014135676,!1]],[[23,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,
null,0x43d8c744b0caa,!1],[23,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,0xc095221702e2,!1,[[3,1]]]]]]],["introevent",[[0,null,!1,null,322000376802863,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xb286482f4cd88,!1]],[[68,cr.behaviors.Fade.prototype.acts.StartFade,"Fade",5292580825742293,!1]]],[0,null,!1,null,0xfdb7bdc7acfbb,[[68,cr.behaviors.Fade.prototype.cnds.OnFadeOutEnd,"Fade",1,!1,!1,!1,550805884864387,!1]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8898761803966829,
!1,[[6,"play"]]]]],[0,null,!1,null,0xddc53d4eb456a,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5299898925936968,!1]],[[23,cr.plugins_.CJSAds.prototype.acts.PreloadFullscreen,null,6674128383625927,!1],[23,cr.plugins_.CJSAds.prototype.acts.PreloadBanner,null,7743461029624464,!1]]]]],["Level3Event",[[1,"greenlight4",0,0,!1,!1,4947925621931538,!1],[1,"redlight4",0,0,!1,!1,6226273728537705,!1],[1,"mph23",0,20,!1,!1,7073933613953373,!1],[1,"mph4",0,1,!1,!1,0x7db840134086d,!1],[1,
"mph13",0,10,!1,!1,5306315162227907,!1],[1,"idletouch4",0,0,!1,!1,7102984351071731,!1],[1,"revtouch4",0,0,!1,!1,4573525742966184,!1],[1,"pause4",0,0,!1,!1,7841372323515771,!1],[1,"zoom4",0,0,!1,!1,0x9359118d74cd8,!1],[1,"mph53",0,50,!1,!1,8988032449817654,!1],[1,"mph603",0,600,!1,!1,0xfea70524f6b99,!1],[1,"mph553",0,550,!1,!1,0x6367f73adbf11,!1],[1,"mph503",0,500,!1,!1,6249391729350267,!1],[1,"mph453",0,450,!1,!1,0x51d9a6f89fd72,!1],[1,"mph403",0,400,!1,!1,9623208256262262,!1],[1,"mph353",0,350,!1,
!1,0x6bae1ed52cd50,!1],[1,"mph303",0,300,!1,!1,7332898454516803,!1],[1,"mph253",0,250,!1,!1,6623418013378192,!1],[1,"mph203",0,200,!1,!1,0x462cf5afa25e9,!1],[1,"mph153",0,150,!1,!1,9002732058291365,!1],[1,"mph103",0,100,!1,!1,6234658107689261,!1],[0,null,!1,null,0xd0a15abbe34de,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,735679539426986,!1]],[[46,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",7616135155862202,!1,[[7,[2,"CarBody2"]],[4,43],[0,[1,0.8]],
[0,[0,0]]]],[44,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",6563316272869496,!1,[[7,[2,"Wheel2"]],[4,46]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x8829ec86f624c,!1,[[7,[2,"Wheel3"]],[4,47]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",8962875365921699,!1,[[7,[2,"Wheel4"]],[4,48]]],[47,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9303053734188324,!1,[[7,[2,"CarBody3"]],[4,43],[0,[0,2]],[0,[0,
-2]]]],[48,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x6664a73b1912d,!1,[[7,[2,"CarBody4"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[43,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",0xc60d62f160b83,!1,[[0,[0,5]]]],[54,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",7336172619971963,!1,[[7,[0,1]],[4,56],[0,[1,0.5]],[0,[1,0.5]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9951033327116484,!1,[[7,[0,2]],[4,
57],[0,[0,2]],[0,[0,0]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",8082970356553681,!1,[[7,[0,1]],[4,57],[0,[0,-2]],[0,[0,1]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9223100253746094,!1,[[7,[0,2]],[4,59],[0,[0,-2]],[0,[0,0]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xc3571d57c75c2,!1,[[7,[0,3]],[4,60],[0,[0,2]],[0,[0,0]]]],[60,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0x8be3f9fc5f8b2,!1,[[7,[0,2]],[4,61],[0,[0,1]],[0,[0,-1]]]],[45,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",6151645843191147,!1,[[4,43],[3,0]]],[44,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x4530143bde1c7,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xac7b29e8fc007,!1,[[4,43],[3,0]]],[58,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x945281b6fee3e,!1,[[4,43],[3,0]]],[59,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",7849406581010814,!1,[[4,43],[3,0]]],[60,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",8719490299280739,!1,[[4,43],[3,0]]],[57,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7241483435953741,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x7867d78f9a440,!1,[[7,[0,2]],[4,43]]],[59,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",6127739257705243,!1,[[7,[0,1]],[4,43]]],[56,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",8935550104881253,!1,[[7,[0,4]],[4,43]]],[57,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",8769048926407764,!1,[[7,[0,10]],[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x8d57506aa9191,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,0x96112a746f8c5,!1,[[0,[1,1]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x44af2171877bb,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,0x896a4a749b92b,
!1,[[4,43],[7,[0,9]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x5d147d55a867c,!1,[[11,"redlight"],[7,[0,0]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0xd571cec70e222,!1,[[3,1]]]]],[0,null,!1,null,0x6a180ecede132,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8778140877095408,!1]],[[33,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",7925096081618781,!1,[[7,[0,1]],[4,0]]],[34,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",
0xd6c07285c2dde,!1,[[7,[0,1]],[4,33],[0,[0,0]],[0,[0,0]]]],[32,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xff03933067bb6,!1,[[7,[0,1]],[4,34],[0,[0,0]],[0,[0,0]]]],[31,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xab12da4289729,!1,[[7,[0,1]],[4,32],[0,[0,0]],[0,[0,0]]]],[30,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",8526016396243053,!1,[[7,[0,1]],[4,31],[0,[0,0]],[0,[0,0]]]],[29,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",5068417609227991,!1,[[7,[0,1]],[4,30],[0,[0,0]],[0,[0,0]]]],[28,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xb4504a2c3a210,!1,[[7,[0,1]],[4,29],[0,[0,0]],[0,[0,0]]]],[26,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",450674523158144,!1,[[7,[0,1]],[4,28],[0,[0,0]],[0,[0,0]]]],[27,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xdd68bb5b58a56,!1,[[7,[0,1]],[4,26],[0,[0,0]],[0,[0,0]]]],[35,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",4935145591510149,!1,[[7,[0,1]],[4,27],[0,[0,0]],[0,[0,0]]]],[36,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",8267104791621553,!1,[[7,[0,1]],[4,35],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x6312aa8c41e7f,!1,[[7,[0,1]],[4,36],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xf9aceff4fd521,!1,[[7,[0,1]],[4,149]]]]],[0,null,!1,null,0x5a886d55138e1,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,5715138113707549,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,7590563238875066,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,0xac039954695b3,!1,[[0,[1,1.3]]]],[70,cr.plugins_.Audio.prototype.acts.Preload,null,9097410793965864,!1,[[2,["motorbikerev_001",!1]]]]]],[0,null,!1,null,0x74db85091646c,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,8016468398992656,!1]],[[49,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,8479332052189619,
!1,[[4,45],[7,[0,1]]]],[50,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6142503969878392,!1,[[4,44],[7,[0,1]]]],[21,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xf35c1ea867b40,!1,[[4,20],[7,[0,2]]]],[20,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x538c1ad78875b,!1,[[4,43],[7,[0,4]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",9167374692702708,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,7765734186378385,!1,[[4,43],[7,[0,
8]]]]]],[0,null,!1,null,0xe0212151cc09e,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xe588e1814f47e,!1,[[4,4]]]],[[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",4794726966937231,!1,[[0,[23,"mph300"]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",4858679333362132,!1,[[0,[0,7]],[0,[0,90]],[7,[0,1]]]],[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",0x683656f9831f9,!1,[[0,[23,"mph50"]]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,
null,5635342567639027,!1,[[4,43],[7,[0,9]]]],[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,5915814027428757,!1,[[3,1]]]],[[0,null,!1,null,9264609561811360,[[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,0x980189c8cf9c7,!1]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,9196780762413482,!1,[[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.PlayByName,null,552528029723892,!1,[[3,0],[1,[2,"Motorbikerev_001"]],[3,0],[0,[0,0]],[1,[2,""]]]]],[[0,null,!1,null,0xf9ce0991f0f00,
[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,null,1,!1,!1,!1,0x871cdf46039ba,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,0xbe0e380916c4b,!1,[[1,[2,""]]]]],[[0,null,!1,null,5973444383421678,[[6,cr.plugins_.Touch.prototype.cnds.HasNthTouch,null,0,!1,!1,!1,0xac357af258c00,!1,[[0,[0,1]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,6818817800973078,!1,[[1,[2,""]]]]]]]],[0,null,!1,null,7873089009582719,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,null,1,!1,!1,!1,
0xd689c25eea4ad,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,0x9903f3b563fac,!1,[[1,[2,""]]]]]]]]]],[0,null,!1,null,8147357709419013,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,367724434516965,!1,[[4,5]]]],[[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",6929406563952476,!1,[[0,[3,[23,"mph200"]]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",0x8b18a80e35fd,!1,[[0,[0,7]],[0,[0,90]],[7,[0,2]]]],[70,cr.plugins_.Audio.prototype.acts.Stop,
null,0xaa16383807276,!1,[[1,[2,""]]]],[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",7331767521516785,!1,[[0,[3,[23,"mph350"]]]]]]],[0,null,!1,null,6660883790892129,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x42142d5fe9dc9,!1,[[4,53]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",713109891595738,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xd9226f135ef0b,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x8295e21dbb87f,
!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xf5dc87b41c90e,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xbcd0d3840dbb5,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,9548147002575592,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",6051292334218076,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,5231106922314195,!1]]],[0,null,!1,null,8761290392890674,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,8802095162941493,!1,[[4,282]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xad3a74da2b65b,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xa78a9b2585338,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xce809de763c5,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,4528328366954498,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,9126115707750606,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,5758707606974865,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x410b45d261fcd,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,7816146311547976,!1]]],[0,null,!1,null,847024198368104,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x702cd60cf8556,!1,[[4,14]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xb79a087bd9733,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x9c5a870bcf121,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,
null,0x61c62ae1b7fd5,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5882725184804113,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,8904574607724072,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xf04c98664fe,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",7310170619275729,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,5688011779852334,!1]]],[0,null,!1,null,7662198985062098,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,4584660374322104,!1,[[4,18]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xb27676412a179,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",7146357973747684,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,347207396180815,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5475991948062921,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,495327489506841,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,8842347569978044,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",9167642542395948,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,5197654406361701,!1]]],[0,null,!1,null,8089862294259741,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6030828771464099,!1,[[4,116]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xd00991fd2d750,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x727cf8776c162,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,
null,9989874911556128,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xe6cf62b67c759,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,9214048892010140,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,6635235081765534,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0xc1f55ac5493a0,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,6591859291684738,!1]]],[0,null,!1,null,0xf57182911b0ba,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,5807250082883215,!1,[[4,24]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8435934431224907,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6122278067888929,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,6069048347288748,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5545130044523162,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xebf31f001ffa1,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,339189479206012,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",7804950600779286,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,5846961493070121,!1]]],[0,null,!1,null,4926498680553605,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9403488361860276,!1,[[4,25]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x6a19d7c44dcdd,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xf84085905acdf,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,
null,8457785916405039,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6756888870946557,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,8135781367285803,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,8436719296289633,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",9652473503079204,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,6660127324802516,!1]]],[0,null,!1,null,7312444808167093,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0xe546a64cb947a,!1,[[4,38]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xcd0ba9c5d3f27,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",4737397877281798,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7875926579852583,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,590744137190365,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,597475711165687,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,7717877409265104,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",6881129135617228,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,8782896508088106,!1]]],[0,null,!1,null,0x6638aefeb42d5,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9077358466418418,!1,[[4,39]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",7857947757607213,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8805300642463165,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,
null,528810916577734,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xe1d75ded67ddb,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x928a72fdc6877,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xe18ecc57db4ed,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x85f865164b932,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x7813bb1c6a830,!1]]],[0,null,!1,null,6821307692331637,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,9404396469580368,!1,[[4,3]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5739732876119888,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6346672897071001,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,5371300149597196,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,8266079513745056,!1,[[0,[1,1.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6108512657394432,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,
null,9383185612497652,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,9844084076932016,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",664867354264835,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xcd3ea3b09d352,!1]]],[0,null,!1,null,0x3c32cff08f403,[[284,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,925968927370244,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0x953c7423b71ac,!1,[[0,[0,2]]]],[12,cr.plugins_.Sprite.prototype.acts.Destroy,
null,5909732843579992,!1]]],[0,null,!1,null,5357669863326906,[[13,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4699307124710067,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0x8a33d2c04ac0f,!1,[[0,[0,2]]]],[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xb2d1594202483,!1]]],[0,null,!1,null,0x3dfdc586813ad,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x6f581d77b335f,!1,[[4,19]]]],[[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,7817650576012114,
!1,[[4,79],[7,[0,1]]]],[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6088137889553715,!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,5359950238567807,!1],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xb2be0193b5ab3,!1]]],[0,null,!1,null,0xacebd4c0f4a97,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x76217f92e68f1,!1,[[4,62]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xddbd86bc28466,!1,[[4,76],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,
null,7216411814642745,!1,[[4,76],[7,[0,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,6426642162225526,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5996374652972312,!1,[[0,[0,0]]]]]],[0,null,!1,null,0xca2f5f1ae17fa,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xa8d87fca1f63e,!1,[[4,63]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x8b08ac3506ce9,!1,[[4,79],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6809828678331447,
!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9315610737676716,!1,[[0,[1,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,7539587947047088,!1,[[3,1]]]]],[0,null,!1,null,8107840398569614,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xb06faf041eb0b,!1,[[4,74]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,24764295542917,!1,[[6,"Level4"]]],[126,cr.plugins_.Clay.prototype.acts.level_success,null,0x71074e077ea02,!1,[[1,[2,"Forest Construction Part 2"]]]],
[126,cr.plugins_.Clay.prototype.acts.facebook_post,null,75324370565612,!1,[[1,[2,"I Passed Somerset Cider Farm, Can You?"]],[1,[2,""]],[1,[2,"https://www.dropbox.com/s/82ul3rk0t1r509a/posttofacebookpic.png"]],[3,0]]],[126,cr.plugins_.Clay.prototype.acts.achievements_award,null,0x7a3631a424ba0,!1,[[7,[0,4254]],[3,0]]]]],[0,null,!1,null,5476577936701418,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6959418214686224,!1,[[4,73]]]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,
5912843995038353,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x5be357ee562e7,!1,[[6,"play"]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0x726c7799e5083,!1,[[3,1]]]]],[0,null,!1,null,7394709406651582,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,577593274031379,!1]],[[-1,cr.system_object.prototype.acts.SaveState,null,9476738335091634,!1,[[1,[2,"mysave"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5683822301403172,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,0x7428299e3cc7a,!1,[[11,"greenlight"],[7,[0,0]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8880385660365713,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x81d51c4f82775,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5314108803557031,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,7700434524161165,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xd4388d66e6f07,!1,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,0x9b98e13969d38,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8693535450830686,!1,[[0,[0,3]]]],[-1,cr.system_object.prototype.acts.Wait,null,564969108322053,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x498afd1dfabc3,!1,[[0,[0,4]]]],[-1,cr.system_object.prototype.acts.Wait,null,4854462445718701,!1,[[0,[1,0.7]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x6ef38c3cd902c,!1,[[11,"greenlight"],[7,[0,1]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,0x7844441e1acb1,!1,[[0,[0,5]]]]]],[0,null,!1,null,9742484928188432,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x9d2ddb0094d09,!1,[[11,"greenlight"],[8,0],[7,[0,1]]]]],[[101,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x532f9fc95691f,!1,[[0,[0,1]]]]]],[0,null,!1,null,0x98b5af2548a56,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5197757918349023,!1,[[4,102]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,8707642954997604,!1,[[0,[1,1]]]],
[70,cr.plugins_.Audio.prototype.acts.Play,null,6070522953039217,!1,[[2,["pol-lovushke-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.Play,null,0xc67249b68d7b7,!1,[[2,["motorbikerev_001",!1]],[3,0],[0,[0,-100]],[1,[2,""]]]],[102,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xa8d61e3a35093,!1],[226,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xdebad809d86d3,!1]]],[0,null,!1,null,0xeb1c8eec0f9f,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!0,!1,
0xe17d1c952cc74,!1,[[4,4]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,0xf419a9040bf14,!1,[[1,[2,""]]]]]],[0,null,!1,null,9154120991150372,[[102,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,8452058312966844,!1]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,6436696539054193,!1]]],[0,null,!1,null,0x61c4c7872f36f,[[-1,cr.system_object.prototype.cnds.EffectsSupported,null,0,!1,!1,!1,7113699284586377,!1]],[]],[0,null,!1,null,0x47c3750bdd9e6,[[-1,cr.system_object.prototype.cnds.OnLoadComplete,
null,1,!1,!1,!1,8885914107131836,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,0x9393e1e1abed5,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,9663780123603524,!1],[70,cr.plugins_.Audio.prototype.acts.Play,null,0xdfc698bf3931e,!1,[[2,["pol-lovushke-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,5575013110296473,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,6599687639788931,!1]],[[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,
854121835793799,!1,[[3,0]]]]],[0,null,!1,null,0xd0933582bdb47,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xaaa05fae073a8,!1]],[[23,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,0xce3b9860a3551,!1],[23,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,6133711228801657,!1,[[3,1]]]]],[0,null,!1,null,9681750239334168,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7281880970161623,!1]],[[283,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8976050920950052,
!1,[[0,[0,2]]]]]]]],["Level1part2Event",[[1,"greenlight2",0,0,!1,!1,6308876249294527,!1],[1,"redlight2",0,0,!1,!1,5192497631306021,!1],[1,"mph21",0,20,!1,!1,4779171909174994,!1],[1,"mph2",0,1,!1,!1,0xd8ecb5829e3d2,!1],[1,"mph11",0,10,!1,!1,8102759538611412,!1],[1,"idletouch2",0,0,!1,!1,0x50f6e0c110109,!1],[1,"revtouch2",0,0,!1,!1,0x3dccfe6f4e8f1,!1],[1,"pause2",0,0,!1,!1,0x3af5c0bdcd681,!1],[1,"zoom2",0,0,!1,!1,0xa27cef8c798eb,!1],[1,"mph51",0,50,!1,!1,0xc810acd27f396,!1],[1,"mph601",0,600,!1,!1,
0xaa92ff3c2d76e,!1],[1,"mph551",0,550,!1,!1,5602359731606168,!1],[1,"mph501",0,500,!1,!1,4951815435142361,!1],[1,"mph451",0,450,!1,!1,8528320157572016,!1],[1,"mph401",0,400,!1,!1,0x4f092c841909d,!1],[1,"mph351",0,350,!1,!1,8289648457270798,!1],[1,"mph301",0,300,!1,!1,601405633612343,!1],[1,"mph251",0,250,!1,!1,6890435095916212,!1],[1,"mph201",0,200,!1,!1,6852320904127908,!1],[1,"mph151",0,150,!1,!1,0xba04de1984b83,!1],[1,"mph101",0,100,!1,!1,6976002015658842,!1],[0,null,!1,null,7916802733285501,[[-1,
cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x6f6a82d12d38a,!1]],[[46,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",879456986507609,!1,[[7,[2,"CarBody2"]],[4,43],[0,[1,0.8]],[0,[0,0]]]],[44,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x6cb86354256f9,!1,[[7,[2,"Wheel2"]],[4,46]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",5508879243259815,!1,[[7,[2,"Wheel3"]],[4,47]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",503732596715593,!1,[[7,[2,"Wheel4"]],[4,48]]],[47,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9710106467938912,!1,[[7,[2,"CarBody3"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[48,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x634d27cf097ee,!1,[[7,[2,"CarBody4"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[43,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",6523470372512387,!1,[[0,[0,5]]]],[54,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",7883629483764695,!1,[[7,[0,1]],[4,56],[0,[1,0.5]],[0,[1,0.5]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",8650231052057523,!1,[[7,[0,2]],[4,57],[0,[0,2]],[0,[0,0]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",5093280479615794,!1,[[7,[0,1]],[4,57],[0,[0,-2]],[0,[0,1]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xbbcf6c2447fd4,!1,[[7,[0,2]],[4,59],[0,[0,-2]],[0,[0,0]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0x7263fababb8d1,!1,[[7,[0,3]],[4,60],[0,[0,2]],[0,[0,0]]]],[60,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",5822659280803021,!1,[[7,[0,2]],[4,61],[0,[0,1]],[0,[0,-1]]]],[61,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",9262649163165698,!1,[[7,[0,2]],[4,43]]],[59,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",9922354208046642,!1,[[7,[0,1]],[4,43]]],[56,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x8764f3731027a,
!1,[[7,[0,4]],[4,43]]],[57,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",7520956389843799,!1,[[7,[0,10]],[4,43]]],[45,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",6323866413966437,!1,[[4,43],[3,0]]],[44,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",9223320222412548,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7141774931219007,!1,[[4,43],[3,0]]],[58,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",
5071416414827074,!1,[[4,43],[3,0]]],[59,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7402031639735879,!1,[[4,43],[3,0]]],[60,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x777579aeddc82,!1,[[4,43],[3,0]]],[57,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x89696f1734850,!1,[[4,43],[3,0]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,4817720327583967,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,9065910721315840,
!1,[[0,[1,1]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",7559750292075895,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,0xe6a335bdc1297,!1,[[4,43],[7,[0,8]]]],[-1,cr.system_object.prototype.acts.SetVar,null,403354174363608,!1,[[11,"redlight"],[7,[0,0]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,7577427178679279,!1,[[3,1]]]]],[0,null,!1,null,742057538781468,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,420496546421161,
!1]],[[33,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",7176335372012871,!1,[[7,[0,1]],[4,25]]],[34,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6761793119964202,!1,[[7,[0,1]],[4,33],[0,[0,0]],[0,[0,0]]]],[32,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",4911533702378003,!1,[[7,[0,1]],[4,34],[0,[0,0]],[0,[0,0]]]],[31,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9932466258741232,!1,[[7,[0,1]],[4,
32],[0,[0,0]],[0,[0,0]]]],[30,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9144518697162436,!1,[[7,[0,1]],[4,31],[0,[0,0]],[0,[0,0]]]],[29,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6287765454364743,!1,[[7,[0,1]],[4,30],[0,[0,0]],[0,[0,0]]]],[28,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",8180247944630142,!1,[[7,[0,1]],[4,29],[0,[0,0]],[0,[0,0]]]],[26,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0xf1f460eba0584,!1,[[7,[0,1]],[4,28],[0,[0,0]],[0,[0,0]]]],[27,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9637703060551936,!1,[[7,[0,1]],[4,26],[0,[0,0]],[0,[0,0]]]],[35,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9251325370437558,!1,[[7,[0,1]],[4,27],[0,[0,0]],[0,[0,0]]]],[36,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xb66ccd589133a,!1,[[7,[0,1]],[4,35],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0xc931037374ec1,!1,[[7,[0,1]],[4,36],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",6886469847709407,!1,[[7,[0,2]],[4,38]]]]],[0,null,!1,null,9798206854723848,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xa2f5362f539df,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,0x428aa1e3d6dd7,!1,[[0,[0,0]]]],[84,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",7845976727909892,!1,[[7,[2,"CarBody2"]],[4,
81],[0,[0,1]],[0,[0,0]]]],[88,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xcd196ab473f47,!1,[[7,[2,"Wheel2"]],[4,84]]],[85,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xb63f4422bf2e7,!1,[[7,[2,"Wheel3"]],[4,82]]],[85,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xd6144f8e77d77,!1,[[7,[2,"wheel4"]],[4,83]]],[82,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xf00469f863922,!1,[[7,[2,"CarBody3"]],[4,81]]],[83,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0x71f85cce4e7b1,!1,[[7,[2,"CarBody4"]],[4,81],[0,[0,2]],[0,[0,-2]]]],[81,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",0xab055677d5e7b,!1,[[0,[0,5]]]],[95,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",5106520144619625,!1,[[7,[0,1]],[4,92],[0,[1,0.5]],[0,[1,0.5]]]],[92,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",5093967547653148,!1,[[7,[0,2]],[4,91],[0,[0,2]],[0,[0,0]]]],[90,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",7634721077437383,!1,[[7,[0,1]],[4,91],[0,[0,-2]],[0,[0,2]]]],[90,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xa5920fa68a75e,!1,[[7,[0,2]],[4,89],[0,[0,-2]],[0,[0,2]]]],[92,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",8130148060202238,!1,[[7,[0,3]],[4,93],[0,[0,2]],[0,[0,-2]]]],[93,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",7251156414535232,!1,[[7,[0,2]],[4,94],[0,[0,1]],[0,[0,-1]]]],[94,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",0x7a2ce02ee4b1b,!1,[[7,[0,2]],[4,81]]],[89,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",9398607847968384,!1,[[7,[0,1]],[4,81]]],[92,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",918096610513124,!1,[[7,[0,4]],[4,81]]],[85,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x75b5b6d79e718,!1,[[4,286],[3,0]]],[88,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",9474248901879116,!1,[[4,286],[3,0]]],[94,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",0xd4dcdc23173cd,!1,[[4,81],[3,0]]],[90,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",5782764315454648,!1,[[4,81],[3,0]]],[89,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xa9ad9937e89d,!1,[[4,81],[3,0]]],[93,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xe97ae27b1f01,!1,[[4,81],[3,0]]],[91,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x66bdadcba54a0,!1,[[4,81],[3,0]]],[94,cr.plugins_.Sprite.prototype.acts.SetPosToObject,
null,9359655374165472,!1,[[4,81],[7,[0,6]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,0x4f71053770e2d,!1,[[0,[1,1.3]]]],[70,cr.plugins_.Audio.prototype.acts.Preload,null,0x9db074cbe46fa,!1,[[2,["motorbikerev_001",!1]]]]]],[0,null,!1,null,9091993634709606,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0x3f3b4682460a5,!1]],[[49,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5833924962587939,!1,[[4,45],[7,[0,1]]]],[50,cr.plugins_.Sprite.prototype.acts.SetPosToObject,
null,922648664018564,!1,[[4,44],[7,[0,1]]]],[21,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,526978358346869,!1,[[4,20],[7,[0,2]]]],[20,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x8bafea69c252a,!1,[[4,43],[7,[0,4]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x9fce7fa99cc17,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,0x661390f1b99e,!1,[[4,43],[7,[0,8]]]],[86,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6218247623151629,
!1,[[4,85],[7,[0,1]]]],[87,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5683618239981103,!1,[[4,88],[7,[0,1]]]],[96,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,0x5a7f1c6990097,!1,[[4,81],[7,[0,8]]]]]],[0,null,!1,null,4815504444842014,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,5148415854274582,!1,[[4,4]]]],[[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",0xd42a2c4c56427,!1,[[0,[23,"mph300"]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,
"Physics",8982246730237152,!1,[[0,[0,7]],[0,[0,90]],[7,[0,1]]]],[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",0x4fd707664a715,!1,[[0,[23,"mph50"]]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,7799666915823946,!1,[[4,43],[7,[0,8]]]],[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,4805688275324,!1,[[3,1]]]],[[0,null,!1,null,5799130409245423,[[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,5696455970714314,!1]],[[70,cr.plugins_.Audio.prototype.acts.Stop,
null,9814151633498968,!1,[[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.PlayByName,null,5712809721829099,!1,[[3,0],[1,[2,"Motorbikerev_001"]],[3,0],[0,[0,0]],[1,[2,""]]]]],[[0,null,!1,null,5552562660415897,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,null,1,!1,!1,!1,4668956664639929,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,5437486977315782,!1,[[1,[2,""]]]]],[[0,null,!1,null,0xfa7146f25c6b3,[[6,cr.plugins_.Touch.prototype.cnds.HasNthTouch,null,0,!1,!1,!1,6688031621741818,
!1,[[0,[0,1]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,9826253916441924,!1,[[1,[2,""]]]]]]]],[0,null,!1,null,4804699414774842,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,null,1,!1,!1,!1,7938412625608964,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,7673657625149122,!1,[[1,[2,""]]]]]]]]]],[0,null,!1,null,5182678527786653,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,9832158776154480,!1,[[4,5]]]],[[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,
"Physics",6198200049605106,!1,[[0,[3,[23,"mph350"]]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",0x6356a766c1315,!1,[[0,[0,7]],[0,[0,90]],[7,[0,2]]]],[70,cr.plugins_.Audio.prototype.acts.Stop,null,0x4b662c96d12be,!1,[[1,[2,""]]]],[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",5247273538570356,!1,[[0,[3,[23,"mph350"]]]]]]],[0,null,!1,null,7431419286114238,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8656114555544246,!1,[[4,53]]]],[[61,
cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9968054924064954,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8408831276260972,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,5444857146820446,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7869117267201526,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,6794143281867582,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x8c42822daff0,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,
"ScrollTo",8460944142016745,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,9165338757950942,!1]]],[0,null,!1,null,5579282907837331,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xc3fc82f8d1414,!1,[[4,282]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9547426183708006,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x5be28c24a7b00,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x58f7f11eeb005,!1,[[4,43]]],[-1,
cr.system_object.prototype.acts.SetTimescale,null,0xc850ea3172a45,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,4684621577073611,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,8209722624125374,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",77024613418594,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xb0240f1b1cd4c,!1]]],[0,null,!1,null,0xb3025cf309487,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9603741637807656,
!1,[[4,14]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",4506902710779507,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5065129670131968,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7503151041801976,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8845503184421161,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,6540660595630379,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,52218342626154,
!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",7458756353665233,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x8e5aa18501866,!1]]],[0,null,!1,null,5291055629087916,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6964947725011965,!1,[[4,18]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9096700012609408,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5129544995632454,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,
null,5771255364480865,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x998870811cc07,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,9589224176433860,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xba061d58696f8,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",7390693974065959,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,7344613820384926,!1]]],[0,null,!1,null,7846624245909473,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,4753387420253279,!1,[[4,116]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xd9a50b4947ea0,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xc9a96eb1af1a0,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7783018061054725,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8740476598110955,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,599586382249908,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,5672701387088218,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",8649883457714471,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x4c9cfde7e5cb0,!1]]],[0,null,!1,null,8807743682943097,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x3c2c65d9b7849,!1,[[4,24]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x5db7623cada0a,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x955fe8ed7ad8,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,
null,0x3adaddead2137,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9856883204658648,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xf57942dfd7841,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x4285c792fcb23,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",387547802031383,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,9631766476992324,!1]]],[0,null,!1,null,0x9e1f9f0e040db,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,5979195628274211,!1,[[4,25]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8948905153012642,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x48a5a04052b0f,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x6be886c538873,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5588786595892611,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,7311118132666581,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,9942007414283588,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x534175ab722a6,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,546915749203987,!1]]],[0,null,!1,null,7028456915826179,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xc7dcd122e55b1,!1,[[4,38]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xfbe16e66809fb,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5827863933571089,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,
null,0xf2c1078aa8b6e,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5761570087416863,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x94dc16726333b,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,8198805510440003,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x44de9d18582c8,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x7c17144e44d39,!1]]],[0,null,!1,null,0xf235017e678ec,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,80466425597964,!1,[[4,39]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x6171cc9711a17,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6978944562514611,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x9c992ad25b8a8,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x4c666a556eef4,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,6695749333709184,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,7908357155618118,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",5659333918825087,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xb078f3bd837fb,!1]]],[0,null,!1,null,9832792013477520,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x7c1c80aad34ee,!1,[[4,3]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x85167d4672e5,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9412606384596484,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,
null,7254074687754651,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,6293097086638097,!1,[[0,[1,1.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6055693641940222,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x798cd73790cc4,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,7507969527405432,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",5119674509317658,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,
null,0x9c987acaa9375,!1]]],[0,null,!1,null,9571838946140800,[[284,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5701069808684916,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,6141889408919133,!1,[[0,[0,2]]]],[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,7418699794349876,!1]]],[0,null,!1,null,0x6db178631bf0e,[[13,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8099301767537318,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,8489559968904427,
!1,[[0,[0,2]]]],[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,463642753338003,!1]]],[0,null,!1,null,7478032863578343,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x67d1e503b7252,!1,[[4,284]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0xc815084c1bb63,!1,[[0,[0,2]]]],[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xc3c3343ba3cc6,!1]]],[0,null,!1,null,7683586919264008,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5456894180835082,!1,[[4,19]]]],
[[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x4785a0cd22256,!1,[[4,79],[7,[0,1]]]],[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x6523078c58c56,!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,7159171170704865,!1],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,4724100911995891,!1]]],[0,null,!1,null,4944232148879735,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7910585005512614,!1,[[4,62]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,
null,5906013950437488,!1,[[4,76],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x3be40e9ccb26f,!1,[[4,76],[7,[0,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0x8e5a0bd466813,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x96cee9828aa5b,!1,[[0,[0,0]]]]]],[0,null,!1,null,7269789655241642,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7874821205366339,!1,[[4,63]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,76231562694003,
!1,[[4,79],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xc5d590196cd33,!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9871868868821720,!1,[[0,[1,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0x7b183a361e7bb,!1,[[3,1]]]]],[0,null,!1,null,0xa5065fd2a8537,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8922768367498281,!1,[[4,74]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xd0c5f1f33943d,!1,[[6,"Level2"]]],
[126,cr.plugins_.Clay.prototype.acts.level_success,null,0xa866356ed71d,!1,[[1,[2,"Forest Construction Part 2"]]]],[126,cr.plugins_.Clay.prototype.acts.facebook_post,null,0x71ac8aef4f6cb,!1,[[1,[2,"I Passed Forest Construction On MX Adventure, Can You?"]],[1,[2,""]],[1,[2,"https://www.dropbox.com/s/82ul3rk0t1r509a/posttofacebookpic.png"]],[3,0]]],[126,cr.plugins_.Clay.prototype.acts.achievements_award,null,8979329030827397,!1,[[7,[0,4252]],[3,0]]],[-1,cr.system_object.prototype.acts.SaveState,null,
5458161978752041,!1,[[1,[2,"mysave"]]]]]],[0,null,!1,null,8126756692623484,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9918875454785512,!1,[[4,73]]]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,9903318307210064,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,4723275232993551,!1,[[6,"play"]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,826761440235984,!1,[[3,1]]]]],[0,null,!1,null,0x8bfcae0e108f3,[[95,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,
0,!1,!1,!0,5830446548879175,!1,[[4,53]]]],[[286,cr.behaviors.Flash.prototype.acts.Flash,"Flash",6020457607954331,!1,[[0,[1,0.2]],[0,[1,0.1]],[0,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,null,828911037969113,!1,[[0,[1,1]]]],[286,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xd5a83b287f8e3,!1],[96,cr.plugins_.Particles.prototype.acts.Destroy,null,4825197838378432,!1]]],[0,null,!1,null,9999194531299368,[[95,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x803ede8240f96,!1,[[4,
3]]]],[[286,cr.behaviors.Flash.prototype.acts.Flash,"Flash",5885290505680931,!1,[[0,[1,0.2]],[0,[1,0.1]],[0,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,null,8955336405494313,!1,[[0,[1,1]]]],[286,cr.plugins_.Sprite.prototype.acts.Destroy,null,5082764573250457,!1],[96,cr.plugins_.Particles.prototype.acts.Destroy,null,8618624595768227,!1]]],[0,null,!1,null,0x73f208d3cc389,[[81,cr.plugins_.Sprite.prototype.cnds.IsBetweenAngles,null,0,!1,!1,!1,0x4832c02b9b48a,!1,[[0,[0,10]],[0,[0,90]]]]],[[81,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,
"Physics",5901271356814104,!1,[[0,[0,5]],[0,[0,100]],[7,[0,1]]]]]],[0,null,!1,null,0x77a561481759b,[[81,cr.plugins_.Sprite.prototype.cnds.IsBetweenAngles,null,0,!1,!1,!1,0xbdb90fdfdc4f8,!1,[[0,[0,240]],[0,[0,350]]]]],[[81,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",5651947318872996,!1,[[0,[0,5]],[0,[0,100]],[7,[0,2]]]]]],[0,null,!1,null,0x3d90dcbe1b891,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8737945188659726,!1]],[[-1,cr.system_object.prototype.acts.SaveState,
null,0xa6500403dd799,!1,[[1,[2,"mysave"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x89dfbeda58d2c,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6967222859785598,!1,[[11,"greenlight"],[7,[0,0]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x77afc5ae13098,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,4904622447640202,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8463218500611392,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,
null,6589713736419588,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8693936004878361,!1,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,null,7084970224446906,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5302515909042795,!1,[[0,[0,3]]]],[-1,cr.system_object.prototype.acts.Wait,null,9502936629511366,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xc00859c23d2a1,!1,[[0,[0,4]]]],[-1,cr.system_object.prototype.acts.Wait,
null,0x642bdbafeefa1,!1,[[0,[1,0.7]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x84fe7e570346d,!1,[[11,"greenlight"],[7,[0,1]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5908013131440157,!1,[[0,[0,5]]]]]],[0,null,!1,null,48108228582526,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0xf034911f29354,!1,[[11,"greenlight"],[8,0],[7,[0,1]]]]],[[88,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",0xbedae5b7996d5,!1,[[0,[23,"mph200"]]]],[85,cr.behaviors.Physics.prototype.acts.ApplyTorque,
"Physics",6895171560593744,!1,[[0,[23,"mph50"]]]]]],[0,null,!1,null,0x6b16a592cfa05,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,0x79d9f302758f3,!1,[[11,"greenlight"],[8,0],[7,[0,1]]]]],[[101,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,538140448901475,!1,[[0,[0,1]]]]]],[0,null,!1,null,7104818136911102,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,633189692717082,!1,[[4,102]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x91348ca28b1ea,!1,
[[0,[1,1]]]],[70,cr.plugins_.Audio.prototype.acts.Play,null,0xa017a3d35ebbe,!1,[[2,["pol-afterburner-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.Play,null,96242086465407,!1,[[2,["motorbikerev_001",!1]],[3,0],[0,[0,-100]],[1,[2,""]]]],[102,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x82820c747b24e,!1],[226,cr.plugins_.Sprite.prototype.acts.Destroy,null,5300370408242973,!1]]],[0,null,!1,null,0x9b12a9141f495,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,
null,0,!1,!0,!1,6816620354125593,!1,[[4,4]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,9838059532005684,!1,[[1,[2,""]]]]]],[0,null,!1,null,6069740820838263,[[102,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,0x3ba6d182f4450,!1]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x52cc111db47dd,!1]]],[0,null,!1,null,6311196133616353,[[-1,cr.system_object.prototype.cnds.OnLoadComplete,null,1,!1,!1,!1,836405737074607,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,4698570574810811,
!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,7748696562696412,!1],[70,cr.plugins_.Audio.prototype.acts.Play,null,5729834703316903,!1,[[2,["pol-lovushke-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,6350748546637347,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,5141278086908712,!1]],[[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,8554032218482357,!1,[[3,0]]]]],[0,null,!1,null,0x51df52c67b819,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,5686399107987492,!1]],[[23,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,7120305285248056,!1],[23,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,0x56363404c63f9,!1,[[3,1]]]]]]],["playevent",[[1,"levelsave2",0,0,!1,!1,0x7e692cc8867e1,!1],[0,null,!1,null,837462279751914,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,6833005332740653,!1]],[[51,cr.plugins_.Facebook.prototype.acts.LogIn,null,0xe79a112da61e5,!1,[[3,0],[3,0]]],[70,cr.plugins_.Audio.prototype.acts.Play,
null,4758350745943236,!1,[[2,["pol-cyborg-wars-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]],[241,cr.plugins_.Twitter.prototype.acts.SetPos,null,0xb9e9cf22239f4,!1,[[0,[0,20]],[0,[0,781]]]]]],[0,null,!1,null,0x829f5406102d,[[51,cr.plugins_.Facebook.prototype.cnds.OnLogIn,null,1,!1,!1,!1,5874841248427212,!1]],[[51,cr.plugins_.Facebook.prototype.acts.PromptToShareApp,null,6677473038351895,!1,[[1,[2,"MX Adventure"]],[1,[2,"Test Your Motor Bike Skills Today"]],[1,[2,"Extreme Motorcross Adventure, Join The Fun Today And Beat Your Freinds"]],
[1,[2,""]]]]]],[0,null,!1,null,4797879779710378,[[126,cr.plugins_.Clay.prototype.cnds.cdns_facebook_invite,null,1,!1,!1,!1,7738979668470857,!1]],[[126,cr.plugins_.Clay.prototype.acts.social_share,null,7425152013708774,!1,[[1,[2,"See If You Have What It Takes To Beat Me"]]]]]],[0,null,!1,null,0x58c683617344f,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xfad109f75611e,!1,[[4,120]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,6317530011763506,!1,[[6,"Level1"]]],[241,
cr.plugins_.Twitter.prototype.acts.SetPos,null,8737149495115296,!1,[[0,[0,-9976]],[0,[0,-9971]]]]]],[0,null,!1,null,5338385788258198,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6198115992865339,!1,[[4,123]]]],[[125,cr.plugins_.Browser.prototype.acts.GoToURLWindow,null,0x584e7093d7f30,!1,[[1,[2,"https://www.facebook.com/G.JMojoStudio"]],[1,[2,"NewWindow"]]]]]],[0,null,!1,null,0x92bf547d490f3,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,4684111350150712,
!1,[[4,122]]]],[[126,cr.plugins_.Clay.prototype.acts.facebook_invite,null,7123468858520081,!1,[[1,[2,"Join MX Adventures and see if you can beat me!"]]]]]],[0,null,!1,null,0x81ab99d08bc99,[[51,cr.plugins_.Facebook.prototype.cnds.IsReady,null,0,!1,!1,!1,0x3ddabcd3d8ea1,!1]],[[51,cr.plugins_.Facebook.prototype.acts.LogIn,null,717438900662026,!1,[[3,0],[3,0]]]]],[0,null,!1,null,8504640383504524,[[51,cr.plugins_.Facebook.prototype.cnds.IsLoggedIn,null,0,!1,!1,!1,0xc4dc74b691d0a,!1]],[[51,cr.plugins_.Facebook.prototype.acts.PublishToWall,
null,7202200609953267,!1,[[1,[2,"Join The Fun, Mx Adventure. Can You Beat Your Friends?"]]]]]],[0,null,!1,null,0xae65c082f36b2,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xb0341d694e8c1,!1,[[4,166]]]],[[-1,cr.system_object.prototype.acts.LoadState,null,4765651444441997,!1,[[1,[2,"mysave"]]]]]],[0,null,!1,null,5372800779638338,[[-1,cr.system_object.prototype.cnds.OnLoadComplete,null,1,!1,!1,!1,5112808859825685,!1]],[]],[0,null,!1,null,7384298126478916,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,
null,1,!1,!1,!1,4991876388203166,!1,[[4,177]]]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,99879660242314,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,7421074422033363,!1,[[6,"credits"]]]]],[0,null,!1,null,6003765160122155,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9387161683311612,!1,[[4,165]]]],[[181,cr.plugins_.Sprite.prototype.acts.SetPos,null,6003326040300154,!1,[[0,[0,839]],[0,[0,500]]]],[180,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x8f292f45ef58a,
!1,[[0,[0,850]],[0,[0,344]]]],[182,cr.plugins_.Sprite.prototype.acts.SetPos,null,6827814894729449,!1,[[0,[0,646]],[0,[0,516]]]],[183,cr.plugins_.Sprite.prototype.acts.SetPos,null,5636396129486418,!1,[[0,[0,1038]],[0,[0,520]]]]]],[0,null,!1,null,8286961871489278,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x3dfc0ba4c48ea,!1,[[4,182]]]],[[181,cr.plugins_.Sprite.prototype.acts.SetPos,null,5954783654488413,!1,[[0,[0,1025]],[0,[0,2029]]]],[180,cr.plugins_.Sprite.prototype.acts.SetPos,
null,5728025328590151,!1,[[0,[0,1148]],[0,[0,1264]]]],[182,cr.plugins_.Sprite.prototype.acts.SetPos,null,0x7b269b1f49b96,!1,[[0,[0,494]],[0,[0,1222]]]],[183,cr.plugins_.Sprite.prototype.acts.SetPos,null,8446221435719241,!1,[[0,[0,716]],[0,[0,1226]]]]]],[0,null,!1,null,8548156590366975,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7223189037513893,!1,[[4,183]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x929ed5a9b06b4,!1,[[6,"Level1"]]]]],[0,null,!1,null,7276074876664506,
[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9663450822007316,!1]],[[23,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,0x39e8fa7db8599,!1],[23,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,840075041396746,!1,[[3,0]]]]],[0,null,!1,null,4864640252842598,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9364636977847332,!1,[[4,274]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,418469629628614,!1,[[6,"Level1part2"]]]]],[0,null,!1,null,55630251881043,
[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x5bfa373265fd9,!1,[[4,275]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,5518093639668221,!1,[[6,"Level2"]]]]],[0,null,!1,null,9539002164355500,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7702649126595317,!1,[[4,276]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9450919065950780,!1,[[6,"Level3"]]]]],[0,null,!1,null,7543464247476079,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,
1,!1,!1,!1,0x4ae35d566d6ef,!1,[[4,277]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,7387815478169908,!1,[[6,"Level4"]]]]],[0,null,!1,null,5300480412824136,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6995857994453393,!1,[[4,278]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x84a1b6e4cf293,!1,[[6,"Level5"]]]]],[0,null,!1,null,507625761635652,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7695244078013497,!1,[[4,279]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,
null,0xdb1ac16ba8488,!1,[[6,"Level6"]]]]],[0,null,!1,null,4743580922874776,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,5383829380913504,!1,[[4,279]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x801cc2246b135,!1,[[6,"Level7"]]]]],[0,null,!1,null,7113348795428198,[[43,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5698013925318213,!1,[[4,74]]]],[[166,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x6515490c67da3,!1]]],[0,null,!1,null,8415664169689616,
[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7069485496504418,!1,[[4,281]]]],[[125,cr.plugins_.Browser.prototype.acts.GoToURL,null,4507297839045859,!1,[[1,[2,"https://twitter.com/intent/follow?original_referer=http%3A%2F%2F192.168.0.6%3A50000%2F&screen_name=GJMojoStudio&tw_p=followbutton&variant=2.0"]]]]]]]],["Level2Event",[[1,"greenlight3",0,0,!1,!1,398203287043421,!1],[1,"redlight3",0,0,!1,!1,7325573417564262,!1],[1,"mph22",0,20,!1,!1,7673816316681116,!1],[1,"mph3",0,1,!1,
!1,9321581547352458,!1],[1,"mph12",0,10,!1,!1,5502908813801321,!1],[1,"idletouch3",0,0,!1,!1,522394894119897,!1],[1,"revtouch3",0,0,!1,!1,448996474758906,!1],[1,"pause3",0,0,!1,!1,9737681906791212,!1],[1,"zoom3",0,0,!1,!1,7556724053271111,!1],[1,"mph52",0,50,!1,!1,8032756854752322,!1],[1,"mph602",0,600,!1,!1,0xb1566d0a09cc6,!1],[1,"mph552",0,550,!1,!1,0xb47971d232af,!1],[1,"mph502",0,500,!1,!1,6863397750431098,!1],[1,"mph452",0,450,!1,!1,0x5fc93bce7a64e,!1],[1,"mph402",0,400,!1,!1,6226526184412611,
!1],[1,"mph352",0,350,!1,!1,0xd732ffd36143d,!1],[1,"mph302",0,300,!1,!1,7501215280559266,!1],[1,"mph252",0,250,!1,!1,9476961576887928,!1],[1,"mph202",0,200,!1,!1,5814436258168306,!1],[1,"mph152",0,150,!1,!1,0xd8c768e9dd29f,!1],[1,"mph102",0,100,!1,!1,8843986103981487,!1],[0,null,!1,null,0xddff7359b35da,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,4949128753984932,!1]],[[46,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",4996774723278446,!1,[[7,[2,"CarBody2"]],
[4,43],[0,[1,0.8]],[0,[0,0]]]],[44,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x6fa911396be26,!1,[[7,[2,"Wheel2"]],[4,46]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xb0bdee6df36f0,!1,[[7,[2,"Wheel3"]],[4,47]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x8a8ec0e613dc7,!1,[[7,[2,"Wheel4"]],[4,48]]],[47,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6665254848080981,!1,[[7,[2,"CarBody3"]],[4,43],
[0,[0,2]],[0,[0,-2]]]],[48,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9366523131438456,!1,[[7,[2,"CarBody4"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[43,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",9062217362729980,!1,[[0,[0,5]]]],[54,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xcfb514c4a2be2,!1,[[7,[0,1]],[4,56],[0,[1,0.5]],[0,[1,0.5]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",794655589289306,
!1,[[7,[0,2]],[4,57],[0,[0,2]],[0,[0,0]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",8340268091973731,!1,[[7,[0,1]],[4,57],[0,[0,-2]],[0,[0,1]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xf851a980cfc13,!1,[[7,[0,2]],[4,59],[0,[0,-2]],[0,[0,0]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xf594bb9372acd,!1,[[7,[0,3]],[4,60],[0,[0,2]],[0,[0,0]]]],[60,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",5798723230567268,!1,[[7,[0,2]],[4,61],[0,[0,1]],[0,[0,-1]]]],[45,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x85df043efefd5,!1,[[4,43],[3,0]]],[44,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",5704147948269716,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",4812732060039346,!1,[[4,43],[3,0]]],[58,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x722d4857d75fb,!1,[[4,43],[3,0]]],[59,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",8214858877850319,!1,[[4,43],[3,0]]],[60,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7117091081584903,!1,[[4,43],[3,0]]],[57,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",8063028848916989,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",7965973614711937,!1,[[7,[0,2]],[4,43]]],[59,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x8305f2a42ee22,!1,[[7,[0,1]],[4,43]]],[56,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",4897699112367902,!1,[[7,[0,4]],[4,43]]],[57,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x6acbf287dbe1,!1,[[7,[0,10]],[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5717079341541716,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,7402273059202148,!1,[[0,[1,1]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",9022133806407136,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,0x8e487d12bdfb7,
!1,[[4,43],[7,[0,9]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7876004194757829,!1,[[11,"redlight"],[7,[0,0]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,9170365698501176,!1,[[3,1]]]]],[0,null,!1,null,4703016725046634,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xe0db338d10814,!1]],[[33,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",6794226153206968,!1,[[7,[0,1]],[4,25]]],[34,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",7388957298833186,!1,[[7,[0,1]],[4,33],[0,[0,0]],[0,[0,0]]]],[32,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xbbb3594622113,!1,[[7,[0,1]],[4,34],[0,[0,0]],[0,[0,0]]]],[31,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",801755124287339,!1,[[7,[0,1]],[4,32],[0,[0,0]],[0,[0,0]]]],[30,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",897286486356072,!1,[[7,[0,1]],[4,31],[0,[0,0]],[0,[0,0]]]],[29,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",4702054026653551,!1,[[7,[0,1]],[4,30],[0,[0,0]],[0,[0,0]]]],[28,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x97d6b97591ec9,!1,[[7,[0,1]],[4,29],[0,[0,0]],[0,[0,0]]]],[26,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",551221625417697,!1,[[7,[0,1]],[4,28],[0,[0,0]],[0,[0,0]]]],[27,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",5836829737429847,!1,[[7,[0,1]],[4,26],[0,[0,0]],[0,[0,0]]]],[35,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",4583834603102215,!1,[[7,[0,1]],[4,27],[0,[0,0]],[0,[0,0]]]],[36,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x68a9f745ca5c4,!1,[[7,[0,1]],[4,35],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6139015790261634,!1,[[7,[0,1]],[4,36],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xdc642e66a2795,!1,[[7,[0,2]],[4,38]]]]],[0,null,!1,null,9761921711073056,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,8743194523622069,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,6319950845989131,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,0x95b76fa7a49b0,!1,[[0,[1,1.3]]]],[70,cr.plugins_.Audio.prototype.acts.Preload,null,9032012880472368,!1,[[2,["motorbikerev_001",!1]]]]]],[0,null,!1,null,8103249721456274,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,981262184604458,!1]],[[49,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,876056313995792,
!1,[[4,45],[7,[0,1]]]],[50,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6919940509760868,!1,[[4,44],[7,[0,1]]]],[21,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6157270922244703,!1,[[4,20],[7,[0,2]]]],[20,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,7474458121265894,!1,[[4,43],[7,[0,4]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x445cfc19da84c,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,6642957520225392,!1,[[4,43],[7,[0,
9]]]]]],[0,null,!1,null,9638538482701392,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,6719361519879761,!1,[[4,4]]]],[[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",0x62e976b2ffd81,!1,[[0,[23,"mph300"]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",713633639553743,!1,[[0,[0,7]],[0,[0,90]],[7,[0,1]]]],[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",8857365211018373,!1,[[0,[23,"mph50"]]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,
null,7064099326851506,!1,[[4,43],[7,[0,9]]]],[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,0x63a6a6608e81f,!1,[[3,1]]],[70,cr.plugins_.Audio.prototype.acts.SetMuted,null,0x826d4c2d035f4,!1,[[1,[2,"rev"]],[3,1]]]],[[0,null,!1,null,4772986114151034,[[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,6059129027026706,!1]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,688557658490594,!1,[[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.PlayByName,null,589160753234161,!1,[[3,
0],[1,[2,"Motorbikerev_001"]],[3,0],[0,[0,0]],[1,[2,""]]]]],[[0,null,!1,null,7756947837997522,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,null,1,!1,!1,!1,0x4bfeb714e36f8,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,0x3e58370f00466,!1,[[1,[2,""]]]]],[[0,null,!1,null,9239947686184962,[[6,cr.plugins_.Touch.prototype.cnds.HasNthTouch,null,0,!1,!1,!1,9348676548345072,!1,[[0,[0,1]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,0x5fe3ef39d2689,!1,[[1,[2,""]]]]]]]],[0,null,
!1,null,0xb0eec64b5e35f,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,null,1,!1,!1,!1,0x68b60ff09f44b,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,8588262347388939,!1,[[1,[2,""]]]]]]]]]],[0,null,!1,null,9403495527043492,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,5339038803675728,!1,[[4,5]]]],[[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",9320618288057748,!1,[[0,[3,[23,"mph200"]]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,
"Physics",8562673972100175,!1,[[0,[0,7]],[0,[0,90]],[7,[0,2]]]],[70,cr.plugins_.Audio.prototype.acts.Stop,null,4671754282134355,!1,[[1,[2,""]]]],[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",5833459508106167,!1,[[0,[3,[23,"mph350"]]]]]]],[0,null,!1,null,6991401946052512,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6214738809550586,!1,[[4,133]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9409480035708316,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",0x825a4f4d2aa24,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,9522377672288124,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xde4de4508590b,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xdbceaf19ff2e,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,5341601592907123,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",6342464306228521,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xacbc46acf82e9,
!1]]],[0,null,!1,null,7384956666558768,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7311937641551339,!1,[[4,282]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5907602957650334,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xd5eaac6476d7f,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7484468680014967,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x816b6275872b9,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,6542840776896552,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x5cc329d8cee0d,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",756068236734334,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x63b1bbdb7b51d,!1]]],[0,null,!1,null,0x38e714acb82cc,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xbc053db327f69,!1,[[4,14]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x5261c9b0f21ed,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",6091197333651737,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7010355025531762,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x8f94b2a35edc9,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xe31bfdceab78c,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,4788843744161781,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",8175356213633516,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,
7982711210283265,!1]]],[0,null,!1,null,453571347019855,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5474394711805149,!1,[[4,18]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9232706101706858,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xdc94828aa9c41,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,755495673570919,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x990e9a7936a61,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,8910938099128578,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,8907616914116715,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",308351312754929,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,4905965579957298,!1]]],[0,null,!1,null,0x9109e14d3cf34,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7781014871972363,!1,[[4,116]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xbfd6321fe10fc,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",0x9a44eccbae10a,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,8591834048136097,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xa7edcb33b6a15,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,9933599039363928,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,5844041286275187,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",7406575133745783,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,
8869601758715319,!1]]],[0,null,!1,null,0x77f2531c2e35a,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,38584619792726,!1,[[4,24]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x463d9a7142827,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x5126446b2f0ab,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,6821500525994709,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6589566879551294,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,0xc3419e5196cf3,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,980872309170446,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",8363830323768348,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x7e0eaaa36fa9d,!1]]],[0,null,!1,null,8475205638595201,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6300627490927796,!1,[[4,25]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6077703463176655,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",0xd058a2bb3d193,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x8470ce5a1faf8,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x577c4da9d42c4,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,6989503596325445,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,7657888649685086,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",9850926926487776,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,7337217809457405,
!1]]],[0,null,!1,null,0xf73dc4baacf56,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5921017085743063,!1,[[4,38]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5531866164948159,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8606775982616073,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,8538040844656115,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9118201716019708,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,8396860509302097,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,9114706954810096,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",8482592698326842,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xa43dd83822e70,!1]]],[0,null,!1,null,0xc6116110bcaff,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x4bd4a4963c753,!1,[[4,39]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xdac1a67bd71b7,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",9699862806577932,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x5f4826d0270fc,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7359673027316268,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,9663586891211624,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,7486576969146843,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x7c954b6eb7285,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,
5306760057675903,!1]]],[0,null,!1,null,7956572510389431,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x9dc74cf80417b,!1,[[4,3]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6878674777889963,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x48b9a7d2221e0,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xff99ea2ceb8a0,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9034080139471768,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,
null,9899514461526988,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,7409933112498541,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",7521082677862176,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x75862222fd48c,!1]]],[0,null,!1,null,9277516298983206,[[284,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,885578439538249,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0x880c946082186,!1,[[0,[0,2]]]],[12,cr.plugins_.Sprite.prototype.acts.Destroy,
null,820329298531882,!1]]],[0,null,!1,null,5561375142663836,[[13,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xb63d568e4d28,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,8452289561757076,!1,[[0,[0,2]]]],[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,6291343808205074,!1]]],[0,null,!1,null,9129000541432352,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x5cd968c6967d,!1,[[4,284]]]],[[-1,cr.system_object.prototype.acts.Wait,null,305769873983571,
!1,[[0,[0,2]]]],[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x5b521789cada,!1]]],[0,null,!1,null,9807563710367616,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9275038822228872,!1,[[4,19]]]],[[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6257168937345597,!1,[[4,79],[7,[0,1]]]],[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xc7d0601399b11,!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xad9d561211583,!1],[70,cr.plugins_.Audio.prototype.acts.StopAll,
null,6891991262886961,!1]]],[0,null,!1,null,7993585047356723,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6213073883144782,!1,[[4,62]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,479352733994383,!1,[[4,76],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,8827984412531375,!1,[[4,76],[7,[0,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,9712765635497554,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,400536682693786,
!1,[[0,[0,0]]]]]],[0,null,!1,null,0xa66bbcfbfb28e,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x61d818b0defe1,!1,[[4,63]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,7701720435342278,!1,[[4,79],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x5bb98a407f901,!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,4513596824751229,!1,[[0,[1,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,8744650198194727,!1,
[[3,1]]]]],[0,null,!1,null,5986007317110105,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9534093666253544,!1,[[4,74]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0xc099acb7f67e9,!1,[[6,"Level3"]]],[126,cr.plugins_.Clay.prototype.acts.level_success,null,8134888444524522,!1,[[1,[2,"ForestConstruction"]]]],[126,cr.plugins_.Clay.prototype.acts.facebook_post,null,5741552478597112,!1,[[1,[2,"I Passed This Level Now Off To Somerset Cider Farm, Can You Beat Me?"]],[1,[2,
""]],[1,[2,"https://www.dropbox.com/s/82ul3rk0t1r509a/posttofacebookpic.png"]],[3,0]]],[126,cr.plugins_.Clay.prototype.acts.achievements_award,null,7288612050324952,!1,[[7,[0,4253]],[3,0]]]]],[0,null,!1,null,9264381445944280,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7177788209919742,!1,[[4,73]]]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,8367675183055868,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0xdcc66ca961b00,!1,[[6,"play"]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,
null,0xa646ec667b10,!1,[[3,1]]]]],[0,null,!1,null,6190546924078527,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8344434222566394,!1]],[[-1,cr.system_object.prototype.acts.SaveState,null,9119203257686224,!1,[[1,[2,"mysave"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,525050487273229,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xaf0045e65dcbe,!1,[[11,"greenlight"],[7,[0,0]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5616343525436758,
!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,9579093177937152,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xe5ce6ea9a23cf,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,7523909366486322,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,934749366640547,!1,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xca749eaf04aa9,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x5c150e14b776f,
!1,[[0,[0,3]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x7fe2f711b6b7f,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,9256101379768416,!1,[[0,[0,4]]]],[-1,cr.system_object.prototype.acts.Wait,null,5849511131299817,!1,[[0,[1,0.7]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9831035629603326,!1,[[11,"greenlight"],[7,[0,1]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x73e3c9db9d004,!1,[[0,[0,5]]]]]],[0,null,!1,null,8054343495734996,[[-1,cr.system_object.prototype.cnds.CompareVar,
null,0,!1,!1,!1,9354509958481456,!1,[[11,"greenlight"],[8,0],[7,[0,1]]]]],[[101,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,939074429160248,!1,[[0,[0,1]]]]]],[0,null,!1,null,6807968208690951,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x41b2046ca817b,!1,[[4,102]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,5962587330583319,!1,[[0,[1,1]]]],[70,cr.plugins_.Audio.prototype.acts.Play,null,7746887435558193,!1,[[2,["pol-lovushke-short",!1]],[3,1],[0,[0,0]],[1,
[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.Play,null,0x5cf00d78e51ec,!1,[[2,["motorbikerev_001",!1]],[3,0],[0,[0,-100]],[1,[2,""]]]],[102,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xbbd3e73fe98a,!1],[226,cr.plugins_.Sprite.prototype.acts.Destroy,null,8231097187921767,!1]]],[0,null,!1,null,0x717a59358bad2,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!0,!1,6711420430541635,!1,[[4,4]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,8023372214904178,!1,[[1,[2,""]]]]]],[0,
null,!1,null,7225585989117426,[[102,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,45370653608709,!1]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,9597500288624304,!1]]],[0,null,!1,null,9086540966774504,[[126,cr.plugins_.Clay.prototype.cnds.cdns_facebook_post,null,1,!1,!1,!1,8081700514836741,!1]],[]],[0,null,!1,null,7237839591649595,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,6580621515975286,!1]],[[136,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",0xc58d2c0dd9a69,!1,[[7,[0,1]],[4,139]]]]],[0,null,!1,null,8048388949031634,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7609780975800633,!1]],[[283,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,65408285256599,!1,[[0,[0,2]]]]]],[0,null,!1,null,5308152157750269,[[-1,cr.system_object.prototype.cnds.OnLoadComplete,null,1,!1,!1,!1,7885090500936924,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,0x7ead40f4c8c94,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,7413324470039981,!1],[70,cr.plugins_.Audio.prototype.acts.Play,null,5565454713076311,!1,[[2,["pol-lovushke-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,0x447ef8ff81328,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,9321493272115756,!1]],[[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,0x4cc1098aabee1,!1,[[3,0]]]]],[0,null,!1,null,9750784170524196,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xf825a2cb29f4f,!1]],[[23,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,
null,0x5df044aa7403f,!1],[23,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,5664869253224246,!1,[[3,1]]]]]]],["creditevents",[[0,null,!1,null,7865298534280454,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5527112361948988,!1]],[[70,cr.plugins_.Audio.prototype.acts.Play,null,50646234058794,!1,[[2,["pol-brave-worm-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,0x8cff011f34cad,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchStart,null,1,!1,!1,!1,5254735717336527,!1]],
[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,8004387994394501,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,4570247705617559,!1,[[6,"play"]]]]]]],["Level4Event",[[1,"greenlight5",0,0,!1,!1,0x6bed47d6181a,!1],[1,"redlight5",0,0,!1,!1,0x8c011be2a56df,!1],[1,"mph24",0,20,!1,!1,969058615719101,!1],[1,"mph5",0,1,!1,!1,0xe97e9989ded53,!1],[1,"mph14",0,10,!1,!1,7175385091804593,!1],[1,"idletouch5",0,0,!1,!1,0x8d43ff8b9cc39,!1],[1,"revtouch5",0,0,!1,!1,7708174718069461,!1],[1,"pause5",0,0,
!1,!1,4852889978059004,!1],[1,"zoom5",0,0,!1,!1,8231545707786359,!1],[1,"mph54",0,50,!1,!1,8391644880820136,!1],[1,"mph604",0,600,!1,!1,5392317260100859,!1],[1,"mph554",0,550,!1,!1,0x6565142c65a1a,!1],[1,"mph504",0,500,!1,!1,5475385059707718,!1],[1,"mph454",0,450,!1,!1,0xbd8a22b9e4fdb,!1],[1,"mph404",0,400,!1,!1,0x7edc1bea45f61,!1],[1,"mph354",0,350,!1,!1,0xac45c1f67d6b6,!1],[1,"mph304",0,300,!1,!1,8115502291899192,!1],[1,"mph254",0,250,!1,!1,4696243090303145,!1],[1,"mph204",0,200,!1,!1,7462973858265145,
!1],[1,"mph154",0,150,!1,!1,9618586875646800,!1],[1,"mph104",0,100,!1,!1,8398220177991193,!1],[0,null,!1,null,9627527934542338,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xade7be7fe10f,!1]],[[46,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xdc6a52936756b,!1,[[7,[2,"CarBody2"]],[4,43],[0,[1,0.8]],[0,[0,0]]]],[44,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x53f4be576bcd2,!1,[[7,[2,"Wheel2"]],[4,46]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",949072291840638,!1,[[7,[2,"Wheel3"]],[4,47]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xaf1259a18777d,!1,[[7,[2,"Wheel4"]],[4,48]]],[47,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xf489c39473260,!1,[[7,[2,"CarBody3"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[48,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6058342324822009,!1,[[7,[2,"CarBody4"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[43,cr.behaviors.Physics.prototype.acts.SetWorldGravity,
"Physics",9808164338879752,!1,[[0,[0,5]]]],[54,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",7086015395107697,!1,[[7,[0,1]],[4,56],[0,[1,0.5]],[0,[1,0.5]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",8418347974979894,!1,[[7,[0,2]],[4,57],[0,[0,2]],[0,[0,0]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x496d593acc3e4,!1,[[7,[0,1]],[4,57],[0,[0,-2]],[0,[0,1]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",8092382266477329,!1,[[7,[0,2]],[4,59],[0,[0,-2]],[0,[0,0]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",5515307168778865,!1,[[7,[0,3]],[4,60],[0,[0,2]],[0,[0,0]]]],[60,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x94f998880dffb,!1,[[7,[0,2]],[4,61],[0,[0,1]],[0,[0,-1]]]],[45,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",5086912250035184,!1,[[4,43],[3,0]]],[44,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",7299616486702382,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",6740394110876262,!1,[[4,43],[3,0]]],[58,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7298062007156632,!1,[[4,43],[3,0]]],[59,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7351684859385961,!1,[[4,43],[3,0]]],[60,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x9463849479280,!1,[[4,43],[3,0]]],[57,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",0x5ed668a4775ab,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",8621250059195342,!1,[[7,[0,2]],[4,43]]],[59,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xc4cf690a1c291,!1,[[7,[0,1]],[4,43]]],[56,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x8d177b575a670,!1,[[7,[0,4]],[4,43]]],[57,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x99f3d584b1607,!1,[[7,[0,10]],[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,9970793839942624,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,0x5b451d6467b51,!1,[[0,[1,1]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",815296206094307,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,6789331342387927,!1,[[4,43],[7,[0,9]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0x7921879cb3a7f,!1,[[11,"redlight"],[7,[0,0]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0x7ea537bbef908,!1,[[3,1]]],[43,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,8160325622010656,!1,[[0,[0,3]]]]]],[0,null,!1,null,0x3affe710b6c46,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xf1de851b22100,!1]],[[33,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",6031354788855389,!1,[[7,[0,1]],[4,0]]],[34,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x3cc7936bf9dfb,!1,[[7,[0,1]],[4,33],[0,[0,0]],[0,[0,0]]]],[32,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xd17de15f1fe2a,!1,
[[7,[0,1]],[4,34],[0,[0,0]],[0,[0,0]]]],[31,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",8344987858783499,!1,[[7,[0,1]],[4,32],[0,[0,0]],[0,[0,0]]]],[30,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x97ce296614c87,!1,[[7,[0,1]],[4,31],[0,[0,0]],[0,[0,0]]]],[29,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6051634326449626,!1,[[7,[0,1]],[4,30],[0,[0,0]],[0,[0,0]]]],[28,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0x5bd05a987d909,!1,[[7,[0,1]],[4,29],[0,[0,0]],[0,[0,0]]]],[26,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xd81bd6e6d739d,!1,[[7,[0,1]],[4,28],[0,[0,0]],[0,[0,0]]]],[27,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",5672696901050451,!1,[[7,[0,1]],[4,26],[0,[0,0]],[0,[0,0]]]],[35,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xeab512b1d1421,!1,[[7,[0,1]],[4,27],[0,[0,0]],[0,[0,0]]]],[36,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0xba490e1e52295,!1,[[7,[0,1]],[4,35],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9630011027365972,!1,[[7,[0,1]],[4,36],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",5545108355971316,!1,[[7,[0,1]],[4,149]]]]],[0,null,!1,null,5504838866156845,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5227918964468906,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,6938756600247323,
!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,8872867236390452,!1,[[0,[1,1.3]]]],[70,cr.plugins_.Audio.prototype.acts.Preload,null,0x9d4d7b856520f,!1,[[2,["motorbikerev_001",!1]]]]]],[0,null,!1,null,0x49d4fdad798c2,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,0xefb5bdac48dd3,!1]],[[49,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,8113095968538248,!1,[[4,45],[7,[0,1]]]],[50,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9011234198855736,!1,
[[4,44],[7,[0,1]]]],[21,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x662232c6b2e21,!1,[[4,20],[7,[0,2]]]],[20,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6246131109038025,!1,[[4,43],[7,[0,4]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x72f8f7c2abd3e,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,9269906336662158,!1,[[4,43],[7,[0,8]]]],[198,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x62dc249696250,!1,[[4,197],[7,[0,1]]]],
[199,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9176685867298352,!1,[[4,197],[7,[0,2]]]],[202,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6213998153241747,!1,[[4,200],[7,[0,2]]]],[201,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9074330556521394,!1,[[4,200],[7,[0,1]]]],[208,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,328975191926805,!1,[[4,207],[7,[0,1]]]]]],[0,null,!1,null,6081159265848043,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,
!1,764978823450826,!1,[[4,4]]]],[[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",0xa443e8855417a,!1,[[0,[23,"mph300"]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",0x3f819e64fc04d,!1,[[0,[0,7]],[0,[0,90]],[7,[0,1]]]],[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",0xd27b37a2bb11d,!1,[[0,[23,"mph50"]]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,50609676431594,!1,[[4,43],[7,[0,9]]]],[66,cr.plugins_.Particles.prototype.acts.SetSpraying,
null,0x849870b45409e,!1,[[3,1]]]],[[0,null,!1,null,0x3b12e88d772c5,[[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,9221095198780840,!1]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,311384098346573,!1,[[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.PlayByName,null,0xe7a1af83678f1,!1,[[3,0],[1,[2,"Motorbikerev_001"]],[3,0],[0,[0,0]],[1,[2,""]]]]],[[0,null,!1,null,0x9b4e06e6fb889,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,null,1,!1,!1,!1,8882923047274389,!1,[[0,[0,0]]]]],
[[70,cr.plugins_.Audio.prototype.acts.Stop,null,7473943367520668,!1,[[1,[2,""]]]]],[[0,null,!1,null,0xfa44be41517a0,[[6,cr.plugins_.Touch.prototype.cnds.HasNthTouch,null,0,!1,!1,!1,490044009350332,!1,[[0,[0,1]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,9608641482136642,!1,[[1,[2,""]]]]]]]],[0,null,!1,null,0xaaabd104b4b36,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,null,1,!1,!1,!1,0x90c4ac3e73cc3,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,0xad5c5f026493a,!1,[[1,
[2,""]]]]]]]]]],[0,null,!1,null,8950588197219575,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,6286630608550678,!1,[[4,5]]]],[[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",694954188549099,!1,[[0,[3,[23,"mph200"]]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",9752326801661340,!1,[[0,[0,7]],[0,[0,90]],[7,[0,2]]]],[70,cr.plugins_.Audio.prototype.acts.Stop,null,0xe4add5f72fb89,!1,[[1,[2,""]]]],[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,
"Physics",862192221174726,!1,[[0,[3,[23,"mph350"]]]]]]],[0,null,!1,null,5522260345696861,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5979718150207898,!1,[[4,53]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5459023243967301,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5943345017458299,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x8ca75f8d7e23c,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6084831996318763,
!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,7072083908922856,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,862285946253166,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",887835091331796,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,342722900207673,!1]]],[0,null,!1,null,8515747518604395,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8487231869485439,!1,[[4,282]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",0xce66a1b1915fc,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",621265976452878,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,5875038787644162,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7468418626842638,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,5957470150106296,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xb87a09eb59da7,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
9935434932799794,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,7991248916240128,!1]]],[0,null,!1,null,0xeaa702a48b88b,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9208380807937348,!1,[[4,14]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9380321223617986,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x8f786d2aae339,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,5330956708487008,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,5410550709449029,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,6517942125497446,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xae0e172350288,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",8396766102992474,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,8681829377421868,!1]]],[0,null,!1,null,5047713505880002,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x5e8eae8186c76,!1,[[4,18]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",5060304850153164,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xaca7d6dd0cfb6,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7498776171253857,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8419699715364345,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x45e81143de91f,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,9691967007370248,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
0x4db7fb5aed9b6,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,4860767207685422,!1]]],[0,null,!1,null,6340740762750349,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,888673393836246,!1,[[4,116]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xc4f07147eff65,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8192278820302751,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xb93e708b2a815,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,6310414095478456,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xeee2e6166805d,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,6267993461802071,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",5652730455159447,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,7473809634252114,!1]]],[0,null,!1,null,9676760286532992,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xac18155a0bbac,!1,[[4,24]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",7153726097121502,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x67e7012e14385,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7433645695812833,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5784872455544693,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x96515a6983571,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,5223979524657163,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
0xd2410e89360b5,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,4990967452466146,!1]]],[0,null,!1,null,8178541981707459,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6696701710301013,!1,[[4,25]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5864000583241356,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x50a0e42823998,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,8675589372038078,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,9936643080707204,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,6212159543220368,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,4815958633087638,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",7783719263287842,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,601840247311587,!1]]],[0,null,!1,null,7315449360665708,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa85f70078aebd,!1,[[4,38]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",6335650981195056,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6965906892483862,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,5794784619710066,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7456351295129636,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,9309251450437712,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xb449258194011,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
0xbe4a4b3186e56,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,5465378690975894,!1]]],[0,null,!1,null,7430892464562177,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7028516574005271,!1,[[4,39]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",375044901932619,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",799173432996587,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,6375131008540629,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,0x94cb602e3f0cf,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x5060e865510ab,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,8596557125479855,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x3a0613776234b,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,4840991369872848,!1]]],[0,null,!1,null,0x38e7a9370e133,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8731162660542736,!1,[[4,3]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",0xd254b77d726e8,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xa97f4429e5bb1,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7108626010659481,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,7842934753891721,!1,[[0,[1,1.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,4554296502489038,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,null,5607264949499301,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,5702824267610129,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",9576856210415308,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xdcf5bde0ef16b,!1]]],[0,null,!1,null,0xa07e8754dd629,[[284,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x3a303d673defe,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,7163660578994747,!1,[[0,[0,2]]]],[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xff76739b318e,!1]]],[0,null,!1,null,4742292587249518,
[[13,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xab273c1eccc9d,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,8982211990360221,!1,[[0,[0,2]]]],[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x4ce47093eaad7,!1]]],[0,null,!1,null,0x466a57c1287bb,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x9a75d2dbb54f1,!1,[[4,19]]]],[[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5844481495580217,!1,[[4,79],[7,[0,1]]]],[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,
null,6563548468420296,!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x7718dd9a6bd0b,!1],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x45a4ebed2e65c,!1]]],[0,null,!1,null,6225734146567647,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,4993028302723529,!1,[[4,62]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x705942d9a241b,!1,[[4,76],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,8554532083661108,!1,[[4,
76],[7,[0,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,9272205406576618,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9122091912045396,!1,[[0,[0,0]]]]]],[0,null,!1,null,4997830793475074,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7392350812330693,!1,[[4,63]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x3d71f6738e402,!1,[[4,79],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xe9f93b3c52ec8,!1,[[4,79],[7,
[0,1]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8661804254431587,!1,[[0,[1,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0xa49c4d0dd7c31,!1,[[3,1]]]]],[0,null,!1,null,6979323632390587,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x8257a05805504,!1,[[4,74]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,0x8178ab7256d11,!1,[[6,"Level5"]]],[126,cr.plugins_.Clay.prototype.acts.level_success,null,6761317918273816,!1,[[1,[2,"Forest Construction Part 2"]]]],
[126,cr.plugins_.Clay.prototype.acts.facebook_post,null,5907878832159897,!1,[[1,[2,"I Just Cant Be Stopped, Can You?"]],[1,[2,""]],[1,[2,"https://www.dropbox.com/s/82ul3rk0t1r509a/posttofacebookpic.png"]],[3,0]]],[126,cr.plugins_.Clay.prototype.acts.achievements_award,null,0xc475d0c0194a0,!1,[[7,[0,4254]],[3,0]]]]],[0,null,!1,null,0xd25cf0c02cc0d,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7691803256141803,!1,[[4,73]]]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x6d49086a2ca9b,
!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,6989712014054348,!1,[[6,"play"]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,5522692942466203,!1,[[3,1]]]]],[0,null,!1,null,0xfcfc16025edec,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x479056d9a40a5,!1]],[[-1,cr.system_object.prototype.acts.SaveState,null,0x93110697851dd,!1,[[1,[2,"mysave"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6681757920294841,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,588509445470807,!1,[[11,"greenlight"],[7,[0,0]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6487622914611043,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,5796795100620779,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5740378025111507,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xcc0e26e1de580,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x5b5b4e08c2af7,!1,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,6317339534948972,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,4767910758415663,!1,[[0,[0,3]]]],[-1,cr.system_object.prototype.acts.Wait,null,6443737508714191,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xfd3c2bc5235e7,!1,[[0,[0,4]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xb0b76281995ed,!1,[[0,[1,0.7]]]],[-1,cr.system_object.prototype.acts.SetVar,null,5191629029623166,!1,[[11,"greenlight"],[7,[0,1]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,6771982382324164,!1,[[0,[0,5]]]]]],[0,null,!1,null,4883972361256211,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9051204781944964,!1,[[11,"greenlight"],[8,0],[7,[0,1]]]]],[[101,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5840965402695702,!1,[[0,[0,1]]]]]],[0,null,!1,null,7822168095909111,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x95af73371ed19,!1,[[4,102]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x62e6f909606f7,!1,[[0,[1,1]]]],
[70,cr.plugins_.Audio.prototype.acts.Play,null,0x3fc364f6b37c0,!1,[[2,["pol-grid-breaking-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.Play,null,8006232817520196,!1,[[2,["motorbikerev_001",!1]],[3,0],[0,[0,-100]],[1,[2,""]]]],[102,cr.plugins_.Sprite.prototype.acts.Destroy,null,5132072416322246,!1],[226,cr.plugins_.Sprite.prototype.acts.Destroy,null,7969419935218824,!1]]],[0,null,!1,null,7162786820562533,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,
!1,!0,!1,0xee73da5ccef3b,!1,[[4,4]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,7279061258918419,!1,[[1,[2,""]]]]]],[0,null,!1,null,6206425252795704,[[102,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,8605109386510735,!1]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,9480232396668204,!1]]],[0,null,!1,null,7182309666296273,[[-1,cr.system_object.prototype.cnds.EffectsSupported,null,0,!1,!1,!1,0x9efdc40bebb69,!1]],[]],[0,null,!1,null,0x9787f224fc4bc,[[-1,cr.system_object.prototype.cnds.OnLoadComplete,
null,1,!1,!1,!1,0xbb8130f58057f,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,0xc39e71d13cd94,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x5f23b3a38f92d,!1],[70,cr.plugins_.Audio.prototype.acts.Play,null,9422027620206376,!1,[[2,["pol-grid-breaking-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,0x59e4a096f7503,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8245966191894021,!1,[[4,212]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,
null,8193360135999342,!1]]],[0,null,!1,null,9061657201734608,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xf5198e4e1b8c5,!1]],[[234,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",4888333343445515,!1,[[7,[0,1]],[4,233]]]]],[0,null,!1,null,9863315198125438,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,5260763898448184,!1]],[[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,6621509298309267,!1,[[3,0]]]]],[0,null,!1,null,0x443ecd632027d,
[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x5b8d58ebd0a25,!1]],[[23,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,9648802383087412,!1],[23,cr.plugins_.CJSAds.prototype.acts.ShowBanner,null,7986713194064485,!1,[[3,1]]]]]]],["Level5Event",[[1,"onground",0,0,!1,!1,9535880482184116,!1],[1,"greenlight6",0,0,!1,!1,0xfe897d74a97c3,!1],[1,"redlight6",0,0,!1,!1,5483405864372078,!1],[1,"mph25",0,20,!1,!1,5288208082652205,!1],[1,"mph6",0,1,!1,!1,663444658118278,!1],[1,"mph15",
0,10,!1,!1,0x79697bd7a37a9,!1],[1,"idletouch6",0,0,!1,!1,0x8fad76d0e5942,!1],[1,"revtouch6",0,0,!1,!1,7569571691398034,!1],[1,"pause6",0,0,!1,!1,0xbef97b5f1e2d6,!1],[1,"zoom6",0,0,!1,!1,5897512938163753,!1],[1,"mph55",0,50,!1,!1,6672779798862649,!1],[1,"mph605",0,600,!1,!1,5017454422957471,!1],[1,"mph555",0,550,!1,!1,0xd8245f3ba25f9,!1],[1,"mph505",0,500,!1,!1,0xafed82c949bfa,!1],[1,"mph455",0,450,!1,!1,0x7a2d1386399d3,!1],[1,"mph405",0,400,!1,!1,6161418846236163,!1],[1,"mph355",0,350,!1,!1,7954787995050974,
!1],[1,"mph305",0,300,!1,!1,8728972559223968,!1],[1,"mph255",0,250,!1,!1,0xdb07d8d1925f3,!1],[1,"mph205",0,200,!1,!1,4789833388411344,!1],[1,"mph155",0,150,!1,!1,0xfbe2acae0112f,!1],[1,"mph105",0,100,!1,!1,462652721783589,!1],[0,null,!1,null,5322040808151161,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7841779447922076,!1]],[[46,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9551168191833934,!1,[[7,[2,"CarBody2"]],[4,43],[0,[1,0.8]],[0,[0,0]]]],[44,
cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xdd1c2310df46b,!1,[[7,[2,"Wheel2"]],[4,46]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xf77bd81caa01,!1,[[7,[2,"Wheel3"]],[4,47]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x6a0ebe3aaab8e,!1,[[7,[2,"Wheel4"]],[4,48]]],[47,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x89f81beec7908,!1,[[7,[2,"CarBody3"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[48,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",7101237438494956,!1,[[7,[2,"CarBody4"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[43,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",7423357855841804,!1,[[0,[0,5]]]],[54,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6267506131409051,!1,[[7,[0,1]],[4,56],[0,[1,0.5]],[0,[1,0.5]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x9e6a7b3d2f289,!1,[[7,[0,2]],[4,57],[0,[0,2]],[0,[0,0]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0x8d8b55f3f6f34,!1,[[7,[0,1]],[4,57],[0,[0,-2]],[0,[0,1]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",5551093510864684,!1,[[7,[0,2]],[4,59],[0,[0,-2]],[0,[0,0]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",673845519370755,!1,[[7,[0,3]],[4,60],[0,[0,2]],[0,[0,0]]]],[60,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",540623056592622,!1,[[7,[0,2]],[4,61],[0,[0,1]],[0,[0,-1]]]],[45,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",0xdd8bd23968bcf,!1,[[4,43],[3,0]]],[44,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",85654902717466,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7548325796607947,!1,[[4,43],[3,0]]],[58,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",312354884551092,!1,[[4,43],[3,0]]],[59,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x96287563f376d,!1,[[4,43],[3,0]]],[60,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",8415598209012986,!1,[[4,43],[3,0]]],[57,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x5325f49b61f97,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x3e7203218adb9,!1,[[7,[0,2]],[4,43]]],[59,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",4609012961132424,!1,[[7,[0,1]],[4,43]]],[56,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xf66abd441f997,!1,[[7,[0,4]],[4,43]]],[57,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",7881160528880252,!1,[[7,[0,10]],[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5067662835877862,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,8448847106743242,!1,[[0,[1,1]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0xc3b5d679a23b7,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,0xbe2f019627b9f,!1,[[4,43],[7,[0,9]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xfb6cd36cf8f6b,!1,[[11,"redlight"],
[7,[0,0]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,7844319805310165,!1,[[3,1]]]]],[0,null,!1,null,0xe1e73cb3f326,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7479468713090581,!1]],[[33,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x7b5962b8c2551,!1,[[7,[0,1]],[4,0]]],[34,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",7253280958774203,!1,[[7,[0,1]],[4,33],[0,[0,0]],[0,[0,0]]]],[32,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0xda7b4e6f6ee0d,!1,[[7,[0,1]],[4,34],[0,[0,0]],[0,[0,0]]]],[31,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9300730385641964,!1,[[7,[0,1]],[4,32],[0,[0,0]],[0,[0,0]]]],[30,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xfea5dc629268,!1,[[7,[0,1]],[4,31],[0,[0,0]],[0,[0,0]]]],[29,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",8612240832952806,!1,[[7,[0,1]],[4,30],[0,[0,0]],[0,[0,0]]]],[28,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0xcc220a4feaa47,!1,[[7,[0,1]],[4,29],[0,[0,0]],[0,[0,0]]]],[26,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x936b75586c709,!1,[[7,[0,1]],[4,28],[0,[0,0]],[0,[0,0]]]],[27,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xa744db1996c58,!1,[[7,[0,1]],[4,26],[0,[0,0]],[0,[0,0]]]],[35,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xaa026abcc5280,!1,[[7,[0,1]],[4,27],[0,[0,0]],[0,[0,0]]]],[36,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0x88e907c598159,!1,[[7,[0,1]],[4,35],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x95729b414ae03,!1,[[7,[0,1]],[4,36],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",9008045457259664,!1,[[7,[0,1]],[4,149]]]]],[0,null,!1,null,5329643702396331,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xd0e97d0cd3b27,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,0xf360953d67022,
!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,6773366594299498,!1,[[0,[1,1.3]]]],[70,cr.plugins_.Audio.prototype.acts.Preload,null,0x82eb56f3fa4ef,!1,[[2,["motorbikerev_001",!1]]]]]],[0,null,!1,null,0x5425e44eecc83,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,8793228902943568,!1]],[[49,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xf441ad5354216,!1,[[4,45],[7,[0,1]]]],[50,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9884168891795588,!1,
[[4,44],[7,[0,1]]]],[21,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x942431045b3e4,!1,[[4,20],[7,[0,2]]]],[20,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6588101202207042,!1,[[4,43],[7,[0,4]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",9574495532644980,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,8127848213704666,!1,[[4,43],[7,[0,9]]]]]],[0,null,!1,null,0x861e8c177c8e9,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,
0,!1,!1,!1,6427229402379016,!1,[[4,4]]]],[[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",9399636591560326,!1,[[0,[23,"mph300"]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",9151025304587428,!1,[[0,[0,7]],[0,[0,90]],[7,[0,1]]]],[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",8918045925966628,!1,[[0,[23,"mph50"]]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,4753001860821694,!1,[[4,43],[7,[0,9]]]],[66,cr.plugins_.Particles.prototype.acts.SetSpraying,
null,0xd43cc3a74bebe,!1,[[3,1]]]],[[0,null,!1,null,0x6d43432da6e4e,[[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,8382023426210553,!1]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,7801514065145754,!1,[[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.PlayByName,null,0x9b1d915eabf94,!1,[[3,0],[1,[2,"Motorbikerev_001"]],[3,0],[0,[0,0]],[1,[2,""]]]]],[[0,null,!1,null,0x746940c938dc6,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,null,1,!1,!1,!1,9134985235702038,!1,[[0,[0,
0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,9714965959190824,!1,[[1,[2,""]]]]],[[0,null,!1,null,8049761687433963,[[6,cr.plugins_.Touch.prototype.cnds.HasNthTouch,null,0,!1,!1,!1,6655274101122844,!1,[[0,[0,1]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,7520410072550201,!1,[[1,[2,""]]]]]]]],[0,null,!1,null,0x4f384c62ec592,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,null,1,!1,!1,!1,0x8b2f9097877bd,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,0x829fb82e033e1,
!1,[[1,[2,""]]]]]]]]]],[0,null,!1,null,0x5c579e9e1f08d,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0x44b8b239beef0,!1,[[4,5]]]],[[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",9126511893139462,!1,[[0,[3,[23,"mph200"]]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",8947558494207886,!1,[[0,[0,7]],[0,[0,90]],[7,[0,2]]]],[70,cr.plugins_.Audio.prototype.acts.Stop,null,8112409039631291,!1,[[1,[2,""]]]],[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,
"Physics",0xafe8d2ec626e9,!1,[[0,[3,[23,"mph350"]]]]]]],[0,null,!1,null,0xac976268b89cf,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x94a1a43686597,!1,[[4,53]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",7384752580116041,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5323644354842441,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7901691441453305,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xce7fc370a1954,
!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,6240215997633694,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xe8c974706ccba,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",6390661288265926,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,7497571057963776,!1]]],[0,null,!1,null,0x6a37dcbf99993,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7372433430388795,!1,[[4,282]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",0xa2dd0bc5f26f0,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6245290865390642,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,8099355071411601,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,830771631093141,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,5311463184851996,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,6453650733012934,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
7406428966271065,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,607222829982046,!1]]],[0,null,!1,null,0x3b6e6d7128d5d,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xdf1be51742483,!1,[[4,14]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6079017830766449,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5574609606634968,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,8269295108818507,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,0xb7c78dc5912c2,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,6803506824827558,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x748111eb4109f,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",7357473006365847,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,9859884633028072,!1]]],[0,null,!1,null,8789491284931132,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf7983143a693b,!1,[[4,18]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",0xa7973abde0bd0,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9712672359636636,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7608769363931031,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,943288978366077,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,7014350761751915,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,8409537990884949,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
5264188991934753,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xbdc79d67be90a,!1]]],[0,null,!1,null,302077199207342,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x5d514447a230,!1,[[4,116]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xee79ae88a4de6,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x743a9db2b1699,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x9d2374daad408,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,0x7fd6b6766716c,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,8241836974862289,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x838a1481bb689,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x623dab66636a9,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,7326703733107571,!1]]],[0,null,!1,null,0xa434b23c7c4f,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,288095880968696,!1,[[4,24]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",0xc1057d52f90cd,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9238557492724504,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x693ff83a68a22,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7682796971252911,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,9465697547190682,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,6994854115161382,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
0x5df67a1a47d44,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xeb05f80c3baa3,!1]]],[0,null,!1,null,8160679338749317,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5984719326591353,!1,[[4,25]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9234491104195120,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9677831337275944,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x48cd81b15525b,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,0xf448bf5cf4a4e,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x61fb26dec81fd,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x632e7e9b8dda4,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x8d32ae2e0774e,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x94a6023e56bde,!1]]],[0,null,!1,null,0xcc015fe9595cf,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x626f31ef8c7ef,!1,[[4,38]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",9207955913091032,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x870cbe13487e9,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,8352442499760918,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7983556018621244,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,8293115915889628,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x512acb4dacfff,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
8062964054226462,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,9051910645218136,!1]]],[0,null,!1,null,6788397623697153,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xf7871de3fed58,!1,[[4,39]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x9ad7a0ada8905,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9907116536651176,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,6413589021455914,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,7102863583294388,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xb550c1cb92b53,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xc32d9d5f4fddf,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",5709743099217389,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,452033397238724,!1]]],[0,null,!1,null,5803674583357895,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7984816458811187,!1,[[4,3]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",0x59097d5cb87be,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",7169992692428494,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,9507231698128804,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,4783942975740617,!1,[[0,[1,1.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xbaeb692572d9,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xdf41c3ee0c35a,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,7893916303359711,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",9865306803389536,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,4618989202580376,!1]]],[0,null,!1,null,0x404c8b8f49e7f,[[284,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7904061050964716,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0x4695e271b8246,!1,[[0,[0,2]]]],[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x87bfa21692245,!1]]],[0,null,!1,null,0x9350383ae536,
[[13,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9471753981397772,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,8004363284833813,!1,[[0,[0,2]]]],[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,370212475227989,!1]]],[0,null,!1,null,4963782235693717,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xa7c8dec0ae02a,!1,[[4,19]]]],[[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x9be9ab17b5a7e,!1,[[4,79],[7,[0,1]]]],[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,
null,0x946cba1fbc3c1,!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,6849220902109595,!1],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,7917107463944328,!1]]],[0,null,!1,null,9856149939528896,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6029576277799033,!1,[[4,62]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,7053992018586452,!1,[[4,76],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,944756832110327,!1,[[4,
76],[7,[0,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,5306865041147239,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x8e596150c8b3f,!1,[[0,[0,0]]]]]],[0,null,!1,null,546289513267636,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9743781506537984,!1,[[4,63]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6209986868662446,!1,[[4,79],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xe5ab369907f49,!1,[[4,79],[7,
[0,1]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9960291270163688,!1,[[0,[1,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,8671294266763632,!1,[[3,1]]]]],[0,null,!1,null,5544032380623164,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4702151342083913,!1,[[4,74]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,8327259563562732,!1,[[6,"Level6"]]],[126,cr.plugins_.Clay.prototype.acts.level_success,null,0xbca265c0c6ec5,!1,[[1,[2,"Forest Construction Part 2"]]]],
[126,cr.plugins_.Clay.prototype.acts.facebook_post,null,7265311685669563,!1,[[1,[2,"Just Cleared The Batch, Can You?"]],[1,[2,""]],[1,[2,"https://www.dropbox.com/s/82ul3rk0t1r509a/posttofacebookpic.png"]],[3,0]]],[126,cr.plugins_.Clay.prototype.acts.achievements_award,null,9063467644285360,!1,[[7,[0,4254]],[3,0]]]]],[0,null,!1,null,8311860657895827,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x4b71b592bb3b1,!1,[[4,73]]]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,732287651087408,
!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,8556571912972501,!1,[[6,"play"]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0x3b328d08bcda0,!1,[[3,1]]]]],[0,null,!1,null,5515246378297985,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8640103722861085,!1]],[[-1,cr.system_object.prototype.acts.SaveState,null,9031701460741224,!1,[[1,[2,"mysave"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8042840875018392,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,0xc71f322d1862a,!1,[[11,"greenlight"],[7,[0,0]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8944982129798915,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,840403417759865,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x4265223d26661,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,723672230676857,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xc179e37381419,!1,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,7407928829477195,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6452271541442659,!1,[[0,[0,3]]]],[-1,cr.system_object.prototype.acts.Wait,null,6697008372284873,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xb7469dc7c92e9,!1,[[0,[0,4]]]],[-1,cr.system_object.prototype.acts.Wait,null,5259450025255818,!1,[[0,[1,0.7]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xca5de26908d89,!1,[[11,"greenlight"],[7,[0,1]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,0xeeef9729367d8,!1,[[0,[0,5]]]]]],[0,null,!1,null,8580497663760476,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,9562357915351024,!1,[[11,"greenlight"],[8,0],[7,[0,1]]]]],[[101,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,8352564175063157,!1,[[0,[0,1]]]]]],[0,null,!1,null,0x79e891826c92,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,8087954270764158,!1,[[4,102]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x51845b85fbc2f,!1,[[0,[1,1]]]],
[70,cr.plugins_.Audio.prototype.acts.Play,null,6849439120890948,!1,[[2,["pol-lovushke-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.Play,null,6395493448984276,!1,[[2,["motorbikerev_001",!1]],[3,0],[0,[0,-100]],[1,[2,""]]]],[102,cr.plugins_.Sprite.prototype.acts.Destroy,null,939086518489299,!1],[226,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x7c7fbd82f2d8a,!1]]],[0,null,!1,null,0x7c89a8cd3a9dc,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!0,!1,
8730898408283294,!1,[[4,4]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,0x5eb0acbf85d26,!1,[[1,[2,""]]]]]],[0,null,!1,null,7592302341486969,[[102,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,0x5bfb474bf905e,!1]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,9026449118251014,!1]]],[0,null,!1,null,0x392ed03e2078b,[[-1,cr.system_object.prototype.cnds.EffectsSupported,null,0,!1,!1,!1,0x8becdeb38ac85,!1]],[]],[0,null,!1,null,7004572268943729,[[-1,cr.system_object.prototype.cnds.OnLoadComplete,
null,1,!1,!1,!1,94099046442192,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,0x7459d981ae0cb,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,7268841096081981,!1],[70,cr.plugins_.Audio.prototype.acts.Play,null,466210945326367,!1,[[2,["pol-grid-breaking-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,5334011087013272,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x9dfbfaa39cdcb,!1]],[[234,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",384219959216796,!1,[[7,[0,1]],[4,233]]]]],[0,null,!1,null,6615038836196136,[[43,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x4d6cf8bdbe124,!1,[[4,238]]]],[[160,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",0x3f980878bfd88,!1,[[3,1]]]]],[0,null,!1,null,7397695513760029,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,595162628699838,!1]],[[23,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,9769494209735528,!1],[23,cr.plugins_.CJSAds.prototype.acts.ShowBanner,
null,0xce9998495ea33,!1,[[3,1]]]]],[0,null,!1,null,0xa65b456be8ef4,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8163371518612619,!1]],[[283,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,692134930812165,!1,[[0,[0,3]]]]]],[0,null,!1,null,9900975082640692,[[209,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8034541315559411,!1,[[4,54]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xbcd8a6a379fd1,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",0xb728e8d9f8dbd,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,8151286199692081,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,6974043375750882,!1,[[0,[1,1.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8136879610134808,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,null,5720613140479919,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x3abdf0ecc3db2,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,
"ScrollTo",0x74f0f0ff4ac35,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xc95ae5f743579,!1]]],[0,null,!1,null,9364311338294858,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4567029819388678,!1,[[4,148]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",7445116127121827,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",4654888746425494,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,4608313540809307,!1,[[4,43]]],[-1,
cr.system_object.prototype.acts.SetLayoutScale,null,0xed8606d8f56aa,!1,[[0,[1,1.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8402040352784349,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x574b819b9873a,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,4532215952803056,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",5501828507146436,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x986226de4a5cf,!1]]],[0,null,
!1,null,9771648940527748,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,6742093813379305,!1]],[[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,0x48cb75745bb9a,!1,[[3,0]]]]]]],["Level6Event",[[1,"onground2",0,0,!1,!1,7591275764953751,!1],[1,"greenlight7",0,0,!1,!1,9518095310453820,!1],[1,"redlight7",0,0,!1,!1,0x5e1b3803690e4,!1],[1,"mph26",0,20,!1,!1,0xf7ec737c1fb4,!1],[1,"mph7",0,1,!1,!1,8501419466012296,!1],[1,"mph16",0,10,!1,!1,9388274750007160,!1],[1,"idletouch7",0,0,
!1,!1,7724927490039725,!1],[1,"revtouch7",0,0,!1,!1,7572941374826118,!1],[1,"pause7",0,0,!1,!1,0xab2b497d5137,!1],[1,"zoom7",0,0,!1,!1,0xa86e0a659b608,!1],[1,"mph56",0,50,!1,!1,8207624084877211,!1],[1,"mph606",0,600,!1,!1,0xa129c74291f6a,!1],[1,"mph556",0,550,!1,!1,0xaab15e69ee0a2,!1],[1,"mph506",0,500,!1,!1,5868241373690942,!1],[1,"mph456",0,450,!1,!1,7577182056029339,!1],[1,"mph406",0,400,!1,!1,7925608904737543,!1],[1,"mph356",0,350,!1,!1,8946579927358143,!1],[1,"mph306",0,300,!1,!1,5678668302584129,
!1],[1,"mph256",0,250,!1,!1,4707249997790121,!1],[1,"mph206",0,200,!1,!1,470217314765776,!1],[1,"mph156",0,150,!1,!1,562655088357801,!1],[1,"mph106",0,100,!1,!1,0xc3598617fe359,!1],[0,null,!1,null,860015359149256,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,6358229377774539,!1]],[[46,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x83ef5ada58cf0,!1,[[7,[2,"CarBody2"]],[4,43],[0,[1,0.8]],[0,[0,0]]]],[44,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",0x67877d7590c37,!1,[[7,[2,"Wheel2"]],[4,46]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x8a592df6111c,!1,[[7,[2,"Wheel3"]],[4,47]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x3ac1e4845e2b3,!1,[[7,[2,"Wheel4"]],[4,48]]],[47,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",7169220582627904,!1,[[7,[2,"CarBody3"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[48,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0x497039bc056bd,!1,[[7,[2,"CarBody4"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[43,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",0x842c7d450e737,!1,[[0,[0,5]]]],[54,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6167364830911557,!1,[[7,[0,1]],[4,56],[0,[1,0.5]],[0,[1,0.5]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",7840559747788158,!1,[[7,[0,2]],[4,57],[0,[0,2]],[0,[0,0]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",7698197245987542,!1,[[7,[0,1]],[4,57],[0,[0,-2]],[0,[0,1]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",7106494910271611,!1,[[7,[0,2]],[4,59],[0,[0,-2]],[0,[0,0]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xc1b0227258eb3,!1,[[7,[0,3]],[4,60],[0,[0,2]],[0,[0,0]]]],[60,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",7316691751673983,!1,[[7,[0,2]],[4,61],[0,[0,1]],[0,[0,-1]]]],[45,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",7957255259603953,!1,[[4,43],[3,0]]],[44,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",344488054114755,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",9086505592135868,!1,[[4,43],[3,0]]],[58,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",29666488016739,!1,[[4,43],[3,0]]],[59,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",4571301679156692,!1,[[4,43],[3,0]]],[60,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",9620376229610136,!1,[[4,43],[3,0]]],[57,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0x8dc5c21ffee16,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x61bd1acc767a,!1,[[7,[0,2]],[4,43]]],[59,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",8681037441101129,!1,[[7,[0,1]],[4,43]]],[56,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x815c4bc98ba97,!1,[[7,[0,4]],[4,43]]],[57,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",5299875632162212,!1,[[7,[0,10]],[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x8024269d3dc7c,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,0x98d981de392c6,!1,[[0,[1,1]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",6031511472619475,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,0x9d45e06d74345,!1,[[4,43],[7,[0,9]]]],[-1,cr.system_object.prototype.acts.SetVar,null,7397400352076712,!1,[[11,"redlight"],
[7,[0,0]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,9676346477363644,!1,[[3,1]]]]],[0,null,!1,null,4955217022360887,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x569f6e78a10d2,!1]],[[33,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",4559540358345416,!1,[[7,[0,1]],[4,0]]],[34,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xbd331113222d6,!1,[[7,[0,1]],[4,33],[0,[0,0]],[0,[0,0]]]],[32,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",873368128871012,!1,[[7,[0,1]],[4,34],[0,[0,0]],[0,[0,0]]]],[31,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xe672f64504e47,!1,[[7,[0,1]],[4,32],[0,[0,0]],[0,[0,0]]]],[30,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x8ad2ad27ce643,!1,[[7,[0,1]],[4,31],[0,[0,0]],[0,[0,0]]]],[29,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6453318099698908,!1,[[7,[0,1]],[4,30],[0,[0,0]],[0,[0,0]]]],[28,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",6732991846746193,!1,[[7,[0,1]],[4,29],[0,[0,0]],[0,[0,0]]]],[26,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",5735700412108995,!1,[[7,[0,1]],[4,28],[0,[0,0]],[0,[0,0]]]],[27,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x922d6ddbd5ea,!1,[[7,[0,1]],[4,26],[0,[0,0]],[0,[0,0]]]],[35,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xd10c3fcfc9e09,!1,[[7,[0,1]],[4,27],[0,[0,0]],[0,[0,0]]]],[36,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",5707004086728418,!1,[[7,[0,1]],[4,35],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x8b8b28e0328f4,!1,[[7,[0,1]],[4,36],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xd3b04d5902a5b,!1,[[7,[0,1]],[4,149]]]]],[0,null,!1,null,5568663339287449,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8006482299161708,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,667249553371496,
!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,5858039571971192,!1,[[0,[1,1.3]]]],[70,cr.plugins_.Audio.prototype.acts.Preload,null,0x3a394b52f46fa,!1,[[2,["motorbikerev_001",!1]]]]]],[0,null,!1,null,9068198831535016,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,934048143838633,!1]],[[49,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,802125226718501,!1,[[4,45],[7,[0,1]]]],[50,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xb60447eeb3ed8,!1,
[[4,44],[7,[0,1]]]],[21,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,4857110053579507,!1,[[4,20],[7,[0,2]]]],[20,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,7738275694286138,!1,[[4,43],[7,[0,4]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x91c933982ba39,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,5323417935431598,!1,[[4,43],[7,[0,9]]]]]],[0,null,!1,null,7998437230862864,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,
0,!1,!1,!1,0xbdc3b12d1fe3c,!1,[[4,4]]]],[[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",0xdc32c99c64dd6,!1,[[0,[23,"mph300"]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",7165545277078044,!1,[[0,[0,7]],[0,[0,90]],[7,[0,1]]]],[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",9073900180400332,!1,[[0,[23,"mph50"]]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,578995081918999,!1,[[4,43],[7,[0,9]]]],[66,cr.plugins_.Particles.prototype.acts.SetSpraying,
null,6105265600363797,!1,[[3,1]]]],[[0,null,!1,null,7228686952912187,[[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,9639248767091400,!1]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,5949127013664639,!1,[[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.PlayByName,null,0xc12ea7163d6d9,!1,[[3,0],[1,[2,"Motorbikerev_001"]],[3,0],[0,[0,0]],[1,[2,""]]]]],[[0,null,!1,null,4806055837228382,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,null,1,!1,!1,!1,999911361207426,!1,[[0,[0,
0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,339692481614883,!1,[[1,[2,""]]]]],[[0,null,!1,null,5973101700129974,[[6,cr.plugins_.Touch.prototype.cnds.HasNthTouch,null,0,!1,!1,!1,7109024209779738,!1,[[0,[0,1]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,0xe42742730fb85,!1,[[1,[2,""]]]]]]]],[0,null,!1,null,0x6acccf6731a2,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,null,1,!1,!1,!1,5692724520783389,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,6704285323825149,
!1,[[1,[2,""]]]]]]]]]],[0,null,!1,null,5487634587725216,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,5634914619869557,!1,[[4,5]]]],[[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",8969948505808365,!1,[[0,[3,[23,"mph200"]]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",0x941982822d7a8,!1,[[0,[0,7]],[0,[0,90]],[7,[0,2]]]],[70,cr.plugins_.Audio.prototype.acts.Stop,null,0xf29fedc857ca5,!1,[[1,[2,""]]]],[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,
"Physics",0xd63ee27379399,!1,[[0,[3,[23,"mph350"]]]]]]],[0,null,!1,null,0x67f2a275b6eab,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,326902032985132,!1,[[4,53]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xe22b3b35515d7,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6431352976618286,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xd6694d877aa36,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x7346fbf29d04c,
!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,622543186560109,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,7918167787212975,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",7859928632187551,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,8339950778522219,!1]]],[0,null,!1,null,0xd8c452801f60e,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8465130372677317,!1,[[4,282]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",7979232103981604,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x74b4c0aa800b6,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xd68c743efca5f,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6933372378468461,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x3b905fb91c17d,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,9270230786661844,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
0x490f6082fbead,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,6945412251427043,!1]]],[0,null,!1,null,693750031806481,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7058573332222349,!1,[[4,14]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5652426437919329,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xe02567540f9aa,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,6824125958076218,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,9315448149816094,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x7d45c69c0dc56,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,9882611422048172,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",6404478265422198,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,556580348135393,!1]]],[0,null,!1,null,5003869136068262,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5622400985960092,!1,[[4,18]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",6608366634640584,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8871425295021539,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7746543566243537,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,9169222930653884,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,7570483688050185,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,462186364471144,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
9393731686962794,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x607510cb4de6b,!1]]],[0,null,!1,null,771465516000581,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xa7120a96301fd,!1,[[4,116]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6633415469374469,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xb0272d053bb5,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xa9b9d1ea4553a,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,9910533552280944,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,5823431325197576,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,4534092181017325,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",4724403754338163,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,941014606446052,!1]]],[0,null,!1,null,0x78e9ca10112c0,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6111614126988253,!1,[[4,24]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",5859168335988945,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x6f0d9a67cd403,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xbba86fbb892a7,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x8565f1f5d2437,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x4acd6754e8d1c,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xd62d1c77303c8,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
5812504526395552,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,5455548265524012,!1]]],[0,null,!1,null,9867613659457602,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,983719392928135,!1,[[4,25]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x95be3fd02b3c8,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xee85623d05abf,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,8257053475878661,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,8780628937074683,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,9662210003860896,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,7044244305196928,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",5519074618982012,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,6726561435905616,!1]]],[0,null,!1,null,0xeafc4c17cc0aa,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xe57b371177c7d,!1,[[4,38]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",487012195482639,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8302047164489342,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xfacba7545f6d6,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,833610970635256,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,6693403184800819,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xcb6d83e4a9739,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
0x5936f1f01f75a,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,5781850451517233,!1]]],[0,null,!1,null,4897002131869522,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,4737198488353535,!1,[[4,39]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",7405725067059953,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5922798454246729,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x97603a88b1b02,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,
null,7349898697700735,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x7d644050472e1,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,774180646102539,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x733677c116b90,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,8088704262625845,!1]]],[0,null,!1,null,411514402024663,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6656285016412389,!1,[[4,3]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",693902812980201,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",834934607704002,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,7757234948385368,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,0x84e64618e8d17,!1,[[0,[1,1.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,895194646814834,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,null,6768178279202043,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,8158316969072269,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",5221073729656385,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xb0dff80825f47,!1]]],[0,null,!1,null,0x706a262fb4fed,[[284,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7471475939146857,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,8327913184276812,!1,[[0,[0,2]]]],[12,cr.plugins_.Sprite.prototype.acts.Destroy,null,5676316205382854,!1]]],[0,null,!1,null,7506258472371542,
[[13,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x71c88a0969b43,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,9919910894847016,!1,[[0,[0,2]]]],[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,5804808491434577,!1]]],[0,null,!1,null,6165259577171408,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,744437492407126,!1,[[4,19]]]],[[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5077667812860426,!1,[[4,79],[7,[0,1]]]],[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,
null,0xf77135dbcc763,!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x9f7a7accb60a4,!1],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xdad681f6d84b0,!1]]],[0,null,!1,null,7964769369176754,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,6596155531820234,!1,[[4,62]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,5833755271728778,!1,[[4,76],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,6910483719247444,!1,[[4,
76],[7,[0,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,6200087068854659,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xa5ad6de2601e9,!1,[[0,[0,0]]]]]],[0,null,!1,null,9020618482130592,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,533535282997729,!1,[[4,63]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xd5897afc94747,!1,[[4,79],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xaf8cad7ded6d5,!1,[[4,79],[7,
[0,1]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xe06b10b3f8dfa,!1,[[0,[1,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0xf1ee51bc1196e,!1,[[3,1]]]]],[0,null,!1,null,0x7b717148e7db,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8406987633803129,!1,[[4,74]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,616340416427165,!1,[[6,"Level7"]]],[126,cr.plugins_.Clay.prototype.acts.level_success,null,0xaf29d92d01274,!1,[[1,[2,"Forest Construction Part 2"]]]],
[126,cr.plugins_.Clay.prototype.acts.facebook_post,null,0x75aab8870771c,!1,[[1,[2,"Flipping Up The Mud On This One, Can You?"]],[1,[2,""]],[1,[2,"https://www.dropbox.com/s/82ul3rk0t1r509a/posttofacebookpic.png"]],[3,0]]],[126,cr.plugins_.Clay.prototype.acts.achievements_award,null,8500124730135881,!1,[[7,[0,4254]],[3,0]]]]],[0,null,!1,null,0x6bbdcfb1e6ea4,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,9256658579425480,!1,[[4,73]]]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,
null,811647599130451,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,7385793623659393,!1,[[6,"play"]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0x6c348edf754ca,!1,[[3,1]]]]],[0,null,!1,null,4710416266016666,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5647783054273302,!1]],[[-1,cr.system_object.prototype.acts.SaveState,null,4987478034572366,!1,[[1,[2,"mysave"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x5c8403108e27b,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,0x75b6dea6e17d,!1,[[11,"greenlight"],[7,[0,0]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,34519364281228,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xd2ea67c8aa4f,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5120246634269333,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xc7af35a7838cc,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,47656203202217,!1,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,4591991709234625,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,7458504277570391,!1,[[0,[0,3]]]],[-1,cr.system_object.prototype.acts.Wait,null,9528089947561208,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,6431458421037836,!1,[[0,[0,4]]]],[-1,cr.system_object.prototype.acts.Wait,null,7657111327324717,!1,[[0,[1,0.7]]]],[-1,cr.system_object.prototype.acts.SetVar,null,6027483025200837,!1,[[11,"greenlight"],[7,[0,1]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,9468208408518944,!1,[[0,[0,5]]]]]],[0,null,!1,null,0x90292d00c6eab,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,5163318664401869,!1,[[11,"greenlight"],[8,0],[7,[0,1]]]]],[[101,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,7339103237187496,!1,[[0,[0,1]]]]]],[0,null,!1,null,5244044052596674,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7881584346870448,!1,[[4,102]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,0x5ae312ed6283d,!1,[[0,[1,1]]]],
[70,cr.plugins_.Audio.prototype.acts.Play,null,7389984742643912,!1,[[2,["pol-lovushke-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.Play,null,4560827610492508,!1,[[2,["motorbikerev_001",!1]],[3,0],[0,[0,-100]],[1,[2,""]]]],[102,cr.plugins_.Sprite.prototype.acts.Destroy,null,83102921502124,!1],[226,cr.plugins_.Sprite.prototype.acts.Destroy,null,0x3b6ac5f04720d,!1]]],[0,null,!1,null,0x57c5b43396b59,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!0,!1,
0x97f15eec5ffe3,!1,[[4,4]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,6903576993511371,!1,[[1,[2,""]]]]]],[0,null,!1,null,9205240443239988,[[102,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,0x6827375c50c29,!1]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,9257641796582422,!1]]],[0,null,!1,null,6348280280054975,[[-1,cr.system_object.prototype.cnds.EffectsSupported,null,0,!1,!1,!1,0xd897f17f027fc,!1]],[]],[0,null,!1,null,8982342291178782,[[-1,cr.system_object.prototype.cnds.OnLoadComplete,
null,1,!1,!1,!1,8479646507642912,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,6404640494277025,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,9177848773160736,!1],[70,cr.plugins_.Audio.prototype.acts.Play,null,5579883177805656,!1,[[2,["pol-grid-breaking-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,8833933890779559,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9507668103389854,!1]],[[234,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",4535600397757166,!1,[[7,[0,1]],[4,233]]]]],[0,null,!1,null,0x93296fcb584d2,[[43,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,5549598164237623,!1,[[4,238]]]],[[160,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",4639312943244737,!1,[[3,1]]]]],[0,null,!1,null,0x543efe8deb72b,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0xdbd3d8908bacc,!1]],[[23,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,6691484507371117,!1],[23,cr.plugins_.CJSAds.prototype.acts.ShowBanner,
null,0x457da60fe9c9b,!1,[[3,1]]]]],[0,null,!1,null,0xe644302b5b1ac,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,7015603735109013,!1]],[[283,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5973880478902507,!1,[[0,[0,3]]]]]],[0,null,!1,null,747780693814944,[[209,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xd454ecd8c53eb,!1,[[4,54]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",4850600127866649,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",7061768125993278,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xd5f5851cd4e7,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,902327295026318,!1,[[0,[1,1.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x96280d4db003f,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xf2c462c1b054a,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xfac63e62ca90d,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",
4824299660954287,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,7266416571588159,!1]]],[0,null,!1,null,5806852595445456,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7026983916729879,!1,[[4,148]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xce179a4779f48,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xaad6d7fcf45ce,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,6472778211938478,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,
null,0xffb4f52aa4012,!1,[[0,[1,1.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xbc939ae7c928a,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,null,6915782227298849,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x6b79f1461e301,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",7221547325701456,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xe72a904be5d47,!1]]],[0,null,!1,null,8111083929658031,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,6568290275345313,!1,[[4,212]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,0xfdaadcaa6fc7,!1]]],[0,null,!1,null,8472869143521586,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,5355520457519039,!1]],[[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,5904178367041715,!1,[[3,0]]]]]]],["Level7Event",[[1,"onground3",0,0,!1,!1,0xbbb5272742bad,!1],[1,"greenlight8",0,0,!1,!1,0x91689a1e322af,!1],[1,"redlight8",0,0,!1,!1,9259190858721396,!1],[1,"mph27",
0,20,!1,!1,8279957987051471,!1],[1,"mph8",0,1,!1,!1,6007629809905807,!1],[1,"mph17",0,10,!1,!1,0xed830104c1a71,!1],[1,"idletouch8",0,0,!1,!1,0xde39ca04e21ad,!1],[1,"revtouch8",0,0,!1,!1,5451848455193752,!1],[1,"pause8",0,0,!1,!1,0xfc300f90ddd05,!1],[1,"zoom8",0,0,!1,!1,5606253407053923,!1],[1,"mph57",0,50,!1,!1,9194814162288972,!1],[1,"mph607",0,600,!1,!1,8230214744237479,!1],[1,"mph557",0,550,!1,!1,5916292020868878,!1],[1,"mph507",0,500,!1,!1,7934014047557472,!1],[1,"mph457",0,450,!1,!1,8742524746565787,
!1],[1,"mph407",0,400,!1,!1,0x9d2fb3b1f1e19,!1],[1,"mph357",0,350,!1,!1,0x6dec61c178dcc,!1],[1,"mph307",0,300,!1,!1,6802995247725352,!1],[1,"mph257",0,250,!1,!1,9616871552818846,!1],[1,"mph207",0,200,!1,!1,7576073836183542,!1],[1,"mph157",0,150,!1,!1,6351161041212141,!1],[1,"mph107",0,100,!1,!1,0xad9fa4e6e66e0,!1],[0,null,!1,null,0x8adf5872b10e5,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,0x3b4fcc8442a7a,!1]],[[46,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",8575460262509933,!1,[[7,[2,"CarBody2"]],[4,43],[0,[1,0.8]],[0,[0,0]]]],[44,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",8921255602070587,!1,[[7,[2,"Wheel2"]],[4,46]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",7032667050732396,!1,[[7,[2,"Wheel3"]],[4,47]]],[45,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xa6c162e3d67f6,!1,[[7,[2,"Wheel4"]],[4,48]]],[47,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",
0x80a44fcbf6901,!1,[[7,[2,"CarBody3"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[48,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9820170976154452,!1,[[7,[2,"CarBody4"]],[4,43],[0,[0,2]],[0,[0,-2]]]],[43,cr.behaviors.Physics.prototype.acts.SetWorldGravity,"Physics",4658441928524522,!1,[[0,[0,5]]]],[54,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",6410389943852833,!1,[[7,[0,1]],[4,56],[0,[1,0.5]],[0,[1,0.5]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",7918855782549555,!1,[[7,[0,2]],[4,57],[0,[0,2]],[0,[0,0]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",8942485874946325,!1,[[7,[0,1]],[4,57],[0,[0,-2]],[0,[0,1]]]],[58,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x9d8d7abfa9117,!1,[[7,[0,2]],[4,59],[0,[0,-2]],[0,[0,0]]]],[56,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",4915109888021868,!1,[[7,[0,3]],[4,60],[0,[0,2]],[0,[0,0]]]],[60,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0x8381e2b75ded5,!1,[[7,[0,2]],[4,61],[0,[0,1]],[0,[0,-1]]]],[45,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7913741192649015,!1,[[4,43],[3,0]]],[44,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xed50aad4d7d09,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7769821651246209,!1,[[4,43],[3,0]]],[58,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",7306029666678818,!1,[[4,43],[3,0]]],[59,cr.behaviors.Physics.prototype.acts.EnableCollisions,
"Physics",4954303424397252,!1,[[4,43],[3,0]]],[60,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",9718562478967320,!1,[[4,43],[3,0]]],[57,cr.behaviors.Physics.prototype.acts.EnableCollisions,"Physics",0xc1a0d092da3aa,!1,[[4,43],[3,0]]],[61,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xcae5cd1ddf787,!1,[[7,[0,2]],[4,43]]],[59,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",5463388755684571,!1,[[7,[0,1]],[4,43]]],[56,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",5709390627637233,!1,[[7,[0,4]],[4,43]]],[57,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0xbbc2fda873423,!1,[[7,[0,10]],[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7592347340427235,!1,[[0,[1,1]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,7693308290370094,!1,[[0,[1,1]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x575373515277d,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,8233712423305874,
!1,[[4,43],[7,[0,9]]]],[-1,cr.system_object.prototype.acts.SetVar,null,0xab771567ffb6a,!1,[[11,"redlight"],[7,[0,0]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,5155688000111257,!1,[[3,1]]]]],[0,null,!1,null,0xe3dc3a182b3a3,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,6990875984548153,!1]],[[33,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",0x41213a6e93cbb,!1,[[7,[0,1]],[4,0]]],[34,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",
0x4631f6c4ee9c9,!1,[[7,[0,1]],[4,33],[0,[0,0]],[0,[0,0]]]],[32,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x5959cb0af23ba,!1,[[7,[0,1]],[4,34],[0,[0,0]],[0,[0,0]]]],[31,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xdba59d12f41f3,!1,[[7,[0,1]],[4,32],[0,[0,0]],[0,[0,0]]]],[30,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",4783894879764788,!1,[[7,[0,1]],[4,31],[0,[0,0]],[0,[0,0]]]],[29,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",537587632417987,!1,[[7,[0,1]],[4,30],[0,[0,0]],[0,[0,0]]]],[28,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",9419489028574904,!1,[[7,[0,1]],[4,29],[0,[0,0]],[0,[0,0]]]],[26,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x8379fee8702b8,!1,[[7,[0,1]],[4,28],[0,[0,0]],[0,[0,0]]]],[27,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0x397b114be1767,!1,[[7,[0,1]],[4,26],[0,[0,0]],[0,[0,0]]]],[35,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,
"Physics",0x624e611cb2333,!1,[[7,[0,1]],[4,27],[0,[0,0]],[0,[0,0]]]],[36,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",0xf46d4c20291bc,!1,[[7,[0,1]],[4,35],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateLimitedRevoluteJoint,"Physics",5969901490432822,!1,[[7,[0,1]],[4,36],[0,[0,0]],[0,[0,0]]]],[37,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,"Physics",880195294846893,!1,[[7,[0,1]],[4,149]]]]],[0,null,!1,null,8948658025481034,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,
null,1,!1,!1,!1,6271568742892149,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,0x92b532cd851c9,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,0xaa46a80da8b36,!1,[[0,[1,1.3]]]],[70,cr.plugins_.Audio.prototype.acts.Preload,null,8459459729637345,!1,[[2,["motorbikerev_001",!1]]]]]],[0,null,!1,null,5589201133829558,[[-1,cr.system_object.prototype.cnds.EveryTick,null,0,!1,!1,!1,9565995013652088,!1]],[[49,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x851d8593c2291,
!1,[[4,45],[7,[0,1]]]],[50,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0x995c6d6c53450,!1,[[4,44],[7,[0,1]]]],[21,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,959514576607273,!1,[[4,20],[7,[0,2]]]],[20,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,0xd703f19c468f6,!1,[[4,43],[7,[0,4]]]],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x7dc04b39c5264,!1,[[3,1]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,null,6260320614443142,!1,[[4,43],[7,[0,9]]]]]],
[0,null,!1,null,7283491543901352,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0x98b8dabaea35e,!1,[[4,4]]]],[[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",0xa6d55c6588736,!1,[[0,[23,"mph300"]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",7717693881093755,!1,[[0,[0,7]],[0,[0,90]],[7,[0,1]]]],[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",0xaff086b68a4e3,!1,[[0,[23,"mph50"]]]],[66,cr.plugins_.Particles.prototype.acts.SetPosToObject,
null,8201614005037212,!1,[[4,43],[7,[0,9]]]],[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,0x6f6b8c1ad6403,!1,[[3,1]]]],[[0,null,!1,null,4533322931276143,[[-1,cr.system_object.prototype.cnds.TriggerOnce,null,0,!1,!1,!1,9040099328408520,!1]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,9193926094736084,!1,[[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.PlayByName,null,843995653908122,!1,[[3,0],[1,[2,"Motorbikerev_001"]],[3,0],[0,[0,0]],[1,[2,""]]]]],[[0,null,!1,null,9138660060091056,
[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchStart,null,1,!1,!1,!1,7213353006967791,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,0xea782ecc2128b,!1,[[1,[2,""]]]]],[[0,null,!1,null,0x798f575e0c3b8,[[6,cr.plugins_.Touch.prototype.cnds.HasNthTouch,null,0,!1,!1,!1,8023766965664862,!1,[[0,[0,1]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,8348599819596352,!1,[[1,[2,""]]]]]]]],[0,null,!1,null,5884753142365582,[[6,cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd,null,1,!1,!1,!1,
7740278386104786,!1,[[0,[0,0]]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,0x7eca1c2820816,!1,[[1,[2,""]]]]]]]]]],[0,null,!1,null,5172076452381542,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,!1,!1,!1,0xd99c607c1d390,!1,[[4,5]]]],[[45,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",8074774004677981,!1,[[0,[3,[23,"mph200"]]]]],[43,cr.behaviors.Physics.prototype.acts.ApplyForceAtAngle,"Physics",7313437126108967,!1,[[0,[0,7]],[0,[0,90]],[7,[0,2]]]],[70,cr.plugins_.Audio.prototype.acts.Stop,
null,8941608321787867,!1,[[1,[2,""]]]],[44,cr.behaviors.Physics.prototype.acts.ApplyTorque,"Physics",5906486196240151,!1,[[0,[3,[23,"mph350"]]]]]]],[0,null,!1,null,8612377867371375,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7061736379360535,!1,[[4,53]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xa9a5faf622f6c,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",7006819674960059,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,
8479844588709022,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x722eb52a91f40,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xff4dde4fe47c5,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x3f568cd92672e,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",8318369751586294,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,323047071456186,!1]]],[0,null,!1,null,9328982774727492,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0xbba4f65d05b69,!1,[[4,282]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5012554289489481,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9461799036284986,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xd6ab6332dba42,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6613748482541456,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,9934880530984904,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,0x8df28dcf3c974,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",472410656392487,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x7db3112a03221,!1]]],[0,null,!1,null,6983240882974632,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6551460806975455,!1,[[4,14]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5491595894295607,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5909080901918304,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,
null,4897286719834431,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x5d7c2343dda08,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x64ff132ac021f,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,7184320707633269,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",689276843800545,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,8777927090588478,!1]]],[0,null,!1,null,7534918997373963,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,4784369037127429,!1,[[4,18]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9136039387591476,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8129381573297549,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,397727556281805,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8778965203890253,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,7265634818165437,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,6697398194638017,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",7075517024293531,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,9067817419847844,!1]]],[0,null,!1,null,7333005860665016,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xc45009f733112,!1,[[4,116]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x9d74df3ae8c2d,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0xa5d1ceb111f21,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,
null,7930804303290085,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,8468311806795652,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,5929803654447317,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x86677d86cff13,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0xd302232acc6ab,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0x8a3e604c19e9,!1]]],[0,null,!1,null,9349144482768666,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,8295294741296981,!1,[[4,24]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8041384753200494,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x97bbca9e36b90,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xb28220d91d408,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6515776368521315,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x3ccc64ea2fa58,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,9758931492362952,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",4936228222378292,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,7472588205335831,!1]]],[0,null,!1,null,0xbc1b253b35872,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xb7b6a6b5562cc,!1,[[4,25]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",5489035052987707,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x470207f3e48fb,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,
null,5518455692466032,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x3c7894d5f21d4,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xa235c880873d4,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x46ff5e26df605,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",5866526179881241,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,744668938867962,!1]]],[0,null,!1,null,0x7270b5631ad3f,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,7249535242807847,!1,[[4,38]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6832298884761172,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",319235266250243,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,5935050665154144,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0x42d1d365ffe62,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,8109320360261632,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,
null,7281189756034821,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0x47e58c957c17d,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,7616456419942541,!1]]],[0,null,!1,null,7211817483860445,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,7361841957906667,!1,[[4,39]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",6518320940665781,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",8332251991610682,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,
null,7734072893023593,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xb1dc4e8825025,!1,[[0,[1,0.2]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x7aa9d9f5ea6f,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0x9d7bbbaaf94d0,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",4552676093224335,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,0xd37f3ecc6dbf2,!1]]],[0,null,!1,null,8545131159922794,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0xd155570e93165,!1,[[4,3]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",9509167161124232,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",4969836079050709,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0x7da97ca8da68e,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,6903874448127827,!1,[[0,[1,1.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,7186631050609043,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,
null,7855343538554925,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xeb59ca54ecbbf,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",0xd6d8ac2dbd81c,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,8933249028373849,!1]]],[0,null,!1,null,5769439561825372,[[284,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,8382393439308528,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,4723397733265994,!1,[[0,[0,2]]]],[12,cr.plugins_.Sprite.prototype.acts.Destroy,
null,0x957024e615dc7,!1]]],[0,null,!1,null,0xce13b31d613ad,[[13,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,6094866711240649,!1,[[4,53]]]],[[-1,cr.system_object.prototype.acts.Wait,null,0xd62ed879eddc0,!1,[[0,[0,2]]]],[13,cr.plugins_.Sprite.prototype.acts.Destroy,null,5749030244668352,!1]]],[0,null,!1,null,0x95ca695c4ae9f,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,375068639022064,!1,[[4,19]]]],[[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,4769745472410558,
!1,[[4,79],[7,[0,1]]]],[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,8860997821599642,!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xe433a007dbbdc,!1],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,4650363877535885,!1]]],[0,null,!1,null,0x64eedb2c29a9f,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0xbdd4b5f122f70,!1,[[4,62]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9554881600857576,!1,[[4,76],[7,[0,1]]]],[73,
cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,9795438585265158,!1,[[4,76],[7,[0,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,5687028487165848,!1,[[3,0]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,5515021738410902,!1,[[0,[0,0]]]]]],[0,null,!1,null,4883944841208124,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,905775165679411,!1,[[4,63]]]],[[78,cr.plugins_.Sprite.prototype.acts.SetPosToObject,null,8095586090313467,!1,[[4,79],[7,[0,1]]]],[73,cr.plugins_.Sprite.prototype.acts.SetPosToObject,
null,349157717631522,!1,[[4,79],[7,[0,1]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6121571267959609,!1,[[0,[1,1]]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,5134368517163997,!1,[[3,1]]]]],[0,null,!1,null,8703684518262879,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x885db1ae3c42f,!1,[[4,74]]]],[[-1,cr.system_object.prototype.acts.GoToLayout,null,9178055284834352,!1,[[6,"credits"]]],[126,cr.plugins_.Clay.prototype.acts.level_success,null,7970343191013651,
!1,[[1,[2,"Forest Construction Part 2"]]]],[126,cr.plugins_.Clay.prototype.acts.facebook_post,null,6432615500488127,!1,[[1,[2,"Cant Beat Abit Of Street MX, Can You?"]],[1,[2,""]],[1,[2,"https://www.dropbox.com/s/82ul3rk0t1r509a/posttofacebookpic.png"]],[3,0]]],[126,cr.plugins_.Clay.prototype.acts.achievements_award,null,0x719a599468df0,!1,[[7,[0,4254]],[3,0]]]]],[0,null,!1,null,7028881508367151,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,0x816e76b0f00e0,!1,[[4,73]]]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,
null,0xd6f0d8f746fb5,!1],[-1,cr.system_object.prototype.acts.GoToLayout,null,0x51e4cf7783d2d,!1,[[6,"play"]]],[70,cr.plugins_.Audio.prototype.acts.SetSilent,null,0x9bfc353e21732,!1,[[3,1]]]]],[0,null,!1,null,0x71e0cbab7a6a7,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,6871428713647404,!1]],[[-1,cr.system_object.prototype.acts.SaveState,null,5462417832027032,!1,[[1,[2,"mysave"]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,0xb8f1ff671b42,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.SetVar,
null,7690806141522012,!1,[[11,"greenlight"],[7,[0,0]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,4992446489747165,!1,[[0,[0,0]]]],[-1,cr.system_object.prototype.acts.Wait,null,5547193826293877,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,30316683176492,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.Wait,null,0xcdc189a85ab02,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xad4e0e4f2ed53,!1,[[0,[0,2]]]],[-1,cr.system_object.prototype.acts.Wait,
null,840263548988292,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0xac846bd5b779b,!1,[[0,[0,3]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x9015b09b4cb71,!1,[[0,[1,0.7]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x540f39d74e47d,!1,[[0,[0,4]]]],[-1,cr.system_object.prototype.acts.Wait,null,9366791267901348,!1,[[0,[1,0.7]]]],[-1,cr.system_object.prototype.acts.SetVar,null,9077247791646632,!1,[[11,"greenlight"],[7,[0,1]]]],[99,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
null,6148866950851263,!1,[[0,[0,5]]]]]],[0,null,!1,null,0x5d87c07f3242,[[-1,cr.system_object.prototype.cnds.CompareVar,null,0,!1,!1,!1,7969198104071664,!1,[[11,"greenlight"],[8,0],[7,[0,1]]]]],[[101,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,0x51cdff44f747e,!1,[[0,[0,1]]]]]],[0,null,!1,null,9522842550107604,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchObject,null,1,!1,!1,!1,7803018095021726,!1,[[4,102]]]],[[-1,cr.system_object.prototype.acts.SetTimescale,null,928289178015291,!1,[[0,[1,1]]]],
[70,cr.plugins_.Audio.prototype.acts.Play,null,5452766143554683,!1,[[2,["pol-from-the-street-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]],[70,cr.plugins_.Audio.prototype.acts.Play,null,0x8682b56a886c9,!1,[[2,["motorbikerev_001",!1]],[3,0],[0,[0,-100]],[1,[2,""]]]],[102,cr.plugins_.Sprite.prototype.acts.Destroy,null,8851787150261015,!1],[226,cr.plugins_.Sprite.prototype.acts.Destroy,null,0xf4762e3492215,!1]]],[0,null,!1,null,7241361686364117,[[6,cr.plugins_.Touch.prototype.cnds.IsTouchingObject,null,0,
!1,!0,!1,6222381298582386,!1,[[4,4]]]],[[70,cr.plugins_.Audio.prototype.acts.Stop,null,0xedf59ca5874ca,!1,[[1,[2,""]]]]]],[0,null,!1,null,8308437326803605,[[102,cr.plugins_.Sprite.prototype.cnds.IsVisible,null,0,!1,!1,!1,6340048911592437,!1]],[[70,cr.plugins_.Audio.prototype.acts.StopAll,null,786615625577677,!1]]],[0,null,!1,null,0x650b5c7d4e655,[[-1,cr.system_object.prototype.cnds.EffectsSupported,null,0,!1,!1,!1,7951770898497204,!1]],[]],[0,null,!1,null,5509760240200138,[[-1,cr.system_object.prototype.cnds.OnLoadComplete,
null,1,!1,!1,!1,0x619d1c5e77133,!1]],[[-1,cr.system_object.prototype.acts.Wait,null,0xda30bdc8fa149,!1,[[0,[1,0.01]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xb3937679c65e6,!1],[70,cr.plugins_.Audio.prototype.acts.Play,null,0x59f359854663e,!1,[[2,["pol-from-the-street-short",!1]],[3,1],[0,[0,0]],[1,[2,""]]]]]],[0,null,!1,null,5222291298435047,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,9903888059382216,!1]],[[234,cr.behaviors.Physics.prototype.acts.CreateRevoluteJoint,
"Physics",9072369012680624,!1,[[7,[0,1]],[4,233]]]]],[0,null,!1,null,43559111842331,[[43,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0x59f30fcdb5bd1,!1,[[4,238]]]],[[160,cr.behaviors.Physics.prototype.acts.SetEnabled,"Physics",8440251030346033,!1,[[3,1]]]]],[0,null,!1,null,0x96d418f65983b,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,5149473059400873,!1]],[[23,cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,null,0xb26de7711d4,!1],[23,cr.plugins_.CJSAds.prototype.acts.ShowBanner,
null,0x8b32a7455e269,!1,[[3,1]]]]],[0,null,!1,null,650181031271816,[[-1,cr.system_object.prototype.cnds.OnLayoutStart,null,1,!1,!1,!1,8517709458099001,!1]],[[283,cr.plugins_.Sprite.prototype.acts.SetAnimFrame,null,5025920761449242,!1,[[0,[0,1]]]]]],[0,null,!1,null,7578199229275908,[[209,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,0xfb946c0839885,!1,[[4,54]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x868dc0160af16,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,
"Physics",0xcabd6bd124b6c,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,6566682165176705,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,null,8664643258544945,!1,[[0,[1,1.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,6224696291447292,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,null,0x38e13171fb116,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,0xbb3220cbda037,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,
"ScrollTo",0x7d5bffc564335,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,9879170905241212,!1]]],[0,null,!1,null,6044699582687034,[[54,cr.plugins_.Sprite.prototype.cnds.OnCollision,null,0,!1,!1,!0,9161190558024228,!1,[[4,148]]]],[[61,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x5a2f00575dbd1,!1],[59,cr.behaviors.Physics.prototype.acts.RemoveJoints,"Physics",0x9a1d45bab5c05,!1],[-1,cr.system_object.prototype.acts.ScrollToObject,null,0xefa544c5747fb,!1,[[4,43]]],[-1,cr.system_object.prototype.acts.SetLayoutScale,
null,7075478014234528,!1,[[0,[1,1.5]]]],[-1,cr.system_object.prototype.acts.SetTimescale,null,369536727999702,!1,[[0,[1,0.1]]]],[-1,cr.system_object.prototype.acts.Wait,null,5527570176266868,!1,[[0,[0,1]]]],[-1,cr.system_object.prototype.acts.RestartLayout,null,6868469902302365,!1],[21,cr.behaviors.scrollto.prototype.acts.SetEnabled,"ScrollTo",9145461705636616,!1,[[3,0]]],[70,cr.plugins_.Audio.prototype.acts.StopAll,null,6746733488408261,!1]]],[0,null,!1,null,993774877692334,[[283,cr.plugins_.Sprite.prototype.cnds.OnCollision,
null,0,!1,!1,!0,0xe30de18ece39b,!1,[[4,212]]]],[[-1,cr.system_object.prototype.acts.RestartLayout,null,9094369536731404,!1]]],[0,null,!1,null,0x596dca714a819,[[6,cr.plugins_.Touch.prototype.cnds.OnTouchEnd,null,1,!1,!1,!1,0x96e5b360e27,!1]],[[66,cr.plugins_.Particles.prototype.acts.SetSpraying,null,7567971514144263,!1,[[3,0]]]]]]]],"",!1,1800,960,5,!1,!0,!1,"1.0",!0,!1,1,2,1830,!1,!0,1,[]]};

createCocoonJSRuntime();

})();
